#
# License:
#
#    Copyright (c) 2003-2006 ossim.net
#    Copyright (c) 2007-2014 AlienVault
#    All rights reserved.
#
#    This package is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; version 2 dated June, 1991.
#    You may not use, modify or distribute this program under any other version
#    of the GNU General Public License.
#
#    This package is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this package; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
#    MA  02110-1301  USA
#
#
# On Debian GNU/Linux systems, the complete text of the GNU General
# Public License can be found in `/usr/share/common-licenses/GPL-2'.
#
# Otherwise you can read it here: http://www.gnu.org/licenses/gpl-2.0.txt
#

#
# GLOBAL CONSTANTS
#

NETSCREEN_IDP_SID_TRANSLATION_TABLE = {
 'TROJAN:MISC:KONIK-CLIENT-REQ': '1',
 'SHELLCODE:SPARC:GEN-3-PKT': '2',
 'HTTP:OMNI:IMAGEMAP': '3',
 'HTTP:STC:CLSID:ACTIVEX:AX-125': '4',
 'DDOS:TRIN00:MASTERPW-DEFLT-WIN': '5',
 'TFTP:3COM-TFTP': '6',
 'IMAP:LOTUS-CRAM': '7',
 'HTTP:WIN-CMD:WIN-WGUEST': '8',
 'SPYWARE:TROJAN:CLICKFRAUD': '9',
 'APP:SNORT:GARBAGE-PACKET': '10',
 'SCAN:MISC:FTP:REALPATH-OF2': '11',
 'SPYWARE:KL:ELGOLF': '12',
 'HTTP:STC:CLSID:ACTIVEX:AX-48': '13',
 'TROJAN:MISC:GRISCH1-CLIENT-HELO': '14',
 'FTP:OVERFLOW:PASS_TOO_LONG': '15',
 'TCP:C2S:EXPLOIT:C2S-URG-OVERLAP': '16',
 'SPYWARE:BH:IMESHMEDIABAR': '17',
 'NFS:ERR:LARGE-CRED': '18',
 'TROJAN:BACKORIFICE:CONNECTION': '19',
 'SPYWARE:KL:KEYSPYWARE': '20',
 'HTTP:CGI:MAIL-FORM-ACCESS': '21',
 'SPYWARE:AD:SPEDIABAR': '22',
 'HTTP:GMAIL:FILE-UPLOAD': '23',
 'HTTP:PHP:PHPMYADMIN:SVR-PARAM': '24',
 'DNS:EXPLOIT:SQUID-PROXY-PTR-DOS': '25',
 'VOIP:MGCP:SDP:HEADER-ORD-ERR': '26',
 'SPYWARE:KL:BEEE': '27',
 'SPYWARE:BH:DAOSEARCH': '28',
 'HTTP:TUNNEL:PROXY': '29',
 'RPC:RPC.TTDBSERVER:TT-MAL-FS-3': '30',
 'HTTP:STC:VULN:APACHE-2-0-52': '31',
 'DNS:AUDIT:REQ-INVALID-HDR-RD': '32',
 'SMB:EXPLOIT:NULL-SERVICE': '33',
 'LPR:INVALID:LINE': '34',
 'LDAP:INVALID:REFERRAL_INVALID': '35',
 'FTP:OVERFLOW:USERNAME-2-LONG': '36',
 'DNS:EXPLOIT:REQUEST-SHORT-MSG': '37',
 'APP:SBS-TRAINING-OF': '38',
 'REXEC:AUDIT:PARAM-NOT-OK': '39',
 'HTTP:IIS:JET-DB-VBA-REMOTE-EXEC': '40',
 'POP3:EXT:DOT-INF': '41',
 'SHELLCODE:LINUXX86:GEN-3-TCP': '42',
 'SCADA:ICCP:BUFFER-SIZE': '43',
 'SSL:INVALID:COMP-METHOD': '44',
 'HTTP:STC:CLSID:ACTIVEX:AX-73': '45',
 'HTTP:NETSCAPE:WP-VER-INFO': '46',
 'MS-RPC:SRV-SVC-OF': '47',
 'RADIUS:ACCCHAL_INV_NUM_ATTRS': '48',
 'WORM:FIZZER:SMTP-PROP': '49',
 'APP:WINMAIL-PATH-DIS': '50',
 'RPC:RPC.SNMPXDMID:OVERFLOW': '51',
 'DB:ORACLE:WEBCACHE-FILE-APPEND': '52',
 'HTTP:STC:MOZILLA:HOST-MAL-IDN': '53',
 'LDAP:FAILED:DELETE-RESULT-FAIL': '54',
 'HTTP:IIS:IIS-HILIGHT-BYPASS': '55',
 'HTTP:COLDFUSION:GETFILE-PROBE': '56',
 'HTTP:STC:MOZILLA:SIDEBAR': '57',
 'SPYWARE:AD:SSSPIDER': '58',
 'HTTP:TOMCAT:JSP-DEC-INT-OF': '59',
 'HTTP:HOTMAIL:LIVE-EXE-ATTACH': '60',
 'TROJAN:MISC:FLU-COMMAND': '61',
 'SPYWARE:GM:SEARCHBOSS': '62',
 'SCADA:ICCP:DISCONNECT-CODE': '63',
 'NFS:ERR:LARGE-FH': '64',
 'SPYWARE:RAT:PHOENIX2-1-28': '65',
 'ICMP:AUDIT:ICMP-WITH-OPTIONS': '66',
 'HTTP:INFO-LEAK:ORDER-LOG': '67',
 'HTTP:OVERFLOW:OV-HDR-OF': '68',
 'POP3:OUTLOOK:HRALIGN-OF': '69',
 'HTTP:PHP:POSTNUKE-CMD-EXEC': '70',
 'TROJAN:MISC:BREACHPRO-CAP-REQ': '71',
 'HTTP:UNIX-CMD:UNIX-CMD-M-Z': '72',
 'WORM:SANTY:GOOGLE-SEARCH': '73',
 'HTTP:STC:CLSID:ACTIVEX:AX-107': '74',
 'HTTP:STC:CLSID:ACTIVEX:AX-135': '75',
 'SMTP:AUDIT:REQ-BIN-DATA-3': '76',
 'P2P:WINMX:CLIENT-NET-PRB-DNS': '77',
 'SPYWARE:BH:STUMBLEUPON': '78',
 'ECHO:EXPLOIT:MISMATCHING-REPLY': '79',
 'TELNET:DOS:SOLARIS-2-5-1': '80',
 'NETBIOS:ACCESS:IPC-1': '81',
 'SMTP:SPAMASS-DOS': '82',
 'HTTP:STC:SAFARI:HELP-RUNSCRPT': '83',
 'APP:TUN:6TO4-TUNNEL': '84',
 'APP:KERBEROS:DOS-TCP': '85',
 'HTTP:IIS:ENUMDSN-ATTEMPT': '86',
 'HTTP:STC:CLSID:ACTIVEX:AX-87': '87',
 'WORM:CONFICKER:E-MS08-067': '88',
 'SNMPTRAP:ENCODING:TT-TOO-BIG': '89',
 'HTTP:SQL:INJ:IISPROTECT': '90',
 'SPYWARE:TROJAN:UNNAMED-BD': '91',
 'SCAN:MISC:TELNET:SU-ROOT': '92',
 'APP:3COM-NET-SUP-DIR-TRAV': '93',
 'HTTP:CGI:BNB-SURVEY-REMOTE-EXEC': '94',
 'NTP:ERROR:INVALID_MODE': '95',
 'HTTP:INFO:YOUTUBE': '96',
 'FTP:EXPLOIT:OPENFTPD-MSG-FS': '97',
 'VOIP:SIP:LIMITS:REQ-DISPO-OF': '98',
 'TROJAN:DOLY:SERVER-RES-V1': '99',
 'HTTP:IIS:ISAPI-IDA-OVERFLOW': '100',
 'TROJAN:MISC:HELLDRIVER-COMMAND': '101',
 'RADIUS:ACC_ACC_DISALOWD_ATTR': '102',
 'SPYWARE:AD:TEOMA': '103',
 'SCAN:NESSUS:COUNT-CGI': '104',
 'SCAN:CORE:SAMBA-NTTRANS': '105',
 'SMTP:EXT:DIR-TRAV': '106',
 'SPYWARE:TROJAN:GWBOY': '107',
 'HTTP:MISC:RAILS-ROUTING': '108',
 'WORM:SDBOT:DX-IRC-BEACON': '109',
 'TROJAN:BACKDOOR-ZTOO': '110',
 'SMTP:EXT:DOT-GRP': '111',
 'SCADA:DNP3:WARM-RESTART': '112',
 'SPYWARE:RAT:TEAMVIEW-HTTP-CLNT': '113',
 'SPYWARE:KL:ACTIVEKEYLOGGER_392': '114',
 'TROJAN:MISC:BT-SERV-VER-RESP': '115',
 'SMTP:MAL:WMF-MAL-HEADER': '116',
 'HTTP:SQL:INJ:CHAR': '117',
 'SPYWARE:RAT:SNIPERNET': '118',
 'SPYWARE:TROJAN:TROYA_1_4': '119',
 'SNMP:ENCODING:OID-TOO-LONG': '120',
 'APP:CUPS:COMMAND-CHAR': '121',
 'HTTP:STC:IE:JS-LOCATION-ASSIGN': '122',
 'SNMP:SYMANTEC-DNS-BYPASS': '123',
 'HTTP:STC:CLSID:REF-19': '124',
 'HTTP:PHP:PHPBB:PROFILE-ADD-DOS': '125',
 'SHELLCODE:UNIXWARE:GEN-PKT': '126',
 'SYSLOG:AUDIT:INVALID-PRIORITY': '127',
 'HTTP:XSS:MAILMAN-OPTIONS': '128',
 'TROJAN:CDK:PORT79': '129',
 'HTTP:STC:CANVAS-BABYBOTTLE-GZIP': '130',
 'VIRUS:SMTP:UUENCODED-DOT-VBS': '131',
 'SNMPTRAP:ENCODING:NZLEN-NULL': '132',
 'FTP:OVERFLOW:S2C-PATH-OF': '133',
 'SPYWARE:KL:KEYLOGGERPRO': '134',
 'HTTP:PHP:VBULLETIN-CODE-EXEC': '135',
 'SPYWARE:KL:ADVANCEDSPY_4': '136',
 'SCAN:CANVAS:LINUXSNMP': '137',
 'SPYWARE:AD:PARTYPOKER07': '138',
 'LDAP:LOTUS-DOMINO': '139',
 'HTTP:STC:NAV-REDIR': '140',
 'SCAN:MISC:FTP:LOGXFR-OF1': '141',
 'SPYWARE:RAT:SERVEME': '142',
 'SCAN:MISC:HTTP:WEBTRENDS-PROBE': '143',
 'TROJAN:MISC:TRON-COMMAND': '144',
 'TROJAN:MISC:TROJANSPIRIT-CMD': '145',
 'SSH:OVERFLOW:PUTTY-VER': '146',
 'HTTP:STC:CLSID:ACTIVEX:AX-94': '147',
 'HTTP:STC:CLSID:REF-45': '148',
 'HTTP:PKG:MOUNTAIN-ORDR-DSCLSR': '149',
 'SMTP:MAL:JPEG-ATTACH-COMMENT-OF': '150',
 'SMTP:EXPLOIT:PINE-CHARSET-OF-1': '151',
 'HTTP:STC:CLSID:REF-12': '152',
 'FTP:SERVU:MDTM-OVERFLOW': '153',
 'SPYWARE:AD:TOOLBARBROWSER': '154',
 'HTTP:STC:IE:MHTML-HREF-OF': '155',
 'HTTP:INFO:TRACE': '156',
 'FTP:WU-FTP:DELE-OF': '157',
 'HTTP:DOMINO:NSF-DIR-TRAVERSAL': '158',
 'VOIP:SIP:KEEP-ALIVE': '159',
 'HTTP:STC:IMG:MAL-EMF-2': '160',
 'SPYWARE:KL:FARSIGHTER': '161',
 'APP:KERBEROS:DBLFREE': '162',
 'HTTP:STC:CLSID:ACTIVEX:WMI-OBJ': '163',
 'SPYWARE:BH:YELLOWPAGES': '164',
 'CHAT:YIM:XSS': '165',
 'DNS:OVERFLOW:ADM-TCP': '166',
 'GOPHER:INVALID:DOC-TYPE': '167',
 'NETBIOS:DIR:SYMANFW-NBS-UDP': '168',
 'NETBIOS:NBDS:OF:MSG': '169',
 'TROJAN:MISC:WEBSERVCT10': '170',
 'SPYWARE:DM:ALTNET-VAR1': '171',
 'MS-RPC:LOC-SVC-OF': '172',
 'TELNET:USER:APC-BACKDOOR': '173',
 'VOIP:SIP:HAMMER': '174',
 'HTTP:STC:W32-PARAM-HTTP': '175',
 'TCP:AUDIT:S2C-TIMEWAIT-ACK': '176',
 'HTTP:STC:IE:MSWEBDVD-NPA': '177',
 'HTTP:OVERFLOW:ACCEPT': '178',
 'APP:TUN:TEREDO-TUNNEL': '179',
 'SHELLCODE:X86:DECODER-2': '180',
 'HTTP:MISC:NOOP-SLIDE-HEAD-OF': '181',
 'SPYWARE:AD:CRAZYWINNINGS': '182',
 'SNMPTRAP:INFO:ERR_STAT_NOT_WRIT': '183',
 'P2P:AUDIT:GNUTELLA-HTTP-GET': '184',
 'SPYWARE:RAT:FEAR2-0': '185',
 'HTTP:STC:ADOBE:PDF-JBIG2DECODE': '186',
 'IMAP:OVERFLOW:SCO-IMAPD-UNO-OF': '187',
 'SMTP:EXT:DOT-BAS': '188',
 'HTTP:STC:CLSID:ACTIVEX:AX-68': '189',
 'SPYWARE:RAT:FREAK-ICQ': '190',
 'TROJAN:MISC:NETSPY-SRV-RESP': '191',
 'NETBIOS:NBNS:INVALID:HDR-Z': '192',
 'TROJAN:MISC:MICROSPY-COMMAND': '193',
 'SMTP:MAILMAN:PASSWD-DISCLOSURE': '194',
 'SCAN:MISC:HTTP:CPSHOST-DLL': '195',
 'HTTP:STC:IE:MMCN-EXEC': '196',
 'CHAT:YIM:DOUBLE-EXT': '197',
 'HTTP:CGI:EXCITE-AT-ADMIN-CGI': '198',
 'SMB:AUDIT:EXT-SEC-DISABLED': '199',
 'SCAN:NESSUS:GLOBAL-ASA': '200',
 'HTTP:STC:IE:OBJECT-OF1': '201',
 'SPYWARE:RAT:SMALLUPLOADER': '202',
 'HTTP:PHP:ALEXPHP-INCLUDE': '203',
 'MS-RPC:MSRPC-EVASION-4': '204',
 'HTTP:SQL:INJ:BIZTALK': '205',
 'P2P:AUDIT:SOFTETHER-TCP': '206',
 'POP3:EMAIL-SCRIPT': '207',
 'HTTP:CGI:BUGZILLA:CMD-EXEC': '208',
 'HTTP:STC:IMG:JPEG-BAD-LENGTH': '209',
 'IKE:MALFORMED:2MANY-PAYLOAD': '210',
 'HTTP:DIR:TRAVERSE-DIRECTORY': '211',
 'SCAN:CORE:AGENT-LOAD-WIN': '212',
 'SPYWARE:RAT:SHITHEEP': '213',
 'SMB:NETBIOS:INV-SNAME-LEN': '214',
 'HTTP:STC:ACTIVEX:OLE-AUTO': '215',
 'HTTP:TOMCAT:SOURCE-MAL-REQ': '216',
 'HTTP:STC:IMG:NOT-JPEG': '217',
 'FTP:DOS:ASTERISK': '218',
 'SPYWARE:BH:MAPSTANTOOLBAR': '219',
 'VIRUS:POP3:NIMDA': '220',
 'HTTP:STC:IE:TEXT-HELP-ZONE-BP': '221',
 'HTTP:STC:ACTIVEX:QTPLUGINX': '222',
 'HTTP:DOMINO:CSP-SRC-DISCLOSURE': '223',
 'FTP:PROFTP:USER-DOS': '224',
 'GOPHER:OVERFLOW:HOST': '225',
 'CHAT:AUDIT:YMSG:RESP-CRYPT': '226',
 'DNS:WPADREG': '227',
 'HTTP:OVERFLOW:AUTH-OVFLW': '228',
 'TFTP:AUDIT:S2C-UNEXP-DATA': '229',
 'HTTP:XSS:JAVA-COM-EXP': '230',
 'CHAT:AUDIT:YMSG:CONF-INVIT': '231',
 'OS:LINUXX86:POP2-OF-2': '232',
 'HTTP:STC:MOZILLA:JS-EVAL': '233',
 'HTTP:CGI:FORMMAIL-ENV-VAR': '234',
 'HTTP:APACHE:ENCODED-DIRTRAV': '235',
 'APP:RIM-BLACKBERRY-DOS': '236',
 'HTTP:STC:IE:ADDRBAR-SPOOF-1': '237',
 'SMB:MSSQL-DECLARE-EXEC': '238',
 'SPYWARE:RAT:NEUROTICKITTEN': '239',
 'SPYWARE:AD:EQISO': '240',
 'SPYWARE:RAT:ACIDHEAD': '241',
 'SPYWARE:AD:VIEWPOINTMEDIA': '242',
 'SMTP:EXPLOIT:EUDORA-URL-SPOOF': '243',
 'VOIP:SIP:AUDIT:INV-URI': '244',
 'VOIP:SIP:AUDIT:INV-REQ-HEADER': '245',
 'HTTP:EXT:METAFILE': '246',
 'HTTP:APACHE:HTGREP-HDR': '247',
 'HTTP:BADBLUE:CONF-FILE-ACCESS': '248',
 'VNC:INVALID:CLIENT-VERSION': '249',
 'APP:WINAMP:MIDI-OF': '250',
 'CHAT:AUDIT:YMSG:INV-STAT-CODE': '251',
 'HTTP:IIS:SITE-SERVER-FILE-UPLD': '252',
 'IMAP:OVERFLOW:IMAP-CONT-OF': '253',
 'HTTP:STC:WINAMP:SKIN-DOWNLOAD': '254',
 'HTTP:STC:IMG:WMF-MAL-HEADER-2': '255',
 'IMAP:CYRUS:FETCH-CMD': '256',
 'NETBIOS:NBDS:OF:NAME': '257',
 'HTTP:MISC:BLUECOAT-ADMIN': '258',
 'TROJAN:MISC:NETCONTROL-SVR-RESP': '259',
 'SPYWARE:RAT:PCACMEPRO': '260',
 'TROJAN:MISC:GIRLFRIEND-SRV-RESP': '261',
 'POP3:OVERFLOW:BSD-OFLOW-2': '262',
 'POP3:EXT:DOT': '263',
 'CHAT:ICQ:ISS-OVERFLOW': '264',
 'SPYWARE:BP:CW-CAMEUP': '265',
 'HTTP:CISCO:VOIP:PORT-INFO-REQ': '266',
 'PROTOCOLS:PORT:SIP': '267',
 'HTTP:STC:IE:MHTML-XDOM': '268',
 'SPYWARE:BP:HAPPYTOFIND': '269',
 'POP3:OVERFLOW:LINE': '270',
 'TROJAN:MISC:LATINUS-CMD': '271',
 'HTTP:STC:IE:IFRAME-HTA': '272',
 'TROJAN:MISC:CHUPA-COMMAND': '273',
 'MS-RPC:ERR:EPM-WRONG-TOWER-LEN': '274',
 'HTTP:CGI:MYLOG': '275',
 'VOIP:MGCP:DOUBLE-ENCODING': '276',
 'SNMP:INFO:ERR_STAT_NO_ACCESS': '277',
 'POP3:OUTLOOK:OL-IFRAME-EXEC': '278',
 'OS:SCOX86:CALSERVER-OF': '279',
 'APP:TUN:IPV6-OVER-IPV4': '280',
 'SPYWARE:KL:CODENAMEALVIN': '281',
 'CHAT:MSN:HTTP:CALL': '282',
 'SPYWARE:AD:GOLDENPALACECASINO': '283',
 'WORM:SMB:DELODER-2': '284',
 'P2P:MISC:100BAO': '285',
 'SPYWARE:KL:APLUSKEYLOGGER': '286',
 'WORM:NIMDA:NIMDA-EML': '287',
 'P2P:NAPSTER:DATA-7777': '288',
 'ICMP:EXPLOIT:MIP-ROUTE-OF': '289',
 'SPYWARE:AD:BORLAN': '290',
 'APP:BORLAND:VISIBROKER': '291',
 'VOIP:SIP:SHORT-REQUEST': '292',
 'SMTP:WP5-EMAIL': '293',
 'SPYWARE:KL:SPYLANTERNKEYLOGGER': '294',
 'HTTP:STC:MSA-SPOOF': '295',
 'SMTP:SENDMAIL:DEBIAN-SASL-AUTH': '296',
 'HTTP:IRIX:PFDISPLAY-EXEC': '297',
 'SSL:OVERFLOW:SSL-KEY_ARG1': '298',
 'SCAN:MISC:X11-XTERM-OF-TCP': '299',
 'SMTP:INVALID:BOUNDARY-MISS': '300',
 'SPYWARE:TROJAN:DOWNLOADER-YD': '301',
 'VOIP:SKYPE:LOGIN-1': '302',
 'SPYWARE:BP:COMETCURSOR': '303',
 'SNMP:ERROR:CLIENT-RESPONSE': '304',
 'SPYWARE:AD:SEARCHHIPPOTOOLBAR': '305',
 'CHAT:YIM:LONG-FILE-NAME': '306',
 'HTTP:STC:ACTIVEX:WKIMGSRV': '307',
 'P2P:EMULE:KADEMLIA-KAD': '308',
 'HTTP:STC:ACTIVEX:TRIEDITDOC': '309',
 'TROJAN:MISC:MOBLIVION-SERV-RESP': '310',
 'WORM:DABBER:B-BACKDOOR-CMD': '311',
 'SCAN:NMAP:FINGERPRINT': '312',
 'HTTP:AUDIT:NULL-HREF': '313',
 'SPYWARE:BH:SNAPTOOLBAR': '314',
 'CHAT:AIM:MESSAGE-RECEIVE': '315',
 'NETBIOS:NBDS:INVALID:MSG_TYPE': '316',
 'LPR:OVERFLOW:D-LENGTH': '317',
 'HTTP:IRIX:WEBDIST-REMOTE-EXEC': '318',
 'HTTP:SQL:INJ:USER-ADD': '319',
 'TROJAN:HACKATTACK:SERVER-RES': '320',
 'TROJAN:MISC:NETSILENCE-SRV-RESP': '321',
 'SPYWARE:AD:HOTBAR': '322',
 'SNMP:COMMUNITY:ZERO-LEN': '323',
 'SMTP:MSSQL-WORM-EMAIL': '324',
 'TELNET:EXPLOIT:RESOLV-HOST-CONF': '325',
 'HTTP:STC:ACTIVEX:TROUBLE-QUERY': '326',
 'HTTP:STC:ACTIVEX:MCA-VTRACE': '327',
 'SCAN:MISC:FTP:REALPATH-OF1': '328',
 'CHAT:IRC:NICK': '329',
 'APP:MISC:PIGEON-DOS': '330',
 'SCAN:NESSUS:SMB-SCAN': '331',
 'DOS:NETDEV:WEBJET-TRAVERSAL': '332',
 'APP:LANDESK-OF': '333',
 'DOS:NETDEV:CISCO-SWIPE': '334',
 'TROJAN:MISC:CRACKDOWN-SRV-RESP': '335',
 'SPYWARE:RAT:ROACH1-0-CTS': '336',
 'HTTP:XSS:OMNIHTTPD-REDIR': '337',
 'HTTP:STC:ACTIVEX:GOMPLAYER': '338',
 'SMB:ERROR:GRIND': '339',
 'SPYWARE:RAT:PCSHARE': '340',
 'NETBIOS:NBNS:EMPTY-UDP-MSG': '341',
 'HTTP:PHP:PHPRPC-EXEC': '342',
 'APP:VERITAS:NETBACKUP-BPCD': '343',
 'VNC:INVALID:CLIENT-REQUEST': '344',
 'REXEC:AUDIT:PARAM-OK': '345',
 'HTTP:PHP:CMD-INJ': '346',
 'TROJAN:NETDEVIL:NETDEVIL-STC': '347',
 'HTTP:BARRACUDA:PREV-EXEC': '348',
 'HTTP:STC:IE:SHOWHELP': '349',
 'TROJAN:AUTOPROXY:INFECTED-HOST': '350',
 'SMTP:URL-LOC': '351',
 'SCAN:MISC:HTTP:WEBCOM-EXE': '352',
 'HTTP:STC:ACTIVEX:DATASRCCTL': '353',
 'APP:SHOUTCAST:ICY-OVERFLOW': '354',
 'HTTP:PHP:DOTPROJECT-USERCOOKIE': '355',
 'SMTP:EXT:DOT-SHS': '356',
 'HTTP:STC:CHAR-CONFLICT': '357',
 'HTTP:STC:IE:IE-MEM-CORRUPT': '358',
 'HTTP:REQERR:BIN-DATA-CONT-ENC': '359',
 'CHAT:YIM:HTTP-TUNNEL': '360',
 'VOIP:SIP:AUDIT:INVALID-HEX-LOW': '361',
 'SCAN:METASPLOIT:TWIKI-CONF-CMD': '362',
 'APP:HPOVNNM:OVTRACE': '363',
 'HTTP:INFO:XEROX-DS-INFO': '364',
 'P2P:GNUTELLA:DOWNLOAD': '365',
 'LDAP:EMPTY:SRCH_RES_OBJ_EMPTY': '366',
 'HTTP:STC:IMG:NOT-GIF': '367',
 'TCP:S2C:INFO:S2C-URG-DATA': '368',
 'SPYWARE:RAT:BOBO': '369',
 'SMTP:MAL:ACROBAT-UUEXEC': '370',
 'HTTP:STC:IE:IE-CACHE-SMDIALOG': '371',
 'SMTP:COMMAND:EXPN': '372',
 'HTTP:STC:BT:CLIENT-VULN3': '373',
 'HTTP:STC:ACTIVEX:PVCAL': '374',
 'P2P:AUDIT:GNUTELLA-BYE-TTL': '375',
 'LDAP:FORMAT:ENC_LEN_INDEFINITE': '376',
 'APP:VERITAS:CLIENT-AUTH-OF': '377',
 'SPYWARE:AD:ADULTLINKS': '378',
 'SMTP:AUDIT:ENCODE-MIME-TYPE': '379',
 'SCAN:MISC:FTP:PPC-FS1': '380',
 'HTTP:AUDIT:UNKNWN-REQ': '381',
 'SMTP:EXT:DOT-ADP': '382',
 'SPYWARE:BH:NAVEXCEL': '383',
 'APP:REMOTE:TIMBUKTU-CONNECT': '384',
 'SHELLCODE:WINDOWS:GEN-1-TCP': '385',
 'VNC:SESSION': '386',
 'SNMPTRAP:INFO:ERR_STAT_WRNG_ENC': '387',
 'P2P:MISC:POCO-UDP': '388',
 'IMAP:CYRUS:LOGIN-OF-2': '389',
 'TROJAN:MISC:LEGUARDIEN': '390',
 'HTTP:PHP:WRD-PR-CMD-INJ': '391',
 'TROJAN:MISC:ONE-CLIENTID': '392',
 'HTTP:STC:MOZILLA:JSCRIPT-CLIP': '393',
 'APP:CA:ARCSRV:PORTMAPPER': '394',
 'CHAT:IRC:OVERFLOW:LINE': '395',
 'HTTP:PHP:ULTIMATE-PHP-BOARD': '396',
 'SNMP:COMMUNITY:ILMI': '397',
 'SCAN:AMAP:SSL-ON-POP3': '398',
 'NTP:TRAFFIC': '399',
 'P2P:NAPSTER:UPLOAD-REQ-7777': '400',
 'RUSERS:ERR:LONG-NETNAME': '401',
 'SNMP:AUDIT:OTHER-ERROR': '402',
 'HTTP:INFO:SPIDER-ROBOT': '403',
 'HTTP:STC:IMG:BMP-BAD-PARAMETER': '404',
 'SPYWARE:AD:COMMONNAME': '405',
 'P2P:AUDIT:GNUTELLA-HDR-ATRB': '406',
 'DB:ORACLE:TNS-CMD-INJ': '407',
 'TELNET:OVERFLOW:SGI': '408',
 'SPYWARE:TROJAN:X-BKDR': '409',
 'SPYWARE:AD:LIVEPROTECTION': '410',
 'HTTP:STC:IMG:ANI-BLOCKSIZE': '411',
 'HTTP:MISC:SHAMBALA-DOS1': '412',
 'NNTP:OVERFLOW:LINE-OVERFLOW': '413',
 'SMTP:EXCHANGE:IMAP-DOS': '414',
 'DNS:AUDIT:TYPE-EXPERIMENTAL': '415',
 'P2P:AUDIT:GNUTELLA-EOL': '416',
 'SPYWARE:AD:SC-SEARCH-O-MATIC': '417',
 'HTTP:STC:CLSID:ACTIVEX:AX-130': '418',
 'FTP:VULN:WS-FTP-5-0-4': '419',
 'DOS:NETDEV:WEBJET-WRITETOFILE': '420',
 'HTTP:SQL:INJ:CONVERT-INJ-OF': '421',
 'HTTP:PHP:FORMAT-OF': '422',
 'SCAN:RVSCAN:FTP': '423',
 'SPYWARE:TROJAN:ABREMOTEPRO31': '424',
 'SCAN:MISC:HTTP:TEST-DOT-CGI': '425',
 'P2P:BITTORRENT:OVERFLOW': '426',
 'MISC:KERIO-AUTH-OF': '427',
 'P2P:FREENET:CONNECTION': '428',
 'HTTP:STC:CLSID:ACTIVEX:AX-18': '429',
 'POP3:OVERFLOW:QPOP-OF4': '430',
 'TROJAN:MISC:REMOTEHACK-CLIENTID': '431',
 'HTTP:STC:OUTLOOK:WAB-BOF': '432',
 'CHAT:MSN:ACCESS': '433',
 'DNS:OVERFLOW:SCO-NAMED2-OF1': '434',
 'DOS:NETDEV:LINKSYS-GOZILA-DOS': '435',
 'IMAP:OVERFLOW:MAILBOX': '436',
 'HTTP:XSS:TOMCAT-JSP': '437',
 'HTTP:STC:MOZILLA:QUERYINT-OF': '438',
 'SHELLCODE:SPARC:GEN-1-PKT': '439',
 'DB:ORACLE:DEFAULT-PW-CLARK': '440',
 'TROJAN:MISC:INTRUZZO-VER': '441',
 'DNS:TRAFFIC': '442',
 'SSL:DEFAULT-PW': '443',
 'SCAN:MISC:HTTP:UNIX-BIN-CHMOD': '444',
 'HTTP:STC:IMG:PICT-UNCOMP-UF': '445',
 'ICMP:INFO:INFORMATION': '446',
 'ICMP:INFO:ECHO': '447',
 'APP:PCANYWHERE:STARTUP': '448',
 'DB:IB:CREATE-REQ-OF': '449',
 'HTTP:STC:IE:MSRAT-NAME-OF2': '450',
 'CHAT:AUDIT:YMSG:OFLOW-CHALNG': '451',
 'TCP:AUDIT:S2C-LASTACK-ACK': '452',
 'HTTP:MISC:LFTP-HTML-BO': '453',
 'APP:CITRIX:AGENT-OF-2': '454',
 'SMB:ENUM:NETSESSION': '455',
 'RTSP:REALSERVER:REAL-SETUP-OF3': '456',
 'IMAP:OVERFLOW:MAILENABLE-OF-2': '457',
 'APP:SYMC:XFERWAN-OF': '458',
 'TROJAN:PHATBOT:CMD-CONNECT': '459',
 'SMTP:EXT:DOT-INS': '460',
 'HTTP:CGI:LITESERV-CGI-DISC': '461',
 'DB:ORACLE:SYS-KUPW-WORKER': '462',
 'HTTP:IIS:SOURCE-VIEW': '463',
 'HTTP:FRONTPAGE:ADMIN.PWD-REQ': '464',
 'IDENT:INVALID:EMPTY-LN': '465',
 'P2P:MISC:PEERENABLE': '466',
 'HTTP:XDOMAINXML': '467',
 'SPYWARE:KL:STEALTHWATCHER2000': '468',
 'P2P:WINMX:CLIENT-MATCHMAKE-DNS': '469',
 'APP:ETHEREAL:DISTCC-OF': '470',
 'HTTP:PHP:VWAROOT-INCLUDE': '471',
 'LPR:OVERFLOW:C-MAIL': '472',
 'HTTP:STC:ACTIVEX:ATUCFOBJ-DLL': '473',
 'TROJAN:BACKCONSTR:CONNECTION': '474',
 'SPYWARE:UTIL:NUCLEARSCAN': '475',
 'HTTP:OVERFLOW:CONNECTION': '476',
 'SPYWARE:TROJAN:HGZ': '477',
 'SCAN:MISC:NULL': '478',
 'TROJAN:MITGLEIDER': '479',
 'HTTP:XSS:IPLANET-ROOT': '480',
 'HTTP:STC:CLSID:ACTIVEX:AX-115': '481',
 'CHAT:IRC:INVALID:NULL-CHAR': '482',
 'APP:CUPS:CGI-ADMIN-OF': '483',
 'SPYWARE:BH:WOWOK-MP3': '484',
 'HTTP:PHP:GALLERY:EMBED-AUTH-VAR': '485',
 'HTTP:STC:IMG:MAL-WMF-REC-OF': '486',
 'SPYWARE:AD:DELFINMEDIAVIEWER': '487',
 'HTTP:STC:IE:CACHE-EXTERNAL': '488',
 'SPYWARE:AD:ADTOOLS': '489',
 'HTTP:STC:ACTIVEX:BB-LOAD': '490',
 'WORM:NIMDA:SCRIPTS-ROOT': '491',
 'SYSLOG:AUDIT:EMPTY-PRI': '492',
 'MS-RPC:LSASS:OVERSIZED-FRAG': '493',
 'HTTP:PKG:TUXEDO-INIFILE': '494',
 'CHAT:IRC:OVERFLOW:PASSWORD': '495',
 'TFTP:AUDIT:WRITE-FAILED': '496',
 'SPYWARE:AD:4ARCADEPBAR': '497',
 'ICMP:INFO:ECHO-REQUEST': '498',
 'HTTP:STC:IMG:PICT-POLY-UF': '499',
 'HTTP:IIS:FILE-LIST-ATTEMPT': '500',
 'SPYWARE:BH:QMTOOLBAR': '501',
 'DHCP:AUDIT:UNK-OPCODE': '502',
 'SPYWARE:BH:EXTRATOOLBAR10': '503',
 'SPYWARE:AD:ASIAFINESTTOOLBAR': '504',
 'MS-RPC:DCOM:REMACT': '505',
 'TCP:C2S:ERROR:REASS-LOST-TRACK': '506',
 'NETBIOS:ACCESS:ADMIN': '507',
 'LPR:INVALID:D-NAME': '508',
 'IMAP:EXPLOIT:NETMAIL-APPEND': '509',
 'HTTP:DOMINO:UTF-DOS': '510',
 'P2P:MISC:SOULSEEK': '511',
 'APP:PROXY:ACPROXY-XSS-INJECT': '512',
 'HTTP:PKG:ALLAIRE-JRUN-DOS': '513',
 'FTP:PASSWORD:PLUS': '514',
 'SPYWARE:TROJAN:EXPLOIT_1_4_5': '515',
 'HTTP:CGI:ARMADA-DIR-TRAVERSAL': '516',
 'SMTP:AUDIT:REQ-BIN-DATA-2': '517',
 'HTTP:STC:MPG123-HEAP-OF': '518',
 'SNMP:INFO:ERR_STAT_WRONG_VAL': '519',
 'SCAN:ADM:FTP-SCAN': '520',
 'HTTP:STC:IE:WMP-BMP-OF-1': '521',
 'HTTP:STC:ACTIVEX:YSHORTCUT': '522',
 'APP:CPANEL-RESETPASS': '523',
 'SPYWARE:KL:HACKERWACKER': '524',
 'SCADA:ICCP:UNSUPPORTED-TPDU': '525',
 'SCAN:ISS:FTP-SCAN': '526',
 'TCP:C2S:EVASION:C2S-URG-OUT-WIN': '527',
 'SCAN:II:ISAKMP-FLOOD': '528',
 'NFS:INFO:UNKNOWN-PROG': '529',
 'HTTP:IIS:COMMAND-EXEC-2': '530',
 'FTP:OVERFLOW:PATH-LINUX-X86-3': '531',
 'SPYWARE:KL:KGBKEYLOGGER': '532',
 'SSL:UNK-CHG-CPHR-SPEC-MSG': '533',
 'FTP:DIRECTORY:CISCOFTP-OF': '534',
 'SPYWARE:AD:NETWORKESSENTIALS': '535',
 'HTTP:STC:CLSID:ACTIVEX:AX-16': '536',
 'DB:ORACLE:TNS-TRANS-BOF': '537',
 'APP:POSTFIX-GLD-OF': '538',
 'SPYWARE:RAT:NIGHTCREATURE': '539',
 'IMAP:AUTH-OF': '540',
 'CHAT:AUDIT:YMSG:MAIL-SNDR-ADDR': '541',
 'APP:ETHEREAL:TCP-80-DOS': '542',
 'HTTP:STC:CLSID:ACTIVEX:AX-22': '543',
 'SNMPTRAP:INFO:STAT_WRNG_TYPE': '544',
 'VOIP:SIP:OVERFLOW:OVERLONG-UTF8': '545',
 'P2P:KAZAA:FILE-SEND': '546',
 'SPYWARE:AD:BONZIBUD': '547',
 'SPYWARE:AD:MEDIATICKETS': '548',
 'FTP:OVERFLOW:SITESTRING-2-LONG': '549',
 'POP3:EXT:DOT-URL': '550',
 'DHCP:OPT:MAX-MSG-SIZE-2-SMALL': '551',
 'TELNET:FAILURE:PERM-DENIED': '552',
 'RPC:RPC.MOUNTD:XLINK-IOF': '553',
 'APP:NAIMCOMN': '554',
 'NFS:INVALID:INVALID-HOW': '555',
 'HTTP:DOMINO:USERNAME-DISCOVERY': '556',
 'SPYWARE:BH:THECOOLBAR': '557',
 'TFTP:MISSING-MODE': '558',
 'LDAP:FAILED:COMPARE_RESULT_FAIL': '559',
 'SPYWARE:AD:AURORA': '560',
 'HTTP:PKG:CART32-CLI-DIS': '561',
 'SMTP:OUTLOOK:MHTML-CDI': '562',
 'SPYWARE:AD:MYWAYSEARCHBAR': '563',
 'SPYWARE:AD:ATGAMES': '564',
 'SCAN:CORE:SSH-SKEY-BSDAUTH': '565',
 'HTTP:IIS:WEBDAV:XML-HANDLER-DOS': '566',
 'HTTP:PROXY:SQUID-OVERSIZE-HDR': '567',
 'IMAP:IPSWITCH:IMAIL-INFO': '568',
 'HTTP:STC:CLSID:REF-23': '569',
 'DNS:AUDIT:REQ-C2S-RESPONSE': '570',
 'TROJAN:MISC:THING-SERV-RESP': '571',
 'WORM:NIMDA:MSADC-ROOT': '572',
 'P2P:KAZAA:FILE-REQ': '573',
 'SPYWARE:RAT:AUTOCRAT': '574',
 'HTTP:STC:CLSID:ACTIVEX:YDPCTL': '575',
 'SPYWARE:RAT:SUPERVISORPLUS': '576',
 'HTTP:PHP:PHPBB:SEARCH-INJECT': '577',
 'FTP:AUDIT:REQ-NESTED-REQUEST': '578',
 'SSL:INVALID:CERT-VERSION': '579',
 'SPYWARE:RAT:BOSSWATCHER': '580',
 'LDAP:OVERFLOW:ENC_REPR_2LONG': '581',
 'HTTP:STC:QT-RTSP-LINK-OF': '582',
 'VOIP:SIP:LIMITS:CONTACT-OF': '583',
 'HTTP:AGORA:DBACCESS': '584',
 'HTTP:IIS:HTR-ASP-CODE-DISC': '585',
 'HTTP:STC:CLSID:ACTIVEX:AX-90': '586',
 'NTP:EXCEEDED_REF_CLKAGE': '587',
 'SPYWARE:AD:DRIVECLEANER10111': '588',
 'HTTP:STC:IE:PROTO-LINK-REDIRECT': '589',
 'SNMP:INFO:ERR_STAT_NO_CREAT': '590',
 'SMTP:EXT:DOT-ANI': '591',
 'HTTP:STC:ACTIVEX:VISBASIC6-AX-4': '592',
 'HTTP:PHP:PHPFORUM-INC': '593',
 'VNC:INVALID:NAME-TOO-LONG': '594',
 'SMTP:EXCHANGE:MAL-VERB-XEXCH50': '595',
 'RPC:RPC.MOUNTD:SHOWMOUNT': '596',
 'HTTP:COBALT:SERVICE-DOS': '597',
 'SPYWARE:UTIL:WEBFERRET': '598',
 'TCP:AUDIT:C2S-SEG-OUT-OF-WIN': '599',
 'HTTP:STC:IE:FULLMEM-RELOAD3': '600',
 'TCP:ERROR:REASS-MEMORY-OVERFLOW': '601',
 'HTTP:EXT:RAT-SVR-PUSH': '602',
 'HTTP:STC:IE:XML-REDIR': '603',
 'DB:ORACLE:DECLARE-EXEC': '604',
 'SCAN:MISC:TELNET:XHOST': '605',
 'SMB:NETBIOS:SHARE-LVL-SEC': '606',
 'VOIP:SIP:AUDIT:INV-CALL-ID': '607',
 'TROJAN:TELNET:USER-R00T': '608',
 'HTTP:STC:ACTIVEX:RMOC3260': '609',
 'HTTP:PKG:CART32-ADM-PW-CHG': '610',
 'TROJAN:BYTE-VERIFY-HTML': '611',
 'SPYWARE:RAT:BLUEFIRE': '612',
 'WORM:AGOBOT:PY-HTTP-PROP': '613',
 'TROJAN:MISC:XANADU111-CON': '614',
 'RPC:RPC.MOUNTD:LINUX-MOUNTD-OBO': '615',
 'DDOS:TRINITY:DEFAULT-PW': '616',
 'HTTP:STC:ACTIVEX:NSKEY-DLL': '617',
 'SPYWARE:AD:COMEDYPLANET': '618',
 'RLOGIN:AUDIT:PARAM-OK': '619',
 'TCP:AUDIT:OPT-UNSOL-TS': '620',
 'HTTP:STC:IMG:GIF-BAD-PARAMETER': '621',
 'TROJAN:NETBUS:SERVER-RES-12346': '622',
 'HTTP:STC:CLSID:ACTIVEX:AX-31': '623',
 'HTTP:PKG:WEBMIN-FILEDISC': '624',
 'HTTP:STC:ACTIVEX:ADODB': '625',
 'FTP:WU-FTP:IREPLY-FS': '626',
 'HTTP:STC:ACTIVEX:TM-HOUSECALL': '627',
 'HTTP:STC:CLSID:ACTIVEX:AX-84': '628',
 'SPYWARE:BH:SPYNOVA': '629',
 'HTTP:STC:IMG:WMF-DOWNLOAD': '630',
 'HTTP:STC:IE:CREATETEXTRANGE-2': '631',
 'HTTP:BADBLUE:PROXY-RELAY': '632',
 'APP:CA:ARCSRV:CAMEDIASRV': '633',
 'DB:MS-SQL:TDI-OVERFLOW': '634',
 'SPYWARE:RAT:HIDDENCAMERA': '635',
 'SPYWARE:AD:SNAPULTRASEARCH136': '636',
 'SCAN:MISC:TELNET:CAT-ETC-PASSWD': '637',
 'RADIUS:ACSREQ_INV_NUM_ATTRS': '638',
 'VOIP:SIP:LIMITS:AUTH-INFO-OF': '639',
 'ECHO:EXPLOIT:SERVER-NO-RESPONSE': '640',
 'SMTP:EXT:DOT-MSI': '641',
 'HTTP:STC:IMG:PNG-WIDTH': '642',
 'CHAT:AIM:OVERFLOW:AIM-HTTP-AWAY': '643',
 'HTTP:PHP:COOLPHP-DIRTRAV': '644',
 'CHAT:AUDIT:MSN:GROUP-NAME': '645',
 'HTTP:STC:CLSID:ACTIVEX:AX-108': '646',
 'TROJAN:MISC:ECLYPSE-SRV-RESP': '647',
 'SPYWARE:BH:FLASHBAR': '648',
 'SPYWARE:AD:INEXPLORERTOOLBAR': '649',
 'SNMP:ERROR:SERVER-REQUEST': '650',
 'SMTP:EXT:DOT-HTA': '651',
 'TROJAN:MISC:MOONPIE3-FTP-RESP': '652',
 'HTTP:STC:CLSID:ACTIVEX:XMLHTTP': '653',
 'SPYWARE:BH:SPOTON': '654',
 'HTTP:STC:CLSID:ACTIVEX:TLI-AX': '655',
 'HTTP:STC:CLSID:ACTIVEX:SONICAX': '656',
 'SPYWARE:KL:ACTIVITY-LOGGER': '657',
 'SCAN:MISC:MSTREAM-REP-12754': '658',
 'SCAN:MISC:HTTP:SWEDITSERVLET': '659',
 'NTP:PASV_NOT_DISSOLVED': '660',
 'VOIP:SIP:OVERFLOW:METHOD': '661',
 'MS-RPC:DCOM:REMACT-UDP445': '662',
 'SCAN:CORE:OPENSSH-CHANNEL': '663',
 'TROJAN:MISC:TROJAN-CIA': '664',
 'ICMP:INFO:ADDR-REQ': '665',
 'SPYWARE:BH:VIPNETLINK': '666',
 'APP:NOWSMS': '667',
 'SMTP:SMTP-URI-INJ': '668',
 'HTTP:STC:ACTIVEX:AXVLC': '669',
 'SPYWARE:TROJAN:WIN32-DONN-A': '670',
 'P2P:BITTORRENT:DHT': '671',
 'IKE:DOS:ISAKMP-DOS-IPSEC': '672',
 'SPYWARE:BH:NETGUIDE': '673',
 'SCAN:MISC:TELNET:TELNET-PORT-25': '674',
 'HTTP:STC:SRVRSP:COMPRESSED': '675',
 'SPYWARE:AD:MYDAILYHOROSCOPE': '676',
 'HTTP:STC:WINAMP:CDDA-OF3': '677',
 'SCAN:APPDETECTIVE:LDAP-UA': '678',
 'NNTP:AUDIT:UNKNOWN-CMD': '679',
 'TROJAN:MISC:DANTON-SVR-RESP': '680',
 'VNC:AUDIT:AUTH-STATUS': '681',
 'TCP:AUDIT:UNSOL-SACKPERM': '682',
 'TROJAN:MISC:PHOENIX-SERV-RESP': '683',
 'NETBIOS:AUDIT:NAME_ERROR': '684',
 'SCADA:DNP3:MISC-REQ': '685',
 'NTP:ERROR:INVALID_DISPERSION': '686',
 'LDAP:EMPTY:SRCHREQ_LOGOP_NOARGS': '687',
 'SPYWARE:RAT:GREEKHACKERS1-1-STC': '688',
 'HTTP:SQL:INJ:IMP': '689',
 'HTTP:DIR:CRYSTAL-REPORTS': '690',
 'SPYWARE:AD:GIGATECH-SUPERBAR': '691',
 'MS-RPC:DCOM:REMACT-445': '692',
 'HTTP:STC:CLSID:REF-48': '693',
 'P2P:KAZAA:PEER-REQ': '694',
 'VOIP:SIP:SDP:VERSION-OF': '695',
 'SPYWARE:BH:EXACTSEEK': '696',
 'SPYWARE:KL:LOGIT10': '697',
 'HTTP:XSS:ISA-AUTH-XSS': '698',
 'HTTP:STC:CLSID:ACTIVEX:CTX-BO': '699',
 'WORM:AKAK-TRAFFIC': '700',
 'SPYWARE:RAT:MASTER': '701',
 'HTTP:INFO-LEAK:WFCHAT': '702',
 'IMAP:OVERFLOW:WUIMAPD-PART-OF2': '703',
 'HTTP:WIN-CMD:BAT': '704',
 'HTTP:STC:CLSID:ACTIVEX:AX-30': '705',
 'DISCARD:TRAFFIC': '706',
 'SPYWARE:AD:DOWNLOADRECEIVER': '707',
 'SPYWARE:AD:ACTIVESEARCH': '708',
 'SPYWARE:DIALER:COMLOAD': '709',
 'HTTP:PKG:WEBMIN-FAKE-SESSION': '710',
 'HTTP:STC:IMG:NOT-PNG': '711',
 'SPYWARE:KL:SPYOUTSIDE-SMTP': '712',
 'SPYWARE:TROJAN:TROLLA': '713',
 'RLOGIN:USER:USER-ROOT': '714',
 'RUSERS:OVERFLOW:DEV-OVERFLOW': '715',
 'SCAN:CORE:TELNETD-LOGIN': '716',
 'DNS:BIND-NXT-OVERFLOW3': '717',
 'HTTP:CGI:LISTSERV-BO': '718',
 'SCADA:REALWIN': '719',
 'SPYWARE:BH:NEED2FIND': '720',
 'POP3:EXT:DOT-INS': '721',
 'APP:MISC:ICE-HDR-OF': '722',
 'SPYWARE:TROJAN:NUCLEARUP': '723',
 'SCAN:MISC:HTTP:SRCADM-PROBE': '724',
 'APP:XDMCP:DTLOGIN-DBL-FREE': '725',
 'TCP:AUDIT:SYN-RTNS--BADWSF': '726',
 'TROJAN:MISC:ULTIMATE-RAT21': '727',
 'HTTP:STC:SCRIPT:UNICODE-SLED': '728',
 'DOS:NETDEV:LIVINGSTON': '729',
 'HTTP:MISC:WEBWEAVER-DDP': '730',
 'LDAP:INVALID:MODDNREQ-NWRDN-INV': '731',
 'ICMP:EXPLOIT:LAN-SMURF': '732',
 'HTTP:NOVELL:GWWEB-DIR-TRAVERSAL': '733',
 'SCAN:MISC:HTTP:ETC-SHADOW': '734',
 'WORM:LOVEGATE-INFECTED': '735',
 'RPC:RPC.SADMIND:METHOD-CMD-EX-2': '736',
 'SPYWARE:BP:INTERNETMARKETINGBAR': '737',
 'TROJAN:MISC:XANADU10-CON': '738',
 'HTTP:EXT:DOT-GRP': '739',
 'HTTP:REQERR:REQ-MALFORMED-URL': '740',
 'FTP:DIRECTORY:DOT-DOT': '741',
 'SCAN:MISC:HTTP:UNIX-BIN-GCC': '742',
 'TCP:OPTERR:BAD-OPTION': '743',
 'HTTP:STC:IE:MHTML-REDIR-JS': '744',
 'HTTP:STC:CLSID:ACTIVEX:AX-24': '745',
 'HTTP:PHP:PHPNUKE:BOOKMARK-SQL': '746',
 'SCAN:MISC:HTTP:SEARCH-VTS': '747',
 'DB:ORACLE:SQL-PLUS-LOAD-UIX': '748',
 'HTTP:XSS:HTML-SCRIPT-IN-URL-PTH': '749',
 'HTTP:STC:IMG:BMP-WIDTH-OF': '750',
 'HTTP:STC:CLSID:ACTIVEX:AX-57': '751',
 'HTTP:SQL:INJ:AUTHID': '752',
 'SMTP:OVERFLOW:SENDMAIL-CMT-OF2': '753',
 'MS-RPC:MESSENGER-POPUP': '754',
 'TCP:AUDIT:S2C-FIN-OUT-OF-WIN': '755',
 'HTTP:PHP:DFORUM-PHP-INC': '756',
 'HTTP:OVERFLOW:CONTENT-LOCATION': '757',
 'DNS:BIND-NXT-OVERFLOW2': '758',
 'HTTP:PHP:GALLERY:EMBED-AUTH': '759',
 'HTTP:EXT:DOT-HLP': '760',
 'TCP:S2C:EVASION:S2C-ESTB-SYN': '761',
 'SCAN:CYBERCOP:SMTP-EHLO': '762',
 'HTTP:STC:MOZILLA:FIREUNICODE': '763',
 'SPYWARE:RAT:DIGIWATCHER-2-32': '764',
 'SPYWARE:KL:ACESPY': '765',
 'VOIP:MGCP:AUDIT:INV-TRANS-ID': '766',
 'APP:HPOVNNM:EVTCOR-CMD-INJ': '767',
 'TROJAN:PHATBOT:FTP-CONNECT': '768',
 'TROJAN:MISC:BIGORNA-SRV-RESP': '769',
 'APP:SAMBA:NETDFS-OF': '770',
 'HTTP:STC:ACTIVEX:VISBASIC6-AX-3': '771',
 'SPYWARE:AD:KEENVALUE': '772',
 'WORM:MOFEI:MOFEI-B-PROPAGATION': '773',
 'CHAT:AUDIT:YMSG:CHATRM-MSG': '774',
 'HTTP:STC:MCAFEE:FREESCAN-LEAK': '775',
 'HTTP:WASD:DIR-TRAV': '776',
 'SPYWARE:BH:EZ_TRACKS_TOOLBAR': '777',
 'NTP:ERROR:CTL_INV_PEER_EVCODE': '778',
 'CHAT:QQ:QQ-CONNECT': '779',
 'HTTP:CGI:HYPERSEEK-DIR-TRAVERSL': '780',
 'HTTP:STC:IMG:JPEG-UNDERRUN': '781',
 'HTTP:CGI:NAGIOS-CMD-INJ': '782',
 'SPYWARE:KL:MASSCONNECT': '783',
 'POP3:ERROR:INVALID_BASE64_CHAR': '784',
 'MS-RPC:NOVELL-PRINT': '785',
 'HTTP:STC:IE:IE-LOCAL-FORMAT': '786',
 'LDAP:FORMAT:ATTRIB-DESC-FMTERR': '787',
 'POP3:EXT:DOT-MSP': '788',
 'HTTP:STC:IE:FRAME-FLOOD': '789',
 'NFS:INVALID:INVALID-EOF': '790',
 'SCADA:MODBUS:WRITE': '791',
 'MS-RPC:ERR:INV-AUTH-LEN': '792',
 'SPYWARE:AD:MAPQUEST-TOOLBAR': '793',
 'HTTP:STC:CLSID:ACTIVEX:AX-75': '794',
 'HTTP:PHP:PHP-NEWS-FILE-INC': '795',
 'SPYWARE:TROJAN:WEBDOWNLOADER': '796',
 'HTTP:STC:ACTIVEX:OURGAME': '797',
 'HTTP:APACHE:USER-ENUM': '798',
 'DB:MS-SQL:SP_START_JOB-1433': '799',
 'WORM:MYTOB:ED-IRC': '800',
 'SSL:AUDIT:HTTP-OVER-SSL': '801',
 'APP:ORACLE:OHS-LEAK': '802',
 'SMTP:EXT:DOT-BAT': '803',
 'SSL:INVALID:MESSAGE-FMT': '804',
 'SCAN:MISC:HTTP:AUTH-ACCESS': '805',
 'VOIP:SIP:AUDIT:INV-VIA-PROT-ID': '806',
 'WORM:MOFEI:MOFEI-BACKDOOR2': '807',
 'SPYWARE:KL:BASP-PRO-4': '808',
 'HTTP:CGI:INCLUDER-EXEC': '809',
 'HTTP:STC:IMG:BMP-HEADER-UF': '810',
 'HTTP:CGI:CDOMAINFREE-RMT-EXEC': '811',
 'P2P:DC:DNS-QUERY': '812',
 'HTTP:PHP:WEBMIN-TARGET': '813',
 'DNS:REQUEST:REVERSE-LOOKUP': '814',
 'HTTP:CGI:GEOCEL-FILE-DISCLOSURE': '815',
 'DDOS:TRIN00:MASTERPW-DEF-REMOTE': '816',
 'TROJAN:MISC:VOODOO-COMMAND': '817',
 'TROJAN:MISC:TROJANCOW-COMMAND': '818',
 'REXEC:OVERFLOW:COMMAND': '819',
 'TROJAN:REMOTE-EXPLORER:CONNECT': '820',
 'HTTP:PHP:THATWARE:CONFIG-INC': '821',
 'APP:GAME:DIRECTPLAY-DOS': '822',
 'SPYWARE:GM:HMTOOLBAR': '823',
 'SPYWARE:RAT:MINICOMMAND203-ICQ': '824',
 'HTTP:STC:CLSID:ACTIVEX:AX-83': '825',
 'TROJAN:MISC:AMANDA-SRV-RESP': '826',
 'CHAT:AUDIT:YMSG:CRYPT-PASSWD': '827',
 'SMTP:EXPLOIT:DMAIL-FS': '828',
 'NTP:ERROR:CTL_INV_PEER_SELECT': '829',
 'SPYWARE:AD:DOWNLOAD-ACCEL': '830',
 'APP:NTOP-WEB-FS1': '831',
 'SPYWARE:AD:HENBANG': '832',
 'SPYWARE:RAT:LANFILTRATOR1-1-CTS': '833',
 'HTTP:STC:IMG:WMF-METASPLOIT-GZ': '834',
 'SPYWARE:BH:FREEZE-COM': '835',
 'TROJAN:TELNET:USER-D13HH[': '836',
 'SCAN:AMAP:SSL-ON-SSH': '837',
 'FTP:OVERFLOW:WUBSD-SE-RACE': '838',
 'NTP:ERROR:MSG_TOO_LONG': '839',
 'IP:IGMP-MS-DOS': '840',
 'SCAN:MISC:HTTP:CFGWIZ-EXE-PROBE': '841',
 'FTP:EXPLOIT:FTPBIN-WRITEABLE': '842',
 'TELNET:USER:DEFAULT-PW-3COM': '843',
 'HTTP:TUNNEL:ALTNET-OVER-HTTP': '844',
 'SPYWARE:AD:3WPLAYER_1_7': '845',
 'RSH:USER:USER-ECHO': '846',
 'HTTP:STC:PPT-SCRIPT2': '847',
 'APP:ARKEIA:AGENT-ACCESS': '848',
 'HTTP:STC:CLSID:ACTIVEX:HP-MODEM': '849',
 'HTTP:MISC:EZGUESTBOOK': '850',
 'APP:CA:PRODUCT-DISC-BOF': '851',
 'NETBIOS:AUDIT:NBNAME-RES-ADDR': '852',
 'HTTP:STC:MOZILLA:QI-MEMCORRUPT': '853',
 'SCAN:MISC:HTTP:PAGESERVICE': '854',
 'SMB:OF:NWCW-INV-CALL': '855',
 'HTTP:WEBPLUS:WEBPING': '856',
 'HTTP:STC:CLSID:REF-52': '857',
 'SPYWARE:RAT:FLUX': '858',
 'APP:AI:PARTIAL-MATCH': '859',
 'HTTP:WHATSUP:WEB-SQL-INJECT': '860',
 'HTTP:SQL:INJ:POSTNUKE': '861',
 'SPYWARE:BH:WISHBONE': '862',
 'SPYWARE:AD:FREEDOWNLOADMANAGER': '863',
 'LDAP:INVALID:SEARCH-BASEOBJ-INV': '864',
 'HTTP:STC:CLSID:ACTIVEX:EPO-SM': '865',
 'LDAP:INVALID:REQ_OBJECT_INVALID': '866',
 'HTTP:STC:ACTIVEX:SAP-AG-SAPGUI': '867',
 'HTTP:STC:ACTIVEX:MSGSC-DLL': '868',
 'SCAN:MISC:HTTP:VOIDEYE': '869',
 'SPYWARE:TROJAN:FUNFACTORY-STC': '870',
 'SPYWARE:BP:SMILEYCENTRAL': '871',
 'HTTP:STC:VULN:CHEROKEE-0-4-17-1': '872',
 'HTTP:STC:CSS-RELOADED': '873',
 'WORM:CHOD.B': '874',
 'SMTP:EXT:DOT': '875',
 'SMB:EXPLOIT:GREENAPPLE-2': '876',
 'P2P:MISC:KUGOO-LOGIN': '877',
 'SPYWARE:AD:BROADCASTURBANTUNER': '878',
 'SSL:DTLS-DOS': '879',
 'POP3:EXT:DOT-JS': '880',
 'IMAP:OVERFLOW:LINE': '881',
 'SPYWARE:TROJAN:CROSSBOW': '882',
 'HTTP:STC:CLSID:ACTIVEX:AX-58': '883',
 'SHELLCODE:LINUXX86:GEN-2-PKT': '884',
 'PORTMAPPER:INFO:NULL-PROC': '885',
 'TELNET:OVERFLOW:YBSD-OF-CHECK': '886',
 'HTTP:PHP:PHPBB:PROOTPATH-INJ': '887',
 'SMTP:AUDIT:EXTERNAL-MESG': '888',
 'SPYWARE:AD:TOPICKS': '889',
 'TROJAN:MISC:PHASE-ZERO-SRV-RESP': '890',
 'VOIP:SIP:BRUTE-FORCE': '891',
 'TROJAN:BACKORIFICE:EXECUTION': '892',
 'FTP:PROFTP:SIZE-DOS': '893',
 'DISCARD:EXPLOIT:UNEXPECTED-REP': '894',
 'LDAP:FAILED:MODDN-RESULT-FAIL': '895',
 'APP:SITEMINDER-AUTH-REDIR': '896',
 'SPYWARE:DIALER:EASYDATES': '897',
 'APP:AFP-LEN-OF': '898',
 'HTTP:STC:IMG:ANI-SIZE-OF': '899',
 'SNMP:ERROR:MSG-TOO-SHORT': '900',
 'HTTP:STC:SWF:HEAP-OF': '901',
 'SMB:AUDIT:INV-PROTOCOL': '902',
 'NETBIOS:WINS:SRV-NAME-OF': '903',
 'CHAT:MSN:INVALID:PNG-HEIGHT': '904',
 'TCP:OPTERR:SHORT-READ': '905',
 'SPYWARE:AD:DASHBAR': '906',
 'TELNET:AUDIT:REQ-SUBNEG-UNKNOWN': '907',
 'HTTP:CISCO:CATALYST-ARB-CMD': '908',
 'WORM:NETSKY:V-SMTP-PROP': '909',
 'SCAN:MISC:HTTP:PUBXPERT-PSUSER': '910',
 'SPYWARE:DIALER:PLUGINACCESS': '911',
 'SCADA:IEC104:SESSION-ALT-PORT': '912',
 'HTTP:STC:CLSID:ACTIVEX:ACER-OBJ': '913',
 'HTTP:LHTTPD:GET-OF-RH7': '914',
 'P2P:OVERNET:KADEMILIA-OVERNET': '915',
 'LPR:OVERFLOW:C-FONT': '916',
 'HTTP:OVERFLOW:CONTENT-LENGTH': '917',
 'HTTP:STC:IE:JS-MC-2': '918',
 'HTTP:BADBLUE:INVALID-BYTE-REQ': '919',
 'PROTOCOLS:TRAFFIC:NOT-FTP': '920',
 'HTTP:CGI:REF-CMD-INJECT': '921',
 'TROJAN:MISC:BDDT-SRV-OK': '922',
 'CHAT:ICQ:FILE-RECEIVE': '923',
 'SPYWARE:RAT:REMOTESTORM1-2STC': '924',
 'HTTP:TUNNEL:CHAT-YIM': '925',
 'HTTP:REQERR:BIN-DATA-ACCEPT': '926',
 'CHAT:AUDIT:YMSG:CHATROOM-NAME': '927',
 'SPYWARE:RAT:ROBO-HACK1-2': '928',
 'DHCP:OPT:DEF-TTL-ZERO': '929',
 'HTTP:STC:CLSID:ACTIVEX:AX-72': '930',
 'SPYWARE:AD:NETPUMPER126': '931',
 'SMTP:RESPONSE:USER-UNKNOWN': '932',
 'TCP:C2S:INFO:C2S-FIN-OUT-OF-WIN': '933',
 'SPYWARE:TROJAN:MYDEMISE': '934',
 'SCAN:NESSUS:HTTP-USER-AGENT': '935',
 'DNS:QUERY:VERSION-QUERY': '936',
 'HTTP:STC:ACTIVEX:AUTODESK-IDROP': '937',
 'HTTP:PKG:EZMALL-LOG-ORDER-ACCSS': '938',
 'HTTP:IIS:ASPNET-DOS': '939',
 'HTTP:PASSWD:COMMON': '940',
 'P2P:WINNY:PEER-CONNECT': '941',
 'HTTP:PHP:PHPBB:AUTH-BYPASS': '942',
 'SPYWARE:BH:LOOKSTER': '943',
 'SMTP:EXT:DOT-WSC': '944',
 'VOIP:MGCP:SDP:HEADER-RPT-ERR': '945',
 'MS-RPC:LAN-WORM-SPREAD': '946',
 'SPYWARE:RAT:MINICOMLITE': '947',
 'SNMP:RESPONSE:TOO-BIG': '948',
 'WORM:CODERED-2:CMD-BACKDOOR': '949',
 'SNMP:ENCODING:INVALID-MIBROOT': '950',
 'RADIUS:RADIUS-USR-OF': '951',
 'TROJAN:MISC:BLACKANGEL-SRV-RESP': '952',
 'CHAT:MSN:GIF-OVERFLOW': '953',
 'HTTP:3COM:LOG-CLEAN': '954',
 'HTTP:STC:ATOM-TABLE': '955',
 'SCAN:MISC:HTTP:WIN-CD..': '956',
 'RPC:RPC.SADMIND:SADMIND-OF': '957',
 'HTTP:PKG:SALESLOGIC-UNAUTH-ADMN': '958',
 'POP3:EXT:DOT-MSI': '959',
 'SPYWARE:GM:DROP-AGENT-ADA': '960',
 'DNS:AUDIT:TYPE-ALL': '961',
 'VOIP:SIP:LIMITS:AUTHORIZ-OF': '962',
 'HTTP:PROXY:CAW-URI-RES': '963',
 'SNMPTRAP:ENCODING:INVALID-MROOT': '964',
 'HTTP:STC:IE:VML-FILL-BOF': '965',
 'HTTP:PHP:TIKIWIKI-JHOT': '966',
 'CHAT:MSN:INVALID:MSN-VID-FRAME': '967',
 'HTTP:STC:IE:PRE-TAG-2': '968',
 'HTTP:STC:CLSID:ACTIVEX:AX-149': '969',
 'HTTP:INFO:MS-UPDATE': '970',
 'VNC:ULTRAVNC-CLIENT-AUTH-OF': '971',
 'SPYWARE:RAT:LITTLEWITCHEXPLORER': '972',
 'SCAN:MISC:HTTP:UNIX-BIN-CSH': '973',
 'IP:EXPLOIT:IP-TRACEROUTE': '974',
 'HTTP:STC:CLSID:REF-1': '975',
 'SPYWARE:RAT:ALEXMESSOMALEX-STC': '976',
 'HTTP:MISC:XENEO-WEBREQ-DOS': '977',
 'FTP:EXPLOIT:GLFTPD-KAKAKA': '978',
 'TELNET:USER:ROOT': '979',
 'HTTP:LINUX:RPM-QUERY': '980',
 'APP:REAL:REALTEXT-ERR-OF': '981',
 'HTTP:STC:IE:FIREFOX-URL-CMD-INJ': '982',
 'SYSLOG:AUDIT:MISSING-PRI': '983',
 'PROTOCOLS:PORT:TELNET': '984',
 'VOIP:SKYPE:PROBE-1': '985',
 'SPYWARE:BH:NEWDOTNETQUICKSEARCH': '986',
 'FTP:SERVU:STOU-DOS': '987',
 'SMTP:COMMAND:DEBUG': '988',
 'SCAN:AMAP:FTP-ON-POP3': '989',
 'SMTP:EXPLOIT:RELAY-ATTEMPT': '990',
 'SPYWARE:AD:UNNAMED-ADWARE': '991',
 'SPYWARE:AD:WHENUSEARCH': '992',
 'HTTP:CGI:SPIDERSALES': '993',
 'SPYWARE:TROJAN:DIRTXT': '994',
 'HTTP:STC:CLSID:ACTIVEX:NAVCOMUI': '995',
 'SMB:NETBIOS:RMT-REG-ACCESS': '996',
 'SPYWARE:DM:ALEXA-TOOLBAR': '997',
 'RUSERS:AUDIT:ROOT-ACCESS': '998',
 'DOS:APPLICATION:TEMPLATE-7070': '999',
 'SMTP:EXT:DOT-PIF': '1000',
 'SCAN:MISC:HTTP:WEBDRIVER-ACCESS': '1001',
 'HTTP:STC:IE:CACHE-CREATERANGE': '1002',
 'LDAP:SUN-REQ-FS': '1003',
 'SPYWARE:TROJAN:CYBERPAKY': '1004',
 'RTSP:OVERFLOW:STREAMCOUNT': '1005',
 'TROJAN:MISC:VAMPIRE-SRV-RESP': '1006',
 'FTP:USER:ACFTP-BAD-LOGIN': '1007',
 'WORM:PHPINCLUDE:REMOTE-FILENAME': '1008',
 'HTTP:STC:ACTIVEX:SYMFAX': '1009',
 'SPYWARE:RAT:BUSCHTROMMEL122-STC': '1010',
 'MS-RPC:NETSRVRDSKENUM': '1011',
 'SPYWARE:AD:ISEARCH': '1012',
 'HTTP:STC:CLSID:ACTIVEX:AX-39': '1013',
 'TELNET:USER:EZSETUP': '1014',
 'HTTP:INFO:MWS-SEARCH-OF1': '1015',
 'DB:DB2:DB2-DOS': '1016',
 'IMAP:OVERFLOW:LINUX-X86-1': '1017',
 'SHELLCODE:SPARC:SETGID-0-PKT': '1018',
 'SMB:AUDIT:NT-LM-0.12': '1019',
 'DDOS:TRIN00:MASTER-PROMPT': '1020',
 'HTTP:STC:CLSID:ACTIVEX:MS-MDAC2': '1021',
 'VOIP:SIP:OVERFLOW:SECURITY-PAR': '1022',
 'SPYWARE:AD:WINANTIVIRUSPRO2007': '1023',
 'TROJAN:MISC:CONNECTION-RESP': '1024',
 'TCP:S2C:EXPLOIT:URG-WO-FLAGS': '1025',
 'SMTP:EMAIL:EUDORA-LONG-MSG-URL': '1026',
 'SCAN:MISC:SVR-RES-S1024': '1027',
 'HTTP:MISC:IASP-DIR-TRAV': '1028',
 'HTTP:STC:CLSID:ACTIVEX:AX-38': '1029',
 'HTTP:STC:CLSID:ACTIVEX:AX-128': '1030',
 'LDAP:EMPTY:ATTRIBVAL_LIST_EMPTY': '1031',
 'SPYWARE:GM:MYSPACEBARIE': '1032',
 'SNMPTRAP:ENCODING:ZLEN-VALUE': '1033',
 'APP:NAV-ENT-WEB-OF-2': '1034',
 'DB:MS-SQL:STOR-PROC-ARB-FILE': '1035',
 'SPYWARE:RAT:BIONET-TCP': '1036',
 'SCAN:MISC:HTTP:README-EML': '1037',
 'HTTP:STC:WIN-MAL-COMP-FILE': '1038',
 'SPYWARE:TROJAN:ERASER': '1039',
 'LDAP:INVALID:ENC_INTEGER_LEN': '1040',
 'SPYWARE:TROJAN:BRAINWIPER': '1041',
 'SPYWARE:AD:2005SEARCHLOADER': '1042',
 'P2P:DC:ACTIVE': '1043',
 'CHAT:AIM:TUNNEL': '1044',
 'VNC:ERR:NO-AUTH-SCHEME': '1045',
 'MS-RPC:ERR:EPM-INV-LHS-LEN': '1046',
 'HTTP:OVERFLOW:EPOLICY-OF': '1047',
 'SPYWARE:AD:SHOPATHOMESELECT': '1048',
 'HTTP:STC:SKYPE4COM': '1049',
 'SPYWARE:BH:HOTBAR100368': '1050',
 'POP3:EXT:DOT-WSC': '1051',
 'MS-RPC:ERR:FRAG-LEN-TOO-SMALL': '1052',
 'TCP:AUDIT:C2S-FINWAIT2-FIN': '1053',
 'SPYWARE:BH:FREEACCESS': '1054',
 'HTTP:STC:IE:COLORBALANCE': '1055',
 'HTTP:STC:CLSID:ACTIVEX:AX-138': '1056',
 'FTP:WU-FTP:SETPROCTITLE': '1057',
 'HTTP:IIS:NSIISLOG-CHUNKED-POST': '1058',
 'P2P:BEARSHARE:SEARCH': '1059',
 'DB:ORACLE:DEFAULT-PW-ADAMS': '1060',
 'P2P:KAZAA:FILE-HASH': '1061',
 'DOS:NETDEV:LINKSYS-GOZILA-DOS2': '1062',
 'WORM:SLAPPER:B-INFECT': '1063',
 'SNMP:ENCODING:ES-TOO-BIG': '1064',
 'P2P:MISC:PHEX': '1065',
 'HTTP:STC:ACTIVEX:MSOWC-2': '1066',
 'TIP:INV-IDENTIFY-RESP': '1067',
 'FTP:FILE:SPACE.ASP': '1068',
 'HTTP:EXPLOIT:IE-SAVE-AS-HIDE': '1069',
 'SPYWARE:RAT:MINIOBLIVION': '1070',
 'HTTP:STC:ACTIVEX:AOL-AMPX': '1071',
 'FINGER:REQERR:BIN-HOST': '1072',
 'SPYWARE:GM:IOWAWEBDOWNLOADER': '1073',
 'SCAN:NESSUS:NPH-PUBLISH-CGI': '1074',
 'HTTP:WHATSUP:DOS-DEV-DOS': '1075',
 'CHAT:IRC:INVALID:MSG': '1076',
 'SPYWARE:AD:SIMBAR': '1077',
 'FINGER:EXPLOIT:DOT-AT-HOST': '1078',
 'SHELLCODE:SPARC:GEN-3-TCP': '1079',
 'P2P:NAPSTER:DOWNLOAD-8888': '1080',
 'SHELLCODE:METASPLOIT:PEX-ALPHA': '1081',
 'HTTP:EXT:DOT-CHM': '1082',
 'VOIP:SIP:LIMITS:REC-ROUTE-OF': '1083',
 'SPYWARE:BH:STARTNOW': '1084',
 'SPYWARE:AD:HOTOFFERS': '1085',
 'HTTP:OVERFLOW:SAMBAR-SEARCH': '1086',
 'HTTP:INFO:REQ-NO-CONTENT-LENGTH': '1087',
 'HTTP:APACHE:XSPACE': '1088',
 'SCAN:MISC:HTTP:SCRIPTS-BROWSE': '1089',
 'IKE:DOS:TCP-HUMP': '1090',
 'SPYWARE:RAT:HANUMAN': '1091',
 'SPYWARE:RAT:SPYAGENT-SMTP': '1092',
 'HTTP:STC:WINAMP:CDDA-OF': '1093',
 'SCAN:MISC:HTTP:EXAMPLEAPP-PRB': '1094',
 'TCP:S2C:EVASION:S2C-URG-OUT-WIN': '1095',
 'SCAN:MISC:HTTP:BIGCONF-ACCESS': '1096',
 'SPYWARE:KL:WIN32.REMOTEKEYLOG.B': '1097',
 'HTTP:STC:CLSID:ACTIVEX:NCT-AX': '1098',
 'HTTP:INFO-LEAK:WEB-INF-DOT': '1099',
 'SMB:INFO:LANMAN-1.0': '1100',
 'HTTP:STC:ADOBE:ACROBAT-UUEXEC': '1101',
 'SCAN:MISC:HTTP:LWGATE-PROBE': '1102',
 'HTTP:INFO-LEAK:POLYCOM': '1103',
 'HTTP:CGI:HASSAN-DIR-TRAVERSAL': '1104',
 'WHOIS:TUNNEL': '1105',
 'TELNET:FAILURE:NON-NTLM': '1106',
 'HTTP:DOMINO:HASH-DUMPER': '1107',
 'DB:ORACLE:OVERFLOW_MSG': '1108',
 'DHCP:ERROR:INV-HW-LEN': '1109',
 'SPYWARE:RAT:EXCEPTION1-0-HTTP': '1110',
 'SHELLCODE:HP-UX:HP-NOOP-1-PKT': '1111',
 'SPYWARE:AD:CLIPGENIE': '1112',
 'RUSERS:ERR:WRONG-DIR': '1113',
 'CHAT:AUDIT:YMSG:URL': '1114',
 'IDENT:AUDIT:PORT-PAIR': '1115',
 'HTTP:STC:CLSID:ACTIVEX:AX-10': '1116',
 'SMTP:DOS:SENDMAIL-BIGHEADER': '1117',
 'TROJAN:CDK:PORT15858': '1118',
 'APP:VERITAS:AGENT-NAME-OF': '1119',
 'HTTP:STC:CLSID:ACTIVEX:RFCGUI': '1120',
 'HTTP:PHP:PHPNUKE:CID-SQL-INJECT': '1121',
 'NTP:ERROR:CTL_INV_PEER_STATUS': '1122',
 'HTTP:IIS:ASN.1-BIT-STRING': '1123',
 'HTTP:IIS:SAMPLE-ACCESS': '1124',
 'DNS:OVERFLOW:OPT-DOS': '1125',
 'SPYWARE:TROJAN:LURKER11': '1126',
 'HTTP:MISC:NG-WG602-BACKDOOR': '1127',
 'SHELLCODE:HP-UX:HP-NOOP-2-PKT': '1128',
 'VOIP:SIP:AUDIT:INV-CHAR-LOW': '1129',
 'TROJAN:QAZ:TCP25-CALLING-HOME': '1130',
 'HTTP:STC:OUTLOOK:OUTLOOK-PRF': '1131',
 'TROJAN:Y3K-RAT:Y3K14-RAT-UDP': '1132',
 'TROJAN:MISC:EVENTHORIZON-CMD': '1133',
 'SCAN:MISC:TELNET:SHUTDOWN': '1134',
 'VOIP:SIP:SHORT-RESPONSE': '1135',
 'VOIP:SIP:SDP:MEDIA-PORT-OF': '1136',
 'IKE:MALFORMED:INV-PAY-LEN': '1137',
 'HTTP:STC:ACTIVEX:VIDEOCALL': '1138',
 'MS-RPC:MSRPC-EVASION-3': '1139',
 'POP3:USER:ROOT': '1140',
 'HTTP:STC:CLSID:ACTIVEX:AX-102': '1141',
 'CHAT:MSN:HTTP:MSNFTP-INVITE': '1142',
 'LDAP:UNSUPPORTED_VERSION': '1143',
 'RSH:AUDIT:PARAM-NOT-OK': '1144',
 'VNC:AUDIT:CONNECT-FAIL': '1145',
 'RLOGIN:FAILURE:LOGIN-FAILURE': '1146',
 'WORM:SLAPPER:CINIK-SRC': '1147',
 'SPYWARE:TROJAN:AUTOSPY-STC': '1148',
 'HTTP:BIGBROTHER:DIR-TRAVERSAL': '1149',
 'SPYWARE:TROJAN:DLOADERAGENT-TL': '1150',
 'SPYWARE:AD:GATOR-DATEMANAGER': '1151',
 'SCADA:MODBUS:LENGTH': '1152',
 'P2P:EDONKEY:FILE-SEARCH-REQ': '1153',
 'HTTP:IIS:CMS:MAL-CMS-REQ-2': '1154',
 'HTTP:INFO-LEAK:BANNERMATIC': '1155',
 'SCAN:MISC:HTTP:IIS-SAMPLES': '1156',
 'SYSLOG:FAILURES:MSG-TOO-LONG': '1157',
 'TCP:AUDIT:OPTIONS-UNNEGOT-SACK': '1158',
 'HTTP:STC:CLSID:ACTIVEX:AX-151': '1159',
 'MS-RPC:LSASS:MAL-OPCODE-2': '1160',
 'LPR:OVERFLOW:LINE': '1161',
 'HTTP:SQL:INJ:CONVERT': '1162',
 'HTTP:PHP:WEBCAL-INC': '1163',
 'HTTP:STC:IE:ADDRBAR-SPOOF-2': '1164',
 'SCAN:MISC:HTTP:FILES-ACCESS': '1165',
 'APP:QT-SERVER:QT-ARG-DOS': '1166',
 'SMTP:INVALID:UNFIN-MULTIPART': '1167',
 'SNMP:ENCODING:ZLEN-FOR-VALUE': '1168',
 'HTTP:XSS:ASP-REQ-VALIDATION': '1169',
 'HTTP:WEBLOGIC:ENCODING': '1170',
 'DHCP:AUDIT:CLI-HW-MISMATCH': '1171',
 'TCP:AUDIT:WRONG-CHECKSUM': '1172',
 'SPYWARE:GM:SPYWARESTORMER': '1173',
 'SNMPTRAP:ENCODING:INT-TOO-BIG': '1174',
 'RLOGIN:AUDIT:REQ-ILLEGAL-PORT': '1175',
 'SMTP:OVERFLOW:COMMAND-LINE': '1176',
 'SPYWARE:AD:ADBARS': '1177',
 'WORM:EMAIL:W32-FRIENDGREET': '1178',
 'LPR:OVERFLOW:C-SYMLINK': '1179',
 'TROJAN:MISC:KIDTERROR-SRV-RESP': '1180',
 'NTP:ERROR:MSG_TOO_SHORT': '1181',
 'HTTP:STC:CLSID:ACTIVEX:SAP-AX': '1182',
 'SPYWARE:KL:SYS-KEYLOG-1-3': '1183',
 'LDAP:INVALID:REQ-OPERATION-INV': '1184',
 'DOS:IP:PGM': '1185',
 'SPYWARE:TROJAN:GENIE17': '1186',
 'DOS:NETDEV:WEBJET-FW-INFOLEAK': '1187',
 'SHELLCODE:LINUXX86:NETRIC-BIND': '1188',
 'HTTP:STC:WINAMP:M3U-BOF': '1189',
 'MS-RPC:SPOOLER-DLL-LOAD': '1190',
 'SPYWARE:RAT:JOKERSFTP': '1191',
 'SPYWARE:BH:INTERNETOPTIMIZER': '1192',
 'APP:PEER2MAIL': '1193',
 'APP:CISCO:ACS-FS': '1194',
 'SNMP:AUDIT:PRIVATE': '1195',
 'HTTP:CGI:CYBEROFFICE-DB-REQUEST': '1196',
 'SPYWARE:UTIL:SPYWARESTRIKE': '1197',
 'TROJAN:MISC:DCONNECT': '1198',
 'SPYWARE:RAT:BADRAT1-1': '1199',
 'SPYWARE:AD:NETGUARDERWEBCLEANER': '1200',
 'HTTP:STC:IE:STYLESHEET-OF': '1201',
 'MS-RPC:DCOM:EXPLOIT-3': '1202',
 'MS-RPC:ERR:EPM-INV-TOWER-LEN': '1203',
 'SPYWARE:AD:VIP01-BIZ': '1204',
 'P2P:NAPSTER:DATA-8888': '1205',
 'TROJAN:MISC:FORE-SRV-RESP': '1206',
 'LDAP:FAILED:SEARCH-RESULT-FAIL': '1207',
 'HTTP:REQERR:BIN-DATA-AUTH': '1208',
 'POP3:EXT:DOUBLE-EXTENSION': '1209',
 'HTTP:TUNNEL:TELNET': '1210',
 'WORM:SMB:W32-SLACKOR': '1211',
 'VIRUS:POP3:UUENCODED-DOT-VBS': '1212',
 'SPYWARE:RAT:OMERTA-V13': '1213',
 'APP:ETHEREAL:IGAP-ACCT-OF': '1214',
 'POP3:EXT:DOT-SHS': '1215',
 'RADIUS:RADIUS-BRUTE-FORCE': '1216',
 'HTTP:STC:ADOBE:PDF-OPENACTION': '1217',
 'SCAN:MISC:TELNET:XHOST-PLUS': '1218',
 'POP3:EXT:DOT-JSE': '1219',
 'HTTP:TOMCAT:SERVLET-DEVICE-DOS': '1220',
 'SMTP:OUTLOOK:OBJECT-TAG-XML': '1221',
 'HTTP:STC:CLSID:ACTIVEX:AX-25': '1222',
 'SPYWARE:AD:URLBLAZE': '1223',
 'HTTP:STC:IE:IE-CACHE-ELEBYID': '1224',
 'DNS:EXPLOIT:TRANSPOOF': '1225',
 'SCAN:MISC:HTTP:ADMIN-FILES': '1226',
 'HTTP:INFO-LEAK:NETGEAR-CONFLEAK': '1227',
 'SPYWARE:GM:NETCRAFTTOOLBAR': '1228',
 'SCAN:MISC:HTTP:UPLOADER-EXE': '1229',
 'HTTP:SQL:INJ:SQLCMDSHELL': '1230',
 'APP:GAME:WOW-LOGIN': '1231',
 'P2P:EDONKEY:CLIENT-VER-CHECK': '1232',
 'VOIP:H225SGN:SETUP': '1233',
 'IMAP:OVERFLOW:LIT_LENGTH_OFLOW': '1234',
 'ICMP:AUDIT:INVALID-CODE': '1235',
 'HTTP:STC:QT-EMBED-JS': '1236',
 'LDAP:INVALID:ENC_INVALID_LEN': '1237',
 'SPYWARE:TROJAN:EVILOTUS_1_32': '1238',
 'SPYWARE:BH:COOLSEARCH': '1239',
 'SCAN:MISC:HTTP:ANNEX-DOS': '1240',
 'DB:ORACLE:DEFAULT-PW-BLAKE': '1241',
 'TROJAN:MISC:INTERNALREVISE-CMD': '1242',
 'SPYWARE:BH:SEARCH4TOP': '1243',
 'TROJAN:MISC:CRAZZYNET-SRV-RESP': '1244',
 'SPYWARE:BH:MYSEARCHBAR': '1245',
 'TCP:AUDIT:C2S-TIMEWAIT-FIN': '1246',
 'SCAN:MISC:HTTP:WEBHITS-ACCESS': '1247',
 'HTTP:IIS:ENCODING:PERC-PERC-3': '1248',
 'SMTP:EXT:DOT-ISP': '1249',
 'HTTP:HOTMAIL:ZIP-DOWNLOAD': '1250',
 'SPYWARE:BH:KWORD-INTERKEY': '1251',
 'APP:REAL:RAM-FILE-OF': '1252',
 'TROJAN:DOLY:SERVER-RES-V2': '1253',
 'LDAP:KERIO-DOS': '1254',
 'SMB:NETBIOS:INV-CDNAME-ENC': '1255',
 'HTTP:STC:IMG:PNG-CHUNK-OF': '1256',
 'RPC:RPC.TTDBSERVER:TT-MAL-FS': '1257',
 'SPYWARE:BH:CWSSTARTPAGEVARIANT': '1258',
 'SMTP:DOS:SENDMAIL-HELO-DOS': '1259',
 'P2P:BITTORRENT:TRACKER-SCRAPE': '1260',
 'CHAT:AUDIT:YMSG:USERNAME': '1261',
 'FTP:WS-FTP:WS-FTP-COMM-OF': '1262',
 'TELNET:USER:DEFAULT-PW': '1263',
 'P2P:KAZAA:UDP-PROBE': '1264',
 'VOIP:SIP:SECURITY-PAR-ERR': '1265',
 'SMTP:EXT:DOT-JSE': '1266',
 'SCAN:MISC:HTTP:TESTCOUNTER': '1267',
 'DB:MYSQL:BRUTE-FORCE': '1268',
 'VIRUS:SMTP:EXE-ATTACH-1': '1269',
 'SPYWARE:AD:PEOPLEONPAGE': '1270',
 'HTTP:CGI:TECHNOTE-MAIN-DCLSR': '1271',
 'DB:ORACLE:TNS-ORACLE-OF': '1272',
 'SPYWARE:AD:IEDEFENDER': '1273',
 'HTTP:STC:SWF:DEFSCENE-OF': '1274',
 'HTTP:STC:ACTIVEX:DERIVO': '1275',
 'SCAN:MISC:HTTP:EDIT-DOC-ATTEMPT': '1276',
 'SNMP:ENUM:LM2-ACCESS': '1277',
 'HTTP:STC:CLSID:ACTIVEX:AX-85': '1278',
 'HTTP:ORACLE:SOAP-CONF': '1279',
 'SMTP:AUDIT:REQ-NESTED-REQUEST': '1280',
 'TROJAN:HXDEF1.00': '1281',
 'APP:WMP:DSHOW-BIGCHUNK-SMB': '1282',
 'HTTP:TUNNEL:SMTP': '1283',
 'SMTP:EXT:DOT-CPL': '1284',
 'HTTP:STC:IMG:JPEG-HEIGHT-OF': '1285',
 'HTTP:IIS:REGREAD-ATTEMPT': '1286',
 'SCAN:MISC:HTTP:MSPROXY-PROBE': '1287',
 'HTTP:PHP:PHORUM:RESPONSE-SPLIT': '1288',
 'SPYWARE:TROJAN:LETMERULE20-STC': '1289',
 'SYSLOG:SYSLOG-CRAFTED-PKT': '1290',
 'IMAP:OVERFLOW:FLAG': '1291',
 'HTTP:CGI:TWIKI-SEARCH-CMD-EXEC': '1292',
 'SSH:MISC:EXPLOIT-CMDS-UNIX': '1293',
 'HTTP:IIS:MSADC-PROBE': '1294',
 'TCP:AUDIT:C2S-FINRETR-BADSEQ': '1295',
 'SPYWARE:BH:MICROGRAMING': '1296',
 'HTTP:STC:CLSID:REF-44': '1297',
 'SHELLCODE:SCO:GEN-1-PKT': '1298',
 'HTTP:STC:NORTON:LAUNCHURL-HTTP': '1299',
 'HTTP:FRONTPAGE:DVWSSR.DLL-OFLOW': '1300',
 'DB:MS-SQL:CONVERT-OF': '1301',
 'SSL:INVALID:CIPHER-SUITE': '1302',
 'TROJAN:NETSPHERE:SVR-RES': '1303',
 'POP3:OVERFLOW:TXTLINE_2LONG': '1304',
 'DHCP:EXPLOIT:SOLARIS-EXEC': '1305',
 'SPYWARE:AD:GROOWESEARCHBAR': '1306',
 'HTTP:STC:STREAM:WMV': '1307',
 'HTTP:PHP:PHPROJEKT-INC': '1308',
 'DNS:ISATAPREG': '1309',
 'SPYWARE:RAT:FERAT1-00-CTS': '1310',
 'SPYWARE:AD:CALLINGHOME-BIZ': '1311',
 'DB:MS-SQL:SQLMON-PING-DOS': '1312',
 'SHELLCODE:X86:SETGID-0-PKT': '1313',
 'NETBIOS:NBNS:TYPE_UNKNOWN': '1314',
 'SPYWARE:AD:HSADVISORTOOLBAR': '1316',
 'HTTP:STC:STREAM:FLV': '1317',
 'HTTP:STC:CLSID:ACTIVEX:NAVOPTS': '1318',
 'LPR:OVERFLOW:C-TITLE': '1319',
 'HTTP:STC:CLSID:ACTIVEX:KASP-AX': '1320',
 'DDOS:TRIN00:MASTER-CMD-MSIZE': '1321',
 'SPYWARE:BH:ZANGO': '1322',
 'VOIP:MGCP:SDP:TIME-OF': '1323',
 'SPYWARE:UTIL:SMARTBARXP': '1324',
 'HTTP:COLDFUSION:ONREQUESTEND': '1325',
 'VOIP:SIP:AUDIT:EMPTY-HEADER-VAL': '1326',
 'HTTP:COBALT:CONF-DIR-TRAV': '1327',
 'SCAN:MISC:IDP-TEST': '1328',
 'DB:MS-SQL:HELLO-OF1': '1329',
 'HTTP:PHP:SITEMAN-USER': '1330',
 'HTTP:IIS:COMMAND-EXEC-ALL': '1331',
 'SPYWARE:KL:BOSSEVERYWARE': '1332',
 'SPYWARE:DM:BRIDALBASICS': '1333',
 'SCAN:MISC:HTTP:HTGREP-ACCESS': '1334',
 'CHAT:AUDIT:YMSG:OFLOW-RESP-CRPT': '1335',
 'SMTP:VULN:MERCUR-3-3': '1336',
 'HTTP:STC:NORTON:SYMSPAM-HTTP': '1337',
 'VOIP:SIP:OVERFLOW:VIA-HOST-OF': '1338',
 'HTTP:STC:IE:JS-VBS-DECODE-OF': '1339',
 'NETBIOS:DOS:RFPARALYZE': '1340',
 'SPYWARE:RAT:NETCONTROLTAKEOVER': '1341',
 'IMAP:MDAEMON:MDAEMON-FETCH-OF': '1342',
 'HTTP:STC:IE:GOOGLEBAR-FILE': '1343',
 'HTTP:STC:CLSID:ACTIVEX:AX-82': '1344',
 'HTTP:COLDFUSION:CFCACHE-MAP': '1345',
 'LPR:OVERFLOW:C-NAME': '1346',
 'SPYWARE:RAT:MINICOMMAND203-CTS': '1347',
 'MS-RPC:DCOM:REMACT-UDP': '1348',
 'HTTP:ORACLE:SOAP-ACCESS': '1349',
 'LPR:INVALID:REQUEST': '1350',
 'HTTP:CGI:APM-ACC-BYPASS': '1351',
 'HTTP:CISCO:MARS-JMX': '1352',
 'HTTP:WEBPLUS:DIR-TRAVERSAL': '1353',
 'SPYWARE:KL:RADARSPY-10': '1354',
 'HTTP:IIS:PERL-0A-ATTEMPT': '1355',
 'HTTP:CHKP:AUTH-FMT-STR': '1356',
 'WORM:SASSER:A-D-F-FTP-DL-5554': '1357',
 'SPYWARE:TROJAN:COMANDO': '1358',
 'FTP:WS-FTP:CPWD': '1359',
 'RLOGIN:REQERR:DATA-IN-1ST-LINE': '1360',
 'SPYWARE:BH:2ND-THOUGHT': '1361',
 'LPR:INVALID:D-EMPTY': '1362',
 'CHAT:AUDIT:YMSG:RECIPIENT': '1363',
 'SMTP:COMMAND:ETRN': '1364',
 'SNMP:COMMUNITY:OVERFLOW-1K': '1365',
 'SMB:OF:RECV-RAW': '1366',
 'HTTP:STC:CLSID:ACTIVEX:AX-17': '1367',
 'HTTP:STC:CLSID:ACTIVEX:AX-23': '1368',
 'SPYWARE:TROJAN:DIMBUS': '1369',
 'HTTP:EXT:DOT-PPT': '1370',
 'DB:MS-SQL:PREAUTH-OVERFLOW': '1371',
 'VIRUS:POP3:SOBER-K': '1372',
 'HTTP:INFO-LEAK:CUTENEWS': '1373',
 'SPYWARE:RAT:DSKLITE1-0-ICQ': '1374',
 'HTTP:STC:X11-OVERSIZE-FONT-DATA': '1375',
 'SPYWARE:AD:SEPRO': '1376',
 'MS-RPC:MSG-QUEUE-HEAP-OF': '1377',
 'HTTP:STC:CLSID:REF-24': '1378',
 'APP:SBS-TRAINING-OF2': '1379',
 'SPYWARE:RAT:SKYRATSHOW': '1380',
 'HTTP:STC:CLSID:ACTIVEX:AX-118': '1381',
 'DHCP:AUDIT:SVRNAME-NOT-T2': '1382',
 'HTTP:APACHE:SCALP': '1383',
 'HTTP:STC:JAVA-MEM': '1384',
 'IP:INFO:INVALID-SOURCE': '1385',
 'TCP:AUDIT:UNSOL-WSF': '1386',
 'SCADA:IEC104:SESSION': '1387',
 'APP:PPTP:PPTP-UNK-CTRL': '1388',
 'WORM:MIMAIL:MIMAIL.L': '1389',
 'SPYWARE:BH:SCNTOOLBAR': '1390',
 'SMTP:OVERFLOW:CONTENT-NAME': '1391',
 'SMTP:EXT:DOT-CMD': '1392',
 'HTTP:STC:MOZILLA:FIRESEARCH': '1393',
 'HTTP:PHP:KIETU-HIT-INCLUDE': '1394',
 'TROJAN:MISC:FILENAIL-REQUEST': '1395',
 'SPYWARE:RAT:NEUROTICKAT1-3-ICQ': '1396',
 'APP:TUN:TOR-1': '1397',
 'DOS:IP:FRAGMENT': '1398',
 'HTTP:STC:RSS-FEED-CODE-INJ': '1399',
 'WORM:MOFEI:MOFEI-BACKDOOR3': '1400',
 'APP:VERITAS:MAL-REQUEST-DOS': '1401',
 'DHCP:OPT:INV-OPT-LEN': '1402',
 'SPYWARE:BP:UCMORE': '1403',
 'SMTP:OVERFLOW:REPLY-LINE': '1404',
 'SCAN:XPROBE:XPROBE-BADCODE': '1405',
 'SCAN:AMAP:FTP-ON-SSH': '1406',
 'WORM:SMB:BUGBEAR-B': '1407',
 'NETBIOS:NBNS:POINTER_LOOP': '1408',
 'HTTP:STC:IE:IEFRAME': '1409',
 'TELNET:USER:4DGIFTS': '1410',
 'APP:ORACLE:SBAS-AUTH-BYPASS': '1411',
 'DOS:NETDEV:WEBJET-HTS-DOT': '1412',
 'DB:ORACLE:DBMS_AQELM': '1413',
 'SPYWARE:RAT:STRIKER1-0': '1414',
 'HTTP:STC:CLSID:ACTIVEX:SYM-SS': '1415',
 'HTTP:PHP:DOTBR-INFO-LEAK': '1416',
 'CHAT:AUDIT:AIM:INV-TLV-LEN': '1417',
 'HTTP:STC:ACTIVEX:HP-LOADRUNNER': '1418',
 'SPYWARE:AD:SEARCHITBAR': '1419',
 'SPYWARE:RAT:SOFTWARSHADOW-STC': '1420',
 'P2P:MISC:P2P-NETWORKING': '1421',
 'HTTP:NCSA:PHF-EXEC': '1422',
 'SHELLCODE:SPARC:SETUID-0-PKT': '1423',
 'P2P:BITTORRENT:TRACKER-QUERY': '1424',
 'DB:MS-SQL:SQLMON-MDAC-OFLOW': '1425',
 'HTTP:EXT:HTRSRCFRAG': '1426',
 'SPYWARE:RAT:BIONET-FTP': '1427',
 'HTTP:STC:IMG:EXE-FOR-IMAGE': '1428',
 'NNTP:VULN:ISC-2-2-2': '1429',
 'SPYWARE:BH:SEARCHFORIT': '1430',
 'HTTP:STC:CLSID:ACTIVEX:HTML-HLP': '1431',
 'HTTP:STC:CLSID:ACTIVEX:PDWIZARD': '1432',
 'SPYWARE:BH:MYFUNCARDS': '1433',
 'APP:SAMBA:NTRANS-RPLY': '1434',
 'SMB:OF:WKSSVC-CALL': '1435',
 'SPYWARE:RAT:XHX1-6': '1436',
 'SPYWARE:BP:CPUSH': '1437',
 'HTTP:SAVANT:GET-PERCENT': '1438',
 'HTTP:NCSA:COMPAS-LF': '1439',
 'LDAP:INVALID:SEARCH-FILTER-INV': '1440',
 'SPYWARE:AD:IGETNET': '1441',
 'LDAP:FORMAT:ENC-UNK-END-CHAR': '1442',
 'SNMPTRAP:ENCODING:MALFORMED-OID': '1443',
 'HTTP:EXT:FILE-EXT-IN-DIR': '1444',
 'HTTP:PHP:MAMBO-PATH-INCL': '1445',
 'SPYWARE:KL:ADVCMPMONITOR': '1446',
 'IMAP:CYRUS:PRELOG': '1447',
 'ECHO:AUDIT:LINE': '1448',
 'LPR:OVERFLOW:CFILE': '1449',
 'SCAN:MISC:HTTP:ARCHITEXT-QUERY': '1450',
 'SCADA:ICCP:WRONG-CN-PARA': '1451',
 'CHAT:AIM:CLOSE-CONNECTION': '1452',
 'APP:TUN:TOR-2': '1453',
 'HTTP:STC:CLSID:REF-2': '1454',
 'SPYWARE:TROJAN:ACESSOR20': '1455',
 'POP3:OVERFLOW:APOP': '1456',
 'HTTP:AGORA:AUTH': '1457',
 'HTTP:CGI:EMUMAIL-INFO-LEAK': '1458',
 'RPC:FAILURE:CALLIT-FAILED': '1459',
 'HTTP:TOMCAT:REAL-PATH-REQ': '1460',
 'SPYWARE:TROJAN:YKW375': '1461',
 'SPYWARE:BH:CNNICUPDATE': '1462',
 'SMTP:OUTLOOK:OWA-XSS': '1463',
 'MS-RPC:ARNUDP-RPC-DOS': '1464',
 'DOS:NETDEV:CISCO-PIM': '1465',
 'HTTP:OVERFLOW:CONTENT-ENCODING': '1466',
 'HTTP:STC:IE:LOCAL-ACCESS-DAT': '1467',
 'VOIP:SKYPE:VERSION-CHECK': '1468',
 'SPYWARE:GM:GOZILLA': '1469',
 'SPYWARE:BH:RICERCADOPPIA': '1470',
 'SMTP:EXT:DOT-MDB': '1471',
 'SCAN:MISC:HTTP:UNIX-BIN-PS': '1472',
 'SPYWARE:BH:DIGITALNAMES': '1473',
 'HTTP:STC:STREAM:REAL-WALL': '1474',
 'HTTP:COLDFUSION:JRUN-SC-PARSE': '1475',
 'TFTP:AUDIT:C2S-INVALID-OPCODE': '1476',
 'SCAN:MISC:TELNET:CD-VAR-HIDDEN': '1477',
 'VOIP:SIP:BRUTE-INV': '1478',
 'HTTP:DIR:PARAM-TRAVERSE': '1479',
 'POP3:EXT:DOT-ZIP': '1480',
 'POP3:EXT:DOT-HLP': '1481',
 'VOIP:SIP:AUDIT:CONTENT-LENGTH': '1482',
 'SCAN:MISC:HTTP:MAN-SH-PROBE': '1483',
 'APP:UPNP:DLINK-SEARCH-NOTIFY': '1484',
 'WORM:BERBEW:KEYLOGGER-UPLOAD': '1485',
 'POP3:ERROR:BOUNDARY_MISSING': '1486',
 'HTTP:STC:MOZILLA:SSL-ICON': '1487',
 'DHCP:AUDIT:INV-SVR-SRC-PORT': '1488',
 'SPYWARE:KL:APOPHISSPY10': '1489',
 'HTTP:STC:IE:IE-MHT-REDIRECT': '1490',
 'HTTP:SQL:INJ:CMD-CHAIN-2': '1491',
 'DB:MS-SQL:TDS-FRAG-FLOOD': '1492',
 'HTTP:STC:IE:LOC-SPOOF': '1493',
 'APP:HPOVNNM:NNM-BO': '1494',
 'HTTP:PHP:PHORUM:ADMIN-PW-CHG': '1495',
 'APP:CA:ARC-BCK-MSG': '1496',
 'SMTP:INVALID:BASE64-CHAR': '1497',
 'HTTP:COLDFUSION:CF-CLASS-DWLD': '1498',
 'SYSLOG:AUDIT:PACKET': '1499',
 'P2P:AUDIT:GNUTELLA-PONG-LEN': '1500',
 'P2P:AUDIT:GNUTELLA-OK-RESP': '1501',
 'HTTP:NOVELL:WEBACC-MODIFY': '1502',
 'HTTP:IIS:FP30REG-CSS1': '1503',
 'RUSERS:INVALID:BAD-CRED-LEN': '1504',
 'LDAP:EMPTY:EXTDRSP-RSPNM-EMPTY': '1505',
 'SPYWARE:KL:SPYTECTOR131': '1506',
 'SPYWARE:AD:SPYWARENUKER': '1507',
 'APP:VERITAS:VERITAS-NULL-PTR': '1508',
 'APP:SL-WEB-SUP-OF': '1509',
 'SPYWARE:RAT:TRAITOR21': '1510',
 'POP3:AUDIT:LOGIN-FAILED': '1511',
 'POP3:EXT:DOT-PCD': '1512',
 'LDAP:INVALID:MESGID-INVALID': '1513',
 'APP:NOVELL:HTTP-NOVELL-REDIRECT': '1514',
 'SPYWARE:RAT:BSETROJAN': '1515',
 'TROJAN:MISC:SCHOOLBUS-JOYBD': '1516',
 'TROJAN:MISC:DTR-BANNER': '1517',
 'SNMP:ENCODING:TLEN-TOO-BIG': '1518',
 'SPYWARE:AD:BROWSERACCELERATOR': '1519',
 'HTTP:STC:HHP-BINARY': '1520',
 'HTTP:IIS:IIS-HTR-OVERFLOW': '1521',
 'SPYWARE:AD:WEATHERSCOPE': '1522',
 'SNMPTRAP:ENCODING:CNTR-TOO-BIG': '1523',
 'LPR:OVERFLOW:LPD-EXPLOIT': '1524',
 'HTTP:PHP:PHORUM:READ-ACCESS': '1525',
 'TROJAN:MISC:MASSAKER-SRV-RESP': '1526',
 'DNS:EXPLOIT:POINTER-LOOP': '1527',
 'VOIP:SIP:SQL-CMD-1': '1528',
 'DB:MS-SQL:TDS-FRAG-LEN-ZERO': '1529',
 'SPYWARE:BH:ABCSEARCH': '1530',
 'SSH:MISC:UNIX-ID-RESP': '1531',
 'TROJAN:MISC:DUDDIE-COMMAND': '1532',
 'HTTP:PHP:PHPBB:PM-SQL-USER': '1533',
 'HTTP:PKG:VWALL-FTPSAV-DLL': '1534',
 'SPYWARE:BP:ETCETERASEARCH': '1535',
 'SHELLCODE:SPARC:GEN-5-PKT': '1536',
 'HTTP:TUNNEL:REDUH': '1537',
 'APP:CVS:EXCESSIVE-MAX-DOTDOT': '1538',
 'HTTP:COLDFUSION:HEADER-LOG-OF': '1539',
 'HTTP:EXPLOIT:ILLEGAL-HOST-CHAR': '1540',
 'HTTP:IIS:FPCOUNT-OVERFLOW': '1541',
 'RPC:AUDIT:REQUEST-DENIED': '1542',
 'HTTP:IIS:MFC-EXT-OF': '1543',
 'TROJAN:MISC:BF-EVOLUTION-BANNER': '1544',
 'DB:ORACLE:APPDET-CONNECT': '1545',
 'TROJAN:MISC:ULTIMATERAT': '1546',
 'HTTP:TOMCAT:JSP-COMMENTS': '1547',
 'SNMP:ERROR:INVALID_ESTATUS': '1548',
 'SMTP:MAL:MAL-ZIP-HDR': '1549',
 'IMAP:OVERFLOW:MAILENABLE-ARG-OF': '1550',
 'SCAN:METASPLOIT:LSASS': '1551',
 'IDENT:OVERFLOW:REQUEST-NUM': '1552',
 'VIRUS:POP3:EICAR-ATTACHMENT': '1553',
 'HTTP:SQL:INJ:MERCURY-UA': '1554',
 'WORM:FIZZER:IRC-CHAN-2': '1555',
 'TELNET:FAILURE:LOGIN-FAILED': '1556',
 'HTTP:STC:CLSID:ACTIVEX:AX-71': '1557',
 'TROJAN:NETBUS:CLT-GETINFO-12345': '1558',
 'SPYWARE:TROJAN:LITHIUM102': '1559',
 'VOIP:SIP:SQL-INJ': '1560',
 'VNC:INVALID:SERVER-VERSION': '1561',
 'SPYWARE:AD:ZAMINGO': '1562',
 'SMTP:AUDIT:HIGH-VOLUME': '1563',
 'SPYWARE:AD:COMODOTOOLBAR': '1564',
 'SCAN:MISC:HTTP:ADMINLOGIN': '1565',
 'NTP:INVALID:TIMESTMP_NOT_MATCH': '1566',
 'DNS:INFO:TYPE-AXFR': '1567',
 'HTTP:MISC:PUT-METHOD': '1568',
 'CHAT:ICQ:ICQPHONE-EXEC': '1569',
 'HTTP:NETSCAPE:ENTERPRISE-DOS': '1570',
 'HTTP:STC:IE:URL-HIDING-ENC': '1571',
 'HTTP:SQL:INJ:IS_SRVROLEMEMBER': '1572',
 'APP:REAL:NEG-CONT-LEN': '1573',
 'SPYWARE:RAT:HVLRAT-530-CTS': '1574',
 'SPYWARE:TROJAN:THEEF210': '1575',
 'TCP:AUDIT:S2C-FINWAIT2-FIN': '1576',
 'SNMP:TRAP-DECODE-DOS': '1577',
 'HTTP:STC:IE:ONENOTE-URL': '1578',
 'HTTP:INVALID:INVLD-AUTH-LEN': '1579',
 'SPYWARE:AD:MIRAGOSEARCHBAR': '1580',
 'WORM:BAGLE:Q-HTTP': '1581',
 'HTTP:STC:ACTIVEX:XLISTEN': '1582',
 'RUSERS:OVERFLOW:USER-OVERFLOW': '1583',
 'CHAT:AUDIT:YMSG:SEPARATOR': '1584',
 'SSH:ERROR:MSG-TOO-LONG': '1585',
 'IMAP:FAILURE:BRUTE-FORCE': '1586',
 'SPYWARE:RAT:CIA1-22': '1587',
 'SMB:CONNECT-FROM-LOCALHOST': '1588',
 'HTTP:HOTMAIL:FILE-UPLOAD': '1589',
 'P2P:AUDIT:GNUTELLA-SEARCH': '1590',
 'DNS:QUERY:ENC-STATUS-SPOOF': '1591',
 'HTTP:IIS:PERC-2E-ASP': '1592',
 'HTTP:REQERR:BIN-DATA-ACC-ENC': '1593',
 'HTTP:STC:CLSID:ACTIVEX:AX-33': '1594',
 'HTTP:SAVANT:GET-DOT1': '1595',
 'SMTP:EXCHANGE:MULTI-LONG-MAILRT': '1596',
 'APP:MS-SMS-DOS': '1597',
 'SPYWARE:GM:DUDUACCELERATOR': '1598',
 'HTTP:INFO-LEAK:SSN-CLEARTEXT': '1599',
 'HTTP:STC:CLSID:ACTIVEX:AX-29': '1600',
 'SPYWARE:RAT:HORNET-DOWNLOADER': '1601',
 'TROJAN:EAGHOUSE': '1602',
 'SNMPTRAP:INFO:ERR_STAT_COM_FAIL': '1603',
 'TROJAN:MISC:DCONNECT-SERVER': '1604',
 'TCP:C2S:AMBIG:SYN-RTNS--BADSACK': '1605',
 'SMB:AUDIT:NULL-NVE-LM': '1606',
 'CHAT:GOOGLE:GTALK-STARTUP': '1607',
 'HTTP:STC:CLSID:ACTIVEX:AX-52': '1608',
 'SPYWARE:RAT:HVLRAT-530-STC': '1609',
 'HTTP:FRONTPAGE:FRM-RES-PROBE': '1610',
 'SPYWARE:AD:TARGETSAVER': '1611',
 'HTTP:STC:CLSID:ACTIVEX:AX-141': '1612',
 'SPYWARE:DM:TRUSTYFILES': '1613',
 'SSL:HTTPS-UNIX-CMDS': '1614',
 'SCADA:ICCP:CN-INVALID': '1615',
 'SMTP:MAL:MS-HSC-DVD-VLN': '1616',
 'TROJAN:MISC:PITFALL-TELNET-ID': '1617',
 'MS-RPC:MSRPC-ISYSACTIVATE-RACE': '1618',
 'HTTP:WIN-CMD:WIN-CMD-EXE': '1619',
 'HTTP:CGI:AXIS-EXEC': '1620',
 'HTTP:PHP:REMOTE-FILE-INCL': '1621',
 'DNS:AUDIT:CLASS-UNKNOWN': '1622',
 'HTTP:STC:CLSID:ACTIVEX:AX-01': '1623',
 'HTTP:STC:OUTLOOK:WABFILE': '1624',
 'SCAN:MISC:HTTP:REPOST-ACCESS': '1625',
 'SPYWARE:RAT:STEALTHREDIR-FTP': '1626',
 'HTTP:STC:CLSID:REF-14': '1627',
 'FTP:EXPLOIT:ZYXEL-CONF-GET': '1628',
 'LDAP:FAILED:MODIFY-RESULT-FAIL': '1629',
 'SHELLCODE:LINUXX86:GEN-3-PKT': '1630',
 'HTTP:3COM:OFFICECONNECT': '1631',
 'APP:CA:ARCSERVE-FILE-UPLOAD': '1632',
 'VOIP:SIP:OVERFLOW:PORT-OF': '1633',
 'SPYWARE:TROJAN:POISONIVY212': '1634',
 'IDENT:OVERFLOW:REQUEST': '1635',
 'SCAN:MISC:HTTP:CONTEXTADMIN': '1636',
 'CHAT:AIM:TOC': '1637',
 'HTTP:PHP:PHPMYADMIN:SERVERDB': '1638',
 'DB:ORACLE:ORACLE-SQL-BOF': '1639',
 'NETBIOS:ACCESS:SAMBA-CLIENT': '1640',
 'MS-RPC:ERR:CO-PTYPE-IN-CL-PDU': '1641',
 'HTTP:CGI:STORE-ATTEMPT': '1642',
 'HTTP:PHP:PHP-CAL-FILE-INC': '1643',
 'HTTP:PHP:THATWARE:ARTLIST-INC': '1644',
 'TELNET:OVERFLOW:ABSOLUTE-UK2-OF': '1645',
 'HTTP:EXPLOIT:SQLXML-ISAPI-OF': '1646',
 'SMTP:MAL:HEADER-NAME-OF': '1647',
 'SPYWARE:RAT:FAKE0-2': '1648',
 'SMTP:EMAIL:EUDORA-SPOOF1': '1649',
 'SHELLCODE:WINDOWS:GEN-2-TCP': '1650',
 'LPR:OVERFLOW:D-NAME': '1651',
 'HTTP:STC:CLSID:ACTIVEX:AX-67': '1652',
 'OS:LINUXX86:NTPDX-OF': '1653',
 'MS-RPC:DCERPC-DOS1': '1654',
 'DB:ORACLE:WORKSPACE-MGR-INJ': '1655',
 'SPYWARE:RAT:ROACH1-0-STC': '1656',
 'HTTP:EXPLOIT:DANSIE-INFO-LEAK': '1657',
 'SPYWARE:AD:CINMUS': '1658',
 'SPYWARE:AD:SIDEFIND': '1659',
 'HTTP:STC:CLSID:ACTIVEX:AX-78': '1660',
 'LPR:OVERFLOW:C-FORMAT': '1661',
 'TROJAN:MATRIX:CLIENT-REQ': '1662',
 'SCAN:CORE:EXPLOIT-UNPACK': '1663',
 'MS-RPC:ATSVC-RUNDLL': '1664',
 'DNS:OVERFLOW:TXTRECORD': '1665',
 'HTTP:CISCO:CSUSERCGI': '1666',
 'DB:MYSQL:SSL-OF': '1667',
 'VNC:AUDIT:UNKNOWN-SERVER-MSG': '1668',
 'SPYWARE:AD:MYSEARCHADROTATOR': '1669',
 'HTTP:INVALID:BAD-CONTENT-LENGTH': '1670',
 'SCAN:MISC:HTTP:FILEMAIL-ACCESS': '1671',
 'HTTP:CGI:GLIMPSE-PIPE': '1672',
 'HTTP:INFO-LEAK:VIGNETTE-LEAK': '1673',
 'APP:MISC:HEARTBEAT-OF': '1674',
 'HTTP:STC:CLSID:ACTIVEX:AX-96': '1675',
 'HTTP:STC:IE:MEMCORRUPT2': '1676',
 'VOIP:SIP:SRV-RESP-400': '1677',
 'HTTP:CGI:PERL:AMAYA-DIR-TRAV': '1678',
 'TROJAN:MISC:LAST2K-CONN': '1679',
 'TCP:AUDIT:S2C-SYN-RST': '1680',
 'SPYWARE:RAT:REMOTE-ANYTHING': '1681',
 'SPYWARE:BH:PORN385': '1682',
 'CHAT:AUDIT:YMSG:STATUS-CODE': '1683',
 'TROJAN:MISC:LITHIUM-SRV-RESP': '1684',
 'HTTP:STC:CLSID:ACTIVEX:OUA': '1685',
 'SPYWARE:TROJAN:SANDESA-ICQNOTIF': '1686',
 'APP:SAMBA:SWAT-AUTH-DOS': '1687',
 'DB:MS-SQL:SQLMON-EMPTY-PKT': '1688',
 'HTTP:PHP:PHPPASS-BYPASS': '1689',
 'DHCP:OPT:LOG-BUF-OVERFLOW': '1690',
 'HTTP:STC:CLSID:ACTIVEX:AX-133': '1691',
 'SCAN:NIKTO:USER-AGENT': '1692',
 'SMTP:MAL:NOTES-INI-SMTP': '1693',
 'APP:SUPERSCOUT': '1694',
 'HTTP:EXT:DOT-UNSAFE': '1695',
 'HTTP:STC:CLSID:ACTIVEX:AX-63': '1696',
 'HTTP:PHP:PHPNUKE:PATH-DISC1': '1697',
 'POP3:OVERFLOW:QPOP-OF1': '1698',
 'HTTP:STC:CLSID:ACTIVEX:CREATEOB': '1699',
 'HTTP:INFO-LEAK:WIN-INI': '1700',
 'HTTP:IIS:ENCODING:UNICODE-BP4': '1701',
 'SSH:MISC:MAL-VERSION': '1702',
 'SMB:TRANS2ROOT-OF-2': '1703',
 'HTTP:OVERFLOW:COOKIE': '1704',
 'SPYWARE:TROJAN:IEVA1.0': '1705',
 'DOS:NETDEV:ROUTEFINDER-VPN-DOS': '1706',
 'SCAN:MISC:HTTP:HTW-ACCESS': '1707',
 'SCAN:MISC:HTTP:BIN-G-PLUS-PLUS': '1708',
 'VOIP:MGCP:INV-CHAR-HIGH': '1709',
 'TROJAN:MISC:SONOFPW-SERV-RESP': '1710',
 'HTTP:SQL:INJ:HEADER-REFERRER': '1711',
 'HTTP:MISC:KEYFOCUS-KF-DIRTRAV': '1712',
 'HTTP:PHP:ADPFORUM-ACCT-ADD': '1713',
 'SPYWARE:GM:EXPERTANTIVIRUS41': '1714',
 'VOIP:MGCP:SDP:VERSION-OF': '1715',
 'TROJAN:BACKORIFICE:BOPING-WIN': '1716',
 'HTTP:NETSCAPE:WP-VERIFY-LINK': '1717',
 'TROJAN:MISC:QWERTOS-COMMAND': '1718',
 'APP:SOCKS:SMTP-PROXY-HTTP': '1719',
 'DNS:EXPLOIT:INFOLEAK-UDP': '1720',
 'HTTP:DIR:DIR-TRAV-HDR': '1721',
 'SNMP:AUDIT:NO-SUCH-NAME': '1722',
 'SCAN:MISC:TELNET:NC': '1723',
 'FTP:AUDIT:REQ-INVALID-CMD-SEQ': '1724',
 'SCADA:MODBUS:LISTEN-ONLY': '1725',
 'SPYWARE:RAT:SCREENCONTROL10-STC': '1726',
 'SCAN:MISC:HTTP:SENDFORM-ACCESS': '1727',
 'SCADA:ICCP:WRONG-FN-PARAMETER': '1728',
 'HTTP:STC:CLSID:ACTIVEX:AX-47': '1729',
 'APP:PROXY:SQUID-WCCP-BO': '1730',
 'SPYWARE:AD:IMNAMES': '1731',
 'SNMP:ERROR:INVALID-REQUEST': '1732',
 'SPYWARE:GM:DOWNLOADER-2': '1733',
 'APP:GIOP-COMM': '1734',
 'POP3:EXT:DOT-REG': '1735',
 'HTTP:PHP:PHPDIG-FILE-INC': '1736',
 'HTTP:HOTMAIL:FILE-DOWNLOAD': '1737',
 'ICMP:AUDIT:RESPONSE-RESND': '1738',
 'HTTP:STC:IE:CDO-IN-HEADER': '1739',
 'P2P:MISC:FREECAST': '1740',
 'TROJAN:MISC:INTRUDER-RESPONSE': '1741',
 'SSL:INVALID:SVR-HELLO-DATA': '1742',
 'TROJAN:BACKCONSTR:FTP-PORT-OPEN': '1743',
 'TCP:AUDIT:C2S-LASTACK-ACK': '1744',
 'SHELLCODE:DIGITAL:NOOP-TCP': '1745',
 'HTTP:STC:IE:COMPINST-OF': '1746',
 'SPYWARE:RAT:ANALRAPE-ICQ-NOTIFY': '1747',
 'DB:ORACLE:DEFAULT-PW-CTXSYS': '1748',
 'HTTP:IIS:COMMAND-EXEC-5': '1749',
 'SCAN:MISC:HTTP:WIN-ARGS-CMD': '1750',
 'RSYNC:DIR-TRAV': '1751',
 'LDAP:INVALID:REQ-ATTRIBTYPE-INV': '1752',
 'HTTP:WEBSTER:DIR-TRAVERSAL': '1753',
 'WORM:FIZZER:IRC-CHAN-1': '1754',
 'HTTP:CGI:BUGZILLA:PRIV-UP': '1755',
 'HTTP:PHP:PHPNUKE:MODULES-DOS': '1756',
 'HTTP:STC:MOZILLA:MAL-SVG-INDEX': '1757',
 'DB:MYSQL:SHORT-MSG': '1758',
 'HTTP:CGI:TEST-CGI': '1759',
 'SSL:OVERFLOW:SSL-KEY_ARG2': '1760',
 'VOIP:SIP:AUDIT:INV-CONTACT': '1761',
 'DB:ORACLE:SDO_TOPO_DROP_FTBL': '1762',
 'SPYWARE:TROJAN:G-SPOT': '1763',
 'SPYWARE:KL:KEYLOGGERKINGHOME32': '1764',
 'SPYWARE:TROJAN:OUTBREAK': '1765',
 'SPYWARE:TROJAN:SINIQUE1-0': '1766',
 'HTTP:STC:CLSID:ACTIVEX:REALWALL': '1767',
 'SPYWARE:AD:CRACKSPIDER': '1768',
 'TCP:S2C:ERROR:REASS-LOST-TRACK': '1769',
 'SPYWARE:BH:QCBAR': '1770',
 'SCAN:MISC:TELNET:SU-BIN': '1771',
 'NETBIOS:NBDS:INVALID:HDR_FLGS': '1772',
 'SPYWARE:TROJAN:HATREDFIEND': '1773',
 'SSH:ERROR:INVALID-PKT-TYPE': '1774',
 'HTTP:EXPLOIT:BRUTE-SEARCH': '1775',
 'SNMPTRAP:INFO:ERR_STAT_NO_ACC': '1776',
 'SPYWARE:RAT:NETCONTROLE3-0': '1777',
 'CHAT:MSN:POINT-TO-POINT': '1778',
 'SPYWARE:GM:DOWNLOADER-1': '1779',
 'SPYWARE:BH:CWS-CAMEUP': '1780',
 'HTTP:IIS:ASPX-DOS': '1781',
 'POP3:AUDIT:INVALID-FILENAME': '1782',
 'NFS:AUDIT:MKNOD': '1783',
 'FTP:WU-FTP:LINUX-OF': '1784',
 'LPR:OVERFLOW:C-SOURCE': '1785',
 'HTTP:CGI:INFOSRCH-REMOTE-EXEC': '1786',
 'HTTP:CISCO:VOIP:STREAM-ID-DOS': '1787',
 'HTTP:INFO-LEAK:ZYXEL-PRESTIGE': '1788',
 'HTTP:STC:WINAMP:AU-OF1': '1789',
 'LPR:INVALID:CMD-TRUNC': '1790',
 'DB:MYSQL:LOGIN-OVERLONG-PSWD': '1791',
 'SNMP:DOS:CISCO-DOS': '1792',
 'HTTP:PHP:ZENTRACK-CMD-EXEC': '1793',
 'SPYWARE:TROJAN:OPTIXPRO132': '1794',
 'HTTP:CGI:DCFORUM-AZ-EXEC': '1795',
 'APP:CA:ARCSRV:DISCOVERY-OF': '1796',
 'POP3:EXT:DOT-WSZ-WAL': '1797',
 'SNMP:DOS:GETBULK': '1798',
 'LDAP:INVALID:SRCH-SIZELIMIT-INV': '1799',
 'IKE:DOS:ISAKMP-DOS-3': '1800',
 'SPYWARE:AD:TRANSPONDERSTUB': '1801',
 'DB:ORACLE:VULN-VER-9.2.0.4': '1802',
 'HTTP:MISC:TOPTOOLS-HPNST-DOS': '1803',
 'SPYWARE:AD:FREESCRATCHANDWIN': '1804',
 'HTTP:STC:IE:INFINITE-ARRAY': '1805',
 'SPYWARE:BH:ANALYZEIE': '1806',
 'SCAN:MISC:HTTP:ADMADM-EXE-PROBE': '1807',
 'SMB:NETDDE-SHARE-OF': '1808',
 'TELNET:USER:DYNALINK-BACKDOOR': '1809',
 'SMTP:OVERFLOW:SENDMAIL-MIME-OF': '1810',
 'HTTP:PHP:PHPNUKE:4NALBUM-INC': '1811',
 'HTTP:STC:ADOBE:ACROBAT-URL-DF': '1812',
 'HTTP:GMAIL:FILE-DOWNLOAD': '1813',
 'HTTP:PHP:REDHAT-PIRANHA-PASSWD': '1814',
 'SPYWARE:TROJAN:ZXSHELL': '1815',
 'HTTP:PKG:MS-JET-VBA': '1816',
 'HTTP:OVERFLOW:JANA-PRXY-OF1': '1817',
 'HTTP:XSS:HTML-HTW': '1818',
 'APP:SECURECRT-CONF': '1819',
 'TROJAN:KUANG2:SERVER-RESP': '1820',
 'HTTP:STC:CLSID:ACTIVEX:AX-97': '1821',
 'TROJAN:MS-04-028:R-ADMIN-START': '1822',
 'RUSERS:INVALID:INVALID-DIR': '1823',
 'TCP:AUDIT:S2C-SEG-OUT-OF-WIN': '1824',
 'SPYWARE:BH:ZEROPOPUP': '1825',
 'SCAN:MISC:HTTP:UNIX-BIN-ID': '1826',
 'IMAP:CYRUS:PARTIAL-CMD': '1827',
 'SPYWARE:TROJAN:Y3K2K5': '1828',
 'SPYWARE:AD:LINKSPIDERSEARCHBAR': '1829',
 'SCAN:MISC:HTTP:EDIT-ACCESS': '1830',
 'NTP:ERROR:DATA_FIELD_TOO_SHORT': '1831',
 'SPYWARE:TROJAN:HAVRAT1.1': '1832',
 'P2P:KAZAA:WEB-CONN': '1833',
 'IMAP:OVERFLOW:REFERENCE': '1834',
 'CHAT:AUDIT:YMSG:OFLOW-CONF-NAME': '1835',
 'TROJAN:INFECTOR:SVR-RES': '1836',
 'CHAT:MSN:INVALID:PNG-WIDTH': '1837',
 'HTTP:STC:SYMANTEC-AV-STACK': '1838',
 'HTTP:STC:IMG:OFFEND-GG': '1839',
 'CHAT:AUDIT:MSN:USER-STATE': '1840',
 'HTTP:STC:CLSID:REF-25': '1841',
 'SCAN:MISC:HTTP:WIN-PERL': '1842',
 'SNMP:INFO:ERR_STATUS_WRG_TYPE': '1843',
 'SNMP:ERROR:INVALID-RESPONSE': '1844',
 'APP:MISC:TANNE-FMT-STR': '1845',
 'POP3:EXT:DOT-BAS': '1846',
 'GOPHER:OVERFLOW:SELECTOR': '1847',
 'DB:POSTGRESQL:CACHEW-OF': '1848',
 'HTTP:PHP:AWSTATS-SORT': '1849',
 'HTTP:STC:CLSID:ACTIVEX:MAGVIEW': '1850',
 'SMTP:AUDIT:MISSING-MAIL-FROM': '1851',
 'P2P:EDONKEY:C2S-PING-BEACON': '1852',
 'VNC:OVERFLOW:NAME': '1853',
 'SPYWARE:RAT:BEAST202-ICQ': '1854',
 'VOIP:SIP:AUDIT:INV-TERMINATION': '1855',
 'HTTP:IIS:CGI-BIN-CMD-EXE': '1856',
 'SCAN:MISC:HTTP:SNORK-ACCESS': '1857',
 'DOS:IP:CHARGEN-BOMB': '1858',
 'SPYWARE:BH:NEWNETDOMAIN722': '1859',
 'POP3:OVERFLOW:LINUX-OFLOW': '1860',
 'HTTP:STC:ACTIVEX:MCFE-OVERWRITE': '1861',
 'SPYWARE:AD:DIVXPRO': '1862',
 'HTTP:STC:IE:MAL-SAMI': '1863',
 'SNMPTRAP:ERROR:INV_ERR_STAT': '1864',
 'SCADA:DNP3:RESPONSE-DOS': '1865',
 'SPYWARE:RAT:HATREDFRIEND-TCP': '1866',
 'TROJAN:MISC:GLACIER': '1867',
 'SPYWARE:KL:STARLOGGER': '1868',
 'HTTP:STC:MOZILLA:SHELL': '1869',
 'DNS:OVERFLOW:BIN': '1870',
 'NTP:ERROR:CTL_INVALID_OPCODE': '1871',
 'DB:MYSQL:LOGIN-NO-USER': '1872',
 'DB:MYSQL:MAXDB-SERVER-OF': '1873',
 'APP:OFFSCAN': '1874',
 'DNS:DYNAMICUPDATE': '1875',
 'SCAN:MISC:TELNET:CD-USR-HIDDEN': '1876',
 'SMTP:BANNER-CAPTURE': '1877',
 'HTTP:EXPLOIT:IE-ZONE-SPOOF': '1878',
 'HTTP:PHP:FREENEWS-PHP-INC1': '1879',
 'DB:MS-SQL:SQLMON-HEAP-OFLOW': '1880',
 'SMTP:EXPLOIT:RELAY-ATTEMPT-VAR': '1881',
 'SNMP:INFO:ERR_STAT_UNDO_FAILD': '1882',
 'WORM:SDBOT:OH-LSASS-OF': '1883',
 'SSH:ERROR:MSG-TOO-SHORT': '1884',
 'SNMP:INFO:ERR_STAT_INCON_NAME': '1885',
 'SHELLCODE:X86:NOOP-TCP': '1886',
 'HTTP:STC:IE:IFRAME-FILE': '1887',
 'DDOS:TRIN00:DAEMON-TO-MSTR2-PKT': '1888',
 'HTTP:OVERFLOW:GAZTEK-HTTPD-OF': '1889',
 'HTTP:STC:ACTIVEX:LPVIEWER': '1890',
 'SPYWARE:TROJAN:HELIOS-ICQNOTIFY': '1891',
 'SMTP:AUDIT:ENCODE': '1892',
 'HTTP:PROXY:ANON:FOXY-FILTER': '1893',
 'SPYWARE:TROJAN:WINICABRAS11': '1894',
 'SMTP:REQERR:REQ-SYNTAX-ERROR': '1895',
 'IKE:MALFORMED:PACKET': '1896',
 'CHAT:MSN:INVITE-SEND': '1897',
 'HTTP:MISC:MCAFFEE-SRV-HDR': '1898',
 'SMTP:EMAIL:ADDR-NOPSLED': '1899',
 'DB:ORACLE:TNS-DOS': '1900',
 'APP:TUN:TEREDO-INFO': '1901',
 'MS-RPC:DCOM:REMACT-OBJNAME-OF': '1902',
 'SPYWARE:AD:NEWWEB': '1903',
 'NTP:ERROR:CTL_INVALID_ERRCODE': '1904',
 'DB:MS-SQL:PWD-ENCRYPT': '1905',
 'SPYWARE:KL:LTTLOGGER': '1906',
 'SHELLCODE:HP-UX:HP-NOOP-2-TCP': '1907',
 'MS-RPC:PGP-SRV-PTR': '1908',
 'HTTP:STC:CLSID:ACTIVEX:AX-20': '1909',
 'FTP:PROFTP:PROFTP-FS-MKDIR': '1910',
 'HTTP:PHP:PHPNUKE:VIEWADMIN': '1911',
 'SNMP:HMAC-AUTH-BYPASS': '1912',
 'SPYWARE:GM:ALFACLEANER': '1913',
 'HTTP:STC:WINAMP:ID3V2-OVERFLOW': '1914',
 'GOPHER:OVERFLOW:DISPLAY': '1915',
 'DNS:AUDIT:RCODE-FORMAT-ERROR': '1916',
 'SMB:EXT:DOT-ZIP': '1917',
 'HTTP:STC:ITUNES-PL': '1918',
 'SPYWARE:KL:SPYGRAPHICAPRO': '1919',
 'HTTP:STC:IE:DRAG-DROP-MOD': '1920',
 'SPYWARE:RAT:DWMREMOTECONTROL': '1921',
 'SCAN:MISC:HTTP:SEARCH97-VTS': '1922',
 'P2P:MLDONKEY:CLIENT-ACTIVE': '1923',
 'TFTP:DIRECTORY:ROOT': '1924',
 'HTTP:STC:FOXIT-PDF-OF': '1925',
 'SPYWARE:RAT:AQUA-0-2': '1926',
 'DOS:IP:IGMP-OVERSIZE': '1927',
 'SPYWARE:AD:ACCESSIBILITYTOOLBAR': '1928',
 'WORM:BAGLE:AF-SMTP': '1929',
 'HTTP:STC:CLSID:ACTIVEX:AX-06': '1930',
 'MS-RPC:ATSVC-BIND': '1931',
 'CHAT:AUDIT:MSN:MSN-USER-NAME': '1932',
 'LDAP:OVERFLOW:ATTRIB-DESC-OF': '1933',
 'DB:MS-SQL:XP-DIRTREE1': '1934',
 'SNMPTRAP:INFO:ERR_STAT_AUTH_ERR': '1935',
 'SMTP:AUDIT:COMMAND-FAILED': '1936',
 'SCAN:MISC:HTTP:WEBSITEPRO': '1937',
 'HTTP:STC:MOZILLA:FF-DEL-OBJ-REF': '1938',
 'VOIP:SIP:SDP:SYNTAX-ERROR': '1939',
 'SCAN:MISC:HTTP:CYBERCOP-HTTP': '1940',
 'SMTP:EXCHANGE:AUTH-GUEST': '1941',
 'TROJAN:JECT.A': '1942',
 'HTTP:STC:IE:CREATETEXTRANGE-3': '1943',
 'HTTP:STC:IE:CHAN-SCRIPT': '1944',
 'SCAN:NESSUS:SMTP-SCAN': '1945',
 'HTTP:INFO:HTTPPOST-GETSTYLE': '1946',
 'WORM:SMB:DELODER': '1947',
 'DB:MS-SQL:REPLWRITETIVARBIN-DB': '1948',
 'P2P:BEARSHARE:FILE-XFER': '1949',
 'SPYWARE:TROJAN:SINSTERLER': '1950',
 'SHELLCODE:X86:GEN-1-PKT': '1951',
 'TROJAN:MYDOOM:S-IRC-BACKDOOR': '1952',
 'SCAN:MISC:HTTP:QUERYHIT-ACCESS': '1953',
 'MS-RPC:SAMR-ACCESS-REQUEST': '1954',
 'HTTP:CISCO:IOS-ADMIN-ACCESS': '1955',
 'HTTP:AGORA:POSTGRES65': '1956',
 'HTTP:PKG:WEBGAIS-REMOTE-EXEC': '1957',
 'TROJAN:NETDEVIL:NETDEVIL1-4': '1958',
 'SNMPTRAP:COMMUNITY:FORMAT-CHAR': '1959',
 'APP:WMP:DSHOW-BIGCHUNK-HTTP': '1960',
 'HTTP:EXPLOIT:SWS-NO-LINEFEED': '1961',
 'HTTP:PHP:SPHPBLOG-PW-DOWNLOAD': '1962',
 'SNMPTRAP:INFO:STAT_WRNG_VAL': '1963',
 'DHCP:OPT:TCP-DEF-TTL-ZERO': '1964',
 'VOIP:MGCP:SDP:MAL-HEADER': '1965',
 'SPYWARE:BH:PUSHTOOLBAR': '1966',
 'SMTP:COMMAND:SMTP-VRFY-CMD': '1967',
 'HTTP:STC:CLSID:ACTIVEX:AX-101': '1968',
 'SCAN:MISC:HTTP:SENDMESSAGE': '1969',
 'WORM:SLAPPER:C2-INFEC': '1970',
 'SMB:AUDIT:UNK-SHDR-TYPE': '1971',
 'HTTP:CGI:WEBSPEED-WSMADMIN': '1972',
 'HTTP:FRONTPAGE:FOURDOTS': '1973',
 'SPYWARE:KL:SSKC20': '1974',
 'PROTOCOLS:TRAFFIC:NOT-IMAP': '1975',
 'VOIP:SKYPE:LOGIN-2': '1976',
 'HTTP:PHP:DOTBR-PHP-EXEC': '1977',
 'HTTP:CGI:PERL:DUMPENV-PROBE': '1978',
 'SPYWARE:RAT:INCOMMAND': '1979',
 'SMTP:EXT:DOT-SCT': '1980',
 'HTTP:STC:IMG:WMP-BMP-OF': '1981',
 'SPYWARE:GM:SPYWAREQUAKE': '1982',
 'VOIP:SIP:AUDIT:INV-CSEQ': '1983',
 'DB:MYSQL:COMTABLEDUMP-OF': '1984',
 'SCAN:MISC:HTTP:CACHEMGR-ACCESS': '1985',
 'APP:MDAEMON:MDCONFIG-VER': '1986',
 'HTTP:STC:CLSID:ACTIVEX:AX-11': '1987',
 'SPYWARE:RAT:DSKLITE1-0': '1988',
 'HTTP:IIS:MSADC-VBBO-ACCESS': '1989',
 'HTTP:STC:JAVA:MAL-JNLP-FILE': '1990',
 'HTTP:STC:IE:DND-IMG': '1991',
 'HTTP:ORACLE:CONF-ACCESS': '1992',
 'VOIP:SIP:AUDIT:SYNTAX-ERROR': '1993',
 'HTTP:STC:IMG:MAL-EMF': '1994',
 'WORM:MARE-D-SCAN': '1995',
 'CHAT:AUDIT:YMSG:CONF-HOST': '1996',
 'SPYWARE:AD:WEBNEXUS': '1997',
 'FTP:VULN:SERV-U-FTP-2-6': '1998',
 'HTTP:APACHE:WEBDAV-PROPFIND': '1999',
 'SCAN:II:SNMP-PRINT-DOS': '2000',
 'HTTP:DOMINO:ACCEPT-LANG-OF': '2001',
 'SSL:INVALID:CERT-FORMAT': '2002',
 'SPYWARE:RAT:AMREMOTECLIENT1-1': '2003',
 'SMTP:AUDIT:INVALID-FILENAME': '2004',
 'SCAN:METASPLOIT:METERPRETER-DLL': '2005',
 'HTTP:STC:CLSID:REF-6': '2006',
 'HTTP:STC:CLSID:ACTIVEX:SPLINE': '2007',
 'SPYWARE:KL:EMAILSPYPRO': '2008',
 'DNS:INFO:HIGH-TRANS-ID': '2009',
 'HTTP:IIS:ENCODING:UNICODE-BP2': '2010',
 'FTP:PROFTP:PPC-FS2': '2011',
 'SMTP:EMAIL:REPLY-TO-PIPE': '2012',
 'DB:ORACLE:TNS-DOS-LOOP-DOS': '2013',
 'GOPHER:OVERFLOW:LINE': '2014',
 'NTP:PEER_MODE_INCOMPAT': '2015',
 'HTTP:STC:CLSID:ACTIVEX:VIELIB': '2016',
 'SPYWARE:KL:NICESPY': '2017',
 'RPC:AUTOMOUNTD-OF': '2018',
 'CHAT:AUDIT:YMSG:MSG-SIZE': '2019',
 'SPYWARE:BH:NAVEXCEL-HELPER': '2020',
 'SHELLCODE:X86:NOOP-STLTH-TCP': '2021',
 'SCAN:MISC:FTP:FTP-MKD-DOT': '2022',
 'P2P:EMULE:PLUS-VER-CHECK': '2023',
 'TROJAN:TELNET:USER-HAX0R': '2024',
 'HTTP:EXPLOIT:BRUTE-FORCE': '2025',
 'SPYWARE:AD:GOPHORIA010B': '2026',
 'SPYWARE:BH:YOURSITEBAR': '2027',
 'SPYWARE:KL:ACTIVITYMONITOR': '2028',
 'SMB:EXPLOIT:SMBDIE': '2029',
 'DB:MS-SQL:PWD-CHANGE': '2030',
 'SMB:AUDIT:LONG-ACCOUNT': '2031',
 'SHELLCODE:X86:NOOP-PKT': '2032',
 'LDAP:EMPTY:ASSERT_EMPTY': '2033',
 'HTTP:STC:JAVA:JAVA-VM-ARGS-OF': '2034',
 'HTTP:STC:MAL-MDB-BIN': '2035',
 'NETBIOS:NBNS:NAME_TOO_LONG': '2036',
 'HTTP:PROXY:ANON:CGIPROXY': '2037',
 'HTTP:STC:IE:IFRAME-SMB': '2038',
 'SPYWARE:BH:ACCOONA': '2039',
 'IKE:DOS:CISCO-DOS': '2040',
 'SCAN:MISC:HTTP:INTRANET-REQ': '2041',
 'TROJAN:MISC:TCC-IDENTIFY': '2042',
 'HTTP:OVERFLOW:CONTENT-OVERFLOW': '2043',
 'HTTP:PHP:CEDRIC-EMAIL-PHPINC1': '2044',
 'HTTP:TUNNEL:HTTPTUNNEL-URL': '2045',
 'TCP:AUDIT:SYN-RTNS-BADISS': '2046',
 'SPYWARE:RAT:EVILFTP': '2047',
 'HTTP:NETSCAPE:INDEX-DISCLOSURE': '2048',
 'HTTP:PKG:NAI-PGP-ADMIN-ACCESS-1': '2049',
 'SPYWARE:TROJAN:BANDOOK-V1-0': '2050',
 'HTTP:XSS:WEB-VIEW-DOC-SCR-INJ': '2051',
 'HTTP:STC:ACTIVEX:BACKDOORS': '2052',
 'DOS:APPLICATION:TEMPLATE': '2053',
 'SMB:MAILSLOT-OF': '2054',
 'HTTP:XSS:PHPNUKE-BOOKMARKS': '2055',
 'PORTMAPPER:ERR:WRONG-DIR': '2056',
 'PROTOCOLS:PORT:HTTP': '2057',
 'VOIP:H225RAS:DOS:LRQ': '2058',
 'SMB:OF:LINUX-KERNEL-INT-OF': '2059',
 'TROJAN:TELNET:USER-WH00T': '2060',
 'HTTP:STC:SAFARI:DISK-URI': '2061',
 'SPYWARE:TROJAN:APOFIS1.0': '2062',
 'SPYWARE:RAT:HATREDFRIEND-HTTP': '2063',
 'SPYWARE:KL:SC-KEYLOG': '2064',
 'SPYWARE:BH:PROVENTACTICS35': '2065',
 'LDAP:OVERFLOW:DN_TOO_LONG': '2066',
 'TFTP:OPERATION:WRITE': '2067',
 'VOIP:MGCP:AUDIT:INV-PARM-NAME': '2068',
 'P2P:AUDIT:GNUTELLA-LINE': '2069',
 'FTP:AUDIT:LOGIN-FAILED': '2070',
 'TROJAN:MISC:RULER-SERV-RESP': '2071',
 'SPYWARE:AD:ELITEBAR': '2072',
 'NFS:AUDIT:REQ-DENIED': '2073',
 'FTP:OVERFLOW:OPENBSD-FTPD-GLOB': '2074',
 'HTTP:STC:CLSID:REF-30': '2075',
 'SCAN:MISC:HTTP:WIN-RCMD': '2076',
 'SPYWARE:RAT:FORCE1-61': '2077',
 'TCP:AUDIT:SYN-RTNS-BADTS': '2078',
 'SPYWARE:BH:FREECRUISE-TB': '2079',
 'HTTP:PHP:ACHIEVO-EXEC': '2080',
 'LDAP:EMPTY:EXTDRSP-RESP-EMPTY': '2081',
 'HTTP:PKG:TUXEDO-DOS': '2082',
 'RPC:RPC.STATD:AUTOMOUNT-TLI': '2083',
 'MS-RPC:MSGQU-FRNAME': '2084',
 'TELNET:NEGOT:REQ-SUBNEG-FORMAT': '2085',
 'SSL:AUDIT:CERT-EXPIRED': '2086',
 'SPYWARE:RAT:OMNIQUARD-IRC': '2087',
 'RUSERS:ERR:SHORT-READ': '2088',
 'SNMP:AUDIT:BAD-VALUE': '2089',
 'SSL:INVALID:NULL-CERT': '2090',
 'P2P:EDONKEY:CLIENT-HELLO': '2091',
 'HTTP:OVERFLOW:WEBC-REQ-OF': '2092',
 'SNMPTRAP:ERROR:INVALID-MSG-FMT': '2093',
 'NNTP:OVERFLOW:XPAT-PATTERN': '2094',
 'SPYWARE:AD:POWERZONE': '2095',
 'HTTP:STC:IE:HTML-HELP-ZONE-BP': '2096',
 'HTTP:STC:SCRIPT:PAYLOAD-SETUP': '2097',
 'CHAT:AUDIT:YMSG:BUD-LIST': '2098',
 'APP:EZNET-LOGIN-BOF': '2099',
 'HTTP:OVERFLOW:SERVER': '2100',
 'VOIP:MGCP:SDP:INV-CI': '2101',
 'SCAN:MISC:HTTP:CSS-PROBE': '2102',
 'HTTP:IIS:ASPNET-DISCLOSURE': '2103',
 'HTTP:EXPLOIT:SHOUTCAST-FMT-STR': '2104',
 'LDAP:INVALID:ENTRY_INVALID': '2105',
 'SPYWARE:TROJAN:TEQUILABANDITA': '2106',
 'HTTP:PHP:SQUIRRELMAIL-AUTH': '2107',
 'HTTP:MISC:BLACKBERRY-SVR-DOS': '2108',
 'SPYWARE:AD:NETWORDAGENT': '2109',
 'LDAP:OVERFLOW:REQ-OF': '2110',
 'HTTP:STC:ACTIVEX:AURIGMAIMG': '2111',
 'HTTP:STC:CLSID:ACTIVEX:AX-70': '2112',
 'SMB:OF:SECUR-TOKEN-OVERFLOW': '2113',
 'RUSERS:INVALID:INVALID-PROC': '2114',
 'IKE:FW1-OVERFLOW': '2115',
 'HTTP:STC:IE:SETSLICE-OF': '2116',
 'HTTP:EXPLOIT:VAR-RESPONSE-SPLIT': '2117',
 'HTTP:CGI:QUIKSTORE-CFG-ACCESS': '2118',
 'FTP:VULN:SERV-U-FTP-5-0-0-6': '2119',
 'APP:ETHEREAL:TCPDUMP-ISAKMP-DOS': '2120',
 'IMAP:OVERFLOW:LINUX-X86-3': '2121',
 'HTTP:NETGEAR:DG834G-DEBUG-MODE': '2122',
 'HTTP:STC:CLSID:ACTIVEX:AX-62': '2123',
 'SPYWARE:BH:EXTREME-BIZ': '2124',
 'APP:QT-SERVER:DESCRIBE-DOS': '2125',
 'RADIUS:ACCREJ_INV_NUM_ATTRS': '2126',
 'VOIP:SIP:AUDIT:INV-INVITE-SRC': '2127',
 'SPYWARE:TROJAN:NETSHADOW': '2128',
 'SPYWARE:TROJAN:THEEF210FTP': '2129',
 'MS-RPC:MSRPC-HIGRCE': '2130',
 'SPYWARE:RAT:ASSASSIN-1-1STC': '2131',
 'P2P:LIMEWIRE:FREEWIRE': '2132',
 'HTTP:STC:IMG:PNG-HEIGHT': '2133',
 'SPYWARE:AD:EZTRACKS': '2134',
 'APP:CA:IGATEWAY-CNT-LEN-OF': '2135',
 'HTTP:CGI:LIBCGI-TUXBR-OF1': '2136',
 'HTTP:IIS:WEB-ADMIN': '2137',
 'SMB:EXPLOIT:MAL-JPEG-DL': '2138',
 'PROTOCOLS:TRAFFIC:NOT-POP3': '2139',
 'APP:MERCURY-BOF': '2140',
 'SCAN:RPVS:XSS-URL': '2141',
 'HTTP:STC:IE:MEMCORRUPT1': '2142',
 'FTP:VULN:SERV-U-FTP-4-3': '2143',
 'SHELLCODE:X86:SETUID-0-TCP': '2144',
 'APP:VERITAS:MAL-REQUEST-DOS-2': '2145',
 'TCP:AUDIT:UNKNOWN': '2146',
 'SMB:DFSENUM-OF': '2147',
 'MS-RPC:DCOM:REMACT-139': '2148',
 'CHAT:GOOGLE:GTALK-CALL': '2149',
 'SPYWARE:RAT:BUSCHTROMMEL1-22': '2150',
 'TROJAN:MISC:LESZCZ-SRV-RESP': '2151',
 'VOIP:SIP:SDP:INV-CI': '2152',
 'SCAN:CYBERCOP:FINGER-QUERY': '2153',
 'CHAT:AUDIT:YMSG:OFLOW-PASSWD': '2154',
 'FTP:WU-FTP:FTPD-BSD-X86': '2155',
 'SMB:EXPLOIT:REGISTRY-DOS': '2156',
 'HTTP:STC:IMG:WMF-METASPLOIT': '2157',
 'MS-RPC:LSASS:MAL-OPCODE': '2158',
 'SMB:EXPLOIT:LLS-NAME': '2159',
 'APP:AMANDA:AMANDA-ROOT-OF2': '2160',
 'HTTP:PHP:PHPBB:AVATAR-PATH-INC': '2161',
 'APP:GAME:COD4-CONNECT': '2162',
 'VOIP:H225SGN:RELEASE-COMPLETE': '2163',
 'HTTP:OVERFLOW:PI3WEB-SLASH-OF': '2164',
 'APP:TUN:TOR-3': '2165',
 'SMTP:OUTLOOK:MMCN-EXEC': '2166',
 'SMTP:EMAIL:RCPT-TO-DECODE': '2167',
 'APP:ORACLE:WEBCACHE-METHOD-OF': '2168',
 'VNC:QEMU-KVM-DOS': '2169',
 'WORM:LOVGATE:BACKDOOR-LOGIN': '2170',
 'HTTP:PHP:WOLTAB-SQL-INJ': '2171',
 'HTTP:STC:CLSID:ACTIVEX:AX-126': '2172',
 'SCAN:MISC:HTTP:ETC-MOTD': '2173',
 'SMTP:EXT:DOT-EXE': '2174',
 'TROJAN:MISC:RATHEAD-SRV-RESP': '2175',
 'HTTP:STC:CHTSKDIC': '2176',
 'HTTP:STC:ROOTKIT-DL': '2177',
 'APP:SAP:WEB-SRV-OF': '2178',
 'HTTP:IIS:HTR-OVERFLOW': '2179',
 'HTTP:PKG:ICQ-WEBFRONT-DOS-2': '2180',
 'CHAT:AUDIT:YMSG:OFLOW-CONF-MSG': '2181',
 'HTTP:STC:CLSID:REF-3': '2182',
 'MS-RPC:MSRPC-EVASION-5': '2183',
 'DNS:OVERFLOW:NXT-OVERFLOW': '2184',
 'HTTP:SQL:INJ:BTTLXEFORUM': '2185',
 'HTTP:MISC:RAS-CFG': '2186',
 'TELNET:OVERFLOW:LINEMODE-OF': '2187',
 'POP3:EXT:DOT-HT': '2188',
 'DB:MS-SQL:SP_START_JOB-445': '2189',
 'APP:HPOVNNM:OVALARMSRV-DOS2': '2190',
 'P2P:NAPSTER:UPLOAD-REQ-8888': '2191',
 'LDAP:EMPTY:ATTRIBLIST_EMPTY': '2192',
 'CHAT:AUDIT:IRC-CMD': '2193',
 'IMAP:OVERFLOW:LINUX-X86-4': '2194',
 'HTTP:INFO:CHARSET-ASCII': '2195',
 'HTTP:STC:CLSID:ACTIVEX:AX-69': '2196',
 'HTTP:SQL:INJ:DECLARE-EXEC': '2197',
 'NTP:ERROR:MSG_WITHIN_POLL_INTVL': '2198',
 'SPYWARE:AD:WHENUWEATHERCAST': '2199',
 'HTTP:PROXY:SQUID-NTLM-OF': '2200',
 'SPYWARE:GM:SPYWARELOCKED33': '2201',
 'HTTP:IIS:ENCODING:SINGLE-DIG-2': '2202',
 'MS-RPC:EXCHANGE-MEM': '2203',
 'HTTP:STC:MOZILLA:NAV-OBJ-EXEC': '2204',
 'DOS:NETDEV:CISCO-TELNET-BOF1': '2205',
 'RUSERS:AUDIT:UNKNOWN-VER': '2206',
 'HTTP:OVERFLOW:MS-W3WHO-OF': '2207',
 'CHAT:YIM:LOGIN-ATTEMPT': '2208',
 'TROJAN:MISC:PRIORITY-COMMAND': '2209',
 'MS-RPC:ERR:EPM-INV-NUM-ENTRIES': '2210',
 'MS-RPC:ERR:CL-PAYLOAD-NOT-EMPTY': '2211',
 'SMTP:EXCHANGE:SCT_XEXCH50_2LONG': '2212',
 'HTTP:STC:IE:HTA-CONTENT-TYPE': '2213',
 'DOS:NETDEV:NETWORK-3COM-DOS': '2214',
 'SNMPTRAP:INFO:ERR_STAT_RD_ONLY': '2215',
 'OS:LINUXX86:MOUNTD-OF-1': '2216',
 'SCAN:MISC:HTTP:WIN-NC': '2217',
 'POP3:DOS:INWEB-HELO-DOS': '2218',
 'HTTP:STC:SWF:MAL-SWF-OF': '2219',
 'HTTP:STC:CLSID:ACTIVEX:AX-136': '2220',
 'PROTOCOLS:PORT:POP3': '2221',
 'HTTP:CGI:MONALBUM': '2222',
 'SHELLCODE:SGI:GEN-1-PKT': '2223',
 'SPYWARE:AD:WORDIQTOOLBAR': '2224',
 'FTP:DIRECTORY:MSIE-FTP-DIRTRAV': '2225',
 'APP:REAL:PLAYER-SMIL-OF': '2226',
 'APP:PCANYWHERE:PCANYWHERE-DOS': '2227',
 'VOIP:SIP:LIMITS:IN-REPLY-TO-OF': '2228',
 'SPYWARE:BH:SEXYVIDEOSCREENSAVER': '2229',
 'HTTP:STC:CLSID:ACTIVEX:AGENT': '2230',
 'VNC:OVERFLOW:AUTH-CHALLENGE': '2231',
 'APP:VERITAS:NETBACKUP-FS': '2232',
 'HTTP:XSS:BEA-ADMIN-CONSOLE': '2233',
 'FINGER:EXPLOIT:ACCOUNT-ENUM': '2234',
 'SPYWARE:AD:IST-POWERSCAN': '2235',
 'SPYWARE:TROJAN:BLUEEYE10B': '2236',
 'HTTP:STC:IE:WMP-BMP-OF-2': '2237',
 'TROJAN:SATANS-BD:SERVER-RES': '2238',
 'HTTP:CISCO:SERVLETEXEC': '2239',
 'SCAN:CERBERUS:FTP': '2240',
 'SPYWARE:BH:ISTSLOTCHBAR': '2241',
 'WORM:WORM-BROPIA-F': '2242',
 'SMTP:EXT:DOT-HLP': '2243',
 'MISC:2WIRE-DSL-VULN': '2244',
 'TROJAN:MISC:PPORT-INFO-REQ': '2245',
 'HTTP:STC:ATL:SHOCKWAVE': '2246',
 'FTP:REQERR:REQ-MISSING-ARGS': '2247',
 'APP:REMOTE:RDP-DOS': '2248',
 'CHAT:MSN:FILE-TRANS-INV': '2249',
 'SMB:FILE:AUTORUN.INF-COPY': '2250',
 'HTTP:NETSCAPE:WP-CS-DUMP': '2251',
 'SPYWARE:KL:COMPUTERSPY': '2252',
 'SCADA:DNP3:BROADCAST': '2253',
 'TCP:AUDIT:SYNSENT-RST': '2254',
 'FTP:PASSWORD:ROOT': '2255',
 'HTTP:SQL:INJ:CMD-CHAIN-1': '2256',
 'SPYWARE:GM:JUBSTER': '2257',
 'TCP:C2S:AMBIG:OLAP-MISMATCH': '2258',
 'SPYWARE:AD:GAMEBAR': '2259',
 'NTP:PEER_STRATUM_INCOMPATI': '2260',
 'HTTP:INFO:FARK': '2261',
 'SSL:SCHANNEL': '2262',
 'SPYWARE:UTIL:COPERNICAGENT': '2263',
 'SPYWARE:UTIL:SPAMBLOCKERUTILITY': '2264',
 'HTTP:CGI:INFO2WWW-EXEC': '2265',
 'SPYWARE:AD:PALTALK': '2266',
 'HTTP:STC:IE:IE-REFRESH-OF': '2267',
 'SCAN:CANVAS:CANVAS-HELIUM': '2268',
 'P2P:GNUTELLA:CONNECT': '2269',
 'DB:MYSQL:MYSQL-PFIELD-TYPE': '2270',
 'TCP:AUDIT:S2C-RST-DATA': '2271',
 'HTTP:IIS:SENSEPOST.EXE': '2272',
 'SPYWARE:AD:EUNIVERSEUPDATER': '2273',
 'NTP:INVALID:CTL_CLKERR_RPRTED': '2274',
 'DNS:HEADERERROR:INVALID-OPCODE': '2275',
 'SPYWARE:RAT:PTAKKS': '2276',
 'VOIP:SIP:AUDIT:BAD-IPV6': '2277',
 'FTP:PROFTP:PROFTPD-GEN-GLOB-DOS': '2278',
 'APP:MDAEMON:SEND-OF': '2279',
 'SMB:EXPLOIT:DOT-JOB': '2280',
 'SCAN:PYSMBLIB': '2281',
 'MS-RPC:MSDTC-OF': '2282',
 'SPYWARE:RAT:RIX310': '2283',
 'SPYWARE:AD:CASHBACK': '2284',
 'VOIP:MGCP:LINE-OVERFLOW': '2285',
 'TELNET:FAILURE:GUEST': '2286',
 'HTTP:STC:IE:JS-MC-1': '2287',
 'HTTP:IIS:NSIISLOG-OF': '2288',
 'HTTP:OWA:LOGIN-REDIR': '2289',
 'SSL:INVALID:SESSION-ID-LEN': '2290',
 'NETBIOS:OVERFLOW:ASN-1-DER-OF': '2291',
 'SCAN:AMAP:SSL-ON-HTTP': '2292',
 'SPYWARE:BH:A1VACATIONRENTALS': '2293',
 'SPYWARE:AD:ZENOSEARCH': '2294',
 'DB:MYSQL:AUTH-BYPASS': '2295',
 'SMTP:SENDMAIL:SENDMAIL-FF-OF': '2296',
 'SPYWARE:BH:SOSOTOOLBAR': '2297',
 'FTP:PASSWORD:H0TB0X': '2298',
 'OS:LINUXX86:BOOTP-OF': '2299',
 'HTTP:YAHOO:ACTIVITY': '2300',
 'HTTP:PHP:HORDE-EVAL': '2301',
 'SPYWARE:BH:ONESTEPSEARCH10118': '2302',
 'SMTP:EXT:DOT-INF': '2303',
 'HTTP:MISC:JIGSAW-DEV-DOS1': '2304',
 'CHAT:JABBER:JABBER-CTRAF': '2305',
 'SPYWARE:TROJAN:ELFRAT': '2306',
 'HTTP:NOVELL:IMANAGER-LONG-TREE': '2307',
 'SPYWARE:BH:IMESHBAR': '2308',
 'LDAP:INVALID:ENC_BOOLEAN': '2309',
 'CHAT:AUDIT:YMSG:CONTACT-NAME': '2310',
 'LDAP:INVALID:ATTRIBTYPE_INVALID': '2311',
 'HTTP:CGI:EASYNEWS-ADMIN1': '2312',
 'HTTP:CGI:SITESEARCHER-EXEC': '2313',
 'HTTP:STC:ADOBE:ACROBAT-URL-DOS': '2314',
 'RSH:AUDIT:REQ-ILLEGAL-ERR-PORT': '2315',
 'SPYWARE:AD:CASALEMEDIA': '2316',
 'APP:CA:ARCSRV:MOBILE': '2317',
 'SPYWARE:AD:GAMESPY-ARCADE': '2318',
 'SCAN:MISC:HTTP:POST-QUERY-PROBE': '2319',
 'CHAT:AUDIT:YMSG:INV-GROUP-NAME': '2320',
 'HTTP:STC:CLSID:ACTIVEX:AX-55': '2321',
 'SPYWARE:BH:MAKEMESEARCH': '2322',
 'SCAN:MISC:SYN-FIN': '2323',
 'RPC:RWHOD:RWHOD-NULL-INJ': '2324',
 'TCP:AUDIT:SYNRCVD-SYNACK': '2325',
 'DB:ORACLE:EXP-APP-WEBCAHE': '2326',
 'HTTP:MISC:DYNDNSUPDATE': '2327',
 'DOS:NETDEV:ASCEND-KILL': '2328',
 'HTTP:OVERFLOW:ZEROO-OF1': '2329',
 'SPYWARE:KL:WINVESTIGATOR': '2330',
 'HTTP:PHP:RUNCMS-FILE-UP': '2331',
 'HTTP:STC:IE:OE-MSHTML-OF': '2332',
 'HTTP:XSS:SHARE-XSS': '2333',
 'SCAN:MISC:HTTP:UNIX-BIN-CHGRP': '2334',
 'CHAT:AUDIT:YMSG:USER-NAME': '2335',
 'SMB:SERVER-SVC-OF': '2336',
 'P2P:OVERNET:CONNECT-REQ': '2337',
 'VOIP:SIP:OVERFLOW:LINE-OVERFLOW': '2338',
 'SPYWARE:TROJAN:COBRAUPLOADER': '2339',
 'TELNET:EXPLOIT:MIT-KERB-DASH-E': '2340',
 'POP3:OVERFLOW:CONTENT_NAME': '2341',
 'SPYWARE:AD:GATORGOTSMILEY': '2342',
 'SNMPTRAP:ENCODING:GAUGE-TOO-BIG': '2343',
 'APP:DOUBLETAKE': '2344',
 'HTTP:STC:CLSID:ACTIVEX:AX-46': '2345',
 'HTTP:STC:VULN:WEBLOGIC-8-1': '2346',
 'HTTP:STC:CLSID:ACTIVEX:AX-21': '2347',
 'P2P:NAPSTER:DATA-5555': '2348',
 'SCAN:MISC:HTTP:UNIX-BIN-LS': '2349',
 'IDENT:INVALID:SENDMAIL-EXPL': '2350',
 'HTTP:IIS:IIS-AUTH-BYPASS': '2351',
 'SPYWARE:KL:ACTIVEKEYLOGGER': '2352',
 'SSL:INVALID:CONTENT-TYPE': '2353',
 'SPYWARE:KL:XP-ADVANCEDKEYLOGGER': '2354',
 'VOIP:SIP:SDP:TIME-OF': '2355',
 'VOIP:SIP:SRV-RESP-401': '2356',
 'TROJAN:MISC:BASICHELL-SRV-RESP': '2357',
 'NETBIOS:NBNS:INVALID:RRNB-FLG': '2358',
 'MS-RPC:DCERPC-DOS3': '2359',
 'DHCP:AUDIT:UNK-HW-TYPE': '2360',
 'HTTP:TUNNEL:KAZAA-OVER-HTTP': '2361',
 'SCAN:CERBERUS:SMTP': '2362',
 'DB:ORACLE:TNS-DBMS-OF': '2363',
 'SPYWARE:RAT:ABACAB-HTTP': '2364',
 'SPYWARE:KL:COMPUTERKEYLOGGER': '2365',
 'SCAN:MISC:HTTP:FORMHANDLER': '2366',
 'HTTP:PHP:CLAROLINE-INCLUDE': '2367',
 'SCAN:CORE:SAMBA-TRANS2': '2368',
 'HTTP:PHP:PHPBB:SEARCH-DOS': '2369',
 'HTTP:STC:CLSID:ACTIVEX:AX-32': '2370',
 'NFS:INVALID:INVALID-FILETYPE': '2371',
 'SCADA:DNP3:RESTART': '2372',
 'HTTP:WEBSPHERE:SERVER-OF': '2373',
 'HTTP:INFO-LEAK:BOOT-INI': '2374',
 'TROJAN:DOLY:COMMAND-V1': '2375',
 'P2P:OVERNET:KEEP-ALIVE': '2376',
 'SPYWARE:RAT:GH0ST': '2377',
 'DB:MYSQL:MYSQL-PASSWORD-OF': '2378',
 'SPYWARE:AD:BUNDLEWARE': '2379',
 'P2P:AUDIT:SE-HUB-LOOK': '2380',
 'NETBIOS:WINS:WPADWINS': '2381',
 'FTP:USER:ROOT': '2382',
 'SPYWARE:RAT:SNID-X2-1-2C-CTS': '2383',
 'CHAT:AUDIT:YMSG:MESSAGE-SEND': '2384',
 'SCAN:MISC:HTTP:TILDA-ROOT': '2385',
 'SPYWARE:TROJAN:BANDOOK-1-35': '2386',
 'SNMPTRAP:ENCODING:ZLEN-FOR-OID': '2387',
 'HTTP:STC:IMG:EXE-IN-IMAGE': '2388',
 'SMTP:REQERR:REQ-DUPLICATE-HELLO': '2389',
 'HTTP:STC:IMG:EXE-FOR-IMG-TYPE': '2390',
 'HTTP:WEBPLUS:VERSION': '2391',
 'HTTP:STC:WMP-ASX': '2392',
 'HTTP:STC:CLSID:REF-13': '2393',
 'SPYWARE:GM:ALBUMGALAXY': '2394',
 'DB:MS-SQL:REPLWRITETIVARBIN-INJ': '2395',
 'HTTP:STC:CLSID:ACTIVEX:AX-02': '2396',
 'HTTP:STC:WIN-EXE-DOWNLOAD': '2397',
 'SPYWARE:AD:MIDADDLE': '2398',
 'HTTP:STC:MIRC-URI-OF': '2399',
 'VOIP:MGCP:SDP:HEADER-UNK-ERR': '2400',
 'SPYWARE:KL:ADVANCEDKEYLOGGER': '2401',
 'HTTP:XSS:CISCO-CSUSERCGIXSS': '2402',
 'TELNET:FAILURE:EMP-CISCO-PWD': '2403',
 'WORM:SQL-SNAKE:MSSQL-REG-1': '2404',
 'IMAP:REQERR:REQ-DUPLICATE-TAG': '2405',
 'HTTP:INFO:NULL-AUTH': '2406',
 'WORM:SDBOT:OH-BACKDOOR-COMMAND': '2407',
 'VOIP:SIP:AUDIT:UTF8-ERROR': '2408',
 'HTTP:STC:CLSID:ACTIVEX:AX-142': '2409',
 'DHCP:OPT:BAD-HOSTNAME': '2410',
 'SPYWARE:TROJAN:ONLY1RAT': '2411',
 'SPYWARE:KL:PC-BLACK-BOX': '2412',
 'TROJAN:Y3K-RAT:Y3K16-RAT-BANNER': '2413',
 'SMB:EXPLOIT:NULL-PATH': '2414',
 'SCAN:MISC:HTTP:CFAPPMAN-PROBE': '2415',
 'IDENT:AUDIT:NEST-REQ': '2416',
 'SNMP:INFO:ERR_STAT_RES_UNAVAIL': '2417',
 'HTTP:MISC:EMULIVE-ADMIN': '2418',
 'SSL:OVERFLOW:KEY-ARG-NO-ENTROPY': '2419',
 'MS-RPC:WKST-SVC-OFLOW': '2420',
 'SPYWARE:AD:EZULA-WEBOFFER': '2421',
 'SCAN:CORE:JPEG-GDI-VGX-EXPLOIT': '2422',
 'GOPHER:INVALID:TRUNC-LINE': '2423',
 'DB:MS-SQL:X-RAY-SCANNER': '2424',
 'HTTP:INVALID:UNEXPECTCHAR': '2425',
 'TROJAN:MISC:EXECUTOR-CMD': '2426',
 'GOPHER:INVALID:NST-REQ': '2427',
 'SPYWARE:RAT:ANTIPC': '2428',
 'TROJAN:MISC:ROOTBEER-CLIENT': '2429',
 'HTTP:STC:IE:ANCHOR-SHARE-URI': '2430',
 'TCP:AUDIT:C2S-FUTURE-ACK': '2431',
 'SPYWARE:BH:E2GIVE': '2432',
 'HTTP:STC:CLSID:ACTIVEX:AX-66': '2433',
 'HTTP:STC:ACTIVEX:SQLVDIR-DLL': '2434',
 'VOIP:MGCP:INVALID-HEX-LOW': '2435',
 'X11:X11-XC-QUERY-SECURITY': '2436',
 'HTTP:CGI:AXIS-ACCOUNT': '2437',
 'DNS:AUDIT:INVALID-Z': '2438',
 'RTSP:REALSERVER:MAL-HEADER': '2439',
 'TROJAN:INFECTOR:CLIENT-REQ': '2440',
 'APP:AJP12-SHUTDOWN': '2441',
 'MS-RPC:DCERPC-DOS2': '2442',
 'FTP:DIRECTORY:TILDE-ROOT': '2443',
 'SCAN:MISC:HTTP:MAINFRMST-PROBE': '2444',
 'SPYWARE:UTIL:BOHAJER-DOWNLOADER': '2445',
 'OS:LINUXX86:POP2-OF-1': '2446',
 'SMTP:EXT:DOT-ADE': '2447',
 'SCADA:MODBUS:INVALID-HEADER': '2448',
 'P2P:EDONKEY:PORT-53': '2449',
 'SMB:SEARCH-OF': '2450',
 'SCAN:MISC:HTTP:UNIX-BIN-CPP': '2451',
 'APP:IPSO-FILE-VIEW': '2452',
 'SMB:OF:SMB-INVALID-BUFFER': '2453',
 'SPYWARE:GM:DOTCOMTOOLBAR': '2454',
 'LPR:OVERFLOW:C-BANNER': '2455',
 'SPYWARE:AD:YAYAD': '2456',
 'HTTP:STC:SRVRSP:AUTH-RESP-OF': '2457',
 'SPYWARE:KL:BEYONDKEYLOGGER_SMTP': '2458',
 'VOIP:SIP:LIMITS:EXPIRES-OF': '2459',
 'SSH:AUDIT:UNEXPECTED-HEADER': '2460',
 'HTTP:IIS:ENCODING:UNICODE': '2461',
 'HTTP:PKG:DB4WEB-FILE-ACCESS-WIN': '2462',
 'MS-RPC:ERR:COUNT-TOO-LARGE': '2463',
 'HTTP:OWA:OUTLOOK-WEB-DOS': '2464',
 'SMTP:MAL:EMAIL-URL-HIDING-ENC': '2465',
 'FTP:OVERFLOW:WFTPD-MKD-OVERFLOW': '2466',
 'HTTP:MISC:MOODLOGIC-CLIENT': '2467',
 'HTTP:STC:ACTIVEX:FACEBOOK-PHOTO': '2468',
 'SPYWARE:AD:EXEEM-BETA': '2469',
 'NETBIOS:NBDS:INVALID:1STLVL_ENC': '2470',
 'NETBIOS:OVERFLOW:MAILSLOT': '2471',
 'SPYWARE:TROJAN:ZLOBMEDIACODEC': '2472',
 'HTTP:PHP:PODCAST-FILE-INCL': '2473',
 'APP:IBM:TSM-CLIENT-OF': '2474',
 'LDAP:OVERFLOW:MESSAGE-TOO-LONG': '2475',
 'REXEC:OVERFLOW:PASSWORD': '2476',
 'POP3:OVERFLOW:BOUNDARY_OVERFLOW': '2477',
 'SCAN:PISS:FTP-SCAN': '2478',
 'SPYWARE:TROJAN:PROXY-ATIUP': '2479',
 'SPYWARE:TROJAN:DARKSKY': '2480',
 'IMAP:SET-QUOTA': '2481',
 'DNS:AUDIT:REP-MISMATCHING-AN': '2482',
 'TCP:AUDIT:S2C-TIMEWAIT-FIN': '2483',
 'HTTP:STC:JAVA:SANDBOX-BYPASS': '2484',
 'IMAP:OVERFLOW:WUIMAPD-MBOX-OF': '2485',
 'MS-RPC:WKST-SVC-OF': '2486',
 'APP:GAME:UNREAL-GAMESPY-QP-BOF': '2487',
 'HTTP:MISC:PASSPORT-RESET': '2488',
 'SPYWARE:UTIL:I2HUB': '2489',
 'VOIP:SIP:AUDIT:SESSION-HIJACK': '2490',
 'SCAN:MISC:HTTP:POSTING-ATTEMPT': '2491',
 'TROJAN:TELNET:USER-HIDESOURCE': '2492',
 'SPYWARE:TROJAN:BAC-GEN-E': '2493',
 'SHELLCODE:WINDOWS:GEN-2-PKT': '2494',
 'SCAN:MISC:HTTP:ETC-INETD-CONF': '2495',
 'HTTP:DIR:BARRACUDA-DIRTRAV': '2496',
 'HTTP:STC:ACTIVEX:LINKSYS': '2497',
 'SCAN:MISC:TELNET:SU-WRNG-GRP': '2498',
 'SMTP:EXT:DOT-MSC': '2499',
 'HTTP:STC:ACTIVEX:VISBASIC6-AX-2': '2500',
 'VOIP:SIP:OVERFLOW:HEADER-OF': '2501',
 'SPYWARE:TROJAN:DACRYPTIC': '2502',
 'NFS:OVERFLOW:XLOG-1BYTE-OF': '2503',
 'P2P:SHAREAZA:CLIENT-ACTIVE': '2504',
 'TELNET:USER:AXIS-COPYRIGHT': '2505',
 'HTTP:STC:IE:WMP-INFO-DISC': '2506',
 'SPYWARE:TROJAN:HUE1-0': '2507',
 'SHELLCODE:SGI:GEN-2-PKT': '2508',
 'HTTP:PHP:WORDPRESS-COOKIE-INJ': '2509',
 'HTTP:REQERR:HEADER-INJECT': '2510',
 'IP:OPTERR:INVALID-LENGTH': '2511',
 'HTTP:PHP:PHPBB:HIGHLIGHT-EXEC': '2512',
 'CHAT:AIM:AIM-FILE-GET': '2513',
 'SPYWARE:TROJAN:REVERSABLE': '2514',
 'TROJAN:NETBUS:SERVER-RES-12345': '2515',
 'SPYWARE:DIALER:TIB-PORN-DIALER': '2516',
 'SPYWARE:BP:MACHERSTOOLBAR': '2517',
 'SMB:AUDIT:UNEXP-REQ': '2518',
 'FTP:CURL-OF-BANNER': '2519',
 'HTTP:PHP:PHPBB:PHPBB-XS1': '2520',
 'POP3:EXT:DOT-VBE': '2521',
 'CHAT:ICQ:FILE-SEND': '2522',
 'SMB:INFO:WFWGRP-3.1A': '2523',
 'APP:ARKEIA:DEFAULT-PASSWORD': '2524',
 'SYSLOG:FAILURES:EMPTY-MSG': '2525',
 'IMAP:OVERFLOW:BIN-SH': '2526',
 'SCAN:MISC:HTTP:PERLSHOP-PROBE': '2527',
 'SCAN:MISC:HTTP:MSDAC-PROBE': '2528',
 'FTP:OVERFLOW:LINE-TOO-LONG': '2529',
 'HTTP:OVERFLOW:INV-CHUNK-LEN': '2530',
 'WORM:CHUNKED-WORM': '2531',
 'APP:SUPERSCOUT-USERDB': '2532',
 'DB:MS-SQL:LOGIN-FAILURE': '2533',
 'SPYWARE:DM:MYNAPSTER': '2534',
 'HTTP:CGI:TWIKI-VIEW-EXEC': '2535',
 'HTTP:STC:CLSID:REF-31': '2536',
 'SPYWARE:RAT:DATARAPE10F-GETPWD': '2537',
 'RLOGIN:AUDIT:PARAM-NOT-OK': '2538',
 'SCAN:AMAP:HTTP-ON-SMTP': '2539',
 'APP:HPOVNNM:REQ_SEV_CHANGE-DOS': '2540',
 'HTTP:APACHE:NOSEJOB': '2541',
 'APP:MDAEMON:FORM2RAW-OF': '2542',
 'SPYWARE:RAT:HERMANUPLOADER-CTS': '2543',
 'HTTP:STC:CLSID:ACTIVEX:AX-116': '2544',
 'HTTP:PHP:WORDPRESS-USER-INJ': '2545',
 'TROJAN:MISC:NETADMIN-COMMAND': '2546',
 'CHAT:GADU-GADU:DISCOVER': '2547',
 'HTTP:STC:EMBED-SRC-OF': '2548',
 'SPYWARE:BP:MIRARTOOLBAR': '2549',
 'DHCP:OPT:MISSING-EOO': '2550',
 'HTTP:IIS:MALFORMED-BAT-URL': '2551',
 'SNMPTRAP:INFO:ERR_STAT_NO_CREAT': '2552',
 'SMB:EXPLOIT:SRV-RENAME-DOS': '2553',
 'CHAT:MSN:HTTP:LOGIN': '2554',
 'SPYWARE:TROJAN:LITTLEWITCH-CMD': '2555',
 'TROJAN:TELNET:USER-REWT': '2556',
 'HTTP:STC:ACTIVEX:SYMC-APPSTEAM': '2557',
 'TELNET:USER:DEFAULT-PW-NORTEL': '2558',
 'SCAN:MISC:HTTP:BACKUP-REQ': '2559',
 'IMAP:EXPLOIT:CMD-FORMAT-STRING': '2560',
 'SPYWARE:DM:KONTIKI': '2561',
 'HTTP:OVERFLOW:URL-OVERFLOW': '2562',
 'SCAN:MISC:HTTP:VIEWCODE-ASP': '2563',
 'TFTP:MRIS-ACCESS-VIOLATE': '2564',
 'SPYWARE:GM:SONGOOG': '2565',
 'SCAN:MISC:FTP:LOGXFR-OF2': '2566',
 'HTTP:PHP:SQUIRRELMAIL': '2567',
 'LDAP:EMPTY:EXTDREQ-REQVAL-EMPTY': '2568',
 'PROTOCOLS:TRAFFIC:NOT-DNS-TCP': '2569',
 'HTTP:OVERFLOW:LIBHTTPD-GET-OF': '2570',
 'WORM:CODERED-2:ROOT-BACKDOOR': '2571',
 'HTTP:NETSCAPE:WP-STOP-VER': '2572',
 'HTTP:PHP:COOLFORUM-INJ': '2573',
 'SPYWARE:RAT:FATALWOUND': '2574',
 'NETBIOS:NBDS:INVALID:LABEL_LEN': '2575',
 'P2P:WINMX:CLIENT-VER-CHK': '2576',
 'HTTP:INFO:TMICRO-PROXY-REQ': '2577',
 'SSL:INVALID:COMP-METH-LEN': '2578',
 'HTTP:HOTMAIL:EXE-DOWNLOAD': '2579',
 'FTP:DIRECTORY:DOT-PCT-20-DOT': '2580',
 'DHCP:AUDIT:CLI-HWADDR-NOT-T2': '2581',
 'HTTP:STC:HHP-BINARY-2': '2582',
 'HTTP:STC:ACTIVEX:CTSUENG-OCX': '2583',
 'SPYWARE:RAT:BLUEFIRE-FTP': '2584',
 'SMTP:OUTLOOK:LOCAL-LINK': '2585',
 'HTTP:SQL:INJ:WS2000': '2586',
 'HTTP:STC:CLSID:ACTIVEX:AX-109': '2587',
 'SNMP:ENCODING:EI-TOO-BIG': '2588',
 'HTTP:STC:CLSID:ACTIVEX:AX-54': '2589',
 'HTTP:INVALID:MSNG-HTTP-VER': '2590',
 'MS-RPC:ERR:RESPONSE-NO-REQ': '2591',
 'LDAP:EMPTY:MODIFYREQ_ADD_EMPTY': '2592',
 'HTTP:HOTMAIL:LIVE-ATTACH': '2593',
 'HTTP:SSL:MOZ-SSLV2-CL': '2594',
 'DB:MYSQL:LOGIN-OVERLONG-USER': '2595',
 'DB:ORACLE:VULN-VER-10.1.0.1': '2596',
 'HTTP:STC:CLSID:REF-26': '2597',
 'SSL:SERIAL-NUM-TOO-LONG': '2598',
 'SPYWARE:AD:WEBCPR': '2599',
 'DB:ORACLE:PITRIG-TRUNC-DROP': '2600',
 'TROJAN:MISC:NETTAXI-SRV-RESP': '2601',
 'HTTP:STC:MOZILLA:WRAPPED-JAVA': '2602',
 'SPYWARE:RAT:SPECREM6-2-CTS': '2603',
 'DB:MS-SQL:SA-LOGIN': '2604',
 'VNC:ERR:TOO-MANY-AUTH-FAIL': '2605',
 'P2P:WINMX:DOWNLOAD': '2606',
 'NTP:MODE_STRATUM_ALTERED': '2607',
 'SPYWARE:RAT:HANKYPANKY': '2608',
 'SMB:INFO:NEG-FAILED': '2609',
 'TROJAN:MISC:FE-SERV-RESP': '2610',
 'SPYWARE:KL:CAM2FTP': '2611',
 'SPYWARE:RAT:PRORAT1-9-ICQ': '2612',
 'HTTP:STC:CLSID:ACTIVEX:AX-19': '2613',
 'DNS:INFO:XFER-BAD': '2614',
 'MS-RPC:ERR:EPM-WRONG-RHS-LEN': '2615',
 'HTTP:OVERFLOW:METHOD-GENRC-OF': '2616',
 'HTTP:STC:CLSID:ACTIVEX:MDSAUTH': '2617',
 'SPYWARE:RAT:CIA1-22-SMTP': '2618',
 'SMTP:CLAMAV-CMD-INJ': '2619',
 'SHELLCODE:SPARC:GEN-5-TCP': '2620',
 'CHAT:IRC:INVALID:PREFIX': '2621',
 'VOIP:H225RAS:AUDIT:UNKN-MESSAGE': '2622',
 'CHAT:IRC:CC-NUMBER': '2623',
 'LDAP:EMPTY:MODIFYREQ_EMPTY': '2624',
 'SPYWARE:RAT:CYBERNETIC1-62': '2625',
 'SMB:EXPLOIT:SMB-SHRE-NAME-OFLOW': '2626',
 'DHCP:EXPLOIT:HOSTNAME-HTML': '2627',
 'VOIP:SIP:AUDIT:MISSING-VERSION': '2628',
 'SPYWARE:TROJAN:DWNLDR-ARQ': '2629',
 'SPYWARE:AD:WAREZP2P': '2630',
 'HTTP:STC:IE:IE-FTP-CMD': '2631',
 'RADIUS:ACCREQ_DISALLOWD_ATTR': '2632',
 'SCAN:NIKTO:URL': '2633',
 'SPYWARE:KL:MSN-SPY-MONITOR': '2634',
 'APP:MISC:ZKFINGER-OF': '2635',
 'HTTP:IIS:HTW-CROSS-SITE': '2636',
 'DOS:CA-DOS': '2637',
 'APP:IPSWITCH:LOGGING-SVC-DOS': '2638',
 'HTTP:PKG:JETTY-CMD-EXEC': '2639',
 'IP:ESP-RUNT': '2640',
 'DNS:OVERFLOW:HOSTNAME-OF': '2641',
 'RSH:AUDIT:REQ-ILLEGAL-PORT': '2642',
 'NNTP:AUDIT:NESTED-REPLY': '2643',
 'SPYWARE:TROJAN:SPAM-MAXY': '2644',
 'SCAN:CANVAS:INGRESS': '2645',
 'SCAN:MISC:TELNET:NMAP': '2646',
 'LDAP:EMPTY:SCHREQ_FILTER_EMPTY': '2647',
 'HTTP:STC:IE:IE-FTP-SCRIPTING': '2648',
 'TROJAN:SUBSEVEN:SCAN': '2649',
 'VOIP:SIP:AUDIT:INV-CONT-TYPE': '2650',
 'SPYWARE:GM:DOWNLOADER-F': '2651',
 'RTSP:OVERFLOW:LINE-OF': '2652',
 'SMTP:EXT:DOT-WSH': '2653',
 'HTTP:STC:ACTIVEX:OWC': '2654',
 'FTP:VULN:WS-FTP-4-0-2': '2655',
 'SPYWARE:AD:VIRTUMONDE': '2656',
 'DNS:OVERFLOW:SCO-NAMED2-OF2': '2657',
 'HTTP:CGI:WEBPALS-EXEC': '2658',
 'DNS:OVERFLOW:TOO-LONG-TCP-MSG': '2659',
 'APP:SNORT:BACKORIFICE-DOS': '2660',
 'SNMPTRAP:ERROR:INV_ERRSTAT_LEN': '2661',
 'APP:SNORT:BACKORIFICE-BOF': '2662',
 'FTP:PASSWORD:COMMON-PASSWD': '2663',
 'DB:ORACLE:USERNAME-DUMP': '2664',
 'TROJAN:MISC:SCHNECK-SERV-RESP': '2665',
 'RADIUS:ACCREJ_DISALLOWD_ATTR': '2666',
 'APP:VERITAS:VERITAS-FILE-DUMP': '2667',
 'HTTP:AUDIT:FW1-SCHEME-OF': '2668',
 'SNMPTRAP:INFO:STAT_INCON_NAME': '2669',
 'SMTP:EXT:DOT-PCD': '2670',
 'NFS:AUDIT:ROOT-ACCESS': '2671',
 'DNS:AUDIT:MISMATCHING-AN-CNAME': '2672',
 'APP:KERBEROS:DOS': '2673',
 'HTTP:CGI:CLASSIFIEDS-CGI-EMAIL': '2674',
 'HTTP:PHP:VBULL-CAL-EXEC': '2675',
 'HTTP:REQERR:SMUGGLING': '2676',
 'PORTMAPPER:INFO:DUMP_PROC': '2677',
 'HTTP:PHP:LOG-INSERT': '2678',
 'HTTP:STC:ACTIVEX:OFFICE-OCX': '2679',
 'HTTP:STC:CLSID:ACTIVEX:AX-147': '2680',
 'APP:ETHEREAL:EIGRP-OF': '2681',
 'TROJAN:BACKORIFICE:WEB-SERVER': '2682',
 'SPYWARE:AD:SUPERFASTMP3SEARCH': '2683',
 'FTP:COMMAND:SITE-EXEC': '2684',
 'TROJAN:MISC:CELINE-SRV-RESP': '2685',
 'TELNET:OVERFLOW:NEW-ENVIRON-OF': '2686',
 'TROJAN:MISC:OXON-COMMAND': '2687',
 'HTTP:FRONTPAGE:FP30REG.DLL-OF': '2688',
 'SPYWARE:UTIL:SARSNOTIFIER': '2689',
 'SCAN:MISC:HTTP:CROSS-SCRIPT': '2690',
 'SPYWARE:BH:411WEBTOOLBAR': '2691',
 'FTP:AUDIT:REP-INVALID-REPLY': '2692',
 'POP3:DOS:WINGATE': '2693',
 'SPYWARE:AD:WINADISCOUNT': '2694',
 'SPYWARE:RAT:MINIMO': '2695',
 'HTTP:PHP:PHPBB:UID-SQL-INJECT': '2696',
 'APP:MISC:HP-MERCURY-BOF': '2697',
 'HTTP:IIS:ASP-DOT-NET-BACKSLASH': '2698',
 'HTTP:PHP:PHPWEB-REMOTE-FILE': '2699',
 'NTP:ERROR:CTL_VAR_NAME_2LONG': '2700',
 'SCAN:SSH-RESEARCH:ACTIVITY': '2701',
 'APP:GAME:UT2004-QUERY': '2702',
 'HTTP:STC:SCRIPT:FUNC-REASSIGN': '2703',
 'TROJAN:PHASEZERO:SERVER-RES': '2704',
 'SCADA:IEC104:INVALID-UDP-MSG': '2705',
 'APP:GAME:CS-CONNECT': '2706',
 'HTTP:EXPLOIT:ORACLE-9I-AUTH-OF': '2707',
 'NETBIOS:NBNS:C2S_RESPONSE': '2708',
 'HTTP:STC:CLSID:ACTIVEX:AX-05': '2709',
 'TCP:AUDIT:OLD-3WH-ACK': '2710',
 'SMTP:EXCHANGE:CMD_XEXCH50_2LONG': '2711',
 'SCAN:CANVAS:FEDORA4': '2712',
 'SMTP:OVERFLOW:METAMAIL-HDR-OF2': '2713',
 'HTTP:YAHOO:ATTACHMENT-DOWNLOAD': '2714',
 'VOIP:MGCP:AUDIT:INV-RSP-HDR': '2715',
 'VOIP:SIP:AUDIT:URI-ERROR': '2716',
 'HTTP:CGI:SMARTSEARCH-EXEC': '2717',
 'HTTP:PHP:PHPNUKE:ADMIN-GUESS': '2718',
 'RADIUS:ACSREQ_DISALLOWD_ATTR': '2719',
 'APP:PCANYWHERE:LOGIN-ADMIN': '2720',
 'HTTP:STC:IMG:ICO-SIZE-OF': '2721',
 'MS-RPC:DCE-RPC-UUID-BIND': '2722',
 'SPYWARE:KL:007SPYSOFTWARE-SMTP': '2723',
 'SMTP:MAL:XSS-URL-IN-EMAIL': '2724',
 'HTTP:PHP:TIKIWIKI-CMD-EXEC': '2725',
 'RTSP:EMPTY-HEADER': '2726',
 'P2P:BITTORRENT:BT-TRACKER-DOS': '2727',
 'SMB:INFO:DOT-EXE-FILE-XFER': '2728',
 'IDENT:INVALID:EOL': '2729',
 'TCP:OPTERR:TOO-LONG': '2730',
 'HTTP:STC:CLSID:ACTIVEX:VML-AX': '2731',
 'SNMP:ENCODING:NZLEN-FOR-NULL': '2732',
 'HTTP:STC:IE:OLE-AUTO': '2733',
 'HTTP:STC:CLSID:REF-7': '2734',
 'NNTP:INN:INND-OF2': '2735',
 'HTTP:FRONTPAGE:SERVICE.PWD-REQ': '2736',
 'TROJAN:MISC:AOLADMIN-SRV-RESP': '2737',
 'SPYWARE:GM:ZANGO-EASY-MESSENGER': '2738',
 'SPYWARE:TROJAN:ACIDSHIVERS': '2739',
 'NFS:INVALID:INVALID-DIR': '2740',
 'FTP:SERVU:CHMOD-OVERFLOW': '2741',
 'TROJAN:GOZI-REG': '2742',
 'SHELLCODE:X86:NOOP-STLTH-PKT': '2743',
 'SCAN:MISC:HTTP:ADMCGI-EXE-PROBE': '2744',
 'SHELLCODE:METASPLOIT:WIN-BINDSH': '2745',
 'GOPHER:INVALID:EOL': '2746',
 'SPYWARE:DM:WEBHANCER': '2747',
 'LDAP:OVERFLOW:DC-MEM-LEAK-DOS': '2748',
 'DB:ORACLE:DBMS-METADATA-SQL-INJ': '2749',
 'SPYWARE:AD:GATOR-EWALLET': '2750',
 'SNMP:INFO:ERR_STAT_WRG_ENC': '2751',
 'TCP:C2S:EXPLOIT:RST-BRUTE-FORCE': '2752',
 'SMB:NETBIOS:INV-CGNAME-ENC': '2753',
 'RUSERS:AUDIT:REQ-DENIED': '2754',
 'DB:ORACLE:SHORT_MSG': '2755',
 'CHAT:AIM:LOGIN-ATTEMPT': '2756',
 'WHOIS:UNEXPECTED-REPLY': '2757',
 'SNMP:ENCODING:ZLEN-FOR-OID': '2758',
 'HTTP:STC:ADOBE:PDF-UNICODED-SC': '2759',
 'FTP:COMMAND:PLATFTP-CD-DOS': '2760',
 'HTTP:PKG:DNSTOOLS-AUTH-BYPASS': '2761',
 'CHARGEN:EXPLOIT:UNEXPECTED-REQ': '2762',
 'MS-RPC:MSRPC-EVASION-8': '2763',
 'SPYWARE:BH:KOMPASS-TOOLBAR': '2764',
 'SNMP:DANGEROUS:LINKSYS-WAP55AG': '2765',
 'SPYWARE:AD:PPRICH': '2766',
 'APP:CA:LIC-GETCONFIG-OF2': '2767',
 'CHAT:JABBER:JABBER-XTRAF': '2768',
 'IMAP:VULN:CYRUS-2-1-11': '2769',
 'HTTP:STC:BT:CLIENT-VULN2': '2770',
 'IMAP:AUDIT:COMMAND-FAILED': '2771',
 'TCP:AUDIT:SYN-RTNS-BADWIN': '2772',
 'HTTP:STC:MOZILLA:ONUNLOAD-SSL': '2773',
 'WORM:CODERED:INFECTION-ATTEMPT': '2774',
 'TROJAN:ADMW0RM:USER-LOGIN': '2775',
 'HTTP:CGI:HTDIG-INCLUSION': '2776',
 'SPYWARE:AD:WINZIX-2-2-0': '2777',
 'SCAN:CANVAS:ESERV': '2778',
 'DDOS:TRIN00:MASTER-CMD-MDOS': '2779',
 'FINGER:EXPLOIT:REDIRECTION': '2780',
 'DDOS:TRIN00:MASTER-CMD-KILLDEAD': '2781',
 'SPYWARE:TROJAN:NETANGEL1-0': '2782',
 'POP3:EXT:DOT-EXE': '2783',
 'RPC:RPC.TTDBSERVER:TT-MAL-FS-2': '2784',
 'PORTMAPPER:INFO:UNSET-PROC': '2785',
 'HTTP:PHP:MLOG-SCREEN': '2786',
 'RPC:KADMIND-OF': '2787',
 'MS-RPC:ERR:FRAG-LEN-TOO-BIG': '2788',
 'TROJAN:MISC:NETTERROR-SRV-RESP': '2789',
 'SCAN:MISC:HTTP:UNIX-BIN-BASH': '2790',
 'DDOS:TRIN00:MASTER-CMD-DOS': '2791',
 'P2P:NAPSTER:DATA-6666': '2792',
 'APP:BRG-MAIL-US-PASS': '2793',
 'HTTP:IIS:HDR-EVASION': '2794',
 'SPYWARE:TROJAN:SILENTSPY': '2795',
 'HTTP:PHP:BZOPEN-OF': '2796',
 'SMB:EXPLOIT:NULL-FILENAME': '2797',
 'DB:MYSQL:MYSQL-USE-DOS': '2798',
 'LPR:OVERFLOW:CFILE-LEN': '2799',
 'HTTP:STC:CLSID:ACTIVEX:AX-27': '2800',
 'HTTP:WEBLOGIC:JSESSIONID': '2801',
 'TROJAN:MISC:INFRATROJAN-COMMAND': '2802',
 'HTTP:PHP:YABBSE-PKG-EXEC': '2803',
 'HTTP:STC:ACTIVEX:KAZAA-ALTNET': '2804',
 'HTTP:FRONTPAGE:SHTML.EXE-PATH': '2805',
 'SCAN:MISC:HTTP:WWWADM-ACCESS': '2806',
 'LPR:INVALID:C-EMPTY': '2807',
 'HTTP:STC:CLSID:ACTIVEX:EXECHAND': '2808',
 'CHAT:AUDIT:YMSG:CHAT-NAME-OF': '2809',
 'P2P:NAPSTER:DOWNLOAD-7777': '2810',
 'LDAP:INVALID:SRCH-DEREF-AL-INV': '2811',
 'HTTP:TOMCAT:TOMCAT-JSP-DISC': '2812',
 'MS-RPC:NETDDE-SHARE-OF': '2813',
 'SNMP:ENUM:ORINOCO-INFO1': '2814',
 'HTTP:STC:CLSID:ACTIVEX:TREND-AX': '2815',
 'SSL:HTTPS-UNIX-ID-RESP': '2816',
 'SMTP:EXCHANGE:CALENDAR-HEAP': '2817',
 'POP3:ERROR:UNFINISHED_MULTIPART': '2818',
 'SPYWARE:TROJAN:UPNRUN-V10': '2819',
 'RTSP:REALSERVER:REAL-SETUP-OF1': '2820',
 'FTP:VULN:SERV-U-FTP-4-2': '2821',
 'DB:ORACLE:DBMS-EXPORT-PRIV': '2822',
 'SPYWARE:BH:SOGOU': '2823',
 'SPYWARE:AD:COOPEN': '2824',
 'SMB:OF:PNP-OF': '2825',
 'SCADA:IEC104:INVALID-START-TAG': '2826',
 'WORM:CONFICKER:C-ACTIVITY-2': '2827',
 'HTTP:OVERFLOW:CHUNK-OVERFLOW': '2828',
 'TROJAN:QAZ:TCP139-SCAN': '2829',
 'HTTP:INFO-LEAK:WWWBOARD-PASSWD': '2830',
 'CHAT:IRC:INVALID:FORMAT-STR': '2831',
 'P2P:EMULE:DECODE16-OVERFLOW': '2832',
 'SCADA:DNP3:READ': '2833',
 'SPYWARE:TROJAN:HALFLIFEJACKER': '2834',
 'SCAN:MISC:HTTP:ALIBABA': '2835',
 'SPYWARE:TROJAN:BAROK': '2836',
 'HTTP:CGI:TWIKI-REV-CMD-INJ': '2837',
 'SPYWARE:TROJAN:BLHOUSE': '2838',
 'SPYWARE:KL:POWEREDKEYLOGGER-2-2': '2839',
 'TROJAN:MISC:PCINVADER-COMMAND': '2840',
 'SCAN:MISC:HTTP:MMSTDOD-PROBE': '2841',
 'SMTP:EXCHANGE:INV_BDAT_SEC_LEN': '2842',
 'HTTP:NETSCAPE:WP-USR-PROP': '2843',
 'HTTP:STC:CLSID:ACTIVEX:AX-03': '2844',
 'VOIP:H225RAS:DOS:RRQ': '2845',
 'HTTP:STC:CLSID:REF-20': '2846',
 'SNMP:ENCODING:GET-BULK-REQ': '2847',
 'HTTP:OVERFLOW:WMF-HEAPOF': '2848',
 'POP3:EXT:DOT-BAT': '2849',
 'DHCP:SERVER:ISC-DISCOVER-DOS': '2850',
 'RPC:AUDIT:REQ-INVALID-XID': '2851',
 'VOIP:SIP:LIMITS:CONT-ENC-OF': '2852',
 'SPYWARE:AD:DIYBAR': '2853',
 'HTTP:NETSCAPE:UNIXWARE-DOS': '2854',
 'HTTP:SQL:INJ:PL-SQL': '2855',
 'HTTP:STC:CLSID:ACTIVEX:LENOVO': '2856',
 'CHAT:AUDIT:YMSG:ACTIVITY-SIZE': '2857',
 'SPYWARE:AD:CONTRA_VIRUS': '2858',
 'VOIP:SIP:OVERFLOW:T-38-SDP-OF': '2859',
 'P2P:OVERNET:CONNECTED': '2860',
 'SPYWARE:AD:BLOWSEARCH': '2861',
 'HTTP:XSS:HTW-XSS': '2862',
 'RADIUS:INCONSISTANT_LENGTH': '2863',
 'HTTP:EXT:DOT-VML': '2864',
 'FTP:COMMAND:3CDAEMON-PATH-DISCL': '2865',
 'HTTP:PHP:THATWARE:AUTH-INC': '2866',
 'DB:MYSQL:SINGLE-ROW-DOS': '2867',
 'HTTP:STC:CLSID:REF-8': '2868',
 'SPYWARE:TROJAN:3XBACKDOOR': '2869',
 'HTTP:STC:CLSID:ACTIVEX:ORADC': '2870',
 'HTTP:SQL:INJ:COMMENT': '2871',
 'POP3:OUTLOOK:MHTML-CDI': '2872',
 'TROJAN:GUPTACHAR-2.0': '2873',
 'SPYWARE:AD:WUPD-MEDIAACCESS': '2874',
 'VNC:OVERFLOW:REASON': '2875',
 'SCAN:WEBTRENDS:UDP-PROBE': '2876',
 'APP:CA:LIC-GCR-OF': '2877',
 'HTTP:STC:ACTIVEX:SNAPVIEW-OCX': '2878',
 'HTTP:STC:CLSID:ACTIVEX:INTUIT': '2879',
 'TROJAN:MISC:WINMITE-SRV-RDY': '2880',
 'HTTP:APACHE:RESIN-WEB-INF': '2881',
 'SPYWARE:KL:GHOSTKEYLOGGER': '2882',
 'SPYWARE:AD:ENBROWSERSNACKMAN': '2883',
 'FTP:WU-FTP:DELE-OF2': '2884',
 'SPYWARE:KL:KEYSPY': '2885',
 'HTTP:STC:CLSID:ACTIVEX:AX-50': '2886',
 'SPYWARE:RAT:REMOTESTORM1-2-CTS': '2887',
 'APP:KERBEROS:KBR-DOS-TCP-2': '2888',
 'HTTP:PHP:VBULLETIN-IMPEX-INC': '2889',
 'SCAN:MISC:HTTP:SHELL-ACCESS': '2890',
 'TFTP:EMPTY-FILENAME': '2891',
 'HTTP:STC:CLSID:ACTIVEX:AX-43': '2892',
 'SNMP:SQUID-PROXY-ASN1-OF': '2893',
 'VNC:ERR:CLNT-CUT': '2894',
 'VOIP:SIP:AUDIT:UNK-METHOD': '2895',
 'HTTP:XSS:HTML-SCRIPT-IN-URL-PRM': '2896',
 'SCAN:MISC:MSTREAM-CLIENT-REQ': '2897',
 'HTTP:INFO-LEAK:ORACLE-SQL': '2898',
 'APP:SYMC:AGENT-RM-CMD': '2899',
 'CHAT:AIM:OVERFLOW:URL': '2900',
 'HTTP:INFO-LEAK:CART32-INFO-LEAK': '2901',
 'VOIP:MGCP:AUDIT:INV-EP-NAME': '2902',
 'HTTP:STC:CLSID:ACTIVEX:AX-07': '2903',
 'SCAN:MISC:HTTP:UPLOAD-PROBE': '2904',
 'SPYWARE:AD:NEW-DOT-NET': '2905',
 'CHAT:AUDIT:YMSG:FILE-SEND': '2906',
 'VOIP:SIP:OVERFLOW:MAX-FORWARD': '2907',
 'SPYWARE:AD:NABAZATOOLBAR': '2908',
 'HTTP:CGI:POLL-IT-VAR-OVERWRITE': '2909',
 'TROJAN:NETDEVIL:NETDEVIL': '2910',
 'HTTP:COBALT:SEC-REQ-PROBE-2': '2911',
 'CHAT:AUDIT:YMSG:EVENT-CODE': '2912',
 'SPYWARE:KL:LANTERNKEYLOGGER_6': '2913',
 'APP:BAKBON-NETVAULT-INT-OF': '2914',
 'NFS:INVALID:BAD-CRED-LEN': '2915',
 'SCAN:CANVAS:WORDMAIL3': '2916',
 'DOS:WINDOWS:MS-RDP-PATTERN-DOS': '2917',
 'LPR:OVERFLOW:C-INDENT': '2918',
 'HTTP:STC:NOTES-INI': '2919',
 'HTTP:BROWSER:ICQ': '2920',
 'TROJAN:MISC:MNEAH-SERV-RESP': '2921',
 'WORM:SASSER:A-D-F-SHELL-CMD': '2922',
 'APP:CUPS:HPGL-PC-OF': '2923',
 'HTTP:STC:CLSID:REF-36': '2924',
 'SPYWARE:BH:SOFA_TOOLBAR': '2925',
 'HTTP:STC:MHTML-CDI': '2926',
 'SPYWARE:RAT:BIONET405-CTS': '2927',
 'HTTP:PKG:NS-QUERY-PAT': '2928',
 'RPC:RPC.CMSD:RPC-CMSD-OVERFLOW': '2929',
 'HTTP:STC:SCRIPT:UNI-SHELLCODE': '2930',
 'P2P:AUDIT:GNUTELLA-MESSAGE': '2931',
 'SCAN:MISC:FTP:BSD-FTPD-MKD-OF': '2932',
 'APP:SCOHELP-OF1': '2933',
 'SPYWARE:AD:SPY_SHREDDER_2_1': '2934',
 'P2P:BEARSHARE:UA': '2935',
 'FTP:AUDIT:COMMAND-FAILED': '2936',
 'SNMP:COMMUNITY:AVAYA-DEFCOM1': '2937',
 'MS-RPC:ERR:LEN-CONFLICT': '2938',
 'SMTP:AUDIT:REQ-MISSING-RCPT-TO': '2939',
 'HTTP:STC:URI-INJ': '2940',
 'RTSP:SETUP-EMPTY': '2941',
 'APP:CVS:CVS-AUTHOR-OF': '2942',
 'HTTP:INFO-LEAK:PHP-PROXIMA': '2943',
 'RUSERS:INVALID:BAD-VERF-CRED': '2944',
 'HTTP:STC:CLSID:ACTIVEX:AX-99': '2945',
 'TROJAN:DAGGER:SERVER-RES': '2946',
 'SCAN:MISC:HTTP:MACHINEINFO': '2947',
 'APP:CA:ARCSRV:UNICENTERAGENT-OF': '2948',
 'DNS:INFO:RCODE-SERVER-FAILURE': '2949',
 'HTTP:MISC:NEOTERIS-IVE-BF': '2950',
 'LPR:AUDIT:RESPONSE': '2951',
 'TROJAN:MISC:R3C-SERV-RESP': '2952',
 'HTTP:STC:CLSID:ACTIVEX:AX-12': '2953',
 'HTTP:STC:IE:SYSIMAGE-INFO-DISC': '2954',
 'APP:HPOVNNM:HPOVTRACE-OF': '2955',
 'SMTP:VULN:EXIM-4-20': '2956',
 'HTTP:STC:IE:MSRAT-NAME-OF-SVR': '2957',
 'DDOS:TRIN00:DAEMON-TO-MASTER-2': '2958',
 'SYSLOG:CP-SYSLOGD-ESC': '2959',
 'IMAP:OVERFLOW:LINUX-X86-5': '2960',
 'SPYWARE:RAT:NEUROTICKAT1-3-STC': '2961',
 'APP:NOVELL:MESSENGER-SERVER-BOF': '2962',
 'MS-RPC:MSRPC-EVASION-7': '2963',
 'NTP:ERROR:CTL_INVALID_EVCODE': '2964',
 'SPYWARE:TROJAN:BLACKCURSE4': '2965',
 'RUSERS:OVERFLOW:HOST-OVERFLOW': '2966',
 'IMAP:OVERFLOW:PASS': '2967',
 'TROJAN:MISC:CERO-SRV-RESP': '2968',
 'HTTP:STC:CLSID:ACTIVEX:AX-150': '2969',
 'SCAN:MISC:TELNET:CD-DOT-DOT-DOT': '2970',
 'TROJAN:TELNET:USER-LRKR0X': '2971',
 'SPYWARE:BH:CWS-GONNASEARCH': '2972',
 'SSL:SESSION-ID-LEN-2BIG': '2973',
 'HTTP:TUNNEL:SIP': '2974',
 'LDAP:EMPTY:EXTDREQ-REQNM-EMPTY': '2975',
 'TROJAN:MISC:TRANSSCOUT-CLIENTID': '2976',
 'HTTP:IIS:ENCODING:UNICODE-BP': '2977',
 'SSL:CIPHER-SUITE-OVERFLOW': '2978',
 'HTTP:STC:MOZILLA:ICONURL-JS': '2979',
 'SPYWARE:AD:2MFREEGAMES': '2980',
 'SPYWARE:KL:PAGKEYLOG': '2981',
 'WORM:BAGLE:AF-HTTP': '2982',
 'SNMPTRAP:ENCODING:OID-TOO-LONG': '2983',
 'CHAT:AUDIT:YMSG:WEBCAM-KEY': '2984',
 'SMTP:OVERFLOW:BOUNDARY': '2985',
 'VOIP:SIP:LIMITS:ROUTE-OF': '2986',
 'HTTP:STC:CLSID:ACTIVEX:AX-114': '2987',
 'VOIP:SIP:LIMITS:PROX-AUTHRIZ-OF': '2988',
 'P2P:AUDIT:GNUTELLA-PING-LEN': '2989',
 'POP3:OUTLOOK:LOCAL-LINK': '2990',
 'APP:NOVELL:MESSENGER-OF': '2991',
 'SCAN:MISC:HTTP:SERVERS-DOS': '2992',
 'TELNET:USER:DEFAULT-PW-3': '2993',
 'APP:REMOTE:RDP-CONNECT': '2994',
 'HTTP:STC:IE:DHTML-HANDLER-RACE': '2995',
 'NFS:INVALID:INVALID-AMASK': '2996',
 'HTTP:SQL:INJ:HEADER-2': '2997',
 'HTTP:TOMCAT:JSP-PAGE': '2998',
 'APP:VMS-8.3.5-CMD-EXE': '2999',
 'IMAP:OVERFLOW:IMAP4-LSUB-OF': '3000',
 'P2P:AUDIT:GNUTELLA-PUSH-LEN': '3001',
 'SCAN:AMAP:SAP-R3-ON-HTTP': '3002',
 'HTTP:XSS:CISCO-IOS-ADMIN': '3003',
 'SPYWARE:TROJAN:BLACKDIVER': '3004',
 'HTTP:CGI:TEXIS-INFOPROBE': '3005',
 'SMTP:COMMAND:BDAT': '3006',
 'SPYWARE:TROJAN:GLOBALKILLERHTTP': '3007',
 'APP:HPOVNNM:OVALARMSRV-DOS': '3008',
 'HTTP:STC:CLSID:ACTIVEX:AX-104': '3009',
 'HTTP:STC:MAL-VBP': '3010',
 'VOIP:SIP:SDP:HEADER-UNK-ERR': '3011',
 'DB:MS-SQL:XP_CMDSHELL-SMB': '3012',
 'HTTP:STC:ACTIVEX:DA-3': '3013',
 'SPYWARE:TROJAN:EVILGOAT': '3014',
 'HTTP:OVERFLOW:REFERER': '3015',
 'LDAP:AUDIT:ANONYMOUS_BIND': '3016',
 'SCAN:CANVAS:TIVOLI3': '3017',
 'FINGER:EXPLOIT:ZERO-AT-HOST': '3018',
 'SPYWARE:BH:SBUHOTBAR484': '3019',
 'HTTP:EXPLOIT:MS-DOS-DEV': '3020',
 'HTTP:IIS:DLL-URL-REQ': '3021',
 'HTTP:STC:ACTIVEX:ORBITDM': '3022',
 'DB:ORACLE:UNK-COMMAND': '3023',
 'HTTP:STC:CLSID:ACTIVEX:CAPICOM': '3024',
 'SPYWARE:KL:PC-PARENT': '3025',
 'HTTP:PROXY:ANON:CONCEAL-WS': '3026',
 'HTTP:IIS:INDEX-SERVER-SQLQHIT': '3027',
 'HTTP:SQL:INJ:MYSHOP': '3028',
 'VOIP:SIP:AUDIT:UNK-PARA-VIA': '3029',
 'SPYWARE:RAT:BIFROSE': '3030',
 'HTTP:PHP:PHORUM:REMOTE-EXEC': '3031',
 'LDAP:EMPTY:REFERRAL_EMPTY': '3032',
 'TCP:AUDIT:C2S-PART-OUT-OF-WIN': '3033',
 'DDOS:SHAFT:CLIENT-TO-HANDLER': '3034',
 'IDENT:JIDENTD:IDENT-OF1': '3035',
 'TROJAN:MISC:PCINVADER-FTP-BANR': '3036',
 'CHAT:AUDIT:YMSG:GROUP-NAME': '3037',
 'HTTP:STC:ACTIVEX:MSOWC-1': '3038',
 'DOS:NETDEV:HP-LCD-MOD-9100': '3039',
 'POP3:EXT:DOT-VBS': '3040',
 'SMTP:EXCHANGE:INV_BDAT_CMD': '3041',
 'SCAN:MISC:HTTP:IPLANET-GETPROP': '3042',
 'DB:IB:CONNECT-BOF': '3043',
 'DB:ORACLE:XML-SCHEMA-OF': '3044',
 'TROJAN:MISC:NOKNOK-COMMAND': '3045',
 'HTTP:STC:ACTIVEX:GATEWAYX': '3046',
 'IKE:DOS:ISAKMP-DOS-1': '3047',
 'NETBIOS:NBNS:INVALID:FIRST-ENC': '3048',
 'POP3:EXT:DOT-CHM': '3049',
 'RPC:RPC.MOUNTD:SHOWMOUNT-TCP': '3050',
 'SPYWARE:RAT:FADE1-0-TCP': '3051',
 'DOS:NETDEV:CISCO-IPMOBILITY': '3052',
 'NETBIOS:NBNS:INVALID:HDR-OPCODE': '3053',
 'NETBIOS:NBNS:RESCODE:FORMAT_ERR': '3054',
 'APP:REMOTE:TEAMVIEWER': '3055',
 'HTTP:XSS:MERCURY-BOARD': '3056',
 'LDAP:EMPTY:SRCHREQ_FILTER_EMPTY': '3057',
 'HTTP:IIS:INDEX-SERVER-SRC-CODE': '3058',
 'SCAN:MISC:HTTP:SERVER-INFO': '3059',
 'WORM:AGOBOT:HTTP-SHARE-ENUM': '3060',
 'VOIP:SIP:OVERFLOW:HDR-URI-OF': '3061',
 'SMB:EXPLOIT:LANMAN-NUKE': '3062',
 'APP:PROXY:PORT-8118': '3063',
 'HTTP:PROXY:SQUID-AT-AT': '3064',
 'TROJAN:MISC:TRUVA-SERV-RESP': '3065',
 'SPYWARE:TROJAN:FURAX10B3': '3066',
 'SMTP:AUDIT:DUPLICATE-HEADER': '3067',
 'HTTP:CGI:RSA-AGENT-BOF': '3068',
 'VOIP:H225SGN:PROTO': '3069',
 'HTTP:STC:ACTIVEX:TM-OS': '3070',
 'HTTP:STC:ACTIVEX:AKAMAI-DM': '3071',
 'IP:AUDIT:INVALID-TYPE': '3072',
 'HTTP:DOMINO:POST-DOS2': '3073',
 'HTTP:EXPLOIT:SYM-FILEUPLOAD': '3074',
 'LPR:INVALID:C-NAME': '3075',
 'DDOS:TRIN00:DAEMON-TO-MSTR1-PKT': '3076',
 'SMTP:SERVER:OVERFLOW-WIN-X86': '3077',
 'SMTP:VULN:MERCUR-4-2': '3078',
 'DDOS:SHAFT:AGENT-TO-HANDLER-PKT': '3079',
 'LDAP:EMPTY:ATTRIBVALUE_EMPTY': '3080',
 'SMTP:AUDIT:REQ-BINARY-DATA': '3081',
 'SCADA:IEC104:MESSAGE-OVERFLOW': '3082',
 'HTTP:CGI:APPLE-QT-FILEDISC1': '3083',
 'SCAN:MISC:HTTP:UNIX-BIN-LS-PIPE': '3084',
 'HTTP:IIS:ASP-DOT-NET-VSTATE': '3085',
 'HTTP:STC:ACTIVEX:HP': '3086',
 'SMB:AUDIT:NULL-NVE-OS': '3087',
 'VOIP:SIP:AUDIT:INV-CHARACTER': '3088',
 'TCP:OPTERR:NONSYN-MSS': '3089',
 'SCAN:CYBERCOP:FINGER-REDIR': '3090',
 'SPYWARE:AD:PURITYSCAN': '3091',
 'TELNET:USER:DEFAULT-PW-2': '3092',
 'APP:GAME:CS-S-CONNECT': '3093',
 'TROJAN:SUBSEVEN:2.2-SERVER-RES': '3094',
 'SPYWARE:KL:WINFAMILYSAFETY': '3095',
 'FTP:EXPLOIT:TYPSOFT-DOS': '3096',
 'RTSP:OVERFLOW:TRANSPORT-OF': '3097',
 'SMTP:INVALID:DUP-BOUNDARY': '3098',
 'VNC:AUTH-BYPASS': '3099',
 'TROJAN:MS-04-028:TOOL-DOWNLOAD': '3100',
 'HTTP:UNIX-CMD:UNIX-CMD-A-L': '3101',
 'TROJAN:DPTHRT:REQ-SERVER-REHASH': '3102',
 'PORTMAPPER:INFO:PORTMAP-DUMP': '3103',
 'SPYWARE:RAT:ACIDDROP': '3104',
 'CHAT:JABBER:JABBER-DOS1': '3105',
 'TROJAN:MISC:NETMETRO-COMMAND': '3106',
 'APP:NOVELL:IMONITOR-OF': '3107',
 'WORM:NIMDA:NIMDA-NWS': '3108',
 'HTTP:IIS:ASP-CHUNKED-OF': '3109',
 'HTTP:STC:IE:CREATETEXTRANGE': '3110',
 'P2P:OVERNET:PEER-DISCOVERY': '3111',
 'RPC:FAILURE:SET-FAILED': '3112',
 'SPYWARE:AD:STATIONRIPPER': '3113',
 'REXEC:AUDIT:ILL-ERR-PORT': '3114',
 'WHOIS:REQUEST-TOO-LONG': '3115',
 'VOIP:ASTERISK-CS-OVERFLOW': '3116',
 'HTTP:IIS:CMS:MAL-CMS-REQ': '3117',
 'SMB:EXPLOIT:WILD-FILE-DOS': '3118',
 'POP3:EXT:DOT-VB': '3119',
 'TROJAN:MISC:NOSECURE-COMMAND': '3120',
 'POP3:EXT:DOT-CMD': '3121',
 'HTTP:DOMINO:NSF-PASSWORD-BYPASS': '3122',
 'HTTP:STC:IE:IEUNMEM': '3123',
 'CHAT:IRC:OVERFLOW:NICK': '3124',
 'HTTP:CGI:W3-MSQL-FILE-DISCLSR': '3125',
 'HTTP:STC:SWF:PHPEXEC': '3126',
 'HTTP:CGI:HTMLSCRIPT-FILEDISCLSR': '3127',
 'MS-RPC:NTLM-RPCSS': '3128',
 'POP3:ERROR:PARTIAL_MESSAGE': '3129',
 'APP:CVS:ENTRY-TAG-OF': '3130',
 'FINGER:REPLYERROR:BIN-DATA': '3131',
 'HTTP:PHP:PHPBB:HIGHLIGHT-EXEC2': '3132',
 'APP:CUPS:CUPS-JOBS-EXP': '3133',
 'DHCP:ERROR:INV-MSG-TYPE': '3134',
 'HTTP:STC:WP5-DL': '3135',
 'NETBIOS:NBNS:INVALID:LABEL-LEN': '3136',
 'SCADA:MODBUS:SLAVE-ID': '3137',
 'SPYWARE:RAT:WINSHELL': '3138',
 'SPYWARE:AD:WEBREDIR': '3139',
 'UDP:PORT-ZERO': '3140',
 'HTTP:STC:APPLE-ICHAT': '3141',
 'P2P:DC:HUB-LOGIN': '3142',
 'FTP:PROFTP:SIZE-DOS2': '3143',
 'HTTP:APACHE:REWRITE-OF': '3144',
 'HTTP:STC:ACTIVEX:WINDVD7': '3145',
 'VOIP:SIP:LIMITS:CALL-ID-OF': '3146',
 'SCAN:AMAP:SSL-ON-SMTP': '3147',
 'TELNET:EXPLOIT:SOLARIS-LOGIN-OF': '3148',
 'APP:SAP:MSG-SRV-GRP': '3149',
 'DNS:EXPLOIT:EMPTY-UDP-MSG': '3150',
 'SCAN:MISC:TELNET:VI-ETC-GROUP': '3151',
 'SMTP:OVERFLOW:METAMAIL-HDR-FS2': '3152',
 'HTTP:OVERFLOW:HEADER': '3153',
 'HTTP:SQL:INJ:L-FORUM': '3154',
 'HTTP:PKG:WEBMIN-BRUTE': '3155',
 'SCAN:MISC:HTTP:WIN-WSH': '3156',
 'TELNET:OVERFLOW:SUBOPTION': '3157',
 'SCAN:CORE:SQL-SERVER-HELLO': '3158',
 'DDOS:TRIN00:MASTER-CMD-MPING': '3159',
 'SCAN:MISC:HTTP:VIOLATION-ACCS': '3160',
 'HTTP:STC:CLSID:ACTIVEX:YMAIL': '3161',
 'RADIUS:INVALID_ATTR_LENGTH': '3162',
 'LPR:WINDOWS-LPR-DOS': '3163',
 'HTTP:SQL:INJ:CONCAT': '3164',
 'SCAN:MISC:HTTP:SNIPPETS-PROBE': '3165',
 'SPYWARE:RAT:ASSASSIN1-1-CTS': '3166',
 'SPYWARE:AD:ATLAS': '3167',
 'APP:CA:ARCSRV:LND-FILE-MANIP': '3168',
 'TROJAN:MISC:PROSIAK-SERV-RESP': '3169',
 'HTTP:STC:CLSID:REF-16': '3170',
 'HTTP:STC:ACTIVEX:ULTRAOFFICE': '3171',
 'NTP:ERROR:CTL_NONSTD_VAR_NAME': '3172',
 'CHAT:GOOGLE:START': '3173',
 'HTTP:STC:IE:MHTML-REDIRECT': '3174',
 'HTTP:WASD:CONF-ACCESS': '3175',
 'HTTP:LHTTPD:HOST-DOT-DOT-SLASH': '3176',
 'CHAT:AUDIT:YMSG:BUDY-LIST': '3177',
 'FTP:PASSWORD:FTPPASS-BLUESKIES': '3178',
 'HTTP:XSS:CSS-HEAP': '3179',
 'TROJAN:MISC:UNDETECTED-SRV-RESP': '3180',
 'HTTP:STC:CLSID:ACTIVEX:AX-76': '3181',
 'SMTP:EXCHANGE:ICAL-DOS': '3182',
 'HTTP:STC:ACTIVEX:REAL-IMPORT': '3183',
 'HTTP:WEBLOGIC:URL-REVEAL-SRC': '3184',
 'APP:MISC:MCAFEE-EPOL-ORCH': '3185',
 'DHCP:AUDIT:BOOT-FNAME-NOT-T2': '3186',
 'HTTP:PHP:UPLOAD-LOCATION': '3187',
 'HTTP:SQL:INJ:PROC-GENERIC': '3188',
 'MS-RPC:ERR:INV-AUTH-PAD-LEN': '3189',
 'CHAT:IRC:SSN-CLEARTEXT': '3190',
 'TROJAN:NETMTROPOL:CLI-REQ-5302': '3191',
 'DB:MYSQL:MS-DOS-NAMES-DOS': '3192',
 'SSL:CLNT-MSTR-KEY-OVERFLOW': '3193',
 'SHELLCODE:HP-UX:HP-NOOP-1-TCP': '3194',
 'PROTOCOLS:TRAFFIC:NOT-DNS-UDP': '3195',
 'TFTP:AUDIT:C2S-UNEXP-ACK': '3196',
 'POP3:EXT:DOT-MSC': '3197',
 'SPYWARE:AD:METAEUREKA': '3198',
 'DOS:NETDEV:CISCO-SUNND': '3199',
 'CHAT:AUDIT:YMSG:MEMBER-NAME': '3200',
 'APP:MISC:DOMINO-MGR-FS': '3201',
 'SCAN:NMAP:NMAP-UDP-1': '3202',
 'SPYWARE:KL:ABSYSTEMSPY': '3203',
 'HTTP:STC:CLSID:ACTIVEX:AX-79': '3204',
 'HTTP:CGI:USERONLINE-LOGLEAK': '3205',
 'VNC:OVERFLOW:AUTH-STATUS': '3206',
 'SCAN:MISC:HTTP:IIS-NEWDSN': '3207',
 'TROJAN:MISC:RADMIN-CMD': '3208',
 'DB:MS-SQL:STOR-PROC-PRIV-UPGRD': '3209',
 'HTTP:PHP:PHPNUKE:QR-SQL-INJECT': '3210',
 'LDAP:INVALID:SRCHREQ_FLEN_INV': '3211',
 'P2P:WINMX:SERVER-SUPERNODE-LIST': '3212',
 'PORTMAPPER:INFO:SET-PROC': '3213',
 'SNMP:FMT-STR-TCP': '3214',
 'SNMP:INFO:ERR_STAT_AUTH_ERROR': '3215',
 'NFS:INVALID:BAD-VERF-CRED': '3216',
 'CHAT:AUDIT:YMSG:MSG-TOO-BIG': '3217',
 'FTP:WU-FTP:SITE-OF': '3218',
 'SCAN:MISC:TELNET:REBOOT': '3219',
 'SHELLCODE:METASPLOIT:DECODR-PEX': '3220',
 'SMTP:RESPONSE:RELAYING-DENIED': '3221',
 'SPYWARE:KL:PERFECTKEYLOGGER168': '3222',
 'CHAT:AUDIT:YMSG:CHALLENGE': '3223',
 'HTTP:PHP:CEDRIC-EMAIL-PHPINC2': '3224',
 'SPYWARE:RAT:CIA1-22-HTTP': '3225',
 'HTTP:APACHE:LDAPFS': '3226',
 'CHAT:MSN:MESG-SEND': '3227',
 'HTTP:APACHE:PHP-INVALID-HDR': '3228',
 'TROJAN:SUBSEVEN:SUBSEVEN-HTTP': '3229',
 'HTTP:OVERFLOW:HOST': '3230',
 'SCAN:MISC:HTTP:DCFORUM-ACCESS': '3231',
 'WORM:SQL-SNAKE:MSSQL-REG-4': '3232',
 'APP:PROXY:PORT-8888': '3233',
 'VOIP:SIP:LIMITS:PROX-REQ-OF': '3234',
 'FINGER:AUDIT:REQ-WRONG-FORMAT': '3235',
 'SMTP:AUDIT:BANNER-PROBE': '3236',
 'HTTP:STC:CLSID:ACTIVEX:DXTLIPI': '3237',
 'SPYWARE:KL:SPYOUTSIDE-FTP': '3238',
 'APP:PEERCAST-BOF': '3239',
 'SPYWARE:RAT:THEEF-2-0-ICQ': '3240',
 'RPC:RPC.TTDBSERVER:TT-REAL-PATH': '3241',
 'HTTP:STC:CLSID:ACTIVEX:AX-61': '3242',
 'SMB:INFO:LANMAN-1.2X002': '3243',
 'HTTP:PHP:PHPMYADMIN:FMT-OPTION': '3244',
 'VOIP:MGCP:OVERLONG-UTF8': '3245',
 'SMTP:EXCHANGE:OWA-CSS': '3246',
 'HTTP:INVALID:EXPECT': '3247',
 'HTTP:STC:BT:CLIENT-VULN4': '3248',
 'SMTP:OUTLOOK:OBJECT-TAG': '3249',
 'HTTP:XSS:APACHE-SSI-XSS': '3250',
 'HTTP:STC:IE:WMP-SKIN-EXEC': '3251',
 'FINGER:USER:ROOT': '3252',
 'SPYWARE:AD:STARWARETOOLBAR': '3253',
 'HTTP:STC:CLSID:ACTIVEX:OSCAN8': '3254',
 'CHAT:AIM:LINK-EXEC': '3255',
 'HTTP:DOMINO:INFO-LEAK': '3256',
 'HTTP:INFO:RESIN-DEV-WEBROOT': '3257',
 'HTTP:XSS:HDR-REFERRER': '3258',
 'MS-RPC:MSRPC-EVASION-2': '3259',
 'POP3:ERROR:TOO_MANY_BOUNDARIES': '3260',
 'SHELLCODE:WINDOWS:GEN-1-PKT': '3261',
 'DB:ORACLE:DEFAULT-PW-SYS': '3262',
 'TROJAN:YAT:YAT-BANNER': '3263',
 'LDAP:EMPTY:ATTRIB_ASSERT_EMPTY': '3264',
 'HTTP:STC:CLSID:ACTIVEX:HRTBEAT': '3265',
 'HTTP:IIS:ASP-SHOWCODE': '3266',
 'FTP:CUTEFTP-OF': '3267',
 'HTTP:STC:CAPICOM-EXP': '3268',
 'HTTP:STC:ACTIVEX:MSVIDCTL-2': '3269',
 'HTTP:STC:ACTIVEX:RDP-UNSAFE-AX': '3270',
 'SMB:SMB20-NEG-DOS': '3271',
 'SMTP:EXT:DOT-WSZ': '3272',
 'HTTP:STC:MOZILLA:PLUGIN-ACL': '3273',
 'DNS:EXPLOIT:EXPLOIT-BIND9-RT': '3274',
 'HTTP:EXPLOIT:SMALL-FIRST-DATA': '3275',
 'SPYWARE:AD:MYWEBSEARCHTOOLBAR': '3276',
 'RPC:RPC.SADMIND:METHOD-CMD-EX': '3277',
 'TCP:AUDIT:SYNSENT-NONSYN': '3278',
 'SPYWARE:RAT:STATWIN': '3279',
 'HTTP:STC:MOD-CACHE-DOS': '3280',
 'APP:CA:ARCSERVE-DIRTRAV': '3281',
 'PORTMAPPER:ERR:LARGE-CRED': '3282',
 'P2P:XUNLEI:UDP': '3283',
 'SCAN:MISC:HTTP:ACHG-HTR-PROBE': '3284',
 'MS-RPC:ERR:WRONG-FRAG': '3285',
 'HTTP:STC:IE:IE5-BMP-BOF': '3286',
 'SPYWARE:AD:A9TOOLBAR': '3287',
 'CHAT:AUDIT:YMSG:MAIL-SNDR-NAME': '3288',
 'FTP:WU-FTP:WUFTPD-FMT-STR': '3289',
 'SNMP:ENCODING:VALUE-MISSING': '3290',
 'RPC:KRB5-LIB-OF': '3291',
 'TROJAN:MISC:FRENZY-SRV-RESP': '3292',
 'CHAT:MSN:LOGIN-ATTEMPT': '3293',
 'HTTP:PKG:CARELLO-VBEXEC': '3294',
 'HTTP:STC:CLSID:ACTIVEX:AX-129': '3295',
 'SPYWARE:TROJAN:AGENTWD': '3296',
 'SPYWARE:RAT:EXCEPTION1-0': '3297',
 'HTTP:WHATSUP:HTTP-SVR-BO': '3298',
 'WORM:AGOBOT:TV-DCE-RPC-PROP': '3299',
 'HTTP:AUDIT:REQ-LONG-UTF8CODE': '3300',
 'SHELLCODE:BSDX86:GEN-2-PKT': '3301',
 'DB:MYSQL:ZERO-LEN-PW': '3302',
 'SCAN:MISC:TELNET:ETC-GROUP': '3303',
 'TELNET:EXPLOIT:LD-PRELOAD': '3304',
 'SNMP:ERROR:INVALID-MSG-FORMAT': '3305',
 'HTTP:CGI:EXTROPIA-DIR-TRAVERSAL': '3306',
 'HTTP:PHP:BLACKBOARD-INC': '3307',
 'LPR:AUDIT:PORT': '3308',
 'DDOS:TRIN00:MASTERPW-DEF-STRTUP': '3309',
 'SCAN:MISC:HTTP:CONT-HTM-PROBE': '3310',
 'LDAP:INVALID:SRCH_RES_ATTR_INV': '3311',
 'SPYWARE:BH:SEARCHESSISTANT': '3312',
 'SPYWARE:AD:IST-ISTBAR': '3313',
 'LDAP:INVALID:SEARCH_SCOPE_INV': '3314',
 'HTTP:PHP:PHPNEWS:SQL-SENDTO': '3315',
 'DB:ORACLE:INVALID-LOGIN': '3316',
 'HTTP:IIS:ENCODING:PERC-PERC-2': '3317',
 'RSH:USER:USER-ROOT': '3318',
 'SHELLCODE:WIN-SHELL': '3319',
 'HTTP:IIS:WEBDAV:COMMAND-OF': '3320',
 'SMB:INFO:MSNET-1.03': '3321',
 'MS-RPC:EPDUMP-SCAN': '3322',
 'SCAN:NESSUS:DNS-SCAN': '3323',
 'HTTP:STC:IE:JS-MEM-CORR': '3324',
 'SPYWARE:TROJAN:AUTOSPY-CTS': '3325',
 'HTTP:STC:CLSID:REF-32': '3326',
 'FTP:CISCO-VPN-ACCESS': '3327',
 'HTTP:INFO-LEAK:CC-CLEAR-VAR': '3328',
 'HTTP:STC:CLSID:ACTIVEX:YHOO-AUD': '3329',
 'WORM:BLASTER:BACKDOOR-CMD': '3330',
 'SCADA:IEC104:MALFORMED-MESSAGE': '3331',
 'SCAN:MISC:HTTP:FINGER-PROBE': '3332',
 'VOIP:SIP:OVERFLOW:USERNAME': '3333',
 'VOIP:SIP:LIMITS:PRIORITY-OF': '3334',
 'HTTP:CGI:ROSE-ADMIN-1': '3335',
 'SPYWARE:TROJAN:WINTERLOVE': '3336',
 'TROJAN:KUANG2:SERVER-RESP-2': '3337',
 'CHAT:MSN:BRIDGE': '3338',
 'HTTP:STC:CLSID:ACTIVEX:AX-45': '3339',
 'APP:SNORT:DCE-RPC-DOS': '3340',
 'HTTP:STC:CLSID:ACTIVEX:AX-65': '3341',
 'LDAP:AUDIT:BIND_RESULT_FAILED': '3342',
 'TROJAN:HACKATTACK:PROBE': '3343',
 'MS-RPC:DCOM:EXPLOIT-2': '3344',
 'SMTP:MAL:OUTLOOK-MAILTO-QUOT': '3345',
 'HTTP:STC:CLSID:ACTIVEX:ORADC2': '3346',
 'SMTP:EXT:DOT-PPT': '3347',
 'HTTP:XSS:AWSTATS-EXEC': '3348',
 'HTTP:STC:ACTIVEX:MSVIDCTL-1': '3349',
 'SMTP:EXT:DOT-COM': '3350',
 'HTTP:STC:CLSID:ACTIVEX:MCAFEE': '3351',
 'SPYWARE:BH:SWBAR-ADROAD-CPR': '3352',
 'LDAP:FORMAT:ENC_LEN_LEFT_ZEROS': '3353',
 'P2P:AUDIT:GNUTELLA-MSG': '3354',
 'SCAN:CYBERCOP:OS-PROBE-2': '3355',
 'SNMPTRAP:AUDIT:UNKNOWN-VERSION': '3356',
 'HTTP:STREAM:YOUTUBE-REQ': '3357',
 'SMTP:INVALID:DUP-AUTH': '3358',
 'HTTP:CGI:MOREOVER-CACHE-FEED': '3359',
 'SMB:OF:RPC-PNP-OF-2': '3360',
 'HTTP:STC:IE:IE-IMG-INF-DOS': '3361',
 'DNS:AUDIT:REQ-ANSWERS-IN-QUERY': '3362',
 'POP3:EXT:DOT-OCX': '3363',
 'HTTP:STC:CLSID:ACTIVEX:AX-81': '3364',
 'RLOGIN:OVERFLOW:TERMINAL': '3365',
 'HTTP:MISC:WR850-WEBSHELL': '3366',
 'HTTP:STC:ACTIVEX:MS-IE-WMS': '3367',
 'HTTP:STC:ACTIVEX:GUI-CM-CTRLS': '3368',
 'HTTP:IIS:AD-SERVER-CONFIG': '3369',
 'MS-RPC:MAL-DNS': '3370',
 'HTTP:STC:APPLE-PICT': '3371',
 'SPYWARE:TROJAN:YXNETSCREEN20': '3372',
 'HTTP:STC:IE:FOLDER-COM-EXEC': '3373',
 'RPC:RLPR-FS-TCP': '3374',
 'HTTP:OVERFLOW:ATP-HTTPD-OF': '3375',
 'SSL:SLAPPER-WORM-PROBE': '3376',
 'HTTP:EXT:DOT-XUL': '3377',
 'SMB:AUDIT:NULL-ACCOUNT': '3378',
 'HTTP:CGI:KORWEBLOG-PATHDISC': '3379',
 'APP:HSSPD': '3380',
 'SPYWARE:KL:ACTUALSPY': '3381',
 'APP:ETHEREAL:NETFLOW-OF': '3382',
 'HTTP:XSS:CISCO-XSS': '3383',
 'APP:PCANYWHERE:LOGIN-FAILURE': '3384',
 'HTTP:MISC:XOOPS-WEBROOT': '3385',
 'SPYWARE:TROJAN:WINSHADOW30': '3386',
 'SPYWARE:GM:ERRORSAFE': '3387',
 'APP:IBM:TSM-SIGN-ON-OF': '3388',
 'SPYWARE:AD:EARTHLINKTOOLBAR': '3389',
 'SMTP:EXT:DOT-HT': '3390',
 'TROJAN:NETBUS:PRO-SERVER-RES': '3391',
 'DNS:OVERFLOW:SPARC-UDP': '3392',
 'HTTP:IIS:CMDSHELL-ATTEMPT': '3393',
 'HTTP:STC:CLSID:REF-4': '3394',
 'LDAP:EMPTY:SRCHREQ_FTR_SSTR': '3395',
 'HTTP:IIS:PROPFIND': '3396',
 'DOS:NETDEV:CISCO-HTTPD-DOS': '3397',
 'DNS:EXPLOIT:MAL-TXT-REC': '3398',
 'NFS:INVALID:INVALID-PROC': '3399',
 'HTTP:STC:ACTIVEX:MSCOMM32': '3400',
 'SCADA:ICCP:INVALID-TPDU': '3401',
 'SPYWARE:AD:SYSTEM-DOCTOR': '3402',
 'NTP:ERROR:CTL_INVALID_CLK_SRC': '3403',
 'RPC:RPC.TTDBSERVER:TT-MAL-OF': '3404',
 'HTTP:STC:SBS-TRAIN': '3405',
 'TIP:RECONNECT': '3406',
 'SPYWARE:KL:SMART_PC_KEYLOGGER': '3407',
 'SCAN:MISC:HTTP:FLEXFORM-PROBE': '3408',
 'VOIP:MGCP:AUDIT:INV-IP-DOMAIN': '3409',
 'HTTP:CGI:W3-MSQL-CGI-OF': '3410',
 'HTTP:STC:SRVRSP:403-FORBID': '3411',
 'SCAN:MISC:HTTP:WIN-ARGS-BAT': '3412',
 'POP3:AUDIT:DUPLICATE-HEADER': '3413',
 'DDOS:TRIN00:DAEMON-TO-MASTER-1': '3414',
 'SMTP:COMMAND:WIZ': '3415',
 'SPYWARE:RAT:SOFTWARSHADOW-CTS': '3416',
 'TROJAN:MISC:MOONPIE-SERV-RESP': '3417',
 'SPYWARE:AD:ROOGOO': '3418',
 'SPYWARE:AD:MINIBUG': '3419',
 'P2P:EDONKEY:OTHER-SVR-INFO-REQ': '3420',
 'SNMP:ENCODING:OIDVAL-TOO-BIG': '3421',
 'HTTP:EXT:DOT-LNK': '3422',
 'SPYWARE:TROJAN:SPYLPLY.A': '3423',
 'APP:CA:ARCSRV:LND-OF': '3424',
 'SPYWARE:BH:DREAMBAR': '3425',
 'HTTP:STC:IMG:JPEG-SCRIPT': '3426',
 'CHAT:AUDIT:YMSG:DATA-TYPE': '3427',
 'SPYWARE:RAT:DELTASOURCE': '3428',
 'CHAT:IRC:OVERFLOW:USERNAME': '3429',
 'APP:PPTP:POPTOP-OF1': '3430',
 'SCAN:CORE:MP-IE-ZONE-BYPASS': '3431',
 'VOIP:MGCP:AUDIT:INV-CONN-ID': '3432',
 'TROJAN:MISC:GIFT-COMMAND': '3433',
 'DDOS:SHAFT:HANDLER-TO-AGENT': '3434',
 'SMTP:OVERFLOW:CODEBLUE-OF1': '3435',
 'SCAN:MISC:HTTP:W2TVARS-PM-PROBE': '3436',
 'NTP:RECVD_UNEXPECTED_PKT': '3437',
 'SHELLCODE:SCO:GEN-1-TCP': '3438',
 'NTP:INVALID:CTL_DATA_MULTI_PKT': '3439',
 'HTTP:PHP:PHPMYADMIN:LOCALFILE': '3440',
 'TFTP:AUDIT:S2C-INVALID-OPCODE': '3441',
 'SCAN:MISC:TELNET:APPEND-RHOSTS': '3442',
 'ECHO:CHARGEN-DOS': '3443',
 'DNS:OVERFLOW:INVALID-LABEL-LEN': '3444',
 'HTTP:STC:SAFARI:SSH-URI': '3445',
 'SPYWARE:TROJAN:FKWP-WDOWNLOADER': '3446',
 'SCAN:MISC:TELNET:STROBE': '3447',
 'SPYWARE:LIGATS': '3448',
 'P2P:XUNLEI:MESSSAGE': '3449',
 'HTTP:STC:CLSID:ACTIVEX:AX-148': '3450',
 'SPYWARE:AD:DOWNLOADWARE': '3451',
 'POP3:EXT:DOT-LNK': '3452',
 'HTTP:STC:CLSID:ACTIVEX:AX-124': '3453',
 'SPYWARE:TROJAN:ACROPOLIS': '3454',
 'TCP:AUDIT:C2S-URG-DATA': '3455',
 'HTTP:INFO-LEAK:SALESCART-DB': '3456',
 'POP3:OVERFLOW:SCO-POP3-OVERFLOW': '3457',
 'HTTP:PHP:SILENT-STORM-ADMIN': '3458',
 'HTTP:PHP:CACTI-CONFIG-INC': '3459',
 'APP:PROXY:PORT-8000': '3460',
 'SCAN:MISC:HTTP:TRACE': '3461',
 'VOIP:SIP:CSCO-INVITE-DOS': '3462',
 'APP:TMIC:SP-CREATEBIND-OF': '3463',
 'HTTP:CYCLADES:CONSOLE-CON': '3464',
 'SPYWARE:AD:MONEYBAR': '3465',
 'HTTP:REQERR:BIN-DATA-CONT-LOC': '3466',
 'HTTP:STC:CLSID:ACTIVEX:AX-122': '3467',
 'APP:NAV-ENT-WEB-OF': '3468',
 'RADIUS:INVALID_MSG_CODE': '3469',
 'POP3:OVERFLOW:QPOP-OF2': '3470',
 'TROJAN:MISC:ALVGUS-SRV-RESP': '3471',
 'IMAP:OVERFLOW:TAG': '3472',
 'HTTP:STC:CLSID:REF-50': '3473',
 'SMTP:EXCHANGE:XLINK2_TOO_LONG': '3474',
 'SCAN:MISC:HTTP:WIN-C-SAMPLE': '3475',
 'HTTP:ISA-AUTH-BYPASS': '3476',
 'MS-RPC:ERR:SHORT-MSG': '3477',
 'SCAN:NESSUS:TFTP-SCAN': '3478',
 'DNS:NEGANY': '3479',
 'NETBIOS:AUDIT:INV_HDR': '3480',
 'HTTP:MISC:BLUECOAT-HOST-HDR-OF': '3481',
 'SPYWARE:TROJAN:BACKORIFICE2006': '3482',
 'SPYWARE:AD:YOURPRIVACYGUARD': '3483',
 'SPYWARE:KL:DREAMSCAPEKEYLOGGER': '3484',
 'HTTP:BADBLUE:INVALID-GET-DOS': '3485',
 'APP:RH-ICOMMERCE-ANYFILE': '3486',
 'HTTP:EXT:DOT-RPT': '3487',
 'HTTP:WEBLOGIC:WEBROOT': '3488',
 'RPC:AUDIT:GETPORT-FAILED': '3489',
 'VOIP:SIP:LIMITS:FROM-OF': '3490',
 'TCP:OPTERR:BAD-LENGTH': '3491',
 'APP:CA:ARCSRV:UA-OF': '3492',
 'RSH:FAILURE:LOGIN-FAILURE': '3493',
 'APP:AMANDA:AMANDA-ROOT-OF1': '3494',
 'P2P:NAPSTER:LOGIN-7777': '3495',
 'SPYWARE:AD:ZUVIO': '3496',
 'TROJAN:ACKCMD:PROBE': '3497',
 'HTTP:STC:CLSID:ACTIVEX:INC-AX': '3498',
 'SPYWARE:AD:POWERSTRIP': '3499',
 'APP:ITECH-BO': '3500',
 'SPYWARE:RAT:CIA1-3': '3501',
 'SPYWARE:RAT:LAMESPY': '3502',
 'SPYWARE:AD:JILYIETOOLBAR': '3503',
 'HTTP:PKG:NAI-PGP-ADMIN-ACCESS-2': '3504',
 'SMTP:EXPLOIT:HCP-QUOTE-SCRIPT': '3505',
 'HTTP:STC:ACTIVEX:HPSUPPORT': '3506',
 'HTTP:IIS:ENCODING:UNICODE-BP5': '3507',
 'HTTP:PROXY:ANON:PROXY-1': '3508',
 'FTP:OVERFLOW:PATH-TOO-LONG': '3509',
 'TROJAN:TELNET:USER-W00W00': '3510',
 'TFTP:AUDIT:READ-FAILED': '3511',
 'P2P:AUDIT:GNUTELLA-RTABLE-UPD': '3512',
 'SPYWARE:TROJAN:SUNSHADOW-1-70': '3513',
 'HTTP:APACHE:MODPHP-UPLOAD-HOF': '3514',
 'RSH:OVERFLOW:COMMAND': '3515',
 'HTTP:BADBLUE:MFC-ISAPI-CMD-OF': '3516',
 'P2P:MISC:GLUZ': '3517',
 'SPYWARE:RAT:X2A': '3518',
 'ICMP:EXPLOIT:ECHOK': '3519',
 'RTSP:PLAY': '3520',
 'DB:ORACLE:TNS-INTERMEDIA-DOS': '3521',
 'ICMP:EXPLOIT:DIFF-CSUM-IN-RESP': '3522',
 'MS-RPC:MSG-QUEUE-HEAP-OF2': '3523',
 'HTTP:INFO-LEAK:HTPASSWD-REQUEST': '3524',
 'SCAN:MISC:FTP:PATH-LINUX-X86-2': '3525',
 'SMTP:EXCHANGE:MULTI-MAILROUTE': '3526',
 'SMTP:OVERFLOW:SENDMAIL-CMT-OF1': '3527',
 'HTTP:STC:IE:IE7-MHTML': '3528',
 'P2P:WINMX:CLIENT-VER-CHK-DNS': '3529',
 'HTTP:INFO:IDN-HOSTNAME': '3530',
 'SPYWARE:TROJAN:DOWNLOADER.AB': '3531',
 'VOIP:SIP:OVERFLOW:HDR-EXP-OF': '3532',
 'VOIP:SIP:LIMITS:ACC-OF': '3533',
 'TROJAN:MATRIX:SERVER-RES': '3534',
 'HTTP:STC:PPT-HEAP-OF': '3535',
 'HTTP:TUNNEL:CHAT-MSN-IM-SSL': '3536',
 'SMTP:EXT:DOT-WSF': '3537',
 'SPYWARE:RAT:SNID-X2-1-2C-STC': '3538',
 'CHAT:AIM:AIM-HTTP-PROXY': '3539',
 'HTTP:STC:CLSID:REF-37': '3540',
 'NETBIOS:NBDS:EMPTY_UDP_MSG': '3541',
 'HTTP:STC:CLSID:ACTIVEX:AX-134': '3542',
 'SPYWARE:BH:BLUEWAVEADULTLINK-TB': '3543',
 'WORM:NIMDA:EMAIL-PROP': '3544',
 'POP3:OVERFLOW:COMMAND': '3545',
 'SPYWARE:TROJAN:NETWINDOW': '3546',
 'SPYWARE:BH:ABLE2KNOWTOOLBAR': '3547',
 'HTTP:PHP:PHPNUKE:PATH-DISC2': '3548',
 'SYSLOG:AUDIT:INVALID-MONTH': '3549',
 'SPYWARE:TROJAN:BACKLASH': '3550',
 'HTTP:STC:CLSID:ACTIVEX:DLMGR': '3551',
 'P2P:GROKSTER:GROKSTER': '3552',
 'SPYWARE:GM:RELEVANTKNOWLEDGE': '3553',
 'SPYWARE:AD:SHOPNAV': '3554',
 'CHAT:AUDIT:YMSG:FILE-SEND-HTTP': '3555',
 'TROJAN:MISC:OOTLT-COMMAND': '3556',
 'IP:OVERFLOW:OPTIONS': '3557',
 'SCADA:IEC104:SHORT-MSG': '3558',
 'HTTP:PHP:PHPLIB-REMOTE-EXEC': '3559',
 'HTTP:STC:CLSID:ACTIVEX:VANTAGEX': '3560',
 'FINGER:EXPLOIT:NULL-BYTE': '3561',
 'SPYWARE:KL:BEYOND-KEYLOGGER-FTP': '3562',
 'IMAP:OVERFLOW:NETMAIL-OF': '3563',
 'SCAN:MISC:HTTP:WWW-SQL-PROBE': '3564',
 'SPYWARE:AD:TRELLIANTOOLBAR': '3565',
 'VNC:AUDIT:CLIENT-BITPERPIXEL': '3566',
 'DB:ORACLE:SYS-PBSDE-INIT-OF': '3567',
 'LDAP:INVALID:SRCH-TYPEONLY-INV': '3568',
 'SPYWARE:TROJAN:FUCKTROJAN': '3569',
 'VOIP:H225RAS:AUDIT:NO-PROTOID': '3570',
 'DB:ORACLE:TNS-CMD-EXEC': '3571',
 'TROJAN:SHV4-ROOTKIT-HTTP': '3572',
 'SPYWARE:TROJAN:DOWNLOADERDELF': '3573',
 'HTTP:PHP:CACTI-RRD-AUTH-BYPASS': '3574',
 'VNC:OVERFLOW:AUTH-RESPONSE': '3575',
 'SPYWARE:AD:EMPIREPOKER': '3576',
 'HTTP:STC:CLSID:ACTIVEX:YVERINFO': '3577',
 'APP:GAME:STEAM-LOGIN': '3578',
 'SPYWARE:KL:OVERSPY': '3579',
 'HTTP:MISC:LINBIT-LINBOX-BYPASS': '3580',
 'RADIUS:ACCREQ_INV_NUM_ATTRS': '3581',
 'SMB:XTIERRPCPIPE': '3582',
 'TFTP:DIRECTORY:SOLAR-TFTP-TRVRS': '3583',
 'SYSLOG:FORMAT:PRI-TOO-LONG': '3584',
 'NFS:ERR:SHORT-READ': '3585',
 'RADIUS:ACCREP_DISALLOWD_ATTR': '3586',
 'VOIP:MGCP:SDP:INV-ORIGIN': '3587',
 'HTTP:XSS:URL-IMG-XSS': '3588',
 'DNS:AUDIT:RCODE-NAME-ERROR': '3589',
 'DOS:NETDEV:ASCEND-KILL2': '3590',
 'HTTP:STC:CLSID:ACTIVEX:VERI-AX': '3591',
 'HTTP:STC:CLSID:ACTIVEX:AX-13': '3592',
 'DB:ORACLE:TNS-TRACE-OF': '3593',
 'PORTMAPPER:INVALID:BAD-CRED-LEN': '3594',
 'SPYWARE:BH:3SEARCH': '3595',
 'SNMP:ENCODING:IP-TOO-BIG': '3596',
 'VNC:AUDIT:AUTH-FAILED': '3597',
 'SMB:EXPLOIT:GREENAPPLE-3': '3598',
 'SPYWARE:AD:KOOLBAR': '3599',
 'SPYWARE:AD:ZANGO2007TOOLBAR': '3600',
 'FTP:OVERFLOW:ASCII-WRITE': '3601',
 'CHAT:AUDIT:YMSG:CONF-MSG': '3602',
 'SMB:AUDIT:UNEXP-REP': '3603',
 'SMB:OF:MAL-QFILEPATHINFO': '3604',
 'VOIP:SIP:MALFORMED-PORT': '3605',
 'DB:MYSQL:MAXDB-WEBDAV-OF': '3606',
 'HTTP:IIS:DATA-DISCLOSURE': '3607',
 'SPYWARE:KL:COMPUTERMONITOR_1_1': '3608',
 'SPYWARE:KL:NETOBSERVE': '3609',
 'DB:ORACLE:SYS-LT-FINDRICSET': '3610',
 'SMTP:COMMAND:VRFY': '3611',
 'WORM:PHPINCLUDE:SEARCH-REQ': '3612',
 'DNS:AUDIT:RCODE-NOT-IMPL': '3613',
 'SPYWARE:KL:007SPYSOFTWARE-FTP': '3614',
 'HTTP:STC:ACTIVEX:DSPEECH-BO': '3615',
 'VOIP:SIP:LIMITS:ACC-CONTACT-OF': '3616',
 'TROJAN:MISC:HACKWORLD-CMD': '3617',
 'P2P:BITTORRENT:HANDSHAKE': '3618',
 'DB:ORACLE:DEFAULT-PW-OUTLN': '3619',
 'SMTP:INVALID:PARTIAL-MESG': '3620',
 'SMTP:EXPLOIT:SENDMAIL-IDENTEXEC': '3621',
 'VOIP:SIP:LIMITS:CONTENT-LEN-OF': '3622',
 'P2P:MISC:MANOLITO-DOWNLOAD': '3623',
 'HTTP:STC:CLSID:ACTIVEX:AX-42': '3624',
 'SPYWARE:TROJAN:WOLLF': '3625',
 'DB:MYSQL:MAXDB-WEB-OF': '3626',
 'SPYWARE:KL:SPYBUDDY372': '3627',
 'SCAN:MISC:HTTP:HTGROUP-ACCESS': '3628',
 'TROJAN:MISC:FRENZY-COMMAND': '3629',
 'TROJAN:MISC:MOONPIE-FTP-RESP': '3630',
 'NETBIOS:NBDS:INVALID:DGM_LEN': '3631',
 'SMTP:EXT:DOT-MSP': '3632',
 'HTTP:TOMCAT:DIR-TRAV': '3633',
 'HTTP:STC:RESIZE-DOS': '3634',
 'SPYWARE:TROJAN:MESSIAH2-0': '3635',
 'APP:VERITAS:REG-WRITE': '3636',
 'HTTP:STC:CLSID:ACTIVEX:VBTOVSI': '3637',
 'DB:ORACLE:TNS-RDBMS-DOS': '3638',
 'CHAT:AUDIT:YMSG:VALUE': '3639',
 'IDENT:OVERFLOW:REPLY': '3640',
 'HTTP:COLDFUSION:ADMIN-PROBE': '3641',
 'SMTP:SPAM-ASSN-INJ': '3642',
 'CHAT:GADU-GADU:BANNER': '3643',
 'HTTP:STREAM:QUICKTIME-CLIENT': '3644',
 'WORM:SLAPPER:AION-INFECT': '3645',
 'PORTMAPPER:ERR:SHORT-READ': '3646',
 'FINGER:DOS:BOMB': '3647',
 'DB:ORACLE:DEFAULT-PW-SYSTEM': '3648',
 'SCADA:IEC104:TYPE-I': '3649',
 'HTTP:STC:ACTIVEX:HTMLSAFHLP': '3650',
 'SPYWARE:KL:EMAILSPYMONITOR_6_9': '3651',
 'SNMP:DOS:WIN-DEL': '3652',
 'HTTP:REQERR:DOUBLE-ENCODE': '3653',
 'HTTP:STC:CLSID:ACTIVEX:NESSCAN': '3654',
 'HTTP:PHP:GLOBALS-INJ': '3655',
 'SMTP:RESPONSE:RLY-PBTED': '3656',
 'DNS:FAILURE:RCODE_NOTAUTH': '3657',
 'SPYWARE:RAT:THEEF-2.0-CGI': '3658',
 'SCADA:ICCP:WRONG-DT-PARAMETER': '3659',
 'VOIP:SIP:LIMITS:RETRY-AFTER-OF': '3660',
 'HTTP:INFO:FACEBOOK': '3661',
 'SMTP:EXT:DOT-WMF': '3662',
 'HTTP:STC:IE:MSRAT-NAME-OF-SVR2': '3663',
 'HTTP:REQERR:REQ-MISSING-HOST': '3664',
 'HTTP:STC:OLE-SHELL': '3665',
 'RSYNC:CHUNK-OF': '3666',
 'HTTP:CGI:CHETCPASSWD-OF': '3667',
 'FTP:FILE:FTP-PUT-AUTOEXECBAT': '3668',
 'MS-RPC:INDX-SVC-ACTIVE': '3669',
 'LDAP:EMPTY:MODREQ-ATTRIB-EMPTY': '3670',
 'SMTP:EMAIL:RCPT-TO-PIPE': '3671',
 'HTTP:PHP:FILE-INCL-DL': '3672',
 'SPYWARE:BH:PEOPLE_PAL_6_6': '3673',
 'TROJAN:MISC:CGI-BUINET-SRV-RESP': '3674',
 'IKE:DOS:WIN2K-DOS': '3675',
 'SPYWARE:BH:BLAZEFIND': '3676',
 'SPYWARE:BH:ILOOKUP': '3677',
 'SYSLOG:FORMAT:PRIORITY': '3678',
 'CHAT:AUDIT:YMSG:MESSAGE-RECEIVE': '3679',
 'HTTP:BIGBROTHER:INFO-DISCLOSURE': '3680',
 'SMB:NETBIOS:UNK-SHDR-FLAGS': '3681',
 'SPYWARE:AD:DOWNLOADER-G': '3682',
 'VNC:OVERFLOW:RSN-TOO-LONG': '3683',
 'SPYWARE:TROJAN:ZZMM20': '3684',
 'HTTP:ALTNWADMIN': '3685',
 'MS-RPC:TREND-MICRO-RPC': '3686',
 'WORM:BAGLE:HTTP-BACKDOOR': '3687',
 'HTTP:STC:IE:TITLE-BAR-URI': '3688',
 'VOIP:SIP:AUDIT:INVALID-RCODE': '3689',
 'DHCP:AUDIT:INV-CLI-SRC-PORT': '3690',
 'HTTP:IIS:DIR-LIST-PROBE': '3691',
 'SPYWARE:TROJAN:WEBCENTER': '3692',
 'SPYWARE:RAT:MINICOMMAND203-STC': '3693',
 'SPYWARE:RAT:REMOTECONTROL-17': '3694',
 'HTTP:INFO-LEAK:F-SECURE-MANAGER': '3695',
 'SMTP:OVERFLOW:EMAIL-USERNAME': '3696',
 'SPYWARE:AD:WHENUSAVENOW': '3697',
 'SCAN:MISC:MSTREAM-REP-15104': '3698',
 'SPYWARE:BH:SC-EXPANDSEARCH': '3699',
 'HTTP:STC:MS-RICH-OLE': '3700',
 'HTTP:STC:CLSID:ACTIVEX:INOTES6W': '3701',
 'POP3:REQERR:REQ-SYNTAX-ERROR': '3702',
 'P2P:NAPSTER:DATA-6699': '3703',
 'SPYWARE:TROJAN:GLOBALKILLER-STC': '3704',
 'NETBIOS:NBNS:INVALID:NAME-FLGS': '3705',
 'SPYWARE:BH:SEARCHSQUIRE': '3706',
 'SMB:NTLM-LOGIN-FAILED': '3707',
 'SNMPTRAP:ENCODING:TLEN-TOO-BIG': '3708',
 'RTSP:EXPLOIT:INVALID-PORT': '3709',
 'HTTP:STC:MOZILLA:FIREBURN': '3710',
 'HTTP:STC:CLSID:REF-9': '3711',
 'SPYWARE:TROJAN:VOICESPY': '3712',
 'HTTP:STC:CLSID:ACTIVEX:AX-146': '3713',
 'SMB:INFO:XENIX-CORE': '3714',
 'SPYWARE:AD:EZSEARCHBAR': '3715',
 'SMTP:COMMAND:TURN': '3716',
 'HTTP:STC:CLSID:ACTIVEX:CTX-BO2': '3717',
 'DHCP:REPLY:CLIENT-REPLY': '3718',
 'SPYWARE:KL:WATCHDOG': '3719',
 'SNMPTRAP:INFO:ERR_STAT_2BIG': '3720',
 'IMAP:OVERFLOW:WUIMAPD-PART-OF': '3721',
 'SCAN:II:IIS-ISAPI-ENUM': '3722',
 'SMTP:EXT:DOT-CRT': '3723',
 'SPYWARE:AD:ALTAVISTATOOLBAR': '3724',
 'HTTP:STC:CLSID:REF-27': '3725',
 'TROJAN:PEACOMM-TROJAN': '3726',
 'HTTP:NETSCAPE:WP-VER-DIFF': '3727',
 'SCAN:MISC:HTTP:UNIX-BIN-CHSH': '3728',
 'SPYWARE:RAT:BIONET': '3729',
 'HTTP:3COM:ADMIN-LOGOUT': '3730',
 'VOIP:SIP:AUDIT:TELEPRESENCE': '3731',
 'DNS:AUDIT:TYPE-NON-1035': '3732',
 'HTTP:STC:WGET-REDIRECT': '3733',
 'HTTP:IIS:WEBDAV:MALFORMED-REQ1': '3734',
 'TROJAN:MISC:WARTROJAN-COMMAND': '3735',
 'CHAT:AUDIT:YMSG:BUD-NAME': '3736',
 'HTTP:PHP:FORMMAIL-INCLUDE': '3737',
 'LDAP:SUN-DIR-OF': '3738',
 'TROJAN:MISC:ULTORS-SERV-RESP': '3739',
 'SPYWARE:BH:FFINDER': '3740',
 'APP:SAMBA:ROOT-SYS': '3741',
 'HTTP:STC:STREAM:SWF': '3742',
 'HTTP:IIS:X-SITE-SCRIPT': '3743',
 'DB:INGRES-UUID_FROM_CHAR-OF': '3744',
 'HTTP:PKG:OFFICESCAN-JDKRQNOTIFY': '3745',
 'SCAN:MISC:HTTP:AX-ADMIN-ACCESS': '3746',
 'SPYWARE:UTIL:HIPPYNOTIFY20': '3747',
 'P2P:MISC:HOTLINE': '3748',
 'LPR:OVERFLOW:DFILE': '3749',
 'TROJAN:MISC:MASTERS-COMMAND': '3750',
 'DB:ORACLE:INTERMEDIA-DOS': '3751',
 'HTTP:STC:ACTIVEX:UNCOMMON-AX': '3752',
 'HTTP:WEBLOGIC:BEAPACHE': '3753',
 'HTTP:CGI:ORACLE-WEB-REMOTE-EXEC': '3754',
 'HTTP:CGI:ANYFORM-SEMICOLON': '3755',
 'HTTP:LHTTPD:FCGI-HEADER-OF': '3756',
 'SPYWARE:AD:MALWARE_CRUSH_3_7': '3757',
 'SPYWARE:RAT:BUSCHTROMMEL-ICQ': '3758',
 'IMAP:AUDIT:LOGIN-FAILED': '3759',
 'HTTP:NCSA:NPH-TEST-CGI': '3760',
 'HTTP:OVERFLOW:MONIT-REQ': '3761',
 'WORM:NIMDA:SCRIPTS-CMD': '3762',
 'APP:MISC:KADMIN-4-OF': '3763',
 'HTTP:APACHE:WIN32BATCH': '3764',
 'P2P:MISC:MUTE': '3765',
 'SNMPTRAP:ENCODING:IP-TOO-BIG': '3766',
 'SPYWARE:AD:MAXSEARCH': '3767',
 'DB:ORACLE:EMANAGEMENT-BOF': '3768',
 'HTTP:STC:CLSID:ACTIVEX:VS05-INJ': '3769',
 'NTP:ERROR:SERVER_SYNCH_ALARM': '3770',
 'SMTP:OVERFLOW:TOO-MANY-RCPT': '3771',
 'HTTP:CISCO:VOIP:PORT-INFO-DOS': '3772',
 'CHAT:GADU-GADU:CLIENT-REQ': '3773',
 'APP:GAME:STARDOCK-IMPULSE': '3774',
 'SPYWARE:KL:ESURVEILLER': '3775',
 'VOIP:H225SGN:SETUP-NOGRANT-PORT': '3776',
 'TCP:C2S:EXPLOIT:URG-WO-FLG': '3777',
 'DNS:OVERFLOW:OVERSIZED-UDP-MSG': '3778',
 'DNS:AUDIT:TYPE-UNKNOWN': '3779',
 'HTTP:OVERFLOW:RSA-WEB-OF': '3780',
 'RPC:RPC.STATD:RPC-STATD-OF': '3781',
 'SNMP:COMMUNITY:SURECOM-RTR': '3782',
 'SPYWARE:TROJAN:SNOWDOOR': '3783',
 'SPYWARE:TROJAN:KMSNRAT100': '3784',
 'POP3:ERROR:ILLEGAL_MIME_ENCODE': '3785',
 'SNMP:INFO:ERR_STATUS_WRG_LEN': '3786',
 'APP:CA:ARCSRV:MOBILE-2': '3787',
 'NETBIOS:WINS:UPDATE-OF': '3788',
 'SCAN:MISC:ADMROCKS-UDP': '3789',
 'FTP:EXPLOIT:SYNTAX-ERROR': '3790',
 'VNC:ERR:SVR-CUT-TOO-LONG': '3791',
 'SPYWARE:BH:EZGREETS-TOOLBAR': '3792',
 'HTTP:STREAM:QUICKTIME-FIREFOX': '3793',
 'SSL:INVALID:VALIDITY-FMT': '3794',
 'HTTP:STC:ACTIVEX:HPUPDATE': '3795',
 'SHELLCODE:LINUXX86:GEN-BIN-PKT': '3796',
 'HTTP:STC:DESKTOP-INI-CODE-EXE': '3797',
 'HTTP:INVALID:INVLD-AUTH-CHAR': '3798',
 'DB:ORACLE:MALFORMED-IP': '3799',
 'HTTP:STC:CLSID:REF-40': '3800',
 'HTTP:STC:IMG:WMF-METASPLOIT2': '3801',
 'HTTP:STREAM:GOOGLE-VIDEO': '3802',
 'SPYWARE:RAT:CHARON-1-0-3': '3803',
 'DB:ORACLE:DEFAULT-PW-DBSMNP': '3804',
 'LDAP:OPENLDAP-2.2.23-DOS': '3805',
 'HTTP:UNIX-FILE:ETC-PASSWD': '3806',
 'SPYWARE:TROJAN:PHANTOMFTP': '3807',
 'HTTP:STC:CLSID:ACTIVEX:AX-103': '3808',
 'NFS:ERR:LONG-FILENAME': '3809',
 'SPYWARE:BH:HITHOPPER': '3810',
 'DISCARD:INFO:ASCEND-DISCARD': '3811',
 'SPYWARE:RAT:FERAT1-00-STC': '3812',
 'HTTP:SQL:INJ:SYSOBJECTS': '3813',
 'DNS:TUNNEL:OZYMANDNS': '3814',
 'SMB:FILE:WEB-VIEW-DOC-SCR-INJ': '3815',
 'P2P:BITTORRENT:DOT-TORRENT': '3816',
 'SMB:ERROR:MAL-MSG': '3817',
 'SPYWARE:KL:GURLWATCH': '3818',
 'SPYWARE:TROJAN:DARKMOON-4-11': '3819',
 'FTP:EXPLOIT:BOUNCE-ATTACK': '3820',
 'DB:SAPDB-WEB-OF': '3821',
 'P2P:GNUTELLA:CONNECTION-OK-V06': '3822',
 'SYSLOG:AUDIT:INVALID-DAY': '3823',
 'NETBIOS:NBNS:C2S_AA_FLAG': '3824',
 'HTTP:STC:CLSID:REF-33': '3825',
 'VOIP:SIP:LIMITS:ALLOW-OF': '3826',
 'VNC:OVERFLOW:CLIENT-CUT-TEXT': '3827',
 'FTP:EXPLOIT:ILLEGAL-PORT': '3828',
 'HTTP:PROXY:SQUID-FTP': '3829',
 'SCAN:MISC:FTP:FREEBSD-FTPD-GLOB': '3830',
 'HTTP:STC:CLSID:ACTIVEX:MACRO-AX': '3831',
 'HTTP:STC:IE:CACHE-CLIPDATA': '3832',
 'LPR:AUDIT:CMD': '3833',
 'SPYWARE:RAT:NCPH': '3834',
 'HTTP:INVALID:VAR-NEG-LG': '3835',
 'SPYWARE:RAT:LANFILTRATOR1-1-STC': '3836',
 'TROJAN:MISC:HOSTCONTROL-RESP': '3837',
 'SPYWARE:TROJAN:DW-ARQ-2': '3838',
 'HTTP:STC:IMG:OVERLARGE-BMP': '3839',
 'TELNET:EXPLOIT:LD-LIBRARY-PATH': '3840',
 'FTP:PASSWORD:USER-DICT': '3841',
 'SMTP:OVERFLOW:MHTML-OF': '3842',
 'MS-RPC:WRKST-DOS': '3843',
 'WORM:SQL-SNAKE:MSSQL-REG-2': '3844',
 'APP:NOVELL:EDIRECTORY-BOF': '3845',
 'IMAP:EXPLOIT:CMD-DIR-TRSVR': '3846',
 'SCADA:MODBUS:CLEAR': '3847',
 'APP:NOVELL:MESSENGER-HOF': '3848',
 'SPYWARE:TROJAN:PSEUDORAT01B': '3849',
 'SPYWARE:AD:OFFEROPTIMIZER': '3850',
 'SCAN:CORE:MSRPC-WKSSVC': '3851',
 'SCAN:MISC:HTTP:VTI-BIN-PROBE': '3852',
 'IKE:DOS:ISAKMP-DOS-2': '3853',
 'TROJAN:MISC:WANREMOTE-ADMIN': '3854',
 'POP3:OUTLOOK:MULTIPLE-FROM': '3855',
 'HTTP:COLDFUSION:APPLICATION-CFM': '3856',
 'TELNET:USER:DEFAULT-PW-4': '3857',
 'SPYWARE:RAT:SUPERSPY': '3858',
 'FINGER:BACKDOOR:CMD-ROOTSH': '3859',
 'HTTP:NOVELL:NETWARE-CONVERT.BAS': '3860',
 'SCAN:METASPLOIT:APACHE-CHUNK-OF': '3861',
 'POP3:ERROR:ILLEGAL_ENCODE': '3862',
 'HTTP:FRONTPAGE:RAD-OVERFLOW': '3863',
 'RTSP:REALSERVER:REAL-SETUP-OF4': '3864',
 'HTTP:REQERR:DOUBLE-CONTENT': '3865',
 'SPYWARE:TROJAN:X-DOOR': '3866',
 'TCP:C2S:FLAGSERROR:DIRTY-SYN': '3867',
 'HTTP:IIS:LOCALHOST-SPOOF': '3868',
 'SMTP:OUTLOOK:HTML-NAME-OF': '3869',
 'SPYWARE:AD:PACIMEDIA': '3870',
 'HTTP:IIS:ENCODING:SINGLE-DIG-1': '3871',
 'HTTP:STC:CLSID:ACTIVEX:WSH': '3872',
 'SCAN:MISC:HTTP:SYNTXCHK-PROBE': '3873',
 'VNC:ERR:BRUTE-FORCE': '3874',
 'LDAP:OVERFLOW:ENCODING-INT-OF': '3875',
 'TELNET:FAILURE:BRUTE-FORCE': '3876',
 'APP:CA:ALERT-SRV-OF': '3877',
 'HTTP:STC:IE:MSRAT-NAME-OF': '3878',
 'SPYWARE:BH:LOOKTHRUBAR': '3879',
 'HTTP:STC:CLSID:ACTIVEX:AX-113': '3880',
 'FINGER:REQERR:UNEXP-LINE': '3881',
 'HTTP:PHP:LOKWABB-PRIVM2': '3882',
 'SNMPTRAP:COMMUNITY:NULL-CHAR': '3883',
 'SPYWARE:AD:ZANGOTOOLBAR': '3884',
 'APP:NOVELL:NMAP-NETMAIL-STOR': '3885',
 'DB:ORACLE:EXCLUSION-BYPASS': '3886',
 'HTTP:INFO-LEAK:HTACCESS': '3887',
 'SCAN:MISC:HTTP:TEST-PROBE': '3888',
 'SSL:IIS:SSL-CPHR-EXPL': '3889',
 'DB:DB2:XML-QUERY-OF': '3890',
 'CHAT:AUDIT:YMSG:COOKIE': '3891',
 'HTTP:STC:MOZILLA:FIREFLASH': '3892',
 'APP:KERBEROS:DBLFREE-2': '3893',
 'HTTP:IIS:ISM.DLL-FILENAME': '3894',
 'HTTP:PHP:YABBSE-SSI-INCLUDE': '3895',
 'HTTP:STC:SAFARI:MAL-REGEX': '3896',
 'SPYWARE:RAT:NETTHIEF': '3897',
 'HTTP:IIS:WEBDAV:MALFORMED-REQ2': '3898',
 'HTTP:IIS:ASP-SOURCECODE-DISCLSR': '3899',
 'SMTP:INVALID:2MANY-BOUNDARY': '3900',
 'FINGER:OVERFLOW:LINE': '3901',
 'HTTP:STC:IE:CENROLL': '3902',
 'HTTP:CISCO:WIFI-AUTH-DOS': '3903',
 'HTTP:STC:ACTIVEX:VISBASIC6-AX-5': '3904',
 'RUSERS:ERR:LARGE-CRED': '3905',
 'APP:AI:PROTOCOL-MISMATCH': '3906',
 'HTTP:STC:CLSID:ACTIVEX:IP-AX': '3907',
 'SPYWARE:AD:GABESTMEDIAPLAYER': '3908',
 'HTTP:SQL:INJ:WP-SQL': '3909',
 'TROJAN:GATECRASHER:SERVER-RES': '3910',
 'APP:CA:ARCSRV:RPC-TAPE-ENG': '3911',
 'HTTP:IIS:COLDFUSION-INFOLEAK': '3912',
 'APP:ARKEIA:TYPE-77-OF': '3913',
 'NNTP:OVERFLOW:NNTP-XHDR': '3914',
 'HTTP:STC:CLSID:ACTIVEX:AX-64': '3915',
 'SPYWARE:DIALER:STRIPPLAYER': '3916',
 'VOIP:SIP:HEADER-UFLOW': '3917',
 'HTTP:UNIX-CMD:SBIN-HALT': '3918',
 'SHELLCODE:X86:SETGID-0-TCP': '3919',
 'TROJAN:MISC:PSYCHWARD-SRV-RESP': '3920',
 'CHAT:AUDIT:MSN:MSG-2LONG': '3921',
 'DNS:OVERFLOW:TCP-RESPONSE': '3922',
 'SMTP:EXT:DOT-386': '3923',
 'SPYWARE:BP:WILDTANGENT': '3924',
 'P2P:MISC:MEDIASEEK-PL-CLIENT': '3925',
 'HTTP:STC:OUTLOOK:WABFILE-STC': '3926',
 'POP3:EXT:DOT-MDB': '3927',
 'HTTP:STC:ACTIVEX:ADDCOLUMN': '3928',
 'TROJAN:SUBSEVEN:SUBSEVEN': '3929',
 'SPYWARE:RAT:KATUX2-0-SERVER': '3930',
 'HTTP:STC:CLSID:ACTIVEX:AX-34': '3931',
 'HTTP:WIN-CMD:ROOT.EXE': '3932',
 'FTP:LUKEMFTP:URG-RELOGIN': '3933',
 'IMAP:OVERFLOW:LIST-OF': '3934',
 'SPYWARE:RAT:A-311DEATH': '3935',
 'HTTP:INFO-LEAK:JSP-SRC': '3936',
 'NFS:AUDIT:INVALID-XID': '3937',
 'SCAN:AMAP:SAP-R3-ON-SMTP': '3938',
 'HTTP:CGI:ALTAVISTA-TRAVERSAL': '3939',
 'VOIP:SIP:AUDIT:BAD-IPV4': '3940',
 'CHAT:AUDIT:YMSG:MAIL-SUBJECT': '3941',
 'SMTP:AUDIT:REP-INVALID-REPLY': '3942',
 'APP:NOVELL:GROUPWISE-WA': '3943',
 'DB:MS-SQL:MSSQL-LGN-BRUTE-FORCE': '3944',
 'SHELLCODE:SGI:GEN-1-TCP': '3945',
 'SHELLCODE:X86:DECODER-1': '3946',
 'SPYWARE:AD:YELLOWBRIDGETOOLBAR': '3947',
 'P2P:MISC:APPLEJUICE': '3948',
 'TROJAN:MISC:EXPLOITER-SRV-RESP': '3949',
 'DB:ORACLE:CTXSYS-DRILOAD': '3950',
 'NETBIOS:DOS:RFPOISON': '3951',
 'DB:ORACLE:DEFAULT-PW-AURORA': '3952',
 'P2P:AUDIT:GNUTELLA-QUERY': '3953',
 'RPC:FAILURE:UNSET-FAILED': '3954',
 'TROJAN:MISC:BUTTMAN-COMMAND': '3955',
 'SHELLCODE:SPARC:SETUID-0-TCP': '3956',
 'HTTP:STC:IE:OBJECT-OF': '3957',
 'TCP:AUDIT:S2C-FUTURE-ACK': '3958',
 'VNC:INVALID:SERVER-RESPONSE': '3959',
 'NETBIOS:NBNS:RESCODE:REFUSED': '3960',
 'SCAN:METASPLOIT:SMB-ACTIVE': '3961',
 'TCP:AUDIT:S2C-PART-OUT-OF-WIN': '3962',
 'HTTP:STC:CLSID:ACTIVEX:DATUPLE': '3963',
 'SPYWARE:AD:KAZOOM': '3964',
 'SPYWARE:AD:VIRUSPROTECTPRO37': '3965',
 'CHAT:AIM:OVERFLOW:AWAY-FS': '3966',
 'HTTP:STC:CLSID:ACTIVEX:AX-88': '3967',
 'TROJAN:BACKDOOR:BANNER': '3968',
 'HTTP:STC:CLSID:ACTIVEX:DXSDK': '3969',
 'IDENT:GEWSE-FLOOD': '3970',
 'LDAP:EMPTY:SRCHREQ_FTR_NULL': '3971',
 'NETBIOS:DIR:CD-DOTDOTDOT': '3972',
 'SPYWARE:AD:FREEWAREFILEBAR': '3973',
 'HTTP:3COM:3COM-PASS-LEAK': '3974',
 'HTTP:PHP:MIDICART-DB': '3975',
 'SHELLCODE:DIGITAL:NOOP-PKT': '3976',
 'SNMP:AUDIT:SET-REQUEST': '3977',
 'NNTP:NN:NN-FMTSTR1': '3978',
 'DOS:WINDOWS:WINNUKE-NETBIOS': '3979',
 'SHELLCODE:SPARC:NOOP-RVRS-PKT': '3980',
 'POP3:EXT:DOT-386': '3981',
 'SCAN:MISC:HTTP:MAILLIST-PROBE': '3982',
 'HTTP:PHP:LOKWABB-PRIVM3': '3983',
 'DHCP:OPT:IFMTU-TOO-SMALL': '3984',
 'NFS:OVERFLOW:LINUX-ACL-OF-DOS': '3985',
 'RSYNC:EXCLUDE-OF': '3986',
 'CHAT:IRC:OVERFLOW:NUM-REPLY': '3987',
 'HTTP:NETSCAPE:WP-UNCHECKOUT': '3988',
 'TROJAN:MISC:NIRVANA-COMMAND': '3989',
 'SHELLCODE:SPARC:GEN-2-TCP': '3990',
 'CHAT:AUDIT:MSN:PHONE-NUM': '3991',
 'NETBIOS:NBNS:RESCODE:CONFLICT': '3992',
 'TROJAN:MISC:RUX-COMMAND': '3993',
 'SCAN:MISC:HTTP:CODE-ACCESS': '3994',
 'NETBIOS:NBDS:INVALID:PROTO': '3995',
 'HTTP:OVERFLOW:CHUNK-LEN-OFLOW': '3996',
 'SMB:NETBIOS:INV-CDNAME-LEN': '3997',
 'SPYWARE:RAT:LANFILTRATOR-SIN': '3998',
 'SPYWARE:BH:RX-TOOLBAR': '3999',
 'HTTP:STC:CLSID:ACTIVEX:KASP-AX2': '4000',
 'SCAN:MISC:HTTP:IFRAME-DOS': '4001',
 'HTTP:STC:CLSID:ACTIVEX:AX-53': '4002',
 'HTTP:STC:CLSID:REF-15': '4003',
 'HTTP:STC:CLSID:ACTIVEX:DA-2': '4004',
 'NFS:ERR:LONG-PATHNAME': '4005',
 'HTTP:CGI:MONALBUM-INFO': '4006',
 'SPYWARE:BH:LOOSKY-GEN': '4007',
 'SMTP:MAL:ANI-ATTACH': '4008',
 'TFTP:MSG-TOO-LONG': '4009',
 'SPYWARE:BH:GRALICWRAP': '4010',
 'SPYWARE:AD:ZQUEST': '4011',
 'HTTP:WEBPLUS:VIEW-SOURCE': '4012',
 'POP3:OVERFLOW:BSD-OFLOW-1': '4013',
 'HTTP:STC:CLSID:ACTIVEX:AX-28': '4014',
 'DNS:BIND-NXT-OVERFLOW4': '4015',
 'WORM:SQL-SNAKE:MSSQL-REG-3': '4016',
 'FINGER:EXPLOIT:PIPE': '4017',
 'TROJAN:MISC:BREACH-SRV-RESP': '4018',
 'SCADA:IEC104:TYPE-S': '4019',
 'LPR:OVERFLOW:C-LENGTH': '4020',
 'SPYWARE:BH:ADTRAFFIC': '4021',
 'P2P:GNUTELLA:URN-DOWNLOAD-REQ': '4022',
 'RPC:XDR-INTEGER-OVERFLOW': '4023',
 'SNMP:INFO:ERROR_STATUS_GEN_ERR': '4024',
 'HTTP:STC:CLSID:ACTIVEX:AX-131': '4025',
 'SPYWARE:AD:SUNSHINESPY_1_0': '4026',
 'SPYWARE:AD:INSTANTBUZZ': '4027',
 'SPYWARE:AD:ZIPITFAST': '4028',
 'APP:NOVELL:ZENWORK-CONTENT-LEN': '4029',
 'WORM:CODERED-2:INFECT-ATTEMPT': '4030',
 'HTTP:REQERR:URL-VAR-FS': '4031',
 'TELNET:CMD:HALT': '4032',
 'FTP:USER:ANONYMOUS': '4033',
 'HTTP:PHP:FORMMAIL-SCRIPTROOT': '4034',
 'HTTP:STC:CLSID:ACTIVEX:SYM-FWAX': '4035',
 'SPYWARE:TROJAN:SHARK232': '4036',
 'TCP:AUDIT:C2S-CLOSED-ACK': '4037',
 'DB:MYSQL:CREATE-FUNCTION': '4038',
 'HTTP:INFO-LEAK:JBOSS-JSP-SRC': '4039',
 'HTTP:VLCFS': '4040',
 'APP:GAME:UT3-QUERY': '4041',
 'TROJAN:MISC:WINRAT12-TCP': '4042',
 'VOIP:SIP:SDP:HEADER-ORD-ERR': '4043',
 'SPYWARE:KL:SYSTEMSURVEILLANCE': '4044',
 'HTTP:STC:CLSID:ACTIVEX:MS-MDAC': '4045',
 'HTTP:STC:IMG:NOT-BMP': '4046',
 'HTTP:OVERFLOW:JANASRV-VER-OF': '4047',
 'DB:ORACLE:DEFAULT-PW-MDSYS': '4048',
 'SNMPTRAP:AUDIT:PROXY-AGENT': '4049',
 'SPYWARE:KL:ELITEKEYLOGGER': '4050',
 'SPYWARE:RAT:COMA-STC': '4051',
 'HTTP:STC:CLSID:ACTIVEX:AX-60': '4052',
 'LDAP:INVALID:REQTYPE_INVALID': '4053',
 'HTTP:STC:MPG123-STEREO-OF': '4054',
 'SPYWARE:RAT:SPECREM6-2-STC': '4055',
 'NETBIOS:NBNS:RESCODE:SVR_FAIL': '4056',
 'P2P:EDONKEY:S2C-PONG-RESPONSE': '4057',
 'HTTP:STC:CLSID:ACTIVEX:AX-91': '4058',
 'TROJAN:MISC:NETRAIDER-SRV-RESP': '4059',
 'SMTP:SENDMAIL:ADDR-PRESCAN-ATK': '4060',
 'TCP:ERROR:FLOW-MEMORY-OVERFLOW': '4061',
 'SPYWARE:BH:BAZOOKABAR': '4062',
 'HTTP:STC:CLSID:ACTIVEX:AX-140': '4063',
 'HTTP:STC:CLSID:REF-41': '4064',
 'SCAN:MISC:HTTP:ADMIN': '4065',
 'DNS:FAILURE:RCODE_NOTZONE': '4066',
 'SPYWARE:TROJAN:HRAT': '4067',
 'RADIUS:INVALID_MSG_LENGTH': '4068',
 'SCAN:AUDIT:NBSTAT-QUERY': '4069',
 'WORM:NIMDA:NIMDA-RICHED20': '4070',
 'SPYWARE:TROJAN:OLELOA.GEN': '4071',
 'SMB:AUDIT:OLD-VERSION': '4072',
 'SPYWARE:TROJAN:ABWIZ-C': '4073',
 'P2P:BITTORRENT:CONTENT-TYPE': '4074',
 'HTTP:STC:IE:GOPHER-IMGTAG': '4075',
 'HTTP:STC:IE:LOCAL-WEB-FOLDER': '4076',
 'VOIP:MGCP:UTF8-ERROR': '4077',
 'HTTP:DOMINO:POST-DOS1': '4078',
 'SMB:OF:NETCONMGR-DOS': '4079',
 'HTTP:AUDIT:INV-HTTP-VER': '4080',
 'APP:SAP:IGS-OF': '4081',
 'DB:ORACLE:DEFAULT-PW-ORDSYS': '4082',
 'HTTP:STC:IE:WMP-FILE-MANIP': '4083',
 'HTTP:CGI:ADS-CGI-REMOTE-EXEC': '4084',
 'SNMP:AUDIT:PUBLIC': '4085',
 'WORM:PHPINCLUDE:EXPLOIT': '4086',
 'HTTP:STC:CLSID:ACTIVEX:AX-123': '4087',
 'SMTP:MAL:DATA-SCHEME': '4088',
 'SPYWARE:RAT:HORNET': '4089',
 'SCAN:MISC:HTTP:DIR-LISTING': '4090',
 'FTP:AUDIT:REP-NESTED-REPLY': '4091',
 'SCAN:SATAN:FTP-SCAN': '4092',
 'APP:REAL:SERVER-DOS': '4093',
 'SCAN:CANVAS:NETWORKER-3': '4094',
 'SMTP:SAGTUBE-DOS': '4095',
 'HTTP:IIS:MALFORMED-HTR-REQUEST': '4096',
 'HTTP:STC:CLSID:ACTIVEX:AX-121': '4097',
 'NTP:ERROR:CTL_INV_CLKSTATUS': '4098',
 'SHELLCODE:X86:GEN-1-TCP': '4099',
 'HTTP:SQL:INJ:COMPARISON': '4100',
 'POP3:EXT:DOT-WSF': '4101',
 'SPYWARE:AD:HXDL': '4102',
 'SNMP:INFO:ERR_STAT_INCON_VAL': '4103',
 'SPYWARE:TROJAN:MOSUCKER3-0': '4104',
 'CHAT:JABBER:UNAME-OF': '4105',
 'RPC:RPC.MOUNTD:SHOWMOUNT-UDP': '4106',
 'SPYWARE:GM:VMNTOOLBAR16': '4107',
 'HTTP:STC:PPT-SCRIPT': '4108',
 'HTTP:STC:FF-NAV-URI': '4109',
 'IKE:DOS:TCPDUMP-ID-UNDERFLOW': '4110',
 'RSH:USER:USER-BIN': '4111',
 'SMB:TRANS2ROOT-OF': '4112',
 'DOS:NETDEV:CATALYST-SSH-DOS': '4113',
 'SCAN:MISC:HTTP:ADMIN-NSF-ACCESS': '4114',
 'DNS:AUDIT:REP-MISMATCHING-QD': '4115',
 'VOIP:SIP:LIMITS:CALL-INFO-OF': '4116',
 'HTTP:OVERFLOW:ACROBATX-NULL': '4117',
 'VOIP:SIP:AUDIT:DUPLICATE-HEADER': '4118',
 'HTTP:CGI:SOJOURN-FILE-VIEW': '4119',
 'DNS:AUDIT:CLASS-NON-IN': '4120',
 'SPYWARE:RAT:MITHRIL-1-45': '4121',
 'ICMP:EXPLOIT:FLOOD': '4122',
 'NETBIOS:NBDS:SHORT_MSG': '4123',
 'APP:UPNP:APPLE-MDNS': '4124',
 'VNC:OVERFLOW:CLIENT-INIT': '4125',
 'TELNET:AUDIT:USER': '4126',
 'APP:VERITAS:NB-VMD-OF': '4127',
 'SPYWARE:AD:7FASST': '4128',
 'TROJAN:MISC:UDP-BACKDOOR': '4129',
 'P2P:NAPSTER:SERVER-LOGIN': '4130',
 'APP:ARKEIA:DEFAULT-ADMIN-PW': '4131',
 'SMTP:EXT:DOT-JOB': '4132',
 'HTTP:STC:CLSID:ACTIVEX:AX-44': '4133',
 'SMTP:OUTLOOK:OSS-FILE': '4134',
 'TROJAN:MISC:BLADERUNNER-RESP': '4135',
 'HTTP:CGI:FAXSURVEY-REMOTE-EXEC': '4136',
 'IMAP:OVERFLOW:OL-IFRAME-EXEC': '4137',
 'TROJAN:MISC:HELLZ-SRV-RESP': '4138',
 'SCAN:MISC:HTTP:WIN-TFTP-EXE': '4139',
 'SMB:EXPLOIT:ISS-ACCOUNTNAME-OF': '4140',
 'HTTP:STC:CLSID:ACTIVEX:ACF': '4141',
 'HTTP:STC:ADOBE:FLATEDECODE': '4142',
 'SPYWARE:AD:MOKEAD': '4143',
 'SMTP:OUTLOOK:TNEF-INT-OF': '4144',
 'CHAT:AUDIT:YMSG:BUD-LST': '4145',
 'ICMP:INFO:TIMESTAMP': '4146',
 'SPYWARE:KL:SYSTEMSLEUTH': '4147',
 'FTP:REQERR:GNULS-WIDTH-DOS': '4148',
 'SPYWARE:TROJAN:RAD1-2-3': '4149',
 'MS-RPC:SPOOLER-OF': '4150',
 'TROJAN:MISC:GHOST-SRV-RESP': '4151',
 'SHELLCODE:SPARC:NOOP-PKT': '4152',
 'SHELLCODE:SGI:GEN-2-TCP': '4153',
 'VOIP:SIP:KEEP-ALIVE-3': '4154',
 'OS:LINUXX86:MOUNTD-OF-3': '4155',
 'RTSP:REALSERVER:REAL-SETUP-OF2': '4156',
 'ICMP:EXPLOIT:DIFF-CSUM-IN-RESND': '4157',
 'SCAN:NETECT:SMTP': '4158',
 'POP3:REQERR:REQ-BINARY-DATA': '4159',
 'SHELLCODE:LINUXX86:GEN-1-PKT': '4160',
 'LDAP:SIDVAULT-DOS': '4161',
 'MS-RPC:ERR:EPM-WRONG-LHS-LEN': '4162',
 'TROJAN:BACKORIFICE:BO2K-CONNECT': '4163',
 'HTTP:IIS:IISCHECK-PROBE': '4164',
 'HTTP:NOVELL:GROUPWISE-GWWEB-DOS': '4165',
 'LPR:AUDIT:C-CMD': '4166',
 'POP3:OVERFLOW:PASS': '4167',
 'HTTP:DAVREDIR': '4168',
 'HTTP:EXT:DOT-JOB': '4169',
 'HTTP:MISC:NOOP-SLIDE-REQ-OF': '4170',
 'SPYWARE:TROJAN:TRAILOFDESTRUC20': '4171',
 'SMB:AUDIT:NULL-DOMAIN': '4172',
 'LDAP:INVALID:MODDNREQ-ENTRY-INV': '4173',
 'RPC:RPC.STATD:STATD-FMT-STR4': '4174',
 'CHAT:AUDIT:YMSG:OFLOW-GRP-NAME': '4175',
 'IP:OPTERR:INVALID-INFRAGMENT': '4176',
 'HTTP:STC:CLSID:ACTIVEX:AOL-AX': '4177',
 'TROJAN:MISC:PROJNEXT-SERV-RESP': '4178',
 'APP:HPOVNNM:OVALARMSRV-FMT-STR': '4179',
 'SMTP:COMMAND:HELP': '4180',
 'TROJAN:QAZ:CLIENT-LOGIN': '4181',
 'CHAT:GOOGLE:GTALK-PHONE-SESSION': '4182',
 'MS-RPC:SPOOLSS-BOF': '4183',
 'MS-RPC:ERR:EPM-INV-RHS-LEN': '4184',
 'HTTP:STC:ACTIVEX:VISBASIC6-AX-1': '4185',
 'SNMPTRAP:INFO:STAT_UNDO_FAIL': '4186',
 'HTTP:STC:ACTIVEX:HP-DATAMGR': '4187',
 'HTTP:STC:IMG:MALFORMED-JPEG': '4188',
 'LDAP:EMPTY:ATTRIBDESC_EMPTY': '4189',
 'SPYWARE:AD:CUSTOMTOOLBAR': '4190',
 'SPYWARE:AD:EXACTNAVISEARCH': '4191',
 'APP:ORACLE:WEBCACHE-INSECURE': '4192',
 'HTTP:IIS:ASPX-URL': '4193',
 'HTTP:XSS:IE-DHTML-EDIT': '4194',
 'SPYWARE:BH:FINDTHEWEBSITE': '4195',
 'HTTP:STC:CLSID:ACTIVEX:VMWARE': '4196',
 'SPYWARE:TROJAN:REVOPA': '4197',
 'SCAN:MISC:TELNET:CISCO': '4198',
 'DDOS:SHAFT:AGENT-TO-HANDLER': '4199',
 'RSH:AUDIT:PARAM-OK': '4200',
 'HTTP:STC:ACTIVEX:IBM-AS': '4201',
 'CHAT:AUDIT:YMSG:OFLOW-URL': '4202',
 'DOS:UPNP-CHARGEN-DOS': '4203',
 'APP:CA:LIC-COMMAND-OF': '4204',
 'TROJAN:BACKORIFICE:BOPING': '4205',
 'VIRUS:SMTP:SMTP-ZONEALARM-EXE': '4206',
 'HTTP:STC:IE:UTF8-DECODE-OF': '4207',
 'DB:ORACLE:DEFAULT-PW-ORDCOMMON': '4208',
 'HTTP:STC:WINAMP:CDDA-OF2': '4209',
 'TROJAN:DPTHRT:REQUEST': '4210',
 'SPYWARE:BH:RABIO42': '4211',
 'SHELLCODE:SPARC:GEN-2-PKT': '4212',
 'HTTP:STC:CLSID:REF-5': '4213',
 'HTTP:STC:IMG:EMF-DOWNLOAD': '4214',
 'SHELLCODE:SGI:GEN-BIN-PKT': '4215',
 'HTTP:OVERFLOW:TRANSFER-ENCODING': '4216',
 'HTTP:CGI:SUNPS-IRUNBOOK': '4217',
 'DHCP:OPT:INV-NB-NODE-TYPE': '4218',
 'RADIUS:MALFORMED_VENDOR_ATTR': '4219',
 'APP:TUN:GRE-TUNNEL': '4220',
 'APP:PPTP:POPTOP-NEG-READ': '4221',
 'FTP:SERVU:LIST-OVERFLOW': '4222',
 'APP:GAUNTLET:GAUNTLET-URL-OF': '4223',
 'TROJAN:NETBUS:CLT-GETINFO-12346': '4224',
 'SCADA:MODBUS:READ': '4225',
 'SNMP:ENCODING:GAUGE-TOO-BIG': '4226',
 'LPR:OVERFLOW:C-USER': '4227',
 'SMTP:EXT:DOT-OCX': '4228',
 'VOIP:SKYPE:INSTALL': '4229',
 'SPYWARE:AD:ZAPSPOT': '4230',
 'VOIP:SIP:BIN-IN-AUTH-RESP': '4231',
 'VOIP:SIP:AUDIT:NOT-SIP': '4232',
 'DB:ORACLE:DBMS-EXP-EXT-INJ': '4233',
 'TROJAN:MISC:CAFEINI-SERV-RESP': '4234',
 'TROJAN:MISC:BLAAAAA-CLIENT-REQ': '4235',
 'FINGER:USER:SEARCH': '4236',
 'CHAT:MSN:MESG-RECV': '4237',
 'HTTP:INFO-LEAK:VIGNETTE-LEAK-2': '4238',
 'SPYWARE:TROJAN:REMOTEHACK': '4239',
 'VOIP:SIP:AUDIT:INVALID-HEX-HIGH': '4240',
 'HTTP:STC:CLSID:ACTIVEX:AX-145': '4241',
 'SPYWARE:AD:GATORWEBSECUREALERT': '4242',
 'POP3:AUDIT:REQ-NESTED-REQUEST': '4243',
 'NETBIOS:NBNS:INVALID:PTR': '4244',
 'SCAN:MISC:HTTP:WS-FTP-INI-ATMPT': '4245',
 'SPYWARE:RAT:REMOTEHAVOC': '4246',
 'IMAP:AUDIT:REQ-INVALID-STATE': '4247',
 'TELNET:SVRRESP:MS-CLIENT-INFO': '4248',
 'DNS:AUDIT:REP-S2C-QUERY': '4249',
 'WORM:SLAMMER:INFECT-ATTEMPT': '4250',
 'SPYWARE:RAT:CD-ROMTROJAN': '4251',
 'HTTP:STC:WINHELP32-OF2': '4252',
 'TELNET:CMD:CAT-ETC-PASSWD': '4253',
 'LDAP:EMPTY:SRCH_FILTER_EMPTY': '4254',
 'HTTP:STC:CLSID:ACTIVEX:SONY-XCP': '4255',
 'FINGER:USER:SLASH-FILE': '4256',
 'HTTP:PHP:GALLERY:MAL-INCLUDE': '4257',
 'SPYWARE:AD:WINFIXER2005': '4258',
 'SPYWARE:KL:ARDAMAXKLOGGER28': '4259',
 'HTTP:STC:ACTIVEX:HXVZ': '4260',
 'SNMP:RESPONSE:READ-ONLY': '4261',
 'SNMPTRAP:ENCODING:OVAL-TOO-BIG': '4262',
 'HTTP:STC:OPERA:DL-SPOOF': '4263',
 'HTTP:STC:IE:VML-NUM-BOF': '4264',
 'SSL:UNK-HANDSHAKE-TYPE': '4265',
 'CHAT:AUDIT:YMSG:MAIL-ADDR': '4266',
 'WORM:SLAPPER:C-INFECT': '4267',
 'SPYWARE:DM:SLINKYSLATETOOLBAR': '4268',
 'SPYWARE:BH:YOKSUPERSEARCH': '4269',
 'SMB:EXPLOIT:FOLDER-COM-EXEC': '4270',
 'P2P:GNUTELLA:UDP-TRAFFIC': '4271',
 'HTTP:STC:ACTIVEX:INSTALLSHIELD': '4272',
 'APP:IBM:TSM-NODE-NAME-OF': '4273',
 'SPYWARE:RAT:HORNET-NOTIFY': '4274',
 'DB:ORACLE:INSECURE-TNS-LISTENER': '4275',
 'SCAN:SENTINEL:TELNET-SPOOF': '4276',
 'TFTP:AUDIT:C2S-UNEXP-DATA': '4277',
 'HTTP:STC:IMG:WMF-MALFORMED': '4278',
 'IMAP:OVERFLOW:COMMAND': '4279',
 'POP3:AUDIT:EMPTY-BOUNDARY': '4280',
 'HTTP:STC:CLSID:ACTIVEX:AX-110': '4281',
 'SPYWARE:TROJAN:TRAFFBEST-BIZ': '4282',
 'SPYWARE:KL:LITTLEWITCHKEYLOGGER': '4283',
 'DB:ORACLE:REPORT-CMD-INJ': '4284',
 'SCAN:MISC:QUERY': '4285',
 'SPYWARE:TROJAN:RADMIN30': '4286',
 'SNMP:ERROR:INVALID_GAUGE_VALUE': '4287',
 'SPYWARE:RAT:AMITIS': '4288',
 'VOIP:SIP:REC-NULL-URI-TO': '4289',
 'NETBIOS:OVERFLOW:ASN1-BER': '4290',
 'APP:EIQ-LM-OF': '4291',
 'RADIUS:ACCCHA_DISALLOWD_ATTR': '4292',
 'SCAN:MISC:TELNET:VI-ETC-PASSWD': '4293',
 'HTTP:OVERFLOW:NULLHTTPD-ROOT-OF': '4294',
 'SCADA:DNP3:NON-DNP3': '4295',
 'SMTP:OUTLOOK:W32-PARAM': '4296',
 'DB:MYSQL:CREATE-TABLE': '4297',
 'SPYWARE:GM:PCAST': '4298',
 'TROJAN:MISC:DRAT-SRV-VERSION': '4299',
 'TROJAN:MISC:MAVERICKS-SRV-RESP': '4300',
 'RPC:RPC.STATD:STATD-FMT-STR1': '4301',
 'SMB:EXPLOIT:SAMBA-DIR-TRAV': '4302',
 'HTTP:OVERFLOW:SET-COOKIE': '4303',
 'DHCP:AUDIT:MISS-MAGIC-COOKIE': '4304',
 'SPYWARE:KL:ACTIVITYKEYLOGGER': '4305',
 'HTTP:MISC:BLUECOAT-LICENSE': '4306',
 'HTTP:STC:CLSID:ACTIVEX:AX-112': '4307',
 'HTTP:PHP:PHPBB:PHPBB-XS2': '4308',
 'LDAP:EMPTY:DELREQ_EMPTY': '4309',
 'HTTP:STC:CLSID:ACTIVEX:MSODS': '4310',
 'FTP:PASSWORD:BRUTE-FORCE': '4311',
 'TROJAN:MISC:MILLENIUM-SERV-RESP': '4312',
 'TCP:AUDIT:OPT-UNSUP': '4313',
 'SPYWARE:RAT:DIEMSMUTTER': '4314',
 'HTTP:STC:HPJ-OPTIONS': '4315',
 'SMTP:EMAIL:EUDORA-SPOOF4': '4316',
 'VOIP:SIP:AUDIT:DUPLICATE-INVITE': '4317',
 'HTTP:STC:CLSID:ACTIVEX:AX-14': '4318',
 'NETBIOS:NBNS:SHORT_MSG': '4319',
 'SPYWARE:DIALER:YEAKNET': '4320',
 'IP:SRC-ROUTE-OF': '4321',
 'HTTP:STC:CLSID:ACTIVEX:COM-OBJ': '4322',
 'SPYWARE:RAT:NUCLEAR-RAT-6-21': '4323',
 'SCAN:MISC:HTTP:UNIX-BIN-ECHO': '4324',
 'SMTP:MAL:ANI-MAL-HEADER': '4325',
 'SPYWARE:TROJAN:WINEGGDROPSPRO': '4326',
 'HTTP:XSS:IE7-XSS': '4327',
 'IMAP:IPSWITCH:CHAR-OF': '4328',
 'SPYWARE:BP:IEPLUGIN': '4329',
 'HTTP:STC:IE:IE-HCP-DELETE': '4330',
 'IMAP:IPSWITCH:FETCH-OF': '4331',
 'RADIUS:ACCREQ_ATTR_MISSING': '4332',
 'SPYWARE:TROJAN:YURI-1-2': '4333',
 'POP3:EXT:DOT-GRP': '4334',
 'SPYWARE:AD:X-CON3.2.8': '4335',
 'HTTP:STC:CLSID:ACTIVEX:YAHOO-IM': '4336',
 'SSL:INVALID:CHALLENGE-LEN': '4337',
 'HTTP:STC:CLSID:REF-21': '4338',
 'HTTP:STC:CLSID:ACTIVEX:AX-117': '4339',
 'LDAP:INVALID:ADDREQ-ENTRY-INV': '4340',
 'SHELLCODE:X86:SETUID-0-PKT': '4341',
 'HTTP:CISCO:VOIP:STREAM-ID-REQ': '4342',
 'SPYWARE:TROJAN:INIKILLER': '4343',
 'HTTP:STC:ACTIVEX:HPVIRTUAL': '4344',
 'HTTP:STC:IMG:WMF-MAL-HEADER': '4345',
 'SPYWARE:AD:ARESPREMIUM': '4346',
 'TCP:OPTERR:SYN-SACK': '4347',
 'SYSLOG:AUDIT:TIMESTAMP': '4348',
 'SPYWARE:AD:GOLDRIVIERACASINO': '4349',
 'HTTP:XSS:SERVICE-CGI': '4350',
 'HTTP:PROXY:SUNPROXY': '4351',
 'HTTP:STC:CLSID:ACTIVEX:AX-155': '4352',
 'HTTP:INVALID:MISSING-REQ': '4353',
 'APP:KERBEROS:EXCESSIVE-ERRORS': '4354',
 'SCAN:MISC:CAT-ETC-PASSWD-UDP': '4355',
 'CHAT:AUDIT:YMSG:OFLOW-COOKIE': '4356',
 'TROJAN:MISC:BUGS-COMMAND': '4357',
 'SPYWARE:BH:DEALIO_TOOLBAR': '4358',
 'HTTP:STC:SRVRSP:404-NOT-FOUND': '4359',
 'SNMP:AUDIT:UNKNOWN-VERSION': '4360',
 'HTTP:STC:CLSID:REF-28': '4361',
 'P2P:ARES:PEER-CONNECT-TCP': '4362',
 'SMTP:MAL:FIREFOX-HTML-URL-INJ': '4363',
 'RLOGIN:USER:USER-ECHO': '4364',
 'SPYWARE:AD:ADSTART': '4365',
 'IMAP:IPSWITCH:DELE-OF': '4366',
 'HTTP:STC:CLSID:ACTIVEX:SHELLAPP': '4367',
 'SPYWARE:TROJAN:BOER': '4368',
 'HTTP:STC:CLSID:ACTIVEX:AX-106': '4369',
 'HTTP:STC:SCRIPT:OBFUSCATED': '4370',
 'ICMP:AUDIT:WRONG-CHECKSUM': '4371',
 'LDAP:EMPTY:MODIFYREQ_PART_EMPTY': '4372',
 'SPYWARE:RAT:BEAST20X-CTS': '4373',
 'MISC:GTS-WAP-PASSDISC': '4374',
 'HTTP:PHP:PHPESCSHELL': '4375',
 'SMTP:OUTLOOK:TZID-OF': '4376',
 'SHELLCODE:SPARC:GEN-4-PKT': '4377',
 'DB:ORACLE:ISQLPLUS-OF': '4378',
 'SMTP:EXT:DOUBLE-EXTENSION': '4379',
 'NFS:ERR:LONG-NETNAME': '4380',
 'SNMPTRAP:INFO:ERR_STAT_WRNG_LEN': '4381',
 'APP:WHATSUP:IPSWITCH-DIR-TRV': '4382',
 'DDOS:TRIN00:MASTER-CMD-MDIE': '4383',
 'HTTP:MISC:REAL-RMP-TRAV': '4384',
 'WORM:MASLAN:IRC-BACKDOOR-CON': '4385',
 'HTTP:STC:ACTIVEX:EBAY': '4386',
 'SCAN:MISC:HTTP:FPCOUNT-PROBE': '4387',
 'SPYWARE:BH:ABOUTBLANK': '4388',
 'SCAN:MISC:TELNET:TELNET-PORT-21': '4389',
 'SPYWARE:RAT:RTB666': '4390',
 'HTTP:PROXY:LIST:PROXYFIND': '4391',
 'P2P:NAPSTER:LOGIN-8888': '4392',
 'HTTP:STC:ADOBE:PM-FONT-OF': '4393',
 'HTTP:STC:IE:XML-DISCLOSE': '4394',
 'SMTP:EXPLOIT:KERIO-MS-FS': '4395',
 'SPYWARE:TROJAN:EVADE1-1B': '4396',
 'SNMP:ERROR:INVALID_MAX_REPS': '4397',
 'DB:MYSQL:MYSQL-DATE-FS': '4398',
 'NETBIOS:NBNS:RESCODE:NOT_IMPLTD': '4399',
 'NFS:INVALID:INVALID-RSTAT': '4400',
 'OS:LINUXX86:MOUNTD-OF-2': '4401',
 'SMTP:DOS:EUDORA-MIME-DOS': '4402',
 'TCP:AUDIT:S2C-FINRETR-BADSEQ': '4403',
 'HTTP:STC:ACTIVEX:SAPI-DLL': '4404',
 'HTTP:STC:CLSID:ACTIVEX:CACLLCDE': '4405',
 'HTTP:STC:IE:FULLMEM-RELOAD2': '4406',
 'WORM:SLAPPER:WORM-INFECT': '4407',
 'SPYWARE:RAT:SCHWINDLER1-82-CTS': '4408',
 'HTTP:PHP:CACTI-RDD-LOCAL-SCRIPT': '4409',
 'SPYWARE:TROJAN:SEED1-0': '4410',
 'SPYWARE:BH:SCIRUSTOOLBAR': '4411',
 'HTTP:STC:CLSID:REF-10': '4412',
 'HTTP:COBALT:SEC-REQ-PROBE': '4413',
 'HTTP:PHP:MANTIS-ARB-EXEC1': '4414',
 'SMTP:EXPLOIT:PINE-BOUNDARY': '4415',
 'SPYWARE:GM:WEBSITELOGGER34': '4416',
 'TROJAN:MISC:MINIASYLUM-SRV-RESP': '4417',
 'HTTP:PKG:ECOMMERCE-CHECK-TXT': '4418',
 'HTTP:IRIX:CGI-BIN-WRAP': '4419',
 'SCAN:MISC:HTTP:DELETE-DOC': '4420',
 'TCP:AUDIT:S2C-SIMUL-SYN': '4421',
 'SPYWARE:RAT:WEBCAMTROJAN': '4422',
 'SPYWARE:RAT:SPYONE-1-0': '4423',
 'SPYWARE:AD:MALWARE-ALARM': '4424',
 'SPYWARE:AD:PESTBOT': '4425',
 'TCP:S2C:FLAGSERROR:DIR-SYNACK': '4426',
 'SPYWARE:BP:BYDOU': '4427',
 'SCAN:MISC:FTP:OPENBSD-X86': '4428',
 'DNS:OVERFLOW:SPARC-TCP': '4429',
 'SPYWARE:BH:MORPHEUS-TOOLBAR': '4430',
 'IMAP:OVERFLOW:USER': '4431',
 'RPC:RPC.WALLD:WALLD-ERR-FMT-G': '4432',
 'TCP:C2S:AMBIG:C2S-SYN-DATA': '4433',
 'DNS:AUDIT:REP-QTYPE-UNEXPECTED': '4434',
 'DHCP:SERVER:ISC-FORMAT-STRING': '4435',
 'SNMP:DANGEROUS:JETDIRECT-PASS': '4436',
 'TELNET:USER:OUTOFBOX': '4437',
 'DNS:OVERFLOW:BAD-CHAR-UDP': '4438',
 'HTTP:XSS:SHAREPOINT-XSS': '4439',
 'SMTP:MAJORDOMO:COMMAND-EXEC': '4440',
 'VOIP:MGCP:SDP:MEDIA-PORT-OF': '4441',
 'HTTP:STC:SEARCH-LINK': '4442',
 'MS-RPC:MSDTC-DOS': '4443',
 'SCADA:ICCP:REASON-CODE-LENGTH': '4444',
 'SPYWARE:BH:SIDESTEP': '4445',
 'HTTP:STC:CLSID:ACTIVEX:AX-143': '4446',
 'HTTP:FRONTPAGE:DOS-NAME-DOS': '4447',
 'P2P:MISC:XOLOX': '4448',
 'SPYWARE:BP:UPLINK': '4449',
 'SMTP:EXT:DOT-JS': '4450',
 'HTTP:STC:CLSID:ACTIVEX:AX-100': '4451',
 'HTTP:STC:IE:HDRLOC-MSITS': '4452',
 'FTP:EXPLOIT:WIN32-WFTPD-BOF': '4453',
 'HTTP:STC:CLSID:ACTIVEX:AX-59': '4454',
 'SMTP:OUTLOOK:VML-BOF': '4455',
 'SPYWARE:BH:COUPONBAR': '4456',
 'HTTP:STC:ITUNES-ITMS-OF': '4457',
 'HTTP:STC:ACTIVEX:MSMASK32-OCX': '4458',
 'APP:GOOG-PICASA': '4459',
 'HTTP:PHP:PHPBB:LANG-EXEC': '4460',
 'SNMP:ERROR:INV_NON_REPEATERS': '4461',
 'HTTP:CGI:FORMMAIL-VULN': '4462',
 'MS-RPC:MSG-QUEUE-OF': '4463',
 'IP:OPTERR:DUPLICATE': '4464',
 'SPYWARE:GM:SPYDAWN': '4465',
 'SPYWARE:BH:HDT_BAR': '4466',
 'SCADA:MODBUS:NON-MODBUS': '4467',
 'P2P:EDONKEY:FILE-SHARES': '4468',
 'SPYWARE:TROJAN:BIFROST121': '4469',
 'LDAP:COMMGATE-OF': '4470',
 'VOIP:SIP:LIMITS:PROX-AUTH-OF': '4471',
 'SMTP:AUDIT:REQ-MISSING-HELLO': '4472',
 'SMTP:MAL:MALFORMED-WMF': '4473',
 'SPYWARE:AD:SEEQTOOLBAR': '4474',
 'DB:ORACLE:TNS-BEQ-BYPASS': '4475',
 'SPYWARE:AD:ULTRABAR': '4476',
 'VOIP:SIP:SESSION-REQ': '4477',
 'HTTP:PKG:SUPERSCOUT-USERLIST': '4478',
 'SMTP:EXT:DOT-LNK': '4479',
 'SPYWARE:RAT:CIA1-22-ICQ': '4480',
 'SPYWARE:AD:COMTRYMUSICDL': '4481',
 'SPYWARE:AD:AVSYSTEMCARE': '4482',
 'HTTP:STC:CLSID:ACTIVEX:AX-127': '4483',
 'SPYWARE:TROJAN:DUMARU': '4484',
 'DHCP:RQST:DHCP-HN-OF2': '4485',
 'HTTP:STC:IE:CONT-LOC-ZON-BYPASS': '4486',
 'APP:REAL:PLAYER-FILE-SEC-BYPASS': '4487',
 'HTTP:OREILLY:WIN-C-SMPLE-OVFLOW': '4488',
 'HTTP:MISC:MOBY-LENGTH-DOS': '4489',
 'SMTP:OVERFLOW:EMAIL-ADDRESS': '4490',
 'SNMP:COMMUNITY:NULL-CHAR': '4491',
 'VNC:AUDIT:UNKNOWN-CLIENT-MSG': '4492',
 'LPR:AUDIT:CMD-FAILED': '4493',
 'P2P:ARES:PEER-CONNECT-UDP': '4494',
 'APP:REAL:PLAYER-MAL-SKIN': '4495',
 'HTTP:STC:STREAM:CONTENT-TYPE': '4496',
 'HTTP:OVERFLOW:CONTENT-MD5': '4497',
 'SPYWARE:RAT:COOLREMOTECONTROL': '4498',
 'PROTOCOLS:TRAFFIC:NOT-SMTP': '4499',
 'HTTP:XSS:COLDFUSION-MX7': '4500',
 'DB:ORACLE:MALFORMED-PORT': '4501',
 'HTTP:STC:IMG:BMP-OVERFLOW': '4502',
 'SPYWARE:BH:FUNWEBPRODUCTS': '4503',
 'SPYWARE:DM:PIOLET': '4504',
 'HTTP:AUDIT:URL': '4505',
 'HTTP:STC:ACTIVEX:HP-MERC-CLR': '4506',
 'SPYWARE:RAT:NETOPREMOTECONTROL': '4507',
 'SCADA:DNP3:STOP': '4508',
 'HTTP:STC:CLSID:ACTIVEX:AX-09': '4509',
 'VIRUS:SMTP:EXE-IN-ZIP': '4510',
 'WORM:CONFICKER:C-ACTIVITY': '4511',
 'SPYWARE:AD:FAVSEARCH': '4512',
 'SPYWARE:AD:BTGRAB': '4513',
 'LDAP:OVERFLOW:ENCODING-TAG-OF': '4514',
 'CHAT:AUDIT:AIM:TLV-LEN-OVFLW': '4515',
 'SMB:TOOLS:PSEXEC': '4516',
 'HTTP:PHP:EXOOPS-FD': '4517',
 'SCAN:NESSUS:ISS-DIR-LISTING': '4518',
 'HTTP:APACHE:INV-HEADER-DOS': '4519',
 'VOIP:SIP:AUDIT:INV-FROM': '4520',
 'HTTP:STC:VULN:APACHE-1-3-26-31': '4521',
 'HTTP:STC:ADOBE:ACROBAT-EXT-OF': '4522',
 'MS-RPC:NOOP-SLIDE-RPC-REQ': '4523',
 'SPYWARE:BP:BAIGOO': '4524',
 'POP3:EXT:DOT-CRT': '4525',
 'SCAN:MISC:HTTP:UNIX-BIN-CHOWN': '4526',
 'APP:ARKEIA:AGENT-CONFIG': '4527',
 'SPYWARE:RAT:NEUROTICKAT1-3-CTS': '4528',
 'SCAN:MISC:HTTP:CNF-PROBE': '4529',
 'HTTP:STC:IE:WSZ-EXEC': '4530',
 'SPYWARE:TROJAN:DOWNLOADER-ARM': '4531',
 'APP:NOVELL:ZENWORK-OF': '4532',
 'HTTP:WIKI-SERVER-DT': '4533',
 'TROJAN:DAGGER:CLIENT-CONNECT': '4534',
 'POP3:EXT:DOT-PIF': '4535',
 'SPYWARE:DIALER:EROTICACCESS': '4536',
 'HTTP:OVERFLOW:MAIL-ENABLE-AUTH': '4537',
 'SMTP:EMAIL:HEADER-FROM-PIPE': '4538',
 'TROJAN:MISC:R0XR4T-COMMAND': '4539',
 'APP:CVS:DIR-OVERFLOW': '4540',
 'SPYWARE:RAT:ASSASSIN1-1-HTTP': '4541',
 'SPYWARE:TROJAN:ERAZER': '4542',
 'HTTP:INVALID:SSL-INV-HNDSHK': '4543',
 'P2P:EDONKEY:CLIENT-DOS-ATK': '4544',
 'TROJAN:MISC:CYN-CLIENT-REQ': '4545',
 'HTTP:MISC:HP-PROCURVE-RESET': '4546',
 'TROJAN:BACKDOOR:COMMAND': '4547',
 'SPYWARE:RAT:ROACH10-INITIALRESP': '4548',
 'DHCP:RQST:SERVER-REQUEST': '4549',
 'VNC:AUDIT:ENCODING-TYPE': '4550',
 'SPYWARE:TROJAN:ZSPYII0.99': '4551',
 'HTTP:IRIX:CGI-BIN-REMOTE-EXEC': '4552',
 'NFS:ERR:VERSION-MISMATCH': '4553',
 'TELNET:OVERFLOW:OPTIONS-REPLY': '4554',
 'VOIP:SIP:SQL-CMD-2': '4555',
 'IMAP:MER-SUBSCRIBE': '4556',
 'HTTP:STC:CLSID:ACTIVEX:AX-37': '4557',
 'HTTP:PHP:PHPBB:SELECT-FISH': '4558',
 'SPYWARE:DM:POPULARSCREENSAVERS': '4559',
 'HTTP:STC:CLSID:ACTIVEX:AX-154': '4560',
 'PROTOCOLS:PORT:FTP': '4561',
 'HTTP:STC:ACTIVEX:ADODB-CONNECT': '4562',
 'HTTP:PHP:PMACHINE-INCLUDE': '4563',
 'SCAN:MISC:TELNET:TELNET-PORT-80': '4564',
 'HTTP:IIS:MALFORMED-EXT-DATA': '4565',
 'CHAT:IRC:MIRC-PRIVMSG': '4566',
 'SMB:AUDIT:UNK-DIALECT': '4567',
 'HTTP:IIS:MDAC-RDS-2': '4568',
 'LPR:INVALID:EOL': '4569',
 'TROJAN:MISC:WINRAT10-TCP': '4570',
 'HTTP:CGI:TECHNOTE-PRINT-DSCLSR': '4571',
 'FTP:PASSWORD:DEFAULT-USERNM-PW': '4572',
 'TROJAN:MISC:GRISCH2-STAT-REQ': '4573',
 'SPYWARE:BH:EXCITESEARCHBAR': '4574',
 'HTTP:NETSCAPE:WP-HTML-REND': '4575',
 'SPYWARE:TROJAN:HELIOS-3-1-STC': '4576',
 'SPYWARE:AD:VROOMSEARCH': '4577',
 'CHAT:IRC:INVALID:NUM-REPLY': '4578',
 'HTTP:STC:CLSID:ACTIVEX:MOTIVE': '4579',
 'SCADA:IEC104:MESSAGE-TYPEU-FN': '4580',
 'SMTP:EXT:FILE-AVI': '4581',
 'HTTP:STC:ACTIVEX:REVEALTRANS': '4582',
 'HTTP:INVALID:DUPLICATE-HEADER': '4583',
 'TCP:AMBIGUOUS:WSF-TOOBIG': '4584',
 'IMAP:IPSWITCH:STATUS-OF': '4585',
 'IMAP:AUDIT:REQ-UNKNOWN-CMD': '4586',
 'SNMPTRAP:INFO:STAT_RSUNAVAIL': '4587',
 'SPYWARE:KL:XPCSPY-FTP': '4588',
 'LDAP:FAILED:ADD-RESULT-FAIL': '4589',
 'HTTP:PHP:CACTI-RRD-FILE-INC': '4590',
 'LDAP:EMPTY:SRCH_RESREF_NONE': '4591',
 'SPYWARE:AD:FUNBUDDYICONS': '4592',
 'HTTP:STC:CLSID:REF-43': '4593',
 'HTTP:STC:OUTLOOK:SHELL-PROFILE': '4594',
 'HTTP:STC:CLSID:ACTIVEX:AX-89': '4595',
 'VOIP:SIP:OVERFLOW:QPOP-OF': '4596',
 'TCP:OPTERR:NONSYN-WSF': '4597',
 'HTTP:INFO:MEEBO': '4598',
 'HTTP:STC:CLSID:ACTIVEX:AX-41': '4599',
 'HTTP:SQL:INJ:FACTO-CMS': '4600',
 'SPYWARE:AD:SMARTPOPS': '4601',
 'POP3:EXT:DOT-CPL': '4602',
 'POP3:OVERFLOW:QPOP-OF3': '4603',
 'TROJAN:MISC:PEST-COMMAND': '4604',
 'VOIP:MGCP:AUDIT:INV-CALL-ID': '4605',
 'HTTP:STC:IMG:MALFORMED-BMP': '4606',
 'NFS:ERR:WRONG-DIR': '4607',
 'SCAN:MISC:HTTP:WIN-NT-ADMIN-ADD': '4608',
 'VOIP:H225RAS:REG-BAD-ID-CHAR': '4609',
 'APP:REMOTE:TEAMVIEWER-HTTP': '4610',
 'PORTMAPPER:AUDIT:ROOT-ACCESS': '4611',
 'SCAN:MISC:TELNET:APPEND-PASSWD': '4612',
 'SPYWARE:AD:EZULA-TOPTEXT': '4613',
 'IMAP:REQERR:REQ-UNEXPECTED-ARG': '4614',
 'VIRUS:POP3:DOUBLE-DOT-DOT': '4615',
 'SCAN:MISC:ADMROCKS-TCP': '4616',
 'HTTP:STC:MOZILLA:NONASCII-LINK': '4617',
 'TROJAN:DOLY:COMMAND-V2': '4618',
 'SPYWARE:KL:MYBRKEYLOGGER': '4619',
 'HTTP:SQL:INJ:OSCOM': '4620',
 'SPYWARE:BH:LOCATORSTOOLBAR': '4621',
 'HTTP:SQL:INJ:HEADER-3': '4622',
 'NETBIOS:AUDIT:ACTIVE_ERR': '4623',
 'TROJAN:KUANG2:SCAN-DETECT': '4624',
 'FTP:MS-FTP:STAT-GLOB': '4625',
 'APP:CA:LIC-GETCONFIG-OF': '4626',
 'SPYWARE:RAT:SCREENCONTROL10-CTS': '4627',
 'TROJAN:MISC:CYN-CLIENT-CONN': '4628',
 'SPYWARE:RAT:NETDEMON1-0': '4629',
 'SCAN:MISC:TELNET:ID': '4630',
 'SPYWARE:RAT:SPYAGENT-ALERT': '4631',
 'HTTP:STC:IE:SCOB.A': '4632',
 'POP3:AUDIT:REQ-INVALID-STATE': '4633',
 'SMB:INFO:PCLAN-1.0': '4634',
 'SPYWARE:TROJAN:DLOADERQGVARIANT': '4635',
 'SPYWARE:AD:BESTOFFERS': '4636',
 'HTTP:STC:CLSID:REF-34': '4637',
 'SMB:OF:SPOOL-SVC-OF': '4638',
 'SPYWARE:KL:PCACTMONPRO': '4639',
 'SPYWARE:AD:APROPOSMEDIA': '4640',
 'HTTP:STC:CLSID:ACTIVEX:AX-56': '4641',
 'SPYWARE:RAT:GREEKHACKERS1-1-CTS': '4642',
 'HTTP:INFO:AUTH-NEGOTIATE': '4643',
 'SPYWARE:TROJAN:NIRVANA-2.0': '4644',
 'SCAN:SAINT:FTP-SCAN': '4645',
 'SPYWARE:TROJAN:THUZEROTOLERANCE': '4646',
 'P2P:GNUCLEUSLAN:CONNECT': '4647',
 'SPYWARE:GM:GENERIC-DNLDR-AB': '4648',
 'SPYWARE:AD:AORNUM': '4649',
 'POP3:DOS:MDAEMON-POP-DOS': '4650',
 'TCP:S2C:AMBIG:OLAP-MISMATCH': '4651',
 'IMAP:OVERFLOW:LINUX-X86-2': '4652',
 'TELNET:FAILURE:NOT-ON-CONSOLE': '4653',
 'CHAT:AUDIT:YMSG:MSG': '4654',
 'SPYWARE:AD:U88': '4655',
 'SCAN:MISC:HTTP:MEM-BIN-PROBE': '4656',
 'HTTP:MISC:VISNETIC-DOS': '4657',
 'DNS:EXPLOIT:TRANSPOOF-2': '4658',
 'TCP:AUDIT:C2S-TIMEWAIT-ACK': '4659',
 'HTTP:CGI:ALLAIRE-SHELL-ATTEMPT': '4660',
 'SPYWARE:RAT:COOLCAT': '4661',
 'SMTP:EXCHANGE:MAILROUTE-OF': '4662',
 'APP:FLASH-SRV-DOS': '4663',
 'TROJAN:MISC:OSIRIS-SERV-RESP': '4664',
 'SPYWARE:BP:DITTO_TOOLBAR': '4665',
 'DDOS:TRIN00:DAEMON-CMD': '4666',
 'SPYWARE:AD:LORDOFSEARCH': '4667',
 'HTTP:OVERFLOW:CONTENT-RANGE': '4668',
 'NETBIOS:NBDS:BAD_LABEL_FORMAT': '4669',
 'POP3:EXT:DOT-HTA': '4670',
 'SMB:ERROR:INV-MSG-LEN': '4671',
 'SMTP:EXPLOIT:PINE-SLASHQUOTE': '4672',
 'SNMPTRAP:ERROR:UNEXPECTED-REPLY': '4673',
 'HTTP:APACHE:NEG-CTN-LENGTH': '4674',
 'SPYWARE:RAT:SPYAGENT': '4675',
 'ICMP:AUDIT:RESP-WITHOUT-REQ': '4676',
 'DOS:APPLICATION:DOS': '4677',
 'OS:SOLARISX86:NLPS-OF': '4678',
 'TROJAN:MISC:BLAZER-SERV-RESP': '4679',
 'HTTP:IIS:SHAREPOINT-PRIV-ESC': '4680',
 'SMTP:AUDIT:REQ-INVALID-CMD-SEQ': '4681',
 'WORM:NIMDA:BIN-255-CMD': '4682',
 'HTTP:STC:WINAMP:MOD-HDR-OF': '4683',
 'CHAT:AUDIT:YMSG:SENDER': '4684',
 'VOIP:MGCP:AUDIT:INV-PARM-RD': '4685',
 'SCAN:MISC:HTTP:WEB-MAP-ACCESS': '4686',
 'HTTP:AUDIT:UNKNOWN-VERB': '4687',
 'SCAN:CORE:NTPD-CTRL-MSG-OF': '4688',
 'HTTP:XSS:FRONTPAGE-EXT': '4689',
 'HTTP:STC:CLSID:ACTIVEX:FPOLE': '4690',
 'HTTP:STC:X11-OVERSIZE-FONT': '4691',
 'HTTP:STC:IE:TIF-DND': '4692',
 'HTTP:CGI:DRAGON-DFIRE.CGI': '4693',
 'NFS:BSD-MOUNT-DOS': '4694',
 'SNMPTRAP:INFO:STAT_OTHER_ERR': '4695',
 'HTTP:IIS:ENCODING:UNICODE-BP1': '4696',
 'NETBIOS:NBNS:CLASS-UNKNOWN': '4697',
 'MS-RPC:SRVSVC-OF': '4698',
 'SPYWARE:RAT:AIR': '4699',
 'HTTP:PROXY:ANON:PROXY-2': '4700',
 'TROJAN:MISC:SCARAB-CONNECT': '4701',
 'SMB:OF:RPC-PNP-OF': '4702',
 'FTP:WU-FTP:GLOBARG': '4703',
 'PROTOCOLS:PORT:SSH': '4704',
 'SMTP:EMAIL:MAIL-FROM-PIPE': '4705',
 'SPYWARE:KL:NETVIZOR52': '4706',
 'SPYWARE:DIALER:PARISVOYEUR': '4707',
 'LDAP:OVERFLOW:SEARCH-LEVELS-OF': '4708',
 'SPYWARE:RAT:ANTILAMER': '4709',
 'WORM:WITTY:INFECT-ATTEMPT': '4710',
 'HTTP:STC:CLSID:REF-47': '4711',
 'TROJAN:MISC:RMT-REVISE-COMMAND': '4712',
 'P2P:AUDIT:GNUTELLA-SVR-RESP': '4713',
 'SCADA:ICCP:UNSUPPORTED-SERVICE': '4714',
 'APP:PPTP:MICROSOFT-PPTP': '4715',
 'P2P:OVERNET:FILE-SHARES': '4716',
 'DNS:AUDIT:QCLASS-UNEXP': '4717',
 'DHCP:OPT:LEASE-TIME-ZERO': '4718',
 'FTP:OVERFLOW:K4FTP-OF1': '4719',
 'SPYWARE:RAT:ARCANUM-0-1-1': '4720',
 'HTTP:STC:CLSID:ACTIVEX:SWCTL': '4721',
 'SMB:AUDIT:DCERPC-UNEXPECTED-RSP': '4722',
 'SPYWARE:GM:TROJ-SPYWAD-X': '4723',
 'HTTP:CGI:PERL:WEBWHO': '4724',
 'MS-RPC:DCE-RPC-DNSSVR': '4725',
 'SCAN:CANVAS:MAILENABLE': '4726',
 'OS:AIX:PDNSD-OF': '4727',
 'HTTP:CGI:BUGZILLA-SEMICOLON': '4728',
 'HTTP:STC:CLSID:ACTIVEX:WH32-OF': '4729',
 'RLOGIN:OVERFLOW:USERNAME': '4730',
 'VOIP:SIP:LIMITS:MAX-FWRDS-OF': '4731',
 'HTTP:ALTN-SG-OF': '4732',
 'SPYWARE:TROJAN:SNAKETROJAN-HTTP': '4733',
 'RLOGIN:OVERFLOW:LONG-ARGS': '4734',
 'SPYWARE:RAT:NETANGEL1-0-SIN': '4735',
 'TROJAN:MISC:VAGNCKER-SERV-RESP': '4736',
 'DB:ORACLE:GRANT-TYPE-ACCESS-INJ': '4737',
 'HTTP:STC:CLSID:ACTIVEX:AX-139': '4738',
 'HTTP:STC:IE:IE-MSHTML-OF': '4739',
 'SPYWARE:TROJAN:LOKITECH': '4740',
 'P2P:NAPSTER:NEW-USER-LOGIN-8888': '4741',
 'HTTP:STC:ACTIVEX:BACKWEB-LIA': '4742',
 'SMB:OF:MANGLING-FILE-OF': '4743',
 'LDAP:INVALID:SEARCH-ATTRIB-INV': '4744',
 'SNMP:INFO:ERR_STAT_COMMIT_FAILD': '4745',
 'SPYWARE:AD:ALLSUM': '4746',
 'HTTP:CHKP:AUTH-HDR-BOF': '4747',
 'SPYWARE:RAT:SPYAGENT-FTP': '4748',
 'HTTP:INFO-LEAK:SNOOP-DISLOSURE': '4749',
 'HTTP:STC:CLSID:ACTIVEX:AX-120': '4750',
 'SPYWARE:KL:ACTIVEKEYLOGGERHOME': '4751',
 'HTTP:TUNNEL:SSH': '4752',
 'VOIP:SIP:AUDIT:EMPTY-HEADER': '4753',
 'APP:GAME:SOURCE-QUERY': '4754',
 'APP:CA:LOG-SEC-BOF': '4755',
 'IMAP:AUDIT:IMAPS-CLEAR': '4756',
 'HTTP:SQL:INJ:VERSION-DETECT': '4757',
 'TROJAN:MISC:WOW23-TCP': '4758',
 'SMTP:AUTO-SPAM': '4759',
 'HTTP:ORACLE:CHAR-CONV-VULN': '4760',
 'RPC:AUDIT:INVALID-DIR': '4761',
 'RPC:RPC.SADMIND:METHOD-TRAV-UDP': '4762',
 'HTTP:STC:IE:HRALIGN-OF': '4763',
 'MS-RPC:SAMR-ACCESS-DENIED': '4764',
 'CHAT:AUDIT:MSN:MSG': '4765',
 'SPYWARE:TROJAN:THEX-12': '4766',
 'SPYWARE:KL:WINTECTIVE': '4767',
 'SCAN:MISC:TELNET:MKDIR': '4768',
 'SCAN:MISC:HTTP:WAIS-ACCESS': '4769',
 'SCAN:MISC:TELNET:CD-BIN-HIDDEN': '4770',
 'SMB:EXPLOIT:WINBLAST-DOS': '4771',
 'HTTP:IIS:IIS-HTR-CHUNKED': '4772',
 'HTTP:STC:JAVA:JNLP-CHARSET-OF': '4773',
 'SHELLCODE:X86:GEN-2-PKT': '4774',
 'SPYWARE:DIALER:IEACCESS': '4775',
 'HTTP:STC:IMG:ANI-BLOCKSIZE-TXT': '4776',
 'HTTP:STC:CLSID:ACTIVEX:MSAGENT': '4777',
 'HTTP:TUNNEL:CHAT-AOL-IM': '4778',
 'VOIP:MGCP:INV-CHAR-LOW': '4779',
 'SMTP:OVERFLOW:EMAIL-DOMAIN': '4780',
 'LPR:OVERFLOW:C-HOST': '4781',
 'HTTP:OMNI:VISADMIN-DOS': '4782',
 'VOIP:SIP:LIMITS:MIN-EXPIRES-OF': '4783',
 'DB:ORACLE:LOGIN-BYPASS': '4784',
 'HTTP:REQERR:NESTING': '4785',
 'HTTP:SQL:INJ:CMD-IN-URL': '4786',
 'DB:ORACLE:DEFAULT-PW-TRACESVR': '4787',
 'LDAP:EMPTY:SCHREQ-FTR-SSTR-NONE': '4788',
 'SNMPTRAP:INFO:ERR_STAT_NO_NAME': '4789',
 'HTTP:PHP:MANTIS-ARB-EXEC2': '4790',
 'CHAT:GOOGLE:SEND-HTTP': '4791',
 'SMB:OF:DIALECT-INDEX-OVERFLOW': '4792',
 'HTTP:XSS:OUTLOOK-WEB-ACCESS': '4793',
 'SMB:EXPLOIT:ACCOUNT-NAME-OF': '4794',
 'VOIP:SIP:SECURITY-BAD-SCHEMA': '4795',
 'HTTP:STC:IE:XML-HANDLE-EXEC': '4796',
 'HTTP:STC:IE:MAL-DATASTREAM': '4797',
 'HTTP:STC:IE:DHTML-CCR-INV-OBJ': '4798',
 'SPYWARE:GM:SONYROOTKIT': '4799',
 'VOIP:SIP:OVERFLOW:SIPXTAPI-OF': '4800',
 'IKE:DOS:TCPDUMP-SPI-OVERFLOW': '4801',
 'HTTP:IIS:IIS-BYPASS': '4802',
 'SPYWARE:KL:PCSENTINELSOFTWAREKL': '4803',
 'HTTP:PHP:PHPBB:PRIV-DEL': '4804',
 'NTP:ERROR:MAX_STRATUM_EXCEEDED': '4805',
 'SPYWARE:BH:MUSICSTARWARETOOL': '4806',
 'SPYWARE:RAT:FREAK88DAS': '4807',
 'APP:NOVELL:EDIRECTORY-DOS': '4808',
 'IMAP:OVERFLOW:MAILENABLE-OF-3': '4809',
 'SMTP:EMAIL:EUDORA-SPOOF3': '4810',
 'HTTP:CGI:CAREY-COMMERCE-DIR-TRV': '4811',
 'VOIP:SIP:LIMITS:REJ-CONTACT-OF': '4812',
 'TROJAN:MISC:BALSITIX-SRV-RESP': '4813',
 'SPYWARE:RAT:YAT1-3': '4814',
 'RSH:OVERFLOW:USERNAME': '4815',
 'HTTP:CGI:NULL-ENCODING': '4816',
 'APP:SAV-BOF': '4817',
 'DB:MYSQL:LONG-FUNC': '4818',
 'TROJAN:MISC:REMOTEHACK-SVR-RESP': '4819',
 'HTTP:STC:ADOBE:DLMGR-AOM-OF': '4820',
 'VOIP:SIP:OVERSIZED-UDP-MSG': '4821',
 'SPYWARE:TROJAN:ZALIVATOR142PRO': '4822',
 'DOS:NETDEV:HP-LCD-MOD-9001': '4823',
 'SMTP:EXT:DOT-REG': '4824',
 'TROJAN:MISC:WINCRASH': '4825',
 'HTTP:IIS:BAT-&': '4826',
 'HTTP:REQERR:BIN-DATA-HEADER': '4827',
 'HTTP:CISCO-PW-OF': '4828',
 'DOS:NETDEV:CISCO-5000': '4829',
 'VNC:AUDIT:SERVER-BITPERPIXEL': '4830',
 'HTTP:APACHE:MOD-REWRITE-OF': '4831',
 'IMAP:CYRUS:LOGIN-OF': '4832',
 'MS-RPC:MSRPC-EVASION-6': '4833',
 'HTTP:STC:CLSID:ACTIVEX:AX-74': '4834',
 'HTTP:STC:IE:IE-WEBFONTS-DL': '4835',
 'HTTP:INFO-LEAK:NSCONFIG': '4836',
 'CHAT:AUDIT:MSN:URL': '4837',
 'POP3:OVERFLOW:FILENAME2LONG': '4838',
 'SPYWARE:BP:NEWNET': '4839',
 'SNMPTRAP:INFO:ERR_STAT_GEN_ERR': '4840',
 'GOPHER:IE-GOPHER-OF': '4841',
 'SMB:OF:SMB-IPC-OF': '4842',
 'HTTP:OVERFLOW:ACROBATX-HEAP': '4843',
 'DHCP:OPT:MAX-DGM-SZ-2-SMALL': '4844',
 'SMB:NETBIOS:INV-CGNAME-LEN': '4845',
 'TCP:C2S:EXPLOIT:TCP-ZERO-PORT': '4846',
 'HTTP:SQL:INJ:HEADER-COOKIE': '4847',
 'HTTP:STC:ACTIVEX:VMWARE': '4848',
 'WORM:NIMDA:SCRIPTS-C11C-CMD': '4849',
 'HTTP:SQL:INJ:GLOBAL-VAR': '4850',
 'SCAN:AMAP:HTTP-ON-SSH': '4851',
 'SSH:OVERFLOW:SECURECRT-BOF': '4852',
 'SPYWARE:BH:BAIDU_TOOLBAR_4_9_4': '4853',
 'ICMP:AUDIT:INVALID-TYPE': '4854',
 'SPYWARE:KL:DESKTOPSCOUT': '4855',
 'WORM:DABBER:TFTP-TRANSFER': '4856',
 'APP:COLDFUSIONMX-ACC': '4857',
 'HTTP:STC:CLSID:ACTIVEX:MSXML-AX': '4858',
 'HTTP:WIN-CMD:WIN-RGUEST': '4859',
 'SSL:INVALID:CIPHER-SPEC': '4860',
 'VIRUS:SMTP:LOCALHOST-HELO': '4861',
 'SPYWARE:GM:SPYSHERIFF': '4862',
 'SPYWARE:AD:NETSTER': '4863',
 'HTTP:STC:CLSID:ACTIVEX:HTML-HP2': '4864',
 'DNS:AUDIT:OPT-NMB-EXCEEDED': '4865',
 'HTTP:XSS:ORACLE-REPORT-SVR': '4866',
 'HTTP:STC:CLSID:REF-18': '4867',
 'SMTP:EMAIL:HEADER-TO-PIPE': '4868',
 'TROJAN:MISC:PRAYER-SERV-RESP': '4869',
 'SPYWARE:RAT:ACTMONMONITORING': '4870',
 'DB:MYSQL:MYSQL-IFDOS': '4871',
 'SPYWARE:RAT:SCHWINDLER1-82-STC': '4872',
 'SCADA:MODBUS:DOS': '4873',
 'HTTP:STC:CLSID:REF-11': '4874',
 'FTP:AUDIT:REQ-UNKNOWN-CMD': '4875',
 'POP3:EUDORA-MAIL-CLIENT': '4876',
 'HTTP:OVERFLOW:CONTENT-TYPE': '4877',
 'FTP:AUDIT:BINARY-DATA-FOLDER': '4878',
 'DNS:AUDIT:RCODE-REFUSED': '4879',
 'HTTP:CGI:PERL:WEBHINT-CMD-INJ': '4880',
 'SMB:FILE:EICAR-COPY': '4881',
 'DNS:EXPLOIT:INFOLEAK-TCP': '4882',
 'HTTP:EXT:DOT-RAT': '4883',
 'APP:LIBGTOP-FMT-STR': '4884',
 'HTTP:STC:CLSID:ACTIVEX:AX-137': '4885',
 'MS-RPC:MESSENGER-OF': '4886',
 'SMTP:IIS:CDO-OF': '4887',
 'HTTP:IIS:ASP-SEARCH-PROBE': '4888',
 'HTTP:STREAM:ITUNES-USERAGENT': '4889',
 'HTTP:NCSA:JJ-TILDE': '4890',
 'HTTP:CGI:BIZDB-SEARCH.CGI': '4891',
 'SHELLCODE:LINUXX86:GEN-2-TCP': '4892',
 'POP3:REQERR:REQ-MESSAGE-NUMBER': '4893',
 'CHAT:AIM:FILE-SEND': '4894',
 'SCAN:RETINA:FTP': '4895',
 'SPYWARE:BP:IECODEC': '4896',
 'HTTP:STC:SRVRSP:IDC-PATH': '4897',
 'SPYWARE:RAT:SMARTHACKUPLOADER': '4898',
 'DNS:QUERY:NULL-QUERY': '4899',
 'P2P:BITTORRENT:TRACKER-QUERY-2': '4900',
 'HTTP:STC:ACTIVEX:CODEBASE': '4901',
 'SPYWARE:TROJAN:LETMERULE20-CTS': '4902',
 'HTTP:PHP:MAL-FILE-UPLOAD': '4903',
 'TROJAN:WINCRASH:SERVER-RES': '4904',
 'HTTP:STC:ACTIVEX:WFICA': '4905',
 'SMTP:OUTLOOK:DHTML-HANDLER-RACE': '4906',
 'HTTP:STC:ACTIVEX:RWSO': '4907',
 'HTTP:PHP:COOLFORUM-SRC-DISC': '4908',
 'SSL:ENC-LEN-VALUE-TOO-BIG': '4909',
 'FINGER:REQERR:REQ-BINARY-DATA': '4910',
 'APP:ICECAST-BOF': '4911',
 'LDAP:OVERFLOW:ENCODING-LEN-OF': '4912',
 'APP:CVS:CVS-FILE-INFO': '4913',
 'SMB:NETBIOS:INV-SHDR-LEN': '4914',
 'TROJAN:NETMTROPOL:CLI-REQ-5301': '4915',
 'HTTP:PHP:PHPBB:AVATAR-UPLOAD': '4916',
 'HTTP:STC:CLSID:ACTIVEX:HP-AX': '4917',
 'HTTP:STC:IE:BGSOUND-TAG': '4918',
 'SPYWARE:TROJAN:51D1B': '4919',
 'APP:ESIGNAL:OVERFLOW-EXPLOIT': '4920',
 'TROJAN:COREFLOOD:C-AND-C': '4921',
 'SPYWARE:RAT:PLANETREMOTE': '4922',
 'SMB:OF:TAPI-SVC-OF': '4923',
 'HTTP:REQERR:BIN-DATA-CONT-LANG': '4924',
 'TFTP:MSG-TOO-SHORT': '4925',
 'SPYWARE:TROJAN:MATRIX103': '4926',
 'HTTP:OVERFLOW:SYBASE-WEBCONSOLE': '4927',
 'HTTP:STC:IE:INVALID-LAYOUT': '4928',
 'SCAN:MISC:TELNET:CAT-ETC-INETD': '4929',
 'SYSLOG:FAILURES:MSG-TOO-SHORT': '4930',
 'HTTP:INFO-LEAK:VIGNETTE-DIAG': '4931',
 'HTTP:STC:IE:CLSID-IN-FILENAME': '4932',
 'SPYWARE:AD:ESYNDICATE': '4933',
 'LPR:OVERFLOW:C-CLASS': '4934',
 'NETBIOS:NBDS:FRAG_TRANS_RESP': '4935',
 'FTP:AUDIT:REP-BINARY-DATA': '4936',
 'TELNET:FAILURE:WINDOWS': '4937',
 'TCP:AUDIT:C2S-OLD-ESTB': '4938',
 'HTTP:STC:HSC:MS-HSC-URL-VLN': '4939',
 'SCAN:MISC:HTTP:SITE-IISAMPLES': '4940',
 'RLOGIN:USER:USER-BIN': '4941',
 'HTTP:STC:EICAR-DOWNLOAD': '4942',
 'HTTP:STC:IE:IFRAME-NAME-OF': '4943',
 'TROJAN:MISC:REVENGER-SRV-RESP': '4944',
 'HTTP:STC:CLSID:ACTIVEX:AX-92': '4945',
 'HTTP:WEBSPHERE:VER-DOS': '4946',
 'SHELLCODE:UNIXWARE:GEN-TCP': '4947',
 'APP:CA:ARCSRV:LOGGERD-DOS': '4948',
 'VOIP:SIP:EMERGENCY-NUMBER': '4949',
 'HTTP:SQL:INJ:GENERIC': '4950',
 'HTTP:STC:IE:WMP-BMP-OF-3': '4951',
 'MS-RPC:DCOM:EXPLOIT': '4952',
 'HTTP:CGI:CPANEL5-GB-EXEC': '4953',
 'IMAP:REQERR:REQ-INVALID-TAG': '4954',
 'WORM:EMAIL:SOBIG-DL-REQUEST': '4955',
 'HTTP:SQL:INJ:PHPTOPSITES': '4956',
 'SPYWARE:AD:ADCLICKER-EJ': '4957',
 'P2P:XUNLEI:DOWNLOAD': '4958',
 'HTTP:TOMCAT:REAL-PATH-DISC': '4959',
 'SPYWARE:RAT:SUPERRA': '4960',
 'SCAN:NESSUS:SSH': '4961',
 'APP:PEERCAST-CMD-BOF': '4962',
 'SMB:AUDIT:EXP-NEG': '4963',
 'HTTP:CGI:IKONBOARD-BADCOOKIE': '4964',
 'SPYWARE:KL:INWEBSITELOG24': '4965',
 'HTTP:PROXY:LIST:PUBWEBPROXIES': '4966',
 'SMTP:MAL:OUTLOOK-SHELL': '4967',
 'SSL:INVALID:CLIENT-HELLO': '4968',
 'SPYWARE:KL:PROAGENT': '4969',
 'HTTP:CGI:WAYBOARD-FILE-DISCLSR': '4970',
 'LPR:ARB-FILE-UNLINK': '4971',
 'SPYWARE:UTIL:SARIA': '4972',
 'CHAT:IRC:OVERFLOW:CHANNEL': '4973',
 'HTTP:MISC:WWWACL-PROBE': '4974',
 'SCAN:II:ALLAIRE-CF-OF': '4975',
 'SNMPTRAP:ERROR:MSG-TOO-SHORT': '4976',
 'WORM:ZAFI:D-BACKDOOR-UPL': '4977',
 'SPYWARE:KL:STARR': '4978',
 'SPYWARE:BH:PHAZEBAR': '4979',
 'NETBIOS:NBNS:S2C_QUERY': '4980',
 'TROJAN:MISC:UNEXP-SVR-RESP': '4981',
 'HTTP:STC:ACTIVEX:VULN-DHTML': '4982',
 'HTTP:STC:IE:INST-ENG-INT-OF': '4983',
 'HTTP:OVERFLOW:WSHELL-CGIC': '4984',
 'HTTP:FRONTPAGE:AUTH-PWD-PROBE': '4985',
 'HTTP:STC:CLSID:ACTIVEX:REAL-AX': '4986',
 'WORM:MIMAIL:MIMAIL.A': '4987',
 'HTTP:STC:IE:SSL-PROXY-DIS': '4988',
 'SYSLOG:FAILURES:UNEXP-REPLY': '4989',
 'CHAT:IRC:SRV-RESPONSE': '4990',
 'SSH:ERROR:COOKIE-MISMATCH': '4991',
 'RPC:RPC.WALLD:WALLD-ERR-FTSTR-2': '4992',
 'SNMPTRAP:COMMUNITY:OVERFLOW-1K': '4993',
 'TROJAN:MISC:MICHAL-SRV-RESP': '4994',
 'DB:MYSQL:MAXDB-GET-OF': '4995',
 'HTTP:STC:ACTIVEX:IENIPP': '4996',
 'NETBIOS:DIR:CD-DOTDOT': '4997',
 'NFS:OVERFLOW:BUF-OVERFLOW': '4998',
 'SPYWARE:TROJAN:OPTIXLITE': '4999',
 'DNS:INFO:XFER-GOOD': '5000',
 'LPR:INVALID:EOF': '5001',
 'RTSP:OVERFLOW:LOADTEST-PW-OF': '5002',
 'DB:MYSQL:MYSQL-LDAP-DOS': '5003',
 'HTTP:AUDIT:ROBOTS.TXT': '5004',
 'HTTP:STC:ACTIVEX:ASK-COM': '5005',
 'HTTP:STC:OPERA:FILE-URL-OF': '5006',
 'TROJAN:TELNET:USER-SATORI': '5007',
 'SPYWARE:BH:LYCOSSIDESEARCH': '5008',
 'LDAP:FAILED:BRUTE-FORCE': '5009',
 'TROJAN:MISC:M2-SERV-RESPONSE': '5010',
 'RPC:RPC.WALLD:WALLD-ERR-FTSTR': '5011',
 'HTTP:PHP:PHP-XML-CMD': '5012',
 'CHAT:AIM:SERVER-READY': '5013',
 'UDP:ZERO-DATA': '5014',
 'HTTP:3COM:CONF-DOWNLOAD': '5015',
 'HTTP:STC:CLSID:REF-29': '5016',
 'POP3:EXT:DOT-ADE': '5017',
 'TROJAN:MISC:OBLIVION-SRV-RESP': '5018',
 'DDOS:TRINITY:IRC-JOIN': '5019',
 'SPYWARE:RAT:FRAG-ROCK-2-0': '5020',
 'SPYWARE:BP:BROWSERACCELERATOR30': '5021',
 'HTTP:SQL:INJ:HEADER-1': '5022',
 'VOIP:SIP:LIMITS:CONTENT-TYPE-OF': '5023',
 'TROJAN:MISC:MOSUCKER-SERV-RESP': '5024',
 'HTTP:STC:CLSID:ACTIVEX:AX-93': '5025',
 'HTTP:STC:MOZILLA:TITLE-OF': '5026',
 'APP:TUN:GPRS-TUNNEL': '5027',
 'HTTP:STC:CLSID:ACTIVEX:AX-119': '5028',
 'RADIUS:MSG_TOO_SHORT': '5029',
 'SPYWARE:TROJAN:POISONIVY230': '5030',
 'RADIUS:ACC_ACCEPT_INV_NATTRS': '5031',
 'SMTP:EXCHANGE:DOS': '5032',
 'SSH:BRUTE-LOGIN': '5033',
 'SPYWARE:KL:STEALTHACTREPORTER': '5034',
 'HTTP:STC:CLSID:REF-51': '5035',
 'HTTP:INFO-LEAK:COFFEECUP': '5036',
 'SPYWARE:GM:VIRTUALBOUNCER': '5037',
 'HTTP:PKG:DB4WEB-FILE-ACCESS-LIN': '5038',
 'SMTP:AUDIT:REP-NESTED-REPLY': '5039',
 'P2P:AUDIT:GNUTELLA-UNSUP-VER': '5040',
 'SMB:INFO:LANMAN-2.1': '5041',
 'SSH:ERROR:INVALID-HEADER': '5042',
 'APP:CITRIX:AGENT-OF': '5043',
 'HTTP:STC:CLSID:ACTIVEX:AX-08': '5044',
 'CHARGEN:ECHO-DOS': '5045',
 'SCAN:MISC:USER-LIST': '5046',
 'FTP:AUDIT:REQ-BINARY-DATA': '5047',
 'HTTP:BADBLUE:DIR-TRAVERSAL': '5048',
 'DHCP:EXPLOIT:MSG-TOO-SHORT': '5049',
 'HTTP:SQL:INJ:REMOTE-EXEC': '5050',
 'HTTP:STC:ACTIVEX:WINIMGLOG': '5051',
 'ICMP:EXPLOIT:NON-ZERO-DATA-LEN': '5052',
 'SPYWARE:BH:8848': '5053',
 'VIRUS:SMTP:DOUBLE-DOT-DOT': '5054',
 'P2P:MISC:POCO-CONNECT': '5055',
 'CHAT:IRC:OVERFLOW:XCHAT-SOCKS': '5056',
 'APP:REAL:PLAYER-MAL-META-FILE': '5057',
 'VOIP:MGCP:SDP:SYNTAX-ERROR': '5058',
 'SCAN:MISC:HTTP:DAY5DATA-PROBE': '5059',
 'SPYWARE:BH:DEEPDO_TOOLBAR': '5060',
 'HTTP:STC:IE:EXEC-CMD-FILE-SPOOF': '5061',
 'SCAN:MISC:HTTP:PERL-PROBE': '5062',
 'SPYWARE:BP:BYSOO': '5063',
 'HTTP:STC:CLSID:REF-35': '5064',
 'SHELLCODE:X86:GEN-2-TCP': '5065',
 'DNS:OVERFLOW:INVALID-POINTER': '5066',
 'IP:EXPLOIT:SAME-SRC-DST': '5067',
 'SPYWARE:TROJAN:COLDFUSION10': '5068',
 'SPYWARE:AD:IZITOTOOLBAR': '5069',
 'SCAN:CYBERCOP:UDP-BOMB': '5070',
 'DDOS:TRIN00:DAEMON-CMD-XYZ': '5071',
 'SPYWARE:TROJAN:CROSSFIRESTROJAN': '5072',
 'HTTP:TOMCAT:DIRLIST': '5073',
 'VOIP:SIP:AUDIT:INV-CHAR-HIGH': '5074',
 'HTTP:IIS:ASN-1-BOF': '5075',
 'SNMPTRAP:INFO:ERR_STAT_BAD_VAL': '5076',
 'VOIP:SIP:KEEP-ALIVE-2': '5077',
 'SCAN:CORE:DNS-STD-QUERY': '5078',
 'DOS:NETDEV:WEBJET-FRAMEWORK': '5079',
 'SCAN:MISC:X11-XTERM-OF-UDP': '5080',
 'HTTP:STC:CLSID:ACTIVEX:MS-MDAC3': '5081',
 'SCAN:APPDETECTIVE:HTTP-UA': '5082',
 'HTTP:STC:CLSID:REF-42': '5083',
 'SMB:EXPLOIT:GREENAPPLE': '5084',
 'P2P:MORPHEUS:MORPHEUS': '5085',
 'SPYWARE:UTIL:AMPLIFYTOOLBAR': '5086',
 'HTTP:MISC:AVAILABLEMEDIA-REQ': '5087',
 'HTTP:TOMCAT:JSP-BUFFER': '5088',
 'HTTP:STC:CLSID:REF-22': '5089',
 'HTTP:WHATSUP:INSTANCENAME-OF': '5090',
 'MS-RPC:ERR:EPM-INV-OP-NUM': '5091',
 'PROTOCOLS:TRAFFIC:NOT-TELNET': '5092',
 'OS:LINUXX86:LPRNG-OF': '5093',
 'POP3:EXT:DOT-WMF': '5094',
 'P2P:MISC:KUGOO': '5095',
 'POP3:AUDIT:COMMAND-FAILED': '5096',
 'SPYWARE:RAT:BACKATTACK': '5097',
 'HTTP:INFO-LEAK:ASP-WEB-CONFIG': '5098',
 'VOIP:MGCP:AUDIT:INV-CMD-HDR': '5099',
 'SNMP:ENCODING:TT-TOO-BIG': '5100',
 'HTTP:CGI:ROADS-FILE-DISCLOSURE': '5101',
 'APP:CISCO:ACS-OF': '5102',
 'DDOS:TRIN00:DAEMON-CMD-SHI': '5103',
 'TROJAN:Y3K-RAT:Y3K14-RAT-TCP': '5104',
 'RUSERS:INFO:UNKNOWN-PROG': '5105',
 'APP:MOZY-ACTY': '5106',
 'HTTP:XSS:MAILMAN-ADMIN': '5107',
 'HTTP:STC:CLSID:ACTIVEX:AX-111': '5108',
 'HTTP:STC:CLSID:ACTIVEX:XMLCORE': '5109',
 'TROJAN:MISC:RBT-PROBE': '5110',
 'HTTP:STC:CLSID:ACTIVEX:AX-36': '5111',
 'DHCP:OPT:INV-OPT-VAL': '5112',
 'SPYWARE:KL:FEARLESSKEYSPY': '5113',
 'APP:KERBEROS:GSS-ZERO-TOKEN': '5114',
 'HTTP:CGI:LIBCGI-RFP-OVERWRITE': '5115',
 'HTTP:COLDFUSION:EXPRCALC-OPNFIL': '5116',
 'SNMPTRAP:INFO:STAT_INCON_VAL': '5117',
 'SCADA:MODBUS:BUSY-EXCEPTION': '5118',
 'SCAN:MISC:HTTP:PUT': '5119',
 'FTP:PASSWORD:LRKR0X': '5120',
 'SPYWARE:KL:PERFECTKEYLOGGER-FTP': '5121',
 'HTTP:STC:ATL:CISCO-UNITY': '5122',
 'APP:CA:ARCSRV:TCP-BOF': '5123',
 'TFTP:FNAME-NOT-T2': '5124',
 'MS-RPC:LOC-SVC-OF-2': '5125',
 'SSL:INVALID:SVR-HELLO-FMT': '5126',
 'POP3:EXT:DOT-MDE': '5127',
 'SMB:ENUM:NAME-LOOKUP': '5128',
 'TROJAN:MISC:UPLOADER-LOGIN-REQ': '5129',
 'HTTP:PROXY:WPAD-CONNECTION': '5130',
 'SPYWARE:AD:VX2-LOCALNRD': '5131',
 'HTTP:PROXY:HTTP-PROXY-GET': '5132',
 'HTTP:STC:CLSID:ACTIVEX:AX-15': '5133',
 'VOIP:MGCP:INVALID-HEX-HIGH': '5134',
 'CHAT:IRC:INVALID:ARGS': '5135',
 'VNC:ERR:SVR-CUT-OVERFLOW': '5136',
 'TROJAN:MISC:RPM-COMMAND': '5137',
 'P2P:GNUTELLA:X-GNUTELLA': '5138',
 'APP:CA:ARCSRV:MEDIASERVER-BO': '5139',
 'SPYWARE:TROJAN:CRASHCOOL-1-1': '5140',
 'SPYWARE:AD:BROWSERPAL': '5141',
 'APP:RETRO-CL-BO': '5142',
 'SHELLCODE:BSDX86:GEN-1-PKT': '5143',
 'NNTP:INN:INND-OF1': '5144',
 'DB:MYSQL:LOGIN-FAILED': '5145',
 'SPYWARE:AD:WEBSEARCH': '5146',
 'CHAT:AUDIT:YMSG:ACTIVITY': '5147',
 'GOPHER:INVALID:PORT': '5148',
 'RTSP:SETUP': '5149',
 'SPYWARE:AD:BROADCASTPC': '5150',
 'DB:ORACLE:ORCL-TRAV': '5151',
 'TROJAN:MYDOOM:AH-HTTP-INFECT': '5152',
 'HTTP:STC:ACTIVEX:MDAC-DATASPACE': '5153',
 'SMTP:VULN:MAILENABLE-FS': '5154',
 'HTTP:WEBSTER:LONG-GET-REQ': '5155',
 'WORM:SASSER:FTP-SRV-OVERFLOW': '5156',
 'HTTP:STC:CLSID:ACTIVEX:IP-AX2': '5157',
 'HTTP:STC:CLSID:ACTIVEX:AX-105': '5158',
 'TCP:AUDIT:S2C-OLD-ESTB': '5159',
 'HTTP:STC:IE:WMP-AUDIO-MOD': '5160',
 'LDAP:INVALID:SRCH-TIMELIMIT-INV': '5161',
 'APP:EMC-DOS': '5162',
 'TCP:OPTERR:ZERO-LENGTH': '5163',
 'WORM:SANTY:INFECT-ATTEMPT': '5164',
 'ICMP:AUDIT:REQUEST-RESND': '5165',
 'SPYWARE:RAT:REMOTER': '5166',
 'VOIP:H225RAS:DOS:ARQ': '5167',
 'SSL:INVALID:CIPHER-LEN': '5168',
 'APP:TUN:ESP-TUNNEL': '5169',
 'HTTP:STC:CLSID:REF-46': '5170',
 'HTTP:SQL:INJ:AGENT-ADMIN': '5171',
 'HTTP:CISCO:SCANNER-PROBE': '5172',
 'WORM:COMMWARRIORB': '5173',
 'LPR:OVERFLOW:C-JOB': '5174',
 'TROJAN:TELNET:USER-FRIDAY': '5175',
 'MISC:CONEXANT-LOGIN': '5176',
 'SNMP:ENCODING:MALFORMED-OID': '5177',
 'VOIP:SMPP:NOKIA-SMS-MMS-DOS': '5178',
 'TCP:AUDIT:NONSYN-SACKPERM': '5179',
 'HTTP:STC:CLSID:ACTIVEX:WZIP-AX': '5180',
 'HTTP:PHP:PHPBB:DL-SQL-INJ': '5181',
 'TFTP:FILE:ADMIN-DLL': '5182',
 'NNTP:AUDIT:NESTED-REQ': '5183',
 'SCAN:AMAP:FTP-ON-HTTP': '5184',
 'VIRUS:SMTP:NIMDA': '5185',
 'HTTP:STC:IMG:JPEG-MAL-MARKER': '5186',
 'VNC:AUDIT:AUTH-SCHEME': '5187',
 'NTP:ERROR:CTL_VAR_VALUE_2LONG': '5188',
 'SNMP:ENCODING:INT-TOO-BIG': '5189',
 'SPYWARE:BH:123MANIA': '5190',
 'TROJAN:MISC:INSANE-SRV-RESP': '5191',
 'HTTP:STC:CLSID:ACTIVEX:AX-86': '5192',
 'DOS:NETDEV:NORTEL-MARLIN': '5193',
 'HTTP:STC:CLSID:ACTIVEX:AX-153': '5194',
 'SMTP:EXCHANGE:OWA-JSCRIPT': '5195',
 'HTTP:STC:ACTIVEX:VERYPDF': '5196',
 'POP3:EXT:DOT-WSH': '5197',
 'HTTP:STC:CLSID:ACTIVEX:AX-98': '5198',
 'APP:APT-WWW-PROXY:AWPLOG-DOS': '5199',
 'CHARGEN:TRAFFIC': '5200',
 'SCAN:MISC:HTTP:AXS-ACCESS': '5201',
 'HTTP:APACHE:PHP-DOS': '5202',
 'HTTP:INFO-LEAK:WR850-CONF-DL': '5203',
 'IP:INFO:INVALID-DESTINATION': '5204',
 'SMTP:EXPLOIT:QWIKMAIL': '5205',
 'SCAN:MISC:HTTP:NESSUS-HTTP': '5206',
 'APP:QT-SERVER:QT-DEVURL-DOS': '5207',
 'SPYWARE:BH:GETMIRAR': '5208',
 'SMTP:EXT:DOT-VB': '5209',
 'VOIP:MGMT:XPRESSA-HTTP-DOS': '5210',
 'MS-RPC:WEBCLIENT-OF': '5211',
 'SPYWARE:AD:DELUXECOMMUNICATIONS': '5212',
 'FTP:PABLO-FTP:FORMAT-STRING': '5213',
 'SPYWARE:TROJAN:SNAKETROJAN': '5214',
 'HTTP:STC:HHP-PARA-OF': '5215',
 'HTTP:PHP:THATWARE:THATFILE-INC': '5216',
 'NFS:AUDIT:UNKNOWN-VER': '5217',
 'SCAN:MISC:HTTP:STORE-ACCESS': '5218',
 'IMAP:AUDIT:REQ-BINARY-DATA': '5219',
 'HTTP:STC:IE:INFOBAR-DOWNLOAD': '5220',
 'PORTMAPPER:INVALID:BAD-VERF-CRD': '5221',
 'VOIP:SIP:MULTI-TECH-INVITE-OF': '5222',
 'TROJAN:TELNET:USER-HIDEPAK': '5223',
 'SMTP:OVERFLOW:FILENAME': '5224',
 'TCP:AUDIT:OPTIONS-UNNEGOT-TS': '5225',
 'SCAN:MISC:HTTP:ENVIRON-CGI': '5226',
 'HTTP:STC:CLSID:ACTIVEX:AX-40': '5227',
 'SPYWARE:RAT:BEAST202-STC': '5228',
 'HTTP:UNIX-FILE:ETC-HOSTS-ALLOW': '5229',
 'HTTP:IIS:IISADMPWD-PROXY-PASSWD': '5230',
 'SPYWARE:TROJAN:HTTPRAT': '5231',
 'TROJAN:MISC:ILLUSION-1-0': '5232',
 'SPYWARE:RAT:CIA1-22-FTP': '5233',
 'FTP:PROFTP:OVERFLOW1': '5234',
 'TROJAN:DONALDDICK:SERVER-RES': '5235',
 'SPYWARE:TROJAN:BERSEK1.0': '5236',
 'HTTP:STC:CLSID:REF-39': '5237',
 'SPYWARE:AD:ASKJEEVESTOOLBAR': '5238',
 'HTTP:STC:CLSID:ACTIVEX:AX-132': '5239',
 'SMTP:EXT:DOT-CHM': '5240',
 'CHAT:MSN:PNG-PARSE': '5241',
 'APP:VERITAS:COMMAND-CHAIN': '5242',
 'NFS:INVALID:INVALID-CMODE': '5243',
 'HTTP:PHP:FI-DIR-TRAVERSAL': '5244',
 'LPD:OPT-OF': '5245',
 'SCAN:MISC:HTTP:RWWWSH-ACCESS': '5246',
 'APP:PROXY:SQUID-WCCP-DOS': '5247',
 'NTP:CTL_ERR_RSP_SEEN': '5248',
 'HTTP:STC:BT:CLIENT-VULN': '5249',
 'MS-RPC:ERR:INV-PTYPE': '5250',
 'VOIP:H225SGN:SETUP-NOTGRANT-IP': '5251',
 'HTTP:DOMINO:POST-DOS3': '5252',
 'DB:MYSQL:LOGIN-OVERFLOW': '5253',
 'SPYWARE:KL:POWERSPY': '5254',
 'SMB:OF:NETWARE-CLIENT-RPC': '5255',
 'TROJAN:MISC:OPTIX-PRO-CONN': '5256',
 'SPYWARE:AD:YOURENHANCEMENT': '5257',
 'APP:CA:LIC-PUTOLF-OF': '5258',
 'VOIP:SIP:LIMITS:ORGANIZATION-OF': '5259',
 'CHAT:AUDIT:IRC-CMD-CHR': '5260',
 'SSH:OVERFLOW:FREESSHD-KEY-OF': '5261',
 'SPYWARE:KL:DESKTOPDETECTIVE': '5262',
 'SPYWARE:AD:ZTOOLBAR': '5263',
 'POP3:OVERFLOW:USER': '5264',
 'TROJAN:MISC:ACID-BATTERY-CMD': '5265',
 'SPYWARE:KL:NETTRACK-SPY': '5266',
 'HTTP:CGI:CVSWEB-CGI-SEMICOLON': '5267',
 'APP:SVN-DATE-OF': '5268',
 'SMTP:RESPONSE:RLY-ACC-DENIED': '5269',
 'SPYWARE:BH:SIDEFIND-1-0': '5270',
 'HTTP:CGI:WEBSPIRS-FILE-DISCLSR': '5271',
 'SPYWARE:AD:BARGAINBUDDY': '5272',
 'DB:MS-SQL:XP_CMDSHELL-TDS': '5273',
 'SPYWARE:TROJAN:ONE': '5274',
 'HTTP:STC:CLSID:ACTIVEX:CTX-ICA': '5275',
 'SPYWARE:BH:CWSSTARTPAGE-2': '5276',
 'SCADA:DNP3:WRITE': '5277',
 'VOIP:MGCP:AUDIT:INV-PARM-RM': '5278',
 'P2P:GNUCLEUSLAN:BROADCAST': '5279',
 'SPYWARE:RAT:COMA-CTS': '5280',
 'SNMP:COMMUNITY:INTERNAL': '5281',
 'HTTP:CYCLADES:SAVEUSER-PRIV': '5282',
 'HTTP:STC:CLSID:ACTIVEX:AX-26': '5283',
 'P2P:NAPSTER:NEW-USER-LOGIN-7777': '5284',
 'SCAN:MISC:HTTP:WIN-TELNET-EXE': '5285',
 'SPYWARE:TROJAN:ACCESSREMOTEPC': '5286',
 'SPYWARE:RAT:FORCEDCONTROL': '5287',
 'CHAT:AUDIT:AIM:INVALID-TLV': '5288',
 'DHCP:ERROR:INV-MAGIC-COOKIE': '5289',
 'HTTP:STC:VULN:IMAIL-8-13': '5290',
 'HTTP:IIS:MDAC-RDS': '5291',
 'NETBIOS:ACCESS:D-DRIVE': '5292',
 'SMB:EXPLOIT:LINUX-TRANS2-OF': '5293',
 'SPYWARE:BH:PERSONALWEB': '5294',
 'SPYWARE:AD:EXACTSEARCH': '5295',
 'HTTP:STC:CLSID:ACTIVEX:AX-144': '5296',
 'TROJAN:MISC:MEETLAMER-COMMAND': '5297',
 'TROJAN:MISC:WINCRASH10-SRV-RDY': '5298',
 'HTTP:STC:CLSID:ACTIVEX:AX-49': '5299',
 'APP:HPOVNNM:OVALARMSRV-OF': '5300',
 'DB:ORACLE:ORACLE-DSI': '5301',
 'SPYWARE:AD:ICOOLOADER25': '5302',
 'POP3:OUTLOOK:TROUBLE-QUERY-OF': '5303',
 'VOIP:MGCP:AUDIT:UNKNOWN-METHOD': '5304',
 'SPYWARE:KL:EYESPYPRO': '5305',
 'VOIP:SIP:EMERGENCY-PRIORITY': '5306',
 'SCAN:CORE:IIS-ASP-CHUNKED': '5307',
 'TROJAN:MISC:FBACKDOOR-SRV-RESP': '5308',
 'SPYWARE:RAT:PRORAT1-9': '5309',
 'SHELLCODE:SCO:GEN-2-PKT': '5310',
 'HTTP:STC:ACTIVEX:CODEBASE-2': '5311',
 'HTTP:STC:CLSID:ACTIVEX:AX-35': '5312',
 'TELNET:OVERFLOW:OPTION': '5313',
 'TELNET:FAILURE:LOGIN-INCORRECT': '5314',
 'APP:CA:RPC-MSG-OF': '5315',
 'TCP:C2S:EVASION:C2S-ESTB-SYN': '5316',
 'TROJAN:BACKCONSTR:FTP-ON': '5317',
 'HTTP:CGI:AWSTATS': '5318',
 'SPYWARE:AD:WINSYSBA': '5319',
 'HTTP:STC:ACTIVEX:WMEX': '5320',
 'DB:ORACLE:DBMS-CDC': '5321',
 'HTTP:PKG:ANACONDA-DIR-TRAVERSAL': '5322',
 'TROJAN:MS-04-028:BACKDOOR-LOGIN': '5323',
 'SPYWARE:BP:RUSSIAN-SEARCHBAR': '5324',
 'DNS:BIND-NXT-OVERFLOW1': '5325',
 'HTTP:PHP:PHPNUKE:DELADMIN': '5326',
 'HTTP:STC:CLSID:ACTIVEX:BB-PURE': '5327',
 'HTTP:OVERFLOW:CHUNKS-TOO-SMALL': '5328',
 'TROJAN:MISC:NETTRASH-COMMAND': '5329',
 'IKE:INV-DER-LEN': '5330',
 'TROJAN:MISC:ASYLUM-COMMAND': '5331',
 'SMTP:MAL:SQM-CONTENT-XSS': '5332',
 'TROJAN:TELNET:USER-BACKDOOR': '5333',
 'HTTP:STC:ADOBE:PDF-JAVASCRIPT': '5334',
 'POP3:EXT:DOT-SCT': '5335',
 'APP:AI:NO-MATCH': '5336',
 'FTP:PROFTP:OFF-BY-ONE': '5337',
 'POP3:AUDIT:REQ-UNKNOWN-CMD': '5338',
 'TFTP:AUDIT:S2C-UNEXP-ACK': '5339',
 'HTTP:STC:ACTIVEX:DSHOW-FILTER': '5340',
 'SMTP:EXT:DOT-ZIP': '5341',
 'APP:WMP:DSHOW-BIGCHUNK-SMTP': '5342',
 'ICMP:EXPLOIT:DIFF-LEN-IN-RESND': '5343',
 'HTTP:TUNNEL:CHAT-MSN-IM': '5344',
 'SPYWARE:RAT:FREAK': '5345',
 'TROJAN:GATECRASHER:GC-PROBE': '5346',
 'POP3:EXT:DOT-SCR': '5347',
 'SPYWARE:AD:PRAIZETOOLBAR': '5348',
 'SPYWARE:AD:DOGPILETOOLBAR': '5349',
 'SPYWARE:KL:MG-SHADOW20': '5350',
 'SPYWARE:AD:HANSONELLISTOOLBAR': '5351',
 'TFTP:FILE:PASSWD-MAKREC': '5352',
 'HTTP:PKG:EWAVE-SERVLET-DOS': '5353',
 'HTTP:CGI:ALIBABA-REMOTE-EXEC': '5354',
 'SCAN:NMAP:XMAS': '5355',
 'RPC:RPC.STATD:STATD-FMT-STR5': '5356',
 'DB:MS-SQL:SQLMON-MALFORM-DOS': '5357',
 'HTTP:STC:CLSID:ACTIVEX:AX-51': '5358',
 'WORM:DABBER:SASSER-PROBE': '5359',
 'PROTOCOLS:TRAFFIC:NOT-DHCP': '5360',
 'SPYWARE:KL:FKWP-KEYLOGGER': '5361',
 'SPYWARE:RAT:SHNAPPZHTTPRAT': '5362',
 'HTTP:STC:CANVAS-BABYBOTTLE': '5363',
 'TROJAN:MISC:PITFALL-SERV-RESP': '5364',
 'DNS:OVERFLOW:DNS-ATMA-SIZE-OF': '5365',
 'SCAN:CERBERUS:HTTP': '5366',
 'APP:TUN:PACKETIX-VPN-CONNECT': '5367',
 'HTTP:STC:IE:CSS-XDOM-DISC': '5368',
 'HTTP:STC:IE:HTML-OB-MEM': '5369',
 'SMTP:AUDIT:EMPTY-BOUNDARY': '5370',
 'SPYWARE:RAT:BIONET405-STC': '5371',
 'HTTP:EXPLOIT:AMBIG-CONTENT-LEN': '5372',
 'SMTP:DOS:SMARTMAIL-DOS': '5373',
 'VNC:ERR:CONFLICT-HEXTILE-MASK': '5374',
 'DB:ORACLE:SYS-LT-WKRSPC-INJ': '5375',
 'VOIP:SIP:SDP:MAL-HEADER': '5376',
 'HTTP:IIS:ISAPI-PRINTER-OVERFLOW': '5377',
 'SPYWARE:UTIL:SPYBLOCS-EBLOCS': '5378',
 'HTTP:STC:YM-DLL-OF': '5379',
 'HTTP:STC:ACTIVEX:AURIGMA': '5380',
 'CHAT:AUDIT:YMSG:FILE-NAME': '5381',
 'APP:GAME:EAD-LOGIN': '5382',
 'SCAN:MISC:HTTP:ADMADM-HTM-PROBE': '5383',
 'TROJAN:MYDOOM:MYDOOM-TROJAN': '5384',
 'HTTP:STC:CLSID:ACTIVEX:PAVPZ': '5385',
 'HTTP:CGI:ORACLE-RPT-INFOLEAK': '5386',
 'SPYWARE:AD:DESKTOPMEDIA': '5387',
 'SPYWARE:AD:GEOMUNDOSTOOLBAR': '5388',
 'CHAT:AUDIT:YMSG:CONF-NAME': '5389',
 'SCAN:MFS-PROBE': '5390',
 'SPYWARE:UTIL:COPERNICMETABAR': '5391',
 'HTTP:HOTMAIL:LIVE-ACTIVITY': '5392',
 'DOS:NETDEV:LINKSYS-GOZILA-DOS3': '5393',
 'RPC:REQERR:REQ-INVALID-PROC': '5394',
 'HTTP:INFO-LEAK:DS-STORE': '5395',
 'SCAN:MISC:HTTP:QUID-PRO-QUO-LOG': '5396',
 'SHELLCODE:X86:RH80-85PXE': '5397',
 'SPYWARE:RAT:ERAZER-ICQ': '5398',
 'HTTP:STC:ACTIVEX:SAP-IRRFC-OF': '5399',
 'HTTP:STC:IE:EXCEL-POP-UP': '5400',
 'HTTP:STC:IE:CROSS-FRAME-SCRIPT': '5401',
 'HTTP:STC:ACTIVEX:AXIS-CAMERA': '5402',
 'HTTP:STC:CLSID:ACTIVEX:SQLDMO': '5403',
 'P2P:GNUTELLA:LIMEWIRE-DIR-TRANS': '5404',
 'TCP:AUDIT:OLD-SYNACK': '5405',
 'HTTP:STC:ACTIVEX:MACINSTALL': '5406',
 'HTTP:STC:CLSID:ACTIVEX:ORACJI': '5407',
 'POP3:EXT:DOT-ADP': '5408',
 'MS-RPC:ERR:CL-PTYPE-IN-CO-PDU': '5409',
 'SCAN:MISC:FTP:PATH-LINUX-X86-1': '5410',
 'HTTP:PHP:GALLERY:HTTP-VARS': '5411',
 'SPYWARE:GM:SAH-CASHBACK': '5412',
 'HTTP:STC:IE:MHTML-REDIR-INFO': '5413',
 'LPR:OVERFLOW:C-WIDTH': '5414',
 'VIRUS:SMTP:EICAR-ATTACHMENT': '5415',
 'SPYWARE:KL:ARDAMAXKEYLOGGER': '5416',
 'HTTP:IIS:SAM-DOWNLOAD-ATTEMPT': '5417',
 'APP:REMOTE:TIMBUKTU-AUTH-OF': '5418',
 'SPYWARE:AD:TVZSEARCH': '5419',
 'SCADA:DNP3:DISABLE-RESP': '5420',
 'SPYWARE:GM:UFIXER2007': '5421',
 'HTTP:OVERFLOW:CONTENT-LANGUAGE': '5422',
 'SPYWARE:TROJAN:CYN21': '5423',
 'SPYWARE:RAT:PORTALOFDOOM3-0': '5424',
 'ICMP:EXPLOIT:DIFF-LEN-IN-RESP': '5425',
 'HTTP:OVERFLOW:ACCEPT-LANGUAGE': '5426',
 'LDAP:OVERFLOW:ENC-TAG-VAL-OF': '5427',
 'SNMP:ERROR:INVALID_TIMETICKS': '5428',
 'DB:MYSQL:LOGIN-NO-PSWD': '5429',
 'DNS:EXPLOIT:PNTRS-PERNAME-EXCD': '5430',
 'WORM:LOVGATE:P-NET-SHARE-SPREAD': '5431',
 'SPYWARE:GM:TWISTER': '5432',
 'HTTP:CGI:VIRTUAL-VISION-TRVRSL': '5433',
 'SNMP:COMMUNITY:FORMAT-CHAR': '5434',
 'HTTP:TOMCAT:XPL-FILE-DISC': '5435',
 'P2P:NAPSTER:DATA-4444': '5436',
 'SPYWARE:AD:WHENU-CLOCKSYNC': '5437',
 'MS-RPC:DCOM:SVRNAME-2LONG': '5438',
 'SNMPTRAP:ERROR:INV_GAUGE_VAL': '5439',
 'DB:MYSQL:ROOT-USER': '5440',
 'DB:ORACLE:DEFAULT-PW-SCOTT': '5441',
 'SMTP:VULN:CMAILSERVER': '5442',
 'TROJAN:GIRLFRIEND:SERVER-RES': '5443',
 'SNMP:INFO:ERR_STAT_NOT_WRITABLE': '5444',
 'VOIP:SIP:SECURITY-PAR-UFLOW': '5445',
 'SNMP:ENCODING:COUNTER-TOO-BIG': '5446',
 'SCADA:IEC104:TYPE-U': '5447',
 'SNMPTRAP:ERROR:INV_TIMETICKS': '5448',
 'POP3:ERROR:DUPLICATE_BOUNDARY': '5449',
 'HTTP:STC:MOZILLA:FF-WYCIWYG': '5450',
 'HTTP:PHP:PAGETOOL-SQL-INJ': '5451',
 'HTTP:STC:CLSID:ACTIVEX:ISUSWEB': '5452',
 'SSH:PRAGMAFORT-KEY-OF': '5453',
 'SNMPTRAP:AUDIT:PUBLIC': '5454',
 'HTTP:STC:CLSID:ACTIVEX:AX-80': '5455',
 'IDENT:AUDIT:RESPONSE': '5456',
 'SCAN:MISC:HTTP:POSTINFO-ASP': '5457',
 'HTTP:CGI:YABB-DIR-TRAVERSAL': '5458',
 'FTP:USER:FORMAT-STRING': '5459',
 'HTTP:PHP:PHPNUKE:SID-SQL-INJECT': '5460',
 'SYSLOG:AUDIT:MISSING-TS': '5461',
 'SMTP:RESPONSE:PIPE-FAILED': '5462',
 'PORTMAPPER:INFO:CALLIT-PROC': '5463',
 'DB:ORACLE:SYS-KUPVFT-SQL-INJ': '5464',
 'DB:ORACLE:DEFAULT-PW-ORDPLUGINS': '5465',
 'APP:DISTCC-EXEC': '5466',
 'SMTP:EXT:DOT-SCR': '5467',
 'HTTP:STC:NORTON:NAV-AX-DOS': '5468',
 'HTTP:STC:CLSID:REF-38': '5469',
 'SCAN:MISC:HTTP:NPH-PUBLISH': '5470',
 'RPC:RPC.STATD:STATD-FMT-STR2': '5471',
 'DOS:NETDEV:CISCO-RTR-DOS': '5472',
 'HTTP:STC:STREAM:AVI': '5473',
 'HTTP:STC:IMG:ANI-BLOCK-STR2': '5474',
 'WORM:AGOBOT:SASSER-FTP-OF': '5475',
 'POP3:EXT:DOT-ISP': '5476',
 'SPYWARE:KL:WINSPY': '5477',
 'MS-RPC:ERR:FRAG-BIGGER-THAN-NEG': '5478',
 'NETBIOS:NBNS:INVALID:HDR-CNT': '5479',
 'HTTP:PKG:CARBO-FILE-DISCLSR': '5480',
 'SCADA:ICCP:WRONG-AB-PARAMETER': '5481',
 'HTTP:IIS:COMMAND-EXEC-4': '5482',
 'SCAN:MISC:FTP:FTP-MKD': '5483',
 'SPYWARE:AD:GIRAFATOOLBAR': '5484',
 'P2P:AUDIT:SOFTETHER-SSH': '5485',
 'SPYWARE:AD:PAYPERCLICK': '5486',
 'SCAN:CANVAS:NOVELL2': '5487',
 'DNS:AUDIT:TYPE-OBSOLETE': '5488',
 'HTTP:STC:HSC:HCP-QUOTE-SCRIPT': '5489',
 'SCAN:MISC:HTTP:MINISTATS-ADM': '5490',
 'SPYWARE:DM:DWN-ARL': '5491',
 'SPYWARE:AD:BLUBSTER-2X': '5492',
 'SCADA:MODBUS:READ-ID': '5493',
 'SPYWARE:BP:ZQUEST-COOKIE': '5494',
 'SPYWARE:AD:HOTBOTDESKBAR': '5495',
 'DB:ORACLE:REPORTS-XML-DISC': '5496',
 'HTTP:STC:VULN:APACHE-1-3-28': '5497',
 'TROJAN:HXDEF-CLONE': '5498',
 'SPYWARE:BH:SEARCHNUGGET': '5499',
 'SNMPTRAP:AUDIT:PRIVATE': '5500',
 'DNS:OVERFLOW:NAME-TOO-LONG': '5501',
 'P2P:WINMX:CLIENT-NET-PROBE': '5502',
 'SMTP:MAL:BMP-MAL-HEADER': '5503',
 'HTTP:STC:MAL-MDB': '5504',
 'SMTP:OVERFLOW:OUTLOOK-CERT-OF': '5505',
 'HTTP:STC:MOZILLA:EVENT-DLOAD': '5506',
 'APP:WINAMP:CDA-DEV-NAME-OF': '5507',
 'TFTP:OPERATION:GET': '5508',
 'HTTP:PHP:PHPMYNEWS-INCLUDE': '5509',
 'P2P:MISC:OPENFT': '5510',
 'SPYWARE:RAT:SHNAPPZHTTPRAT-SMTP': '5511',
 'SMTP:EXT:DOT-VBS': '5512',
 'SMTP:EXT:DOT-URL': '5513',
 'HTTP:STC:CLSID:ACTIVEX:HPQUTIL': '5514',
 'SCAN:MISC:HTTP:REQ-HTTP-CONF': '5515',
 'TROJAN:MISC:PROGENIC-COMMAND': '5516',
 'POP3:OVERFLOW:PCCILLIN-POP-OF': '5517',
 'SPYWARE:RAT:ALEXMESSOMALEX-CTS': '5518',
 'SCADA:WWSUITE': '5519',
 'P2P:EDONKEY:FILE-DOWNLOAD-REQ': '5520',
 'SCAN:MISC:HTTP:SRCH-HTM-PROBE': '5521',
 'HTTP:STC:IMG:JPEG-WIDTH-OF': '5522',
 'HTTP:NETSCAPE:WP-START-VER': '5523',
 'APP:FEDORA-DIR-SER-INFO-LEAK': '5524',
 'HTTP:STC:IE:ZONE-SPOOF': '5525',
 'SPYWARE:TROJAN:LAMERAT10': '5526',
 'APP:POSTFIX-GLD-FS': '5527',
 'PROTOCOLS:TRAFFIC:NOT-HTTP': '5528',
 'TROJAN:MISC:INCOMMAND-SVR-VER': '5529',
 'IP:AUDIT:HAS-IP-OPTIONS': '5530',
 'HTTP:CGI:BATCH-PIPE': '5531',
 'HTTP:STC:IE:HELPCTR-CODE-EX': '5532',
 'HTTP:INVALID:HDR-FIELD': '5533',
 'VOIP:SIP:OVERFLOW:FROM-OF': '5534',
 'HTTP:IIS:WEBDAV:SEARCH-OF': '5535',
 'SHELLCODE:SPARC:GEN-1-TCP': '5536',
 'DB:MS-SQL:SQLMON-STACK-OFLOW': '5537',
 'SCAN:MISC:HTTP:RESPONDER-ACCESS': '5538',
 'HTTP:DOMINO:SAMETIME-URL-OF': '5539',
 'HTTP:STC:IMG:ANI-BLOCK-STR': '5540',
 'SCAN:APPDETECTIVE:HTTPS': '5541',
 'SPYWARE:AD:CASINOONNET': '5542',
 'FTP:PASSWORD:WH00T': '5543',
 'SPYWARE:TROJAN:HOTMAILHACKER5': '5544',
 'SPYWARE:KL:SUPREMESPY': '5545',
 'APP:RWHOISD:RWHOISD-FS': '5546',
 'CHAT:MSN:FILE-TRANS': '5547',
 'HTTP:STC:IE:SHELL-WEB-FOLDER': '5548',
 'SCAN:MISC:HTTP:UNIX-BIN-CC': '5549',
 'HTTP:PHP:PHPZIPURL': '5550',
 'HTTP:APACHE:LONG-HEADER-DOS': '5551',
 'VOIP:SIP:SDP:HEADER-RPT-ERR': '5552',
 'SPYWARE:KL:WEBMAILSPY': '5553',
 'NETBIOS:ACCESS:C-DRIVE': '5554',
 'APP:TROLLTECH-QT-BMP-OF': '5555',
 'TCP:AUDIT:C2S-RST-DATA': '5556',
 'HTTP:PHP:LOKWABB-PRIVM': '5557',
 'DOS:NETDEV:CISCO-SYSLOG-DOS': '5558',
 'HTTP:STC:ACTIVEX:JBOX': '5559',
 'TROJAN:MISC:BACKAGE-COMMAND': '5560',
 'HTTP:XSS:MS-W3WHO-XSS': '5561',
 'SPYWARE:BH:CNSMIN-3721': '5562',
 'SPYWARE:AD:VEGASPALMSCASINO': '5563',
 'SMTP:EXPLOIT:MIME-TOOLS-EVADE': '5564',
 'HTTP:YAHOO:ATTACHMENT-UPLOAD': '5565',
 'NNTP:ERR:INVALID-CMD': '5566',
 'DNS:EXPLOIT:SQUID-PROXY-DOS': '5567',
 'FTP:PASSWORD:SATORI': '5568',
 'TROJAN:MISC:GSPOT-COMMAND': '5569',
 'HTTP:CGI:ICAT-CARBO': '5570',
 'POP3:FAILURE:BRUTE-FORCE': '5571',
 'SCADA:CITECT-OF': '5572',
 'DNS:AUDIT:REQ-INVALID-HDR-RA': '5573',
 'MS-RPC:RRAS-BOF': '5574',
 'HTTP:INFO-LEAK:GOAHEAD-PERM': '5575',
 'TROJAN:Y3K-RAT:Y3K11-RAT-UDP': '5576',
 'SPYWARE:GM:CHILDWEBGUARDIAN': '5577',
 'RPC:RPC.SADMIND:METHOD-TRAV': '5578',
 'CHAT:AIM:MESSAGE-SEND': '5579',
 'HTTP:STC:DATA-SCHEME': '5580',
 'HTTP:STC:IE:FULLMEM-RELOAD': '5581',
 'SNMPTRAP:COMMUNITY:ZERO-LEN': '5582',
 'POP3:EXT:DOT-COM': '5583',
 'RADIUS:TYPE-DOS': '5584',
 'SPYWARE:RAT:STEALTHREDIR-TCP': '5585',
 'HTTP:CGI:BUGZILLA:CMD-PROD': '5586',
 'SSL:ENC-TAG-VALUE-TOO-BIG': '5587',
 'RADIUS:FS-INJ': '5588',
 'HTTP:IIS:DIR-TRAVERSAL-DOS2': '5589',
 'SPYWARE:GM:EDONKEY2000': '5590',
 'HTTP:STC:CLSID:ACTIVEX:ADOBE': '5591',
 'HTTP:STC:CLSID:ACTIVEX:LEN-AX': '5592',
 'CHAT:YIM:OVERFLOW:SPOOFED-NAME': '5593',
 'TROJAN:MISC:ULLYSSE': '5594',
 'SPYWARE:RAT:HUNTERGOP': '5595',
 'HTTP:MISC:ABYSS-HDR-DOS': '5596',
 'OS:LINUXX86:NTALKD-OF': '5597',
 'SPYWARE:AD:ELITE_PROTECTOR': '5598',
 'POP3:EXTERNAL_MESSAGE': '5599',
 'SCAN:MISC:HTTP:START-STOP-DOS': '5600',
 'SMTP:OVERFLOW:TEXT-LINE-OF': '5601',
 'TROJAN:COREFLOOD:TRACKER-REQ': '5602',
 'FTP:MS-FTP:IIS-BOF': '5603',
 'P2P:MISC:MANOLITO': '5604',
 'SPYWARE:RAT:FADE1-0-HTTP': '5605',
 'HTTP:STC:ACTIVEX:SHELL-APP': '5606',
 'HTTP:STC:IMG:OFFEND-TG': '5607',
 'VOIP:SIP:LIMITS:CSEQ-OF': '5608',
 'LDAP:EMPTY:ADDREQ-ATTRIB-EMPTY': '5609',
 'SMTP:MAL:AIM-BO-URL': '5610',
 'SCAN:CYBERCOP:SMTP-EXPN': '5611',
 'SMTP:MAL:TBIRD-JAVASCRIPT': '5612',
 'PORTMAPPER:ERR:LONG-NETNAME': '5613',
 'SMTP:EXT:DOT-MDE': '5614',
 'HTTP:IIS:WEBDAV:AUTH-BYPASS': '5615',
 'SPYWARE:RAT:HERMANUPLOADER-STC': '5616',
 'TFTP:MISSING-FILENAME': '5617',
 'SPYWARE:TROJAN:CLANDESTINE': '5618',
 'SPYWARE:RAT:DIGITALUPLOAD': '5619',
 'SMB:PRINT-INVALID-SIZE': '5620',
 'DB:MYSQL:FS-REQUEST': '5621',
 'SPYWARE:KL:ALLINONEKEYLOGGER': '5622',
 'SPYWARE:AD:ADDRESSESTOOLBAR': '5623',
 'WORM:NACHI:D-WEBDAV-ATK': '5624',
 'CHAT:AUDIT:MSN:IP-PORT': '5625',
 'DB:MS-SQL:RES-HEAP-OF-1': '5626',
 'TROJAN:MISC:MANTIS-COMMAND': '5627',
 'HTTP:PHP:PHPMYNEWS-FILE-ACCESS': '5628',
 'HTTP:PHP:PMACHINE-PATH-DISC': '5629',
 'SMB:AUDIT:UNK-CMD': '5630',
 'IMAP:REQERR:INVALID_LITERAL_LEN': '5631',
 'SPYWARE:KL:COMPUTERMONITORKL': '5632',
 'APP:TMIC:SP-EARTHAGENT-OF': '5633',
 'SCADA:ICCP:CN-INVALID-LENGTH': '5634',
 'TELNET:EXPLOIT:SGI-RLD': '5635',
 'SPYWARE:RAT:96MM': '5636',
 'DB:MS-SQL:USER-ADD': '5637',
 'P2P:AUDIT:GNUTELLA-TTL': '5638',
 'DOS:EMULE-DOS': '5639',
 'SCAN:AMAP:SAP-R3-ON-SSH': '5640',
 'FTP:COMMAND:SYMLINK': '5641',
 'VOIP:SIP:UNK-SRV-RESP': '5642',
 'HTTP:CGI:BOOZT-CGI-OF': '5643',
 'VOIP:SIP:RESPR-INV-OPT-OF': '5644',
 'VOIP:SIP:AUDIT:NO-COLON': '5645',
 'TFTP:WVFTP-OPTION-OF': '5646',
 'DNS:OVERFLOW:SIG-OVERFLOW': '5647',
 'HTTP:STC:BT:CLIENT-VULN5': '5648',
 'RPC:NULL-TADDR2UADDR': '5649',
 'TFTP:FILENAME-TOO-LONG': '5650',
 'DB:MS-SQL:NULL-PSWRD': '5651',
 'OS:WINDOWS:ASN-KERB-BIT': '5652',
 'DNS:AUDIT:INVALID-RCODE': '5653',
 'HTTP:IIS:HEADER-HOST-DOS': '5654',
 'HTTP:PHP:PHPNUKE:PRIV-ESC': '5655',
 'DB:MS-SQL:MAL-INSERT': '5656',
 'APP:ETHEREAL:3G-A11-B0F': '5657',
 'CHAT:AIM:AIM-FILE-EXE': '5658',
 'HTTP:IIS:ISAPI-IDQ-OVERFLOW': '5659',
 'SPYWARE:RAT:NTRC2000': '5660',
 'TFTP:DIRECTORY:DOT-DOT': '5661',
 'HTTP:IIS:ENCODING:PERC-PERC-1': '5662',
 'TCP:S2C:EXPLOIT:S2C-URG-OVERLAP': '5663',
 'SPYWARE:AD:WINPUP': '5664',
 'TROJAN:SUBSEVEN:2.1.A-SRVR-RES': '5665',
 'HTTP:STC:IMG:WMF-DOWNLOAD-2': '5666',
 'HTTP:CGI:EASY-MB-PRINT': '5667',
 'RUSERS:AUDIT:INVALID-XID': '5668',
 'NNTP:OVERFLOW:OUTLOOK-NNTP-OF': '5669',
 'TROJAN:NETSPHERE:SVR-RES-HIGH': '5670',
 'DB:ORACLE:TNS-OF': '5671',
 'SSL:CPHR-DOS': '5672',
 'DDOS:TRIN00:MASTERPW-DEF-KDIE': '5673',
 'APP:SAP:WEBAS-DOS': '5674',
 'SCADA:ICCP:INVALID-VERSION': '5675',
 'SPYWARE:TROJAN:TROJAN.KILLAV.GJ': '5676',
 'SPYWARE:AD:S1S1S1SEARCHTOOLBAR': '5677',
 'SPYWARE:RAT:ANALFTP': '5678',
 'HTTP:STC:CLSID:REF-17': '5679',
 'DB:MS-SQL:NULL-PASSWORD': '5680',
 'TELNET:EXPLOIT:SOL-AUTH-BYPASS': '5681',
 'SMTP:MAL:NOTES-BIGMAIL': '5682',
 'IMAP:OVERFLOW:MAILENABLE-OF': '5683',
 'REXEC:OVERFLOW:USERNAME': '5684',
 'APP:GAME:WOW-REALM': '5685',
 'APP:CA:ARCSRV:SQLOF': '5686',
 'SPYWARE:BH:LOOKQUICK': '5687',
 'APP:MISC:ACROREAD-XML-URL': '5688',
 'SCAN:CYBERCOP:OS-PROBE-1': '5689',
 'RLOGIN:INFO:RLOGIN-LOGIN': '5690',
 'SMTP:IIS:IIS-ENCAPS-RELAY': '5691',
 'HTTP:STC:ACTIVEX:MAL-CON-2': '5692',
 'HTTP:XSS:IIS-ASP': '5693',
 'TELNET:EXPLOIT:SUN-TELNETD-OF': '5694',
 'SPYWARE:KL:FINDNOT_GUARDOG': '5695',
 'HTTP:IIS:COMMAND-EXEC-3': '5696',
 'SHELLCODE:SPARC:SETGID-0-TCP': '5697',
 'SPYWARE:AD:NICTECH-BM2': '5698',
 'HTTP:STC:CLSID:ACTIVEX:IERPPLUG': '5699',
 'DHCP:SERVER:FMT-STR': '5700',
 'SPYWARE:TROJAN:ABACAB': '5701',
 'FTP:USER:IRIX-DEF-ACCT': '5702',
 'HTTP:STC:CLSID:ACTIVEX:AX-77': '5703',
 'CHAT:MSN:HTTP:CHAT': '5704',
 'HTTP:SQL:INJ:AUTO-TRANS': '5705',
 'FTP:EXPLOIT:MGET-RETR-EXEC': '5706',
 'CHAT:MSN:INVITE-RECV': '5707',
 'APP:TUN:TIC-LOGIN': '5708',
 'APP:REMOTE:RDP-HEAP-OF': '5709',
 'APP:CUPS:EMPTY-UDP': '5710',
 'SPYWARE:BH:OEMJIBAR': '5711',
 'APP:ORACLE:WEBCACHE-INSECURE2': '5712',
 'TCP:AUDIT:BAD-SYN-NONSYN': '5713',
 'SPYWARE:BH:HUNTBAR': '5714',
 'APP:CA:IGATEWAY-BOF': '5715',
 'VOIP:SIP:DOUBLE-ENCODING': '5716',
 'DB:MS-SQL:DOS1': '5717',
 'SPYWARE:TROJAN:FALLINGSTAR': '5718',
 'APP:MISC:CITADEL-BO': '5719',
 'HTTP:OVERFLOW:USER-AGENT': '5720',
 'HTTP:TOMCAT:JSP-AS-HTML': '5721',
 'VNC:OVERFLOW:SET-ENCODINGS': '5722',
 'P2P:WINMX:SERVER-CONNECT-OK': '5723',
 'HTTP:OVERFLOW:OPENVIEW-NNM-CGI': '5724',
 'FTP:COMMAND:WZ-SITE-EXEC': '5725',
 'DB:ORACLE:DEFAULT-PW-JONES': '5726',
 'HTTP:OVERFLOW:ACCEPT-ENCODING': '5727',
 'MS-RPC:MSRPC-EVASION-1': '5728',
 'HTTP:IIS:ADMIN-PROBE': '5729',
 'RADIUS:INVALID_ATTR_TYPE': '5730',
 'HTTP:APACHE:MOD-NTLM-BOF1': '5731',
 'SPYWARE:AD:ADULTP2P_1_5': '5732',
 'SCAN:II:TIQ-WMF-MAL-HEADER': '5733',
 'HTTP:STC:ACTIVEX:HUSDAWG': '5734',
 'HTTP:ORACLE:ORACLE-SBA': '5735',
 'HTTP:STC:ACTIVEX:SOFTARTISANS': '5736',
 'HTTP:STC:ACTIVEX:ZENTURI-DOWNLD': '5737',
 'HTTP:STC:XMPLAY-ASX': '5738',
 'TCP:EXPLOIT:SOCKSTRESS': '5739',
 'APP:ADOBE-CF-DIR-TRAV': '5740',
 'APP:AGENTX-RECEIVE-INT-OF': '5741',
 'APP:AGENTX-RECEIVE-OF': '5742',
 'APP:ALTN-WORLDCLIENT-MEM': '5743',
 'APP:APPLE-CUPS-PNG-FILTER-OF': '5744',
 'APP:APPLE-SIRI': '5745',
 'APP:BAKBON-NETVAULT-HEAP-OF': '5746',
 'APP:BOMBER-BO': '5747',
 'APP:CA:ARCSERVE-GWT-INFO-DISC': '5748',
 'APP:CA:ARCSRV:BACKUP-CMD-EXEC': '5749',
 'APP:CA:ARCSRV:BCK-MSG': '5750',
 'APP:CA:ARCSRV:BME-OP-117': '5751',
 'APP:CA:ARCSRV:CALOGGERD-BO': '5752',
 'APP:CA:ARCSRV:CAMEDIASRV-UDP': '5753',
 'APP:CA:ARCSRV:DIRTRAV': '5754',
 'APP:CA:ARCSRV:DISCSRV-DOS': '5755',
 'APP:CA:ARCSRV:FILE-UPLOAD': '5756',
 'APP:CA:ARCSRV:HSM-OF': '5757',
 'APP:CA:ARCSRV:LGSERVER-AUTH': '5758',
 'APP:CA:ARCSRV:LGSERVER-AUTH-USR': '5759',
 'APP:CA:ARCSRV:LGSERVER-CMDNAME': '5760',
 'APP:CA:ARCSRV:LGSERVER-HSHAKE': '5761',
 'APP:CA:ARCSRV:MAILSLOT-OF': '5762',
 'APP:CA:ARCSRV:METHOD-EXPOSURE': '5763',
 'APP:CA:ARCSRV:RPC-MEMCORRUPT': '5764',
 'APP:CA:ARCSRV:TAPE-ENGINE-DOS': '5765',
 'APP:CA:ARCSRV:TAPE-OP-207': '5766',
 'APP:CA:ARCSRV:UNICENTERAGENT-2': '5767',
 'APP:CA:ARCSRV:XDR-PARSING-BO': '5768',
 'APP:CA:CONSOLE-LOGIN-OVERFLOW': '5769',
 'APP:CA:DBASVR-POINT': '5770',
 'APP:CA:ETRUST-ID-KEY-DOS': '5771',
 'APP:CA:IGATEWAY-DEBUG': '5772',
 'APP:CA:MESSAGE-QUEUE-HEAP': '5773',
 'APP:CDE-DTSPCD-OF': '5774',
 'APP:CISCO:REGISTRAR-AUTH-BYPASS': '5775',
 'APP:CITRIX-IMA-BO': '5776',
 'APP:CITRIX:AG-CMD-INJ': '5777',
 'APP:CITRIX:META-IMA-AUTH': '5778',
 'APP:CITRIX:PROVISIONING-OPCODE': '5779',
 'APP:CLAMAV-UPX-OF-HTTP': '5780',
 'APP:CLAMAV-UPX-OF-SMTP': '5781',
 'APP:CUPS:APPLE-DOSELECT': '5782',
 'APP:CUPS:GIF-READ-LZW-OF': '5783',
 'APP:CUPS:JBIG2-SYMBOLDICTIONARY': '5784',
 'APP:CUPS:TEXTTOPS-OF': '5785',
 'APP:DIGIUM-IAX2-DOS': '5786',
 'APP:DIGIUM-IAX2-POKE-DOS': '5787',
 'APP:DISKPULSE-GETSERVERINFO-OF': '5788',
 'APP:EMBARCADERO-CONNECT-OF': '5789',
 'APP:EMC-ALPHA-BO': '5790',
 'APP:EMC-NETWORKER-BYPASS': '5791',
 'APP:ENCRYPTED-TRAFFIC-1': '5792',
 'APP:ENCRYPTED-TRAFFIC-2': '5793',
 'APP:ENCRYPTED-TRAFFIC-3': '5794',
 'APP:EXCHANGE:EMSMDB32-DOS': '5795',
 'APP:FREEPBX-ARI-DOS': '5796',
 'APP:GAME:DIRECTPLAY-NULL-PTR': '5797',
 'APP:GAME:DIRECTPLAY-PLAYER-DOS': '5798',
 'APP:GAME:WII-ACTIVITY': '5799',
 'APP:HP-DATA-PROTECTOR-BACKUP': '5800',
 'APP:HP-DATA-PROTECTOR-CLIENT-CE': '5801',
 'APP:HP-DATA-PROTECTOR-DTBCLS-OF': '5802',
 'APP:HP-DATA-PROTECTOR-MMD-BOF': '5803',
 'APP:HP-DATA-PROTECTOR-OP-DOS': '5804',
 'APP:HP-DATA-PROTECTOR-SIGN-DOS': '5805',
 'APP:HP-MGMT-DBMAN-OF': '5806',
 'APP:HP-MGMT-IMG-OF': '5807',
 'APP:HP-MGMT-TFTP-DATA-OF': '5808',
 'APP:HP-MGMT-TFTP-MODE-RCE': '5809',
 'APP:HP-PM-EXP-DATA-LOGS': '5810',
 'APP:HP-PWR-MGR-DIR-TRAV': '5811',
 'APP:HP-STORAGEWORKS-BOF': '5812',
 'APP:HPOV:CLASS-NAME-OF': '5813',
 'APP:HPOV:DATA-PROTECTOR-BO': '5814',
 'APP:HPOV:DATA-PROTECTOR-DOS': '5815',
 'APP:HPOV:DEMANDPOLL-FMT-STR': '5816',
 'APP:HPOV:EVTCOR-CMD-INJ': '5817',
 'APP:HPOV:GETNNMDATA-HOSTNAME-OF': '5818',
 'APP:HPOV:GETNNMDATA-ICOUNT-OF': '5819',
 'APP:HPOV:GETNNMDATA-MAXAGE-OF': '5820',
 'APP:HPOV:HP-DPBC-DIR-TRAV': '5821',
 'APP:HPOV:HP-DPBC-OF': '5822',
 'APP:HPOV:HPOPSMGT-OF': '5823',
 'APP:HPOV:INT-MGMT-CTR-DIRTRAV': '5824',
 'APP:HPOV:INT-MGMT-CTR-INFO-DIS': '5825',
 'APP:HPOV:LANG-ACCEPT-OF': '5826',
 'APP:HPOV:NNM-BO': '5827',
 'APP:HPOV:NNM-DISPLAYWIDTH-BOF': '5828',
 'APP:HPOV:NNM-EXECVP-NC-OF': '5829',
 'APP:HPOV:NNM-LOGIN-BOF': '5830',
 'APP:HPOV:NNM-OF': '5831',
 'APP:HPOV:NNM-OVALARM-IO': '5832',
 'APP:HPOV:NNM-OVW-MSG': '5833',
 'APP:HPOV:NNM-RPING-BOF': '5834',
 'APP:HPOV:NNM-SNMP-BOF': '5835',
 'APP:HPOV:NNM-SNMP-HOST': '5836',
 'APP:HPOV:NNMRPTCONFIG-EXE-BOF': '5837',
 'APP:HPOV:NNMRPTCONFIG-EXE-RCE': '5838',
 'APP:HPOV:NNMRPTCONG-TEMPL': '5839',
 'APP:HPOV:NODE-MGR-BO': '5840',
 'APP:HPOV:NODE-MGR-NNMRPTCONFIG': '5841',
 'APP:HPOV:OALARM-LANG-OF': '5842',
 'APP:HPOV:OID-OF': '5843',
 'APP:HPOV:OMNIINET-OF': '5844',
 'APP:HPOV:OMNILNET-NULL': '5845',
 'APP:HPOV:OVALARMSRV-DOS': '5846',
 'APP:HPOV:OVALARMSRV-DOS2': '5847',
 'APP:HPOV:OVALARMSRV-FMT-STR': '5848',
 'APP:HPOV:OVALARMSRV-OF': '5849',
 'APP:HPOV:OVJAVALOCALE-OF': '5850',
 'APP:HPOV:OVTRACE': '5851',
 'APP:HPOV:OVWEBSNMPSRV-OF': '5852',
 'APP:HPOV:PERFORMANCE-INSIGHT': '5853',
 'APP:HPOV:RADIA-NOTIFY': '5854',
 'APP:HPOV:REQ_SEV_CHANGE-DOS': '5855',
 'APP:HPOV:SDP-OF': '5856',
 'APP:HPOV:SDPM-HEAP-BOF': '5857',
 'APP:HPOV:SNMPVIEWER-APP-OF': '5858',
 'APP:HPOV:UNAUTH-FILE-UPLOAD': '5859',
 'APP:IBM:COGNOS-BACKDOOR': '5860',
 'APP:IBM:DIRECTOR-CIM-DOS': '5861',
 'APP:IBM:IDS-LIBRPC': '5862',
 'APP:IBM:INFORMIX-CMD-OF': '5863',
 'APP:IBM:INFORMIX-DBINFO-BOF': '5864',
 'APP:IBM:INFORMIX-EXPLAIN': '5865',
 'APP:IBM:LOTUS-NOTES-HTML-OF': '5866',
 'APP:IBM:LOTUS-NOTES-XSS': '5867',
 'APP:IBM:SET-ENVIRONMENT-BOF': '5868',
 'APP:IBM:TIV-DS-IBMSLAPD-EXE': '5869',
 'APP:IBM:TIV-SM-CAD': '5870',
 'APP:IBM:TIVOLI-FASTBACK-SER-RCE': '5871',
 'APP:IBM:TIVOLI-MAN-HEAP': '5872',
 'APP:IBM:TME-AGENT': '5873',
 'APP:INGRES:DB-COMM-SVR-OF': '5874',
 'APP:ISCSI-TARGET-FMT-STR': '5875',
 'APP:ISCSI-TARGET-OF': '5876',
 'APP:JBOSS-JMX-AUTH-BYPASS': '5877',
 'APP:KERBEROS:KDC-AUTH-DOS': '5878',
 'APP:KERBEROS:KRB5-DOS': '5879',
 'APP:KERBEROS:KRB5-MITM-DES': '5880',
 'APP:KERBEROS:XREALM-DOS': '5881',
 'APP:LANDESK-QIP-HEAL': '5882',
 'APP:MAL-AFP-DSI-REQ': '5883',
 'APP:MCAFEE-ORCH-BO': '5884',
 'APP:MERCURYPH-BO': '5885',
 'APP:MISC:AVIRA-ANTIVIR': '5886',
 'APP:MISC:ESIGNAL-WINSIG-BO': '5887',
 'APP:MISC:GANGLIA-METE-BOF': '5888',
 'APP:MISC:GOOGLE-EARTH': '5889',
 'APP:MISC:HICP-HOSTNAME': '5890',
 'APP:MISC:JRE-PACK200-OF': '5891',
 'APP:MISC:NETVAULT-SD-DOS': '5892',
 'APP:MISC:PXESERVICE-UDP': '5893',
 'APP:MISC:QUEST-NETVAULT-DOS': '5894',
 'APP:MISC:UNISYS-BIS': '5895',
 'APP:MISC:UPLUS-FTP-WEB-OF': '5896',
 'APP:MS-SNABASE-EXE-DOS': '5897',
 'APP:MS-SNBASE': '5898',
 'APP:NETSUPPORT-MANAGER-BO': '5899',
 'APP:NOVELL-NET-FTP-DEL-CMD-OF': '5900',
 'APP:NOVELL:DIS-PRINT-SRV': '5901',
 'APP:NOVELL:EDIR-CONTENT-LEN-OF': '5902',
 'APP:NOVELL:EDIR-HEADER-DOS': '5903',
 'APP:NOVELL:EDIR-PLUGIN-OF': '5904',
 'APP:NOVELL:EDIRECTORY-ME-OF': '5905',
 'APP:NOVELL:EMAIL-ADDRESS-BOF': '5906',
 'APP:NOVELL:GROUPWISE-CLIENT-BO': '5907',
 'APP:NOVELL:IMANAGER-FILE-UPLOAD': '5908',
 'APP:NOVELL:IMANAGER-TREE-NAME': '5909',
 'APP:NOVELL:MESSENGER-DOS': '5910',
 'APP:NOVELL:NDS-IO': '5911',
 'APP:NOVELL:NETWARE-XNFS-BO': '5912',
 'APP:NOVELL:ZENWORK': '5913',
 'APP:NOVELL:ZENWORK-DESKTOP-MGMT': '5914',
 'APP:NOVELL:ZENWORK-DIR-TRVRS': '5915',
 'APP:NOVELL:ZENWORK-MSG': '5916',
 'APP:NOVELL:ZENWORK-ZFHIPCND-EXE': '5917',
 'APP:NOVELL:ZENWORKS-MGMT-DIR': '5918',
 'APP:NOVELL:ZENWORKS-PREBOOT-SVC': '5919',
 'APP:NOVELL:ZENWORKS-ZFHIPCND-OF': '5920',
 'APP:OBSERVICED-OF': '5921',
 'APP:ORACLE:GOLDENGATE-SOAP-OF': '5922',
 'APP:ORACLE:JAVA-RMI-RCE': '5923',
 'APP:ORACLE:SBAS-CMD-INJ': '5924',
 'APP:ORACLE:SBAS-PREAUTH-INJ': '5925',
 'APP:ORACLE:SECURE-BACKUP-INJ': '5926',
 'APP:ORACLE:VIRTUAL-AGENT-CMDINJ': '5927',
 'APP:ORACLE:WEBLOGIC-CMD-EXEC': '5928',
 'APP:PEERCAST-FS': '5929',
 'APP:PPT-TEXTBYTESATOM': '5930',
 'APP:PPTP:POPTOP-OF': '5931',
 'APP:QUEST-BIG-BRO-FD': '5932',
 'APP:RDP-BRUTE-FORCE': '5933',
 'APP:REAL:HELIX-NTLM-OF': '5934',
 'APP:REAL:IVR-OF': '5935',
 'APP:REAL:IVR-OF-1': '5936',
 'APP:REAL:MAL-FLV-FILE': '5937',
 'APP:REAL:PLAYER-FORMAT-STRING': '5938',
 'APP:REAL:QCPFFORMAT-DLL-RCE': '5939',
 'APP:REAL:VIDPLIN-DLL': '5940',
 'APP:REMOTE:GOTOMYPC': '5941',
 'APP:REMOTE:GOTOMYPC-CONN-TEST': '5942',
 'APP:REMOTE:LOGMEIN': '5943',
 'APP:REPLISTOR-DOS': '5944',
 'APP:SENTINEL-LM-OF': '5945',
 'APP:SQUID-HTCP-DOS': '5946',
 'APP:SUN-JAVA-SERVER-ADMIN-DOS': '5947',
 'APP:SVN-DATE-SERVE': '5948',
 'APP:SYMC:ALERT-MGT': '5949',
 'APP:SYMC:ALERT-MGT-FILE-TRNS': '5950',
 'APP:SYMC:AMS-HNDLRSVC-RCE': '5951',
 'APP:SYMC:AMS-MODEM-STRING-OF': '5952',
 'APP:SYMC:AMS-PIN-OF': '5953',
 'APP:SYMC:AMS-SEND-ALERT-ACK-OF': '5954',
 'APP:SYMC:AV-AHS-DOS': '5955',
 'APP:SYMC:AV-HANDL-DOS': '5956',
 'APP:SYMC:AV-INTEL-ALERT': '5957',
 'APP:SYMC:AV-MGT-SVC-BOF': '5958',
 'APP:SYMC:IM-MGR-INJ': '5959',
 'APP:SYMC:LUA-HTML-INJ': '5960',
 'APP:SYMC:VERITAS-VXSVC-BO': '5961',
 'APP:SYMC:VRTSWEB-EXEC': '5962',
 'APP:TMIC:CTRLMGR-CHUNKED': '5963',
 'APP:TMIC:OFFICESCAN-AUTH': '5964',
 'APP:TMIC:OFFICESCAN-PW-OF': '5965',
 'APP:TMIC:TMREGCHANGE': '5966',
 'APP:TUN:ANCHORFREE-VPN-SSL': '5967',
 'APP:TUN:ANCHORFREE-VPN-TCP': '5968',
 'APP:TUN:ANCHORFREE-VPN-UDP': '5969',
 'APP:TUN:ESP-OVER-UDP': '5970',
 'APP:UNIVERSAL-CMDB-AXIS2-RCE': '5971',
 'APP:UPNP:MS-UPNP': '5972',
 'APP:VERITAS-ADMIN-BO': '5973',
 'APP:VERITAS:NB-VMD-OF2': '5974',
 'APP:VERITAS:NETBACKUP-VNETD': '5975',
 'APP:VERITAS:NETBCKP-CMD-EXEC': '5976',
 'APP:VMAUTH-FS': '5977',
 'APP:VMWARE-ISAPI-DOS': '5978',
 'APP:VMWARE-SPRING-CLASSLOADER': '5979',
 'APP:WINAMP:CAF-OF': '5980',
 'APP:WINAMP:MP4-MC': '5981',
 'APP:WINCOM-AUTH-BO': '5982',
 'APP:WINMEDIASRV-RCE': '5983',
 'APP:WINPRICE': '5984',
 'APP:WSDAPI-OF': '5985',
 'APP:YOUSENDIT': '5986',
 'APP:YOUSENDIT-ENCRYPTED': '5987',
 'APP:ZEND-SERVER-JAVA-RCE': '5988',
 'CHAT:AIM:FILE-EXE': '5989',
 'CHAT:AIM:FILE-GET': '5990',
 'CHAT:AIM:HTTP-PROXY': '5991',
 'CHAT:AIM:HTTPS-LOGIN': '5992',
 'CHAT:AIM:OVERFLOW:TRILLIAN-XML': '5993',
 'CHAT:AUDIT:AIM:MSG-HEADER': '5994',
 'CHAT:AUDIT:AIM:MSG-TOO-BIG': '5995',
 'CHAT:AUDIT:AIM:MSG-TOO-SHORT': '5996',
 'CHAT:AUDIT:MSN:CMD': '5997',
 'CHAT:GOOGLE:GTALK-SSL': '5998',
 'CHAT:GOOGLE:TALKGADGET': '5999',
 'CHAT:GOOGLE:TALKGADGET-ACTIVITY': '6000',
 'CHAT:IRC:BOTNET:AGOBOT-CMD': '6001',
 'CHAT:IRC:BOTNET:DOWNLOAD-CMD': '6002',
 'CHAT:IRC:BOTNET:SDBOT-CMD': '6003',
 'CHAT:IRC:LOIC-HIVE-LOGIN': '6004',
 'CHAT:IRC:UNREALRCD-BACKDOOR': '6005',
 'CHAT:JABBER:NIMBUZZ': '6006',
 'CHAT:MSN:PIDGIN-MSN-IO': '6007',
 'CHAT:QQ:QQ-CONNECT-TCP': '6008',
 'CHAT:STEAM-FRIENDS': '6009',
 'CHAT:YIM:FILE-TRANSFER': '6010',
 'CHAT:YIM:HTTP-FILE-TRANSFER': '6011',
 'CHAT:YIM:YAHOO-HTTP-PROXY': '6012',
 'DB:BORLAND-MSG-BO': '6013',
 'DB:DB2:CONNECT-DOS': '6014',
 'DB:DB2:HS-DOS': '6015',
 'DB:DB2:IBM-DAS-BOF': '6016',
 'DB:DB2:JDBC-OF': '6017',
 'DB:DB2:SQL-REPEAT-OF': '6018',
 'DB:FIREBIRD-DOS': '6019',
 'DB:FIREBIRD-USER-BO': '6020',
 'DB:FIREBIRD-XDR-DOS': '6021',
 'DB:IBM-SOLIDDB-AUTH-BYPASS': '6022',
 'DB:INGRESDB-IIDBMS-OF': '6023',
 'DB:MS-SQL:2000-SP_START_JOB': '6024',
 'DB:MS-SQL:INSERT-CMD-BOF': '6025',
 'DB:MS-SQL:WINCC-DEFAULT-PASS': '6026',
 'DB:MYSQL:IN-NULL-ARG-DOS': '6027',
 'DB:MYSQL:MAXDB-CMD': '6028',
 'DB:MYSQL:SELECT-SUB-DOS': '6029',
 'DB:MYSQL:UNIQ-SET-COL-JOIN-DOS': '6030',
 'DB:ORACLE:AS-EMCHARTBEAN-TRAV': '6031',
 'DB:ORACLE:COMPILER-ACL': '6032',
 'DB:ORACLE:CREATE-VIEW': '6033',
 'DB:ORACLE:CREATE_TABLES-INJ': '6034',
 'DB:ORACLE:DBMS-ASSERT': '6035',
 'DB:ORACLE:DBMS-CDC-PUBLISH-INJ': '6036',
 'DB:ORACLE:DBMS:AQELM-OF': '6037',
 'DB:ORACLE:DBMS:CDC-AQJM-UNSAFE': '6038',
 'DB:ORACLE:DBMS:EXP-EXT-UNSAFE': '6039',
 'DB:ORACLE:DBMS:EXPORT-PRIV': '6040',
 'DB:ORACLE:DBMS:METADATA-UNSAFE': '6041',
 'DB:ORACLE:DBMS:OPMN-LOG-FMT-STR': '6042',
 'DB:ORACLE:DBMS:SUB_NAME-SQL-INJ': '6043',
 'DB:ORACLE:DBMS:VAL-REMOTE-INJ': '6044',
 'DB:ORACLE:EVTDUMP': '6045',
 'DB:ORACLE:LOGIN-CMD-INJ': '6046',
 'DB:ORACLE:ODCITABLESTART-OF': '6047',
 'DB:ORACLE:OSB-NDMP-OF': '6048',
 'DB:ORACLE:PASSWD:ADAMS': '6049',
 'DB:ORACLE:PASSWD:AURORA': '6050',
 'DB:ORACLE:PASSWD:BLAKE': '6051',
 'DB:ORACLE:PASSWD:CLARK': '6052',
 'DB:ORACLE:PASSWD:CTXSYS': '6053',
 'DB:ORACLE:PASSWD:DBSNMP': '6054',
 'DB:ORACLE:PASSWD:JONES': '6055',
 'DB:ORACLE:PASSWD:MDSYS': '6056',
 'DB:ORACLE:PASSWD:ORDCOMMON': '6057',
 'DB:ORACLE:PASSWD:ORDPLUGINS': '6058',
 'DB:ORACLE:PASSWD:ORDSYS': '6059',
 'DB:ORACLE:PASSWD:OUTLN': '6060',
 'DB:ORACLE:PASSWD:SCOTT': '6061',
 'DB:ORACLE:PASSWD:SYS': '6062',
 'DB:ORACLE:PASSWD:SYSTEM': '6063',
 'DB:ORACLE:PASSWD:TRACESVR': '6064',
 'DB:ORACLE:SDO_CS-TRANS-OF': '6065',
 'DB:ORACLE:SYS:KUPVFT-UNSAFE': '6066',
 'DB:ORACLE:SYS:KUPW-WORKER': '6067',
 'DB:ORACLE:SYS:LT-FINDRICSET': '6068',
 'DB:ORACLE:SYS:LT-WORKSPACE': '6069',
 'DB:ORACLE:SYS:MDSYS-SDO-LRS': '6070',
 'DB:ORACLE:SYS:PBSDE-INIT-OF': '6071',
 'DB:ORACLE:TIMES-TEN-HTTP-DOS': '6072',
 'DB:ORACLE:TNS:AUTH-SESSKEY-BOF': '6073',
 'DB:ORACLE:TNS:BEQ-BYPASS': '6074',
 'DB:ORACLE:TNS:CMD-EXEC': '6075',
 'DB:ORACLE:TNS:DBMS-OF': '6076',
 'DB:ORACLE:TNS:DOS': '6077',
 'DB:ORACLE:TNS:INTERMEDIA-DOS': '6078',
 'DB:ORACLE:TNS:LOOP-DOS': '6079',
 'DB:ORACLE:TNS:MALFORMED-IP': '6080',
 'DB:ORACLE:TNS:MALFORMED-PORT': '6081',
 'DB:ORACLE:TNS:OF': '6082',
 'DB:ORACLE:TNS:ORACLE-PRIVESC': '6083',
 'DB:ORACLE:TNS:OVERFLOW_MSG': '6084',
 'DB:ORACLE:TNS:RDBMS-DOS': '6085',
 'DB:ORACLE:TNS:SHORT_MSG': '6086',
 'DB:ORACLE:TNS:TRACE-OF': '6087',
 'DB:ORACLE:TNS:UNK-COMMAND': '6088',
 'DB:ORACLE:TNS:UNSAFE-CMD': '6089',
 'DB:ORACLE:WAREHOUSE-SHADOWTABLE': '6090',
 'DB:ORACLE:WB-OLAP-AW-REMOVE-ID': '6091',
 'DB:ORACLE:WB-OLAP-AW-SET-ID': '6092',
 'DB:ORACLE:WEBLOGIC-SERVER': '6093',
 'DB:ORACLE:WEBUI-CMD-INJ': '6094',
 'DB:ORACLE:XDB-DROPMETADATA': '6095',
 'DB:POSTGRESQL:DBA-AUTH-BYPASS': '6096',
 'DB:POSTGRESQL:SUBSTRING-OF': '6097',
 'DB:SALESLOGIX-DISC': '6098',
 'DB:SOLIDDB-DOS': '6099',
 'DB:SOLIDDB-LOG-FS': '6100',
 'DB:SYBASE-MOBILINK-BO': '6101',
 'DB:SYBASE:OPEN-SERVER-CE': '6102',
 'DB:SYBASE:OPEN-SERVER-MC': '6103',
 'DDOS:JAVALOIC-TCP-METHOD': '6104',
 'DDOS:JAVALOIC-TWITTER': '6105',
 'DDOS:JAVALOIC-UDP-METHOD': '6106',
 'DDOS:LOIC-HTTP-METHOD': '6107',
 'DDOS:LOIC-TCP-METHOD': '6108',
 'DDOS:LOIC-UDP-METHOD': '6109',
 'DDOS:LONGCAT': '6110',
 'DHCP:ISC-ZERO-LEN-DOS': '6111',
 'DHCP:OPT:MS-OPT-OF': '6112',
 'DHCP:SERVER:ISC-CMD-INJ': '6113',
 'DNS:AUDIT:AAAA-RR': '6114',
 'DNS:BIND-RRSIG-DOS': '6115',
 'DNS:BIND-RRSIG-QUERY-DOS': '6116',
 'DNS:CRAFTED-MX': '6117',
 'DNS:EXPLOIT:BIND-ADDSOA': '6118',
 'DNS:EXPLOIT:BIND-MULT-RRSET': '6119',
 'DNS:INFO:OVERSIZED_ADV_PAYLOAD': '6120',
 'DNS:INFO:RCODE-BADVERS': '6121',
 'DNS:ISC-BIND-RRSIG-DOS': '6122',
 'DNS:MAILENABLE-SPF': '6123',
 'DNS:MS-FOREFRONT-RCE': '6124',
 'DNS:OVERFLOW:NOOP-RQUERY': '6125',
 'DNS:OVERFLOW:OPT-OVERFLOW': '6126',
 'DNS:QUERY:AUTHORS': '6127',
 'DNS:QUERY:HOSTNAME': '6128',
 'DNS:REPERR:NAPRT-IOF': '6129',
 'DNS:RESP-SPOOF': '6130',
 'DNS:RRSIG-QUERY': '6131',
 'DNS:TOO-MANY-ERRORS': '6132',
 'DNS:TRAFFIC-TCP': '6133',
 'DNS:TRAFFIC-UDP': '6134',
 'DOS:APPLICATION:MS-HIS': '6135',
 'FTP:COMMAND:CTRL-CHAR': '6136',
 'FTP:COMMAND:FTP-FS-COMMAND': '6137',
 'FTP:COMMAND:MULTIPLE-OF': '6138',
 'FTP:COMMAND:SITE-CMD-INJ': '6139',
 'FTP:COMMAND:SLIMFTP-LIST': '6140',
 'FTP:COMMAND:STOR-RHOSTS': '6141',
 'FTP:COMMAND:VICFTPS-DOS': '6142',
 'FTP:COMMAND:WS-FTP-REST': '6143',
 'FTP:COMMAND:WS_FTP-CMD-BO': '6144',
 'FTP:DOS:FTPDMIN-LIST-CMD': '6145',
 'FTP:DOS:GEN-GLOB-DOS': '6146',
 'FTP:DOS:NULL-CRED': '6147',
 'FTP:DOS:SOLARFTP-USER-CMD': '6148',
 'FTP:DOS:VSFTPD-STAT': '6149',
 'FTP:DOS:XM-NLST-NEG': '6150',
 'FTP:EXPLOIT:CA-FTP-LIST-PASV': '6151',
 'FTP:EXPLOIT:WSFTP-FMT-STR': '6152',
 'FTP:EXT:DOT-EXEC': '6153',
 'FTP:EXT:DOT-PDF': '6154',
 'FTP:FILE:PUT-AUTOEXECBAT': '6155',
 'FTP:FILE:RETR': '6156',
 'FTP:FILE:STOR': '6157',
 'FTP:MS-FTP:IIS7-5-DOS': '6158',
 'FTP:MS-FTP:MSFTPSVC-DOS': '6159',
 'FTP:MS-FTP:MSFTPSVC-EXEC': '6160',
 'FTP:OVERFLOW:CMD-NOOP-SLED': '6161',
 'FTP:OVERFLOW:CMD-OF': '6162',
 'FTP:OVERFLOW:EASY-FTP-OF': '6163',
 'FTP:OVERFLOW:GUILDFTP-HEAP': '6164',
 'FTP:OVERFLOW:IE-MAL-SERVER': '6165',
 'FTP:OVERFLOW:MUL-FTP-MKDOF': '6166',
 'FTP:OVERFLOW:ORACLE-UNLOCK': '6167',
 'FTP:OVERFLOW:PASSWORD-BO': '6168',
 'FTP:OVERFLOW:REST-INT-OF': '6169',
 'FTP:OVERFLOW:WFTPD-SIZE': '6170',
 'FTP:PROFTP:MOD-SQL-HEAP-OF': '6171',
 'FTP:REQERR:REQ-TOO-MANY-ARGS': '6172',
 'FTP:RPLERR:CUTEFTP-OF': '6173',
 'FTP:SERVU:RNTO-TRAV': '6174',
 'FTP:VSFTPD-BACKDOOR': '6175',
 'HTTP:ADOBE-ROBOHELP-FILE-UPLOAD': '6176',
 'HTTP:APACHE:APR-DOS': '6177',
 'HTTP:APACHE:APR-PSPRINTF-MC': '6178',
 'HTTP:APACHE:BYTE-RANGE-LEAK': '6179',
 'HTTP:APACHE:FILTER-DISPATCHER': '6180',
 'HTTP:APACHE:MOD-ISAPI-RCE': '6181',
 'HTTP:APACHE:MOD-TCL-FS': '6182',
 'HTTP:APACHE:MOD_PROXY-CHUNKED': '6183',
 'HTTP:APACHE:RANGE-DOS': '6184',
 'HTTP:APACHE:STRUTS2-PI-RCE': '6185',
 'HTTP:AUDIT:GENERIC-FMT-STR': '6186',
 'HTTP:AUDIT:HTTP-1.0-HOST-HEADER': '6187',
 'HTTP:AUDIT:HTTP-VER-1.0': '6188',
 'HTTP:AUDIT:LENGTH-OVER-1024': '6189',
 'HTTP:AUDIT:LENGTH-OVER-2048': '6190',
 'HTTP:AUDIT:LENGTH-OVER-256': '6191',
 'HTTP:AUDIT:LENGTH-OVER-4096': '6192',
 'HTTP:AUDIT:LENGTH-OVER-512': '6193',
 'HTTP:AUDIT:LENGTH-OVER-8192': '6194',
 'HTTP:AUDIT:REMOTE-URL-IN-VAR': '6195',
 'HTTP:AUDIT:TOO-MANY-HEADERS': '6196',
 'HTTP:AUDIT:UNWISE-CHAR': '6197',
 'HTTP:CA-XOSOFT-XOSOAP': '6198',
 'HTTP:CGI:OFFICESCAN-CGI-BO': '6199',
 'HTTP:CGI:SOFTCART': '6200',
 'HTTP:CGI:UBNT-AIROS-CMD-INJ': '6201',
 'HTTP:CGI:WEBSCADA': '6202',
 'HTTP:CISCO:CISCOWORKS-DIR-TRAV': '6203',
 'HTTP:CISCO:IOS-HTML-INJ': '6204',
 'HTTP:CISCO:UNIFIED-XSS': '6205',
 'HTTP:CISCO:UNIFIED-XSS-2': '6206',
 'HTTP:COLDFUSION:ENV-VAR-OW': '6207',
 'HTTP:DFIND-PROBE': '6208',
 'HTTP:DIR:DIR-TRAVERSAL': '6209',
 'HTTP:DIR:SAP-CRY-PATH-DIR': '6210',
 'HTTP:DIR:WINACE-DIR-TRVRS': '6211',
 'HTTP:DIR:WP-UNGALLERY-LFD': '6212',
 'HTTP:DOMINO:HPRAGENTNAME-BOF': '6213',
 'HTTP:DOMINO:REDIR-BOF': '6214',
 'HTTP:DOURAN-ARB-FILE-DL': '6215',
 'HTTP:ESTSOFT-ALZIP-MIM-BO': '6216',
 'HTTP:EXPLOIT:BIN-IN-AUTH-BASIC': '6217',
 'HTTP:EXPLOIT:MAL-LNK': '6218',
 'HTTP:EXPLOIT:MS-ADDRESSBOOK': '6219',
 'HTTP:EXPLOIT:MS-BACKUP-MGR': '6220',
 'HTTP:EXPLOIT:MS-TCPSTACK-URLDOS': '6221',
 'HTTP:EXPLOIT:MS-VS-MFC': '6222',
 'HTTP:EXPLOIT:PI3WEB-USERS': '6223',
 'HTTP:EXPLOIT:REDMINE-CMD-EXEC': '6224',
 'HTTP:EXPLOIT:WEBMIN-FS-INT': '6225',
 'HTTP:EXPLOIT:XERVER-NULL-INJ': '6226',
 'HTTP:EXT:DOT-PIF': '6227',
 'HTTP:EXT:SCR': '6228',
 'HTTP:IIS:ADFS-MAL-HEADER': '6229',
 'HTTP:IIS:ASP-PAGE-BOF': '6230',
 'HTTP:IIS:ASP-RCE': '6231',
 'HTTP:IIS:BAT-AMP': '6232',
 'HTTP:IIS:DIR-BYPASS': '6233',
 'HTTP:IIS:EXAIR-DOS': '6234',
 'HTTP:IIS:FASTCGI': '6235',
 'HTTP:IIS:HTR-OF-2': '6236',
 'HTTP:IIS:IIS-ADS-BYPASS': '6237',
 'HTTP:IIS:IIS-DISC': '6238',
 'HTTP:IIS:IIS-EXT-BYPASS': '6239',
 'HTTP:IIS:MDAC-DATASTUB': '6240',
 'HTTP:IIS:MS-RD-WEB-ACCESS-XSS': '6241',
 'HTTP:IIS:MS-REPORT-VIEWER-XSS': '6242',
 'HTTP:IIS:PBSERVER-PARAM-OF': '6243',
 'HTTP:IIS:REPEAT-PARAM-DOS': '6244',
 'HTTP:IIS:SHARE-ID': '6245',
 'HTTP:IIS:SHAREPOINT-2010-XSS': '6246',
 'HTTP:IIS:SHAREPOINT-CONVERT': '6247',
 'HTTP:IIS:SHAREPOINT-DOS': '6248',
 'HTTP:IIS:SHAREPOINT-MUL-XSS': '6249',
 'HTTP:IIS:SHAREPOINT-XSS': '6250',
 'HTTP:IIS:SOURCE-CODE-DISC': '6251',
 'HTTP:IIS:UNC-PATH-DISC': '6252',
 'HTTP:IIS:WEBDAV:REQ-DISCLO': '6253',
 'HTTP:INFLATE:OVERFLOW': '6254',
 'HTTP:INFLATE:TYPE-MISMATCH': '6255',
 'HTTP:INFO-LEAK:ASP-ORACLE-PAD': '6256',
 'HTTP:INFO-LEAK:BUGZILLA-DISC': '6257',
 'HTTP:INFO-LEAK:CA-TOTAL-DEFENSE': '6258',
 'HTTP:INFO-LEAK:HTTP-SHARE-ENUM': '6259',
 'HTTP:INFO-LEAK:LIVE-WIRE': '6260',
 'HTTP:INFO-LEAK:NET-INFO-DISC': '6261',
 'HTTP:INFO-LEAK:SHAREPOINT-INFO': '6262',
 'HTTP:INFO-LEAK:SUGARCRM': '6263',
 'HTTP:INFO-LEAK:TOSTATICHTML-API': '6264',
 'HTTP:INFO-LEAK:WORDPRES-GAZETTE': '6265',
 'HTTP:INFO-LEAK:WP-DBM-CFG': '6266',
 'HTTP:INFO:HTML5-CONTENT': '6267',
 'HTTP:INFO:OFFLINE-CACHING-HTML5': '6268',
 'HTTP:INFO:YOUTUBE-APP': '6269',
 'HTTP:INVALID:NON-STAND-W-SPACE': '6270',
 'HTTP:INVALID:STATUS-CODE': '6271',
 'HTTP:ISAPI-RSA-WEB': '6272',
 'HTTP:JABBER-SERVER-BYPASS': '6273',
 'HTTP:LINUX:REDHAT-ACCEPT-LANG': '6274',
 'HTTP:MCAFEE-FIREWALL-RCE': '6275',
 'HTTP:MISC:APPLE-INSTALLER-FS': '6276',
 'HTTP:MISC:APPLE-MAPS-APP': '6277',
 'HTTP:MISC:LIFESIZE-ROOM-CMD-INJ': '6278',
 'HTTP:MISC:LIFESIZE-ROOM-SEC-BY': '6279',
 'HTTP:MISC:MAL-WRI': '6280',
 'HTTP:MISC:MS-FOREFRONT-DOS': '6281',
 'HTTP:MISC:SPAM-TO-PHP-REDIR': '6282',
 'HTTP:MISC:SPRING-HEADER-INJ': '6283',
 'HTTP:MISC:TM-INTERSCAN-DIR-TRAV': '6284',
 'HTTP:MS-LYNC-SERVER-RCE': '6285',
 'HTTP:MS-TELNET-INSECURE-LOADING': '6286',
 'HTTP:NOVELL:DHOST-BOF': '6287',
 'HTTP:NOVELL:EDIR-ACCEPT-LANG-OF': '6288',
 'HTTP:NOVELL:EDIR-DHOST': '6289',
 'HTTP:NOVELL:EDIRECTORY-SOAP': '6290',
 'HTTP:NOVELL:GROUPWISE-IMG-BOF': '6291',
 'HTTP:NOVELL:NETMAIL-WEBADMIN': '6292',
 'HTTP:NOVELL:TEAMING-UPLOAD': '6293',
 'HTTP:NOW-SMS-BO': '6294',
 'HTTP:OFFICESCAN-CGIRECVFILE': '6295',
 'HTTP:ORACLE-JRE-INSECURE-LOAD': '6296',
 'HTTP:ORACLE:APEX-HASH': '6297',
 'HTTP:ORACLE:BACKUP-AUTH-BYPASS': '6298',
 'HTTP:ORACLE:COREL-DRAW-BO': '6299',
 'HTTP:ORACLE:GLASSFISH-BYPASS': '6300',
 'HTTP:ORACLE:LOGIN-COOKIES-INJ': '6301',
 'HTTP:ORACLE:OUTSIDEIN-CORELDRAW': '6302',
 'HTTP:ORACLE:SELECTOR-CMD-INJ': '6303',
 'HTTP:ORACLE:SERVER-FORMS-CE': '6304',
 'HTTP:ORACLE:SRV-OPMN-FS': '6305',
 'HTTP:OVERFLOW:AUTH-OVERFLOW': '6306',
 'HTTP:OVERFLOW:AUTHORIZATION': '6307',
 'HTTP:OVERFLOW:BORLAND-STARTEAM': '6308',
 'HTTP:OVERFLOW:HP-POWERMAN-OF': '6309',
 'HTTP:OVERFLOW:HTTPDX-URL': '6310',
 'HTTP:OVERFLOW:IMAGEMAGICK-SGI': '6311',
 'HTTP:OVERFLOW:JAVA-OPTIONS': '6312',
 'HTTP:OVERFLOW:MALICIOUS-HOST': '6313',
 'HTTP:OVERFLOW:MISSING-VER-BO': '6314',
 'HTTP:OVERFLOW:MS-IE-URL-BOF': '6315',
 'HTTP:OVERFLOW:MULTIWEB-REQOF': '6316',
 'HTTP:OVERFLOW:OPENVIEW-NNM-TOOL': '6317',
 'HTTP:OVERFLOW:OVWEBHELP-BO': '6318',
 'HTTP:OVERFLOW:SERVU-SESSION': '6319',
 'HTTP:OVERFLOW:VERB-OVERFLOW': '6320',
 'HTTP:OVERFLOW:XITAMIIFMOD': '6321',
 'HTTP:PHP:4IMAGES-RFI': '6322',
 'HTTP:PHP:724CMS-LFI': '6323',
 'HTTP:PHP:BACULA-WEB-REPORT': '6324',
 'HTTP:PHP:CMD-INJ-UA': '6325',
 'HTTP:PHP:COMPACTCMS-ENGINE-RFI': '6326',
 'HTTP:PHP:CONSTRUCTR-CMS-MUL': '6327',
 'HTTP:PHP:EGROUPWARE-FI': '6328',
 'HTTP:PHP:GAPICMS-DIRDEPTH-INC': '6329',
 'HTTP:PHP:INTERPHOTO-IPLANG-LFI': '6330',
 'HTTP:PHP:JOOMLA-COM-PHOCADL-LFI': '6331',
 'HTTP:PHP:JOOMLA-DIR-TRAV': '6332',
 'HTTP:PHP:JOOMLA-FILE-LISTER': '6333',
 'HTTP:PHP:JOOMLA-JE-STORY-LFI': '6334',
 'HTTP:PHP:JOOMLA-JMSFILESELL-LFI': '6335',
 'HTTP:PHP:JOOMLA-JOOMTOUCH-LFI': '6336',
 'HTTP:PHP:JOOMLA-LOC-FILE': '6337',
 'HTTP:PHP:JOOMLA-OBSUGGEST-LFI': '6338',
 'HTTP:PHP:JOOMLA-XCLONER': '6339',
 'HTTP:PHP:MEDIAWIKI-RCE': '6340',
 'HTTP:PHP:MEDIAWIKI-SCRIPT-INSER': '6341',
 'HTTP:PHP:N-CMS-PAGE-LFI': '6342',
 'HTTP:PHP:OPEN-REALITY-XSS-SQLI': '6343',
 'HTTP:PHP:PACER-CMS-FILE-DELETE': '6344',
 'HTTP:PHP:PACER-EDITION-CMS-LFI': '6345',
 'HTTP:PHP:PHP-FILE-INCL': '6346',
 'HTTP:PHP:PHPINFO-QUERY': '6347',
 'HTTP:PHP:PHPINFO-SERVER': '6348',
 'HTTP:PHP:PHPNUKE:DOWNLD-SQL-INJ': '6349',
 'HTTP:PHP:TIKIWIKI-FORM': '6350',
 'HTTP:PHP:TINYWEBGALLERY-LFI': '6351',
 'HTTP:PHP:WEBSVN-CMD-INJ': '6352',
 'HTTP:PHP:WORDPRESS-JQUERY-LFI': '6353',
 'HTTP:PHP:WORDPRESS-MUL-FL-GAL': '6354',
 'HTTP:PHP:WORDPRESS-MUL-GND-ALBM': '6355',
 'HTTP:PHP:WORDPRESS-OPS-LFI': '6356',
 'HTTP:PHP:WORDPRESS-SPEED-RCE': '6357',
 'HTTP:PHP:WORDPRESS-SPELCHECK-FI': '6358',
 'HTTP:PHP:WORDPRESS-UPLOAD': '6359',
 'HTTP:PHP:WORDPRESS-WPCUSTOM-LFI': '6360',
 'HTTP:PHP:WP-ANNOUNCES-RFI': '6361',
 'HTTP:PHP:WP-IS-HUMAN-CMD-INJ': '6362',
 'HTTP:PHP:WP-WPTOUCH-REDIRECT': '6363',
 'HTTP:PHP:XOOPS-BANNERS-LFI': '6364',
 'HTTP:PROXY:ANON:PHPROXY': '6365',
 'HTTP:PROXY:JONDO-PROXY': '6366',
 'HTTP:PROXY:PROXYPRO-GET': '6367',
 'HTTP:PROXY:SQUID-CACHE-UPDATE': '6368',
 'HTTP:PROXY:SQUID-HEADER-DOS': '6369',
 'HTTP:PROXY:SQUID-NULL-PTR': '6370',
 'HTTP:PROXY:SQUID-STRLISTGETITEM': '6371',
 'HTTP:PROXY:SQUID-TRACE': '6372',
 'HTTP:PROXY:WINGATE-OF': '6373',
 'HTTP:REAL-DESCBO': '6374',
 'HTTP:REQERR:FS-HOST': '6375',
 'HTTP:REQERR:REQ-INJECTION': '6376',
 'HTTP:REQERR:REQ-INVALID-FORMAT': '6377',
 'HTTP:REQERR:URL-LF-CR': '6378',
 'HTTP:ROBOHELP-SQL-INJ': '6379',
 'HTTP:SKYPE-EZPMUTILS': '6380',
 'HTTP:SQL:INJ:4IMAGES-DETAIL-PHP': '6381',
 'HTTP:SQL:INJ:ALTER-MYSQL': '6382',
 'HTTP:SQL:INJ:CA-TOTAL-DEFENSE': '6383',
 'HTTP:SQL:INJ:CA-TOTAL-UNCWS': '6384',
 'HTTP:SQL:INJ:CHAR-ENCODE': '6385',
 'HTTP:SQL:INJ:CISCO-UCM': '6386',
 'HTTP:SQL:INJ:COVER-VISION-ID': '6387',
 'HTTP:SQL:INJ:DH-MLM-LOGIN-PHP': '6388',
 'HTTP:SQL:INJ:HAVIJ-UA': '6389',
 'HTTP:SQL:INJ:JOOMLA-ALLCINEVID': '6390',
 'HTTP:SQL:INJ:JOOMLA-ALPHA-EMAIL': '6391',
 'HTTP:SQL:INJ:JOOMLA-AVRELOADED': '6392',
 'HTTP:SQL:INJ:JOOMLA-CALCBUILDER': '6393',
 'HTTP:SQL:INJ:JOOMLA-CBCONTACT': '6394',
 'HTTP:SQL:INJ:JOOMLA-COM-CCBOARD': '6395',
 'HTTP:SQL:INJ:JOOMLA-COM-CLAN': '6396',
 'HTTP:SQL:INJ:JOOMLA-COM-JCE': '6397',
 'HTTP:SQL:INJ:JOOMLA-COM-JOOMNIK': '6398',
 'HTTP:SQL:INJ:JOOMLA-COM-SHOP': '6399',
 'HTTP:SQL:INJ:JOOMLA-COMHOSPITAL': '6400',
 'HTTP:SQL:INJ:JOOMLA-COMTEAM': '6401',
 'HTTP:SQL:INJ:JOOMLA-CONTROLLER': '6402',
 'HTTP:SQL:INJ:JOOMLA-FAQ-BOOK': '6403',
 'HTTP:SQL:INJ:JOOMLA-FILTERORDER': '6404',
 'HTTP:SQL:INJ:JOOMLA-FOTO': '6405',
 'HTTP:SQL:INJ:JOOMLA-JUICY-PICID': '6406',
 'HTTP:SQL:INJ:JOOMLA-MAPLOCATOR': '6407',
 'HTTP:SQL:INJ:JOOMLA-MORFEOSHOW': '6408',
 'HTTP:SQL:INJ:JOOMLA-NEWSSEARCH': '6409',
 'HTTP:SQL:INJ:JOOMLA-QUESTION': '6410',
 'HTTP:SQL:INJ:JOOMLA-RESTAURANTE': '6411',
 'HTTP:SQL:INJ:JOOMLA-VIRTUAL-MEM': '6412',
 'HTTP:SQL:INJ:JOOMLA-VIRTUEMART': '6413',
 'HTTP:SQL:INJ:JOOSTINA': '6414',
 'HTTP:SQL:INJ:KUBELABS-PHPDUG': '6415',
 'HTTP:SQL:INJ:MAIAN-WEBLOG': '6416',
 'HTTP:SQL:INJ:MAMBO-COM-DOCMAN': '6417',
 'HTTP:SQL:INJ:MYSCHOOL': '6418',
 'HTTP:SQL:INJ:MYSQL-BINLOG-DOS': '6419',
 'HTTP:SQL:INJ:MYSQL-PRIV-ESCAL': '6420',
 'HTTP:SQL:INJ:PANGOLIN': '6421',
 'HTTP:SQL:INJ:SELECT-SUB-DOS': '6422',
 'HTTP:SQL:INJ:SFX-SQLI': '6423',
 'HTTP:SQL:INJ:SLASH-STAR': '6424',
 'HTTP:SQL:INJ:SQL-INJ-URL': '6425',
 'HTTP:SQL:INJ:SQLMAP-ACTIVITY': '6426',
 'HTTP:SQL:INJ:SYMANTEC-IM': '6427',
 'HTTP:SQL:INJ:SYNDEO-CMS-USRNAME': '6428',
 'HTTP:SQL:INJ:SYNERGY-SW': '6429',
 'HTTP:SQL:INJ:TEDE-SIMPLIFICADO': '6430',
 'HTTP:SQL:INJ:TOLINET-AGENCIA-ID': '6431',
 'HTTP:SQL:INJ:UNION-SELECT': '6432',
 'HTTP:SQL:INJ:WORDPRESS-ID': '6433',
 'HTTP:SQL:INJ:WORDPRESS-WP-FRM': '6434',
 'HTTP:SQL:INJ:WP-AJAX-CATEGORY': '6435',
 'HTTP:SQL:INJ:WP-ECOMMERCE': '6436',
 'HTTP:SQL:INJ:WP-EVENTS-MGR': '6437',
 'HTTP:SQL:INJ:WP-GD-STAR-RATING': '6438',
 'HTTP:SQL:INJ:WP-MEDIA-LIBRARY': '6439',
 'HTTP:SQL:INJ:WP-MULTIPLE': '6440',
 'HTTP:SQL:INJ:WP-PHOTORACER': '6441',
 'HTTP:SQL:INJ:WP-SERMON-BROWSER': '6442',
 'HTTP:SQL:INJ:WP-STARSRATEBOX': '6443',
 'HTTP:SQL:INJ:WP-SUPER-CAPTCHA': '6444',
 'HTTP:SQL:INJ:WP-SYMPOSIUM': '6445',
 'HTTP:SQL:INJ:WP-UNIVERSAL-POST': '6446',
 'HTTP:SQL:INJ:XPCMDSHELL': '6447',
 'HTTP:SQL:INJ:YABSOFT-GALLERY-ID': '6448',
 'HTTP:STC:ABOUT-JAVASCRIPT': '6449',
 'HTTP:STC:ACTIVEX:ACCESS-CORRUPT': '6450',
 'HTTP:STC:ACTIVEX:ADESK-AX': '6451',
 'HTTP:STC:ACTIVEX:ADOBE-DL-MGR': '6452',
 'HTTP:STC:ACTIVEX:AEXNSCONSOLE': '6453',
 'HTTP:STC:ACTIVEX:ALTIRIS': '6454',
 'HTTP:STC:ACTIVEX:AVAYA-ONE-X': '6455',
 'HTTP:STC:ACTIVEX:AXISMEDIA-AX': '6456',
 'HTTP:STC:ACTIVEX:BAOFENG-BO': '6457',
 'HTTP:STC:ACTIVEX:BARCODEWIZ': '6458',
 'HTTP:STC:ACTIVEX:BLACKICE': '6459',
 'HTTP:STC:ACTIVEX:BROADWIN': '6460',
 'HTTP:STC:ACTIVEX:BROADWIN-RCE': '6461',
 'HTTP:STC:ACTIVEX:CA-ETRUST': '6462',
 'HTTP:STC:ACTIVEX:CA-PSFORMX-AX': '6463',
 'HTTP:STC:ACTIVEX:CA-WEBSCAN-AX': '6464',
 'HTTP:STC:ACTIVEX:CA-XMLSECDB': '6465',
 'HTTP:STC:ACTIVEX:CAPICOM': '6466',
 'HTTP:STC:ACTIVEX:CHILLKAT-CRYPT': '6467',
 'HTTP:STC:ACTIVEX:CISCO-CSD-WEB': '6468',
 'HTTP:STC:ACTIVEX:CISCO-VPN': '6469',
 'HTTP:STC:ACTIVEX:CITRIX-GATEWAY': '6470',
 'HTTP:STC:ACTIVEX:COM-OBJ': '6471',
 'HTTP:STC:ACTIVEX:CRYSTAL-PRINT': '6472',
 'HTTP:STC:ACTIVEX:CRYSTAL-SEARCH': '6473',
 'HTTP:STC:ACTIVEX:CYGNICON': '6474',
 'HTTP:STC:ACTIVEX:DA-DATUPLE': '6475',
 'HTTP:STC:ACTIVEX:DATA-ACTIVEBAR': '6476',
 'HTTP:STC:ACTIVEX:DATA-ANALYSIS': '6477',
 'HTTP:STC:ACTIVEX:DELL-INFO-DISC': '6478',
 'HTTP:STC:ACTIVEX:DELL-SCANNER': '6479',
 'HTTP:STC:ACTIVEX:DEV-TOOL': '6480',
 'HTTP:STC:ACTIVEX:DOM-INOTES-WEB': '6481',
 'HTTP:STC:ACTIVEX:DRM-MSNETOBJ': '6482',
 'HTTP:STC:ACTIVEX:EASEWE-FTP': '6483',
 'HTTP:STC:ACTIVEX:EASYMAIL-CNCT': '6484',
 'HTTP:STC:ACTIVEX:EASYMAIL-EXP': '6485',
 'HTTP:STC:ACTIVEX:EASYMAIL-IMAP4': '6486',
 'HTTP:STC:ACTIVEX:EASYMAIL-LEAK': '6487',
 'HTTP:STC:ACTIVEX:EASYMAIL-SMTP': '6488',
 'HTTP:STC:ACTIVEX:EBOOK-FLIP': '6489',
 'HTTP:STC:ACTIVEX:EDRAW-OFF-BOF': '6490',
 'HTTP:STC:ACTIVEX:EMC-KEYHELP': '6491',
 'HTTP:STC:ACTIVEX:EMV-PIXTOOLS': '6492',
 'HTTP:STC:ACTIVEX:F-SECURE-MC': '6493',
 'HTTP:STC:ACTIVEX:FLASH9D-CSS': '6494',
 'HTTP:STC:ACTIVEX:GESTEC-ELONFMT': '6495',
 'HTTP:STC:ACTIVEX:GRPWISE-GIXMIM': '6496',
 'HTTP:STC:ACTIVEX:HHCTRL-IMAGE': '6497',
 'HTTP:STC:ACTIVEX:HP-AUDIO-REC': '6498',
 'HTTP:STC:ACTIVEX:HP-EASYPRINTER': '6499',
 'HTTP:STC:ACTIVEX:HP-SW-UPDATE': '6500',
 'HTTP:STC:ACTIVEX:HP-XUPLOAD-OCX': '6501',
 'HTTP:STC:ACTIVEX:HPQUTIL': '6502',
 'HTTP:STC:ACTIVEX:IBM-ACCESS-AX': '6503',
 'HTTP:STC:ACTIVEX:IBM-EGATHERER': '6504',
 'HTTP:STC:ACTIVEX:ICONICS-TRUST': '6505',
 'HTTP:STC:ACTIVEX:ICONICS-WEBHMI': '6506',
 'HTTP:STC:ACTIVEX:ICQPHONE-EXEC': '6507',
 'HTTP:STC:ACTIVEX:IE8-IEDVTOOL': '6508',
 'HTTP:STC:ACTIVEX:IETAB-AX': '6509',
 'HTTP:STC:ACTIVEX:INDUSOFT-ISSYM': '6510',
 'HTTP:STC:ACTIVEX:INST-SHLD-FO': '6511',
 'HTTP:STC:ACTIVEX:IPRINT-CB': '6512',
 'HTTP:STC:ACTIVEX:IPRINT-DEL': '6513',
 'HTTP:STC:ACTIVEX:IPRINT-DRVSET': '6514',
 'HTTP:STC:ACTIVEX:IPRINT-IENIPP': '6515',
 'HTTP:STC:ACTIVEX:ISIS-AFP-BO': '6516',
 'HTTP:STC:ACTIVEX:ISSYMBOL': '6517',
 'HTTP:STC:ACTIVEX:IV-IMAGE2PDF': '6518',
 'HTTP:STC:ACTIVEX:JETAUDIO-DIR': '6519',
 'HTTP:STC:ACTIVEX:JNPR-SSL-VPN': '6520',
 'HTTP:STC:ACTIVEX:JRE-DNSRESOLVE': '6521',
 'HTTP:STC:ACTIVEX:JVIEWPRO': '6522',
 'HTTP:STC:ACTIVEX:LEADTOOLS': '6523',
 'HTTP:STC:ACTIVEX:LIQUID-XML': '6524',
 'HTTP:STC:ACTIVEX:LIVE-MSG': '6525',
 'HTTP:STC:ACTIVEX:LIVE-PROFILE': '6526',
 'HTTP:STC:ACTIVEX:LTOCXTWAINU': '6527',
 'HTTP:STC:ACTIVEX:MAPGUIDE-LAYER': '6528',
 'HTTP:STC:ACTIVEX:MCFEE-MCINSCTL': '6529',
 'HTTP:STC:ACTIVEX:MOXA-PFILENAME': '6530',
 'HTTP:STC:ACTIVEX:MS-AGENT-LIB': '6531',
 'HTTP:STC:ACTIVEX:MS-IE-COM-RCE': '6532',
 'HTTP:STC:ACTIVEX:MS-MDAC': '6533',
 'HTTP:STC:ACTIVEX:MS-MDAC2': '6534',
 'HTTP:STC:ACTIVEX:MS-OWC': '6535',
 'HTTP:STC:ACTIVEX:MS-OWC-BOF': '6536',
 'HTTP:STC:ACTIVEX:MS-OWC-RCE': '6537',
 'HTTP:STC:ACTIVEX:MS-PLAYER-RCE': '6538',
 'HTTP:STC:ACTIVEX:MS-SQLDMO': '6539',
 'HTTP:STC:ACTIVEX:MS-WIN-MSGR': '6540',
 'HTTP:STC:ACTIVEX:MS-XML-CORE': '6541',
 'HTTP:STC:ACTIVEX:MSACCESS-AX': '6542',
 'HTTP:STC:ACTIVEX:MSDA': '6543',
 'HTTP:STC:ACTIVEX:MSO-DATASRC': '6544',
 'HTTP:STC:ACTIVEX:MSXML2-MEMCORR': '6545',
 'HTTP:STC:ACTIVEX:MW6-BARCODE': '6546',
 'HTTP:STC:ACTIVEX:NOVELL-IPRINT': '6547',
 'HTTP:STC:ACTIVEX:OFFICEVIEW-DOS': '6548',
 'HTTP:STC:ACTIVEX:OLEAUTO32': '6549',
 'HTTP:STC:ACTIVEX:ORACLE-DOC-CAP': '6550',
 'HTTP:STC:ACTIVEX:ORACLE-MUL-DOC': '6551',
 'HTTP:STC:ACTIVEX:ORACLE-SIEBEL': '6552',
 'HTTP:STC:ACTIVEX:PCVUE-SCADA': '6553',
 'HTTP:STC:ACTIVEX:PDWIZARD': '6554',
 'HTTP:STC:ACTIVEX:PESTPATROL': '6555',
 'HTTP:STC:ACTIVEX:PHOTOBASIC-AX': '6556',
 'HTTP:STC:ACTIVEX:PRO-SOFTNET': '6557',
 'HTTP:STC:ACTIVEX:QT-MARSH-PUNK': '6558',
 'HTTP:STC:ACTIVEX:QUICKTIME-BOF': '6559',
 'HTTP:STC:ACTIVEX:REAL-CDDA-URI': '6560',
 'HTTP:STC:ACTIVEX:REAL-GAMEHOUSE': '6561',
 'HTTP:STC:ACTIVEX:REAL-IEFRAME': '6562',
 'HTTP:STC:ACTIVEX:REAL-IERPCTL': '6563',
 'HTTP:STC:ACTIVEX:REAL-IERPPLUG': '6564',
 'HTTP:STC:ACTIVEX:REAL-STUBYUTIL': '6565',
 'HTTP:STC:ACTIVEX:REALARCADE-RCE': '6566',
 'HTTP:STC:ACTIVEX:RECORDCLIP': '6567',
 'HTTP:STC:ACTIVEX:RICHTXT': '6568',
 'HTTP:STC:ACTIVEX:ROXIO-CINEPL': '6569',
 'HTTP:STC:ACTIVEX:RP-CDDA-URI': '6570',
 'HTTP:STC:ACTIVEX:SAP-BEXGLOBAL': '6571',
 'HTTP:STC:ACTIVEX:SAP-CRSTL-RPT': '6572',
 'HTTP:STC:ACTIVEX:SAP-GUI-TABONE': '6573',
 'HTTP:STC:ACTIVEX:SAP-WEBBVIEWER': '6574',
 'HTTP:STC:ACTIVEX:SAPGUI-AX': '6575',
 'HTTP:STC:ACTIVEX:SNAPVIEW-RCE': '6576',
 'HTTP:STC:ACTIVEX:SONICWALL-VPN': '6577',
 'HTTP:STC:ACTIVEX:SOPCAST-CNAME': '6578',
 'HTTP:STC:ACTIVEX:SPEECH-API': '6579',
 'HTTP:STC:ACTIVEX:SYGATE-SSHELP': '6580',
 'HTTP:STC:ACTIVEX:SYMC-CLIPROXY': '6581',
 'HTTP:STC:ACTIVEX:SYMC-NAVCOMUI': '6582',
 'HTTP:STC:ACTIVEX:THREEDIFY-BOF': '6583',
 'HTTP:STC:ACTIVEX:TM-ISP-2010': '6584',
 'HTTP:STC:ACTIVEX:TOM-SAMYER-GET': '6585',
 'HTTP:STC:ACTIVEX:TUMBLEWEED': '6586',
 'HTTP:STC:ACTIVEX:URLMON-DLL': '6587',
 'HTTP:STC:ACTIVEX:UUSEE-UUPLAYER': '6588',
 'HTTP:STC:ACTIVEX:VB-TLBINF32': '6589',
 'HTTP:STC:ACTIVEX:VFP6R': '6590',
 'HTTP:STC:ACTIVEX:VMWARE-FS': '6591',
 'HTTP:STC:ACTIVEX:WIN2K-AX': '6592',
 'HTTP:STC:ACTIVEX:WMI-ADMIN': '6593',
 'HTTP:STC:ACTIVEX:WMI-TOOLS': '6594',
 'HTTP:STC:ACTIVEX:WONDERWARE': '6595',
 'HTTP:STC:ACTIVEX:XML-CORE-3-0': '6596',
 'HTTP:STC:ACTIVEX:YAHOO-AUDIO': '6597',
 'HTTP:STC:ACTIVEX:YAHOO-RCE': '6598',
 'HTTP:STC:ACTIVEX:YDPCTL': '6599',
 'HTTP:STC:ACTIVEX:YMAILATTACH-OF': '6600',
 'HTTP:STC:ACTIVEX:YOUNGZSOFT': '6601',
 'HTTP:STC:ADOBE:ACROBAT-BMP-BIT': '6602',
 'HTTP:STC:ADOBE:ACROBAT-BMP-HEAD': '6603',
 'HTTP:STC:ADOBE:ACROBAT-BMP-RLE': '6604',
 'HTTP:STC:ADOBE:ACROBAT-GETICON': '6605',
 'HTTP:STC:ADOBE:ACROBAT-GLYPH-MC': '6606',
 'HTTP:STC:ADOBE:ACROBAT-IFF-OF': '6607',
 'HTTP:STC:ADOBE:ACROBAT-JPEG2000': '6608',
 'HTTP:STC:ADOBE:ACROBAT-JS-XRF': '6609',
 'HTTP:STC:ADOBE:ACROBAT-PCX-OF': '6610',
 'HTTP:STC:ADOBE:ACROBAT-PICT-IMG': '6611',
 'HTTP:STC:ADOBE:ACROBAT-U3D-BO': '6612',
 'HTTP:STC:ADOBE:ACROBAT-U3D-RCE': '6613',
 'HTTP:STC:ADOBE:ACROFORM-MEM': '6614',
 'HTTP:STC:ADOBE:AUD-SESSFILE': '6615',
 'HTTP:STC:ADOBE:AUD-TRKM': '6616',
 'HTTP:STC:ADOBE:BMP-HEADER': '6617',
 'HTTP:STC:ADOBE:DEFINEFONT': '6618',
 'HTTP:STC:ADOBE:EMBED-OBJ-MIME': '6619',
 'HTTP:STC:ADOBE:FLASH-ACTIONIF': '6620',
 'HTTP:STC:ADOBE:FLASH-ARGCOUNT': '6621',
 'HTTP:STC:ADOBE:FLASH-ARGREST': '6622',
 'HTTP:STC:ADOBE:FLASH-AS-MEM-DOS': '6623',
 'HTTP:STC:ADOBE:FLASH-AS2-OF': '6624',
 'HTTP:STC:ADOBE:FLASH-BITMAPDATA': '6625',
 'HTTP:STC:ADOBE:FLASH-BMD-SCROLL': '6626',
 'HTTP:STC:ADOBE:FLASH-DYN-CALC': '6627',
 'HTTP:STC:ADOBE:FLASH-FILEREF-BO': '6628',
 'HTTP:STC:ADOBE:FLASH-INT-DOS': '6629',
 'HTTP:STC:ADOBE:FLASH-INVOP': '6630',
 'HTTP:STC:ADOBE:FLASH-MP4LOAD-BO': '6631',
 'HTTP:STC:ADOBE:FLASH-RUNTIME': '6632',
 'HTTP:STC:ADOBE:FLASH-SEQUENCE': '6633',
 'HTTP:STC:ADOBE:FLASH-SETSLOT': '6634',
 'HTTP:STC:ADOBE:FLASH-SNATIVE': '6635',
 'HTTP:STC:ADOBE:FLASH-XDOMAIN': '6636',
 'HTTP:STC:ADOBE:FLASH-XSRF': '6637',
 'HTTP:STC:ADOBE:LIBTIF-FETCHDATA': '6638',
 'HTTP:STC:ADOBE:MAL-BMP': '6639',
 'HTTP:STC:ADOBE:MAL-IFF': '6640',
 'HTTP:STC:ADOBE:MAL-PSD': '6641',
 'HTTP:STC:ADOBE:PDF-3D-WH': '6642',
 'HTTP:STC:ADOBE:PDF-BITDEF-OF': '6643',
 'HTTP:STC:ADOBE:PDF-CATALOG': '6644',
 'HTTP:STC:ADOBE:PDF-CCITT': '6645',
 'HTTP:STC:ADOBE:PDF-CIDFONT': '6646',
 'HTTP:STC:ADOBE:PDF-CLUT': '6647',
 'HTTP:STC:ADOBE:PDF-COLORS-INT': '6648',
 'HTTP:STC:ADOBE:PDF-COMPACT': '6649',
 'HTTP:STC:ADOBE:PDF-COOLTYPE-BO': '6650',
 'HTTP:STC:ADOBE:PDF-COOLTYPE-RCE': '6651',
 'HTTP:STC:ADOBE:PDF-DESC-FONTS': '6652',
 'HTTP:STC:ADOBE:PDF-DRAWIMG': '6653',
 'HTTP:STC:ADOBE:PDF-EXT-OF': '6654',
 'HTTP:STC:ADOBE:PDF-FETCHSHORT': '6655',
 'HTTP:STC:ADOBE:PDF-FIELDDIR': '6656',
 'HTTP:STC:ADOBE:PDF-FLATEDECODE': '6657',
 'HTTP:STC:ADOBE:PDF-FONT': '6658',
 'HTTP:STC:ADOBE:PDF-FREETYPE': '6659',
 'HTTP:STC:ADOBE:PDF-GDI-OBJ-RCE': '6660',
 'HTTP:STC:ADOBE:PDF-GETANNOTS': '6661',
 'HTTP:STC:ADOBE:PDF-GLYPH-OF': '6662',
 'HTTP:STC:ADOBE:PDF-GOTO-XSS': '6663',
 'HTTP:STC:ADOBE:PDF-ICC': '6664',
 'HTTP:STC:ADOBE:PDF-ICC-MLUC': '6665',
 'HTTP:STC:ADOBE:PDF-ICC-PRODESC': '6666',
 'HTTP:STC:ADOBE:PDF-JPEG-FILE-CE': '6667',
 'HTTP:STC:ADOBE:PDF-JPXDECODE': '6668',
 'HTTP:STC:ADOBE:PDF-JS-FILE': '6669',
 'HTTP:STC:ADOBE:PDF-JS-HIDE': '6670',
 'HTTP:STC:ADOBE:PDF-JS-METHOD': '6671',
 'HTTP:STC:ADOBE:PDF-JS-NEWPLAYER': '6672',
 'HTTP:STC:ADOBE:PDF-LAUNCH-CMD': '6673',
 'HTTP:STC:ADOBE:PDF-LIBTIFF': '6674',
 'HTTP:STC:ADOBE:PDF-MAL-JPEG': '6675',
 'HTTP:STC:ADOBE:PDF-OBFUSCATION': '6676',
 'HTTP:STC:ADOBE:PDF-PICT-HEAP-OF': '6677',
 'HTTP:STC:ADOBE:PDF-PRINTSEPS': '6678',
 'HTTP:STC:ADOBE:PDF-PRINTSEPS-2': '6679',
 'HTTP:STC:ADOBE:PDF-SPELL-MC': '6680',
 'HTTP:STC:ADOBE:PDF-TJ-OBJECT': '6681',
 'HTTP:STC:ADOBE:PDF-U3D-BO': '6682',
 'HTTP:STC:ADOBE:PDF-U3D-CLOD': '6683',
 'HTTP:STC:ADOBE:PDF-UNI-3D': '6684',
 'HTTP:STC:ADOBE:PDF-UNIVERSAL3D': '6685',
 'HTTP:STC:ADOBE:PDF-URI-OACTION': '6686',
 'HTTP:STC:ADOBE:PDF-UTILPRINTF': '6687',
 'HTTP:STC:ADOBE:PDF-UUEXEC': '6688',
 'HTTP:STC:ADOBE:PDF-XML-XSS': '6689',
 'HTTP:STC:ADOBE:PHOTOSHOP-CS5-MC': '6690',
 'HTTP:STC:ADOBE:PPT-EXTTIMENODE': '6691',
 'HTTP:STC:ADOBE:PS-CS4-ABR': '6692',
 'HTTP:STC:ADOBE:PS-PNG': '6693',
 'HTTP:STC:ADOBE:READER-BPROTECT': '6694',
 'HTTP:STC:ADOBE:READER-DOTRANGE': '6695',
 'HTTP:STC:ADOBE:READER-FONT-OF': '6696',
 'HTTP:STC:ADOBE:READER-PICT-RLE': '6697',
 'HTTP:STC:ADOBE:SWF-ACTIONIF-DO': '6698',
 'HTTP:STC:ADOBE:SWF-ACTIONSCRIPT': '6699',
 'HTTP:STC:ADOBE:SWF-ACTIONSET': '6700',
 'HTTP:STC:ADOBE:SWF-APPLY-FUNC': '6701',
 'HTTP:STC:ADOBE:SWF-BUTTON': '6702',
 'HTTP:STC:ADOBE:SWF-DEFINEFONT4': '6703',
 'HTTP:STC:ADOBE:SWF-DEFINEFUNC2': '6704',
 'HTTP:STC:ADOBE:SWF-EVENTLISTEN': '6705',
 'HTTP:STC:ADOBE:SWF-FLASH-BOF': '6706',
 'HTTP:STC:ADOBE:SWF-FLV-PROC': '6707',
 'HTTP:STC:ADOBE:SWF-GRADIENTFIL2': '6708',
 'HTTP:STC:ADOBE:SWF-GRADIENTFILL': '6709',
 'HTTP:STC:ADOBE:SWF-IN-PDF': '6710',
 'HTTP:STC:ADOBE:SWF-INVALID-OBF': '6711',
 'HTTP:STC:ADOBE:SWF-JPG-OF': '6712',
 'HTTP:STC:ADOBE:SWF-LINUX-AS': '6713',
 'HTTP:STC:ADOBE:SWF-MAL-AS': '6714',
 'HTTP:STC:ADOBE:SWF-MAL-AS-OF': '6715',
 'HTTP:STC:ADOBE:SWF-MAL-AS-RCE': '6716',
 'HTTP:STC:ADOBE:SWF-MAL-FILE': '6717',
 'HTTP:STC:ADOBE:SWF-METHOD-BODY': '6718',
 'HTTP:STC:ADOBE:SWF-NEWFUNC': '6719',
 'HTTP:STC:ADOBE:SWF-OPENTYPE-CFF': '6720',
 'HTTP:STC:ADOBE:SWF-POINTOBJ': '6721',
 'HTTP:STC:ADOBE:SWF-SEC-BYPASS': '6722',
 'HTTP:STC:ADOBE:SWF-SETTARGET': '6723',
 'HTTP:STC:ADOBE:SWF-UNC-JUMP': '6724',
 'HTTP:STC:ADOBE:SWF-XLS-MALF': '6725',
 'HTTP:STC:ADOBE:SWF-XSFORGE': '6726',
 'HTTP:STC:ADOBE:TSAC-STRING': '6727',
 'HTTP:STC:ADOBE:U3D-CLODMESH-MC': '6728',
 'HTTP:STC:ADOBE:XFIR-KEY': '6729',
 'HTTP:STC:ADOBE:XFIR-LNAM': '6730',
 'HTTP:STC:ADOBE:XFIR-PAMI': '6731',
 'HTTP:STC:ADOBE:XFIR-PAMI-RCE': '6732',
 'HTTP:STC:ADOBE:XFIR-PAMM-MEM': '6733',
 'HTTP:STC:ADOBE:XFIR-RCSL': '6734',
 'HTTP:STC:ADOBE:XFIR-RECORD': '6735',
 'HTTP:STC:ADOBE:XFIR-TSAC': '6736',
 'HTTP:STC:ATL:DIRECTSHOW': '6737',
 'HTTP:STC:ATL:MSOFFICE-AX': '6738',
 'HTTP:STC:ATL:OWC': '6739',
 'HTTP:STC:AV-MAGIC-EVADE': '6740',
 'HTTP:STC:AVI-CINEPACK-CODEC-OF': '6741',
 'HTTP:STC:BLACKBERRY-SVR-DOS': '6742',
 'HTTP:STC:BROWSER-DISPLAY-BOX-MC': '6743',
 'HTTP:STC:BROWSER-FLOAT-STYLE-MC': '6744',
 'HTTP:STC:BT:FDM-TORRENT-BOF': '6745',
 'HTTP:STC:CHROME:BUG-REPORT-CE': '6746',
 'HTTP:STC:CHROME:GURL-XO-BYPASS': '6747',
 'HTTP:STC:CHROME:MUL-FILE-TYPE': '6748',
 'HTTP:STC:CHROME:STALE-PTR': '6749',
 'HTTP:STC:CHROME:WEBKIT-FLOAT-PT': '6750',
 'HTTP:STC:CHROME:WEBKIT-OO': '6751',
 'HTTP:STC:CLSID:ACTIVEX:ADOBELOC': '6752',
 'HTTP:STC:CLSID:ACTIVEX:JINIT-AX': '6753',
 'HTTP:STC:CSS-STATUS-BAR-SPOOF': '6754',
 'HTTP:STC:DAVREDIR': '6755',
 'HTTP:STC:DIRECTSHOW-AVI-EXEC': '6756',
 'HTTP:STC:DIRECTX-AVI-WAV-PARSE': '6757',
 'HTTP:STC:DL:4XM-VULNS': '6758',
 'HTTP:STC:DL:ACDSEE-XBM-WIDTH': '6759',
 'HTTP:STC:DL:ACDSEE-XPM-COLOR': '6760',
 'HTTP:STC:DL:ACDSEE-XPM-VALUES': '6761',
 'HTTP:STC:DL:ACE-BO': '6762',
 'HTTP:STC:DL:APPLE-DMG-VOLNAME': '6763',
 'HTTP:STC:DL:APPLE-ITUNES-IO': '6764',
 'HTTP:STC:DL:APPLE-PICT': '6765',
 'HTTP:STC:DL:APPLE-PLS-FILE-BOF': '6766',
 'HTTP:STC:DL:APPLE-QT-H264-BOF': '6767',
 'HTTP:STC:DL:APPLE-QT-H264-OF': '6768',
 'HTTP:STC:DL:APPLE-QT-IMAGE-MC': '6769',
 'HTTP:STC:DL:APPLE-QT-JPEG-OF': '6770',
 'HTTP:STC:DL:APPLE-QT-VR-TRCK-OF': '6771',
 'HTTP:STC:DL:APPLE-SGI-BOF': '6772',
 'HTTP:STC:DL:ARJ-BO': '6773',
 'HTTP:STC:DL:ASF-DF': '6774',
 'HTTP:STC:DL:ASF-SR': '6775',
 'HTTP:STC:DL:AV-CAB-HEADER': '6776',
 'HTTP:STC:DL:AVAST-LHA': '6777',
 'HTTP:STC:DL:AVI-DL-MEM': '6778',
 'HTTP:STC:DL:AVI-LIST-OF': '6779',
 'HTTP:STC:DL:AVI-MMAKER': '6780',
 'HTTP:STC:DL:BITDEFEND-SCRIPT': '6781',
 'HTTP:STC:DL:BZIP2-FILE': '6782',
 'HTTP:STC:DL:CAB-VULNS': '6783',
 'HTTP:STC:DL:CGM-IMG-BOF': '6784',
 'HTTP:STC:DL:CLAMAV-CHM-DOS': '6785',
 'HTTP:STC:DL:CLAMAV-INT': '6786',
 'HTTP:STC:DL:CLAMAV-JPEG-DOS': '6787',
 'HTTP:STC:DL:CLAMAV-MEW-PACKED': '6788',
 'HTTP:STC:DL:CLAMAV-PE-INT': '6789',
 'HTTP:STC:DL:COLORMGMT-PATHNAME': '6790',
 'HTTP:STC:DL:COM-CLSID-DLL': '6791',
 'HTTP:STC:DL:COOLPLAYER-PLAYLIST': '6792',
 'HTTP:STC:DL:CRYSTAL-RPT-OLE': '6793',
 'HTTP:STC:DL:CYBERLINK-LIST-OF': '6794',
 'HTTP:STC:DL:DIRECTSHOW-QUICK-MC': '6795',
 'HTTP:STC:DL:DIRECTX-SAMI': '6796',
 'HTTP:STC:DL:DOC-FIB': '6797',
 'HTTP:STC:DL:DS-ATOM-TABLE': '6798',
 'HTTP:STC:DL:EICAR': '6799',
 'HTTP:STC:DL:EMF-EMR-INT': '6800',
 'HTTP:STC:DL:EMF-OF': '6801',
 'HTTP:STC:DL:EOT-IO': '6802',
 'HTTP:STC:DL:EPS-DSC-BOF': '6803',
 'HTTP:STC:DL:FAX-EDITOR-RCE': '6804',
 'HTTP:STC:DL:FFMPEG-READ-OF': '6805',
 'HTTP:STC:DL:FOXIT-PDF-OF': '6806',
 'HTTP:STC:DL:FREETYPE-TYPE1': '6807',
 'HTTP:STC:DL:GNOME-RC4-BO': '6808',
 'HTTP:STC:DL:GNU-TAR-PAX-BOF': '6809',
 'HTTP:STC:DL:GSTREAMER-QT-OF': '6810',
 'HTTP:STC:DL:GZIP-LHZ': '6811',
 'HTTP:STC:DL:HELP-CNT-OF': '6812',
 'HTTP:STC:DL:HELP-IMG-HEAP': '6813',
 'HTTP:STC:DL:INFORMIX-NFX': '6814',
 'HTTP:STC:DL:JAVA-FILEDIALOG-BOF': '6815',
 'HTTP:STC:DL:JAVA-SB-RES': '6816',
 'HTTP:STC:DL:JRE-APPLET2CLASS-LD': '6817',
 'HTTP:STC:DL:JVM-READMABCURVE': '6818',
 'HTTP:STC:DL:LIBFLAC-PIC-DESC': '6819',
 'HTTP:STC:DL:LIBFLAC-PIC-TYPE': '6820',
 'HTTP:STC:DL:LIBFLAC-VORBIS-CMT': '6821',
 'HTTP:STC:DL:LIBSNDFILE-PAF-OF': '6822',
 'HTTP:STC:DL:LIBXML2-ENTRY-NAME': '6823',
 'HTTP:STC:DL:LOTUS-DOC-VIEWER': '6824',
 'HTTP:STC:DL:MAL-AIFF': '6825',
 'HTTP:STC:DL:MAL-HLP-CHM': '6826',
 'HTTP:STC:DL:MAL-MDB': '6827',
 'HTTP:STC:DL:MAL-MIC-BICLRUSED': '6828',
 'HTTP:STC:DL:MAL-MOVIEMAKER': '6829',
 'HTTP:STC:DL:MAL-MPEG-4': '6830',
 'HTTP:STC:DL:MAL-RMF-GM': '6831',
 'HTTP:STC:DL:MAL-VBP': '6832',
 'HTTP:STC:DL:MAL-VISIO': '6833',
 'HTTP:STC:DL:MAL-WMV-MEDIA': '6834',
 'HTTP:STC:DL:MAL-WOFF': '6835',
 'HTTP:STC:DL:MFC-DOC-TITLE': '6836',
 'HTTP:STC:DL:MP3-WM-MEM': '6837',
 'HTTP:STC:DL:MPEG4-3IVX-FILE': '6838',
 'HTTP:STC:DL:MPG123-HEAP-OF': '6839',
 'HTTP:STC:DL:MPLAYER-CALLOC': '6840',
 'HTTP:STC:DL:MPLAYER-DEMUXER': '6841',
 'HTTP:STC:DL:MPLAYER-SAMI': '6842',
 'HTTP:STC:DL:MPLAYER-TWINVQ-BO': '6843',
 'HTTP:STC:DL:MPP-MEM-VAL': '6844',
 'HTTP:STC:DL:MS-EMF-PARSE': '6845',
 'HTTP:STC:DL:MS-EXCEL-OBJ-MC': '6846',
 'HTTP:STC:DL:MS-FON-FILE-RCE': '6847',
 'HTTP:STC:DL:MS-FONTMATRIX': '6848',
 'HTTP:STC:DL:MS-FOREFRONT-CUP': '6849',
 'HTTP:STC:DL:MS-GDI-EMF': '6850',
 'HTTP:STC:DL:MS-NET-CLILOADER-MC': '6851',
 'HTTP:STC:DL:MS-OFFICE-EXCEL-RCE': '6852',
 'HTTP:STC:DL:MS-OFFICE-PPT-BOF': '6853',
 'HTTP:STC:DL:MS-OFFICE-RCE': '6854',
 'HTTP:STC:DL:MS-OFFICE-WORD-BOF': '6855',
 'HTTP:STC:DL:MS-PUB-MC': '6856',
 'HTTP:STC:DL:MS-PUBLISHER-RCE': '6857',
 'HTTP:STC:DL:MS-READER-MC': '6858',
 'HTTP:STC:DL:MS-RICHEDIT-RCE': '6859',
 'HTTP:STC:DL:MS-VISIO-OBJ-MC': '6860',
 'HTTP:STC:DL:MS-WMF-DOS': '6861',
 'HTTP:STC:DL:MS-WMF-PARSE': '6862',
 'HTTP:STC:DL:MS-WORD-XST-BOF': '6863',
 'HTTP:STC:DL:MS-WORKS-BO': '6864',
 'HTTP:STC:DL:MSHTML-DBLFREE': '6865',
 'HTTP:STC:DL:MSHTML-HELP': '6866',
 'HTTP:STC:DL:MSOFFICE-MSO': '6867',
 'HTTP:STC:DL:MSPROJECT-MEM': '6868',
 'HTTP:STC:DL:MSPUBLISHER-OBJ': '6869',
 'HTTP:STC:DL:MSSQL-BACKUP-MEM': '6870',
 'HTTP:STC:DL:MSWKS-WPS-OF': '6871',
 'HTTP:STC:DL:MSWMM-OF': '6872',
 'HTTP:STC:DL:OFFICE-BMP-HEADER': '6873',
 'HTTP:STC:DL:OFFICE-CGM': '6874',
 'HTTP:STC:DL:OFFICE-MAL-PUB': '6875',
 'HTTP:STC:DL:OFFICE-PCT': '6876',
 'HTTP:STC:DL:OFFICE-PICT-MEM': '6877',
 'HTTP:STC:DL:OFFICEART-PROP': '6878',
 'HTTP:STC:DL:OFFICEART-RCE': '6879',
 'HTTP:STC:DL:OLE-ART-INV': '6880',
 'HTTP:STC:DL:OO-EMF': '6881',
 'HTTP:STC:DL:OO-OLE': '6882',
 'HTTP:STC:DL:OO-RTF': '6883',
 'HTTP:STC:DL:OO-WORD-TABLE': '6884',
 'HTTP:STC:DL:OO-XPMREAD-OF': '6885',
 'HTTP:STC:DL:OPENOFFICE-TIFF-OF': '6886',
 'HTTP:STC:DL:OPENSSL-CMS-FILE': '6887',
 'HTTP:STC:DL:OSX-GIF-BANDPROC': '6888',
 'HTTP:STC:DL:OTF-BO': '6889',
 'HTTP:STC:DL:OTF-CFF-RCE': '6890',
 'HTTP:STC:DL:OTF-DOS': '6891',
 'HTTP:STC:DL:OTF-FONT-INT': '6892',
 'HTTP:STC:DL:OTF-FONT-SIZE': '6893',
 'HTTP:STC:DL:OTF-GLYPH': '6894',
 'HTTP:STC:DL:OTF-INDEX-RCE': '6895',
 'HTTP:STC:DL:OTF-INF-LOOP': '6896',
 'HTTP:STC:DL:OTF-NULL-PTR': '6897',
 'HTTP:STC:DL:PAGEMAKER-OF': '6898',
 'HTTP:STC:DL:PANDA-ZOO-BO': '6899',
 'HTTP:STC:DL:PDF-FILE': '6900',
 'HTTP:STC:DL:PDF-PRINTSEPS': '6901',
 'HTTP:STC:DL:PDF-U3D-CLOD': '6902',
 'HTTP:STC:DL:PPT-FB1-ATOM-OF': '6903',
 'HTTP:STC:DL:PPT-FF-BOF': '6904',
 'HTTP:STC:DL:PPT-OEP-ATOM-INV': '6905',
 'HTTP:STC:DL:PPT-OFFART-ATOM-RCE': '6906',
 'HTTP:STC:DL:PPT-OFFICEART': '6907',
 'HTTP:STC:DL:PPT-SCRIPT': '6908',
 'HTTP:STC:DL:PPT-SCRIPT2': '6909',
 'HTTP:STC:DL:PPT-SHAPES-MEM': '6910',
 'HTTP:STC:DL:PPT-SLIDEATOM': '6911',
 'HTTP:STC:DL:PPT-TXMASTERSTYLE': '6912',
 'HTTP:STC:DL:PPT-UNK-ANI': '6913',
 'HTTP:STC:DL:PPT-VIEWER-MEMALLOC': '6914',
 'HTTP:STC:DL:PPTVIEWER-DRAWSHAPE': '6915',
 'HTTP:STC:DL:PUB-TEXTBOX': '6916',
 'HTTP:STC:DL:QT-COLOR-ATOM': '6917',
 'HTTP:STC:DL:QT-COLOR-TABLE': '6918',
 'HTTP:STC:DL:QT-CRGN-ATOM': '6919',
 'HTTP:STC:DL:QT-EMBED-JS': '6920',
 'HTTP:STC:DL:QT-FLASHPIX-BOF': '6921',
 'HTTP:STC:DL:QT-FLIC-BOF': '6922',
 'HTTP:STC:DL:QT-FLIPFILETYPE': '6923',
 'HTTP:STC:DL:QT-FPX-IO': '6924',
 'HTTP:STC:DL:QT-JVTCOMPENCODE': '6925',
 'HTTP:STC:DL:QT-OBJI': '6926',
 'HTTP:STC:DL:QT-PANORAMA-ATOM': '6927',
 'HTTP:STC:DL:QT-PDAT': '6928',
 'HTTP:STC:DL:QT-PV-GIF': '6929',
 'HTTP:STC:DL:QT-SMIL-FILEHAND': '6930',
 'HTTP:STC:DL:QT-STSD-ATOMS': '6931',
 'HTTP:STC:DL:QT-TOQTPOINTER': '6932',
 'HTTP:STC:DL:QT-UDTA-ATOM': '6933',
 'HTTP:STC:DL:QTPICT-REC-BO': '6934',
 'HTTP:STC:DL:QUICKTIME-PNSIZE': '6935',
 'HTTP:STC:DL:REAL-SWF-BOF': '6936',
 'HTTP:STC:DL:RTF-FPARSE-RCE': '6937',
 'HTTP:STC:DL:SEARCHMS-EXEC': '6938',
 'HTTP:STC:DL:SHOCKWAVE-3D-RCE': '6939',
 'HTTP:STC:DL:SOPHOS-MAL-VISIO': '6940',
 'HTTP:STC:DL:SOPHOS-ZIPDOS': '6941',
 'HTTP:STC:DL:SWF-ACTIONCONSTPOOL': '6942',
 'HTTP:STC:DL:SWF-ACTIONPUSH': '6943',
 'HTTP:STC:DL:SWF-PUSHSTRING': '6944',
 'HTTP:STC:DL:SWF-REALPLAYER-BO': '6945',
 'HTTP:STC:DL:SYM-AV-RAR': '6946',
 'HTTP:STC:DL:VBA-MEM-CORRUPT': '6947',
 'HTTP:STC:DL:VCF-SHELLEXECUTE': '6948',
 'HTTP:STC:DL:VIDEOLAN-WAV-IO': '6949',
 'HTTP:STC:DL:VISIO-BOF': '6950',
 'HTTP:STC:DL:VISIO-DLL-HIJACK': '6951',
 'HTTP:STC:DL:VISIO-DXF-RCE': '6952',
 'HTTP:STC:DL:VISIO-FREED': '6953',
 'HTTP:STC:DL:VISIO-INV-VERSION': '6954',
 'HTTP:STC:DL:VISIO-MAL-DXF': '6955',
 'HTTP:STC:DL:VISIO-OBJ-HEADER': '6956',
 'HTTP:STC:DL:VISIO-UMLSTRING': '6957',
 'HTTP:STC:DL:VISIO-VSD-ICON': '6958',
 'HTTP:STC:DL:VLC-MATROSKA': '6959',
 'HTTP:STC:DL:VLC-MP4-BOF': '6960',
 'HTTP:STC:DL:VLC-REALTEXT-BO': '6961',
 'HTTP:STC:DL:VLC-TY-BO': '6962',
 'HTTP:STC:DL:VLC-XSPF-MC': '6963',
 'HTTP:STC:DL:VLC-XSPF-MEM': '6964',
 'HTTP:STC:DL:VML-GRADIENT': '6965',
 'HTTP:STC:DL:VS-XML-INFO': '6966',
 'HTTP:STC:DL:WIN-EXE-DOWNLOAD': '6967',
 'HTTP:STC:DL:WIN-GDI-METAFILE': '6968',
 'HTTP:STC:DL:WIN-MAL-COMP-FILE': '6969',
 'HTTP:STC:DL:WINRAR-FILE': '6970',
 'HTTP:STC:DL:WMF-HEAPOF': '6971',
 'HTTP:STC:DL:WMF-IO': '6972',
 'HTTP:STC:DL:WMP-DVR-MS': '6973',
 'HTTP:STC:DL:WMP-SKIN-DECOMP': '6974',
 'HTTP:STC:DL:WMP-SKIN-PARSE': '6975',
 'HTTP:STC:DL:WORD-ARRAY-DATA': '6976',
 'HTTP:STC:DL:WORD-BOOKMARK-OF': '6977',
 'HTTP:STC:DL:WORD-CLSID': '6978',
 'HTTP:STC:DL:WORD-CMAJ': '6979',
 'HTTP:STC:DL:WORD-CONV-INT-OF': '6980',
 'HTTP:STC:DL:WORD-DOCSTREAM': '6981',
 'HTTP:STC:DL:WORD-DPENDGROUP': '6982',
 'HTTP:STC:DL:WORD-DPPOLYCOUNT': '6983',
 'HTTP:STC:DL:WORD-FILE-MEM': '6984',
 'HTTP:STC:DL:WORD-FONT': '6985',
 'HTTP:STC:DL:WORD-GLOBAL-INDEX': '6986',
 'HTTP:STC:DL:WORD-IND': '6987',
 'HTTP:STC:DL:WORD-LINK-OBJ': '6988',
 'HTTP:STC:DL:WORD-MAL-DOC': '6989',
 'HTTP:STC:DL:WORD-MAL-INDEX': '6990',
 'HTTP:STC:DL:WORD-MEM-CORR': '6991',
 'HTTP:STC:DL:WORD-RCE': '6992',
 'HTTP:STC:DL:WORD-REC-LEN-OF': '6993',
 'HTTP:STC:DL:WORD-RTF-CONTROL': '6994',
 'HTTP:STC:DL:WORD-RTF-MEM': '6995',
 'HTTP:STC:DL:WORD-RTF-RCE': '6996',
 'HTTP:STC:DL:WORD-SECTION-OF': '6997',
 'HTTP:STC:DL:WORD-SMART-TAGS': '6998',
 'HTTP:STC:DL:WORD-SMARTTAG': '6999',
 'HTTP:STC:DL:WORD-SPRM-MEM': '7000',
 'HTTP:STC:DL:WORD-SPRMCMAJ': '7001',
 'HTTP:STC:DL:WORD-SPRMDEFTABLE': '7002',
 'HTTP:STC:DL:WORD-SPRMTDIAGLINE': '7003',
 'HTTP:STC:DL:WORD-SPRMTSETBRC': '7004',
 'HTTP:STC:DL:WORD-STRING': '7005',
 'HTTP:STC:DL:WORD-STYLE-EXEC': '7006',
 'HTTP:STC:DL:WORD-STYLESHEET-MEM': '7007',
 'HTTP:STC:DL:WORD-TEXTBOX': '7008',
 'HTTP:STC:DL:WORDPAD-BO': '7009',
 'HTTP:STC:DL:WORDPAD-PRL': '7010',
 'HTTP:STC:DL:WP5-FILE': '7011',
 'HTTP:STC:DL:WPD-BO': '7012',
 'HTTP:STC:DL:WPD-WP3-TABLE-BO': '7013',
 'HTTP:STC:DL:XBM-BO': '7014',
 'HTTP:STC:DL:XLS-ARR-INDEX': '7015',
 'HTTP:STC:DL:XLS-AXISPARENT': '7016',
 'HTTP:STC:DL:XLS-BIFF-REC-RCE': '7017',
 'HTTP:STC:DL:XLS-BOUNDSHEET': '7018',
 'HTTP:STC:DL:XLS-BUFF-OR': '7019',
 'HTTP:STC:DL:XLS-CF-BIFF': '7020',
 'HTTP:STC:DL:XLS-CHART-OBJ': '7021',
 'HTTP:STC:DL:XLS-COLUMN-RECORD': '7022',
 'HTTP:STC:DL:XLS-DATA-INIT': '7023',
 'HTTP:STC:DL:XLS-DATA-RECORD': '7024',
 'HTTP:STC:DL:XLS-DBORPARAMQRY': '7025',
 'HTTP:STC:DL:XLS-DRAWING-REC': '7026',
 'HTTP:STC:DL:XLS-FEATHEADER': '7027',
 'HTTP:STC:DL:XLS-FILE-HNDL': '7028',
 'HTTP:STC:DL:XLS-FILE-IMPORT': '7029',
 'HTTP:STC:DL:XLS-FILTER-REC': '7030',
 'HTTP:STC:DL:XLS-FNGROUPNAME': '7031',
 'HTTP:STC:DL:XLS-FORMAT-ARRAY': '7032',
 'HTTP:STC:DL:XLS-FRTWRAPPER': '7033',
 'HTTP:STC:DL:XLS-HEAP-OF': '7034',
 'HTTP:STC:DL:XLS-HFPICT': '7035',
 'HTTP:STC:DL:XLS-HFPICTURE-REC': '7036',
 'HTTP:STC:DL:XLS-IMDATA': '7037',
 'HTTP:STC:DL:XLS-INDEX': '7038',
 'HTTP:STC:DL:XLS-INT-OR': '7039',
 'HTTP:STC:DL:XLS-INV-DRAW': '7040',
 'HTTP:STC:DL:XLS-LBL-RECORD': '7041',
 'HTTP:STC:DL:XLS-LINKED-LIST': '7042',
 'HTTP:STC:DL:XLS-MAL-RTD-REC': '7043',
 'HTTP:STC:DL:XLS-MBOF': '7044',
 'HTTP:STC:DL:XLS-MDSXET-REC': '7045',
 'HTTP:STC:DL:XLS-MDXTUPLE-BIFF': '7046',
 'HTTP:STC:DL:XLS-MS-OGRAPH': '7047',
 'HTTP:STC:DL:XLS-MSOFBTOPT': '7048',
 'HTTP:STC:DL:XLS-NAMED-GRAPH': '7049',
 'HTTP:STC:DL:XLS-NULL-PTR': '7050',
 'HTTP:STC:DL:XLS-OBJ-BIFF': '7051',
 'HTTP:STC:DL:XLS-OBJ-RECORD': '7052',
 'HTTP:STC:DL:XLS-OFFICE-DRAWING': '7053',
 'HTTP:STC:DL:XLS-PALETTE': '7054',
 'HTTP:STC:DL:XLS-PIVOT': '7055',
 'HTTP:STC:DL:XLS-PUB-REC': '7056',
 'HTTP:STC:DL:XLS-REPT': '7057',
 'HTTP:STC:DL:XLS-ROW': '7058',
 'HTTP:STC:DL:XLS-RTWINDOW': '7059',
 'HTTP:STC:DL:XLS-SCENARIO': '7060',
 'HTTP:STC:DL:XLS-SELECTION': '7061',
 'HTTP:STC:DL:XLS-SERIES': '7062',
 'HTTP:STC:DL:XLS-SET-FONT': '7063',
 'HTTP:STC:DL:XLS-SHEET-NAME': '7064',
 'HTTP:STC:DL:XLS-SHEET-OBJ': '7065',
 'HTTP:STC:DL:XLS-SHRFMLA': '7066',
 'HTTP:STC:DL:XLS-SLK-PICTURE': '7067',
 'HTTP:STC:DL:XLS-SST': '7068',
 'HTTP:STC:DL:XLS-STYLE-RECORD': '7069',
 'HTTP:STC:DL:XLS-SXDB': '7070',
 'HTTP:STC:DL:XLS-SXSTREAMID': '7071',
 'HTTP:STC:DL:XLS-SXVIEW': '7072',
 'HTTP:STC:DL:XLS-SXVIEW-REC': '7073',
 'HTTP:STC:DL:XLS-VBOBJ-RCE': '7074',
 'HTTP:STC:DL:XLS-VERSIONINFO': '7075',
 'HTTP:STC:DL:XLS-WOPT': '7076',
 'HTTP:STC:DL:XLS-WORKSPACE-DES': '7077',
 'HTTP:STC:DL:XLS-WORKSPACE-IDX': '7078',
 'HTTP:STC:DL:XLS-WRITEAV': '7079',
 'HTTP:STC:DL:XLS-XF-BIFF': '7080',
 'HTTP:STC:DL:XLS-XISPARENT': '7081',
 'HTTP:STC:DL:XLS-XML-ZIP': '7082',
 'HTTP:STC:DL:XLW-MEM-CORR': '7083',
 'HTTP:STC:DL:XORG-PCF-BO': '7084',
 'HTTP:STC:DL:ZIP-FILE': '7085',
 'HTTP:STC:DL:ZIP-FOR-MEDIA': '7086',
 'HTTP:STC:DLL-WEBDAV': '7087',
 'HTTP:STC:FAX-COVER-MC': '7088',
 'HTTP:STC:FILE-UTF7': '7089',
 'HTTP:STC:GOOGLE-APP-MAILTO': '7090',
 'HTTP:STC:HEADER-UTF7': '7091',
 'HTTP:STC:HEURISTIC-VD': '7092',
 'HTTP:STC:IBM-IIM-URI-EXEC': '7093',
 'HTTP:STC:IE-INDEX': '7094',
 'HTTP:STC:IE-STREAM-HDR': '7095',
 'HTTP:STC:IE:ANIMATEMOTION': '7096',
 'HTTP:STC:IE:ANIMATION-RCE': '7097',
 'HTTP:STC:IE:BOUNDELEMENTS': '7098',
 'HTTP:STC:IE:CELEMENT-RCE': '7099',
 'HTTP:STC:IE:CIR-REF': '7100',
 'HTTP:STC:IE:CLIP-MEM': '7101',
 'HTTP:STC:IE:CLONE-REF-CORRUPT': '7102',
 'HTTP:STC:IE:COL-TAG-CACHE': '7103',
 'HTTP:STC:IE:COMPRESSED-URL': '7104',
 'HTTP:STC:IE:CROSS-DOMAIN-INFO': '7105',
 'HTTP:STC:IE:CSRSS-HE-MSG': '7106',
 'HTTP:STC:IE:CSS-DISCLOSURE': '7107',
 'HTTP:STC:IE:CSS-HEAP': '7108',
 'HTTP:STC:IE:CSS-IMPORT': '7109',
 'HTTP:STC:IE:CSS-OF': '7110',
 'HTTP:STC:IE:CSS-PROPERTY-METHOD': '7111',
 'HTTP:STC:IE:CSS-XSS': '7112',
 'HTTP:STC:IE:DEL-OBJ-REF': '7113',
 'HTTP:STC:IE:DEL-TABLE': '7114',
 'HTTP:STC:IE:DEREF-OBJ-ACCESS': '7115',
 'HTTP:STC:IE:DESIGNMODE-INFO': '7116',
 'HTTP:STC:IE:DHTML-OBJ-CORRUPT': '7117',
 'HTTP:STC:IE:DHTML-OBJ-MC': '7118',
 'HTTP:STC:IE:DOCUMENT-RCE': '7119',
 'HTTP:STC:IE:DOM-CACHE-CORRUPT': '7120',
 'HTTP:STC:IE:DOM-OBJ-MC': '7121',
 'HTTP:STC:IE:EMBED-MC': '7122',
 'HTTP:STC:IE:EOT-WEBFONTS-DL': '7123',
 'HTTP:STC:IE:EOTF-LZCOMP-OF': '7124',
 'HTTP:STC:IE:ERROR-HANDLER': '7125',
 'HTTP:STC:IE:EVENT-HANDLER-INFO': '7126',
 'HTTP:STC:IE:EVENT-HANDLER-MC': '7127',
 'HTTP:STC:IE:EVENT-INVOKE': '7128',
 'HTTP:STC:IE:FREED-OBJECT': '7129',
 'HTTP:STC:IE:HIDE-DIALOG': '7130',
 'HTTP:STC:IE:HISTORY-GO-MC': '7131',
 'HTTP:STC:IE:HTML-LAYOUT': '7132',
 'HTTP:STC:IE:HTML-OBJ-MC': '7133',
 'HTTP:STC:IE:HTML-OBJECTS': '7134',
 'HTTP:STC:IE:HTML-RELOAD-CORRUPT': '7135',
 'HTTP:STC:IE:HTML-TAG-MC': '7136',
 'HTTP:STC:IE:HTML-TIME': '7137',
 'HTTP:STC:IE:IE-8-DOM-UN-MEM': '7138',
 'HTTP:STC:IE:IE-HEADER-XDOM-INFO': '7139',
 'HTTP:STC:IE:IE-PDF-REPLACE': '7140',
 'HTTP:STC:IE:IE-UNINIT-DOM': '7141',
 'HTTP:STC:IE:IESHIMS-DLL-HIJACK': '7142',
 'HTTP:STC:IE:IESTYLE-OBJ': '7143',
 'HTTP:STC:IE:IEXDOM-INFO': '7144',
 'HTTP:STC:IE:IFRAME-MEM-CORR': '7145',
 'HTTP:STC:IE:INCOMPLETE-EM': '7146',
 'HTTP:STC:IE:INV-CSSARR': '7147',
 'HTTP:STC:IE:JS-INFO-DISC': '7148',
 'HTTP:STC:IE:LAYOUT-GRID': '7149',
 'HTTP:STC:IE:LOCAL-CNT-INJ': '7150',
 'HTTP:STC:IE:MAL-JPEG': '7151',
 'HTTP:STC:IE:MAL-VB-JSCRIPT': '7152',
 'HTTP:STC:IE:MARKUP-POINTER-RCE': '7153',
 'HTTP:STC:IE:MARQUEE-STYLE': '7154',
 'HTTP:STC:IE:MERGE-ATTRIB': '7155',
 'HTTP:STC:IE:MHTML-INFO-DISC': '7156',
 'HTTP:STC:IE:MHTML-REDIR': '7157',
 'HTTP:STC:IE:MOUSE-MOVE-MEM': '7158',
 'HTTP:STC:IE:MS-TIME-DLL': '7159',
 'HTTP:STC:IE:MULTI-ACTION': '7160',
 'HTTP:STC:IE:NESTED-OBJECT-TAG': '7161',
 'HTTP:STC:IE:OBJ-MGMT-MC': '7162',
 'HTTP:STC:IE:OBJECT-MC': '7163',
 'HTTP:STC:IE:OBJECTS-MEMORY': '7164',
 'HTTP:STC:IE:ONLOAD-EVT-RCE': '7165',
 'HTTP:STC:IE:ONREADYSTATE': '7166',
 'HTTP:STC:IE:ONUNLOAD-MEM': '7167',
 'HTTP:STC:IE:OPTION-ELEMENT-RCE': '7168',
 'HTTP:STC:IE:OVERLAP-TAGS': '7169',
 'HTTP:STC:IE:PAGE-UPDATE-RACE': '7170',
 'HTTP:STC:IE:REDIRECT-MC': '7171',
 'HTTP:STC:IE:SCRIPT-STCK-EXH': '7172',
 'HTTP:STC:IE:SCROLL-EVENT-RCE': '7173',
 'HTTP:STC:IE:SELECT-ELEMENT': '7174',
 'HTTP:STC:IE:SELECT-ELEMENT-RCE': '7175',
 'HTTP:STC:IE:SELECT-EMPTY': '7176',
 'HTTP:STC:IE:SETEXP-REFCOUNT': '7177',
 'HTTP:STC:IE:STYLEOBJ-MEM': '7178',
 'HTTP:STC:IE:STYLESHEET-MC': '7179',
 'HTTP:STC:IE:SWAPNODE-MEM': '7180',
 'HTTP:STC:IE:TABLE-LAYOUT': '7181',
 'HTTP:STC:IE:TABLE-SPAN-CORRUPT': '7182',
 'HTTP:STC:IE:TABLES-MEMCORRUPT': '7183',
 'HTTP:STC:IE:TEXTRANGE-OBJ': '7184',
 'HTTP:STC:IE:TIME-ELEMENT': '7185',
 'HTTP:STC:IE:TOSTATIC-DISC': '7186',
 'HTTP:STC:IE:TOSTATIC-XSS': '7187',
 'HTTP:STC:IE:TOSTATICHTML': '7188',
 'HTTP:STC:IE:UNINIT-CORRUPT': '7189',
 'HTTP:STC:IE:UNINIT-LAYOUT': '7190',
 'HTTP:STC:IE:UNINIT-MEM-CORR': '7191',
 'HTTP:STC:IE:UNISCRIBE-MEM': '7192',
 'HTTP:STC:IE:URI-REDIRECTION': '7193',
 'HTTP:STC:IE:URL-FILE-BOF': '7194',
 'HTTP:STC:IE:USE-AFTER-FREE': '7195',
 'HTTP:STC:IE:USERDATA': '7196',
 'HTTP:STC:IE:VML-RCE': '7197',
 'HTTP:STC:IE:VML-VGX-BOF': '7198',
 'HTTP:STC:IE:WIN-ADO-EXEC': '7199',
 'HTTP:STC:IE:X-DOMAIN-INFO': '7200',
 'HTTP:STC:IE:XFRAME-REST-BYPASS': '7201',
 'HTTP:STC:IE:XML-ELEMENT-RCE': '7202',
 'HTTP:STC:IE:XML-HMAC-BYPASS': '7203',
 'HTTP:STC:IE:XML-MIME-CORRUPT': '7204',
 'HTTP:STC:IE:XSLT-MC': '7205',
 'HTTP:STC:IMG:BMP-HDR-IO': '7206',
 'HTTP:STC:IMG:CUPS-GIF-BO': '7207',
 'HTTP:STC:IMG:JAVA-GIF-MEM': '7208',
 'HTTP:STC:IMG:JDK-ICC': '7209',
 'HTTP:STC:IMG:JPEG:WIN-COLOR': '7210',
 'HTTP:STC:IMG:JPEGDECODERAW-FUNC': '7211',
 'HTTP:STC:IMG:KODAK-TIFF': '7212',
 'HTTP:STC:IMG:LIBPNG-ROWS': '7213',
 'HTTP:STC:IMG:MALFORMED-EMF-TAG': '7214',
 'HTTP:STC:IMG:MS-BMP-OF': '7215',
 'HTTP:STC:IMG:MS-GIFGDI-OF': '7216',
 'HTTP:STC:IMG:MS-OFFICE-GIF': '7217',
 'HTTP:STC:IMG:OFFICE-FLASHPIX': '7218',
 'HTTP:STC:IMG:OFFICE-FLASHPIX2': '7219',
 'HTTP:STC:IMG:OFFICE-MAL-TIF': '7220',
 'HTTP:STC:IMG:OFFICE-MAL-TIFF3': '7221',
 'HTTP:STC:IMG:PAINT-JPEG-OF': '7222',
 'HTTP:STC:IMG:PNG-IHDR-BAD-PAR': '7223',
 'HTTP:STC:IMG:PNG-IO': '7224',
 'HTTP:STC:IMG:PNG-NAME-ERROR': '7225',
 'HTTP:STC:IMG:PNG-PLTE-ERROR': '7226',
 'HTTP:STC:IMG:PNG-TEXT': '7227',
 'HTTP:STC:IMG:PNG-TRNS-ERROR': '7228',
 'HTTP:STC:IMG:PNG_CHUNK_OVERFLOW': '7229',
 'HTTP:STC:IMG:PNG_IHDR_INVAL_LEN': '7230',
 'HTTP:STC:IMG:TARGA-IMG-HEAP': '7231',
 'HTTP:STC:IMG:TFF-THUNDER': '7232',
 'HTTP:STC:IMG:TIFF-BOF': '7233',
 'HTTP:STC:IMG:WMF-SETPALETTE': '7234',
 'HTTP:STC:IMG:XP-MAL-TIFF': '7235',
 'HTTP:STC:ITUNES-HANDLER-OF': '7236',
 'HTTP:STC:JAVA:BEAST-WEBSOCKET': '7237',
 'HTTP:STC:JAVA:DOCBASE-BOF': '7238',
 'HTTP:STC:JAVA:GETSOUNDBANK-OF': '7239',
 'HTTP:STC:JAVA:GIF-MEMCORRUPT': '7240',
 'HTTP:STC:JAVA:JAR-PROCESS-OF': '7241',
 'HTTP:STC:JAVA:JAVADEPLOY-RCE': '7242',
 'HTTP:STC:JAVA:JPEGIMAGE-OF': '7243',
 'HTTP:STC:JAVA:PACK200-INT': '7244',
 'HTTP:STC:JAVA:SETDIFFICM-BOF': '7245',
 'HTTP:STC:JAVA:WINDOWS-TK': '7246',
 'HTTP:STC:LAYOUT-FRM-CONST': '7247',
 'HTTP:STC:LOTUS-CAI-URI': '7248',
 'HTTP:STC:M3U-VLC-SMB-LINK': '7249',
 'HTTP:STC:MCAFEE-FILE-NAME-OF': '7250',
 'HTTP:STC:MOZILLA:ARGUMENT-FUNC': '7251',
 'HTTP:STC:MOZILLA:ARRAY-DANGLE': '7252',
 'HTTP:STC:MOZILLA:CLEARTEXTRUN': '7253',
 'HTTP:STC:MOZILLA:CONSTRUCTFRAME': '7254',
 'HTTP:STC:MOZILLA:CSSVALUE-MEM': '7255',
 'HTTP:STC:MOZILLA:DEFINESETTER': '7256',
 'HTTP:STC:MOZILLA:DOCUMENT-WRITE': '7257',
 'HTTP:STC:MOZILLA:DOMNODEREMOVED': '7258',
 'HTTP:STC:MOZILLA:FF-INFO': '7259',
 'HTTP:STC:MOZILLA:FF-XSL-TRANS': '7260',
 'HTTP:STC:MOZILLA:FIREFOX-INPUT': '7261',
 'HTTP:STC:MOZILLA:FIREFOX-MC': '7262',
 'HTTP:STC:MOZILLA:FIREFOX-NSTREE': '7263',
 'HTTP:STC:MOZILLA:FIREFOX-RCE': '7264',
 'HTTP:STC:MOZILLA:FRAME-COMMENT': '7265',
 'HTTP:STC:MOZILLA:IFRAME-SRC': '7266',
 'HTTP:STC:MOZILLA:IFRAME-STYLE': '7267',
 'HTTP:STC:MOZILLA:JIT-ESCAPE-MC': '7268',
 'HTTP:STC:MOZILLA:MAL-REG-EX': '7269',
 'HTTP:STC:MOZILLA:MCHANNEL-UAF': '7270',
 'HTTP:STC:MOZILLA:MOZ-BINDING': '7271',
 'HTTP:STC:MOZILLA:MOZ-FLOAT-OF': '7272',
 'HTTP:STC:MOZILLA:MOZ-TAG-ORDER': '7273',
 'HTTP:STC:MOZILLA:NSCSSVALUE-OF': '7274',
 'HTTP:STC:MOZILLA:OFFSET-MEM-COR': '7275',
 'HTTP:STC:MOZILLA:OVERFLOW-EVENT': '7276',
 'HTTP:STC:MOZILLA:PARAM-OF': '7277',
 'HTTP:STC:MOZILLA:PKCS11-RCE': '7278',
 'HTTP:STC:MOZILLA:PROPTAB-MEM': '7279',
 'HTTP:STC:MOZILLA:REDUCE-RIGHT': '7280',
 'HTTP:STC:MOZILLA:STR-REPLACE': '7281',
 'HTTP:STC:MOZILLA:SVG-DATA': '7282',
 'HTTP:STC:MOZILLA:SVG-RCE': '7283',
 'HTTP:STC:MOZILLA:SVG-XML-INT-OF': '7284',
 'HTTP:STC:MOZILLA:XBL-TAG-RM': '7285',
 'HTTP:STC:MOZILLA:XUL-FRAMETREE': '7286',
 'HTTP:STC:MOZILLA:XUL-TREE': '7287',
 'HTTP:STC:MS-FOREFRONT-RCE': '7288',
 'HTTP:STC:OBJ-FILE-BASE64': '7289',
 'HTTP:STC:ON-BEFORE-UNLOAD': '7290',
 'HTTP:STC:OPERA:DOCUMENT-WRITE': '7291',
 'HTTP:STC:OPERA:OPERA-CONFIG': '7292',
 'HTTP:STC:ORBIT-DL-URL': '7293',
 'HTTP:STC:PAJAX-RCE': '7294',
 'HTTP:STC:PLS-WINAMP': '7295',
 'HTTP:STC:PPT-CRAFTED-PATH': '7296',
 'HTTP:STC:PPT-LONGNAME': '7297',
 'HTTP:STC:RHINO-HDR-OF': '7298',
 'HTTP:STC:SAFARI-IE-RCE': '7299',
 'HTTP:STC:SAFARI:CHARSET-XFORM': '7300',
 'HTTP:STC:SAFARI:CHILD-REMOVAL': '7301',
 'HTTP:STC:SAFARI:CONT-EDITABLE': '7302',
 'HTTP:STC:SAFARI:CSS-FORMAT-HINT': '7303',
 'HTTP:STC:SAFARI:FLOAT-BOF': '7304',
 'HTTP:STC:SAFARI:FLOAT-TYPE-RCE': '7305',
 'HTTP:STC:SAFARI:IMG-USE-FREE': '7306',
 'HTTP:STC:SAFARI:INNERHTML-MC': '7307',
 'HTTP:STC:SAFARI:PARENT-CLOSE': '7308',
 'HTTP:STC:SAFARI:RTL-USE-FREE': '7309',
 'HTTP:STC:SAFARI:WEBKIT-1ST-LTR': '7310',
 'HTTP:STC:SAFARI:WEBKIT-AFREE': '7311',
 'HTTP:STC:SAFARI:WEBKIT-FREE-CE': '7312',
 'HTTP:STC:SAFARI:WEBKIT-MENU-MEM': '7313',
 'HTTP:STC:SAFARI:WEBKIT-RANGEOBJ': '7314',
 'HTTP:STC:SAFARI:WEBKIT-RENDER': '7315',
 'HTTP:STC:SAFARI:WEBKIT-SVG-MARK': '7316',
 'HTTP:STC:SAFARI:WEBKIT-SVG-MC': '7317',
 'HTTP:STC:SCRIPT:HTML-SCRIPT': '7318',
 'HTTP:STC:SCRIPT:JAVA-EVASION': '7319',
 'HTTP:STC:SCRIPT:MSF-ABOUT': '7320',
 'HTTP:STC:SCRIPT:REPLACE-OBSF': '7321',
 'HTTP:STC:SHAREPOINT-XSS': '7322',
 'HTTP:STC:SILVERLIGHT-MEM-CORR': '7323',
 'HTTP:STC:SILVERLIGHT-RCE': '7324',
 'HTTP:STC:SSL:MD5-SIGNATURE': '7325',
 'HTTP:STC:STREAM:ASF-BOF': '7326',
 'HTTP:STC:STREAM:ASF-WMP': '7327',
 'HTTP:STC:STREAM:CINEPAK-RCE': '7328',
 'HTTP:STC:STREAM:DIRECTSHOW-MJPG': '7329',
 'HTTP:STC:STREAM:DIRECTSHOW-MP3': '7330',
 'HTTP:STC:STREAM:DIRECTX-MJPEG': '7331',
 'HTTP:STC:STREAM:DIRSHOW-MJPEG': '7332',
 'HTTP:STC:STREAM:FFDSHOW-URL-OF': '7333',
 'HTTP:STC:STREAM:FLASH-MEMORY': '7334',
 'HTTP:STC:STREAM:MAL-AVI-RIFF': '7335',
 'HTTP:STC:STREAM:QT-DESC-ATOM': '7336',
 'HTTP:STC:STREAM:QT-FF': '7337',
 'HTTP:STC:STREAM:QT-FLASHPIX-OF': '7338',
 'HTTP:STC:STREAM:QT-HREFTRACK': '7339',
 'HTTP:STC:STREAM:QT-IT-MEM': '7340',
 'HTTP:STC:STREAM:QT-M3U': '7341',
 'HTTP:STC:STREAM:QT-MAL-SMIL': '7342',
 'HTTP:STC:STREAM:QT-MOV-FILE-BOF': '7343',
 'HTTP:STC:STREAM:QT-MOV-IO': '7344',
 'HTTP:STC:STREAM:QT-RESPONSE-BO': '7345',
 'HTTP:STC:STREAM:REAL-AVI': '7346',
 'HTTP:STC:STREAM:REALAUDIO-OF': '7347',
 'HTTP:STC:STREAM:REALMEDIA-PROC': '7348',
 'HTTP:STC:STREAM:REALPLAYER-MP3': '7349',
 'HTTP:STC:STREAM:REALPLAYER-QCP': '7350',
 'HTTP:STC:STREAM:VLC-REALINDEX': '7351',
 'HTTP:STC:STREAM:WINAMP-META-OF': '7352',
 'HTTP:STC:SUSPICIOUS-JS-FUNC': '7353',
 'HTTP:STC:SWF:MAL-PAMM-CHUNK': '7354',
 'HTTP:STC:SWF:REAL-FLV': '7355',
 'HTTP:STC:SWF:SWAVE-TSAC-CHUNK': '7356',
 'HTTP:STC:VULN:OUTLOOK-XSRF': '7357',
 'HTTP:STC:WEBEX-WRF-BOF': '7358',
 'HTTP:STC:WHSC-RCE': '7359',
 'HTTP:STC:WIN-CCL-BOF': '7360',
 'HTTP:STC:WIN-SHELLHNDL': '7361',
 'HTTP:STC:WINAMP:MAKI-SCRIPT-OF': '7362',
 'HTTP:STC:WINAMP:MIDI-TIMESTAMP': '7363',
 'HTTP:STC:WINAMP:ULTRAVOX-MSG': '7364',
 'HTTP:STC:WINDOWS-FAX-COVER': '7365',
 'HTTP:STC:WINHELP32-MSGBOX-RCE': '7366',
 'HTTP:STREAM:AAJTAK-STREAM': '7367',
 'HTTP:STREAM:FLV': '7368',
 'HTTP:STREAM:STARTV-STREAM': '7369',
 'HTTP:STREAM:VIDEO-CONTENT': '7370',
 'HTTP:SUN-DIGEST-OF': '7371',
 'HTTP:SUN-JAVA-SYSTEM-WEBDAV-OF': '7372',
 'HTTP:SUN-WEBDAV-FD': '7373',
 'HTTP:SYBASE-AGSOAP-EXE-BOF': '7374',
 'HTTP:TOMCAT:AJP12-SHUTDOWN': '7375',
 'HTTP:TOMCAT:AWSTATS-CFG-EXEC': '7376',
 'HTTP:TOMCAT:DIR-LIST-DISCL': '7377',
 'HTTP:TOMCAT:POLICY-BYPASS': '7378',
 'HTTP:TOO-MANY-PARAMETERS': '7379',
 'HTTP:TRENDMICRO-FMT-STR': '7380',
 'HTTP:TRENDMICRO-SEC-BYPASS': '7381',
 'HTTP:TUNNEL:ANCHORFREE-CLIENT': '7382',
 'HTTP:UA:CURL': '7383',
 'HTTP:UA:SKIPFISH': '7384',
 'HTTP:UA:WGET': '7385',
 'HTTP:WEBDAV-FS': '7386',
 'HTTP:WEBLOGIC:BEA-CONN-BOF': '7387',
 'HTTP:WEBSRV-BO-4096': '7388',
 'HTTP:XSS:ANWIKI-XSS': '7389',
 'HTTP:XSS:APACHE-MOD-NEGOTIATION': '7390',
 'HTTP:XSS:CISCO-CSDC': '7391',
 'HTTP:XSS:CISCOWORKS-CSFHS': '7392',
 'HTTP:XSS:CISCOWORKS-CSFHS-1': '7393',
 'HTTP:XSS:DRUPAL-CUMULAS': '7394',
 'HTTP:XSS:E2-PHOTO-GALLERY': '7395',
 'HTTP:XSS:FOREFRONT-SIGNURL': '7396',
 'HTTP:XSS:HP-SEARCH-XSS': '7397',
 'HTTP:XSS:HTML-SCRIPT-IN-COOKIE': '7398',
 'HTTP:XSS:HTML-SCRIPT-IN-POST': '7399',
 'HTTP:XSS:IBM-OPEN-ADMIN': '7400',
 'HTTP:XSS:INMAGIC-DBTWPUB': '7401',
 'HTTP:XSS:JOOMLA-CITY': '7402',
 'HTTP:XSS:JOOMLA-COM-RESMAN': '7403',
 'HTTP:XSS:LDAP-ACCOUNT-MGR': '7404',
 'HTTP:XSS:MC-CONTENT-MANAGER': '7405',
 'HTTP:XSS:MS-CS': '7406',
 'HTTP:XSS:MS-FOREFRONT-DEFAULT': '7407',
 'HTTP:XSS:MS-FOREFRONT-EXCEL-TBL': '7408',
 'HTTP:XSS:MS-FOREFRONT-INFO-DISC': '7409',
 'HTTP:XSS:MS-IE-TOSTATICHTML': '7410',
 'HTTP:XSS:MUL-RECORDPRESS': '7411',
 'HTTP:XSS:ORACLE-GLASSFISH': '7412',
 'HTTP:XSS:PACER-EDITION-EMAIL': '7413',
 'HTTP:XSS:PHPWEBSITE-PAGE-ID': '7414',
 'HTTP:XSS:ROBOHELP-XSS': '7415',
 'HTTP:XSS:SHAREPOINT-EDITFORM': '7416',
 'HTTP:XSS:SYM-IM-MANAGER': '7417',
 'HTTP:XSS:SYNDEO-CMS-ADDONS': '7418',
 'HTTP:XSS:TM-REQUEST-FORGERY': '7419',
 'HTTP:XSS:VBULLETIN-SORT': '7420',
 'HTTP:XSS:VBULLETIN-SORTORDER': '7421',
 'HTTP:XSS:WP-AJAX-CALENDAR': '7422',
 'HTTP:XSS:WP-AJAX-CATEGORY': '7423',
 'HTTP:XSS:WP-AJAX-RECENT-POSTS': '7424',
 'HTTP:XSS:WP-COMICPRESS': '7425',
 'HTTP:XSS:WP-DAILY-MAUI-PHOTO': '7426',
 'HTTP:XSS:WP-ESHOP': '7427',
 'HTTP:XSS:WP-GAZETTE-THEME': '7428',
 'HTTP:XSS:WP-IGIT-POSTS': '7429',
 'HTTP:XSS:WP-INLINE-GALLERY': '7430',
 'HTTP:XSS:WP-LAZYEST-GALLERY': '7431',
 'HTTP:XSS:WP-LIVE-WIRE-THEME': '7432',
 'HTTP:XSS:WP-LOCAL-MARKET-EXP': '7433',
 'HTTP:XSS:WP-PHOTO-ALBUM': '7434',
 'HTTP:XSS:WP-PHOTORACER': '7435',
 'HTTP:XSS:WP-PHOTOSMASH-GAL': '7436',
 'HTTP:XSS:WP-PLACESTER': '7437',
 'HTTP:XSS:WP-RATING-WIDGET': '7438',
 'HTTP:XSS:WP-SERMON-BROWSER': '7439',
 'HTTP:XSS:WP-SOCIALGRID': '7440',
 'HTTP:XSS:WP-STATS-DASHBOARD': '7441',
 'HTTP:XSS:WP-UNIVERSAL-POST': '7442',
 'HTTP:XSS:WP-WOOTHEMES': '7443',
 'HTTP:XSS:WP-YT-AUDIO': '7444',
 'HTTP:XSS:WP-ZOTPRESS': '7445',
 'HTTP:XSS:X-FORWARDED-FOR-INJ': '7446',
 'HTTP:XSS:XOOPS-MULT': '7447',
 'HTTP:XSS:XOOPS-VIEW-PHOTOS-PHP': '7448',
 'HTTP:XSS:ZEN-CART': '7449',
 'HTTP:YOUNGZSOFT-CONNECT': '7450',
 'ICMP:INFO:ECHO-REPLY': '7451',
 'IDENT:TINYIDENT-OF': '7452',
 'IKE:MALFORMED:INV-PAYLOAD-TYPE': '7453',
 'IMAP:IPSWITCH:DELETE-OF': '7454',
 'IMAP:IPSWITCH:SEARCH-DATE': '7455',
 'IMAP:OVERFLOW:DOMINO-IMAP': '7456',
 'IMAP:OVERFLOW:IMAP-LSUB-OF': '7457',
 'IMAP:OVERFLOW:LITERAL-TOKEN': '7458',
 'IMAP:OVERFLOW:MAILENABLE-APPEND': '7459',
 'IMAP:OVERFLOW:MDAEMON-MD5': '7460',
 'IMAP:OVERFLOW:MERCUR-NTLMSSP': '7461',
 'IMAP:OVERFLOW:MERCURY-LOGIN': '7462',
 'LDAP:AD-CONVERT-ATT': '7463',
 'LDAP:AD-LDAP-DOS': '7464',
 'LDAP:BER-DOS': '7465',
 'LDAP:CONTROLS-MISMATCH': '7466',
 'LDAP:EDIRECTORY-DOS': '7467',
 'LDAP:FORMAT:DN_FMTERR': '7468',
 'LDAP:FORMAT:ENC_INCORRECT_TAG': '7469',
 'LDAP:IMAIL-BOF': '7470',
 'LDAP:INVALID:MODRDN-NULL-RDN': '7471',
 'LDAP:LOTUS-DN': '7472',
 'LDAP:LSASS-HEAP-OF': '7473',
 'LDAP:ORACLE-PREAUTH-DOS': '7474',
 'LDAP:OVERFLOW:IMAIL-ASN1': '7475',
 'LDAP:OVERFLOW:MODRDN-UTF8-EXEC': '7476',
 'LDAP:RECURSIVE-DOS': '7477',
 'LDAP:TIVOLI-OF': '7478',
 'LPD:HUMMINGBIRD': '7479',
 'LPD:MSF-CASCADE': '7480',
 'LPR:HP-UX-CMD': '7481',
 'MISC:HTRAN-PROXY-CONNECT-FAILED': '7482',
 'MISC:LLMNR-REVERSE-LOOKUP': '7483',
 'MISC:PDF:INTEGER-OVERFLOW': '7484',
 'MISC:WINS-BOF': '7485',
 'MISC:WINS-COMMENDLG': '7486',
 'MS-RPC:BROADWIN-BOF': '7487',
 'MS-RPC:EVASION:BLIND-BIND-ACK-2': '7488',
 'MS-RPC:EVASION:BLIND-BIND-ACK2': '7489',
 'MS-RPC:EVASION:BUFFERED-REQ': '7490',
 'MS-RPC:EVASION:BUFFERED-REQUEST': '7491',
 'MS-RPC:EVASION:DCE-LARGE-FRAG-2': '7492',
 'MS-RPC:EVASION:DCERPC-SMALL-REQ': '7493',
 'MS-RPC:EVASION:FRAG2-SMALL': '7494',
 'MS-RPC:EVASION:LARGE-FRAG-1': '7495',
 'MS-RPC:EVASION:LARGE-FRAG-2': '7496',
 'MS-RPC:EVASION:MULTI-HEADER-1': '7497',
 'MS-RPC:EVASION:SMALL-FRAG': '7498',
 'MS-RPC:EVASION:SMALL-REQ-FRAG': '7499',
 'MS-RPC:INV:DCOM-SVC': '7500',
 'MS-RPC:INV:DNS-SVC': '7501',
 'MS-RPC:INV:LLSSRV-SVC': '7502',
 'MS-RPC:INV:MQ-SVC': '7503',
 'MS-RPC:INV:NETDDE-SVC': '7504',
 'MS-RPC:INV:NETWARE-SVC': '7505',
 'MS-RPC:INV:PNP-SVC': '7506',
 'MS-RPC:INV:REQUEST-FROM-SERVER': '7507',
 'MS-RPC:INV:RESPONSE-FROM-CLIENT': '7508',
 'MS-RPC:INV:RRAS-SVC': '7509',
 'MS-RPC:INV:SPOOLSS-SVC': '7510',
 'MS-RPC:INV:SRV-SVC': '7511',
 'MS-RPC:INV:WKSTA-SVC': '7512',
 'MS-RPC:LLSSRV-RCE': '7513',
 'MS-RPC:LSASS:LSA-DOS-CHALLENGE': '7514',
 'MS-RPC:LSASS:NETWARE-CIFS-OF': '7515',
 'MS-RPC:NETRLOGONGETDMNINF-NULL': '7516',
 'MS-RPC:NTLM-RPCSS-DOS': '7517',
 'MS-RPC:OF:LOC-SVC-1': '7518',
 'MS-RPC:OF:LOC-SVC-2': '7519',
 'MS-RPC:OF:MESSENGER-1': '7520',
 'MS-RPC:OF:MQSVC': '7521',
 'MS-RPC:OF:MS-DNS-RPC': '7522',
 'MS-RPC:OF:MSDTC': '7523',
 'MS-RPC:OF:MSG-QUEUE-1': '7524',
 'MS-RPC:OF:MSG-QUEUE-2': '7525',
 'MS-RPC:OF:MSG-QUEUE-3': '7526',
 'MS-RPC:OF:NETDDE-SHARE': '7527',
 'MS-RPC:OF:NWSPOOL-OF': '7528',
 'MS-RPC:OF:RRAS': '7529',
 'MS-RPC:OF:SPOOLSS-1': '7530',
 'MS-RPC:OF:SPOOLSS-3': '7531',
 'MS-RPC:OF:SRV-SVC-1': '7532',
 'MS-RPC:OF:SRV-SVC-2': '7533',
 'MS-RPC:OF:WEBCLIENT': '7534',
 'MS-RPC:OF:WKST-SVC': '7535',
 'MS-RPC:OF:WKST-SVC-PIPE': '7536',
 'NETBIOS:NBDS:BE-SERVERNAME-OF': '7537',
 'NETBIOS:NBDS:MS-BROWSER-ELECT': '7538',
 'NETBIOS:OVERFLOW:LENGTH-OF': '7539',
 'NFS:CAP-MKNOD': '7540',
 'NTP:MODE7-DOS': '7541',
 'NTP:MUL-NTP-DAEMON-AUTOKEY-BOF': '7542',
 'NTP:NTP-READVAR': '7543',
 'OS:LINUXX86:SCTP-CHUNKLESS': '7544',
 'P2P:ARES:UDP-PEER-CHECK': '7545',
 'P2P:BEARSHARE:DJ-SERVICE': '7546',
 'P2P:BEARSHARE:LOGIN': '7547',
 'P2P:BITTORRENT:BITCOMET-CHUNK': '7548',
 'P2P:BITTORRENT:BT-ENCRYPTED': '7549',
 'P2P:BITTORRENT:BT-SEARCH': '7550',
 'P2P:BITTORRENT:DHT4': '7551',
 'P2P:BITTORRENT:HANDSHAKE-UDP': '7552',
 'P2P:BITTORRENT:KICKASSTORRENTS': '7553',
 'P2P:BITTORRENT:TRACKER-UDP': '7554',
 'P2P:EMULE:VERYCD': '7555',
 'P2P:GNUTELLA:FILE-XCH-TCP': '7556',
 'P2P:MISC:IMESH': '7557',
 'P2P:MISC:PPLIVE-HTTP-CLIENT-REQ': '7558',
 'P2P:MISC:PPLIVE-TRACKER-OFF-REQ': '7559',
 'P2P:NAPSTER:USER-LOGIN-7777': '7560',
 'P2P:NAPSTER:USER-LOGIN-8888': '7561',
 'P2P:UNIFS': '7562',
 'P2P:VUZE:BIN-DHT': '7563',
 'P2P:VUZE:HTTP-CLIENT-MODE': '7564',
 'P2P:VUZE:HTTP-RPC-ACTIVITY': '7565',
 'P2P:VUZE:TIVO-DISCO-BEACON': '7566',
 'P2P:VUZE:USER-AGENT': '7567',
 'P2P:XUNLEI:OVER-HTTP': '7568',
 'P2P:XUNLEI:QUERY': '7569',
 'P2P:XUNLEI:STARTUP': '7570',
 'POP3:AUDIT:ILLEGAL-FILENAME': '7571',
 'POP3:OUTLOOK:CRAFTED-RESP': '7572',
 'POP3:OVERFLOW:ERR-RPLY-OF': '7573',
 'POP3:OVERFLOW:HTTP-LINK-OF': '7574',
 'POP3:POP-SCRIPT-TAG': '7575',
 'RPC:CALL-IT-OF': '7576',
 'RPC:EMC-LEGATO-NW-OF': '7577',
 'RPC:KADMIND-KLOG': '7578',
 'RPC:KADMIND-RENAME': '7579',
 'RPC:PCNFSD-FS': '7580',
 'RPC:SOL-CDE-CALENDAR-MGR': '7581',
 'RPC:SUN-SOLARIS-SADMIND-BO': '7582',
 'RPC:WDB-AGENT': '7583',
 'RPC:YPUPDATED-CMD-INJ': '7584',
 'RSH:OVERFLOW:WINRSHD-OF': '7585',
 'RTSP:DESCRIBE-BOF': '7586',
 'RTSP:MAL-RTSP': '7587',
 'RTSP:MS-MEDIA-PLAYER-MC': '7588',
 'RTSP:OVERFLOW:DESCRIBE-OF': '7589',
 'RTSP:OVERFLOW:RTSP-CONTENT': '7590',
 'RTSP:SET-PARAMETER': '7591',
 'RTSP:SETUP-HDR': '7592',
 'SCADA:7T-INTERACTIVE-DC-OF': '7593',
 'SCADA:7T-INTERACTIVE-IGSS-OF': '7594',
 'SCADA:DATAC-REALWIN-MULT-BOF': '7595',
 'SCADA:DATAC-REALWIN-OF': '7596',
 'SCADA:DNP3:COLD-RESTART': '7597',
 'SCADA:MODBUS:BAD-PROTO-ID': '7598',
 'SCADA:MODBUS:INPUT-INT-OF': '7599',
 'SCADA:MODBUS:INVALID-UNI-ID': '7600',
 'SCADA:MODBUS:NOT-MODBUS': '7601',
 'SCADA:MODBUS:OPC-SVR-HEAP-CORR': '7602',
 'SCADA:MODBUS:OVERLONG-PDU': '7603',
 'SCADA:MODBUS:SHORT-PDU': '7604',
 'SCADA:MODBUS:TRAILING-DATA': '7605',
 'SCADA:MODBUS:UNDERFLOW': '7606',
 'SCADA:SCADATEC-MODBUS-BO': '7607',
 'SCADA:WINLOG-TCP-OF': '7608',
 'SCAN:AMAP:AMAP-USER': '7609',
 'SCAN:AMAP:SSL-SCAN': '7610',
 'SCAN:W3AF': '7611',
 'SCREENOS:CONNECT_CMS_PORT': '7612',
 'SCREENOS:CONNECT_SME_PORT': '7613',
 'SCREENOS:DENY_POLICY': '7614',
 'SCREENOS:IDS_COMPONENT': '7615',
 'SCREENOS:IDS_ICMP_ADDR_MSK_REP': '7616',
 'SCREENOS:IDS_ICMP_ADDR_MSK_REQ': '7617',
 'SCREENOS:IDS_ICMP_ECHO_REPLY': '7618',
 'SCREENOS:IDS_ICMP_ECHO_REQUEST': '7619',
 'SCREENOS:IDS_ICMP_FRAGMENT': '7620',
 'SCREENOS:IDS_ICMP_HOST_UNREACH': '7621',
 'SCREENOS:IDS_ICMP_INFO_REPLY': '7622',
 'SCREENOS:IDS_ICMP_INFO_REQUEST': '7623',
 'SCREENOS:IDS_ICMP_PARA_PROB': '7624',
 'SCREENOS:IDS_ICMP_REDIRECT': '7625',
 'SCREENOS:IDS_ICMP_SRC_QUENCH': '7626',
 'SCREENOS:IDS_ICMP_TIME_EXCEED': '7627',
 'SCREENOS:IDS_ICMP_TS_REPLY': '7628',
 'SCREENOS:IDS_ICMP_TS_REQUEST': '7629',
 'SCREENOS:IDS_IP_BLOCK_FRAG': '7630',
 'SCREENOS:IDS_IP_OPT_LSR': '7631',
 'SCREENOS:IDS_IP_OPT_RECORD': '7632',
 'SCREENOS:IDS_IP_OPT_SCHT': '7633',
 'SCREENOS:IDS_IP_OPT_SSR': '7634',
 'SCREENOS:IDS_IP_OPT_STREAM': '7635',
 'SCREENOS:IDS_IP_OPT_TIMESTAMP': '7636',
 'SCREENOS:IDS_IP_UNKNOWN_PROT': '7637',
 'SCREENOS:IDS_SYN_FRAG': '7638',
 'SCREENOS:IDS_TCP_FIN_NO_ACK': '7639',
 'SCREENOS:IDS_TCP_NO_FLAG': '7640',
 'SCREENOS:IP_SOURCE_ROUTE': '7641',
 'SCREENOS:MULTI_AUTH_FAIL': '7642',
 'SCREENOS:UDP_FLOOD': '7643',
 'SHELLCODE:ACTIVE:BIND-1-HTTP': '7644',
 'SHELLCODE:ACTIVE:BIND-1-SMB': '7645',
 'SHELLCODE:ACTIVE:BIND-1-TCP': '7646',
 'SHELLCODE:ACTIVE:BIND-1-UDP': '7647',
 'SHELLCODE:ACTIVE:DECODER-1-80': '7648',
 'SHELLCODE:ACTIVE:DECODER-1-TCP': '7649',
 'SHELLCODE:ACTIVE:DECODER-1-UDP': '7650',
 'SHELLCODE:ACTIVE:DECODER-2-80': '7651',
 'SHELLCODE:ACTIVE:DECODER-2-TCP': '7652',
 'SHELLCODE:ACTIVE:DECODER-2-UDP': '7653',
 'SHELLCODE:ACTIVE:DECODER-3-80': '7654',
 'SHELLCODE:ACTIVE:DECODER-3-TCP': '7655',
 'SHELLCODE:ACTIVE:DECODER-3-UDP': '7656',
 'SHELLCODE:ACTIVE:JS-ESCAPE': '7657',
 'SHELLCODE:ACTIVE:REVERSE-1-80': '7658',
 'SHELLCODE:ACTIVE:REVERSE-1-SMB': '7659',
 'SHELLCODE:ACTIVE:REVERSE-1-TCP': '7660',
 'SHELLCODE:ACTIVE:REVERSE-1-UDP': '7661',
 'SHELLCODE:METASPLOIT:DECODE-X86': '7662',
 'SHELLCODE:METASPLOIT:FNSTENV': '7663',
 'SHELLCODE:METASPLOIT:FNSTENV-80': '7664',
 'SHELLCODE:METASPLOIT:FTENV-SMB': '7665',
 'SMB:AUDIT:INVALID-DATACOUNT': '7666',
 'SMB:CLIENT-MESSAGE-OF': '7667',
 'SMB:CLIENT-POOL-CORR': '7668',
 'SMB:DOUBLE-NEGO-RESP': '7669',
 'SMB:DUPLICATE-SESSION': '7670',
 'SMB:ERROR:MULTI-HEADERS': '7671',
 'SMB:EXPLOIT:MPLAYER-SAMI': '7672',
 'SMB:EXPLOIT:PRINT-SPOOL-BYPASS': '7673',
 'SMB:EXPLOIT:SMB-MULTI-DOS': '7674',
 'SMB:EXPLOIT:SMB1-CHAINING-MC': '7675',
 'SMB:EXPLOIT:SMB2-ZERO-LEN-WRT': '7676',
 'SMB:EXPLOIT:TRANS2-MDL-CHUNK': '7677',
 'SMB:FILE:DLL-TRANSFER': '7678',
 'SMB:INFO:NULL-GSS-TOKEN': '7679',
 'SMB:MS-RENAME-CMD-CE': '7680',
 'SMB:MS-TELNET-INSECURE-LOADING': '7681',
 'SMB:NTLM-LOW-ENTROPY': '7682',
 'SMB:OF:ACCOUNT-NAME-OVERFLOW': '7683',
 'SMB:OF:CREATE-NEG-EOF': '7684',
 'SMB:OF:DFS-RESP': '7685',
 'SMB:OF:DIALECT-INDEX-OF': '7686',
 'SMB:OF:MS-SMB2-RES-DOS': '7687',
 'SMB:OF:PNP-OF-2': '7688',
 'SMB:OF:SMB2-DOS-2': '7689',
 'SMB:OF:SMB2-WRITE-OFFSET': '7690',
 'SMB:OLEAUT32-WMF': '7691',
 'SMB:ORACLE-JRE-INSECURE-LOAD': '7692',
 'SMB:REFLECTION': '7693',
 'SMB:SAMBA-UNICODE-FLAGS2-DOS': '7694',
 'SMB:SAMBA:DFSENUM-OF': '7695',
 'SMB:SAMBA:LSALOOKUPSIDS': '7696',
 'SMB:SAMBA:NETDFS-OF': '7697',
 'SMB:SAMBA:NTRANS-RPLY': '7698',
 'SMB:SAMBA:ROOT-SYS': '7699',
 'SMB:SAMBA:SID-QUOTA': '7700',
 'SMB:SAMBA:SPOOLSS-NOTIFY': '7701',
 'SMB:SAMBA:SWAT-AUTH-DOS': '7702',
 'SMB:SMB-COPY-OF': '7703',
 'SMB:SMB-SRV-NAME-DOS': '7704',
 'SMB:TIMBUKTU-PLUGHNT-COMMAND': '7705',
 'SMB:TRANSACTION-RESPONSE-OF': '7706',
 'SMB:USER-CMD-INJ': '7707',
 'SMB:VISIO-MFC71XXX-DLL-HIJACK': '7708',
 'SMB:WINS-SNAME-REG': '7709',
 'SMTP:AUDIT:REQ-HDR-FLD-UNKNOWN': '7710',
 'SMTP:AUDIT:REQ-UNKNOWN-CMD': '7711',
 'SMTP:COMMAND:AV-INETSERV-DOS': '7712',
 'SMTP:COMMAND:STARTTLS-CMD': '7713',
 'SMTP:DOS:CLAM-TNEF-DOS': '7714',
 'SMTP:EMAIL:RELAY-ADDR-OF': '7715',
 'SMTP:EMAIL:WPD-LOTUS': '7716',
 'SMTP:EXCHANGE:EXCH-TNEF-BO': '7717',
 'SMTP:EXCHANGE:INVLD_XEXCH50_CMD': '7718',
 'SMTP:EXCHANGE:MIME-MALF-ATTACH': '7719',
 'SMTP:EXPLOIT:BITDEF-LOG': '7720',
 'SMTP:EXPLOIT:EMAIL-ADDR-FS': '7721',
 'SMTP:EXPLOIT:GNUPG-INT-OF': '7722',
 'SMTP:EXPLOIT:POSTFIX-AUTH-REUSE': '7723',
 'SMTP:EXT:DOUBLE-EXTENSION-MIME': '7724',
 'SMTP:FROM-FIELD-FS': '7725',
 'SMTP:HTML-VAL-XSS': '7726',
 'SMTP:IIS:SSL-PCT-OF': '7727',
 'SMTP:IPSWITCH-REPLY-TO-OF': '7728',
 'SMTP:MAL:EXIM4-HEADER': '7729',
 'SMTP:MAL:IBM-ATTACHMENT-VIEWER': '7730',
 'SMTP:MAL:LOTUS-APPLIX': '7731',
 'SMTP:MAL:LOTUS-DOC-VIEWER': '7732',
 'SMTP:MAL:LOTUS-LZH-BOF': '7733',
 'SMTP:MAL:LOTUS-MAILTO': '7734',
 'SMTP:MAL:LOTUS-MIF-VIEWER': '7735',
 'SMTP:MAL:LOTUS-VIEWER': '7736',
 'SMTP:MAL:LOTUS-WPD': '7737',
 'SMTP:MERCMAIL-AUTH-OF': '7738',
 'SMTP:OUTLOOK:RTF-PARSE': '7739',
 'SMTP:OUTLOOK:VEVENT-MEMCORRUPT': '7740',
 'SMTP:OVERFLOW:MAILENABLE-BO': '7741',
 'SMTP:OVERFLOW:NTLM-AUTH-OF': '7742',
 'SMTP:OVERFLOW:TABS-EHLO-OF': '7743',
 'SMTP:RCPT-CMD-INJ': '7744',
 'SMTP:REALPLAYER-WAV-BO': '7745',
 'SMTP:RESPONSE:BAD-RESPONSE': '7746',
 'SMTP:SPAMASS-DOS-2': '7747',
 'SMTP:SPAMASSASS-LM-DOS': '7748',
 'SMTP:SYM-NESTED-ZIP': '7749',
 'SMTP:VULN:GROUPWISE-IMG-OF': '7750',
 'SNMP:HMAC-AUTH-BYPASS-EXPLOIT': '7751',
 'SSH:AUDIT:SSH-V1': '7752',
 'SSH:NON-STD-PORT': '7753',
 'SSH:OPENSSH:BLOCK-DOS': '7754',
 'SSL:AUDIT:CERT-BIT-LT-2048': '7755',
 'SSL:AUDIT:KEY-RENEGOTIATION': '7756',
 'SSL:AUDIT:NOT-SSL': '7757',
 'SSL:AUDIT:SESSION-KEY-REUSE': '7758',
 'SSL:DIGINOTAR-CERT-KEY-NEGO': '7759',
 'SSL:IIS:CERT-DOS': '7760',
 'SSL:INVALID:CERT-CHAIN': '7761',
 'SSL:INVALID:SSL-INV-VER': '7762',
 'SSL:MSG-IN-WRONG-DIR': '7763',
 'SSL:OPENSSL-REC-HANDLING-DOS': '7764',
 'SSL:OVERFLOW:BEA-PLUGINS-CERT': '7765',
 'SSL:OVERFLOW:CIPHERS-OBO': '7766',
 'SSL:OVERFLOW:CIPHERS-OF': '7767',
 'SSL:SERVR-CERT-FAILS-VALIDATION': '7768',
 'SSL:SESSION-KEY-REUSE-UNAVAIL': '7769',
 'SSL:THC-SSL-DOS': '7770',
 'SSL:UTN-USERFIRST-HARDWARE': '7771',
 'SSL:VULN:MOZILLA-NSS-REG': '7772',
 'TCP:ERROR:FLOW-MEMORY-EXCEEDED': '7773',
 'TELNET:OVERFLOW:CCPROXY-HOST-OF': '7774',
 'TELNET:OVERFLOW:LOGIN-OF': '7775',
 'TELNET:OVERFLOW:PROCYON': '7776',
 'TFTP:FS-FILE': '7777',
 'TFTP:OPERATION:FS-TFTP-OF': '7778',
 'TFTP:OVERFLOW:MODE-TOO-LONG': '7779',
 'TFTP:SERVER-ERROR-BO': '7780',
 'TFTP:TRANSPORT-BOF': '7781',
 'TROJAN:BACKDOOR-LEOUNCIA': '7782',
 'TROJAN:BACKDOOR:PERL-SHELLBOT-S': '7783',
 'TROJAN:BOT-FEODO-ACTIVITY': '7784',
 'TROJAN:DROIDDREAM': '7785',
 'TROJAN:DUO-USB': '7786',
 'TROJAN:FAKE-AV-CO-CC': '7787',
 'TROJAN:FISP-A-BOOTKIT': '7788',
 'TROJAN:MALVERTISING-CO-CC': '7789',
 'TROJAN:NIGHT-DRAGON-CC': '7790',
 'TROJAN:PROFTPD-BACKDOOR': '7791',
 'TROJAN:PROFTPD-BACKDOOR-BEACON': '7792',
 'TROJAN:R2D2': '7793',
 'TROJAN:SENDACC-JSP': '7794',
 'TROJAN:TELNET:USER-D13HH': '7795',
 'TROJAN:WALDEC-ACTIVITY': '7796',
 'TROJAN:ZEUS:ACTIVITY': '7797',
 'TROJAN:ZEUS:ZBOT-HTTP': '7798',
 'VIRUS:BITCOIN-MINER-BOTNET': '7799',
 'VIRUS:HERE-YOU-HAVE': '7800',
 'VIRUS:SMTP:DOUBLE-EXTENSION': '7801',
 'VOIP:APPLE-FACETIME-REQ': '7802',
 'VOIP:ASTERISK-IAX2-DOS': '7803',
 'VOIP:CISCO-UCM-OF': '7804',
 'VOIP:H225RAS:URQ-DOS': '7805',
 'VOIP:IAX-INT-OF': '7806',
 'VOIP:IAX2-DOS': '7807',
 'VOIP:MGMT:SNOM-VOIP-AUTH-BYPASS': '7808',
 'VOIP:RTP:FLOW-START': '7809',
 'VOIP:RTP:FLOW-START-VIDEO': '7810',
 'VOIP:SIP:ASTERISK-RES-DOS': '7811',
 'VOIP:SIP:ASTERISK-RTP-TYPE': '7812',
 'VOIP:SIP:AUDIT:INV-PARA-VIA': '7813',
 'VOIP:SIP:AUDIT:INV-REP-HEADER': '7814',
 'VOIP:SIP:AUDIT:UNK-HEADER': '7815',
 'VOIP:SIP:BYE-AUTH': '7816',
 'VOIP:SIP:FMT-STR': '7817',
 'VOIP:SIP:LIMITS:ACC-ENC-OF': '7818',
 'VOIP:SIP:LIMITS:ACC-LAN-OF': '7819',
 'VOIP:SIP:LIMITS:SIP-NEG-CNT-LEN': '7820',
 'VOIP:SIP:OVERFLOW:CHUNK-OF': '7821',
 'VOIP:SIP:OVERFLOW:LINE-OF': '7822',
 'VOIP:SIP:UNKNOWN-DATA': '7823',
 'VOIP:SKINNY-DRV-DOS': '7824',
 'VOIP:SKYPE:LOGIN': '7825',
 'VOIP:SKYPE:SKYPE-ENCRYPTED': '7826',
 'WHOIS:INVALID_EOL': '7827',
 'WORM:NACHI:B-C-D-INFECT-ATTEMPT': '7828',
 'X11:XFS-QUERYX': '7829',
 'X11:XFS-SWAP-CHAR': '7830',
 'Gaming:Protocols:CRYPTIC': '7831',
 'Gaming:Protocols:DIRECTPLAY-8': '7832',
 'Gaming:Protocols:HALF-LIFE': '7833',
 'Gaming:Protocols:STEAM': '7834',
 'Gaming:Protocols:UT2004-CONNECT': '7835',
 'Gaming:Protocols:UT2004-QUERY': '7836',
 'Gaming:Protocols:UT3-QUERY': '7837',
 'Gaming:Protocols:WOW-LOGIN': '7838',
 'Gaming:Protocols:WOW-REALM': '7839',
 'Gaming:Web-Based:ADDICTINGGAMES': '7840',
 'Gaming:Web-Based:ARMOR-GAMES': '7841',
 'Gaming:Web-Based:ARMOR-GAMES-PLAY': '7842',
 'Gaming:Web-Based:BIGPOINT': '7843',
 'Gaming:Web-Based:BLOKUS': '7844',
 'Gaming:Web-Based:FLASHGAMES247': '7845',
 'Gaming:Web-Based:HATTRICK': '7846',
 'Gaming:Web-Based:KONGREGATE': '7847',
 'Gaming:Web-Based:MINICLIP': '7848',
 'Gaming:Web-Based:PARTYPOKER': '7849',
 'Gaming:Web-Based:POGO': '7850',
 'Gaming:Web-Based:POPCAP-GAMES': '7851',
 'Gaming:Web-Based:POPCAP-GAMES-PLAY': '7852',
 'Gaming:Web-Based:STARDOCK-IMPULSE': '7853',
 'Gaming:Web-Based:STEAM-STORE': '7854',
 'Gaming:Web-Based:WOW-WEB': '7855',
 'Gaming:Web-Based:XFIRE': '7856',
 'Infrastructure:Authentication:FLASHSOCKET': '7857',
 'Infrastructure:Authentication:RADIUS': '7858',
 'Infrastructure:Authentication:TACACS': '7859',
 'Infrastructure:Backup:ARKEIA-BACKUP': '7860',
 'Infrastructure:Backup:NDMP': '7861',
 'Infrastructure:Backup:NETEGRITY-BACKUP': '7862',
 'Infrastructure:Backup:VERITAS-BACKUP': '7863',
 'Infrastructure:Database:DRDA': '7864',
 'Infrastructure:Database:FEDORA-DSGW': '7865',
 'Infrastructure:Database:MILLENNIUM-ILS': '7866',
 'Infrastructure:Database:MYSQL': '7867',
 'Infrastructure:Database:POSTGRESQL': '7868',
 'Infrastructure:Database:SQLMON': '7869',
 'Infrastructure:Database:SQLSERVER': '7870',
 'Infrastructure:Database:SYBASE': '7871',
 'Infrastructure:Database:TNS': '7872',
 'Infrastructure:Directory:FINGER': '7873',
 'Infrastructure:Directory:IDENT': '7874',
 'Infrastructure:Directory:LDAP': '7875',
 'Infrastructure:Directory:RUSERS': '7876',
 'Infrastructure:Directory:WHOIS': '7877',
 'Infrastructure:Encryption:AICCU-TIC': '7878',
 'Infrastructure:Encryption:ESP-OVER-UDP': '7879',
 'Infrastructure:Encryption:ISAKMP-IKE': '7880',
 'Infrastructure:Encryption:ISAKMP-IKE-DATA': '7881',
 'Infrastructure:Encryption:KRB4': '7882',
 'Infrastructure:Encryption:KRB5': '7883',
 'Infrastructure:Encryption:NAT-T': '7884',
 'Infrastructure:Encryption:OCSP': '7885',
 'Infrastructure:Encryption:SSL': '7886',
 'Infrastructure:Encryption:UNSPECIFIED-ENCRYPTED': '7887',
 'Infrastructure:File-Servers:FTP': '7888',
 'Infrastructure:File-Servers:FTP-DATA': '7889',
 'Infrastructure:File-Servers:NFS': '7890',
 'Infrastructure:File-Servers:RSYNC': '7891',
 'Infrastructure:File-Servers:SMB': '7892',
 'Infrastructure:File-Servers:TFTP': '7893',
 'Infrastructure:File-Servers:TFTP-DATA': '7894',
 'Infrastructure:File-Sharing:GOPHER': '7895',
 'Infrastructure:Legacy:CHARGEN': '7896',
 'Infrastructure:Legacy:DISCARD': '7897',
 'Infrastructure:Legacy:ECHO': '7898',
 'Infrastructure:Mobile:APPLE-SIRI': '7899',
 'Infrastructure:Mobile:SMPP': '7900',
 'Infrastructure:Monitoring:HPOVTRACE': '7901',
 'Infrastructure:Monitoring:IDP-NSM': '7902',
 'Infrastructure:Monitoring:SNMP': '7903',
 'Infrastructure:Monitoring:SNMPTRAP': '7904',
 'Infrastructure:Monitoring:SYMC-AV-MGT': '7905',
 'Infrastructure:Monitoring:SYSLOG': '7906',
 'Infrastructure:Networking:9P': '7907',
 'Infrastructure:Networking:BGP': '7908',
 'Infrastructure:Networking:CUPS': '7909',
 'Infrastructure:Networking:DHCP': '7910',
 'Infrastructure:Networking:DNS': '7911',
 'Infrastructure:Networking:LPR': '7912',
 'Infrastructure:Networking:NBDS': '7913',
 'Infrastructure:Networking:NBNAME': '7914',
 'Infrastructure:Networking:NCP': '7915',
 'Infrastructure:Networking:NTP': '7916',
 'Infrastructure:Networking:UNSPECIFIED': '7917',
 'Infrastructure:Networking:WCCP': '7918',
 'Infrastructure:RPC:DOT-NET': '7919',
 'Infrastructure:RPC:GIOP': '7920',
 'Infrastructure:RPC:JAVA-RMI': '7921',
 'Infrastructure:RPC:MSRPC': '7922',
 'Infrastructure:RPC:MSRPC-UNKNOWN': '7923',
 'Infrastructure:RPC:PORTMAPPER': '7924',
 'Infrastructure:RPC:SRVLOC': '7925',
 'Infrastructure:RPC:SUNRPC': '7926',
 'Infrastructure:RPC:SUNRPC-UNKNOWN': '7927',
 'Infrastructure:SCADA:DNP3': '7928',
 'Infrastructure:SCADA:ICCP': '7929',
 'Infrastructure:SCADA:IEC104': '7930',
 'Infrastructure:SCADA:MODBUS': '7931',
 'Infrastructure:SCM:CVS': '7932',
 'Infrastructure:SCM:DISTCC': '7933',
 'Infrastructure:SCM:PERFORCE': '7934',
 'Infrastructure:Software-Update:ADOBE-UPDATER': '7935',
 'Infrastructure:Software-Update:APPLE-UPDATE': '7936',
 'Infrastructure:Software-Update:GOOGLE-UPDATE': '7937',
 'Infrastructure:Software-Update:MICROSOFT-UPDATE': '7938',
 'Infrastructure:VOIP:APPLE-FACETIME': '7939',
 'Infrastructure:VOIP:H225RAS': '7940',
 'Infrastructure:VOIP:H225SGN': '7941',
 'Infrastructure:VOIP:IAX2': '7942',
 'Infrastructure:VOIP:MEGACO': '7943',
 'Infrastructure:VOIP:MGCP': '7944',
 'Infrastructure:VOIP:RTP-AUDIO': '7945',
 'Infrastructure:VOIP:RTP-VIDEO': '7946',
 'Infrastructure:VOIP:SCCP': '7947',
 'Infrastructure:VOIP:SIP': '7948',
 'Infrastructure:VOIP:SIP-RTP': '7949',
 'Infrastructure:VOIP:SIP-SOAP': '7950',
 'Infrastructure:VOIP:SKYPE': '7951',
 'Infrastructure:VOIP:TEAMSPEAK': '7952',
 'Messaging:Instant-Messaging:AIM': '7953',
 'Messaging:Instant-Messaging:AIMEXPRESS': '7954',
 'Messaging:Instant-Messaging:CONVORE': '7955',
 'Messaging:Instant-Messaging:EBUDDY': '7956',
 'Messaging:Instant-Messaging:GADU-GADU': '7957',
 'Messaging:Instant-Messaging:GOOGLE-TALK': '7958',
 'Messaging:Instant-Messaging:ICQ2GO': '7959',
 'Messaging:Instant-Messaging:ILOVEIM': '7960',
 'Messaging:Instant-Messaging:IMO': '7961',
 'Messaging:Instant-Messaging:INSTAN-T-WEB': '7962',
 'Messaging:Instant-Messaging:IRC': '7963',
 'Messaging:Instant-Messaging:JABBER': '7964',
 'Messaging:Instant-Messaging:LIVEJASMIN': '7965',
 'Messaging:Instant-Messaging:MEEBO': '7966',
 'Messaging:Instant-Messaging:MEEBO-FILE-TRANSFER': '7967',
 'Messaging:Instant-Messaging:MEEBOME': '7968',
 'Messaging:Instant-Messaging:MSN': '7969',
 'Messaging:Instant-Messaging:MSN2GO': '7970',
 'Messaging:Instant-Messaging:NATEON': '7971',
 'Messaging:Instant-Messaging:NIMBUZZ-WEB': '7972',
 'Messaging:Instant-Messaging:PALTALK': '7973',
 'Messaging:Instant-Messaging:PALTALK-SSL': '7974',
 'Messaging:Instant-Messaging:QQ': '7975',
 'Messaging:Instant-Messaging:STEAM-FRIENDS': '7976',
 'Messaging:Instant-Messaging:TALKGADGET': '7977',
 'Messaging:Instant-Messaging:TINYCHAT': '7978',
 'Messaging:Instant-Messaging:TOC': '7979',
 'Messaging:Instant-Messaging:TRILL-START': '7980',
 'Messaging:Instant-Messaging:UNIX-TALK-TCP': '7981',
 'Messaging:Instant-Messaging:UNIX-TALK-UDP': '7982',
 'Messaging:Instant-Messaging:YAHOO-MESSENGER-HTTP': '7983',
 'Messaging:Instant-Messaging:YAHOO-WEBMESSENGER': '7984',
 'Messaging:Instant-Messaging:YMSG': '7985',
 'Messaging:Mail:FASTMAIL': '7986',
 'Messaging:Mail:FRIENDVOX': '7987',
 'Messaging:Mail:GMAIL': '7988',
 'Messaging:Mail:GROUPWISE': '7989',
 'Messaging:Mail:HOTMAIL': '7990',
 'Messaging:Mail:HUSHMAIL': '7991',
 'Messaging:Mail:IMAP': '7992',
 'Messaging:Mail:LIVE-MAIL-ATTACH': '7993',
 'Messaging:Mail:LOTUSNOTES': '7994',
 'Messaging:Mail:MAILDOTCOM': '7995',
 'Messaging:Mail:MAILDOTRU': '7996',
 'Messaging:Mail:MAPI': '7997',
 'Messaging:Mail:NETEASE': '7998',
 'Messaging:Mail:NNTP': '7999',
 'Messaging:Mail:POP3': '8000',
 'Messaging:Mail:SMTP': '8001',
 'Messaging:Mail:YAHOO-MAIL': '8002',
 'Multimedia:Adult:4TUBE': '8003',
 'Multimedia:Adult:DEVIANTCLIP': '8004',
 'Multimedia:Adult:EMPFLIX': '8005',
 'Multimedia:Adult:EXTREMETUBE': '8006',
 'Multimedia:Adult:FUQ': '8007',
 'Multimedia:Adult:HARDSEXTUBE': '8008',
 'Multimedia:Adult:KEEZMOVIES': '8009',
 'Multimedia:Adult:MEGAPORN': '8010',
 'Multimedia:Adult:PORNHUB': '8011',
 'Multimedia:Adult:PORNORAMA': '8012',
 'Multimedia:Adult:PORNOXO': '8013',
 'Multimedia:Adult:REALITYKINGS': '8014',
 'Multimedia:Adult:REDTUBE': '8015',
 'Multimedia:Adult:RK': '8016',
 'Multimedia:Adult:SLUTLOAD': '8017',
 'Multimedia:Adult:SPANKWIRE': '8018',
 'Multimedia:Adult:STREAMATE': '8019',
 'Multimedia:Adult:TNAFLIX': '8020',
 'Multimedia:Adult:TUBE8': '8021',
 'Multimedia:Adult:XHAMSTER': '8022',
 'Multimedia:Adult:XNXX': '8023',
 'Multimedia:Adult:XTUBE': '8024',
 'Multimedia:Adult:XVIDEOS': '8025',
 'Multimedia:Adult:YOUJIZZ': '8026',
 'Multimedia:Adult:YOUPORN': '8027',
 'Multimedia:Audio-Streaming:FREECAST': '8028',
 'Multimedia:Audio-Streaming:HTTP-AUDIO-CONTENT': '8029',
 'Multimedia:Transport:MGCP-RTCP': '8030',
 'Multimedia:Transport:MGCP-RTP': '8031',
 'Multimedia:Transport:MMS': '8032',
 'Multimedia:Transport:PEERCAST': '8033',
 'Multimedia:Transport:RTSP': '8034',
 'Multimedia:Transport:RTSP-OVER-HTTP': '8035',
 'Multimedia:Transport:RTSP-RTCP': '8036',
 'Multimedia:Transport:RTSP-RTP': '8037',
 'Multimedia:Transport:SCCP-RTCP': '8038',
 'Multimedia:Transport:SCCP-RTP': '8039',
 'Multimedia:Transport:SIP-RTCP': '8040',
 'Multimedia:Video-Streaming:AXIS-CAMERA-STREAM': '8041',
 'Multimedia:Video-Streaming:BREAK': '8042',
 'Multimedia:Video-Streaming:COMEDY-CENTRAL': '8043',
 'Multimedia:Video-Streaming:I-CATCHER-CAM-STREAMING': '8044',
 'Multimedia:Video-Streaming:JOOST': '8045',
 'Multimedia:Video-Streaming:MATSUSHITA-CAMERA-STREAM': '8046',
 'Multimedia:Video-Streaming:MOBOTIX-CAMERA-STREAM': '8047',
 'Multimedia:Video-Streaming:NETCAM-LIVE-STREAMING': '8048',
 'Multimedia:Video-Streaming:NETFLIX': '8049',
 'Multimedia:Video-Streaming:NICONICO-DOUGA': '8050',
 'Multimedia:Video-Streaming:PANASONIC-CAMERA': '8051',
 'Multimedia:Video-Streaming:PPSTREAM': '8052',
 'Multimedia:Video-Streaming:QTIME-START': '8053',
 'Multimedia:Video-Streaming:RTMP': '8054',
 'Multimedia:Video-Streaming:SONY-CAMERA-STREAM': '8055',
 'Multimedia:Video-Streaming:TIVO-DISCOVERY-UDP': '8056',
 'Multimedia:Video-Streaming:TOSHIBA-CAMERA-JAR-DL': '8057',
 'Multimedia:Video-Streaming:TOSHIBA-CAMERA-STREAM': '8058',
 'Multimedia:Video-Streaming:TUBEMOGUL-PLAYER': '8059',
 'Multimedia:Video-Streaming:UNIFS': '8060',
 'Multimedia:Web-Based:AAJTAK': '8061',
 'Multimedia:Web-Based:BABELGUM': '8062',
 'Multimedia:Web-Based:BEEMP3': '8063',
 'Multimedia:Web-Based:BOXEE-TV': '8064',
 'Multimedia:Web-Based:COMEDY-CENTRAL-STREAM': '8065',
 'Multimedia:Web-Based:CRACKLE': '8066',
 'Multimedia:Web-Based:DAILYMOTION': '8067',
 'Multimedia:Web-Based:DEEZER': '8068',
 'Multimedia:Web-Based:EVO-CAM-JAR-DL': '8069',
 'Multimedia:Web-Based:FLASH': '8070',
 'Multimedia:Web-Based:FREEETV': '8071',
 'Multimedia:Web-Based:GROOVESHARK-STREAMING': '8072',
 'Multimedia:Web-Based:HULU': '8073',
 'Multimedia:Web-Based:IMEEM': '8074',
 'Multimedia:Web-Based:IMGUR': '8075',
 'Multimedia:Web-Based:JUSTIN-TV': '8076',
 'Multimedia:Web-Based:LAST-FM-STREAMING': '8077',
 'Multimedia:Web-Based:LIVE365': '8078',
 'Multimedia:Web-Based:MAESTRO-FM': '8079',
 'Multimedia:Web-Based:MEGAVIDEO': '8080',
 'Multimedia:Web-Based:METACAFE': '8081',
 'Multimedia:Web-Based:MOBILATORY-SEND-TO-PHONE': '8082',
 'Multimedia:Web-Based:MTV-HD-VIDEO-STREAM': '8083',
 'Multimedia:Web-Based:NAPSTER-STREAMING': '8084',
 'Multimedia:Web-Based:NETFLIX-PLAYER': '8085',
 'Multimedia:Web-Based:NETFLIX-STREAM': '8086',
 'Multimedia:Web-Based:NEWGROUNDS': '8087',
 'Multimedia:Web-Based:PANDORA': '8088',
 'Multimedia:Web-Based:PPLIVE': '8089',
 'Multimedia:Web-Based:SILVERLIGHT': '8090',
 'Multimedia:Web-Based:SOCIALTV': '8091',
 'Multimedia:Web-Based:SONGS-PK': '8092',
 'Multimedia:Web-Based:SPIKE': '8093',
 'Multimedia:Web-Based:STARTV': '8094',
 'Multimedia:Web-Based:STICKAM': '8095',
 'Multimedia:Web-Based:TAGOO': '8096',
 'Multimedia:Web-Based:TIDALTV': '8097',
 'Multimedia:Web-Based:TRUVEO': '8098',
 'Multimedia:Web-Based:TRUVEO-SEARCH': '8099',
 'Multimedia:Web-Based:TU-TV': '8100',
 'Multimedia:Web-Based:TUDOU': '8101',
 'Multimedia:Web-Based:TUNEIN': '8102',
 'Multimedia:Web-Based:TUNEIN-SSL': '8103',
 'Multimedia:Web-Based:TVANTS': '8104',
 'Multimedia:Web-Based:TVUNETWORKS': '8105',
 'Multimedia:Web-Based:TWITVID': '8106',
 'Multimedia:Web-Based:USTREAM': '8107',
 'Multimedia:Web-Based:VEOHTV': '8108',
 'Multimedia:Web-Based:VIDEOSIFT': '8109',
 'Multimedia:Web-Based:VIDEOSURF': '8110',
 'Multimedia:Web-Based:VIEWNETCAM-STREAM': '8111',
 'Multimedia:Web-Based:VIMEO': '8112',
 'Multimedia:Web-Based:WE7': '8113',
 'Multimedia:Web-Based:YAHOO-DOUGA': '8114',
 'Multimedia:Web-Based:YOUKU': '8115',
 'Multimedia:Web-Based:YOUTUBE': '8116',
 'Multimedia:Web-Based:YOUTUBE-COMMENT': '8117',
 'Multimedia:Web-Based:YOUTUBE-STREAM': '8118',
 'Multimedia:Web-Based:YUVUTU': '8119',
 'Multimedia:Web-Based:ZAYCEV': '8120',
 'P2P:File-Sharing:APPLEJUICE': '8121',
 'P2P:File-Sharing:ARES': '8122',
 'P2P:File-Sharing:ARES-UDP': '8123',
 'P2P:File-Sharing:BITTORRENT': '8124',
 'P2P:File-Sharing:BITTORRENT-DHT': '8125',
 'P2P:File-Sharing:BITTORRENT-UDP': '8126',
 'P2P:File-Sharing:DIRECTCONNECT': '8127',
 'P2P:File-Sharing:EDONKEY': '8128',
 'P2P:File-Sharing:EDONKEY-TCP': '8129',
 'P2P:File-Sharing:GNUCLEUSLAN-CONNECT': '8130',
 'P2P:File-Sharing:GNUTELLA': '8131',
 'P2P:File-Sharing:GNUTELLA-FIREWALLED': '8132',
 'P2P:File-Sharing:GNUTELLA-UDP': '8133',
 'P2P:File-Sharing:GNUTELLA-URN': '8134',
 'P2P:File-Sharing:HOTLINE': '8135',
 'P2P:File-Sharing:KADEMLIA-KAD': '8136',
 'P2P:File-Sharing:KADEMLIA-OVERNET': '8137',
 'P2P:File-Sharing:KAZAA': '8138',
 'P2P:File-Sharing:KUGOO': '8139',
 'P2P:File-Sharing:MANOLITO-DOWNLOAD': '8140',
 'P2P:File-Sharing:MANOLITO-UDP-MESSAGE-EXCHANGE': '8141',
 'P2P:File-Sharing:MUTE': '8142',
 'P2P:File-Sharing:NAPSTER-LOGIN': '8143',
 'P2P:File-Sharing:OPENFT': '8144',
 'P2P:File-Sharing:POCO-CONNECT': '8145',
 'P2P:File-Sharing:POCO-UDP': '8146',
 'P2P:File-Sharing:SOULSEEK': '8147',
 'P2P:File-Sharing:VERYCD': '8148',
 'P2P:File-Sharing:XUNLEI': '8149',
 'P2P:File-Sharing:XUNLEI-TCP-MESSAGE': '8150',
 'Remote-Access:Backdoors:NETBUS': '8151',
 'Remote-Access:Backdoors:YKW-TROJAN': '8152',
 'Remote-Access:Command:REXEC': '8153',
 'Remote-Access:Command:RLOGIN': '8154',
 'Remote-Access:Command:RSH': '8155',
 'Remote-Access:Command:RSH-ERROR': '8156',
 'Remote-Access:Command:SSH': '8157',
 'Remote-Access:Command:TELNET': '8158',
 'Remote-Access:Command:TN3270': '8159',
 'Remote-Access:Interactive-Desktop:CDE-DTSPCD': '8160',
 'Remote-Access:Interactive-Desktop:GLIDE': '8161',
 'Remote-Access:Interactive-Desktop:GOTOMYPC': '8162',
 'Remote-Access:Interactive-Desktop:ICA-TCP': '8163',
 'Remote-Access:Interactive-Desktop:ICA-UDP': '8164',
 'Remote-Access:Interactive-Desktop:PCANYWHERE': '8165',
 'Remote-Access:Interactive-Desktop:RDP': '8166',
 'Remote-Access:Interactive-Desktop:TEAMVIEWER': '8167',
 'Remote-Access:Interactive-Desktop:TEAMVIEWER-HTTP': '8168',
 'Remote-Access:Interactive-Desktop:TIMBUKTU': '8169',
 'Remote-Access:Interactive-Desktop:VMWARE-WEBUI': '8170',
 'Remote-Access:Interactive-Desktop:VNC': '8171',
 'Remote-Access:Interactive-Desktop:X11': '8172',
 'Remote-Access:Interactive-Desktop:XDMCP': '8173',
 'Remote-Access:Interactive-Desktop:YOICS': '8174',
 'Remote-Access:Tunneling:HSS-SSL-TCP': '8175',
 'Remote-Access:Tunneling:HSS-SSL-UDP': '8176',
 'Remote-Access:Tunneling:JONDO-PROXY': '8177',
 'Remote-Access:Tunneling:OZYMANDNS': '8178',
 'Remote-Access:Tunneling:PPTP': '8179',
 'Remote-Access:Tunneling:PPTP-DATA': '8180',
 'Remote-Access:Tunneling:REDUH': '8181',
 'Remote-Access:Tunneling:SOCKS4': '8182',
 'Remote-Access:Tunneling:SOCKS5': '8183',
 'Remote-Access:Tunneling:STUN': '8184',
 'Remote-Access:Tunneling:TEREDO': '8185',
 'Social-Networking:Applications:4CHAN': '8186',
 'Social-Networking:Applications:ADULTFRIENDFINDER': '8187',
 'Social-Networking:Applications:BADOO': '8188',
 'Social-Networking:Applications:BEBO': '8189',
 'Social-Networking:Applications:CAFEMOM': '8190',
 'Social-Networking:Applications:CAM4': '8191',
 'Social-Networking:Applications:CLASSMATES': '8192',
 'Social-Networking:Applications:CLOOB': '8193',
 'Social-Networking:Applications:DELICIOUS': '8194',
 'Social-Networking:Applications:DOOF': '8195',
 'Social-Networking:Applications:DOUBAN': '8196',
 'Social-Networking:Applications:EHARMONY': '8197',
 'Social-Networking:Applications:ETSY': '8198',
 'Social-Networking:Applications:FAZED': '8199',
 'Social-Networking:Applications:FOTKI': '8200',
 'Social-Networking:Applications:FRIENDFEED': '8201',
 'Social-Networking:Applications:FRIENDSTER': '8202',
 'Social-Networking:Applications:HATENA': '8203',
 'Social-Networking:Applications:HI5': '8204',
 'Social-Networking:Applications:HOOTSUITE': '8205',
 'Social-Networking:Applications:HYVES-NL': '8206',
 'Social-Networking:Applications:IBIBO': '8207',
 'Social-Networking:Applications:IMVU': '8208',
 'Social-Networking:Applications:IWIW': '8209',
 'Social-Networking:Applications:KAIXIN001': '8210',
 'Social-Networking:Applications:LIVEJOURNAL': '8211',
 'Social-Networking:Applications:MATCH': '8212',
 'Social-Networking:Applications:MEETUP': '8213',
 'Social-Networking:Applications:MEINVZ': '8214',
 'Social-Networking:Applications:MIXI': '8215',
 'Social-Networking:Applications:NETLOG': '8216',
 'Social-Networking:Applications:NING': '8217',
 'Social-Networking:Applications:ODNOKLASSNIKI': '8218',
 'Social-Networking:Applications:OKCUPID': '8219',
 'Social-Networking:Applications:ORKUT': '8220',
 'Social-Networking:Applications:PING-FM': '8221',
 'Social-Networking:Applications:PLENTYOFFISH': '8222',
 'Social-Networking:Applications:REDIFF': '8223',
 'Social-Networking:Applications:RENREN': '8224',
 'Social-Networking:Applications:SECONDLIFE': '8225',
 'Social-Networking:Applications:SKYROCK': '8226',
 'Social-Networking:Applications:STUMBLEUPON': '8227',
 'Social-Networking:Applications:TARINGA': '8228',
 'Social-Networking:Applications:TIANYA': '8229',
 'Social-Networking:Applications:TUENTI': '8230',
 'Social-Networking:Applications:TWEETMEME': '8231',
 'Social-Networking:Applications:TWEETPHOTO': '8232',
 'Social-Networking:Applications:TWIG': '8233',
 'Social-Networking:Applications:TWITPIC': '8234',
 'Social-Networking:Applications:TWITTER': '8235',
 'Social-Networking:Applications:VKONTAKTE': '8236',
 'Social-Networking:Applications:YELP': '8237',
 'Social-Networking:Applications:ZEDGE': '8238',
 'Social-Networking:Facebook:APPLICATIONBUILDER': '8239',
 'Social-Networking:Facebook:BIGPHOTO': '8240',
 'Social-Networking:Facebook:BIRTHDAYCALENDAR': '8241',
 'Social-Networking:Facebook:BUMPERSTICKER': '8242',
 'Social-Networking:Facebook:CARICATURE': '8243',
 'Social-Networking:Facebook:CAUSES': '8244',
 'Social-Networking:Facebook:CIRCLEOFMOMS': '8245',
 'Social-Networking:Facebook:COLLECTHEARTS': '8246',
 'Social-Networking:Facebook:CONTESTS': '8247',
 'Social-Networking:Facebook:DAILYHOROSCOPE': '8248',
 'Social-Networking:Facebook:DECORATIVEWRITING': '8249',
 'Social-Networking:Facebook:DOGBOOK': '8250',
 'Social-Networking:Facebook:EXTENDEDINFO': '8251',
 'Social-Networking:Facebook:FACEBOOK-ACCESS': '8252',
 'Social-Networking:Facebook:FACEBOOK-ACCESS-SSL': '8253',
 'Social-Networking:Facebook:FACEBOOK-APP': '8254',
 'Social-Networking:Facebook:FACEBOOK-CHAT': '8255',
 'Social-Networking:Facebook:FACEBOOK-FANAPPZ': '8256',
 'Social-Networking:Facebook:FACEBOOK-MAIL': '8257',
 'Social-Networking:Facebook:FACEBOOK-MUSIC': '8258',
 'Social-Networking:Facebook:FACEBOOK-MUSIKGW': '8259',
 'Social-Networking:Facebook:FACEBOOK-SOCIALRSS': '8260',
 'Social-Networking:Facebook:FACEBOOK-VISUALBOOKSHELF': '8261',
 'Social-Networking:Facebook:FACEBOOK-YEARBOOK': '8262',
 'Social-Networking:Facebook:FACEBOOK-YOUTUBEBOX': '8263',
 'Social-Networking:Facebook:FAMILYLINK': '8264',
 'Social-Networking:Facebook:FAMILYTREE': '8265',
 'Social-Networking:Facebook:FARMVILLE': '8266',
 'Social-Networking:Facebook:FB-PICNIK': '8267',
 'Social-Networking:Facebook:FLIXSTER': '8268',
 'Social-Networking:Facebook:FRASESDIARIAS': '8269',
 'Social-Networking:Facebook:FUNNYPHOTO': '8270',
 'Social-Networking:Facebook:GALLETASDELAFORTUNA': '8271',
 'Social-Networking:Facebook:GODWANTSYOUTOKNOW': '8272',
 'Social-Networking:Facebook:HALLMARKSOCIALCALENDAR': '8273',
 'Social-Networking:Facebook:HONESTYBOX': '8274',
 'Social-Networking:Facebook:HUGGED': '8275',
 'Social-Networking:Facebook:ICAST': '8276',
 'Social-Networking:Facebook:IKARMA': '8277',
 'Social-Networking:Facebook:ILIKE-MUSIC': '8278',
 'Social-Networking:Facebook:ILIKETHISARTIST': '8279',
 'Social-Networking:Facebook:MARKETPLACE': '8280',
 'Social-Networking:Facebook:MIXPODMUSIC': '8281',
 'Social-Networking:Facebook:MYARABICNAME': '8282',
 'Social-Networking:Facebook:MYBAND': '8283',
 'Social-Networking:Facebook:MYBESTFRIENDS': '8284',
 'Social-Networking:Facebook:MYBFFS': '8285',
 'Social-Networking:Facebook:MYPERSONALITY': '8286',
 'Social-Networking:Facebook:MYTOPFANS': '8287',
 'Social-Networking:Facebook:NETWORKEDBLOGS': '8288',
 'Social-Networking:Facebook:PHOTOOFTHEDAY': '8289',
 'Social-Networking:Facebook:PROFILEBOX': '8290',
 'Social-Networking:Facebook:PROFILEHTML': '8291',
 'Social-Networking:Facebook:QUIZMONSTER': '8292',
 'Social-Networking:Facebook:ROCKYOULIVE': '8293',
 'Social-Networking:Facebook:SKETCHME': '8294',
 'Social-Networking:Facebook:SLIDEFUNSPACE': '8295',
 'Social-Networking:Facebook:SUPERPOKE': '8296',
 'Social-Networking:Facebook:SWEEPSTAKES': '8297',
 'Social-Networking:Facebook:TOPFRIENDS': '8298',
 'Social-Networking:Facebook:WELCOMETAB': '8299',
 'Social-Networking:Facebook:WINDOWSLIVEMESSENGER': '8300',
 'Social-Networking:Facebook:YOURJAPANESENAME': '8301',
 'Social-Networking:Facebook:YOUTUBEVIDEOBOX': '8302',
 'Social-Networking:Facebook:ZOOSK': '8303',
 'Social-Networking:Linkedin:LINKEDIN': '8304',
 'Social-Networking:Linkedin:LINKEDIN-INMAIL': '8305',
 'Social-Networking:Linkedin:LINKEDIN-MAIL': '8306',
 'Social-Networking:Myspace:MYSPACE': '8307',
 'Social-Networking:Myspace:MYSPACE-ADDICTED-TO-HEROES': '8308',
 'Social-Networking:Myspace:MYSPACE-ASTROLOGY': '8309',
 'Social-Networking:Myspace:MYSPACE-AVATAR-DRESSUP-TOKYO': '8310',
 'Social-Networking:Myspace:MYSPACE-BLOODLINES': '8311',
 'Social-Networking:Myspace:MYSPACE-BOWLING-BUDDIES': '8312',
 'Social-Networking:Myspace:MYSPACE-BUDDYPOKE': '8313',
 'Social-Networking:Myspace:MYSPACE-BUMPER-STICKERS': '8314',
 'Social-Networking:Myspace:MYSPACE-CHAT': '8315',
 'Social-Networking:Myspace:MYSPACE-COLLECT-HEARTS': '8316',
 'Social-Networking:Myspace:MYSPACE-COLLECT-KISSES': '8317',
 'Social-Networking:Myspace:MYSPACE-COLLECT-ROSES': '8318',
 'Social-Networking:Myspace:MYSPACE-COOLPICS': '8319',
 'Social-Networking:Myspace:MYSPACE-DAILYHOROSCOPES': '8320',
 'Social-Networking:Myspace:MYSPACE-DANCING-BANANAS': '8321',
 'Social-Networking:Myspace:MYSPACE-DOG-WARS': '8322',
 'Social-Networking:Myspace:MYSPACE-DOG-WORLD': '8323',
 'Social-Networking:Myspace:MYSPACE-DRAGON-WARS': '8324',
 'Social-Networking:Myspace:MYSPACE-DREAM-WORLD': '8325',
 'Social-Networking:Myspace:MYSPACE-FASHION-WARS': '8326',
 'Social-Networking:Myspace:MYSPACE-FISH-ISLE': '8327',
 'Social-Networking:Myspace:MYSPACE-FLORIDA-FOOTBALL-FANS': '8328',
 'Social-Networking:Myspace:MYSPACE-FOOTBALL': '8329',
 'Social-Networking:Myspace:MYSPACE-FRIEND-FACTORY': '8330',
 'Social-Networking:Myspace:MYSPACE-GANG-WARS': '8331',
 'Social-Networking:Myspace:MYSPACE-GIFTS': '8332',
 'Social-Networking:Myspace:MYSPACE-GREEN-PLANET': '8333',
 'Social-Networking:Myspace:MYSPACE-GREEN-SPOT': '8334',
 'Social-Networking:Myspace:MYSPACE-GUARDIAN-ANGELS': '8335',
 'Social-Networking:Myspace:MYSPACE-HAPPY-AQUARIUM': '8336',
 'Social-Networking:Myspace:MYSPACE-HERO-WORLD': '8337',
 'Social-Networking:Myspace:MYSPACE-HEROES': '8338',
 'Social-Networking:Myspace:MYSPACE-HOOP-FEVER-LIVE': '8339',
 'Social-Networking:Myspace:MYSPACE-HOW-WELL-DO-THEY-KNOW': '8340',
 'Social-Networking:Myspace:MYSPACE-HOW-WELL-DO-YOU-KNOW-ME': '8341',
 'Social-Networking:Myspace:MYSPACE-JOBS': '8342',
 'Social-Networking:Myspace:MYSPACE-KINGDOMS-OF-CAMELOT': '8343',
 'Social-Networking:Myspace:MYSPACE-KISSME': '8344',
 'Social-Networking:Myspace:MYSPACE-LETS-GET-MARRIED': '8345',
 'Social-Networking:Myspace:MYSPACE-LIKENESS': '8346',
 'Social-Networking:Myspace:MYSPACE-MAFIA-RESURRECTION': '8347',
 'Social-Networking:Myspace:MYSPACE-MAFIA-WARS': '8348',
 'Social-Networking:Myspace:MYSPACE-MAFIA-WORLD': '8349',
 'Social-Networking:Myspace:MYSPACE-MAIL': '8350',
 'Social-Networking:Myspace:MYSPACE-MAKE-A-BABY': '8351',
 'Social-Networking:Myspace:MYSPACE-MEEZ': '8352',
 'Social-Networking:Myspace:MYSPACE-MINDJOLTGAMES': '8353',
 'Social-Networking:Myspace:MYSPACE-MOBSTERS': '8354',
 'Social-Networking:Myspace:MYSPACE-MOVIES': '8355',
 'Social-Networking:Myspace:MYSPACE-MUSICILIKE': '8356',
 'Social-Networking:Myspace:MYSPACE-MY-GREEN-GARDEN': '8357',
 'Social-Networking:Myspace:MYSPACE-NITROUS-RACING': '8358',
 'Social-Networking:Myspace:MYSPACE-OUTWORLD': '8359',
 'Social-Networking:Myspace:MYSPACE-OVERDRIVE': '8360',
 'Social-Networking:Myspace:MYSPACE-OWN-YOUR-FRIENDS': '8361',
 'Social-Networking:Myspace:MYSPACE-PARADISE-PAINTBALL': '8362',
 'Social-Networking:Myspace:MYSPACE-PET-SOCIETY': '8363',
 'Social-Networking:Myspace:MYSPACE-PHILADELPHIA-EAGLES': '8364',
 'Social-Networking:Myspace:MYSPACE-PHOTOBUZZ': '8365',
 'Social-Networking:Myspace:MYSPACE-PICNIK': '8366',
 'Social-Networking:Myspace:MYSPACE-PIRATES': '8367',
 'Social-Networking:Myspace:MYSPACE-PLAYLIST': '8368',
 'Social-Networking:Myspace:MYSPACE-POKER-PALACE': '8369',
 'Social-Networking:Myspace:MYSPACE-POP-UP-FRIENDS': '8370',
 'Social-Networking:Myspace:MYSPACE-PRISON-LOCKDOWN': '8371',
 'Social-Networking:Myspace:MYSPACE-QUIZAZZ': '8372',
 'Social-Networking:Myspace:MYSPACE-REAL-TOP-FRIENDS': '8373',
 'Social-Networking:Myspace:MYSPACE-ROCKSTARS': '8374',
 'Social-Networking:Myspace:MYSPACE-ROCKYOU-PETS': '8375',
 'Social-Networking:Myspace:MYSPACE-SASSY-MODELS': '8376',
 'Social-Networking:Myspace:MYSPACE-SECRET-ADMIRER': '8377',
 'Social-Networking:Myspace:MYSPACE-SKETCH-ME': '8378',
 'Social-Networking:Myspace:MYSPACE-SORORITY-LIFE': '8379',
 'Social-Networking:Myspace:MYSPACE-SPECIAL-FORCES': '8380',
 'Social-Networking:Myspace:MYSPACE-SPEED-RACING': '8381',
 'Social-Networking:Myspace:MYSPACE-STARDOM': '8382',
 'Social-Networking:Myspace:MYSPACE-STICKFAMILY': '8383',
 'Social-Networking:Myspace:MYSPACE-SUPER-SCRATCH-OFFS': '8384',
 'Social-Networking:Myspace:MYSPACE-SUPER-SLOT-MACHINES': '8385',
 'Social-Networking:Myspace:MYSPACE-SUPERHUG': '8386',
 'Social-Networking:Myspace:MYSPACE-SUPERPOKE': '8387',
 'Social-Networking:Myspace:MYSPACE-SUPERPOKE-PETS': '8388',
 'Social-Networking:Myspace:MYSPACE-TAG-ME': '8389',
 'Social-Networking:Myspace:MYSPACE-TATTOODLE': '8390',
 'Social-Networking:Myspace:MYSPACE-THE-WARLORDS': '8391',
 'Social-Networking:Myspace:MYSPACE-TRIUMPH': '8392',
 'Social-Networking:Myspace:MYSPACE-TRUE-GANGSTERS': '8393',
 'Social-Networking:Myspace:MYSPACE-TRUTH-BOX': '8394',
 'Social-Networking:Myspace:MYSPACE-VAMPIRES': '8395',
 'Social-Networking:Myspace:MYSPACE-VDREAM-RACING': '8396',
 'Social-Networking:Myspace:MYSPACE-VEGAS': '8397',
 'Social-Networking:Myspace:MYSPACE-VIDEO': '8398',
 'Social-Networking:Myspace:MYSPACE-VIRTUAL-PET-FARM': '8399',
 'Social-Networking:Myspace:MYSPACE-WHAT-IS-YOUR-STREET-REP': '8400',
 'Social-Networking:Myspace:MYSPACE-WHAT-MY-FRIENDS-THINK': '8401',
 'Social-Networking:Myspace:MYSPACE-WHAT-WOULD-YOU-WANT': '8402',
 'Social-Networking:Myspace:MYSPACE-WHATS-MY-IMPRESSION': '8403',
 'Social-Networking:Myspace:MYSPACE-WILD-ONES': '8404',
 'Social-Networking:Myspace:MYSPACE-WILD-PARADISE': '8405',
 'Social-Networking:Myspace:MYSPACE-WORLD-DOMINATION': '8406',
 'Social-Networking:Myspace:MYSPACE-YOO-MEE-GAMES': '8407',
 'Social-Networking:Myspace:MYSPACE-YOVILLE': '8408',
 'Social-Networking:Myspace:MYSPACE-ZOMBIE-REVENGE': '8409',
 'Social-Networking:Myspace:MYSPACE-ZYNGA-POKER': '8410',
 'Web:Anonymizer:GLYPE-PROXY': '8411',
 'Web:Anonymizer:PRIVAX': '8412',
 'Web:Anonymizer:PROXONO': '8413',
 'Web:Anonymizer:ULTRASURF': '8414',
 'Web:Anonymizer:VTUNNEL': '8415',
 'Web:Applications:ANIMOTO': '8416',
 'Web:Applications:ANIMOTO-LOGIN': '8417',
 'Web:Applications:ANIMOTO-UPLOAD': '8418',
 'Web:Applications:BACKPACK': '8419',
 'Web:Applications:BACKPACK-EDIT': '8420',
 'Web:Applications:CAMPFIRENOW': '8421',
 'Web:Applications:DOTME': '8422',
 'Web:Applications:DRUPAL-FORUM-POST': '8423',
 'Web:Applications:DRUPAL-PW_RESET': '8424',
 'Web:Applications:DRUPAL-USER-EDIT': '8425',
 'Web:Applications:EDITGRID': '8426',
 'Web:Applications:ELLUMINATE': '8427',
 'Web:Applications:EPEACHTREE': '8428',
 'Web:Applications:EVERNOTE': '8429',
 'Web:Applications:EYEJOT': '8430',
 'Web:Applications:EZNET': '8431',
 'Web:Applications:FEEDBURNER': '8432',
 'Web:Applications:FLIXSTER-SITE': '8433',
 'Web:Applications:FLUXIOM': '8434',
 'Web:Applications:GHOSTERY-VALIDATE': '8435',
 'Web:Applications:GOOGLE-ANALYTICS-TRACKING': '8436',
 'Web:Applications:GOOGLE-DOCS': '8437',
 'Web:Applications:GOOGLE-EARTH': '8438',
 'Web:Applications:GOOGLE-MOBILE-MAPS-APP': '8439',
 'Web:Applications:GOOGLE-SAFEBROWSE-SUB': '8440',
 'Web:Applications:GOOGLE-SAFEBROWSE-UPDATE': '8441',
 'Web:Applications:GOOGLE-TRANSLATE': '8442',
 'Web:Applications:GOTOMEETING': '8443',
 'Web:Applications:GROUPGREETING': '8444',
 'Web:Applications:INSTACALC': '8445',
 'Web:Applications:MAPQUEST': '8446',
 'Web:Applications:PICNIK': '8447',
 'Web:Applications:SALESFORCE': '8448',
 'Web:Applications:SCHMEDLEY': '8449',
 'Web:Applications:SCREENTOASTER': '8450',
 'Web:Applications:SIGHTSPEED': '8451',
 'Web:Applications:SPARKPEOPLE': '8452',
 'Web:Applications:SPRINGPAD': '8453',
 'Web:Applications:SPYPIG': '8454',
 'Web:Applications:SPYPIG-TRACKER-CREATE': '8455',
 'Web:Applications:SUMOPAINT': '8456',
 'Web:Applications:THECIRCLE': '8457',
 'Web:Applications:THINKFREE': '8458',
 'Web:Applications:USERPLANE': '8459',
 'Web:Applications:VOTEYESORNO': '8460',
 'Web:Applications:WEBAIM': '8461',
 'Web:Applications:WEBEX-WEBOFFICE': '8462',
 'Web:Applications:WIDGETOP': '8463',
 'Web:Applications:WIKIDOT-EDIT': '8464',
 'Web:Applications:ZAMZAR': '8465',
 'Web:Applications:ZAMZAR-UPLOAD': '8466',
 'Web:Applications:ZOHO-CHAT': '8467',
 'Web:Applications:ZOHO-MEETING': '8468',
 'Web:Applications:ZOHO-NOTEBOOK': '8469',
 'Web:Applications:ZOHO-PEOPLE': '8470',
 'Web:Applications:ZOHO-PLANNER': '8471',
 'Web:Applications:ZOHO-REPORTS': '8472',
 'Web:Applications:ZOHO-SHARE': '8473',
 'Web:Applications:ZOHO-SHEET': '8474',
 'Web:Applications:ZOHO-SHOW': '8475',
 'Web:Blogging:AMEBA': '8476',
 'Web:Blogging:BLOGGER-POST': '8477',
 'Web:Blogging:BLOGSPOT-POST': '8478',
 'Web:Blogging:FC2-BLOG-POST': '8479',
 'Web:Blogging:FOTOLOG': '8480',
 'Web:Blogging:METROFLOG': '8481',
 'Web:Blogging:SQUIDOO': '8482',
 'Web:CDN:CORALCDN': '8483',
 'Web:CDN:GOOGLE-STATIC': '8484',
 'Web:File-Sharing:4SHARED': '8485',
 'Web:File-Sharing:ADRIVE': '8486',
 'Web:File-Sharing:BADONGO': '8487',
 'Web:File-Sharing:BIGUPLOAD': '8488',
 'Web:File-Sharing:BITTRACKER': '8489',
 'Web:File-Sharing:BONPOO': '8490',
 'Web:File-Sharing:BOXDOTNET': '8491',
 'Web:File-Sharing:BTJUNKIE': '8492',
 'Web:File-Sharing:BTMON': '8493',
 'Web:File-Sharing:DEPOSITFILES': '8494',
 'Web:File-Sharing:DOCSTOC': '8495',
 'Web:File-Sharing:DROPBOKS': '8496',
 'Web:File-Sharing:DROPBOX-LAN-SYNC': '8497',
 'Web:File-Sharing:EASY-SHARE': '8498',
 'Web:File-Sharing:ESNIPS': '8499',
 'Web:File-Sharing:EXTRATORRENT': '8500',
 'Web:File-Sharing:FILEDROPPER': '8501',
 'Web:File-Sharing:FILEFACTORY': '8502',
 'Web:File-Sharing:FILESONIC': '8503',
 'Web:File-Sharing:FILESTUBE': '8504',
 'Web:File-Sharing:FILESWIRE': '8505',
 'Web:File-Sharing:FLIPDRIVE': '8506',
 'Web:File-Sharing:FOLDERSHARE': '8507',
 'Web:File-Sharing:FREAKSHARE': '8508',
 'Web:File-Sharing:FREEDRIVE': '8509',
 'Web:File-Sharing:GAMESTORRENTS': '8510',
 'Web:File-Sharing:GOBOOGY': '8511',
 'Web:File-Sharing:HOTFILE': '8512',
 'Web:File-Sharing:IBACKUP': '8513',
 'Web:File-Sharing:KICKASSTORRENTS': '8514',
 'Web:File-Sharing:LETSCRATE': '8515',
 'Web:File-Sharing:LIVE-SKYDRIVE': '8516',
 'Web:File-Sharing:LIVE-SKYDRIVE-LOGIN': '8517',
 'Web:File-Sharing:MEDIAFIRE': '8518',
 'Web:File-Sharing:MEDIAMAX': '8519',
 'Web:File-Sharing:MEGAUPLOAD': '8520',
 'Web:File-Sharing:MININOVA': '8521',
 'Web:File-Sharing:MOZY': '8522',
 'Web:File-Sharing:MULTIUPLOAD': '8523',
 'Web:File-Sharing:PEERENABLER': '8524',
 'Web:File-Sharing:RAPIDSHARE': '8525',
 'Web:File-Sharing:SENDSPACE': '8526',
 'Web:File-Sharing:SHARINGMATRIX': '8527',
 'Web:File-Sharing:THEPIRATEBAY': '8528',
 'Web:File-Sharing:TORRENT2CRAZY': '8529',
 'Web:File-Sharing:TORRENT411': '8530',
 'Web:File-Sharing:TORRENTHOUND': '8531',
 'Web:File-Sharing:TORRENTINO-RU': '8532',
 'Web:File-Sharing:TORRENTLEECH': '8533',
 'Web:File-Sharing:TORRENTREACTOR': '8534',
 'Web:File-Sharing:TORRENTZ': '8535',
 'Web:File-Sharing:UPLOADING': '8536',
 'Web:File-Sharing:WEBSHOTS': '8537',
 'Web:File-Sharing:WRITEBOARD': '8538',
 'Web:File-Sharing:YOURFILEHOST': '8539',
 'Web:File-Sharing:YOUSENDIT': '8540',
 'Web:File-Sharing:ZENBE': '8541',
 'Web:File-Sharing:ZSHARE': '8542',
 'Web:Forums:AOL-MSG-POST': '8543',
 'Web:Forums:CRAIGSLIST': '8544',
 'Web:Forums:FANPOP': '8545',
 'Web:Forums:GOOGLE-GROUPS-POST': '8546',
 'Web:Forums:KIJIJI': '8547',
 'Web:Forums:MANDUCATION': '8548',
 'Web:Forums:MORNINGSTAR': '8549',
 'Web:Forums:MSN-MONEY-POST': '8550',
 'Web:Forums:RAGINGBULL-POST': '8551',
 'Web:Forums:STACKOVERFLOW': '8552',
 'Web:Forums:YAHOO-FINANCE': '8553',
 'Web:Forums:YAHOO-FINANCE-POST': '8554',
 'Web:HTTP': '8555',
 'Web:Image-Sharing:DEVIANTART': '8556',
 'Web:Image-Sharing:FLICKR': '8557',
 'Web:Image-Sharing:FOTOLIA': '8558',
 'Web:Image-Sharing:IMAGESHACK': '8559',
 'Web:Image-Sharing:PHOTOBUCKET': '8560',
 'Web:Image-Sharing:PHOTOSHOP': '8561',
 'Web:Image-Sharing:PHOTOSHOP-ALBUM-CREATE': '8562',
 'Web:Image-Sharing:PICASA-WEB': '8563',
 'Web:Image-Sharing:SMUGMUG': '8564',
 'Web:Image-Sharing:TINYPIC': '8565',
 'Web:News:BBC-IPLAYER': '8566',
 'Web:News:DIGG': '8567',
 'Web:News:ENGADGET': '8568',
 'Web:News:ESPN': '8569',
 'Web:News:ESPN-CRICINFO': '8570',
 'Web:News:FARK': '8571',
 'Web:News:GIZMODO': '8572',
 'Web:News:KOTAKU': '8573',
 'Web:News:MARCA': '8574',
 'Web:News:MYGAZINES': '8575',
 'Web:News:SLASHDOT-FIREHOSE': '8576',
 'Web:News:THE-ONION': '8577',
 'Web:Portal:163': '8578',
 'Web:Portal:DROPIO': '8579',
 'Web:Portal:INDIATIMES': '8580',
 'Web:Portal:SINA': '8581',
 'Web:Portal:TAOBAO': '8582',
 'Web:Proxy:GPASS': '8583',
 'Web:Real-Estate:HOTPADS': '8584',
 'Web:Real-Estate:REALESTATEABC': '8585',
 'Web:Real-Estate:SOUFUN': '8586',
 'Web:Real-Estate:TRULIA': '8587',
 'Web:Real-Estate:ZILLOW': '8588',
 'Web:Reference:CHICKIPEDIA': '8589',
 'Web:Reference:WIKIPEDIA': '8590',
 'Web:Search:ALLMUSIC-LOOKUP': '8591',
 'Web:Search:FASTTRACK': '8592',
 'Web:Search:GRACENOTE-GCSP-LOOKUP': '8593',
 'Web:Search:GRACENOTE-LOOKUP': '8594',
 'Web:Search:HUBPAGES': '8595',
 'Web:Search:INDEED': '8596',
 'Web:Search:JOONGEL': '8597',
 'Web:Search:MONSTER': '8598',
 'Web:Search:NAUKRI': '8599',
 'Web:Search:SONGZA': '8600',
 'Web:Search:YAHOO-SEARCH': '8601',
 'Web:Search:YANDEX': '8602',
 'Web:Search:ZIPSKINNY': '8603',
 'Web:Shopping:AMAZON': '8604',
 'Web:Shopping:EBAY': '8605',
 'Web:Shopping:EBAYCLASSIFIEDS': '8606',
 'Web:Shopping:ITUNES': '8607',
 'Web:Shopping:QUATRAIN-WINPRICE': '8608',
 'Web:Shopping:RAKUTEN': '8609',
 'Web:Travel:BOOKING': '8610',
 'Web:Travel:CHEAPTICKETS': '8611',
 'Web:Travel:EXPEDIA': '8612',
 'Web:Travel:HOTWIRE': '8613',
 'Web:Travel:INDIAN-RAILWAYS': '8614',
 'Web:Travel:KAYAK': '8615',
 'Web:Travel:ORBITZ': '8616',
 'Web:Travel:PRICELINE': '8617',
 'Web:Travel:TRAVELOCITY': '8618',
 'Web:Travel:TRAVELZOO': '8619',
 'Web:Travel:TRIPADVISOR': '8620',
 'Web:Travel:TRIPAVE': '8621',
 'Web:Wiki:PBWIKI-EDIT': '8622',
 'Web:Wiki:WETPAINT-EDIT': '8623',
 'Web:Wiki:WIKIA': '8624',
 'Web:Wiki:WIKISPACES-EDIT': '8625',
 'APP:BIGANT-USV-BOF': '8626',
 'APP:BLUECOAT-AAA-OF': '8627',
 'APP:CA:ARCSRV:GWT-INFO-DISC': '8628',
 'APP:CISCO:NX-OS-PRIV-ESC': '8629',
 'APP:CITRIX:IMA-BO': '8630',
 'APP:CITRIX:PROVISIONINGSERV-UF': '8631',
 'APP:CITRIX:STEAM-OF': '8632',
 'APP:CITRIX:STREAMPROCESS-BOF': '8633',
 'APP:EMC-DATA-PROTECTION-DOS': '8634',
 'APP:FCKEDITOR-RCE-UPLOAD': '8635',
 'APP:GAME:DIABLO3': '8636',
 'APP:GAME:MEDAL-OF-HONOR-BO': '8637',
 'APP:GAME:PS-APPLICATIONS': '8638',
 'APP:GAME:PS-CHAT': '8639',
 'APP:GAME:PS-COMMUNITY': '8640',
 'APP:GAME:PS-UPDATE': '8641',
 'APP:GAME:XBOX-DASHBOARD': '8642',
 'APP:GAME:XBOX-HTTP-ACCESS': '8643',
 'APP:GAME:XBOX-KERBEROS-LOGIN': '8644',
 'APP:GAME:XBOX-LIVE': '8645',
 'APP:GAME:XBOX-LIVE-MARKETPLACE': '8646',
 'APP:HPOV:NNM-EVTCOR-CMD-INJ': '8647',
 'APP:HPOV:NNM-HTTP-OF': '8648',
 'APP:HPOV:NNM-OVLAUNCH-BO': '8649',
 'APP:HPOV:NNM-RADIA-NOTIFY': '8650',
 'APP:HPOV:NNM-URL-OF': '8651',
 'APP:HPOV:NNM-XSS': '8652',
 'APP:HPOV:OMNIBACK-II-ACE': '8653',
 'APP:IA-WEBMAIL-OF': '8654',
 'APP:IBM:DOMINO-BYPASS': '8655',
 'APP:IBM:INFORMIX-LIBRPC-DLL-BOF': '8656',
 'APP:IBM:TIV-SCHEDULEPARAM-XSS': '8657',
 'APP:IBM:TIVOLI-OF': '8658',
 'APP:INTERSYSTEMS-CACHE-OF': '8659',
 'APP:KERBEROS:MS-KERB-ASN-BIT': '8660',
 'APP:MDAEMON:LIST-OF': '8661',
 'APP:MERCURY-PH-BO': '8662',
 'APP:MISC:AVAYA-WINPDM': '8663',
 'APP:MISC:AVID-MEDIA-OF': '8664',
 'APP:MISC:DOGFOOD-RCE': '8665',
 'APP:MISC:SPREE-SEARCH-CMD-EXE': '8666',
 'APP:MISC:ZABBIX-AGENT-RCE': '8667',
 'APP:NOVELL:GROUPWISE-ADDRESS': '8668',
 'APP:NOVELL:IMANAGER-ARB-UPLOAD': '8669',
 'APP:NOVELL:IMANAGER-CREATE-BO': '8670',
 'APP:NOVELL:IPRINT-GETDRIVER-OF': '8671',
 'APP:NOVELL:NLM-NOTIFY': '8672',
 'APP:NOVELL:NLM-RENAME': '8673',
 'APP:NOVELL:XNFS-NLM': '8674',
 'APP:NOVELL:ZENWORKS-AGENT-OF': '8675',
 'APP:NOVELL:ZENWORKS-CONTENT-LEN': '8676',
 'APP:NOVELL:ZENWORKS-DIR-TRVRS': '8677',
 'APP:NOVELL:ZENWORKS-FHIPCND-EXE': '8678',
 'APP:NOVELL:ZENWORKS-MGT-UPLOAD': '8679',
 'APP:NOVELL:ZENWORKS-MSG-DLL-OF': '8680',
 'APP:NOVELL:ZENWORKS-TFTPD-RCE': '8681',
 'APP:NOW-SMS-OF': '8682',
 'APP:NOW-SMS-OF-MSF': '8683',
 'APP:ORACLE:OHS-PROXY-BYPASS': '8684',
 'APP:ORACLE:OOXML-TAG': '8685',
 'APP:ORACLE:OUTSIDE-JPEG2-CODCOC': '8686',
 'APP:ORACLE:OUTSIDE-JPEG2-CRG': '8687',
 'APP:ORACLE:RHINOSCRIPT-BYPASS': '8688',
 'APP:ORACLE:WEBUI-CMD-INJ': '8689',
 'APP:PCANYWHERE:LOGIN-PASSWD-BO': '8690',
 'APP:PCANYWHERE:SERVER-DOS': '8691',
 'APP:POSTFIX-GREYLISTD-OF': '8692',
 'APP:PROXY:SQUID-HOST-HDR-BYPASS': '8693',
 'APP:QT-SERVER:PARSE-XML-CGI-RCE': '8694',
 'APP:REAL:HELIX-URL-OF': '8695',
 'APP:REAL:REAL-MPG-WIDTH': '8696',
 'APP:REMOTE:NETTRANSPORT-DM': '8697',
 'APP:REMOTE:RDP-RCE': '8698',
 'APP:REMOTE:TEAMVIEWER-URL-MODE': '8699',
 'APP:SAFENET-VPN-OF': '8700',
 'APP:SAP:BIS-LIC-MGR-BOF': '8701',
 'APP:SAP:NETWEAVER-BO': '8702',
 'APP:SAP:NETWEAVER-DIAGI-DOS': '8703',
 'APP:SAP:NETWEAVER-DOS': '8704',
 'APP:SNORT:REPORT-RCE': '8705',
 'APP:SPREECOMMERCE-RCE': '8706',
 'APP:SYMC:BACKUP-EXEC': '8707',
 'APP:SYMC:IM-MGR-ADM-INJ': '8708',
 'APP:TMIC:CONTROL-MANAGER-CMD': '8709',
 'APP:TRACKERCAM-OF': '8710',
 'APP:TUN:TOR-EXIT-HOSTHEADER': '8711',
 'APP:VIDEOSPIRIT-OF': '8712',
 'APP:WEBSENSE-FAV-BYPASS': '8713',
 'APP:WEBSENSE-TRITON-RCE': '8714',
 'APP:WINAMP:AMF-BO': '8715',
 'APP:WINAMP:AVI-STREAM': '8716',
 'APP:WINAMP:MIDI-FILE-OF': '8717',
 'APP:WINAMP:RIFF-INFO': '8718',
 'CHAT:APPLE-IMESSAGE-CONNECTION': '8719',
 'CHAT:GOOGLE:JABBER': '8720',
 'CHAT:OOVOO-ACTIVITY': '8721',
 'CHAT:POPO-CHAT-LOGIN': '8722',
 'DB:IB:FILENAME-OF': '8723',
 'DB:IBM-SOLIDBD-WHERE-DOS': '8724',
 'DB:IBM-SOLIDDB-ROWNUM': '8725',
 'DB:MYSQL:BENCHMARK-DOS': '8726',
 'DB:MYSQL:UPDATEXML': '8727',
 'DB:ORACLE:EXP-APP-WEBCACHE': '8728',
 'DB:ORACLE:ROLLBACKWORKSPACE': '8729',
 'DB:ORACLE:SEARCH-P-GROUPS': '8730',
 'DB:ORACLE:TNS:SERVICE-NAME-OF': '8731',
 'DB:ORACLE:TNS:TABLEFUNC-ASOWN': '8732',
 'DB:SYBASE:MOBILINK-BO': '8733',
 'DDOS:DIRTJUMPER': '8734',
 'DDOS:HOIC-HTTP-METHOD': '8735',
 'DNS:AUDIT:UNASSIGNED-OPCODE': '8736',
 'DNS:AUDIT:Z-RESERVED-OPT': '8737',
 'DNS:BIND9-ASSERT-DOS': '8738',
 'DNS:REPERR:NULL-RDATA-LEN': '8739',
 'DOS:IP:IGMP-LINUX': '8740',
 'DOS:NETDEV:D-LINK-DNS-320': '8741',
 'DOS:SLOWHTTPTEST-TOOL': '8742',
 'FTP:FORMAT-STRING-IN-CMD': '8743',
 'FTP:OVERFLOW:TYPSOFT-SERVER': '8744',
 'HTTP:APACHE:AXIS-SOAP-DOS': '8745',
 'HTTP:APACHE:REV-PROXY-EXPLOIT': '8746',
 'HTTP:APACHE:STRUTS2-COOKIE-OGNL': '8747',
 'HTTP:APACHE:STRUTS2-OGNL-CE': '8748',
 'HTTP:APACHE:STRUTS2-OGNL-INJ': '8749',
 'HTTP:CGI:AWC-XSL-CMD-INJ': '8750',
 'HTTP:CGI:CTEK-SKYROUTER-EXEC': '8751',
 'HTTP:CISCO:CUCM-DIR-TRAV': '8752',
 'HTTP:COLDFUSION:XML-CMD-INJ': '8753',
 'HTTP:DOS:HULK-DOS': '8754',
 'HTTP:DOS:SLOW-HEADER-DOS': '8755',
 'HTTP:EXPLOIT:FP2K-ASP-UPLOAD': '8756',
 'HTTP:EXPLOIT:WEBSTER-URL-OF': '8757',
 'HTTP:IIS:ASP-FORMS-DISCLOSURE': '8758',
 'HTTP:IIS:ASP-NET-FORM-REDIRECT': '8759',
 'HTTP:IIS:IIS-6-7-AUTH-BYPASS': '8760',
 'HTTP:IIS:SP-SCRIPTRESX-XSS': '8761',
 'HTTP:INFO-LEAK-CC': '8762',
 'HTTP:INFO-LEAK-SSN': '8763',
 'HTTP:MISC:ALCATEL-OMNIPCX-CE': '8764',
 'HTTP:MISC:X-MICRO-WLAN-PASSWORD': '8765',
 'HTTP:MONGOOSE-HTTPD-POST-OF': '8766',
 'HTTP:ORACLE:GLASSFISH-MUL-XSS': '8767',
 'HTTP:ORACLE:GLASSFISH-REST': '8768',
 'HTTP:OVERFLOW:IMAGEMAGICK-EXIF': '8769',
 'HTTP:OVERFLOW:SAVANT': '8770',
 'HTTP:PHP:ARDEACORE-RFI': '8771',
 'HTTP:PHP:BASE-RFI': '8772',
 'HTTP:PHP:CAUPOSHOP-LFI': '8773',
 'HTTP:PHP:CENTERON-DIR-TRAV': '8774',
 'HTTP:PHP:COPPERMINE-RCE': '8775',
 'HTTP:PHP:EXIF-HEADER': '8776',
 'HTTP:PHP:GIF-HEADER-EVASION': '8777',
 'HTTP:PHP:HTML-SPCL-CHARS': '8778',
 'HTTP:PHP:MYBB-BACKDOOR': '8779',
 'HTTP:PHP:OSCOMMERCE-ADMIN': '8780',
 'HTTP:PHP:PHP-CGI-CMD-LINE-RCE': '8781',
 'HTTP:PHP:RAXNET-CACTI-RCE': '8782',
 'HTTP:PHP:SYM-GW-LFI': '8783',
 'HTTP:PHP:SYM-WG-FILE-UP': '8784',
 'HTTP:PHP:SYM-WG-IPCHANG': '8785',
 'HTTP:PHP:VAMCART-FU': '8786',
 'HTTP:PHP:WHMCS-LFI': '8787',
 'HTTP:PHP:WP-DOUPLOAD-FU': '8788',
 'HTTP:PHP:WP-MRKPLC-UPLOADIFY': '8789',
 'HTTP:PROXY:PSOPROXY-OF': '8790',
 'HTTP:REQERR:NULL-IN-HEADER': '8791',
 'HTTP:SQL:INJ:AND-NUMBER-EQUALS': '8792',
 'HTTP:SQL:INJ:EXEC-MASTER': '8793',
 'HTTP:SQL:INJ:INSERT-VALUES': '8794',
 'HTTP:SQL:INJ:INTO-OUTFILE': '8795',
 'HTTP:SQL:INJ:MYSQL-TABLE-NAME': '8796',
 'HTTP:SQL:INJ:NULL-NULL-NULL': '8797',
 'HTTP:SQL:INJ:NULLBYTE-COMMENT': '8798',
 'HTTP:SQL:INJ:WAITFOR-DELAY': '8799',
 'HTTP:STC:ACTIVEX:2X-APPLICATION': '8800',
 'HTTP:STC:ACTIVEX:ANSMTP': '8801',
 'HTTP:STC:ACTIVEX:AOL-PHOBOS': '8802',
 'HTTP:STC:ACTIVEX:AWINGSOFT': '8803',
 'HTTP:STC:ACTIVEX:BENNET-TEC': '8804',
 'HTTP:STC:ACTIVEX:C6-URL-DL': '8805',
 'HTTP:STC:ACTIVEX:CHILKAT-CRYPT': '8806',
 'HTTP:STC:ACTIVEX:CHILKAT-FTP2': '8807',
 'HTTP:STC:ACTIVEX:CHILKAT-ZIP': '8808',
 'HTTP:STC:ACTIVEX:CISCO-WVC200': '8809',
 'HTTP:STC:ACTIVEX:CLEARQUEST-OLE': '8810',
 'HTTP:STC:ACTIVEX:CLSID-OBFUS': '8811',
 'HTTP:STC:ACTIVEX:CO-FLEXGRID': '8812',
 'HTTP:STC:ACTIVEX:DECISIONTOOLS': '8813',
 'HTTP:STC:ACTIVEX:DELL-WEBCAM': '8814',
 'HTTP:STC:ACTIVEX:DLINK-DCS-5605': '8815',
 'HTTP:STC:ACTIVEX:DX-PLY-CMD-INJ': '8816',
 'HTTP:STC:ACTIVEX:EDRAW-LIC-NAME': '8817',
 'HTTP:STC:ACTIVEX:EDRAW-VIEWER': '8818',
 'HTTP:STC:ACTIVEX:FLEXERA': '8819',
 'HTTP:STC:ACTIVEX:HP-EASY-PRINT': '8820',
 'HTTP:STC:ACTIVEX:HP-EASY-XML': '8821',
 'HTTP:STC:ACTIVEX:HP-PROTECT-DAM': '8822',
 'HTTP:STC:ACTIVEX:HYLEOS': '8823',
 'HTTP:STC:ACTIVEX:IBM-INOTES-BOF': '8824',
 'HTTP:STC:ACTIVEX:IBM-LOTUS-QIKR': '8825',
 'HTTP:STC:ACTIVEX:IBM-RATIONAL': '8826',
 'HTTP:STC:ACTIVEX:IBM-SPSS-EXHTM': '8827',
 'HTTP:STC:ACTIVEX:IBM-SPSS-MRAB': '8828',
 'HTTP:STC:ACTIVEX:IBM-TIVOLI': '8829',
 'HTTP:STC:ACTIVEX:IBM-VSVIEW6': '8830',
 'HTTP:STC:ACTIVEX:IE-KEYFRAME': '8831',
 'HTTP:STC:ACTIVEX:IMAGE-VIEWER': '8832',
 'HTTP:STC:ACTIVEX:IMESH-IMWEBCON': '8833',
 'HTTP:STC:ACTIVEX:LIVE-WRITER': '8834',
 'HTTP:STC:ACTIVEX:MCAFEE-MYCIO': '8835',
 'HTTP:STC:ACTIVEX:MCAFEE-VT': '8836',
 'HTTP:STC:ACTIVEX:MOVIE-PLAYER': '8837',
 'HTTP:STC:ACTIVEX:MSCOMCTL-OCX': '8838',
 'HTTP:STC:ACTIVEX:NTR-BOF': '8839',
 'HTTP:STC:ACTIVEX:ORACLE-AUTOVUE': '8840',
 'HTTP:STC:ACTIVEX:ORACLE-CROPROJ': '8841',
 'HTTP:STC:ACTIVEX:ORACLE-ODBC-OF': '8842',
 'HTTP:STC:ACTIVEX:ORACLE-SSSPLT': '8843',
 'HTTP:STC:ACTIVEX:ORACLE-TTF16': '8844',
 'HTTP:STC:ACTIVEX:PERSITS-UPLOAD': '8845',
 'HTTP:STC:ACTIVEX:QUEST-INTRUST': '8846',
 'HTTP:STC:ACTIVEX:QUEST-PNLLMCLI': '8847',
 'HTTP:STC:ACTIVEX:QUEST-RCE': '8848',
 'HTTP:STC:ACTIVEX:QUEST-TOAD-DBA': '8849',
 'HTTP:STC:ACTIVEX:RKD-BARCODE': '8850',
 'HTTP:STC:ACTIVEX:SAM-CONNECTDDN': '8851',
 'HTTP:STC:ACTIVEX:SAMSUNG-BACKUP': '8852',
 'HTTP:STC:ACTIVEX:SAMSUNG-NET-I': '8853',
 'HTTP:STC:ACTIVEX:SASCAM-WEBCAM': '8854',
 'HTTP:STC:ACTIVEX:SKINCRAFTER-OF': '8855',
 'HTTP:STC:ACTIVEX:SONICWALL-FS': '8856',
 'HTTP:STC:ACTIVEX:SONY-WIFIMAN': '8857',
 'HTTP:STC:ACTIVEX:SUNWAY': '8858',
 'HTTP:STC:ACTIVEX:TEECHARTPRO-OF': '8859',
 'HTTP:STC:ACTIVEX:TIVOLI-PROV': '8860',
 'HTTP:STC:ACTIVEX:TRENDNET': '8861',
 'HTTP:STC:ACTIVEX:VISCOM-VIEWER': '8862',
 'HTTP:STC:ACTIVEX:VLC-PLY-RCE': '8863',
 'HTTP:STC:ACTIVEX:WMP-AUDIO': '8864',
 'HTTP:STC:ACTIVEX:XMLHTTP': '8865',
 'HTTP:STC:ACTIVEX:YAHOO-CD-PLY': '8866',
 'HTTP:STC:ACTIVEX:ZENWORKS': '8867',
 'HTTP:STC:ADOBE:FLASH-ACTIVEX-MC': '8868',
 'HTTP:STC:ADOBE:FLASH-DYN-SCRIPT': '8869',
 'HTTP:STC:ADOBE:FLASH-MP4-NULL': '8870',
 'HTTP:STC:ADOBE:FLASH-PLAYER-MP4': '8871',
 'HTTP:STC:ADOBE:FLASH-STAGE3D': '8872',
 'HTTP:STC:ADOBE:FLATEDECODE-BO': '8873',
 'HTTP:STC:ADOBE:FLV-APPENDBYTES': '8874',
 'HTTP:STC:ADOBE:JS-CE': '8875',
 'HTTP:STC:ADOBE:PDF-EVASIVE-FF': '8876',
 'HTTP:STC:ADOBE:PDF-HEAP-RCE': '8877',
 'HTTP:STC:ADOBE:PS-TIFF-BOF': '8878',
 'HTTP:STC:ADOBE:READER-BMP': '8879',
 'HTTP:STC:ADOBE:READER-BMP-COLOR': '8880',
 'HTTP:STC:ADOBE:READER-DCT': '8881',
 'HTTP:STC:ADOBE:READER-PRC': '8882',
 'HTTP:STC:ADOBE:READER-TTF-DESC': '8883',
 'HTTP:STC:ADOBE:READER-U3D': '8884',
 'HTTP:STC:ADOBE:SHOCKWAVE-OOB': '8885',
 'HTTP:STC:ADOBE:SHOCKWAVE-RCSL': '8886',
 'HTTP:STC:ADOBE:SWF-FLASH-OF': '8887',
 'HTTP:STC:ADOBE:SWF-TYPE-CONFUS': '8888',
 'HTTP:STC:ADOBE:SWF-UNVRSL-XSS': '8889',
 'HTTP:STC:AV-GATEWAY-BYPASS': '8890',
 'HTTP:STC:BROWSER-RUBY-BLOCK': '8891',
 'HTTP:STC:CACHETIME': '8892',
 'HTTP:STC:CHROME:RESPONSE-MC': '8893',
 'HTTP:STC:DL:A-PDF-RCE': '8894',
 'HTTP:STC:DL:AOL-RTX': '8895',
 'HTTP:STC:DL:APPLE-ITUNES-BOF': '8896',
 'HTTP:STC:DL:APPLE-QT-JPEG-2000': '8897',
 'HTTP:STC:DL:ASTONSOFT-DBR-BO': '8898',
 'HTTP:STC:DL:CISCO-WEBEX-ATDL': '8899',
 'HTTP:STC:DL:CORELAN-S3M': '8900',
 'HTTP:STC:DL:DOCX-ACCESS-RCE': '8901',
 'HTTP:STC:DL:ESIGNAL-MUL-FILE-OF': '8902',
 'HTTP:STC:DL:FAT-MEDIAPLAYER-RCE': '8903',
 'HTTP:STC:DL:FOXIT-CREATEOBJ': '8904',
 'HTTP:STC:DL:FOXIT-READER-ESCAPE': '8905',
 'HTTP:STC:DL:GALAN-BO': '8906',
 'HTTP:STC:DL:IDEAL-SERVER-OF': '8907',
 'HTTP:STC:DL:JRE-ZIP-READCEN': '8908',
 'HTTP:STC:DL:LOTUS-LZH-BOF': '8909',
 'HTTP:STC:DL:MAL-M3U': '8910',
 'HTTP:STC:DL:MAL-MPP': '8911',
 'HTTP:STC:DL:MAL-PLS': '8912',
 'HTTP:STC:DL:MAL-WEBEX-WRF': '8913',
 'HTTP:STC:DL:MCAF-LHA-OF': '8914',
 'HTTP:STC:DL:MIDICONTROLEVENT': '8915',
 'HTTP:STC:DL:MINI-STREAM-PLS-OF': '8916',
 'HTTP:STC:DL:MS-MEDIA-DVR': '8917',
 'HTTP:STC:DL:MS-OBJ-PACKAGER-RCE': '8918',
 'HTTP:STC:DL:MS-WIN-DOTNET-RCE': '8919',
 'HTTP:STC:DL:MS-WIN-VERIFY-TRUST': '8920',
 'HTTP:STC:DL:MSDOTNET-FUNC-PTR': '8921',
 'HTTP:STC:DL:NUANCE-LAUNCH': '8922',
 'HTTP:STC:DL:OFF-GDI-HOF': '8923',
 'HTTP:STC:DL:OFF-GDI-RCD-TYPE': '8924',
 'HTTP:STC:DL:OFFICE-MSO': '8925',
 'HTTP:STC:DL:OFFICE-VBA-UAF': '8926',
 'HTTP:STC:DL:OLE-STRUCTURE-RCE': '8927',
 'HTTP:STC:DL:ORACLE-LOTUS-123': '8928',
 'HTTP:STC:DL:ORBITAL-VIEWER-ORB': '8929',
 'HTTP:STC:DL:PDFXCHANGE-AX': '8930',
 'HTTP:STC:DL:PEAZIP-CINJ': '8931',
 'HTTP:STC:DL:PPT-2000-BOF': '8932',
 'HTTP:STC:DL:PPT-LEGACY-FMT-OF': '8933',
 'HTTP:STC:DL:PPT-MS-OGRAPH': '8934',
 'HTTP:STC:DL:PPT-NOTES-MC': '8935',
 'HTTP:STC:DL:PPT-PP7-MC': '8936',
 'HTTP:STC:DL:PPT-PRINTER-REC-OF': '8937',
 'HTTP:STC:DL:PROSHOW-PSH-FILE-OF': '8938',
 'HTTP:STC:DL:PUB-INDEXLIMITS': '8939',
 'HTTP:STC:DL:PUB-OPY': '8940',
 'HTTP:STC:DL:PUB-PLC': '8941',
 'HTTP:STC:DL:QP-S3M-OF': '8942',
 'HTTP:STC:DL:QT-PICT-FILE-MC': '8943',
 'HTTP:STC:DL:QT-PV-OF': '8944',
 'HTTP:STC:DL:QT-STSC-ATOM-MC': '8945',
 'HTTP:STC:DL:QT-TEXML-COLOR-BOF': '8946',
 'HTTP:STC:DL:QT-TEXML-TRANS-BOF': '8947',
 'HTTP:STC:DL:QUO-ESIGNAL-BOF': '8948',
 'HTTP:STC:DL:RTF-MISMATCH': '8949',
 'HTTP:STC:DL:TRUETYPE-PARSE': '8950',
 'HTTP:STC:DL:TRUETYPE-PARSE2': '8951',
 'HTTP:STC:DL:ULTRAISO-CCD': '8952',
 'HTTP:STC:DL:ULTRAISO-CUE': '8953',
 'HTTP:STC:DL:VISIO-COMPRESSION': '8954',
 'HTTP:STC:DL:VISIO-INVALID-ROW': '8955',
 'HTTP:STC:DL:VISIO-OBJ-CONFUSION': '8956',
 'HTTP:STC:DL:VISIO-OBJ-TAG': '8957',
 'HTTP:STC:DL:VISIO-VSD-MEM': '8958',
 'HTTP:STC:DL:VISIWAVE-SITE-BOF': '8959',
 'HTTP:STC:DL:WEBEX-ATAS': '8960',
 'HTTP:STC:DL:WEBEX-ATDL-BOF': '8961',
 'HTTP:STC:DL:WEBEX-ATDL-OF': '8962',
 'HTTP:STC:DL:WEBEX-RECORD-ATAS': '8963',
 'HTTP:STC:DL:WINAMP-MAL-PLS': '8964',
 'HTTP:STC:DL:WORD-BOF': '8965',
 'HTTP:STC:DL:WORKS-WPS-OF': '8966',
 'HTTP:STC:DL:WPS-HEAP-OF': '8967',
 'HTTP:STC:DL:XLS-BIFF-MC': '8968',
 'HTTP:STC:DL:XLS-BIN-OF': '8969',
 'HTTP:STC:DL:XLS-FIELD-MC': '8970',
 'HTTP:STC:DL:XLS-FORMULA-BIFF': '8971',
 'HTTP:STC:DL:XLS-MAL-OBJ': '8972',
 'HTTP:STC:DL:XLS-MAL-REC-MC': '8973',
 'HTTP:STC:DL:XLS-MERGECELLS-OF': '8974',
 'HTTP:STC:DL:XLS-MOD-BYTES': '8975',
 'HTTP:STC:DL:XLS-OBJECTLINK': '8976',
 'HTTP:STC:DL:XLS-PIC-REC-MC': '8977',
 'HTTP:STC:DL:XLS-SERIES-TYPE-RCE': '8978',
 'HTTP:STC:DL:XLS-SST-REC-MC': '8979',
 'HTTP:STC:DL:XLS-SXLI-MC': '8980',
 'HTTP:STC:DL:XLS-WINDOW2': '8981',
 'HTTP:STC:DOTNET-BUFF-ALLOC': '8982',
 'HTTP:STC:DOTNET-FRAMEWORK-RCE': '8983',
 'HTTP:STC:DOTNET-SERIALIZATION': '8984',
 'HTTP:STC:IE:9-NULL-BYTE-DISC': '8985',
 'HTTP:STC:IE:ANTIXSS-INFO-DISC': '8986',
 'HTTP:STC:IE:ATTR-RM-RCE': '8987',
 'HTTP:STC:IE:AUTH-REFLECTION': '8988',
 'HTTP:STC:IE:CACHED-OBJ-RCE': '8989',
 'HTTP:STC:IE:CENTER-ELE-RCE': '8990',
 'HTTP:STC:IE:COL-SPAN': '8991',
 'HTTP:STC:IE:DEV-TOOLBAR-RCE': '8992',
 'HTTP:STC:IE:EVENT-HANDLER-RCE': '8993',
 'HTTP:STC:IE:HTML-SANITZ': '8994',
 'HTTP:STC:IE:IE-MEM-CORR': '8995',
 'HTTP:STC:IE:IE-MEM-LEAK': '8996',
 'HTTP:STC:IE:INSERT-ADJACENT-RCE': '8997',
 'HTTP:STC:IE:INSERTROW-RCE': '8998',
 'HTTP:STC:IE:LOCATION-X-DOMAIN': '8999',
 'HTTP:STC:IE:MDAC-CACHESIZE-OF': '9000',
 'HTTP:STC:IE:ONBEFORE-DEACTIVATE': '9001',
 'HTTP:STC:IE:ONROWSINSERTED-RCE': '9002',
 'HTTP:STC:IE:POINTER-AFTERFREE': '9003',
 'HTTP:STC:IE:PRINT-PREVIEW-CE': '9004',
 'HTTP:STC:IE:SAMEID-RCE': '9005',
 'HTTP:STC:IE:TIME-RCE': '9006',
 'HTTP:STC:IE:TITLE-ELM-CHG': '9007',
 'HTTP:STC:IE:VML-AFTERFREE': '9008',
 'HTTP:STC:IE:XML-RCE': '9009',
 'HTTP:STC:IE:XSS-FILTER-DISC': '9010',
 'HTTP:STC:IMG:LIBPNG-CHUNK-OV': '9011',
 'HTTP:STC:JAVA:ATOMIC-SB-BREACH': '9012',
 'HTTP:STC:JAVA:BASICSERVICEIMPL': '9013',
 'HTTP:STC:JAVA:JAR-FILE-DOWNLOAD': '9014',
 'HTTP:STC:JAVA:MIXERSEQ-OF': '9015',
 'HTTP:STC:JAVA:TRUE-TYPE-FONT-OF': '9016',
 'HTTP:STC:JAVA:TYPE1-FONT': '9017',
 'HTTP:STC:MOZILLA:FF-ARRAY-SLICE': '9018',
 'HTTP:STC:MOZILLA:GIF89A-EXT': '9019',
 'HTTP:STC:MOZILLA:NNTP-URL': '9020',
 'HTTP:STC:MOZILLA:OGG-VORBIS': '9021',
 'HTTP:STC:MS-OBJ-PACKAGER': '9022',
 'HTTP:STC:OPERA:SEARCH-HIST': '9023',
 'HTTP:STC:OPERA:TREE-TRAVERSE-MC': '9024',
 'HTTP:STC:SAFARI:IPHONE-LIBTIFF': '9025',
 'HTTP:STC:SAFARI:RUNIN-UAF': '9026',
 'HTTP:STC:SAFARI:WEBKIT-ELEMENTS': '9027',
 'HTTP:STC:SAFARI:WEBKIT-LIBXSLT': '9028',
 'HTTP:STC:SCRIPT:MSF-JSOBFU-NEW': '9029',
 'HTTP:STC:SCRIPT:SVL-DBL-FREE': '9030',
 'HTTP:STC:STREAM:GDI-WMF-HEADER': '9031',
 'HTTP:STC:STREAM:MAL-MEDIA': '9032',
 'HTTP:STC:STREAM:REAL-MP4-MEM': '9033',
 'HTTP:STC:SWF:ACTIONTAG': '9034',
 'HTTP:STC:SWF:AS-POOL': '9035',
 'HTTP:STC:SWF:BYTEARRAY': '9036',
 'HTTP:STC:SWF:FLASH-DEFINEFONT': '9037',
 'HTTP:STC:SWF:FLASH-MEM-CORRUPT': '9038',
 'HTTP:STC:SWF:FLASH-RTMP-RESP': '9039',
 'HTTP:STC:SWF:FLASH-SALIGN': '9040',
 'HTTP:STC:SWF:HEADER-MEM-RCE': '9041',
 'HTTP:STC:SWF:KEY-PRESS-EVENT': '9042',
 'HTTP:STC:SWF:PLACEOBJX': '9043',
 'HTTP:STC:SWF:REC-S-OF': '9044',
 'HTTP:STC:SWF:RESOURCEMODULEURLS': '9045',
 'HTTP:STC:SWF:SIZE-MIS': '9046',
 'HTTP:STC:SWF:STAGE3D': '9047',
 'HTTP:STC:SWF:TEXT-IOF': '9048',
 'HTTP:STC:SWF:UNDEF-NS': '9049',
 'HTTP:STC:SWF:URL-SEC-DOM-RCE': '9050',
 'HTTP:STC:VULN:OSX-UPDATE': '9051',
 'HTTP:STC:VULN:TAG-BDO': '9052',
 'HTTP:STC:WIN32KSYS-MEM': '9053',
 'HTTP:STC:WINDOWS-HYPERLINK': '9054',
 'HTTP:STC:WIRESHARK-INSECUREPATH': '9055',
 'HTTP:STREAM:MAGIX-OF': '9056',
 'HTTP:TOMCAT:URL-ENC-DIRTRAV': '9057',
 'HTTP:UBIQUITI-AIROS-CE': '9058',
 'HTTP:WEBLOGIC:CONSOLE-HELP-PORT': '9059',
 'HTTP:WP-FGALLERY-MAL-FILE-HOST': '9060',
 'HTTP:WP-FGALLERY-MAL-FILE-POST': '9061',
 'HTTP:XSS:AXIS-M10-CAMERA': '9062',
 'HTTP:XSS:DYNAMICAX-PORTAL-XSS': '9063',
 'HTTP:XSS:OUTLOOK-WEB': '9064',
 'HTTP:XSS:SHAREPOINT-INPLVIEW': '9065',
 'HTTP:XSS:SHAREPOINT-LIST-XSS': '9066',
 'HTTP:XSS:SHAREPOINT-THEMEWEB': '9067',
 'HTTP:XSS:SHAREPOINT-USER': '9068',
 'HTTP:XSS:SHAREPOINT-WIZARDLIST': '9069',
 'HTTP:XSS:SYMANTEC-WG': '9070',
 'LDAP:NA-PGP-KEYSERVER-OF': '9071',
 'LDAP:OVERFLOW:IMAIL-ASN-1': '9072',
 'LDAP:OVERFLOW:MS-DIR-LEAK-MC': '9073',
 'LPD:LDP-CMD-INJ': '9074',
 'LPD:MSF-CASCADE-JOB-REQ': '9075',
 'NDMP:SHORT-MSG': '9076',
 'NETBIOS:OVERFLOW:ASN-1-BER': '9077',
 'NETBIOS:WINS:REPLICATION-PTR': '9078',
 'NETBIOS:WINS:REPLICATION-PTR-U': '9079',
 'P2P:BITTORRENT:UTORRENT-UDP': '9080',
 'POP3:OVERFLOW:AXIGEN-FS': '9081',
 'PORTMAPPER:GETADDR-RESP-MAL-UA': '9082',
 'RADIUS:FREERADIUS-DOS': '9083',
 'RPC:SUN-SOLARIS-SADMIND-ADM': '9084',
 'SCADA:DEQFACTORY-NETB': '9085',
 'SCADA:ICONICS-GENBROKER': '9086',
 'SCADA:SIEMENS-CSSERVICE-BOF': '9087',
 'SCADA:SIEMENS-TECHNO-VRN-OF': '9088',
 'SCADA:WELLINTECH-KINGVIEW-BO': '9089',
 'SCAN:AMAP:FTP-SCAN': '9090',
 'SCAN:CANVAS:HELIUM-AGENT': '9091',
 'SCAN:DIRBUSTER-UA': '9092',
 'SCAN:METASPLOIT:JAVA-APPLET': '9093',
 'SCAN:MISC:HTTP:HEAD': '9094',
 'SCAN:MISC:HTTP:NETCAT-CMD': '9095',
 'SCAN:NEXPOSE:SNMP-PROBE': '9096',
 'SCAN:NEXPOSE:SQLD-PROBE': '9097',
 'SCAN:NEXPOSE:TFTP-PROBE': '9098',
 'SHELLCODE:METASPLOIT:GREENDAM': '9099',
 'SHELLCODE:METASPLOIT:JAVA-APP': '9100',
 'SHELLCODE:METASPLOIT:JAVA-JAR': '9101',
 'SMB:EXPLOIT:FLASH-CHROME-BREAK': '9102',
 'SMB:FILE:MS-OBJ-PACKAGER': '9103',
 'SMB:FILE:NAME-INV-CHARS': '9104',
 'SMB:FILE:WIRESHARK-INSECUREPATH': '9105',
 'SMB:SAMBA:IDL-PARSE-OOB': '9106',
 'SMTP:DOS:MS-MALWARE-ENGINE': '9107',
 'SSL:OPENSSL-FLOOD': '9108',
 'TELNET:DOS:GAMSOFT': '9109',
 'TELNET:EXPLOIT:MS-CREDENTIAL': '9110',
 'TELNET:OVERFLOW:BSD-ENCRY-KEYID': '9111',
 'TROJAN:ALDIBOT-DETECTION': '9112',
 'TROJAN:BACKORIFICE:CONN-REQ': '9113',
 'TROJAN:CFM-UFO': '9114',
 'TROJAN:EBURY-DNS-EXFILTRATION': '9115',
 'TROJAN:OSX-DNS-CHANGER': '9116',
 'TROJAN:SPYEYE-BEACON': '9117',
 'TROJAN:WIPER-FLAME-POST-EXFIL': '9118',
 'TROJAN:WIPER-FLAME-UPDATE': '9119',
 'VNC:ULTRA-CLIENT-OF': '9120',
 'VOIP:SKYPE:CONNECTION': '9121',
 'WORM:STATS-PHP-IFRAME': '9122',
 'Gaming:Protocols:BATTLE-NET': '9123',
 'Gaming:Protocols:DIABLO3': '9124',
 'Gaming:Protocols:GAMECENTER': '9125',
 'Gaming:Protocols:GAMECENTER-SSL': '9126',
 'Gaming:Protocols:PS3-APPLICATION': '9127',
 'Gaming:Protocols:PS3-CHAT': '9128',
 'Gaming:Protocols:PS3-PSN-COMMUNITY': '9129',
 'Gaming:Protocols:PS3-UPDATE': '9130',
 'Gaming:Protocols:STARCRAFT2': '9131',
 'Gaming:Protocols:WARCRAFT3-JOIN': '9132',
 'Gaming:Protocols:WARCRAFT3-LAN': '9133',
 'Gaming:Protocols:WII': '9134',
 'Gaming:Protocols:WORLD-OF-WARCRAFT': '9135',
 'Gaming:Protocols:XBOX-HTTP': '9136',
 'Gaming:Protocols:XBOX-LIVE': '9137',
 'Gaming:Web-Based:DOOF': '9138',
 'Gaming:Web-Based:FRIENDSTER': '9139',
 'Gaming:Web-Based:GAMESDOTCOM': '9140',
 'Gaming:Web-Based:HABBO': '9141',
 'Gaming:Web-Based:HABBO-HTTP': '9142',
 'Gaming:Web-Based:HABBO-SSL': '9143',
 'Gaming:Web-Based:QQGAMES-2-TCP': '9144',
 'Gaming:Web-Based:QQGAMES-HTTP': '9145',
 'Gaming:Web-Based:QQGAMES-TCP': '9146',
 'Gaming:Web-Based:QQGAMES-UDP': '9147',
 'Gaming:Web-Based:WORDSWITHFRIENDS': '9148',
 'Gaming:Web-Based:XBOX-LIVE-HTTP': '9149',
 'Gaming:Web-Based:XBOX-LIVE-MARKETPLACE': '9150',
 'Gaming:Web-Based:XBOX-LIVE-SSL': '9151',
 'Gaming:Web-Based:XFIRE-SSL': '9152',
 'Gaming:Web-Based:XFIRE-UDP': '9153',
 'Gaming:Web-Based:ZYNGA': '9154',
 'Infrastructure:Database:MONGODB': '9155',
 'Infrastructure:Encryption:SPDY': '9156',
 'Infrastructure:File-Servers:AFP': '9157',
 'Infrastructure:File-Servers:ICLOUD': '9158',
 'Infrastructure:Mobile:ACTIVESYNC': '9159',
 'Infrastructure:Mobile:SYNCML': '9160',
 'Infrastructure:Monitoring:NSM-MGMT': '9161',
 'Infrastructure:RPC:RPC': '9162',
 'Infrastructure:Software-Update:SOPHOS-ANTIVIRUS-UPDATE': '9163',
 'Messaging:Instant-Messaging:AIM-PROXY': '9164',
 'Messaging:Instant-Messaging:APPLE-PUSH': '9165',
 'Messaging:Instant-Messaging:FACEBOOK-MOBILE-CHAT': '9166',
 'Messaging:Instant-Messaging:GOOGLE-WEBCHAT': '9167',
 'Messaging:Instant-Messaging:GOOGLETALK': '9168',
 'Messaging:Instant-Messaging:HIPCHAT': '9169',
 'Messaging:Instant-Messaging:KAKAOTALK': '9170',
 'Messaging:Instant-Messaging:KAKAOTALK-SSL': '9171',
 'Messaging:Instant-Messaging:KIK': '9172',
 'Messaging:Instant-Messaging:KOOLIM': '9173',
 'Messaging:Instant-Messaging:LIVEGO': '9174',
 'Messaging:Instant-Messaging:LYNC-ONLINE': '9175',
 'Messaging:Instant-Messaging:MSN-FILE-TRANSFER-SSL': '9176',
 'Messaging:Instant-Messaging:MSN-OVER-HTTP': '9177',
 'Messaging:Instant-Messaging:MSN-VOICE-CHAT': '9178',
 'Messaging:Instant-Messaging:MSN-VOICE-OVER-SSL': '9179',
 'Messaging:Instant-Messaging:NATEON-LOGIN': '9180',
 'Messaging:Instant-Messaging:NATEON-MOBILE-SSL': '9181',
 'Messaging:Instant-Messaging:NIMBUZZ-MOBILE': '9182',
 'Messaging:Instant-Messaging:PALTALK-TCP': '9183',
 'Messaging:Instant-Messaging:PLUS-IM': '9184',
 'Messaging:Instant-Messaging:POPO163-LOGIN': '9185',
 'Messaging:Instant-Messaging:POPO163-P2P': '9186',
 'Messaging:Instant-Messaging:VIBER-HTTP': '9187',
 'Messaging:Instant-Messaging:VIBER-TCP': '9188',
 'Messaging:Instant-Messaging:VIBER-UDP': '9189',
 'Messaging:Instant-Messaging:WHATSAPP-SSL': '9190',
 'Messaging:Instant-Messaging:WHATSAPP-TCP': '9191',
 'Messaging:Instant-Messaging:YAHOO-MESSENGER-MOBILE': '9192',
 'Messaging:Instant-Messaging:YAHOO-MOBILE-FILE-TRANSFER': '9193',
 'Messaging:Instant-Messaging:YAHOO-VOICE': '9194',
 'Messaging:Mail:IMAP-TLS': '9195',
 'Messaging:Mail:MAILDOTCOM-SSL': '9196',
 'Messaging:Mail:MICROSOFT-EXCHANGE': '9197',
 'Messaging:Mail:SMTP-TLS': '9198',
 'Messaging:Mail:SQUIRRELMAIL': '9199',
 'Multimedia:Adult:XXX-TLD': '9200',
 'Multimedia:Audio-Streaming:SPOTIFY-SSL': '9201',
 'Multimedia:Audio-Streaming:SPOTIFY-TCP': '9202',
 'Multimedia:Audio-Streaming:SPOTIFY-UDP': '9203',
 'Multimedia:Transport:RDT': '9204',
 'Multimedia:Transport:SHOUTCAST': '9205',
 'Multimedia:Video-Streaming:BLIP-TV-STREAM': '9206',
 'Multimedia:Video-Streaming:CLOUDBROWSE': '9207',
 'Multimedia:Video-Streaming:DAILYMOTION-UPLOAD': '9208',
 'Multimedia:Video-Streaming:DAILYMOTION-VIDEO-STREAM': '9209',
 'Multimedia:Video-Streaming:ENGAGEMEDIA-STREAM': '9210',
 'Multimedia:Video-Streaming:FACEBOOK-VIDEO-STREAM': '9211',
 'Multimedia:Video-Streaming:GRABOID': '9212',
 'Multimedia:Video-Streaming:GRABOID-SSL': '9213',
 'Multimedia:Video-Streaming:INTERNET-ARCHIVE-UPLOAD': '9214',
 'Multimedia:Video-Streaming:INTERNET-ARCHIVE-VIDEO-STREAM': '9215',
 'Multimedia:Video-Streaming:NICONICO-DOUGA-STREAM': '9216',
 'Multimedia:Video-Streaming:NICONICO-DOUGA-UPLOAD': '9217',
 'Multimedia:Video-Streaming:OOVOO-SSL': '9218',
 'Multimedia:Video-Streaming:OOVOO-UDP': '9219',
 'Multimedia:Video-Streaming:OPENFILM-STREAM': '9220',
 'Multimedia:Video-Streaming:PIPI-PLAYER': '9221',
 'Multimedia:Video-Streaming:PIPI-PLAYER-AGENT': '9222',
 'Multimedia:Video-Streaming:PIPI-PLAYER-COOKIE': '9223',
 'Multimedia:Video-Streaming:PPLIVE-UDP': '9224',
 'Multimedia:Video-Streaming:PPSTREAM-1-UDP': '9225',
 'Multimedia:Video-Streaming:PPSTREAM-2-UDP': '9226',
 'Multimedia:Video-Streaming:PPSTREAM-3-UDP': '9227',
 'Multimedia:Video-Streaming:PPSTREAM-4-UDP': '9228',
 'Multimedia:Video-Streaming:QVOD-PLAYER-TCP': '9229',
 'Multimedia:Video-Streaming:QVOD-PLAYER-UDP': '9230',
 'Multimedia:Video-Streaming:SOPCAST': '9231',
 'Multimedia:Video-Streaming:SOPCAST-HTTP': '9232',
 'Multimedia:Video-Streaming:TVUPLAYER-AGENT': '9233',
 'Multimedia:Video-Streaming:TVUPLAYER-SSL': '9234',
 'Multimedia:Video-Streaming:TVUPLAYER-TCP': '9235',
 'Multimedia:Video-Streaming:TVUPLAYER-UDP': '9236',
 'Multimedia:Video-Streaming:UUSEE-2-UDP': '9237',
 'Multimedia:Video-Streaming:UUSEE-UDP': '9238',
 'Multimedia:Video-Streaming:VEETLE': '9239',
 'Multimedia:Video-Streaming:VEETLE-COOKIE': '9240',
 'Multimedia:Video-Streaming:VEOH-STREAM': '9241',
 'Multimedia:Video-Streaming:WINDOWS-MEDIA-PLAYER-STREAM': '9242',
 'Multimedia:Video-Streaming:ZATTOO': '9243',
 'Multimedia:Video-Streaming:ZATTOO-HTTP': '9244',
 'Multimedia:Video-Streaming:ZATTOO-SSL': '9245',
 'Multimedia:Web-Based:AOL-VIDEO': '9246',
 'Multimedia:Web-Based:GOOGLE-VIDEOS': '9247',
 'Multimedia:Web-Based:GROOVESHARK-STREAMING-SSL': '9248',
 'Multimedia:Web-Based:HTTP-VIDEO': '9249',
 'Multimedia:Web-Based:JANGO': '9250',
 'Multimedia:Web-Based:JANGO-SSL': '9251',
 'Multimedia:Web-Based:LIVEFLASH': '9252',
 'Multimedia:Web-Based:LIVEVIEW365': '9253',
 'Multimedia:Web-Based:MIXCLOUD': '9254',
 'Multimedia:Web-Based:MIXCLOUD-SSL': '9255',
 'Multimedia:Web-Based:MOG': '9256',
 'Multimedia:Web-Based:MOG-SSL': '9257',
 'Multimedia:Web-Based:NETFLIX': '9258',
 'Multimedia:Web-Based:PDF': '9259',
 'Multimedia:Web-Based:STEREOMOOD': '9260',
 'Multimedia:Web-Based:TED': '9261',
 'Multimedia:Web-Based:VEOHTV-SSL': '9262',
 'Multimedia:Web-Based:WE7-SSL': '9263',
 'P2P:File-Sharing:BEARSHARE': '9264',
 'P2P:File-Sharing:BEARSHARE-SSL': '9265',
 'P2P:File-Sharing:BITTORRENT-DHT4': '9266',
 'P2P:File-Sharing:EDONKEY-FILE-PART': '9267',
 'P2P:File-Sharing:EDONKEY-FILE-REQUEST': '9268',
 'P2P:File-Sharing:FILETOPIA': '9269',
 'P2P:File-Sharing:IMESH': '9270',
 'P2P:File-Sharing:IMESH-HTTP': '9271',
 'P2P:File-Sharing:IMESH-SSL': '9272',
 'P2P:File-Sharing:NATEON-FILE-TRANSFER': '9273',
 'P2P:File-Sharing:PANDO-TCP': '9274',
 'P2P:File-Sharing:PANDO-UDP': '9275',
 'P2P:File-Sharing:TORRENT-FILE-HTTP-DOWNLOAD': '9276',
 'P2P:File-Sharing:VUZE-AGENT': '9277',
 'P2P:File-Sharing:VUZE-HTTP': '9278',
 'Remote-Access:Interactive-Desktop:GOTOMYPC-SSL': '9279',
 'Remote-Access:Interactive-Desktop:GOTOMYPC-WEB': '9280',
 'Remote-Access:Interactive-Desktop:JOIN.ME': '9281',
 'Remote-Access:Interactive-Desktop:LOGMEIN': '9282',
 'Remote-Access:Interactive-Desktop:NETVIEWER': '9283',
 'Remote-Access:Tunneling:OZYMAN-DNS-TUNNEL': '9284',
 'Social-Networking:Applications:2CH': '9285',
 'Social-Networking:Applications:BEBO-COMMENT-POST': '9286',
 'Social-Networking:Applications:BUZZFEED': '9287',
 'Social-Networking:Applications:DIASPORA-HTTP': '9288',
 'Social-Networking:Applications:DIGLO': '9289',
 'Social-Networking:Applications:FOTOLOG-UPLOAD': '9290',
 'Social-Networking:Applications:LOCKERZ': '9291',
 'Social-Networking:Applications:ORKUT-USER-ACTIVITY': '9292',
 'Social-Networking:Applications:SCRIBD': '9293',
 'Social-Networking:Applications:TURNTABLEFM': '9294',
 'Social-Networking:Applications:VK-POST': '9295',
 'Social-Networking:Applications:VK-UPLOAD': '9296',
 'Social-Networking:Business:RYPPLE': '9297',
 'Social-Networking:Business:RYPPLE-HTTP': '9298',
 'Social-Networking:Business:YAMMER': '9299',
 'Social-Networking:Facebook:FACEBOOK-APPLICATIONBUILDER': '9300',
 'Social-Networking:Facebook:FACEBOOK-BIGPHOTO': '9301',
 'Social-Networking:Facebook:FACEBOOK-BUMPERSTICKER': '9302',
 'Social-Networking:Facebook:FACEBOOK-CARICATURE': '9303',
 'Social-Networking:Facebook:FACEBOOK-CAUSES': '9304',
 'Social-Networking:Facebook:FACEBOOK-CIRCLEOFMOMS': '9305',
 'Social-Networking:Facebook:FACEBOOK-COLLECTHEARTS': '9306',
 'Social-Networking:Facebook:FACEBOOK-CONTESTS': '9307',
 'Social-Networking:Facebook:FACEBOOK-DAILYHOROSCOPE': '9308',
 'Social-Networking:Facebook:FACEBOOK-DECORATIVEWRITING': '9309',
 'Social-Networking:Facebook:FACEBOOK-DOGBOOK': '9310',
 'Social-Networking:Facebook:FACEBOOK-EXTENDEDINFO': '9311',
 'Social-Networking:Facebook:FACEBOOK-FAMILYLINK': '9312',
 'Social-Networking:Facebook:FACEBOOK-FAMILYTREE': '9313',
 'Social-Networking:Facebook:FACEBOOK-FARMVILLE': '9314',
 'Social-Networking:Facebook:FACEBOOK-FLIXSTER': '9315',
 'Social-Networking:Facebook:FACEBOOK-FRASESDIARIAS': '9316',
 'Social-Networking:Facebook:FACEBOOK-FUNNYPHOTO': '9317',
 'Social-Networking:Facebook:FACEBOOK-GALLETASDELAFORTUNA': '9318',
 'Social-Networking:Facebook:FACEBOOK-GODWANTSYOUTOKNOW': '9319',
 'Social-Networking:Facebook:FACEBOOK-HALLMARKSOCIALCALENDAR': '9320',
 'Social-Networking:Facebook:FACEBOOK-HONESTYBOX': '9321',
 'Social-Networking:Facebook:FACEBOOK-HUGGED': '9322',
 'Social-Networking:Facebook:FACEBOOK-ICAST': '9323',
 'Social-Networking:Facebook:FACEBOOK-IKARMA': '9324',
 'Social-Networking:Facebook:FACEBOOK-ILIKE-MUSIC': '9325',
 'Social-Networking:Facebook:FACEBOOK-ILIKETHISARTIST': '9326',
 'Social-Networking:Facebook:FACEBOOK-MARKETPLACE': '9327',
 'Social-Networking:Facebook:FACEBOOK-MIXPODMUSIC': '9328',
 'Social-Networking:Facebook:FACEBOOK-MYARABICNAME': '9329',
 'Social-Networking:Facebook:FACEBOOK-MYBAND': '9330',
 'Social-Networking:Facebook:FACEBOOK-MYBESTFRIENDS': '9331',
 'Social-Networking:Facebook:FACEBOOK-MYPERSONALITY': '9332',
 'Social-Networking:Facebook:FACEBOOK-MYTOPFANS': '9333',
 'Social-Networking:Facebook:FACEBOOK-NETWORKEDBLOGS': '9334',
 'Social-Networking:Facebook:FACEBOOK-PHOTOOFTHEDAY': '9335',
 'Social-Networking:Facebook:FACEBOOK-PICNIK': '9336',
 'Social-Networking:Facebook:FACEBOOK-PROFILEBOX': '9337',
 'Social-Networking:Facebook:FACEBOOK-PROFILEHTML': '9338',
 'Social-Networking:Facebook:FACEBOOK-QUIZMONSTER': '9339',
 'Social-Networking:Facebook:FACEBOOK-ROCKYOULIVE': '9340',
 'Social-Networking:Facebook:FACEBOOK-SKETCHME': '9341',
 'Social-Networking:Facebook:FACEBOOK-SLIDEFUNSPACE': '9342',
 'Social-Networking:Facebook:FACEBOOK-SUPERPOKE': '9343',
 'Social-Networking:Facebook:FACEBOOK-SWEEPSTAKES': '9344',
 'Social-Networking:Facebook:FACEBOOK-TOPFRIENDS': '9345',
 'Social-Networking:Facebook:FACEBOOK-UPLOAD': '9346',
 'Social-Networking:Facebook:FACEBOOK-WELCOMETAB': '9347',
 'Social-Networking:Facebook:FACEBOOK-WINDOWSLIVEMESSENGER': '9348',
 'Social-Networking:Facebook:FACEBOOK-YOURJAPANESENAME': '9349',
 'Social-Networking:Facebook:FACEBOOK-YOUTUBEVIDEOBOX': '9350',
 'Social-Networking:Facebook:FACEBOOK-ZOOSK': '9351',
 'Social-Networking:Linkedin:LINKEDIN-POST': '9352',
 'Social-Networking:Myspace:MYSPACE-STATUS-UPDATE': '9353',
 'Social-Networking:Myspace:MYSPACE-UPLOAD': '9354',
 'Social-Networking:TWITTER-UPDATE': '9355',
 'Web:Anonymizer:PROXYDOTORG': '9356',
 'Web:Applications:ACROBAT-CONFERENCE': '9357',
 'Web:Applications:ACROBAT-ONLINE': '9358',
 'Web:Applications:ADOBE-CONNECT': '9359',
 'Web:Applications:AMOEBAOS': '9360',
 'Web:Applications:ANDROID-MARKETPLACE-DOWNLOAD': '9361',
 'Web:Applications:ANIMOTO-SSL': '9362',
 'Web:Applications:ATOM': '9363',
 'Web:Applications:BACKPACK-SSL': '9364',
 'Web:Applications:BEAMYOURSCREEN': '9365',
 'Web:Applications:BLACKBOARD': '9366',
 'Web:Applications:FRING-HTTP': '9367',
 'Web:Applications:FRING-SSL': '9368',
 'Web:Applications:FRING-TCP': '9369',
 'Web:Applications:FRING-UDP': '9370',
 'Web:Applications:JAJAH-WEB': '9371',
 'Web:Applications:LIVE-SKYDRIVE-SSL': '9372',
 'Web:Applications:OFFICE365': '9373',
 'Web:Applications:OUTLOOK-LIVE': '9374',
 'Web:Applications:RSS': '9375',
 'Web:Applications:SALESFORCE-SSL': '9376',
 'Web:Applications:SHAREPOINT': '9377',
 'Web:Applications:SHAREPOINT-ONLINE': '9378',
 'Web:Applications:ZOHO-SSL': '9379',
 'Web:Blogging:TUMBLR': '9380',
 'Web:Blogging:TUMBLR-POST': '9381',
 'Web:Blogging:TUMBLR-SSL': '9382',
 'Web:Blogging:TUMBLR-UPLOAD': '9383',
 'Web:File-Sharing:ACROBAT-FILE-TRANSFER': '9384',
 'Web:File-Sharing:ACROBAT-SENDNOW': '9385',
 'Web:File-Sharing:ADRIVE-SSL': '9386',
 'Web:File-Sharing:CARBONITE': '9387',
 'Web:File-Sharing:CLIP2NET-UPLOAD': '9388',
 'Web:File-Sharing:COMPRESSED-FILE': '9389',
 'Web:File-Sharing:CROCKO': '9390',
 'Web:File-Sharing:DOWN2CRAZY': '9391',
 'Web:File-Sharing:DROPBOX': '9392',
 'Web:File-Sharing:DROPSEND': '9393',
 'Web:File-Sharing:DROPSEND-SSL': '9394',
 'Web:File-Sharing:FLIPDRIVE-SSL': '9395',
 'Web:File-Sharing:GOBOOGY-TCP': '9396',
 'Web:File-Sharing:GOOGLE-DRIVE': '9397',
 'Web:File-Sharing:GYGAN-HTTP': '9398',
 'Web:File-Sharing:GYGAN-NNTP': '9399',
 'Web:File-Sharing:MAILDOTCOM-FILE-STORAGE': '9400',
 'Web:File-Sharing:MOZY-SSL': '9401',
 'Web:File-Sharing:PANDO': '9402',
 'Web:File-Sharing:PANDO-SSL': '9403',
 'Web:File-Sharing:SLIDESHARE': '9404',
 'Web:File-Sharing:SLIDESHARE-SSL': '9405',
 'Web:File-Sharing:SPIDEROAK': '9406',
 'Web:File-Sharing:SUGARSYNC': '9407',
 'Web:File-Sharing:SUGARSYNC-SSL': '9408',
 'Web:File-Sharing:SYNCPLICITY': '9409',
 'Web:File-Sharing:WETRANSFER': '9410',
 'Web:File-Sharing:WETRANSFER-SSL': '9411',
 'Web:File-Sharing:YOUSENDIT-SSL': '9412',
 'Web:File-Sharing:ZUMODRIVE': '9413',
 'Web:Finance:MONEYCONTROL': '9414',
 'Web:Finance:MORNINGSTAR': '9415',
 'Web:Finance:MSN-MONEY-POST': '9416',
 'Web:Finance:NSEINDIA': '9417',
 'Web:Finance:RAGINGBULL-POST': '9418',
 'Web:Finance:YAHOO-FINANCE': '9419',
 'Web:Finance:YAHOO-FINANCE-POST': '9420',
 'Web:Forums:AOL-ANSWERS': '9421',
 'Web:Forums:AOL-ANSWERS-POST': '9422',
 'Web:Forums:SULEKHA': '9423',
 'Web:Image-Sharing:FLICKR-UPLOAD': '9424',
 'Web:Image-Sharing:INSTAGRAM': '9425',
 'Web:Image-Sharing:SHUTTERFLY': '9426',
 'Web:Image-Sharing:SHUTTERFLY-FILE-UPLOAD': '9427',
 'Web:Image-Sharing:SMUGMUG-SSL': '9428',
 'Web:News:REDDIT': '9429',
 'Web:Portal:GOOGLE': '9430',
 'Web:Portal:HINDUSTANTIMES': '9431',
 'Web:Portal:IN': '9432',
 'Web:Real-Estate:99ACRES': '9433',
 'Web:Real-Estate:MAGICBRICKS': '9434',
 'Web:Search:FAROO-SEACRH': '9435',
 'Web:Search:IMDB': '9436',
 'Web:Search:JUSTDIAL': '9437',
 'Web:Search:TIMESJOBS': '9438',
 'Web:Shopping:AMAZON-SSL': '9439',
 'Web:Shopping:FLIPKART': '9440',
 'Web:Shopping:GROUPON': '9441',
 'Web:Shopping:SNAPDEAL': '9442',
 'Web:Travel:CLEARTRIP': '9443',
 'Web:Travel:IRCTC': '9444',
 'Web:Travel:MAKEMYTRIP': '9445',
 'Web:Travel:YATRA': '9446',
}
