# -*- coding: utf-8 -*-
#
# License:
#
#    Copyright (c) 2003-2006 ossim.net
#    Copyright (c) 2007-2014 AlienVault
#    All rights reserved.
#
#    This package is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; version 2 dated June, 1991.
#    You may not use, modify or distribute this program under any other version
#    of the GNU General Public License.
#
#    This package is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this package; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
#    MA  02110-1301  USA
#
#
# On Debian GNU/Linux systems, the complete text of the GNU General
# Public License can be found in `/usr/share/common-licenses/GPL-2'.
#
# Otherwise you can read it here: http://www.gnu.org/licenses/gpl-2.0.txt
#

#
# GLOBAL CONSTANTS
#

ISS_SITEPROTECTOR_SID_TRANSLATION_MAP = {
    'spyware-clariaweatherscope':'12491',
    'MSRPC_Registry_Write_aedebug':'2003207',
    'spyware-adplus-surferbar':'12436',
    'rpc-dcom-scan':'10873',
    'iis-percent-evasion':'4973',
    'SMTP corrupted RCPT command':'11807',
    'SSH_connection_from_host_not_allowed':'13038',
    'xfree-xlib-bo':'15216',
    'w3cxml-xmld-spoofing':'5900002',
    'HTTP CONNECTION_ field overflow':'3488',
    'rhel-rhsa-2007-1030-update':'10436',
    'RTSP_Helix_SetParameter_Overflow':'5900002',
    'win-netdde-bo':'14802',
    'rhel-rhsa-2005-474-update':'9955',
    'Finger_User':'2001101',
    'HTML_JS_Dialog_Delay':'2121041',
    'spyeye-trojan-detected':'5900002',
    'SSH_Kerberos_password_auth._failed':'13047',
    'spyware-cashback':'12481',
    'router-perimeter':'10844',
    'awstats-plugin-command-execution':'637',
    'ie-iframe-src-name-bo':'4774',
    'IRC_Privmsg_Prefix_Overflow':'5900002',
    'rhel-rhsa-2005-061-update':'9829',
    'win-ms04014-patch':'14406',
    'imageshack-toolbar-code-execution':'5900002',
    'postgresql-security-bypass':'9075',
    'ie-local-resource-xss':'4788',
    'CGI_test-cgi':'1209',
    'mozilla-firefox-textbox-file-access':'7077',
    'HTTP asp with . Appended':'3482',
    'MSRPC_MSMQ_Overflow':'2110086',
    'symantec-intel-ams2-bo':'5900002',
    'http-suspicious-unknown-content':'5900002',
    'FTP_GlobalScape_Overflow':'2113213',
    'lurawave-jp2-qcd-bo':'5900002',
    'TCP_Connections_Open_Flood':'5900002',
    'Email_ReplyTo_IpSwitch_DoS':'5900002',
    'filesgrabbed':'2569',
    'rhel-rhsa-2005-068-update':'9832',
    'HTTP_SharePoint_Script':'2113177',
    'HostControl':'3290',
    'toolbar-imageshacktoolbar-info-disclosure':'13735',
    'zone-java-scripting':'15385',
    'nfs-dfstab-share':'7796',
    'HTTP_Domino_HPRAgentName_Overflow':'5900002',
    'HTTP_Watchfire_AppScan_Detected':'4484',
    'win-ms12kb2685939-update':'5900002',
    'iis-cmdasp-gain-privs':'4920',
    'IP_Duplicate':'2002301',
    'HTTP_Cisco_Packet_Tracer_DLL_Hijacking':'5900002',
    'vmware-isapi-extension-dos':'5900002',
    'HostControl_Response':'2001560',
    'fetchmail-null-pointer-dos':'2453',
    'word-document-code-execution':'15149',
    'rhel-rhsa-2007-0731-update':'10365',
    'HTTP_GET_data_overflow':'3941',
    'guptachar-backdoor':'3226',
    'DHCP_Ack':'1798',
    'HTTP_Mozilla_Domain_Name_Overflow':'2106201',
    'Failed_login-account_disabled':'2422',
    'Cold Fusion Sample URL':'1386',
    'helix-dna-describe-bo':'3266',
    'irc-automated-client':'5374',
    'rhel-rhsa-bind-named-service-dos':'10682',
    'malcode-SPPE_DO_Exec_Serv':'6666',
    'gnome-imaprescan-code-execution':'3125',
    'malcode-rexx_20':'6478',
    'malcode-rexx_22':'6480',
    'aol-superbuddy-activex-code-exec':'385',
    'graphedit-measure-dll-ce':'5900002',
    'SMTP_mail_to_uudecode_alias':'11917',
    'SMB passwd file':'11709',
    'RFParalyze_exploit':'9504',
    'symantec-autofixtool-code-execution':'13305',
    'telnet-auth-kerb5':'13526',
    'telnet-auth-kerb4':'13525',
    'sendmail-queue-dos':'11507',
    'PHP CGI overflow':'8849',
    'spyware-idgsearch':'12601',
    'LPD_SAP_Overflow':'5900002',
    'boep-locator':'953',
    'weblogic-running':'14241',
    'xsane-temp-symlink':'15281',
    'RTSP_WMP_Vulnerable_SPN_Op':'2124047',
    'HTTP_HOST_Overflow':'2000636',
    'spyware-boonpie':'12469',
    'Disk_space_shortage':'1828',
    'rhel-rhsa-2008-0847-update':'10586',
    'rhel-rhsa-2005-092-update':'9842',
    'wonderwarewwcabfile-open-bo':'5900002',
    'ftp-chmod':'2832',
    'Telnet RESOLV_HOST_CONF':'13521',
    'gtp-c-err-system-failure':'3201',
    'nt-group-service':'8105',
    'Remote_user_login':'9473',
    'PmapProxy':'2001725',
    'HTTP_TDL4_Botnet_CnC':'5900002',
    'http-website-uploader':'3714',
    'MSRPC_ARCserver_TapeEngine_CallFunction':'2118093',
    'malcode-SpawnDebugOrFtp':'6532',
    'MSM_GenericWarning':'7261',
    'HTML_Net_Virtual_Method_Delegate':'5900002',
    'IKE_main_mode_association_ended':'5036',
    'Exploiter_TCP_Response':'2120005',
    'EZMall_data_URL':'2408',
    'dfch-backdoor':'1784',
    'ICMP flood':'4594',
    'rhel-rhsa-2007-0932-update':'10399',
    'ie-layout-code-execution':'4787',
    'adobe-acrobat-reader-bo':'109',
    'SMB_MailSlot_Heap_Overflow':'2110114',
    'winnt-file-management-dos':'15060',
    'rhel-rhsa-2005-103-update':'9847',
    'iis-isapi-filter-error-dos':'4956',
    'BackDoor2':'746',
    'ASN1_Mozilla_NSS_Parser_Overflow':'576',
    'HTTP_Zero_Hex_Code':'2000628',
    'HTTP_PHP_Transfer_XSS':'2118091',
    'mozilla-diskcache-information-disclosure':'7072',
    'HTTP_Content_Type_Overflow':'5900002',
    'http-dotdot':'3614',
    'spyware-Moneytree':'12646',
    'twiki-search-command-execution':'13819',
    'ie-active-content':'4679',
    'ntpd-remote-bo':'8393',
    'snmp-uint-overflow':'12121',
    'kerberos-kdc-krb5-udp-tcp-bo':'5900002',
    'rhel-rhsa-2006-0719-update':'10194',
    'HTTP_SGI_Handler':'2002516',
    'frozen-file-user-changed':'2777',
    'realplayer-smiltime-wallclockvalue-bo':'9368',
    'rhel-rhsa-2005-587-update':'9990',
    'CGI_csh':'1180',
    'win-ms07kb935840-update':'14589',
    'sip-message-termination-incorrect':'11628',
    'outlook-object-execute-script':'8688',
    'rsagent-mssql65-startup':'11078',
    'MGCP_LongField':'2104034',
    'HTTP_Connect_Overflow':'5900002',
    'IMAP2bis_server_anonymous_login_successful':'5141',
    'decod-dns-malformed':'1680',
    'spyware-funwebproducts':'12566',
    'ISS_Scan_UDP':'2001509',
    'radius-accounting-overflow':'9287',
    'Script_RTSP_MPEG4_MP4Prefix':'2122033',
    'evasion-fragroute-tcp-paws':'2228',
    'rhel-rhsa-2002-122-update':'9513',
    'SSH_DNS_spoofing_attack-reverse_mapping_different':'13042',
    'Add_SID_success':'90',
    'SIP_Content_Length_Mismatch':'2120067',
    'malcode-DisableFirewall':'6210',
    'ldap-message-malformed':'5900002',
    'peoplesoft-iclientservlet-file-upload':'8824',
    'FTP_SITE_EXEC_exploit':'3000',
    'ie-information-bar-bypass':'4780',
    'spyware-premiumconnect':'12695',
    'SSH2_Passwd_auth_failed_wrong_passwd':'13020',
    'rhel-rhsa-2005-828-update':'10051',
    'rhel-rhsa-2009-0205-update':'5900002',
    'HTTP_Napster_Installed':'4177',
    'winxp-rda-enabled':'15098',
    'PmapDump':'8972',
    'rhel-rhsa-2004-486-update':'9756',
    'bagle-worm':'786',
    'pine-from-header-dos':'8946',
    'rhel-rhsa-2012-0407-update':'5900002',
    'FTP Privileged Bounce':'2811',
    'openssl-mitm':'8494',
    'Audit_log_cleared':'605',
    'RMF_Invalid_MIDI_Controller':'5900002',
    'MS_name_lookup':'7238',
    'wuftp-mailadmin-sockprintf-bo':'15186',
    'HTTP_Flexi_ISN_Auth_Bypass':'3916',
    'snmpv3-hmac-security-bypass':'12303',
    'epolicy-orchestrator-running':'2185',
    'sip-blank-header-value':'11613',
    'fedora-ldap-security-bypass':'5900002',
    'SNMP_Crack':'2002002',
    'winamp-wsz-execute-code':'15015',
    'rhel-rhsa-2004-651-update':'9787',
    'aim-addexternalapp-bo':'162',
    'rhel-rhsa-2004-259-update':'9713',
    'openoffice-rtf-bo':'8458',
    'CompoundFile_Word_SmartTag_BO':'2114018',
    'TCP_Xmas_Scan':'2000308',
    'Backdoor2_Response':'747',
    'adobe-activex-dos':'113',
    'active-directory-dc-removal':'61',
    'win-ms10kb2424434-update':'5900002',
    'malcode-SPPE_DO_Wrt_ImpColiding':'6671',
    'DNS_Response_Second_Life':'1952',
    'rhel-rhsa-2006-0698-update':'10190',
    'Microsoft_SnaBase_Loop_DoS':'5900002',
    'Zero length IP option':'15363',
    'php-phphandleiff-dos':'8892',
    'LDAP_conn_denied_max_conn_exceeded':'5839',
    'Trin00_Daemon_Request':'2001524',
    'spyware-gohip':'12577',
    'rsagent-suspect-smtp':'11151',
    'malcode-MiscTroj0':'6373',
    'malcode-MiscTroj1':'6374',
    'Insane_Network_Backdoor':'2110014',
    'gateway-cweblaunchctl-command-execution':'3057',
    'rhel-rhsa-2002-302-update':'9555',
    'MSRPC_Admin_Access':'7301',
    'cmailserver-movetofolder-bo':'1368',
    'Inflate_Utilization_Statistics':'5900002',
    'HTTP_POST_SQL_Select_Top_1':'2110103',
    'rpc-nlog.pl CGI command':'10878',
    'malcode-ExeSeq22_DO':'6270',
    'malcode-ExeSeq54':'6296',
    'malcode-ExeSeq55':'6297',
    'dcforum-az-file-upload':'1655',
    'malcode-ExeSeq50':'6292',
    'rusersd-inetd':'11232',
    'passwd-invalid':'8734',
    'malcode-ExeSeq53':'6295',
    'Trojan_zwShell_CnC':'5900002',
    'spyware-findsex':'12559',
    'SubSeven_email':'13182',
    'tuxclientsystem-activex-code-execution':'5900002',
    'ms-directx-quartz-code-execution':'7174',
    'malcode-SPPE_WrtbleReloc_Misc':'6700',
    'sendmail-mail-relay':'11499',
    'Back_Orifice_2000_command':'651',
    'MSRPC_WebClient_Message_Bo':'2118055',
    'OTF_Sing_Overflow':'5900002',
    'CHM_Windows_Stack_Overflow':'5900002',
    'nessus-scan':'7666',
    'HTTP_Oracle_iSQL_Login_Overflow':'2120053',
    'IMAP4_password_overflow':'5162',
    'win-ms07kb939778-update':'14603',
    'EZshopper_loadpage_CGI':'2413',
    'Mapped_account_failed':'6934',
    'squirrelmail-webmail-xss':'12964',
    'Protos_H225_Attack_Tool':'2107000',
    'linux-utf8-incorrect-md5':'5984',
    'SMTP login failed':'11822',
    'iis-asp-chunked-encoding-bo':'4899',
    'yassl-processoldclienthello-bo':'5900002',
    'BrightStor_Discovery_TCP_Query_Overflow':'2106255',
    'decod-trin00-master-attempt':'1754',
    'rhel-rhsa-2005-215-update':'9876',
    'Image_JPEG_Tag_Overflow':'2107031',
    'win-ms11kb2510030-update':'5900002',
    'rhel-rhsa-2007-0127-update':'10260',
    'nt-maxage':'8181',
    'HTTP_IndexServer_Source_Disclosure':'2002575',
    'rhel-rhsa-2011-1196-update':'5900002',
    'HTTP_YaBB':'2002592',
    'lighttpd-modfastcgi-code-execution':'5910',
    'TFTP_win.ini_file':'13684',
    'admin-usage-app-log':'94',
    'quicktime-qtl-code-execution':'9243',
    'ca-brightstor-catirpc-dos':'1073',
    'telnet-bad-ifs':'13533',
    'windows-wins-replication-partner-bo':'15031',
    'quicktime-flic-file-malformed':'9221',
    'malcode-VB_Events':'6840',
    'win-ms08kb941644-update':'14622',
    'nmsdvdburning-nmsdvdx-file-overwrite':'7859',
    'Computer_account_deleted':'1468',
    'businessobjects-rptviewerax-bo':'1050',
    'javascript-unescape-regex':'5600',
    'msn-activex-information-disclosure':'7274',
    'solaris-idso-gain-privileges':'12377',
    'RPC_Amd_Pid':'2001740',
    'novell-iprint-ippcreateserverref-bo':'7929',
    'citrix-access-gateway-activex-bo':'5900002',
    'Veritas_NetBackup_VolumeMgr_Sscanf':'2113254',
    'HTTP_UltraOffice_ActiveX_BO':'2124035',
    'rhel-rhsa-2006-0680-update':'10185',
    'oo-stream-filestreams':'8443',
    'rhel-rhsa-2005-340-update':'9907',
    'srl-activex-javaapplet-code-execution':'12965',
    'HTTP_IE_HTML_Embed_Overflow':'2102057',
    'malcode-ExoticExeInternet':'6299',
    'file-mail-owned':'2522',
    'HTTP_WebLogic_FileServlet_ShowCode':'2106049',
    'cobalt-raq-remote-access':'1376',
    'IRC_Trinity_agent':'5407',
    'symantec-nbns-response-bo':'13312',
    'NT RASMAN Privilege Escalation attempt':'7952',
    'FTP Syst':'2824',
    'filsys-mountable-block':'2572',
    'iis-adsiis-activex-dos':'4897',
    'aztec-aztec-file-overwrite':'641',
    'SQL_Continuation_Packet_DoS':'5900002',
    'file-target-changed':'2551',
    'ospf-link-state-ack':'8643',
    'SNMP_CiscoMgmt_Ping':'2104015',
    'activex-detected':'81',
    'libc-realpath-offbyone-bo':'5868',
    'netscape-space-view':'7740',
    'clipart-cil-bo':'1360',
    'rhel-rhsa-2010-0076-update':'5900002',
    'win-ms06kb920214-update':'14519',
    'rhel-rhsa-2009-1582-update':'5900002',
    'rhel-rhsa-2008-0132-update':'10497',
    'user-login-pathname':'13981',
    'ie-type-object-bo':'4852',
    'wuftp-message-file-root':'15187',
    'win-ms08kb944533-update':'14628',
    'yahoo-assistant-ynotifier-code-execution':'15310',
    'veritasbackupexec-agent-browser-bo':'14078',
    'apache-modproxy-contentlength-bo':'454',
    'rhel-rhsa-2006-0579-update':'10149',
    'Echo_storm':'2041',
    'MSRPC_Registry_Request_DoS':'2110035',
    'nt-priv-fix':'8244',
    'win-ms10kb2447961-update':'5900002',
    'gnutella-download':'3145',
    'win-ms10kb2440591-update':'5900002',
    'HTTP_MSChartControl_Dir_Traversal':'5900002',
    'novell-edirectory-libnldap-bo':'7916',
    'reg-echo_CGI':'9396',
    'rhel-rhsa-2003-195-update':'9609',
    'nt-version-old':'8366',
    'kernel-version-detected':'5772',
    'backdoor-donald-dick':'682',
    'php-htmlentities-bo':'8865',
    'fpdb-wrong-owner':'2711',
    'http-cgi-nph':'3588',
    'win-ms09kb969462-update':'14728',
    's2-unarchive-check':'11246',
    'SNMP_passwd':'12254',
    'UDP_Probe_CharGen':'13847',
    'spyware-jajsoft-csrs':'12619',
    'rpc.automountd overflow':'10896',
    'HTTP_GET_SQL_WaitForDelay':'2113025',
    'Cabinet_Compression_Fault':'1088',
    'SMTP too many errors':'11840',
    'Rlogin -froot backdoor':'10794',
    'user-password-maxage-invalid':'14001',
    'http-cgi-cdomain':'3563',
    'nt-shutdown':'8310',
    'rhel-rhsa-2005-176-update':'9871',
    'BrightStor_Authentication_Overflow':'2109028',
    'nt-replace-token':'8281',
    'linux-ioperm-unauth-access':'5934',
    'Hvl_Rat':'4554',
    'integraxor-activex-directory-traversal':'5900002',
    'file-assert-code-execution':'2463',
    'TCP_Probe_POP3':'13445',
    'ca-multiple-antivirus-cofffiles-bo':'5900002',
    'remotely-anywhere-running':'9477',
    'HTTP_Second_Life_Authentication':'4367',
    'networker-unspec-bo':'5900002',
    'apache-modssl-htaccess-bo':'461',
    'iis-double-eval-evasion':'4926',
    'HTTP_Netscape_Enterprise_URI_Overflow':'4181',
    'sun-javawebstart-getvmargsoption-bo':'13213',
    'xmcd-envbo':'15240',
    'argent-office-udp-dos':'554',
    'db-activex-vimpx-file-overwrite':'1646',
    'Script_DTD_Domain_Load':'5900002',
    'crushftp-directory-traversal':'1549',
    'access-audit-events':'35',
    'Cart32_Clientlist_URL':'1108',
    'win-ms09kb963027-update':'14720',
    'malcode-SPPE_DO_Misc':'6667',
    'CompoundFile_Property_Error':'5900002',
    'flexiisn-interface-security-bypass':'2687',
    'rsagent-security-options-changed':'11105',
    'rhel-rhsa-2009-0015-update':'5900002',
    'ILOVEYOU_worm':'5043',
    'SNMP_Echo_Bounce':'2002019',
    'mssql-preauth-bo':'7420',
    'win-win32api-code-execution':'14876',
    'sun-jre-jdk-colorlibrary-dos':'13219',
    'rhel-rhsa-2011-0909-update':'5900002',
    'mysql-datadir-root-privileges':'7517',
    'HTTP_Realplayer_Chunked_Overflow':'2113248',
    'SNMP_UInt_Underflow':'2106097',
    'rhel-rhsa-2010-0337-update':'5900002',
    'exchange-imap-command-dos':'2285',
    'iplanet-search-view-files':'5315',
    'nt-maxage-onceonly':'8180',
    'blackice-license-expired':'919',
    'rhel-rhsa-2003-201-update':'9612',
    'apache-socket-starvation-dos':'479',
    'spyware-my-way-speed-bar':'12654',
    'SMB_Netbios_Negotiate_DoS':'5900002',
    'rhel-rhsa-2005-009-update':'9797',
    'openssh-memory':'8471',
    'rhel-rhsa-2012-0466-update':'5900002',
    'ie-active-download':'4680',
    'malcode-rexx_21':'6479',
    'epolicy-http-directory-traversal':'2181',
    'SSH_Deattack_IO':'2120001',
    'win-ms06kb926247-update':'14549',
    'Beast_TCP_Response':'2120017',
    'rhel-rhsa-2008-0288-update':'10550',
    'swf-file-detected':'13282',
    'SNMP_Long_Field_Length':'2106100',
    'Snork attack':'12305',
    'easymail-addattachment-activex-bo':'2025',
    'Swift':'13290',
    'risingonline-webscan-code-execution':'10792',
    'vrrp-detected':'14184',
    'win-ms05kb907245-update':'14464',
    'Edonkey_Connect':'2052',
    'rhel-rhsa-2007-0067-update':'5900002',
    'malcode-BackdoorAppExit':'6167',
    'Suspect_IMAP':'13259',
    'rhel-rhsa-2007-1083-update':'10455',
    'ms-ie-flag-code-execution':'5900002',
    'peoplesoft-schedulertransfer-create-files':'8825',
    'diskeeper-dkservice-dos':'1829',
    'spyware-httper':'12594',
    'ISA_detected_possible_SYN_attack':'5493',
    'lastlines-cgi-command-execution':'5809',
    'http-cgi-anyform':'3553',
    'JavaScript_XML_CoreSvc_Code_Execution':'2114063',
    'adobe-photoshop-gif-code-execution':'5900002',
    'rhel-rhsa-2007-0765-update':'10372',
    'isa-pf-no-ext-interface':'5463',
    'HTTP_URL_overflow':'4461',
    'liquidxmlstudio-openfile-bo':'5900002',
    'winroute-config':'15074',
    'rhel-rhsa-2004-233-update':'9705',
    'spyware-ieloader':'12602',
    'google-talk-detected':'3163',
    'ie-html-url-spoofing':'4771',
    'malcode-Susp14e_EPEnd':'6747',
    'win-ms06kb913446-update':'14491',
    'Konik_TCP_Response':'2113119',
    'HTTP_SurgeMail_Header_Overflow':'5900002',
    'hacker-defender-detected':'3257',
    'prov-system-info':'9133',
    'reg-smb-enabled':'9443',
    'HTTP_Client_Converter_Null_Ptr_BO':'3833',
    'brightstor-mediasvr-bo':'1011',
    'BioNet_Response':'2001535',
    'Exchange_administrator_login_as_user':'2313',
    'citrix-wfica-bo':'1353',
    'rhel-rhsa-2008-0977-update':'10615',
    'SQLServer_login_failed_not_administrator':'12923',
    'microsoft-jet-msjet40-bo':'7010',
    'chilkat-socket-file-overwrite':'1237',
    'JavaScript_Opera_Escape_DoS':'5900002',
    'linux-lockd-remote-dos':'5944',
    'pop-excessive-connections-dos':'8982',
    'rhel-rhsa-2004-636-update':'9784',
    'RAS_RRQ_Inconsistent_Address':'2106305',
    'xorg-xcmisc-overflow':'15274',
    'quicktime-flic-color256-bo':'9220',
    'smtp-vrfy':'11884',
    'HTTP_EZShopper_Loadpage':'2106021',
    'HTTP_MhtmlMid_Bo':'2118069',
    'kernel-udp-fh-dos':'5768',
    'rhel-rhsa-2005-843-update':'10059',
    'BIFF_Workbook_Index_Mem_Corrupt':'2106282',
    'HTTP_Cart32_ChangeAdminPassword':'2002580',
    'DNS_HInfo':'2000407',
    'rhel-rhsa-2005-031-update':'9811',
    'netterm-ftp-ls-bo':'7763',
    'nokia-phoenix-multiple-activex-bo':'7889',
    'thumbnailxpress-thumbnail-file-delete':'13695',
    'remote-administrator-running':'9468',
    'Proxy_Bounce_Deep':'2104037',
    'php-imapmailcompose-bo':'8866',
    'RPC showmount exports':'10858',
    'malcode-SuspWorm0':'6784',
    'wireshark-dhcp-dos':'15113',
    'ethereal-isis-dissector-bo':'2207',
    'Windows_Null_Session':'15036',
    'Scarab_TCP_Response':'2113066',
    'virus-melissa':'14096',
    'BOEP_virwall':'978',
    'snmp-corrupt-packets':'12059',
    'reader-customheap-code-execution':'5900002',
    'rhel-rhsa-2007-0671-update':'10348',
    'ssh-ignore-rhosts':'12976',
    'winxp-credential-storage-allowed':'15094',
    'axis-media- activex-code-execution':'5900002',
    'Trojan_Clampi':'13786',
    'snmp-zero-length-field':'12134',
    'win2k-remove-computer':'14951',
    'ftp-execdotdot':'2842',
    'iis-invalid-filename-passing':'4953',
    'rhel-rhsa-2007-1034-update':'10438',
    'ISA_SCS_Init_Failed':'5515',
    'webshield-smtp-dos':'14251',
    'application-server-stack-bo':'519',
    'icat-carbo-server-vuln':'4585',
    'pdfviewer-ftpdownloadfile-code-execution':'8813',
    'apache-contentroot':'422',
    'SMTP_corrupted_RCPT_command':'11891',
    'nt-system-operator':'8330',
    'Ultravox_Winamp_MP3_BO':'2101030',
    'DNS_name_overflow':'1939',
    'lotus-http-obtain-information':'6056',
    'PDF_Encoded_Filter_Tag':'2114181',
    'ms-csnw-bo':'7164',
    'outlook-long-name':'8681',
    'HPUX_RLPD_Overflow':'2100032',
    'irix-autofsd':'5415',
    'nt-password':'8228',
    'nds-user-file-server-rights':'7627',
    'isa-rules-engine-bypass':'5466',
    'win-ms07kb923723-update':'14555',
    'Realwin_Scada_HMI_Integer_Overflow':'5900002',
    'ISS_scan':'5558',
    'TCP_Probe_NNTP':'13443',
    'Echo Denial of Service':'2033',
    'HTTP_Ieframe_DLL_Hijacking':'5900002',
    'TCP_Probe_HTTP':'13434',
    'FTP_PORT_bounce_to_other_system':'2971',
    'ms-directshow-sami-code-execution':'7169',
    'HTTP_Connection_Overflow':'2000648',
    'malcode-SPMZ_Rare21_Cmos':'6573',
    'quicktime-smil-overflow':'9249',
    'HTTP_OWC_Vulnerable_Client':'2113017',
    'HTTP_PHP_MailManage_Include':'2118114',
    'HP_DP_Cell_Manager_Overflow':'5900002',
    'HTTP_Pfdispaly_Access':'2002523',
    'HTTP_BBN_survey':'2002591',
    'rhel-rhsa-2006-0610-update':'10162',
    'Informix_Username_Overflow':'2114035',
    'decod-ftp-put':'1690',
    'file-bit-frozen':'2465',
    'firebird-username-bo':'2614',
    'rhel-rhsa-2010-0053-update':'5900002',
    'global-usage-cronat':'3110',
    'spyware-zipclix-toolbar':'12844',
    'rhel-rhsa-2004-110-update':'9683',
    'rhel-rhsa-2009-0444-update':'10653',
    'aix-iy59207-fix':'182',
    'win-ms10kb980858-update':'5900002',
    'ssh2-auth-failed-packet-error':'12987',
    'slingbox-detected':'11692',
    'win-ms07kb928090-update':'14567',
    'SMTP Reply-to exec':'11837',
    'rhel-rhsa-2009-1620-update':'5900002',
    'aix-iy64976-fix':'204',
    'HSRP_Suspicious_Priority':'2111012',
    'nt-changedscanfile-attrib':'8005',
    'rhel-rhsa-2009-0409-update':'10650',
    'globallink-glchat-bo':'3117',
    'mysql-dispatchcommand-dos':'7520',
    'spyware-emesx-bho':'12543',
    'BGP_Illegal_Size':'2106125',
    'mssql-replication-sql-injection':'7425',
    'rhel-rhsa-2007-0069-update':'10235',
    'RPC_Cmsd_Overflow':'2001717',
    'POP_Outlook_Date_Overflow':'9028',
    'SDP_Invalid_Header_Type':'2106302',
    'SDP_Null_In_Value':'2106298',
    'malcode-SPPE14':'6629',
    'ISA_client_conn_limit_exceeded_conn_rejected':'5483',
    'Telnet login failed':'13514',
    'Webplus_CGI_exploit':'14248',
    'fw-checkpoint-audit':'3040',
    'up2date-ca-certificate-dos':'13912',
    'HTTP_Shells_Bash':'2002505',
    'RPC getport probe':'10852',
    'zlib-inftrees-bo':'15376',
    'rhel-rhsa-2009-1617-update':'5900002',
    'outlook-express-long':'8677',
    'HTTP_OWC_Installer_Overflow':'2106158',
    'DNS malformed':'1849',
    'malcode-Susp14c':'6744',
    'FTP_Invalid_Port_Cmd':'2001301',
    'Papa_virus':'8719',
    'RWHO host name overflow':'11236',
    'spyware-searchboss':'12723',
    'wftpd-pro-cwd-bo':'14269',
    'spyware-autosearchbho':'12454',
    'rsagent-program-started':'11098',
    'user-superuser':'14017',
    'novell-iprint-lpd-code-execution':'5900002',
    'win-mediaplayer-sspl-bo':'14382',
    'rhel-rhsa-2004-446-update':'9742',
    'win-ms06kb911567-update':'14485',
    'aim-away-bo':'163',
    'DNS TSIG name overflow':'1859',
    'rhel-rhsa-2008-0907-update':'10604',
    'MySQL_Table_Dump_Overflow':'5900002',
    'sccp-open-receive-channel':'11359',
    'MSRPC_Message_Que_Heap_BO':'2110029',
    'xtramail-pass-dos':'15285',
    'LNK_FaceName_Overflow':'2116025',
    'ie-jpeg-image-bo':'4786',
    'FSP_Read_File':'2781',
    'HTTP login failed':'3512',
    'sasfis-trojan-detected':'5900002',
    'LDAP_Sun_Search_Dos':'2118060',
    'ibm-lenovo-acprunner-code-execution':'4571',
    'icmp-reply-received':'4603',
    'win-ms04kb885835-update':'14417',
    'Innd_Cancel_Overflow':'5230',
    'decod-smb-malformed':'1735',
    'rhel-rhsa-2006-0140-update':'10078',
    'cisco-ntp-server-set':'1314',
    'FrontPage service.pwd':'2748',
    'gaim-url-handler-command-execution':'3052',
    'ms-htmlhelp-chm-bo':'5900002',
    'rhel-rhsa-apache-modauthkerb-offbyone-bo':'10679',
    'oracle-runtime-listener':'8572',
    'Finger_Forwarding_DOS':'2001103',
    'flash-unspec-ce-var7':'5900002',
    'hp-openview-nnm-bo':'3324',
    'malcode-RootkitDropper1':'6499',
    'nis-log-nonexistant':'7836',
    'SIIT_Tunnel':'11607',
    'nap-sharing':'7557',
    'Telnet_login_name_overflow':'13576',
    'POP_List_Overflow':'2103008',
    'nt-changedservice-load':'8010',
    'exploit-MSExcel(100037)':'2356',
    'mozilla-garbage-code-execution':'7079',
    'rhel-rhsa-2009-0003-update':'5900002',
    'OSPF_Link_State_Ack_Multicast':'8655',
    'rhel-rhsa-2004-350-update':'9719',
    'HTTP_GTK_Uxtheme_DLL_Hijacking':'5900002',
    'SNMP_Trap_Timestamp_Underflow':'2106087',
    'file-present-detected':'2540',
    'rhel-rhsa-2007-0078-update':'10242',
    'win-ms08kb956416-update':'14681',
    'Masters_Paradise98':'6937',
    'CGI mailnews suspicious field':'1148',
    'djvu-msoffice-activex-bo':'1837',
    'win-ms06kb912442-update':'14487',
    'pdf-stray-stream':'5900002',
    'openoffice-emf-file-bo':'5900002',
    'ie-url-http-requests':'4859',
    'ms-ie-dll-code-execution':'5900002',
    'reg-pagefile-clearing':'9413',
    'SQL_SSRP_Enum_Request':'12913',
    'HTTP_Carello':'2106041',
    'oracle-isqlplus-userid-bo':'8558',
    'malcode-vba93_01':'6846',
    'dns_bad_pkts':'1899',
    'ftp-nonstandard-running':'2855',
    'MSRPC_LSA_DoS':'2002806',
    'Hack-a-tack_trojan_horse_activity':'3252',
    'gdata-scanobjectbrowser-bo':'3067',
    'kingview-historyserver-bo':'5900002',
    'SQL_XP_WeakPermissions':'2106155',
    'aix-iy66933-fix':'205',
    'netbackup-vmd-bo':'7680',
    'rhel-rhsa-2007-1078-update':'10453',
    'reg-afd-free-connections':'9385',
    'KidTerror_Response':'2105076',
    'adobe-reader-mem-ce':'5900002',
    'tcp-fin-rst-range':'13384',
    'Back Orifice 2000 command':'643',
    'apache-413-cgi':'407',
    'quicktime-gif-bo':'9223',
    'rhel-rhsa-2006-0633-update':'10169',
    'win2k-rollup1-sp4-not-installed':'14952',
    'VOIP_Brute_Force':'2106210',
    'lotus-domino-smtp-mail-relay':'6053',
    'GirlFriend_trojan_horse_activity':'3100',
    'POP3_MIME_filename_repeated_blanks':'9011',
    'rhel-rhsa-mozilla-unibrowsread-escalation':'10727',
    'malcode-RCPA4':'6442',
    'malcode-RCPA3':'6441',
    'malcode-RCPA2':'6440',
    'malcode-RCPA1':'6439',
    'win-ms11kb2503658-update':'5900002',
    'Unexplained_Backdoor_Response':'2001597',
    'AOL_Instant_Messenger_Overflow':'2003301',
    'HTTP_Hydra_BruteForce':'2113228',
    'malcode-ObscureBrowser':'6390',
    'nt-changedservice-startup':'8014',
    'winamp-ep-flv-bo':'5900002',
    'tdfc-user-invalid-uid':'13494',
    'HTTP_SiteServer_Post_Dir_Traversal':'2106136',
    'SSH_Kerberos_TGT_not_verified':'13048',
    'ms-drm-activex-code-execution':'5900002',
    'MSMessenger_Message':'7270',
    'shockwave-director-code-exec':'5900002',
    'rhel-rhsa-2004-409-update':'9731',
    'DirectConnect_Connect':'1823',
    'malcode-Susp_SYS_WriteSector':'6778',
    'win-debug-duplicate-handles':'14312',
    'Image_GIF_Java_JRE_Overflow':'2125013',
    'HTTP_HTDIG_htsearch':'2105069',
    'rhel-rhsa-postgresql-datatype-info-disclosure':'10762',
    'HTTP_Rational_Manager_Bypass':'5900002',
    'Backup_Invalid_Input':'2113257',
    'shares-added':'11585',
    'postgresql-datatype-information-disclosure':'9066',
    'http-user-agent-audit':'3707',
    'CompoundFile_PowerPoint_MSO_CodeExec':'2106232',
    'nt-netbios-dict':'8195',
    'gnu-ed-symlink':'3128',
    'rhel-rhsa-2009-0009-update':'5900002',
    'HTML_IE_Parameter_Code_Execution':'2124045',
    'HackATack_Ping':'2001534',
    'rhel-rhsa-2011-1349-update':'5900002',
    'ie-cookie-local-zone':'4719',
    'H225_Suspicious_Field_Length':'3243',
    'LDAP_OpenLdap_Bind_Dos':'2114056',
    'HTTP_SiteCsc_Access':'2002556',
    'kernel-iso9660-dos':'5739',
    'wireshark-mount-dos':'15125',
    'ie-crl-certificate-spoofing':'4721',
    'tomcat-transferencoding-dos':'5900002',
    'XML_IE_InfoBar_Bypass':'2113207',
    'Email_Recipient_Overflow':'2001007',
    'NCX_Backdoor_Response':'2001567',
    'yousendit-email-attachment':'15344',
    'StealthSpy_Response':'2001584',
    'kerberos4-tmpfile-dos':'5714',
    'freeradius-eapttls-dos':'2732',
    'SNMP bad err index tag':'11968',
    'malcode-WABAccess0':'6873',
    'malcode-WABAccess1':'6874',
    'HTTP_Pipelined_Connection':'4295',
    'Smurf_Attack':'2000103',
    'Script_Exploit_Fingerprint':'5900002',
    'POP_Fold_Overflow':'2000713',
    'telnet':'13548',
    'Applix_Graphics_Multiple_BO':'536',
    'rsagent-suspect-pop':'11148',
    'HTTP_OracleApp_oprocmgr_service':'2105029',
    'CGI_pfdispaly.cgi':'1202',
    'rhel-rhsa-2006-0733-update':'10201',
    'AgentManager_Warning':'157',
    'mysql-default-root-password':'7519',
    'apache-tomcat-cookie-info-disclosure':'484',
    'quicktime-udta-atoms-overflow':'9254',
    'Proventia Network Mail Security System_ 1.0':'9140',
    'win-ms06kb926255-update':'14550',
    'TFTP_MSBlaster_Attempt':'2110023',
    'rhel-rhsa-2012-0370-update':'5900002',
    'Stumbler_Connect':'2103026',
    'INN_Control':'5227',
    'XML_Firefox_ImgGraphics_CodeExec':'2124091',
    'snmp-conf-managers':'12057',
    'VOIP_New_Call_Dos':'2106209',
    'roamabout-console-password-disabled':'10832',
    'qpopper-list-bo':'9183',
    'riff-malformed-file-transfer':'10777',
    'QuickTime_CRGN_Overflow':'9262',
    'win-ms10kb2281679-update':'5900002',
    'lotusnotes-xlssr-bo':'6062',
    'ghostscript-postscript-command-execution':'3086',
    'apache-cgi-scriptalias':'417',
    'MSRPC_WksSvc_Mgmnt_JoinDom_Bo':'2118086',
    'SNMP sysName overflow':'12026',
    'dhcp-ascii-log-bo':'1790',
    'rhel-rhsa-2008-0972-update':'10613',
    'win-ms10kb978212-update':'5900002',
    'HTTP_eBuddy_Login':'3892',
    'Order Form v1.2 data URL':'8618',
    'quicktime-toqtpointer-code-execution':'9253',
    'Veritas_Vxschedservice_Code_Execution':'2124089',
    'rhel-rhsa-2009-0397-update':'10648',
    'kernel-choosenewparent-dos':'5723',
    'aix-IY88820-fix':'295',
    'LeakTest trojan horse activity':'5856',
    'SMTP DEBUG command':'11809',
    'sun-jre-xml-unauth-access':'13226',
    'Telnet_Login':'13574',
    'FrontPage_extension_backdoor_URL':'2764',
    'd13hh-solaris-rootkit-login':'1613',
    'JavaScript_Packer_Dean_Edwards':'5900002',
    'iis-create-process':'4921',
    'malcode-SPNE_Attrib_sys':'6587',
    'HTTP_GET_XP_Cmdshell':'2004501',
    'HTTP_MSMessenger_Login':'4171',
    'hsrp-coup':'3351',
    'bugzilla-show-votes-crosssite':'1046',
    'spyware-metadirect':'12642',
    'ssh-service-sweep':'5900002',
    'solaris-answerbook2-admin-interface':'12368',
    'beos-networking-dos':'811',
    'yahoo-messenger-dos':'15315',
    'RIPMetricChange':'10791',
    'RTSP_Suspicious_Header':'5900002',
    'malcode-InjectionAttempt':'6351',
    'imera-imeraieplugin-code-execution':'5189',
    'HTTP_Shells_Perl':'2002521',
    'ftp-privileged-port':'2863',
    'HTTP_Share_Point_XSS':'2110139',
    'TearDrop2':'2000006',
    'rhel-rhsa-2006-0393-update':'10119',
    'activeutils-emaildata-bo':'79',
    'gauntlet-cyberdaemon-bo':'3061',
    'nt-minage-off-onceonly':'8183',
    'share-enumeration-scan':'11576',
    'Cisco_IOS_IPV4_DoS':'2110021',
    'win-ms09kb967723-update':'14724',
    'HTTP_Apache2_Portable_Runtime_DoS':'5900002',
    'rhel-rhsa-2007-0845-update':'10381',
    'cups-cupsd-code-execution':'5900002',
    'sunsolstice-adminsuite-admbuildpath-bo':'13252',
    'almail-bo':'332',
    'safari-idn-spoofing':'11253',
    'file-not-owned-root':'2532',
    'Security_enabled_universal_group_member_removed':'11467',
    'HTTP_Oracle_CharConversion':'2106180',
    'rhel-rhsa-2007-0510-update':'10329',
    'Scada_DNP_Malformed':'2118045',
    'Freak88_Response':'2001556',
    'rhel-rhsa-2010-0624-update':'5900002',
    'apache-postgresql-authentication-module':'468',
    'Logon_process_registered':'6032',
    'win2k-rdp-dos':'14950',
    'SNMP_Cisco_Zero_Size_DOS':'2002023',
    'Scada_Modbus_IncorrectLength':'2118041',
    'win-ms12kb2706726-update':'5900002',
    'imageviewer-tifmergemultifiles-bo':'5900002',
    'wuftp-format-string-stack-overwrite':'15183',
    'malcode-Safety':'6500',
    'NetSphere':'7749',
    'citrix-access-activex-plugin-code-execution':'1350',
    'rhel-rhsa-2010-0661-update':'5900002',
    'malcode-Sus_SearchEXE2':'6736',
    'WindowsMedia_ASF_Overflow':'2106251',
    'MSRPC_WKSSVC_GetJoinInfo_Bo':'7392',
    'Security_disabled_local_group_member_removed':'11457',
    'ms-office-pict-code-execution':'5900002',
    'exchange-smtp-verb-dos':'2301',
    'oracle-applet2classloader-code-exec':'5900002',
    'ie-secure-site-leaving':'4835',
    'IRC_Trinity_Notification':'2112004',
    'rsagent-useradmin-rightgranted':'11177',
    'rhel-rhsa-2007-0979-update':'10418',
    'c6messenger-downloader-file-overwrite':'1058',
    'serverprotect-eng50dll-bo':'11535',
    'stunnel-format-logfile':'13168',
    'ISS_ping_scan':'5557',
    'libtiff-tifjpeg-doublefree-memory-corruption':'5891',
    'kerberos-version4-running':'5712',
    'RPC_TTDBServer_Format_String':'2107028',
    'skyfull-mail-from-bo':'11682',
    'rsagent-imap2-userlogout':'11056',
    'POP3_Attack':'9003',
    'vcf-attachment-bo':'14069',
    'reg-logon-expiry':'9402',
    'IMAP_CramMD5_Long_Username':'2101003',
    'mozilla-crypto-signtext-bo':'7069',
    'newvcommon-activex-bo':'5900002',
    'rhel-rhsa-2007-0705-update':'10355',
    'rhel-rhsa-2005-789-update':'10033',
    'HTTP URL contains _...':'3533',
    'ssh-transport-multiple-bo':'12981',
    'riler-trojan-detected':'10781',
    'nt-services-exe-dos':'8307',
    'Calendar_CGI_exploit':'1093',
    'TCP_Connection_Flood':'2120043',
    'SNMP_Community_Format_String':'2106117',
    'cisco-ios-query-dos':'1300',
    'JavaScript_CSS_Mem_Corruption_Vuln':'2114004',
    'Script_IE_toStaticHTML_Info_Disclosure2':'5900002',
    'HTTP URL overflow':'3537',
    'win-kernel-lpcrequestwaitreplyport-bo':'14359',
    'linux-rootkit4-login-detected':'5961',
    'win-ms10kb2115168-update':'5900002',
    'win-explorer-searchfile-code-execution':'14325',
    'aix-iy78226-fix':'255',
    'rhel-rhsa-2003-262-update':'9625',
    'win-ms08kb947864-update':'14637',
    'rhel-rhsa-2003-090-update':'9586',
    'serverprotect-earthagentexe-bo':'11534',
    'edraw-diagram-dos':'5900002',
    'HTTP_Apache_Header_Memory_DoS':'2122010',
    'win-ms10kb978338-update':'5900002',
    'exchange-owa-obtain-addresses':'2295',
    'http-url-scan':'3706',
    'http-large-request-content':'5900002',
    'libtiff-tifffetchshortpair-bo':'5889',
    'splayer-http-bo':'5900002',
    'rhel-rhsa-2009-0473-update':'10655',
    'win-ms06kb911564-update':'14483',
    'reader-unspec-ce':'5900002',
    'rhel-rhsa-2006-0727-update':'10198',
    'excel-colinfo-bo':'2252',
    'apache-indexing':'441',
    'RPC_CALLIT_ping':'10945',
    'SMTP_Malformed_BDAT':'2118011',
    'Application_Added_to_known_list':'522',
    'No Adapters Open':'7886',
    'SMTP Recipient with trailing dot':'11835',
    'GTP_U_InfrastructureAddress':'2111037',
    'FTP_Unauthenicated_Command':'3013',
    'oracle-dbmssnapinternal-bo':'5900002',
    'chrome-browser-cache-code-exec':'5900002',
    'aix-iy67750-fix':'216',
    'LPD_ControlFile_Overflow':'2110097',
    'word-rtf-string-code-execution':'15156',
    'rhel-rhsa-2006-0648-update':'10172',
    'exploit-MSVisio(100031)':'2369',
    'HTML_Lotus_Webaccess_JS_XSS':'2118062',
    'HTTP_TrendMicro_Officescan_BO':'4429',
    'Swf_Video_Stream_Detected':'13289',
    'ProFTPD snprintf exploit':'9112',
    'rhel-rhsa-2009-0437-update':'5900002',
    'UDP_Probe_NFS':'13852',
    'rhel-rhsa-2007-0220-update':'10275',
    'CiscoSccp_Start_Media_Transmission':'1347',
    'SNMP_PDU_Decode_Error':'12255',
    'openssh-unauthorized-access':'8480',
    'malcode-REPA5':'6461',
    'malcode-REPA4':'6460',
    'RLPR_Format_String':'2113234',
    'pcAnywhere_Login_Failed':'2001610',
    'malcode-REPA3':'6459',
    'malcode-REPA2':'6458',
    'FTP_Reatle_Backdoor':'2118042',
    'exrc-shell':'2403',
    'LsaLookup DoSLsa':'6087',
    'rhel-rhsa-2008-0882-update':'10592',
    'SQL_Convert_Overflow':'12892',
    'win-ms06kb902412-update':'14468',
    'PDF_Bitmap_Color_Overflow':'5900002',
    'iis-ftp-wildcard-dos':'4935',
    'win-ms08kb959349-update':'14695',
    'HTTP_SGI_Webdist':'2002533',
    'xmlrpc-command-execution':'15262',
    'malcode-EICAR_COM':'6236',
    'win-lnk-properties-execute-code':'14362',
    'apache-htdigest-realm-user-bo':'436',
    'omnihttpd-dos':'8432',
    'Rlogin_Login':'10814',
    'win-ms09kb974392-update':'14762',
    'imail-smtp-format-string':'5900002',
    'win-ms04037-patch':'14413',
    'DataProtector_Opcode27_Exec':'5900002',
    'rhel-rhsa-2009-1289-update':'5900002',
    'P2P_Activity':'8702',
    'Novell_iPrint_ActiveX_Multiple_Bo':'2124033',
    'TFTP sam._ file':'13637',
    'interactual-cineplayer-iakey-bo':'5243',
    'HTTP_PHP_DBGuestbook_Code_Execution':'5900002',
    'freetype-cff-bo':'5900002',
    'rhel-rhsa-2004-008-update':'9655',
    'TCP header fragmentation':'13368',
    'ms-win-eot-bo':'7225',
    'wuimapd-partial-mailbox-bo':'15193',
    'micq-sprintf-remote-bo':'7003',
    'mcafee-ebusiness-packet-code-execution':'6947',
    'ip-halfscan':'5276',
    'housecall-notifyonloadnative-code-execution':'3297',
    'ms-messenger-viewprofile-dos':'7185',
    'Java_Untrusted_Object_Execution':'5900002',
    '3com-system-setup-web-access':'25',
    'CompoundFile_Nested_SWF':'5900002',
    'realplayer-activex-cddauri-code-execution':'5900002',
    'apache-modssl-bo':'458',
    'win2k-simplified-chinese-ime':'14967',
    'http-java-class':'3646',
    'imap-login-bo':'5139',
    'mozilla-xul-page-spoofing':'7144',
    'quickbooks-activex-bo':'9209',
    'SSL_MasterKey_SmallCipher_Overflow':'5900002',
    'linux-docbook-stylesheet-insecure':'5924',
    'isa-log-file-write-failed':'5453',
    'smtp-wiz':'11885',
    'SSH_FreeSSHd_Remote_DoS':'5900002',
    'rhel-rhsa-2004-687-update':'9792',
    'Socks_Auth_Failed':'2001611',
    'spyware-dyfuca':'12533',
    'FTP_Bad_Response_Overflow':'2109024',
    'PE_AV_Evasion':'2121039',
    'rhel-rhsa-2009-1136-update':'10672',
    'ie-mshtml-gif-bo':'4808',
    'DNS TCP port probe':'1858',
    'mssql-insecure-password-storage':'7405',
    'rhel-rhsa-2006-0425-update':'10121',
    'aix-iy82993-fix':'270',
    'flash-flv-detected':'2672',
    'malcode-SuperRAT':'6734',
    'EOT_Compressed_OpenTypeFont_Detected':'2173',
    'Hack-a-tack ping':'3248',
    'winvnc-client-bo':'15090',
    'win-ms08kb953747-update':'14666',
    'RPC_CallIt_Unknown':'2001724',
    'JavaScript_IE_Decoding':'5618',
    'win-ms10kb2293211-update':'5900002',
    'rhel-rhsa-2006-0217-update':'10099',
    'http-indexserver-view-files':'3644',
    'TeleCommando':'13503',
    'novell-webserver-dos':'7940',
    'SNMP enterprise underflow':'12000',
    'win-image-logger-file-overwrite':'14349',
    'rhel-rhsa-2005-011-update':'9799',
    'ActiveX_InternetExplorer':'5900002',
    'rhel-rhsa-2007-0003-update':'10214',
    'firefox-nstreerange-code-execution':'5900002',
    'outlook-patch':'8690',
    'ie-dialog-zone-bypass':'4732',
    'http-cgi-calendar-execute':'3560',
    'nt-csrss-dos':'8029',
    'Logon_with_explicit_credentials_success':'6035',
    'Amd_Version':'349',
    'rhel-rhsa-2009-1124-update':'10669',
    'nt-fpnwclnt-chksum':'8077',
    'rhel-rhsa-2005-329-update':'9899',
    'JPEG_Invalid_Precision':'5900002',
    'JavaScript_RisingScanner_UpdateEngine':'5642',
    'win-ms08kb947085-update':'14635',
    'nt-user-dialin-changed':'8348',
    'HTML_ATLStream_BO':'3380',
    'HTTP_WebSphere_HeaderDoS':'4513',
    'win-tcpip-sack-dos':'14859',
    'linux-stp-dos':'5973',
    'SMB_StillImaging_DLL_Hijacking':'5900002',
    'malcode-DeletesFiles0':'6196',
    'malcode-DeletesFiles1':'6197',
    'RPC_Portmap_Set_Spoof':'2001741',
    'HTTP_Post_Field':'4313',
    'JPEG_2000_Quicktime_Overflow':'5900002',
    'spyware-vesta-intl-dialer':'12792',
    'autonomy-keyview-eml-multiple-bo':'617',
    'rhel-rhsa-2009-0011-update':'5900002',
    'ie-file-download-execution':'4741',
    'kernel-dnfibprops-fibprops-dos':'5728',
    'Quake3Arena_Vulnerable_Server':'9203',
    'ms-win-win32-otf-ce':'5900002',
    'MSRPC_TCP_port_probe':'7383',
    'ftp-glob-expansion':'2845',
    'roads_cgi_file_access':'10831',
    'websphere-connect-without-password':'14255',
    'Script_IE_Center_Manipulation':'5900002',
    'fetchmail-authenticate-gssapi':'2449',
    'ypserv':'15357',
    'FTP password overflow':'2805',
    'mysql-libmysqlclient-readrows-bo':'7522',
    'mozilla-chrome-privilege-escalation':'7065',
    'malcode-SPPE_LastSectEP_Bound':'6681',
    'spyware-hotvideo-dialer':'12593',
    'rhel-rhsa-2006-0663-update':'10175',
    'backdoor-forcedentry':'685',
    'nt-adminnopw':'7973',
    'sun-java-parsedouble-dos':'5900002',
    'googleapps-googleapps-command-execution':'3164',
    'rsagent-sqlserver-login-failed-notadmin':'11109',
    'rhel-rhsa-openiscsi-log-dos':'10738',
    'HTTP_HTMLScript':'2002517',
    'rhel-rhsa-2007-0488-update':'10323',
    'win-ms06kb922581-update':'14527',
    'cisco-autoloading-enabled':'1262',
    'nds-user-template-password-life':'7651',
    'TFTP file name overflow':'13631',
    'HP Remote watch':'3298',
    'Telnet_Bad_Xdisplay':'2000912',
    'orinoco-as-default-telnet-password':'8626',
    'firefox-character-encoding-xss':'2621',
    'rhel-rhsa-2005-823-update':'10049',
    'Qaz_Connect':'9173',
    'idn-query-detected':'4671',
    'dns-truncated-response':'1889',
    'Failed_object_privileged_operation':'2433',
    'omnihttpd-statsconfig-corrupt-files':'8433',
    'ICMP_Phishing_Trojan':'2113242',
    'PDF_Embedded_GoTo':'8791',
    'adobe-flash-actionscript-xss':'119',
    'unix-passwords':'13892',
    'fpdb-wrong-perms':'2712',
    'SNMP_Version_Underflow':'2106075',
    'webex-atas32-bo':'5900002',
    'Leszcz_TCP_Response':'2113120',
    'cleverinternet-gettofile-file-overwrite':'1358',
    'win-dns-rpc-bo':'14317',
    '3com-snmp-setup-web-access':'23',
    'rhel-rhsa-2003-121-update':'9594',
    'tftp-windows-system32-put':'13656',
    'win-ms09kb973346-update':'14753',
    'openoffice-word-sprmtsetbrc-bo':'5900002',
    'FTP_Privileged_Bounce':'2975',
    'MySQL_Windows_Query_DoS':'5900002',
    'nt-allocate-floppy':'7978',
    'Qaz_trojan_horse_activity':'9174',
    'multiple-telnetd-bo':'5900002',
    'kerberos-kdc-krb5recvauth-execute-code':'5900002',
    'realplayer-rjs-image-bo':'5900002',
    'HTTP POST contains create%table':'3518',
    'DHCP_Discover':'1802',
    'sun-jsasp-directory-traversal':'13230',
    'FTP_Site_Exec':'2001322',
    'smtp-relay-unauthorized-attempt':'11872',
    'Guest_user_login':'3224',
    'malcode-PoorDropper':'6425',
    'FTP_Glob_Implementation':'2001357',
    'ie-dialog-box-code-execution':'4730',
    'rsagent-ssh-osf1':'11131',
    'MIDI_Zero_Division':'5900002',
    'rhel-rhsa-2003-224-update':'9615',
    'win-ms07kb934233-update':'14585',
    'TrinooDaemon':'13774',
    'DNS_ZXFR':'1975',
    'decod-windows-access-error':'1759',
    'linux-kernel-sctpgetsockopt-dos':'5941',
    'SNMP bad packet tag':'11975',
    'network-monitor-bo':'7777',
    'ms-word-rtf-code-exec':'5900002',
    'ibm-db2-sqlnlsunpaddedcharlen-dos':'4568',
    'cisco-h323-dos':'1275',
    'mozilla-netscape-jar-bo':'7109',
    'HTTP_Netscape_Method_Overflow':'2106004',
    'DRat_TCP_Response':'2113094',
    'CVS_Request_Path_Overflow':'2107027',
    'TCP_Urgent_Data':'13473',
    'LDAP_Response_ASN1_Error':'5900002',
    'win-ms05kb890046-update':'14429',
    'Rexec':'9502',
    'trendmicro-tmcomm-privilege-escalation':'13755',
    'ssh2-auth-failed-for-user':'12985',
    'SNMP cable-docsis community':'11986',
    'nt-system-env-onceonly':'8328',
    'aardvark-infophp-obtain-information':'30',
    'win-media-dos':'14372',
    'rhel-rhsa-2007-0542-update':'10338',
    'win-ms04kb885249-update':'14416',
    'WINS_Replication_Heap_Overflow':'15082',
    'gnutella-tcp-probe':'3147',
    'Email_Autonomy_KeyView_EML_Multiple_Bo':'2124039',
    'tivoli-post-code-execution':'13709',
    'mantis-backdoor':'6931',
    'Change_password_attack':'1222',
    'cineplayer-iamanager-bo':'1250',
    'Veritas_NetBackup_FormatString':'2113231',
    'malcode-DelExiting0':'6204',
    'malcode-DelExiting1':'6205',
    'Email_SubSeven':'2004401',
    'linux-ptrace-race-condition':'5957',
    'win-wins-wpad-registration-spoofing':'14879',
    'HTTP_Apache_ServerInfo':'3764',
    'spyware-adbreak':'12432',
    'HTTP_Post_CATotalDefense_Bypass':'5900002',
    'SMB_Autoexec_bat_Access':'2002707',
    'oracle-dbmsupgrade-sql-injection':'8549',
    'HTTP_DCForum_Admin_Access':'2002667',
    'mysql-checkscramble323-unauthorized-access':'7512',
    'http-request-binary-data':'3682',
    'Detector_Info':'1780',
    'win-ms07kb942695-update':'14614',
    'spyware-pstopper':'12699',
    'malcode-SystemHijack2':'6793',
    'malcode-SystemHijack3':'6794',
    'rhel-rhsa-2008-0214-update':'10530',
    'hp-instantsupport-downloadfile-file-download':'3306',
    'osgfes-admin-code-execution':'5900002',
    'oracle-cpu-july2006':'8539',
    'MSRPC_Unauth_Admin_Access':'2114030',
    'icq-server-running':'4632',
    'exchange-owa-html-xss':'2293',
    'file-not-owned':'2534',
    'nav-port-probe':'7583',
    'rhel-rhsa-2006-0591-update':'10151',
    'iis-webdav-lock-dos':'5005',
    'sip-registers-dos':'11629',
    'HTTP_GET_Very_Long':'2000608',
    'twinge-flood-dos':'13821',
    'rhel-rhsa-2008-0814-update':'5900002',
    'rsagent-notauthorized-login':'11084',
    'libxpm-multiple-stack-bo':'5897',
    'nt-logfull':'8159',
    'http-cgi-bnbform':'3557',
    'malcode-Spawn_Lsr':'6531',
    'cisco-anm-mysql-default-password':'1261',
    'HTTP_AnyForm_Post':'2104023',
    'aolserver-default-password':'403',
    'clamav-pe-overflow':'1355',
    'squid-strings-dos':'5900002',
    'rhel-rhsa-mozilla-content-type-bo':'10710',
    'mscs-authfilter-isapi-bo':'7245',
    'rhel-rhsa-2008-0886-update':'10595',
    'dns_inv_updated':'1929',
    'servu-command-bo':'11557',
    'HTTP_JJ_Overflow':'2002589',
    'SNMP int underflow':'12007',
    'web-site-copying':'14220',
    'user-logon-changes':'13987',
    'file-mail-grants':'2521',
    'win-ms07kb942017-update':'14610',
    'root-cronat':'10838',
    'FTP_Unix_Password_Fil':'3015',
    'cyviewer-activex-file-overwrite':'5900002',
    'MSRPC_Netware_Change_Password_BO':'2122000',
    'IMAP4 command overflow':'5150',
    'ZenWorks_hhMgr_op3_Overflow':'5900002',
    'dns-rrdatalen-underflow':'1886',
    'Twinge attack':'13820',
    'Image_TIFF_Invalid_Orientation':'5900002',
    'RAR_Invalid_Magic_Bytes':'2110204',
    'frontpage-ext-dvwssr-bo':'2752',
    'spyware-netratings':'12667',
    'HTTP_POST_SQL_Convert_Int':'2110104',
    'ibm-db2-sortlist-info-disclosure':'4567',
    'xztoo-backdoor':'15292',
    'malcode-InappropriateNetbios':'6341',
    'user-admin-group':'13949',
    'IMAP2bis_server_user_auto-logout':'5144',
    'office-wordperfect-bo':'8417',
    'HTTP_formmailpl':'2002512',
    'linux-ptrace-modify-process':'5956',
    'ospf-invalid-packet-length':'8642',
    'HTTP_JRun_IIS_Overflow':'2106166',
    'activex-blocked':'80',
    'sendmail-etrn-dos':'11492',
    'Image_TIFF_Quicktime_Overflow':'2121046',
    'php-libxslt-security-bypass':'5900002',
    'p2p-traffic-detected':'8701',
    'rhel-rhsa-2004-583-update':'9769',
    'win-ms08kb957175-update':'14689',
    'malcode-EO1':'6241',
    'SQL_PasswordArray_Overflow':'2120007',
    'malcode-EO2':'6242',
    'HTTP_NCSA_Buffer_Overflow':'4178',
    'ie-br549-activex-bo':'4692',
    'HTTP_Apache_ModProxy_Bypass':'5900002',
    'HTTP_WebLogic_JavaInjection':'4501',
    'ssl-certificate-fqdn-mismatch':'13075',
    'decod-talk':'1749',
    'Image_WMF_GDI_Integer_Overflow':'5110',
    'html-browser-plugin-overflow':'5900002',
    'ie-accept-cookies':'4677',
    'SMB_Abel_Backdoor':'2118005',
    'MSRPC_Netware_BO':'2118047',
    'MS_WMP_Inflate_Overflow':'2118109',
    'HTTP_Prorat_Notification':'4340',
    'nt-perfmon':'8229',
    'atsvc-bind-attempt':'594',
    'backdoor-serveme':'726',
    'qmail-rcpt':'9176',
    'TCP data changed':'13365',
    'sunjava-file-creation-code-execution':'13236',
    'malcode-AntiqueTrojan0':'6137',
    'ICMP_SourceQuench':'4619',
    'active-directory-audit-setup-failed':'57',
    'ie-showhelp-zone-bypass':'4842',
    'openssl-tls-dos':'8502',
    'Back Orifice 2000 ping':'644',
    'smb-signing-disabled':'11728',
    'rhel-rhsa-2005-608-update':'9996',
    'CyberCop_Scan':'1592',
    'nt-create-token-onceonly':'8026',
    'ntfs-file-corruption':'8382',
    'CGI faxsurvey':'1134',
    'zenworks-assetmanagement-collection-bo':'15362',
    'spyware-wazam':'12800',
    'SMTP_too_many_errors':'11945',
    'HTTP_IE_Security_Zone_Bypass':'2120033',
    'malcode-ExploitShellCode':'6303',
    'RPC_BrightStor_Handle_Control':'10941',
    'ie-cache-external-dom-access':'4699',
    'aix-iy88699-fix':'291',
    'HTTP_URL_WWWBoard_Script':'2002537',
    'winamp-inmp3-bo':'15012',
    'ares-galaxy-installed':'553',
    'ssh-deattack-overwrite-memory':'12974',
    'Packet_Capturing_Tool':'2100035',
    'HTTP_TrendMicro_OfficeScan_CGI_Bo':'2125010',
    'iss-wireless':'5553',
    'coldfusion-rds-gain-access':'1397',
    'gtrust-remote-any':'3220',
    'iis-check-script-engines':'4917',
    'gtk-dll-code-execution':'5900002',
    'SMB_Windows_Backup_Mgr_DLL_Hijacking':'5900002',
    'RPC_Statd_MyName_Format_String':'2107022',
    'DNS_Antisniff_Overflow':'2000418',
    'reg-afd-large':'9386',
    'BOEP_cmd':'965',
    'malcode-ExeSeq51':'6293',
    'pcAnywhere_Ping':'2001507',
    'win2k-calendar-error':'14904',
    'malcode-ExeSeq52':'6294',
    'Email_Lnk_File_Attachment':'5900002',
    'Unify_UploadServlet':'13886',
    'malcode-OddIPRangeStrong':'6394',
    'Win_IGMP_DOS':'2002902',
    'Script_FileView_ActiveX_Bo':'2124052',
    'ISA_detected_possible_PoD_attack':'5491',
    'user-homedir-exist':'13960',
    'BIFF_Lotus_123_FileViewer_BO':'828',
    'ipp-malformed':'5342',
    'hp-nnm-ovtopmd-dos':'3322',
    'http-trace-enabled':'3697',
    'spyware-mediacharger':'12636',
    'snmp-nonzerolength-nulltype':'12093',
    'cvs-argumentx-double-free':'1567',
    'mssql-named-pipe-hijack':'7417',
    'rhel-rhsa-2004-133-update':'9686',
    'h225-invalid-length-dos':'3235',
    'Pict_Office_Image_Converter_Overflow':'5900002',
    'FTP_Retr_dotdot':'2001365',
    'iis-ssi-directive-bo':'4988',
    'StorageWorks_Mirroring_Stack_Overflow':'5900002',
    'win-ms10kb977165-update':'14779',
    'rhel-rhsa-2009-1364-update':'5900002',
    'netscape-fasttrack-auth-bo':'7731',
    'rhel-rhsa-2004-400-update':'9727',
    'spyware-hitslink':'12585',
    'Application Added to known list':'500',
    'php-wddx-information-disclosure':'8914',
    'malcode-SPPE_WrtbleReloc_Bound_Misc':'6699',
    'rhel-rhsa-2011-1324-update':'5900002',
    'cisco-ios-ipv6-header-dos':'1292',
    'lockd':'6016',
    'DNS_Cache_Poison_Subdomain_Attack':'1906',
    'ISA_Server_NAT_Insecure':'5519',
    'rhel-rhsa-2007-0701-update':'10353',
    'win-ms08kb955617-update':'14677',
    'rhel-rhsa-2002-123-update':'9514',
    'rsagent-imap2-server':'11055',
    'proftpd-ascii-xfer-newline-bo':'9113',
    'Security_disabled_local_group_created':'11454',
    'rhel-rhsa-2002-312-update':'9557',
    'IP_Timestamp_Not_Aligned':'2000017',
    'rsagent-oracle-startup':'11093',
    'outlook-v1-certificate-plaintext':'8692',
    'ispynow-detected':'5545',
    'kernel-odirect-dos':'5748',
    'blackice-sensor-shutdown':'927',
    'Critical_File_Unknown':'1539',
    'rpc.ypupdated_command':'10929',
    'nt-create-pagefile':'8025',
    'squid-mkdir-put-dos':'12940',
    'spyware-secretcrush':'12733',
    'iis-standalone-server':'4991',
    'php-readfile-dos':'8897',
    'rc-file-groupwritable':'9328',
    'HTTP_StoreCGI':'2002598',
    'shockwave-3d-bo':'11597',
    'spyware-win-popup':'12813',
    'Buschtrommel_TCP_Response':'2120004',
    'HTTP_SGI_Wrap':'2002613',
    'excelviewer-openwebfile-file-execution':'2275',
    'xorg-getpixel-initimage-bo':'15271',
    'MSSQL7_Startup':'7443',
    'reatle-worm':'9379',
    'magnetoicmp-activex-code-exec':'5900002',
    'PcnfsdExec':'2001746',
    'HTTP_ICQ_Pager':'2009301',
    'Teardrop attack':'13495',
    'rhel-rhsa-2007-0956-update':'10407',
    'rhel-rhsa-2009-1184-update':'5900002',
    'password-aging-not-active':'8742',
    'rhel-rhsa-2007-0497-update':'10326',
    'file-default-login':'2477',
    'Email_False_Attachment':'2102025',
    'nt-ras-bo':'8260',
    'SMB_IE_HTA_Remote_Exec':'2109004',
    'rhel-rhsa-2008-0937-update':'10606',
    'visual-studio-vbtsql-bo':'14107',
    'ip-version-invalid':'5282',
    'u3d-filesize-overflow':'5900002',
    'PDF_TIFF_U3D_Overflow':'5900002',
    'win-ms09kb959426-update':'14707',
    'acrobat-reader-u3dsupport-code-exec':'5900002',
    'malcode-SPMZ_DTA_DO_RegEdit':'6561',
    'iams-pop3-command-dos':'4557',
    'SMTP Subject':'11838',
    'ie-cert-view':'4710',
    'security-access-removed':'11436',
    'easewe-execute-code-execution':'5900002',
    'rhel-rhsa-2004-009-update':'9656',
    'winxp-sp2':'15104',
    'kernel-blockprepare-information-disclosure':'5721',
    'apache-modproxy-dos':'455',
    'perf-counter-leak':'8827',
    'Spyware_PH_EliteBar':'2113195',
    'SMTP_BDAT_Large_Chunk':'2120070',
    'reg-ups-shutdown':'9457',
    'rhel-rhsa-2007-0961-update':'10410',
    'RPC_Portmap_Dump':'2001705',
    'Slapper_Worm':'2110006',
    'PDF_JavaScript_Exploit':'8802',
    'rhel-rhsa-2005-766-update':'10022',
    'SNMP_port_probe':'12258',
    'Email_Data':'2086',
    'Dansie_shopping_cart':'1631',
    'Gift_TCP_Response':'2113110',
    'nfs-port-probe':'7807',
    'malcode-Ring2':'6482',
    'nis-names-match':'7838',
    'streamaudio-chaincastproxymanager-bo':'13156',
    'malcode-Ring5':'6485',
    'MySQL_Default_Password':'7538',
    'win-ms05kb904706-update':'14459',
    'win-ms03050-patch':'14400',
    'IMAP4 user name overflow':'5154',
    'decod-finger-metachars':'1683',
    'tomcat-servlet-xss':'13731',
    'rhel-rhsa-2007-0888-update':'10390',
    'malcode-ServiceInjection':'6515',
    'spyware-sexde':'12736',
    'mssql-agent-stored-pw':'7397',
    'mssql-pwdencrypt-bo':'7422',
    'nt-active-modem':'7967',
    'nt-spoofed-lpc-port':'8317',
    'dns-invalid-update':'1875',
    'ie-embedded-object-code-execution':'4738',
    'malcode-SPPE_WrtSect65_01':'6701',
    'Cert_rejected_denied_replication_access':'1124',
    'brightstor-discovery-servicepc-bo':'1005',
    'UDP_ECHO_port_probe':'13840',
    'OpenSSH_Auth_Successful':'8483',
    'kernel-smbfs-directory-traversal':'5761',
    'Trojan_Sasfis':'5900002',
    'Citrix_Provisioning_Services_Overflow2':'5900002',
    'snmp-hangup':'12075',
    'win-ms08kb950759-update':'14650',
    'HTTP_NS_Admin_Overflow':'4201',
    'ForcedEntry':'2698',
    'HTTP_OracleAdmin_Web_Interface':'2113016',
    'nt-reg-anon':'8268',
    'SMB_Mass_Login':'2113225',
    'rhel-rhsa-2012-0690-update':'5900002',
    'HTTP_DCForum_Traversal':'2002670',
    'edirectory-ldap-extension-bo':'5900002',
    'HTTP_URL_Bad_Hex_Code':'2000627',
    'Email_Vrfy_Overflow':'2001033',
    'HTTP_ReportViewer_Disclosure':'5900002',
    'HTTP_POST_ComputeSum':'2106174',
    'wireshark-esp-offbyone-win':'15114',
    'SMB_Copy_Source_Overflow':'11744',
    'HTTP_PcClient_Message':'4252',
    'spyware-adrotator':'12438',
    'HTTP_MaxDB_LockToken_BO':'2106214',
    'akamai-redswoosh-bo':'305',
    'malcode-PackedVBWeak':'6422',
    'netbios-name-scan':'7686',
    'cognos-tomcatmanager-default-password':'5900002',
    'php-zend-array-dos':'8916',
    'Netbackup-dos':'7679',
    'win-ms11kb2587634-update':'5900002',
    'quicktime-macintosh-code-execution':'9235',
    'Email_Pipe':'2001001',
    'rhel-rhsa-2006-0280-update':'10111',
    'decod-packet-capturing-tool':'1721',
    'DPS_IpAddr_Overflow':'2106242',
    'SMB_Lync_DLL_Hijacking':'5900002',
    'RMP_Location_Path_Traversal':'2110121',
    'rhel-rhsa-2005-015-update':'9803',
    'Application Communication Allowed':'502',
    'ie-vbscript-view-files':'4862',
    'blackice-oem-restriction':'925',
    'ms-mpeglayer3-bo':'5900002',
    'libmytinfo-bo':'5874',
    'Echo reply without request':'2034',
    'win-ms10kb978214-update':'14786',
    'linux-sctp-skb-pull-dos':'5970',
    'IPv6_Native':'5367',
    'iis-unicode-wide-encoding':'4995',
    'rhel-rhsa-2009-0258-update':'10622',
    'HTTP_POST_dotdot_data':'2000623',
    'mozilla-contentdefined-code-execution':'7068',
    'snmp-conf-info':'12056',
    'CA_License_Getconfig_Overflow':'5900002',
    'active-directory-domain-removal':'62',
    'malcode-TrojanInjectorEmail':'6802',
    'quake3-auto-download':'9201',
    'FTP pwl file type':'2812',
    'corel-micrografx-activex-bo':'1520',
    'HTTP_Yahoo_YAutoDLL_BO':'2118017',
    'rhel-rhsa-2005-365-update':'9918',
    'tcp-rst-dos':'13394',
    'ie-adodbconnection-code-execution':'4686',
    'apache-modstatus-xss':'464',
    'pmap-sset':'8969',
    'SSH_Service_Sweep':'5900002',
    'rhel-rhsa-2010-0534-update':'5900002',
    'trojan-tcp-numeric-detected':'13783',
    'SMB_ATService_Connect':'11738',
    'win-ms10kb2407132-update':'5900002',
    'ms-win-cinepak-code-execution':'5900002',
    'Whisker URL fingerprint':'14279',
    'adobe-acrobat-null-bo':'107',
    'malcode-SPPE_DO_SEH':'6669',
    'malcode-SPMZ_TSR_STDIN':'6578',
    'brightstor-arcserv-discovery-bo':'1001',
    'passport-events-reporting-disabled':'8723',
    'bgp-illegal-pkt-size':'816',
    'ie-wpad-proxy-settings':'4872',
    'RWHO_host_name_overflow':'11237',
    'digital-rootbeer-backdoor':'1819',
    'mozilla-javascripturi-code-execution':'7092',
    'SSH2_SSH1_Agent_forwarding_denied':'13026',
    'nt-registryopen':'8276',
    'aix-iy67802-fix':'217',
    'spyware-dialerdata-dialer':'12518',
    'isa-pf-dropping-packets':'5458',
    'Dot_NET_Shellcode_Detected':'1989',
    'Unistim_Reregister_DoS':'2114099',
    'HTTP_Cart32_ClientList':'2002579',
    'reg-ups-warning':'9458',
    'rhel-rhsa-2008-0058-update':'10484',
    'ms-directx-directshow-code-execution':'7172',
    'annotationsdk-activex-annosavetotiff-bo':'353',
    'RPC_NFS_Over_LOCKD':'2001707',
    'TLS_Excessive_Renegotiations':'5900002',
    'rhel-rhsa-2008-1029-update':'5900002',
    'Update_Uninstall':'13925',
    'msmsgr-message':'7273',
    'rhel-rhsa-2005-135-update':'9861',
    'IMAP4 port probe':'5153',
    'IRC buffer overflow':'5371',
    'adobe-logic-code-execution':'5900002',
    'SQL_Injection_MySQL_Benchmark':'5900002',
    'rhel-rhsa-apache-child-process-dos':'10678',
    'Netbios_Session_Rejected':'7695',
    'spyware-buddy-browser':'12477',
    'rhel-rhsa-2005-527-update':'9974',
    'tcp-connection-flood':'13383',
    'RAS_RRQ_Low_Time_To_Live':'2106307',
    'Malformed_LSA_request':'6918',
    'XML_Libxml2_DTD_Element_DoS':'5900002',
    'rsagent-change-password-attack-likely':'11018',
    'reg-sec-users':'9440',
    'bitdefender-oscan-bo':'882',
    'linux-mountd-bo':'5949',
    'rsagent-exchange-mail-behalf':'11030',
    'TCP_Probe_Gnutella':'13433',
    'Email_Executable_Extension':'2120020',
    'SMB_Find_Files2_BO':'2102060',
    'Syphillis_Scan':'13329',
    'snmp-dialup-username':'12061',
    'shopping-cart-database-access':'11602',
    'LDAP_Auth_Failed':'2108000',
    'backupexec-authentication-bo':'771',
    'nds-no-account-lockout':'7612',
    'ftp-bounce':'2830',
    'rhel-rhsa-fetchmail-null-pointer-dos':'10687',
    'EventCollector_Info':'2230',
    'malcode-MrVirus2':'6381',
    'uusee-uuupgrade-update-file-overwrite':'14059',
    'bat_URL_type':'805',
    'RTF_Office_Stack_Overflow':'5900002',
    'oracle-detect':'8551',
    'ie-netbios-incorrect-security-zone':'4810',
    'barcode-bidib-file-overwrite':'798',
    'group-names-invalid':'3177',
    'SNMP_V3_Invalid_MsgSecurityModel':'2101061',
    'Kika_UDP_Request':'2113153',
    'FTP_Cwd_dotdot':'2001362',
    'tdfc-boot-os':'13484',
    'win-ms08kb942830-update':'14624',
    'ms-locator-running':'7184',
    'blackice-license-soonexpire':'921',
    'win2k-secenabled-universalgroup-memberadded':'14959',
    'panda-activescan-bo':'8716',
    'Kerberos_ASN1_Overflow':'2107007',
    'HTML_Browser_Plugin_Overflow':'5900002',
    'squirrelmail-magichtml-xss':'12957',
    'win2k-globalgroup-deleted':'14922',
    'win-ms11kb2570222-update':'5900002',
    'Cisco_Cable_Docsis_SNMP_Community':'2106006',
    'DonaldDick':'1984',
    'Cisco_IOS_OSPF_BO':'2110018',
    'NOSecure_TCP_Request':'2113149',
    'RTSP_Multiple_Require_Overflow':'11219',
    'SMTP_MIME_null_charset':'11927',
    'Swf_Malicious_ActionScript':'5900002',
    'nt-guessed-disabled':'8117',
    'Realwin_Scada_String_Overflow':'5900002',
    'Replication_connection_created':'9490',
    'HTTP_ISpyNow_Installed':'4105',
    'openmanager-activex-info-disclosure':'5900002',
    '3ctftpsvc-transporting-mode-bo':'5900002',
    'sun-jre-proxy-session-hijacking':'13220',
    'TCP null scan':'13370',
    'adobe-flash-jar-information-disclosure':'125',
    'TCP FIN scan':'13367',
    'malcode-WritingExeToIEStartPageRegEntry':'6914',
    'Security_Policy_Compliance_Renewed':'11472',
    'SNMP_InvalidTag_Enterprise':'2106111',
    'DNS_name_overflow_very_long':'1941',
    'ie-dhtml-control':'4727',
    'helixserver-rtsp-describe-bo':'5900002',
    'M2Trojan_TCP_Response':'2113121',
    'HTTP_3com_AirConnect_EasySetup':'2106009',
    'xml-entity-reference-dos':'15241',
    'HTTP_MediaPlayer_Classic_DLL_Hijacking':'5900002',
    'rsagent-exchange-pst-password':'11039',
    'FTP CWD ~root command':'2790',
    'exploit-RTF(100029)':'2389',
    'rhel-rhsa-2005-663-update':'10002',
    'win-tcpip-route-code-exec':'14858',
    'Email_IE_HRAlign_Overflow':'2103028',
    'gtp-u-infrastructure-address':'3203',
    'firefox-thunderbird-javascript-code-exec':'2638',
    'Rlogin_Excessive_Tabs':'2103019',
    'edirectory-monitoreventsrequest-bo':'2048',
    'SSL_Secure_Channel_Underflow':'2110131',
    'FTP_Format_String':'2001325',
    'dcom-scada-opc-bo':'1659',
    'rhel-rhsa-2008-0005-update':'10473',
    'rhel-rhsa-2007-0975-update':'10417',
    'Cisco_Syslog_DoS':'1341',
    'rhel-rhsa-2008-0182-update':'10520',
    'dns-predict-query':'1883',
    'backdoor-ultors':'741',
    'BOOTP_Remote_Overflow':'2004302',
    'rhel-rhsa-2005-502-update':'9964',
    'edirectory-eventsrequest-code-execution':'2046',
    'rhel-rhsa-2008-0295-update':'10553',
    'xferwan-tcp-bo':'5900002',
    'rhel-rhsa-2008-0863-update':'10590',
    'HTTP_POST_contains_compute%sum':'4301',
    'Cabinet_Kaspersky_AV_BO':'2106203',
    'NetBus':'7701',
    'm2-trojan-backdoor':'6093',
    'nssldap-dns-srv-bo':'7950',
    'php-nuke-modules-dos':'8886',
    'adobe-memory-privilege-escalation':'129',
    'Boink_attack':'982',
    'win-ms12kb2644615-update':'5900002',
    'sybase-sa-blank-password':'13296',
    'yahoo-messenger-yverinfo-bo':'15324',
    'rhel-rhsa-2005-108-update':'9851',
    'snmp-value-underflow':'12127',
    'IP source route':'5269',
    'asterisk-genprios-security-bypass':'584',
    'rhel-rhsa-2004-360-update':'9721',
    'rhel-rhsa-2003-324-update':'9642',
    'ms-chart-control-info-disclosure':'5900002',
    'finger-running':'2590',
    'HTTP_CobaltRAQ_service':'2105015',
    'JavaScript_Suspicious_Aliasing':'5900002',
    'java-truetype-dos':'5900002',
    'rhel-rhsa-2008-0946-update':'10609',
    'wow-writeinifilestring-code-execution':'15172',
    'rlogin-known-username':'10802',
    'win2k-telnet-system-call-dos':'14978',
    'passport-sample-site-global':'8728',
    'mdac-rdsdataspace-execute-code':'6960',
    'apache-singlesignon-information-disclosure':'478',
    'Encrypted_Session_Policy_Abuse':'5900002',
    'rhel-rhsa-2008-0974-update':'5900002',
    'HTTP_PHPNuke_Admin_Access':'2106028',
    'malcode-EPA1':'6243',
    'TelnetAuthUserLong':'13604',
    'backdoor-prosiak':'717',
    'Excessive DNS requests':'2277',
    'rhel-rhsa-2002-227-update':'9541',
    'HTTP_OpenView_NNM_webappmon_Overflow':'5900002',
    'Corrupt IP options':'1521',
    'UDP_Network_Scan':'2102044',
    'MoonPie_FTP_Response':'2113128',
    'flash-flash10h-activex-ce':'5900002',
    'iag-activex-bo':'4556',
    'Auction Weaver CGI exploit':'595',
    'tux-http-host-dos':'13817',
    'ca-arcservebackup-database-engine-dos':'5900002',
    'oracle-ftp-pass-bo':'8554',
    'muskat-empower-url-dir':'7491',
    'file-duplicated-library':'2496',
    'spyware-ezula':'12553',
    'HTTP_JavaServer_URL_in_caps':'4109',
    'Nonroot_setruid':'7897',
    'HTTP_FormMail':'2002511',
    'ie-object-scripting':'4817',
    'linux-rh-rpmmail':'5959',
    'malcode-SSM3':'6728',
    'malcode-WormIndicator2':'6910',
    'JavaScript_Packer_Delta':'2114164',
    'malcode-ModifySettings1':'6379',
    'rhel-rhsa-php-zend-array-dos':'10759',
    'bisonware-command-bo':'879',
    'HTTP_Authentication_overflow':'3784',
    'SMTP encapsulated relay':'11813',
    'php-sessionname-unspecified':'8905',
    'rhel-rhsa-2005-109-update':'9852',
    'rhel-rhsa-2003-197-update':'9610',
    'flash-actiondefinefunction-doaction-bo':'2669',
    'iis-improper-httptrack-logging':'4948',
    'nds-irf-hides-objects':'7606',
    'ie-telnet-execute-commands':'4850',
    'Flash_ActionDefineFunction_Name_BO':'2106205',
    'AOLIM_Trillian_XML_BO':'400',
    'win-ms05kb896422-update':'14443',
    'RPC_Portmap_High_Port':'10974',
    'HTTP_Shells_Ksh':'2102013',
    'HTTP_CMD_Execute':'2002502',
    'YahooMSG_Filename_Overflow':'2107002',
    'yahoomsg-message':'15333',
    'adobe-authplay-code-execution':'5900002',
    'file-sgid-script':'2543',
    'CGI_htmlscript':'1190',
    'ms-win-wins-code-exec':'5900002',
    'ethereal-3gpp2a11-bo':'2198',
    'Network_Inspection_Resumed':'7780',
    'rhel-rhsa-2002-128-update':'9517',
    'active-directory-object-operation':'68',
    'blackice-application-protection-started':'909',
    'HTTP_AnyForm':'2002504',
    'CVS_Request_Option_Overflow':'2107024',
    'cisco-snmp-improper-request-handling':'1322',
    'FTP_Server_Identity':'2992',
    'Email_From':'2105',
    'aix-iy64926-fix':'201',
    'ie-activex-execution':'4682',
    'MS domain dump':'7148',
    'GSpot_TCP_Response':'2113112',
    'win-ms07kb928843-update':'14569',
    'ms-report-viewer-info-disc':'5900002',
    'spyware-istbardotcom-toolbar':'12617',
    'operations-manager-servlet-code-execution':'5900002',
    'bugzilla-show-attachment':'1043',
    'LDAP_Modify_Req_Bo':'2118072',
    'microsoft-excel-unspecified-code-execution':'7005',
    'rusersd':'11233',
    'nt-userrights-audit-failure':'8360',
    'One_TCP_Request':'2113218',
    'backdoor-gayol':'689',
    'awhttpd-invalid-file-dos':'635',
    'POP3 MIME file name overflow':'8993',
    'ie-cookie-disclosure':'4718',
    'rhel-rhsa-2003-289-update':'9633',
    'boep-yhoo':'960',
    'TelnetXdisplay':'13614',
    'AOLIM_GameRequest_Overflow':'2106059',
    'win-ms10kb2294255-update':'5900002',
    'HTTP_InterscanViruswall_RegGo':'2002635',
    'rhel-rhsa-2007-0494-update':'10325',
    'MSRPC_CA_Arcserve_MessageEngine_Overflow':'5900002',
    'Scada_Citect_ODBC_BO':'11332',
    'openssl-detected':'8490',
    'win-ms07kb924667-update':'14557',
    'Email_Debug':'2001002',
    'spyware-possible-browser-hijackattempt':'12691',
    'win-cdo-bo':'14301',
    'Sybase_Shutdown':'13299',
    'php-mailfunction-header-injection':'8875',
    'winnt-malformed-rpc-dos':'15063',
    'spyware-lycos-sidesearch':'12628',
    'user-admin-locked-shell':'13951',
    'file-suid-binary':'2546',
    'xinetd-identd-bo':'15228',
    'ie-ftp-create-files':'4756',
    'reg-sec-machines':'9436',
    'S2_Scan_Started':'11248',
    'office-unspecified-code-execution':'8416',
    'MSRPC_UDP_port_probe':'7388',
    'HTTP_CrystalReports_FileAccess_DoS':'2113148',
    'cisco-aironet-default-user':'1258',
    'BasicHell_TCP_Response':'2113078',
    'Finger_Scan':'2001110',
    'mozilla-onunload-code-execution':'7115',
    'CompoundFile_Word_Repair_Overflow':'2106252',
    'php-superglobal-dos':'8910',
    'aflog-comments-sql-injection':'148',
    'Unknown IP protocol':'13902',
    'Email_OWA_Header_XSS':'2122039',
    'Keystrokes monitored':'5774',
    'rhel-rhsa-2008-0895-update':'10600',
    'im-impwagent-insecure-directory':'5045',
    'SMB_Media_Encoder_DLL_Hijacking':'5900002',
    'decod-http-post':'1700',
    'rsagent-ssh-securid':'11139',
    'backdoor-syphillis':'734',
    'win-ms11kb2620704-update':'5900002',
    'pcanywhere-tcp-probe':'8761',
    'MSSQL_Failed_Connection':'7445',
    'spyware-sidefind':'12742',
    'iis-asp-http-header-bo':'4902',
    'csa-smb-bo':'1552',
    'start-command-enabled':'13127',
    'timesten-timestend-dos':'5900002',
    'UDP_Trojan_Horse_probe':'13867',
    'broderbund-activex-bo':'1026',
    'TCP_Frag_RFProwl':'2000319',
    'win2k-sfcscan':'14965',
    'http-cgi-cachemgr':'3559',
    'http-cgi-mailnews-username':'3585',
    'nt-user-profile':'8355',
    'backdoor-uucico-bindshell':'743',
    'hpvirtualrooms32-unspecified-code-exec':'3350',
    'excel-label-bo':'2258',
    'malcode-SPNE_3to5_MemAlign':'6582',
    'rhel-rhsa-2011-0198-update':'5900002',
    'win-ms10kb978886-update':'5900002',
    'win-ms10kb981957-update':'5900002',
    'malcode-autoExecCountMacros':'6152',
    'HTTP_Host_Spurious_Data':'3988',
    'HTTP_DragonFire':'2106019',
    'malcode-SPTRJ_Inet_icebp':'6716',
    'HTML_MSXML_Memory_Corruption':'2110118',
    'Virus_Found':'14099',
    'HTML_MS_Office_ActiveX_Exec':'5900002',
    'sendmail-dbrebuild-race-dos':'11485',
    'DataProtector_OmniInet_Overflow':'1644',
    'malcode-RATonDemand':'6432',
    'php-zendhashinit-dos':'8917',
    'iis-url-decoding':'4996',
    'smtp-banner-detected':'11849',
    'windowsmedia-asxplaylist-bo':'15042',
    'rhel-rhsa-2006-0129-update':'10076',
    'rhel-rhsa-2006-0746-update':'10206',
    'acrobat-reader-3d-code-execution':'48',
    'ssrp-enumeration-request-detected':'13121',
    'win95-back-orifice':'15003',
    'anywhere-mailserver-retr-dos':'377',
    'HTTP_MachineInfo':'2002519',
    'License_Will_Expire_Soon':'5907',
    'nds-user-template-no-password-change':'7648',
    'ApplicationCommunicationAllowed':'532',
    'DCOM_Large_Body_Extension':'2102040',
    'passwd-blank-permitted-onceonly':'8732',
    'rhel-rhsa-2006-0735-update':'10203',
    'allaire-jrun-jws-directory-traversal':'315',
    'roads-search-view-files':'10830',
    'rhel-rhsa-2003-242-update':'9619',
    'TCP_Invalid_Urgent_offset':'13416',
    'autonomy-keyview-foliosr-bo':'618',
    'win-ms05kb905749-update':'14462',
    'VNC_Login_Failed':'14162',
    'rhel-rhsa-2006-0661-update':'10174',
    'LPD_Novell_Iprint_Queuename_Overflow':'5900002',
    'CGI whois suspicious field':'1170',
    'passwd-shadow-accessed':'8738',
    'sun-jre-xml-dos':'13225',
    'realplayer-parseknowntype-code-exec':'5900002',
    'HTML_Meta_Refresh_URLs':'2121030',
    'citectscada-odbc-bo':'1349',
    'rhel-rhsa-2005-265-update':'9883',
    'ftp-dotdot-directory-traversal':'2839',
    'php-makehttpsoaprequest-bo':'8876',
    'isa-dialup-ip-assigned':'5438',
    'awstats-configdir-command-execution':'636',
    'win-ms10kb2279986-update':'5900002',
    'ebcrypt-ebcprngenerator-file-overwrite':'2031',
    'quicktime-qtif-file-bo':'5900002',
    'cisco-community-string-enabled':'1271',
    'OSPF_Invalid_Packet_Length':'2110017',
    'kazaa':'5692',
    'finger-inetd':'2586',
    'iis-running':'4980',
    'HTML_ATL_ActiveX_BO':'3379',
    'cisco-CHAP':'1270',
    'rhel-rhsa-2010-0457-update':'5900002',
    'Security_enabled_universal_group_member_added':'11466',
    'mozilla-documentopen-frame-spoofing':'7074',
    'odbc-tools-detected':'8402',
    'SNMP bad varbind tag':'11982',
    'Ascend_Kill':'2000322',
    'sophos-rar-dos':'12405',
    'tftp-passwd-file':'13652',
    'rhel-rhsa-2002-167-update':'9529',
    'reg-ras-rings':'9426',
    'imanager-getmultipartparameters-file-upload':'5900002',
    'softether-ssl-connection-detected':'12358',
    'PDF_Invalid_Stream_Length':'5900002',
    'globallink-glitemflat-bo':'3119',
    'dns-badseq':'1864',
    'ms-win-mhtml-info-disc':'5900002',
    'rhel-rhsa-2005-152-update':'9867',
    'Jolt':'5673',
    'ie-htm-script-execution':'4763',
    'linux-bttv-root-privileges':'5919',
    'epolicy-execute-commands':'2179',
    'file-permissions-generous':'2538',
    'samba-smbcifs-smbd-bo':'11278',
    'Account_name_changed':'39',
    'FTP_file_exec_exploit':'2916',
    'Windows_NNTP_Overflow':'2110067',
    'malcode-RogueInstallation':'6496',
    'TCC_Response':'2118008',
    'POP_Generic_Intel_Overflow':'2104005',
    'duddie-backdoor':'2014',
    'DeepThroat_Response':'2001548',
    'U3D_Adobe_CLODMesh_Exec':'5900002',
    'sensor-error':'11521',
    'sprayd-inetd':'12415',
    'HTTP_Advancestack_BypassAuth':'2106160',
    'debugdiagnostic-debugdiag-dos':'1675',
    'Zincite_Backdoor':'2113146',
    'rsagent-unknown-error':'11169',
    'Spyware_PH_BrilliantDigital':'2113175',
    'HTML_Yahoo_MediaGrid_BO':'2110164',
    'NetAdministrator_TCP_Request':'2113130',
    'HTTP_CheckPoint_FW1_FormatString':'2110044',
    'tomcat-null-directory-listing':'13727',
    'win2k-synchronize-directory':'14972',
    'HTTP_PHPNuke_URL_Redirect':'2106031',
    'FTP_Cybercop_Scan':'2001510',
    'hpux-nfsoncplus-format-string':'5900002',
    'SNMP_BulkRqst_Heap_Overflow':'2118087',
    'Site Server sample URL':'11674',
    'nt-kernvers':'8146',
    'http-cgi-newdsn':'3586',
    'nt-changedservice-startname':'8013',
    'win-ms05kb896423-update':'14444',
    'Manolito_Download':'6930',
    'SNMP_HP_OpenView_hidden_community':'12208',
    'RTF_Word_Parsing':'11210',
    'pop3-client-bo':'9000',
    'silentrunner-collector-popuser-bo':'11609',
    'Sunrpc_BackupProduct_BO':'2118084',
    'aix-iy89512-fix':'299',
    'rhel-rhsa-2003-114-update':'9592',
    'win-gdi-gif-bo':'14329',
    'http-cgi-snork':'3596',
    'quicktime-unspecified-code-execution':'9255',
    'Netbios_Flood_DoS':'2110134',
    'cogsmanager-activex-bo':'5900002',
    'interscan-reggo-bo':'5247',
    'EOT_OpenTypeFont_Detected':'2175',
    'Bla_Request':'2113079',
    'apache-stderr-dos':'482',
    'mssql-xp-weak-permissions':'7438',
    'NTP_Time':'8392',
    'fw1-localhost-auth':'3047',
    'ie-dialog-window-css':'4731',
    'win2k-secenabled-universalgroup-deleted':'14958',
    'libtiff-thundercode-decoder-bo':'5900002',
    'symantec-antivirus-handler-service-dos':'5900002',
    'RIFF_Director_Buffer_Overflow':'5900002',
    'malcode-SPNE_Worm_Internet':'6621',
    'rhel-rhsa-2009-1128-update':'10671',
    'HTML_AnnotationSDK_ActiveX_BO':'3375',
    'malcode-OddShellScript':'6396',
    'smtp-unknown-user':'11882',
    'Syphillis_Scan_Request':'2100013',
    'FSP_Detected':'2780',
    'spyware-searchexplorerbar':'12724',
    'HTTP_AddressBook_DLL_Hijacking':'5900002',
    'rs-kill':'11007',
    'TFTP port probe':'13635',
    'win-ms10kb980218-update':'5900002',
    'TheFlu_TCP_Request':'2113073',
    'rhel-rhsa-2009-0457-update':'5900002',
    'advancedfile-activex-bo':'5900002',
    'rhel-rhsa-2005-330-update':'9900',
    'dns-malformed-packet-flood':'1878',
    'HTML_NullChar_Evasion':'2116022',
    'Qpopper_Possible_user_probe':'9190',
    'rhel-rhsa-2009-0431-update':'5900002',
    'geovision-livex-activex-file-overwrite':'3077',
    'multiple-jbig2-symboldictionary-bo':'5900002',
    'malcode-SetIntervalAndOther':'6521',
    'FTP_Cisco_IOS_Unauthorized_Access':'2106273',
    'spyware-2020search':'12418',
    'AsteriskManager_Command_Exec':'5900002',
    'firefox-passwordmgr-information-disclosure':'2632',
    'isa-fw-init-failed':'5442',
    'leadtools-insert-dos':'5900002',
    'rhel-rhsa-2009-1096-update':'5900002',
    'Telnet_port_probe':'13584',
    'nt-os2-sub':'8223',
    'rhel-rhsa-2010-0166-update':'5900002',
    'DHTML_IE_JavaScript_XSS':'2110074',
    'XML_EntityDecl_DoS':'2119014',
    'win-ms09kb971961-update':'14749',
    'SMB2_Vista_Vulnerable_Dialect':'11734',
    'HTML_RealPlayer_IERPCtl_Overflow':'2122028',
    'vagrnoker-backdoor':'14062',
    'rhel-rhsa-2004-058-update':'9669',
    'movieplayer-drawtext-activex-bo':'7057',
    'rtsp-mpeg4-rtspvapgdecoder-bo':'11213',
    'HTTP_ShockWave':'4392',
    'GTP_C_Discovery':'3207',
    'rhel-rhsa-2007-1041-update':'10441',
    'uucp-commands-insecure':'14050',
    'backdoor-bugs':'669',
    'SOAP_Envelope_Too_Large':'12322',
    'SNMP_V3_Incorrect_Tag':'2101057',
    'malcode-SPNE_Attrib_OpenSysSelf':'6586',
    'isa-web-proxy-dos':'5476',
    'ca-arcservebackup-integer-value-overflow':'1065',
    'aix-iy64820-fix':'199',
    'win-print-spooler-bo':'14812',
    'quicktime-aacencoded-code-execution':'9211',
    'win-ms10kb977894-update':'14782',
    'FrontPage_htimage.exe_URL':'2765',
    'kerberos-principal-name-bo':'5705',
    'ie-cacheattack-execute-code':'4706',
    'spyware-verticity':'12791',
    'win-ms10kb980436-update':'5900002',
    'win-msrpc-popup':'14795',
    'oracle-multiple-function-bo':'8568',
    'rwhod':'11239',
    'bittorrent-get-request-detection':'887',
    'FTP invalid PORT command':'2798',
    'DNS_LLMNR_DotQuery':'5900002',
    'FTP_Site_Exec_Format_Attack':'3001',
    'vista-contacts-gadget-code-execution':'5900002',
    'HTTP_GetArg':'3966',
    'rhel-rhsa-2009-1186-update':'5900002',
    'ie-getobject-directory-traversal':'4758',
    'Finger_Backdoor':'2001109',
    'SMTP MIME name overflow':'11831',
    'pict-malformed-file-detected':'8932',
    'antisniff-dns-overflow':'371',
    'malcode-ServiceInstaller4':'6519',
    'rsagent-ssh-kerberos-notverified':'11126',
    'malcode-ServiceInstaller2':'6517',
    'malcode-ServiceInstaller3':'6518',
    'Scada_ICCP_Long_TPDU':'2118071',
    'MSRPC_LLS_Bo':'2110078',
    'Java_contains_Brown_Orifice_attack':'5587',
    'rhel-rhsa-2005-788-update':'10032',
    'http-unencrypted-traffic-detected':'3700',
    'adobe-acrobat-detected-win':'104',
    'tdfc-group-invalid-gid':'13490',
    'BrightStor_Discovery_UDP_Message_Overflow':'2106256',
    'rhel-rhsa-2003-033-update':'9568',
    'malcode-Susp_Com_BootSector':'6761',
    'indusoft-open-buffer-overflow':'5900002',
    'user-homedir-shared':'13972',
    'webalizer-reverse-dns-bo':'14225',
    'HTTP JavaServer URL in caps':'3511',
    'SIP_Long_Method_Name':'2119015',
    'mozilla-browserengine-memory-corruption':'7063',
    'Boink attack':'980',
    'Norton Antivirus port probe':'7903',
    'mozilla-txtfile-dos':'7132',
    'SSH_Detected':'13040',
    'HTTP_POST_Repeated_Parameter_DoS':'5900002',
    'win-ms03019-patch':'14388',
    'active-directory-certificate-rejected':'59',
    'nt-ms-dhcp-log':'8187',
    'PDF_Color_Spray':'8789',
    'win-ms10kb982665-update':'5900002',
    'Unicenter_Msg_Queue_BO':'2106202',
    'bugzilla-create-account-crosssite':'1037',
    'oracle-weblogic-apacheconnector-bo':'8585',
    'exchange-owa-csrf':'5900002',
    'Quake Exploit':'9197',
    'SMTP_YPOPs_Overflow':'2121003',
    'HTTP_URL_IIS_Password_Change_Attempt':'2002558',
    'DNS_UDP_port_probe':'1962',
    'reg-sys-log-events':'9447',
    'Loki':'2000112',
    'nt-group-debug':'8091',
    'SMTP_Too_Many_Connects':'2110000',
    'nt-user-home-drive':'8351',
    'POP3_AUTH_overflow':'9005',
    'FTP PASV DoS':'2806',
    'rhel-rhsa-2004-463-update':'9748',
    'SMB_Telnet_Exe_Hijacking':'5900002',
    'LDAP_IMail_Overflow':'5844',
    'iprint-executerequest-bo':'5900002',
    'nds-user-volume-write-access':'7656',
    'Napster_Private_Msg':'7565',
    'boep-exchange':'948',
    'HTTP_LastlinesCgi_Traversal':'2106061',
    'Network_Inspection_Suspended':'7781',
    'escan-forgotpassword-cmd-execution':'5900002',
    'HTTP_Netscape_rend':'2105032',
    'win-locator-bo':'14363',
    'rhel-rhsa-2005-071-update':'9835',
    'malcode-ExeSeq22_Spawn':'6273',
    'mozilla-browser-engine-code-exec':'7062',
    'win-user32-control-bo':'14867',
    'win2k-telnet-ntlm-authentication':'14976',
    'snmp-show-routes':'12110',
    'Win_IGMP_Option_DoS':'2113239',
    'groupwise-vcalendar-rrulebo':'5900002',
    'nav-javascript-enabled-execution':'7575',
    'Exchange55_unauthenticated_pop3_command_wrongargs':'2310',
    'flashplayer-swf-execute-code':'2682',
    'winmx-running':'15055',
    'service-compliance':'11542',
    'html-suspicious-hex-text':'5900002',
    'rhel-rhsa-2002-216-update':'9538',
    'ethereal-snmp-community-dos':'2213',
    'openssh-login-restrictions-bypass':'8470',
    'win-ms06kb914389-update':'14494',
    'aix-iy64358-fix':'195',
    'win-ms10kb982802-update':'5900002',
    'HTTP_POST_passwd_file':'4320',
    'ip2location-activex-bo':'5900002',
    'firefox-browser-code-execution':'2620',
    'lotus-domino-nrouter-bo':'5900002',
    'Script_DOM_Layouts_Corruption':'5900002',
    'HTTP_Spyki_PhpInclude_Worm':'2121010',
    'Too_much_IP_fragmentation':'13734',
    'rhel-rhsa-2005-383-update':'9926',
    'rhel-rhsa-2008-0103-update':'10491',
    'malcode-AutoScript1':'6155',
    'CGI bash':'1130',
    'malcode-AutoScript3':'6157',
    'malcode-AutoScript2':'6156',
    'apache-type-map-dos':'489',
    'novell-iprint-executerequest-bo':'7923',
    'aix-iy67248-fix':'208',
    'GTP_C_Element_Underflow':'2111025',
    'nt-group-increase-priority':'8093',
    'downloadject-trojan':'1992',
    'LanMan_Share_Enum':'5804',
    'audit-report-file-deletion':'600',
    'mozilla-multiple-memcorrupt-code-execution':'7106',
    'spyware-surebar':'12757',
    'HTTP_HP_IMC_Credentials_Disclosure':'5900002',
    'SMTP_pipe_in_mail_address':'11930',
    'active-directory-max-ldap-connection':'66',
    'rhel-rhsa-2008-0032-update':'10479',
    'SharePoint_SOAP_Malformed_Request_Code_Exec':'5900002',
    'siteserver-post-directory-traversal':'11677',
    'win-ms12kb2647170-update':'5900002',
    'INI_InformixNFX_BO':'5223',
    'IGMP_Zero_Delay_DoS':'5900002',
    'outlook-mhtml-execute-code':'8684',
    'rhel-rhsa-2010-0703-update':'5900002',
    'gnu-fileutils-race-condition':'3130',
    'malcode-SPTRJ_Hide_WrtEOF':'6713',
    'win-ms10kb2028554-update':'5900002',
    'POP3 command overflow':'8989',
    'tcpdump-drop-permissions-failure':'13479',
    'rhel-rhsa-2004-494-update':'9758',
    'HTTP_WebStore_Misconfig':'2002547',
    'wwwthreads-sql-command-privs':'15195',
    'nt-load-driver':'8150',
    'SNMP_Zero_Length_Field':'12300',
    'Email_Xchg_Auth':'2165',
    'ftp-command-bo':'2835',
    'javascript-activex-obfuscation':'5588',
    'cisco-aironet-default-ssid':'1257',
    'rhel-rhsa-2007-0501-update':'10327',
    'License_Rejected':'5906',
    'ipv6-teredo':'5363',
    'file-default-login-not-frozen':'2476',
    'cisco-security-webagent-file-upload':'5900002',
    'imc-tftpserver-bo':'5900002',
    'spyware-trekblue-spywarenuker':'12778',
    'CSS_Chrome_Stack_Overflow':'5900002',
    'Script_Office_DeleteRecordSourceIfUnused_BO':'11395',
    'rhel-rhsa-2006-0609-update':'10161',
    'Script_MoveNetworks_UpgradeManager_BO':'2122036',
    'dhcpd-nsupdate-format-string':'1814',
    'hp-ovnnm-ovacceptlang-acceptlanguage-bo':'5900002',
    'gspot-backdoor':'3189',
    'backdoor-deltasource':'678',
    'win-chm-code-execution':'14303',
    'isa-fw-start-failed-corrupt':'5443',
    'SNMP_TFTP_Retrieval':'2002009',
    'spyki-php-include-worm':'12417',
    'HTTP_MFC_DLL_Hijacking':'5900002',
    'ms-ie-httpredirect-code-exec':'5900002',
    'ms-ie-insertrow-code-exec':'5900002',
    'antivirus-archive-header-bypass-detection':'376',
    'snmp-uint-underflow':'12122',
    'Application Added':'501',
    'Possible_Smurf_attack_initiated':'9057',
    'SNMP_Sysname_Overflow':'2002005',
    'malcode-SPPE_SEH_Token':'6691',
    'rhel-rhsa-2009-0354-update':'10643',
    'file-uucp-not-owned':'2559',
    'file-directories-insecure':'2495',
    'malcode-SPPE_Jmp_SEH_DLL':'6679',
    'rhel-rhsa-2003-285-update':'9632',
    'NTP_NTPD_Autokey_Overflow':'2101086',
    'Exchange_service_password_change':'2323',
    'malcode-Susp_Write_FTime':'6780',
    'http-converter-null-ptr-deref':'3611',
    'Sslvpn_Http':'13109',
    'linkerbug':'5913',
    'DNS_TSIG_name_overflow':'1960',
    'BOEP_ntoskrnl':'974',
    'voodoo-doll-backdoor':'14178',
    'HTTP_OpenView_NNM_ToolbarArg_Overflow':'2101084',
    'Scada_Modbus_ForceListenOnly':'11343',
    'mozilla-netscape-nsmsgcomputils-bo':'7111',
    'ieee80211-device-present':'4877',
    'UDP_Quake3_Exploit':'2002908',
    'SNMP_community_format':'12182',
    'pcAnywhere_Probe':'8768',
    'cisco-ospf-auth-enabled':'1315',
    'nt-remote-shutdown-onceonly':'8277',
    'HTTP asp with _ appended':'3483',
    'nt-usersnull':'8365',
    'CompoundFile_VBA_Properties_BO':'2106235',
    'nt-guessed-domain-guestpwd':'8119',
    'Spyware_PH_180SearchAssistant':'2113172',
    'rsagent-ssh-passwordauth':'11132',
    'nt-group-backup':'8085',
    'FTP_Oracle_Pass_Overflow':'2118034',
    'microsoft-safrcfiledlg-bo':'7012',
    'TCP_Probe_SMTP':'13449',
    'win-gdi-tiff-image-bo':'14332',
    'firefox-nowaiverwrappers-priv-escalation':'5900002',
    'rhel-rhsa-2002-124-update':'9515',
    'Script_IE_Object_Change_Corruption':'5900002',
    'facebook-imageuploader-bo':'2416',
    'MSRPC_ARCserve_TapeEngine_Job_Exec':'5900002',
    'iplanet-search-bo':'5314',
    'isa-demand-dial-ip-assigned':'5437',
    'HTTP_several_fields_with_binary':'4372',
    'win-media-files-code-execution':'5900002',
    'symantec-veritas-vea-bo':'13314',
    'ms-aspnet-appcode-information-disclosure':'7158',
    'rhel-rhsa-2008-0270-update':'10546',
    'netware-webserver-directory-traversal':'7770',
    'Image_Cursor_Malformed':'2102059',
    'squid-proxy':'12943',
    'tdfc-user-invalid-gid':'13493',
    'rhel-rhsa-2002-170-update':'9530',
    'SNMP format string':'12001',
    'win2k-universalgroup-created':'14985',
    'ca-arcservebackup-tapeengine-opnum37-bo':'1071',
    'msmsgr-login':'7272',
    'openssl-ecdh-dos':'5900002',
    'pcanywhere-ping-detected':'8760',
    'Scada_KingView_History_Opcode3_Overflow':'5900002',
    'HTTP_URL_scan':'4465',
    'SNMP_Sequence_Incorrect_Length':'2101059',
    'najdisi-toolbar-bo':'7546',
    'http-repetitive-requests':'3681',
    'win-ms11kb2604930-update':'5900002',
    'iptables-kernel-firewall-failure':'5356',
    'gnu-enscript-tmpfile-symlink':'3129',
    'mssql-empw-inregistry':'7404',
    'firefox-unicode-data-dos':'2639',
    'AnswerBook2_Admin':'367',
    'imagemagick-sgi-bo':'5123',
    'udp-port-probe':'13835',
    'Email_Outlook_URL_Spoof':'2107021',
    'iptables-save-files-option':'5357',
    'snmp-pdu-underflow':'12100',
    'ms-win-mpeg4-code-execution':'5900002',
    'drw_stack_ovflw':'2010',
    'VmRenamedEvent':'14133',
    'malcode-DeleteSystemFiles':'6200',
    'HTTP_IIS_Unicode_Encoding':'2106056',
    'win-ms09kb973565-update':'14755',
    'rsagent-exchange-anonymous-logon':'11022',
    'Suspect_POP2':'13262',
    'win-ms11kb2652016-update':'5900002',
    'ms-win-msvcrt-bo':'5900002',
    'Latinus_TCP_Response':'2113062',
    'Duplicate_IP_address':'2017',
    'nds-public-rights':'7616',
    'sip-contact-from-id-mismatch':'11614',
    'rhel-rhsa-2007-0009-update':'10216',
    'nt-dcom-runaswrite':'8037',
    'nfs-root-ro-all':'7812',
    'serverprotect-agent-rpcfncopyausrc-bo':'11532',
    'rsagent-oracle-shutdown':'11092',
    'lynx-crlf-injection':'6092',
    'spyware-vcatch':'12790',
    'rhel-rhsa-2009-0955-update':'10658',
    'ARJ_Header_Block_BO':'2121053',
    'aix-iy67654-fix':'213',
    'firefox-sm-pac-code-execution':'5900002',
    'f-backdoor':'2415',
    'sony-connect-m3u-bo':'12402',
    'adobe-dlmanager-acrojs-code-execution':'117',
    'PrettyPark worm':'9101',
    'HTTP_Auth_Failed':'2001602',
    'sip-sdp-connection-ip-mismatch':'11634',
    'win-ms10kb2027452-update':'5900002',
    'rhel-rhsa-2011-0375-update':'5900002',
    'CSS_Large_Layout_Grid_Char':'5900002',
    'ie-object-code-execution':'4813',
    'System_Error':'13341',
    'screen-saver-visible':'11373',
    'orinoco-as-access-table':'8622',
    'VNC_RFBConnFailed_Overflow':'2102001',
    'rhel-rhsa-php-sscnf-safemode-bypass':'10756',
    'nt-manage-log-onceonly':'8178',
    'malcode-VBASpawnsBat_InstallChk':'6860',
    'Blazer5':'933',
    'JBIG2_Adobe_Integer_Overflow':'5660',
    'spyware-win32-backdoor-jeem':'12815',
    'shared-folders':'11582',
    'rsagent-exchange-login-administrator':'11026',
    'MSM_GenericError':'7259',
    'HTTP_Media_Player_PNG_Chunksize_BO':'2106215',
    'POP_Retr_DoS':'2103009',
    'win-ms12kb2688338-update':'5900002',
    'password-reset-successful':'8744',
    'flashget-ftppwd-bo':'5900002',
    'rhel-rhsa-2006-0195-update':'10090',
    'hp-instantsupport-drivercheck-bo':'3307',
    'NNTP_Message-ID_too_long':'7875',
    'IRC_Daemon_Overflow':'2001801',
    'Telnet bad TERMCAP':'13511',
    'MSRPC_LSA_Crash':'2002808',
    'rhel-rhsa-2005-354-update':'9913',
    'active-directory-attributes-changed':'56',
    'Spyware_PH_HotBar':'2113189',
    'Script_IE_CrossDomain_Function_Escalation':'5900002',
    'http-cgi-wwwboard':'3608',
    'http-nov-convert':'3653',
    'php-phpregistervariableex-code-exec':'5900002',
    'reg-nt-vers-install-date':'9411',
    'Millenium_Response':'2001565',
    'Conficker_P2P_Data_Transfer':'2110196',
    'ie-shellapplication-code-execution':'4840',
    'win-tcp-ip-driver-bo':'14853',
    'HTTP_IIS_Hit_Highlighting_Auth_Bypass':'2106274',
    'TelnetEnvTermcap':'13608',
    'cisco-buffered-logging-disabled':'1265',
    'firefox-sm-rtl-spoofing':'5900002',
    'xenapp-ctxxmls-bo':'5900002',
    'MSRPC_MSMQ_Path_BO':'7335',
    'http-bat-execute':'3552',
    'HTTP_Cold_Fusion':'3841',
    'Exair_sample_ASP':'2249',
    'PDF_OpenType_Overflow':'5900002',
    'CompoundFile_Word_Table_CodeExec':'2109009',
    'http-zero-hex-code':'3717',
    'exploit-WinApi(100043)':'2391',
    'Script_MSXML_Chunked_Request':'2114135',
    'malcode-word6_EndlessLoop':'6903',
    'ip-fragment-reassembly-dos':'5275',
    'IP_Microfragment':'2000020',
    'ftp-pipe-vulnerability':'2860',
    'rhel-rhsa-2009-1211-update':'5900002',
    'SNMP_InvalidTag_ErrorStatus':'2106089',
    'publisher-object-handler-code-execution':'9161',
    'ms-win32k-iframe-code-exec':'5900002',
    'malcode-word6_12':'6897',
    'rhel-rhsa-2003-163-update':'9602',
    'NNTP_name_overflow':'7876',
    'rhel-rhsa-2008-0038-update':'10480',
    'win-ms11kb2607702-update':'5900002',
    'email-replyto-field-metacharacters':'2074',
    'backup-product-string-overflow':'768',
    'malcode-SPMZ_Wrt_COMSys':'6579',
    'CGI_wguest.exe':'1216',
    'SMTP_login_name_overflow':'11913',
    'spyware-kitten-freesex-dialer':'12622',
    'installationmanager-ibmim-code-execution':'5235',
    'netbios-port-probe':'7688',
    'dansie-form-variables':'1629',
    'HostShutdownEvent':'3293',
    'nt-cmd-overflow':'8021',
    'ie-ms04004-patch':'4800',
    'ibm-soliddb-memory-dos':'4575',
    'nt-domain-admin-userpwd':'8052',
    'tdl4-trojan-detected':'5900002',
    'firefox-locationhostname-security-bypass':'2630',
    'openssl-rsa-security-bypass':'8496',
    'windows-admin-password-expire':'15021',
    'chemview-activex-bo':'1234',
    'win-ms11kb2518295-update':'5900002',
    'pcvue-getextendedcolor-code-exec':'5900002',
    'win-vbscript-jscript-code-execution':'14871',
    'win-ms06kb910620-update':'14479',
    'rhel-rhsa-2005-582-update':'9986',
    'ftp-unauthorized-access':'2874',
    'libpng-progressive-reader-bo':'5878',
    'Ultors_Response':'2001596',
    'win-ms09kb970483-update':'14737',
    'mysql-login-packet-info-disclosure':'7523',
    'snmp-bad-errorindex':'12042',
    'Oracle_NetAuth_Sesskey_Overflow':'8607',
    'Telnet_RESOLV_HOST_CONF':'13585',
    'Finger list':'2580',
    'rhel-rhsa-2007-0155-update':'10267',
    'TCP_Dataless_Session_RST_DoS':'5900002',
    'nt-add-workstation-onceonly':'7968',
    'malcode-OddSpawn':'6397',
    'rhel-rhsa-2008-0144-update':'10501',
    'mozilla-multiple-java-code-execution':'7103',
    'Y3K_IRC_notification':'15300',
    'decod-queso':'1726',
    'HTTP_Facebook_Newsroom_Inclusion':'5900002',
    'exploit-MSVisio(100025)':'2367',
    'spyware-bullabho':'12479',
    'Packet_Capturing_Remote':'8704',
    'rhel-rhsa-2006-0264-update':'10103',
    'reader-getannots-code-execution':'9345',
    'TFTP_file_name_overflow':'13662',
    'LandeskXFR_Execute':'5900002',
    'win-ms07kb934873-update':'14586',
    'rhel-rhsa-2010-0839-update':'5900002',
    'websphere-host-header-bo':'14257',
    'NetSpy_Response':'2001568',
    'SMB_IE_rpawinet_DLL_Hijacking':'5900002',
    'rhel-rhsa-2005-375-update':'9922',
    'mailenable-append-bo':'5900002',
    'rhel-rhsa-2008-0981-update':'5900002',
    'aix-iy64927-fix':'202',
    'land-dos':'5799',
    'HTTP_ColdFusion_SourceWindow':'2002617',
    'MSRPC_User_Enum':'7390',
    'Oracle_LotsOf_Remote_Registration':'5900002',
    'rhel-rhsa-2008-0973-update':'5900002',
    'anzio-wepo-bo':'378',
    'HTTP_Apache_PHP':'2105040',
    'ole-stream-bo':'8431',
    'CompoundFile_Visio_Version_Mem_Corruption':'2114054',
    'rhel-rhsa-2010-0518-update':'5900002',
    'proftpd-sreplace-bo':'9118',
    'win-media-asf-invalid-stream':'5900002',
    'socks-socks':'12335',
    'file-afctr-read-bo':'2460',
    'Flv_NetStream_Corruption':'5900002',
    'cvs-user-failed-auth-detected':'1575',
    'aix-iy85517-fix':'273',
    'sscan-scan':'12966',
    'rhel-rhsa-2006-0577-update':'10147',
    'udp-dos':'13833',
    'SMB_Samba_ReceiveRaw_BO':'2118136',
    'win-ms04036-patch':'14412',
    'image-halftone-size-bo':'5057',
    'SIP_Proxy_Overflow':'2113238',
    'OSPF_Lnk_State_Req':'8658',
    'win-workstation-service-bo':'14887',
    'libtiff-tifffetchanyarray-dos':'5887',
    'FTP_Port_Bounce':'2001302',
    'rhel-rhsa-2005-331-update':'9901',
    'http-login-known':'3647',
    'backdoor-stealthspy':'730',
    'multiple-browsers-idn-spoof':'7481',
    'win-ms08kb947890-update':'14638',
    'rhel-rhsa-2009-1426-update':'5900002',
    'http-ns-shockwave':'3655',
    'helix-server-displaystring-dos':'5900002',
    'HTTP_URL_MyLog':'2002540',
    'Amanda_TCP_Response':'2113072',
    'oracle-login-command-execute':'8567',
    'rhel-rhsa-2003-150-update':'9599',
    'malcode-SPNE_WrtFile_Hook':'6624',
    'quicktime-h264-movie-overflow':'9225',
    'oracle-layer-md2package-bo':'8562',
    'scanmail-smgsmxcfg30-password-bypass':'11352',
    'squid-wccp-recvfrom-bo':'12950',
    'rhel-rhsa-2009-0005-update':'5900002',
    'ftp-pasv-invalid-response-detected':'2858',
    'abel-backdoor':'33',
    'livedata-iccp-rfc1006-bo':'5998',
    'CGI_sh':'1206',
    'decod-ftp-syst':'1692',
    'RPC_high-port_portmap':'10954',
    'malcode-SPTRJ_Inet_CpySelf_Misc':'6714',
    'edonkey-session-detected':'2051',
    'SSH_OSF-1_security_level':'13051',
    'imap-authenticate-bo':'5137',
    'exim-syntax-format-string':'2338',
    'SNMP_V3_HMAC_Security_Bypass':'12291',
    'Win2K_DomainController_DOS':'2000209',
    'rhel-rhsa-2008-0233-update':'10534',
    'MSRPC_MSDNS_Request_Bo':'2118092',
    'HSRP_Default_Password':'3357',
    'HTTP POST contains compute%sum':'3517',
    'rhel-rhsa-2007-0871-update':'10385',
    'ie-xml-http-request-handling':'4873',
    'rhel-rhsa-2007-1068-update':'10450',
    'email-zip-content-executable':'5900002',
    'gdb-bfd-bo':'3068',
    'TCP post connection SYN':'13374',
    'malcode-SPSC_notNorm_reg_srch':'6708',
    'ie-center-element-code-exec':'5900002',
    'httpfileupload-activex-file-delete':'4544',
    'AnswerBook2_Execute':'368',
    'iis-bdir':'4909',
    'BrightStor_Discovery_TCP_Message_Overflow':'2106253',
    'HTTP_Sharepoint_Inplview_XSS':'5900002',
    'HTTP_POST_SQL_UnionAllSelect':'2113028',
    'SIP_Invalid_URI':'2114021',
    'ospf-short-header':'8647',
    'apache-php-view-files':'467',
    'bind-version-obsolete':'865',
    'TCP port scan':'13373',
    'rhel-rhsa-2010-0029-update':'5900002',
    'HTTP_Classifieds_Post':'2002590',
    'DesktopController_Warning':'1778',
    'netmeeting-desktop-sharing-dos':'7712',
    'CHM_Zero_DirChunkSize':'5900002',
    'dpapi-master-key-backup-attempted':'1996',
    'smb-guest-credentials-verified':'11723',
    'rhel-rhsa-2008-0105-update':'10493',
    'reg-logon-nonstandard-shell':'9404',
    'rhel-rhsa-2005-810-update':'10046',
    'aix-iy77141-fix':'247',
    'malcode-SPNE_SysFile_WrtEOF':'6618',
    'sap-mdrmsap-code-execution':'11298',
    'mailenable-base64-message-code-execution':'6115',
    'rsagent-config-logfiles-deletion-failed':'11021',
    'quicktime-java-applet-bo':'9233',
    'aix-IY88614-fix':'284',
    'scada-dnp-disable-responses':'11318',
    'w2k-still-image-service':'14191',
    'malcode-SPNE_Attribs_OddFirst':'6588',
    'win-ms12kb2663510-update':'5900002',
    'SMB_Samba_AndX_Offset_Infinite_Recursion':'5900002',
    'file-ordinary-files':'2535',
    'SNMP_Trap_Address_Underflow':'2106083',
    'malcode-HookSpy':'6326',
    'rhel-rhsa-2006-0427-update':'10122',
    'NDMP_Oracle_SecureBackup_Overflow':'7598',
    'HTML_Embed_Overflow':'2113240',
    'MSRPC_SPOOLSS_NotifyOp_Samba_Bo':'2118098',
    'quicktime-qtvr-code-execution':'5900002',
    'malcode-SPTRJ_Hide_EP_Srch':'6710',
    'ISA_FW_Init_Failed':'5497',
    'SNMP_V3_Field_Underflow':'2101058',
    'CGI_anyform2':'1176',
    'mssql-dts-reveal-passwords':'7403',
    'rhel-rhsa-2006-0725-update':'10196',
    'ie-vulnerable-mk':'4866',
    'Email_Virus_Iloveyou':'2002208',
    'mssql-webtask-gain-privileges':'7436',
    'Webevent admin':'14228',
    'user-file-permissions':'13955',
    'spyware-gmsoft-dialer':'12575',
    'rhel-rhsa-2008-0831-update':'5900002',
    'win-ms09kb975682-update':'14770',
    'linux-umlnet-gain-privileges':'5981',
    'CGI campas':'1131',
    'netscape-enterprise-list-directories':'7728',
    'HTTP_Squid_HTTP_Version_DoS':'2125008',
    'itunes-file-share-running':'5567',
    'anonftp-dir-owner':'354',
    'unix-setuid-core-event':'13898',
    'kazaa-running':'5691',
    'MSRPC_DFS_EnumInfo_Samba_Bo':'2118097',
    'postfix-mailfrom-rcptto-dos':'9058',
    'FileNail_TCP_Request':'2113106',
    'prov-system-warning':'9135',
    'Finger_RTM':'2608',
    'win-registry-runkey-concealed':'14817',
    'winpcap-bpffilterinit-code-execution':'15071',
    'avtech-activex-bo':'5900002',
    'allaire-jrun-jsp-execute':'314',
    'reg-sys-log-small':'9449',
    'rhel-rhsa-2007-0086-update':'10247',
    'ie-url-code-exec':'4856',
    'rsagent-group-userremoved':'11048',
    'Quake3Arena_Vulnerable_Client':'9202',
    'rhel-rhsa-2007-0087-update':'10248',
    'MSRPC_TrendMicro_String_BO':'2118110',
    'HTTP_IIS_ISAPI_DoS':'4062',
    'postgresql-load-gain-privileges':'9069',
    'rhel-rhsa-2008-0240-update':'10539',
    'HTTP_Cisco_CSA_FileUpload_DotDot':'5900002',
    'mutt-safeopen-race-condition':'7497',
    'zend-server-bridge-code-execution':'5900002',
    'win-ms05kb903235-update':'14457',
    'solaris-clibrary-libproject-gain-privileges':'12373',
    'win-ms03048-patch':'14398',
    'adobe-player-unspecified-bo':'5900002',
    'uucp-mail-forward':'14056',
    'malcode-Susp14e_1st_Jmp':'6745',
    'meetingmanager-atucfobj-dll-ce':'5900002',
    'netbios-hostname-detected':'7685',
    'RPC_CALLIT_mount':'10944',
    'Trace Route':'13744',
    'logwatch-tmp-race-condition':'6037',
    'telnet-xdisplay-long':'13546',
    'DB2_ACCSEC_Connect_DoS':'5900002',
    'SQLServer_login_failed_not_trusted':'12924',
    'SIP_Request_Invalid_Characters':'2114006',
    'weblogic-fileservlet-show-code':'14236',
    'rhel-rhsa-2007-0076-update':'10240',
    'qvtterm-login-dos':'9280',
    'rhel-rhsa-2009-1461-update':'5900002',
    'rhel-rhsa-2007-0960-update':'10409',
    'msjet-database-file-bo':'7255',
    'window-maker-image-bo':'15020',
    'win2k-rpc-dos':'14953',
    'imail-ldap-overflow':'5129',
    'HTTP_MDAC_Bidlab_DLL_Hijacking':'5900002',
    'serverprotect-rpcfnsynctask-bo':'11537',
    'win-ms05kb896688-update':'14448',
    'ms-certificates-spoofing':'5900002',
    'ourgame-gliedown2-gameinfo-bo':'8666',
    'LDAP_eDirectory_MonitorEventsRequest_Overflow':'2106283',
    'ras-urq-eid-changed':'9313',
    'ethereal-giop-dissector-dos':'2206',
    'Local_Client_Sent_Virus':'6007',
    'BOEP_services':'975',
    'adobe-svg-activex-code-execution':'5900002',
    'ftp-admin-login-success':'2827',
    'HTML_IE_Animation_Exec':'5900002',
    'excel-selection-record-bo':'2264',
    'everyone-writable-netbios-share':'2236',
    'http-suspicious-exe-transfer':'3694',
    'rhel-rhsa-2005-104-update':'9848',
    'spyware-iroffer':'12616',
    'active-directory-host-not-gcs':'64',
    'ms-owc-virtualcall-bo':'7197',
    'second-life-authenticationdetected':'11426',
    'TCP short header':'13376',
    'sap-message-group-bo':'5900002',
    'cmail-user-leak':'1367',
    'Kerberos_Principal_Name_Overflow':'5900002',
    'ms-smb-memory-priv-esc':'5900002',
    'WinMX_Download':'15056',
    'rhel-rhsa-2005-074-update':'9838',
    'user-trust-remote-account':'14023',
    'Firebird_SQL_Integer_Overflow':'5900002',
    'HTTP_UTF8_backtick':'4476',
    'Image_GIF_Oversized':'5900002',
    'Scheduled_Baseline_Comparision_Started':'11364',
    'spyware-wink':'12832',
    'Adobe_Flash_Player_SetNALUnit_Exec':'5900002',
    'snmp-extension-octet':'12068',
    'HTTP_IE_Content_Filename_Extension_Clip':'2122004',
    'websphere-header-dos':'14256',
    'eyeballmessengersdk-covideowindow-bo':'2404',
    'rhel-rhsa-mozilla-crypto-signtext-bo':'10712',
    'SMB_Java_Hotspot_Hijack':'5900002',
    'Gnutella_BearShare':'3149',
    'HTTP_InterscanViruswall_ChgCfg':'2002634',
    'EZshopper_search_CGI':'2414',
    'synflood':'13324',
    'ftp-mkd-command-detected':'2854',
    'winxp-server-signing-disabled':'15100',
    'quicktime-jpeg2000-overflow':'5900002',
    'backdoor-rws':'722',
    'FTP_IIS_IAC_Overflow':'5900002',
    'rhel-rhsa-2011-1000-update':'5900002',
    'win-trin00-daemon':'14863',
    'nisd-bo-check':'7851',
    'linux-doaddcounters-race-condition':'5923',
    'consona-tgctlcm-information-disclosure':'5900002',
    'dhcp-supersedelease-dos':'1797',
    'http-multiple-login-failed':'3650',
    'win-ms11kb2476490-update':'5900002',
    'iis-basic-http-auth':'4908',
    'oracle-web-cache-bo':'8582',
    'FTP_Password_Overflow':'2001307',
    'IS_Medium_Vulnerability_Found':'5425',
    'sun-java-javaapi-security-bypass':'13207',
    'sniffer-agent-snmp-bo':'11961',
    'blackice-noncompliance-warning':'924',
    'oracle-appserver-info-sample':'8520',
    'IP_SS_Ping':'2000021',
    'Helix_Server_DoS':'2110050',
    'bgp-route-unreachable':'819',
    'portmapper-unknown-rpc-call':'9051',
    'spyware-firstcash-websearch':'12560',
    'SMTP date overflow':'11808',
    'wireshark-httpdissector-dos':'15119',
    'ISA_PF_Dial_Out_Rebind_Failure':'5507',
    'IPP_CUPS_Undefined_String_Exec':'5900002',
    'CompoundFile_Movie_Maker_Overflow':'1442',
    'smb-share-everyone-readable':'11726',
    'Non-Compliance_Warning':'7895',
    'HTTP_Tivoli_GetMimeType_SQL_Injection':'5900002',
    'cisco-cns-registrar-default-account':'5900002',
    'subversion-filename-directory-traversal':'13193',
    'SNMP_OID_Overflow':'2106102',
    'pop-default':'8981',
    'bigsam-safemode-path-disclosure':'835',
    'Oracle_GrantTypeAccess_Injection':'5900002',
    'bi-soap-accessdenied':'825',
    'malcode-RebootDropper1':'6444',
    'malcode-RebootDropper0':'6443',
    'novell-iprint-uploadresourcetorms-bo':'7937',
    'http-cgi-nphpublish':'3589',
    'nfs-mknod':'7802',
    'mozilla-universalbrowserread-escalation':'7133',
    'Bugs':'1034',
    'UNIX_Root_Su_Successful':'13901',
    'win2k3-smtp-execute-code':'14997',
    'isa-wps-stop':'5479',
    'word-smarttag-code-execution':'15157',
    'rhel-rhsa-2005-831-update':'10054',
    'sapgui-eaiwebviewer3D-webviewer3d-activex-bo':'11300',
    'hpopenview-nnm-multiple-cgi-bo':'3340',
    'HTTP URL bad hex code':'3530',
    'sapgui-sapirrfc-activex-bo':'11301',
    'gnupg-reveal-private':'3141',
    'zlib-gzprintf-bo':'15375',
    'win-ms09kb976307-update':'14771',
    'win-mail-code-execution':'14366',
    'sgi-pfdispaly':'11570',
    'HTTP_Websendmail':'2002535',
    'RPC_Informix_MachineName_Overflow':'5900002',
    'reg-ras-passwords-saved':'9425',
    'word-macro-security-bypass':'15151',
    'ie-security-zone-bypass':'4837',
    'JPEG_2000_JasPer_Overflow':'5900002',
    'tooltalk':'13737',
    'QAZ_Backdoor_Email':'2100001',
    'HTTP_ColdFusion_RDS_Password':'3849',
    'SMTP Xchg Auth':'11847',
    'HTML_Outlook_Codebase_Execute':'2113034',
    'FTP Site Exec Format Attack':'2819',
    'exploit-MSVisio(100039)':'2371',
    'Bionet_ICQ_pager_URL':'875',
    'nt-wins-patch':'8371',
    'synactis-allinthebox-activex-file-overwrite':'13320',
    'JavaScript_Capicom_Certificates':'2114040',
    'TFTP file not found':'13632',
    'stunnel-sigchld-handler-insecure':'13169',
    'rhel-rhsa-2006-0675-update':'10182',
    'uusee-activex-bo':'5900002',
    'php-mail-safemode-bypass':'8874',
    'HTTP_wguestexe':'2002526',
    'SMB_NT_Transact_Bo':'2110039',
    'Invalid_License_Key':'5259',
    'ssh2-passwd-auth-failed-empty-passwd':'12996',
    'ie-application-invocation':'4689',
    'HTTP GET data overflow':'3502',
    'HTTP_WWWThreads_Admin':'2106037',
    'ms-ie-css-code-execution':'5900002',
    'win-ms11kb2489279-update':'5900002',
    'FTP_file_name_overflow':'2917',
    'rhel-rhsa-2008-1028-update':'5900002',
    'rhel-rhsa-2006-0262-update':'10102',
    'klez-worm':'5784',
    'IIS_.printer_overflow':'5013',
    'RPC Amd Version':'10846',
    'icq-file-transfer':'4630',
    'nt-getadmin-present':'8080',
    'group-password':'3179',
    'Rockliffe CGI exploit':'10836',
    'cisco-ios-sccp-dos':'1302',
    'nt-guessed-operpwd':'8121',
    'ms-snmp-bo':'7208',
    'smtp-rcpt':'11871',
    'inetd-path-invalid':'5205',
    'user-mntdev-block':'13991',
    'tektronix-phaserlink-webserver-backdoor':'13502',
    'Empty fragment':'2168',
    'Exchange_unauthenticated_logon_attempt':'2325',
    'RPC_NFS_NLM_CallerName_Overflow':'5900002',
    'rhel-rhsa-2009-1430-update':'5900002',
    'win-ms10kb979559-update':'5900002',
    'malcode-ExeSeq22_COM':'6268',
    'rhel-rhsa-2010-0331-update':'5900002',
    'postquery-http-post-bo':'9078',
    'novell-client-nwfilter-privilege-escalation':'7908',
    'win-ms03044-patch':'14394',
    'UDP_Storm_Worm':'13865',
    'win-grpconv-bo':'14336',
    'malcode-SystemModScript':'6795',
    'http-cgi-formmail-exe':'3575',
    'win-active-directory-ldap-bo':'14285',
    'scada-modbus-restart-dos':'11330',
    'apple-quicktime-qtplugin-bo':'497',
    'UNIX_Root_Login_Successful':'13899',
    'win-ms06kb921398-update':'14524',
    'socks-v5-misconf':'12338',
    'rhel-rhsa-2003-284-update':'9631',
    'SNMP_Counter64':'2106120',
    'brightstor-sun-rpc-bo':'5900002',
    'Cerebus_Scan':'1120',
    'Image_Grid_Overflow':'5086',
    'Backage_TCP_Request':'2113064',
    'ie-tostatichtml-information-disclosure':'5900002',
    'ie-revalidate-certificate':'4825',
    'spyware-searchalot':'12721',
    'spyware-broadcastpc':'12473',
    'Network_Normal':'7782',
    'malcode-SPPE_Jmp_RelocExec_DLL':'6678',
    'firefox-jsdbgapi-code-execution':'2628',
    'lotus-domino-smtp-envid':'6052',
    'dgux-fingerd':'1786',
    'tomcat-implicitobjects-xss':'13725',
    'win-ms10kb2378111-update':'5900002',
    'OTF_Malformed':'5900002',
    'IMAP_Long_Mbox':'2000806',
    'IRC_Notice':'5400',
    'win-ms05kb905915-update':'14463',
    'IP_Unknown_Protocol':'5303',
    'nds-user-no-password':'7639',
    'win-ms11kb2567053-update':'5900002',
    'ike-association-failed-peer-auth':'5027',
    'aoaaudioextractor-activex-code-execution':'5900002',
    'Script_Safari_DocWrite_Exec':'5900002',
    'TrojanCow_TCP_Request':'2113150',
    'axent-netprowler-ipfrag-dos':'639',
    'dhcp-long-discover-message':'1794',
    'HTML_IE_Render_Memory_Corruption':'2110112',
    'active-directory-write-descriptor':'77',
    'cisco-cdp-enabled':'1269',
    'spyware-twaintech':'12782',
    'smb-bo':'11719',
    'win-ms09kb968537-update':'14725',
    'user-homedir-type':'13973',
    'nfs-netgroup':'7805',
    'http-cgi-exec':'3572',
    'CGI guestbook':'1140',
    'rhel-rhsa-2003-259-update':'9624',
    'WebSpeed admin URL':'14252',
    'trillian-xml-bo':'13760',
    'dhcp-ack':'1789',
    'win-ms10kb2320113-update':'5900002',
    'HTTP_URL_dotpath':'2000616',
    'SynDrop_attack':'13323',
    'WebSpeed_admin_URL':'14254',
    'Exchange_nntp_authentication_failures':'2319',
    'SNMP_disable_authen-traps':'12196',
    'nt-group-increase-quota':'8094',
    'legato-portmapper-obtain-information':'5863',
    'ultracrypto-cryptox-file-overwrite':'13873',
    'linux-sysctl-read-memory':'5976',
    'bftpd-site-chown-bo':'814',
    'mssql-agent-create-files':'7396',
    'subversion-svn-bo':'13194',
    'VNC_no_authentication':'14164',
    'SubSeven_Response':'2001519',
    'nt-samba-bo':'8292',
    'HTTP_Tomcat_URI_Overflow':'2114005',
    'zope-zclass-gain-privileges':'15398',
    'Code Red II+':'1380',
    'winnt-cryptkeys-compromise':'15058',
    'rhel-rhsa-2005-598-update':'9993',
    'rhel-sendmail-localhost-spoofing':'10773',
    'HTTP_Indeo_Filter_DLL_Hijacking':'5900002',
    'spyware-pkings-iehelper':'12690',
    'win-ms06kb920685-update':'14522',
    'imail-express-message-bo':'5127',
    'vm-host-scan':'14119',
    'rhel-rhsa-2003-016-update':'9563',
    'win-ms06kb905555-update':'14470',
    'DCOM_SystemActivation_DoS':'2118107',
    'MSRPC_Registry_Write_IMail_Admin':'2003208',
    'Script_OWC_BO':'11396',
    'TLS_Client_Cipher_Renegotiation':'13718',
    'TFTP_Put':'13676',
    'webex-atdl2006-bo':'5900002',
    'officeviewer-ftpuploadfile-bo':'5900002',
    'smtp-email-from-empty':'11855',
    'backupexec-dataprotocol-bo':'774',
    'FTP_Rnfr_Very_Long':'2001349',
    'malcode-KeylogIndicator':'6369',
    'HTTP_Oracle_AppServer_OPMN_FmtString':'2125012',
    'file-cronat-grants':'2470',
    'is-directorylistings-dos':'5900002',
    'SQL_Injection_Declare_Exec':'5900002',
    'aix-sendmail-mail-relay':'301',
    'rhel-rhsa-2004-634-update':'9782',
    'HTTP_UBB_Posting_Topic':'2002571',
    'Retina_Scan':'9495',
    'nt-group-SIDs':'8107',
    'PCAP_Wireshark_DECT_Overflow':'5900002',
    'gnome-esound-symlink':'3123',
    'zope-classes-return-value':'15394',
    'Glacier':'3101',
    'afp-unspec-bo':'5900002',
    'DFchGrisch_TCP_Response':'2113093',
    'remote-root-login-success':'9470',
    'exploit-MSExcel(100007)':'2345',
    'oracle-def-acct':'8550',
    'freesshd-ssh-dos':'5900002',
    'rhel-rhsa-2006-0328-update':'10114',
    'rhel-rhsa-2007-0018-update':'10222',
    'rhel-rhsa-2007-0327-update':'10287',
    'nfs-super':'7818',
    'saned-sanenetinit-memory-consumption':'11297',
    'SQL_Sybase_Login_Exec':'5900002',
    'MIF_Notes_Comment_Overflow':'5900002',
    'ms-moviemaker-bo':'7188',
    'HTTP_IE_ActiveX_ControlMemoryCorruption':'2113252',
    'win-msmq-rpc-code-execution':'14793',
    'Exchange_pop3_authentication_failures':'2320',
    'FTP_Mlst_Very_Long':'2001348',
    'cisco-ios-isakmp-profile-gain-access':'1295',
    'snmp-v3-flags-overflow':'12125',
    'rsagent-oracle-object-failed':'11090',
    'CGI formmail':'1137',
    'MSRPC_Share_Enum':'7369',
    'ms-ie-layout-code-exec':'5900002',
    'SQL_LogExplorer_Overflow':'2113013',
    'isa-ipsec-config-changed':'5451',
    'win-builtin-guestaccount-enumerated':'14300',
    'RPC_showmount_exports':'10984',
    'formmail-installed':'2704',
    'http-cgi-nlog-metachars':'3587',
    'SMTP_false_attachment':'11905',
    'nap-pubmsg':'7555',
    'spyware-sckeylog-trojan':'12718',
    'imail-q-bo':'5900002',
    'SNMP bad specific trap':'11980',
    'RTF_Word_Overflow_Exec':'5900002',
    'Spyware_PH_EzulaTopText':'2113186',
    'HTML_VML_Style_Abuse':'5900002',
    'libpng-wide-image-bo':'5880',
    'canna-irwthrough-bo':'1097',
    'firewire-ieee1394-interface-installed':'2660',
    'logon-with-explicit-credentials-success':'6031',
    'MSM_ConfigurationChanged':'7257',
    'logon-with-explicit-credentials-failure':'6030',
    'nt-dormant-account':'8062',
    'GateCrasher_Response':'2001520',
    'firewall-disabled':'2642',
    'cisco-ios-account-bruteforce':'1279',
    'ie-ms03004-patch':'4799',
    'ms-win-server-browser-bo':'5900002',
    'baofeng-sparser-bo':'795',
    'Service_ticket_granted':'11551',
    'user-ras-dialin':'14007',
    '3dlifeplayer-webplayer-bo':'5900002',
    'Email_To':'2145',
    'pam-icq-parsing-bo':'8707',
    'rhel-rhsa-2007-0595-update':'10344',
    'win-csnw-bo':'14307',
    'stream-dos':'13154',
    'oracle-jsp-reveal-path':'8560',
    'tivoli-login-language-bo':'13708',
    'rhel-rhsa-2006-0197-update':'10091',
    'SMB_Search_Length_Overflow':'11786',
    'ms-excel-unspecified-code-execution':'7176',
    'Security_enabled_universal_group_deleted':'11465',
    'user-trust-hosts':'14018',
    'zone-unsigned-download':'15392',
    'nt-create-object':'8023',
    'lpviewer-lpcontrol-activex-bo':'6083',
    'retina-scanner':'9494',
    'rhel-rhsa-2007-0011-update':'10218',
    'rhel-rhsa-2005-543-update':'9977',
    'samba-secioacl-bo':'11275',
    'SIP_Contact_Overflow':'2107011',
    'malcode-HTMLLongLoopDetections':'6332',
    'malcode-PoorDropper2':'6426',
    'rhel-rhsa-2004-448-update':'9744',
    'Vampire_TCP_Response':'2113043',
    'ms-win-smbrequest-dos':'5900002',
    'spyware-coolsavings':'12502',
    'backdoor-host-control':'695',
    'Y3K_UDP_Response':'2001537',
    'HTML_FTP_Command':'2121009',
    'rhel-rhsa-2004-244-update':'9710',
    'nt-pwd-expired':'8253',
    'iis-webdav-running':'5007',
    'iis-check-8.3-registry':'4911',
    'Suspect_WWW':'13272',
    'outlook-nntp-code-execution':'8686',
    'openldap-slapmodrdn2mods-code-exec':'5900002',
    'spyware-win32-pwsteal-tarno':'12824',
    'FTP_Command_Overflow':'2001317',
    'HTTP_PHF':'4262',
    'nav-submission-security':'7584',
    'IRC_VirusScanTrojan':'5410',
    'rhel-rhsa-2007-0245-update':'10279',
    'myspace-login-detected':'7506',
    'oracle-appserver-http-bo':'8519',
    'Wh00t_Rootkit_Login':'2116002',
    'sun-jre-scripting-info-disclosure':'13221',
    'HTTP_BadBlue_DirDisclosure':'2002649',
    'openview-data-code-exec':'5900002',
    'upx-engine-gain-control':'13929',
    'chrome-svg-filter-code-exec':'5900002',
    'spyware-ucsearch':'12785',
    'HTML_AntiVirus_Evasion':'2114171',
    'ms-ie-tostatichtml-information-disc':'5900002',
    'rhel-rhsa-2005-100-update':'9845',
    'win2k-corrupt-lsp':'14906',
    'AUDIT_DNS_Version_Request':'604',
    'OneOfTheLastTrojans_TCP_Request':'2113220',
    'ca-arcservebackup-netbackup-code-execution':'1068',
    'rhel-rhsa-utillinux-pamacctmgmt-sec-bypass':'10770',
    'iis-asp-vbscript-source':'4904',
    'HTTP_Tivoli_Rembo_Bo':'4424',
    'visualstudio-pdwizard-code-execution':'14111',
    'reg-app-log-small':'9391',
    'xm-ftpserver-user-dos':'15238',
    'NNTP_From_Overflow':'2002401',
    'IMAP4_port_probe':'5163',
    'ofm-oit-cd-bo':'5900002',
    'Successful_Network_login':'13197',
    'dafolo-helpurl-caburl-bo':'1617',
    'mailalias-gw':'6110',
    'php-logging-format-string':'8870',
    'mgetty-cndprogram-callername-bo':'6999',
    'evolution-writehtml-format-string':'2243',
    'rhel-rhsa-2007-0008-update':'10215',
    'nvr-nvunifiedcontrol-bo':'8395',
    'Amd_Overflow':'347',
    'rhel-rhsa-2009-0021-update':'10620',
    'HTTP_SubscribeMe_Setup':'2118007',
    'HTTP field with binary':'3492',
    'Image_EMF_Palette_Read_Overflow':'2121037',
    'malcode-NetworkWorm':'6387',
    'winxp-strong-sessionkey-disabled':'15106',
    'iis-isapi-idq-bo':'4957',
    'vmware-activex-unspecifed6':'14141',
    'DNS_TCP_Malformed':'5900002',
    'openssl-ssl3-masterkey-bo':'8498',
    'socks-port-probe':'12333',
    'DHCP_Large_Option_Bo':'2118068',
    'rhel-rhsa-2006-0206-update':'10097',
    'snmp-long-community-string':'12086',
    'SMB_LSA_Connect':'11758',
    'rhel-rhsa-2003-134-update':'9595',
    'win-error-report-detected':'14324',
    'HTTP_Apache_Chunked_BO':'2114000',
    'bugbear-worm':'1033',
    'win-authenticode-code-execution':'14295',
    'malcode-SuspectedAVDisable':'6781',
    'watchguard-soho-web-auth':'14205',
    'nt-rcmd':'8266',
    'TSM_CAD_Scheduler_Overflow':'13811',
    'isa-window-oob-attack-detected':'5478',
    'TFTP_pwl_file_type':'13678',
    'ibm-tsm-server-unauthorized-access':'4580',
    'decod-pop-user':'1724',
    'rhel-rhsa-2005-198-update':'9872',
    'SMB_PIPE_Invalid_Ptr_Corruption':'2118076',
    'HTTP_Glimpse':'2002513',
    'RemoteWindowsShutdown_Response':'2001574',
    'SSH_ChallengeReponse_Bo':'13032',
    'Svg_Circle_Transform_Overflow':'5900002',
    'CVS_Request_Argument_Overflow':'2107026',
    'postgresql-cursor-bo':'9065',
    'win-ms10kb2292970-update':'5900002',
    'Cold Fusion cache URL':'1385',
    'symantec-intelams2-command-exec':'5900002',
    'win-smb-filename-bu':'14842',
    'NetBus_Pro':'7703',
    'apache-401-cgi':'405',
    'identd':'4670',
    'quicktime-table-atom-overflow':'9251',
    'HTTP_PHP_Includedir':'2002693',
    'SQL_Login':'12903',
    'rhel-rhsa-2004-190-update':'9700',
    'cvs-user-success-auth-detected':'1576',
    'brightstor-enterprise-backup-bo':'1006',
    'flashplayer-activex-control-dos':'5900002',
    'java-brownorifice':'5578',
    'SIP_Version_Not2':'2116021',
    'service-dacl-change':'11544',
    'openoffice-gif-bo':'5900002',
    'gftp-format-string':'3080',
    'Firewall_Configuration_Change':'2646',
    'Application_Control_Request_Overflow':'527',
    'Network_Access_Blocked':'7779',
    'HTTP_GET_Filename_admserv':'2101005',
    'File_Deleted':'2565',
    'mysql-ascii-sql-injection':'7509',
    'web-browser-certificate-validation':'14215',
    'malcode-SPNE_OverWrt_Cmos':'6601',
    'malcode-IRCbot':'6355',
    'spyware-globaldialer':'12574',
    'sendmail-warning-not-enabled':'11515',
    'rhel-rhsa-2007-1045-update':'10442',
    'apache-serversignature':'475',
    'win-dns-query-spoofing':'14316',
    'passwd.txt_URL':'8741',
    'gtrust-unknown-same':'3223',
    'blackice-evaluation-ended':'914',
    'win2k-automation-assertion':'14902',
    'decod-finger-overflow':'1684',
    'MySQL_Login_Handshake_Information_Disclosure':'5900002',
    'FTP_Mkd_Overflow':'2001312',
    'rhel-rhsa-2006-0677-update':'10184',
    'file-swap-insecure':'2549',
    'HTTP_PHP_CGI_Exec':'5900002',
    'boep':'962',
    'amxnetlinx-hostpasswordlogfile-bo':'350',
    'Script_Toshiba_RecordSend_BO':'2122034',
    'rsagent-localgroup-deleted':'11069',
    'SMB file name overflow':'11705',
    'gotomypc-present':'3167',
    'aix-iy77638-fix':'249',
    'Avaya_Cajun_Default_SNMP':'2111001',
    'file-default-console-su':'2474',
    'OTF_Bitmap_Location_Overflow':'5900002',
    'DNS spoof successful':'1857',
    'flash-unspec-ce-var9':'5900002',
    'allaire-jrun-view-jsp-source':'320',
    'spyware-advertbar':'12443',
    'TelnetTerminaltypeLong':'13613',
    'JavaScript_Browser_Overwrite':'2109030',
    'TCP_Network_Scan':'2102043',
    'java-vm-verifier-variant':'5585',
    'JavaScript_Behavior_Time':'5900002',
    'HTML_Iframe_JavaScript':'3419',
    'SMTP_To':'11943',
    'spyware-win32-kwbot-c':'12821',
    'mta-discovery':'7473',
    'theflu-backdoor':'13686',
    'win2k-accessibility-gain-privileges':'14891',
    'uoc-ultraofficecontrol-bo':'13910',
    'PPTP_Badmagic':'2002901',
    'win-compressed-folders-bo':'14305',
    'HTTP_OpenView_NNM_OvAlarm_Overflow':'4212',
    'iis-webdav-xml-attribute-dos':'5009',
    'rc-file-worldwritable':'9330',
    'spyware-win32-kwbot-p':'12822',
    'acrobat-reader-activex-bo':'49',
    'http-server-side-include-injection':'3688',
    'Finger_forwarding_overflow':'2600',
    'Image_EMF_GDI_Heap_Overflow':'5900002',
    'rhel-rhsa-2007-0055-update':'10227',
    'SSH2_Hostbased_auth_successful':'13012',
    'http-put':'3678',
    'viewsrc-cgi-view-files':'14085',
    'rsagent-mssql7-shutdown':'11080',
    'HTTP_asp_with___appended':'3776',
    'QuickTime_Image_Description_Code_Execution':'9268',
    'winxp-sp1-not-installed':'15103',
    'ie-cert-send':'4709',
    'CompoundFile_Excel_FNGroupCount_BO':'2106226',
    'ie-content-advisor-bo':'4715',
    'rservice-exec-enabled':'11183',
    'decod-http-authent':'1695',
    'htmlcapture-activex-file-overwrite':'3478',
    'SNMP_AuthTraps_Disable':'2002011',
    'HTTP_GroupWise_AcceptLang_Overflow':'2106276',
    'Image_GIF_MSNMessenger_Execute_Code':'2116019',
    'user-login-shell-exist':'13983',
    'HTTP_login_name_well_known':'4132',
    'Glacier_Request':'3103',
    'HTTP cgi starting with php':'3486',
    'win-ms12kb2647516-update':'5900002',
    'HTTP POST data with repeated char':'3524',
    'wsftp-long-command-bo':'15178',
    'Image_TIFF_GDI_Buffer_Overflow':'5104',
    'TCP_443_Protocol_Unknown':'13402',
    'SOAP_TotalDefense_SQL_Injection':'5900002',
    'rhel-rhsa-2005-743-update':'10013',
    'LDAP_Filter_Overflow':'2107015',
    'rhel-rhsa-2004-462-update':'9747',
    'win-ms11kb2489283-update':'5900002',
    'pbemail-savesendertoxml-file-overwrite':'8751',
    'adobe-download-aom-bo':'118',
    'spyware-whazit':'12805',
    'mediawiki-image-command-execution':'6981',
    'win2k-serviceticket-granted':'14961',
    'Email_IE_ObjectType_Overflow':'2104016',
    'tivoli-array-information-disclosure':'13705',
    'nt-users-without-descriptions':'8363',
    'file-default-passwd-insecure':'2481',
    'php-includedir-code-execution':'8868',
    'GirlFriend_Response':'2001521',
    'win-ms10kb980232-update':'5900002',
    'postgresql-makeselectstmt-arbitrary-bo':'9070',
    'win-ms12kb2671605-update':'5900002',
    'win-ms10kb2207559-update':'5900002',
    'rhel-rhsa-2002-120-update':'9511',
    'rhel-rhsa-2007-0402-update':'10313',
    'XML_SearchMS_Condition_Exec':'15259',
    'kphone-stun-dos':'5793',
    'rsagent-imap2-autologout':'11051',
    'Image_BMP_MediaPlayer_Bo':'2118056',
    'malcode-SimpleDaemon':'6526',
    'webex-webexucfobject-bo':'14232',
    'rhel-rhsa-2006-0682-update':'10186',
    'rhel-rhsa-2007-0343-update':'10291',
    'otf-malformed':'5900002',
    'wireshark-ieeedissector-dos':'15120',
    'SQL_Jet_ODS_Overflow':'2113020',
    'rtssentry-ptzcampanelctrl-bo':'11221',
    'HTTP_HP_Insight_Backdoor_Attempt':'5900002',
    'HTTP_Connect':'3860',
    'ie-java-enabled':'4784',
    'file-mail-type':'2523',
    'nds-logon-limit':'7611',
    'win-tcpip-icmpv6route-code-exec':'14855',
    'rpc.portmap.set':'10915',
    'ibm-lenovo-acprunner-method-code-execution':'4572',
    'POP_Filename_Overflow':'2000703',
    'CompoundFile_Ole_LoadPicture_Overflow':'2114058',
    'decod-webfinger-attempt':'1756',
    'System_Heap_Overflow':'2114074',
    'Application Protection Started':'507',
    'seqport':'11528',
    'Applix_Graphics_Document_Overflow':'534',
    'imagemagick-graphicsmagick-palm-bo':'5119',
    'CoalescerStatistics':'1371',
    'Scada_DNP_ColdRestart':'11334',
    'rhel-rhsa-2008-0971-update':'10612',
    'LsaLookup_DoSLsa':'6088',
    'ie-cache-elementfrompoint-dom-access':'4697',
    'bigorna-backdoor':'833',
    'All_Proventia_protection_started':'312',
    'mediahouse-stats-login-bo':'6975',
    'decod-netbios-reject':'1714',
    'winamp-pls-file1-bo':'5900002',
    'malcode-ExeSeq41':'6285',
    'apache-prefork-mpm-dos':'469',
    'XML_QuickTime_Media_Link_Detected':'15254',
    'rhel-rhsa-2008-0235-update':'10535',
    'BIFF_Workbook_Selection_Overflow':'2106222',
    'HTTP_Unix_Passwd_File_Accessed':'2110193',
    'IP_Tunnel_Bad_Version':'2110066',
    'rsagent-account-policychanged':'11012',
    'win-ms07kb930178-update':'14573',
    'ras-noaccess':'9310',
    'DNS_Client_Overflow':'2113261',
    'malcode-Win32_Jeefo_a':'6879',
    'HTTP_Long_Options_URL':'4134',
    'HTTP_Java':'4106',
    'ike-main-mode-association-ended':'5029',
    'downloadmanager-url-code-execution':'1993',
    'adobe-flash-activex-information-disclosure':'120',
    'rsagent-sybase-shutdown':'11162',
    'Conficker_P2P_Protection':'2110190',
    'MSRPC_LSA_AddPriv_Samba_Bo':'2118096',
    'win-gdi-wmf-overflow':'14334',
    'Dtspcd_Overflow':'2113001',
    'malcode-Spawn0':'6530',
    'TSM_WdsfSession_Overflow':'2114061',
    'TeleCommando_Response':'2001586',
    'Failure_on_Startup':'2437',
    'malcode-SPNE_ExpImp__DLL':'6592',
    'win-wks-netrwkstauserenum-dos':'14880',
    'oracle-appserver-ndwfn4-bo':'8524',
    'rhel-rhsa-2005-809-update':'10045',
    'AolAdmin_Response':'2001538',
    'outlook-ical-vevent-bo':'8679',
    'rhel-rhsa-2003-317-update':'9641',
    'Trinoo_Master_Response':'2100005',
    'midi-malformed':'5900002',
    'sun-jre-proxy-security-bypass':'5900002',
    'imesh-imwebcontrol-bo':'5190',
    'HTTP_MS_WSDAPI_Code_Exec':'4168',
    'win2k-telnet-idle-sessions-dos':'14975',
    'rhel-rhsa-2006-0665-update':'10176',
    'file-uucp-incorrect':'2558',
    'netscape-java':'7734',
    'SNMP_SUN_hidden_community':'12269',
    'ICC_Profile_Generic_Tag_Overflow':'5900002',
    'malcode-SPPE30_SysDir_IniMod':'6644',
    'nt-alerter':'7976',
    'igss-igssdataserver-bo':'5900002',
    'SMB_Google_Earth_DLL_Hijacking':'5900002',
    'HTTP_Authentication_Format_String':'2118106',
    'spyware-adultxut':'12442',
    'win-ms10kb2412048-update':'5900002',
    'ibm-informix-dynamic-oninit-bo':'5900002',
    'MS_Excel_XLSX_Parsing_Exec':'7237',
    'webcart-cgi-command-execution':'14227',
    'wmvdown-trojan':'15148',
    'HTTP_IRunbook_FileDisclosure':'2106157',
    'iis-indexserver-reveal-path':'4951',
    'iis-exair-dos':'4927',
    'XML_JNLP_Sys_Property_Override':'15252',
    'rhel-rhsa-2004-178-update':'9696',
    'HTTP_IIS_UTF8_Evasion':'2106053',
    'HTTP_Cart32_Expdate':'2002612',
    'office97-files-date':'8418',
    'spyware-downloadware':'12530',
    'user-unauth':'14024',
    'HTTP_PHPMyAdmin_Sql_Include':'2002675',
    'win-webdav-miniredirector-bo':'14875',
    'win-ms07kb937143-update':'14595',
    'ms-word-rtf-bo':'5900002',
    'firefox-browser-code-exec':'5900002',
    'socks-misconf':'12331',
    'SMB_System32_FileWritten':'2116016',
    'rhel-rhsa-2005-335-update':'9904',
    'Schwindler':'11365',
    'HTTP_Lotus_Domino_Date_Overflow':'2113209',
    'malcode-DelTreeWeak':'6207',
    'nt-logon-expiration':'8165',
    'HTTP_HackATack_ICQ_Pager':'2002605',
    'HTML_IE_Uninitialized_Memory_Corruption':'3416',
    'ms-ras-phonebook-bo':'7200',
    'ASN1_NSS_Cert_Sec_Bypass':'577',
    'Y3K_trojan_horse_activity':'15304',
    'HTTP_IIS_Tilde_DoS':'2110135',
    'malcode-SSM4':'6729',
    'exploit-MSWord(100026)':'2379',
    'malcode-SSM2':'6727',
    'malcode-SSM1':'6726',
    'start-run-enabled':'13130',
    'http-anyform':'3550',
    'ipsec-policy-agent-failed':'5349',
    'rhel-rhsa-2004-072-update':'9675',
    'rsagent-exchange-logon-failure':'11029',
    'aix-iy88681-fix':'288',
    'nt-samba-share':'8293',
    'win-ms10kb2360131-update':'5900002',
    'ms-frontpage-get-htimage':'7177',
    'jcomsoft-anigif-readgif-readgif2-bo':'5666',
    'Code Red II':'1381',
    'SSH2_Passwd_auth_successful':'13021',
    'system-audit-events':'13336',
    'nt-hoppaanalyzer-present':'8136',
    'jakarta-tomcat-admin':'5572',
    'user-groups':'13959',
    'smb-win-ini-access':'11733',
    'XFS_Invalid_Opcode':'2106164',
    'rhel-rhsa-2012-0093-update':'5900002',
    'nt-logon-service':'8169',
    'malcode-SpawnExeSus':'6535',
    'sdp-long-value':'11410',
    'malcode-vba93_03':'6848',
    'snort-rpc-fragment-bo':'12308',
    'VNC_Login_Failed_User':'2001612',
    'HTTP_UAG_Cookie_DoS':'5900002',
    'win-dhcp-client-bo':'14313',
    'rhel-rhsa-2004-084-update':'9678',
    'win2k-local-troubleshooter-bo':'14934',
    'JBIG2_Symbol_Dict_Overflow':'5900002',
    'ie-iscomponentinstalled-bo':'4783',
    'aix-iy63363-fix':'187',
    'NetSphere client':'7747',
    'ssh2-passwd-auth-failed-wrong-passwd':'12998',
    'win-ms08kb932349-update':'14619',
    'amd-version':'346',
    'CSS_IE_Flag_Code_Execution':'5900002',
    'malcode-vba93_05':'6850',
    'FTP Site Chown Overflow':'2815',
    'SQL_XP_CMDSHELL_Detected':'12920',
    'rhel-rhsa-2006-0573-update':'10143',
    'voip-protocol-packet-dos':'14171',
    'shareaza-running':'11581',
    'ftp-format-string':'2844',
    'UDPBomb':'13868',
    'UPNP_NOTIFY_overflow':'13927',
    'rhel-rhsa-2007-0431-update':'10317',
    'SNMP bad version size':'11984',
    'Telnet_Env_Overflow':'2000914',
    'gimp-xcfloadvector-bo':'3096',
    'Exchange_user_login_into_other_users_mailbox':'2331',
    'rhel-rhsa-2007-0014-update':'10220',
    'SMTP_date_overflow':'11892',
    'ms-blast-worm':'7162',
    'openssh-challenge-response-bo':'8466',
    'Image_PNG_Zlib_Bo':'2118073',
    'wordperfect-ms04027-patch':'15161',
    'rhel-rhsa-php-wddx-information-disclosure':'10758',
    'XML_JNLP_j2se_Vm_Args_Overflow':'5900002',
    'rhel-rhsa-2010-0577-update':'5900002',
    'nt-lsa-domain-sid':'8173',
    'HTTP_IIS_CmdAsp':'2002639',
    'NNTP_Cancel_Overflow':'2002404',
    'gif-extension-overflow':'3090',
    'Telnet_many_AYTs':'13579',
    'aix-iy68464-fix':'221',
    'tpme-multiple-sql-injection':'5900002',
    'win2k-deny-access':'14907',
    'rhel-rhsa-2005-300-update':'9890',
    'spyware-visicom-media':'12795',
    'joe-execute-commands':'5671',
    'ftp-wrapped':'2880',
    'remotedesktopprotocol-dll-ce':'5900002',
    'crontab-perms-world':'1545',
    'FTP_port_probe':'2972',
    'win-ms10kb981210-update':'5900002',
    'rsh-default':'11194',
    'UDP_Port_Loopback':'2000202',
    'AgentManager_Error':'155',
    'xmpp-message':'15263',
    'rhel-rhsa-2005-105-update':'9849',
    'NNTP_List_Response_Overflow':'2106193',
    'decod-ident-user':'1702',
    'win-ms11kb2538814-update':'5900002',
    'rhel-rhsa-2004-585-update':'9770',
    'SMB_Transaction_Response_Overflow':'5900002',
    'http-cgi-jj':'3583',
    'rpc-getport-audit':'10875',
    'dtr-backdoor':'2011',
    'file-acl-optional':'2458',
    'sip-response-dos':'11633',
    'rhel-rhsa-2009-0332-update':'5900002',
    'oracle-reports-server-bo':'8571',
    'wordtrans-web-code-execution':'15162',
    'HTTP_ShellHistory':'4382',
    'quicktime-idsc-code-execution':'9228',
    'nt-failed-logon':'8070',
    'nt-disabled-account':'8044',
    'Kuang2Virus':'5796',
    'CompoundFile_Shellcode_Detected':'2123000',
    'MSRPC_CA_Alert_Server_Overflow':'5900002',
    'malcode-ServiceMod':'6520',
    'HTTP_URL_NewDsnExe':'2002542',
    'comraider-activex-multiple-file-overwrite':'1469',
    'TFTP win.ini file':'13640',
    'nt-account-audit-success':'7960',
    'win-addressbook-code-execution':'5900002',
    'malcode-word6_10':'6895',
    'malcode-word6_11':'6896',
    'iis-dot-dot-crash':'4924',
    'malcode-word6_14':'6898',
    'malcode-word6_15':'6899',
    'malcode-word6_16':'6900',
    'malcode-word6_17':'6901',
    'malcode-word6_18':'6902',
    'FTP_Windows_SAM_File':'2003602',
    'FTP_ZIPCHK_Overflow':'2001321',
    'FTP_Size_dotdot':'2001366',
    'DNS_NonInternet':'2000404',
    'isa-ms04039-patch':'5455',
    'Exchange55_pop3_authentication_failures':'2306',
    'User_right_revoked':'14043',
    'Email_Qmail_Rcpt':'2001035',
    'DNS_RDATA_String_BO':'2106236',
    'ultravnc-vnclogreallyprint-bo':'13874',
    'BloodFestEvolution_TCP_Response':'2113069',
    'win-ms10kb971468-update':'14773',
    'xm-ftp-abor-format-string':'15236',
    'EvilFTP_Response':'2001522',
    'nt-group-profile-system':'8100',
    'win-ms06kb905754-update':'14472',
    'rhel-rhsa-2007-0492-update':'10324',
    'php-exifprocessifdtag-bo':'8853',
    'rhel-rhsa-multiple-browser-charset-xss':'10735',
    'evansftp-evansftp-bo':'2227',
    'Failed_attempt_to_inherit_object_sid':'2418',
    'kika-backdoor':'5780',
    'xanadu-backdoor':'15198',
    'malcode-SPMZ_Fmt_AbsWrt':'6563',
    'RPC_Pcnfsd_Overflow':'2001747',
    'rsagent-ipop3d-kissofdeath':'11059',
    'rhel-rhsa-2009-1162-update':'5900002',
    'HTTP_MDAC_Access':'2002560',
    'application-communication-allowed':'511',
    'rhel-rhsa-2011-1445-update':'5900002',
    'echo-udp-port-probe':'2037',
    'rsagent-service-called':'11106',
    'wsftp-response-format-string':'5900002',
    '3com-ap-avt-disabled':'9',
    'borland-multiple-functions-bo':'994',
    'ms-win-mhtml-info-disclosure':'5900002',
    'Echo_Reply_Without_Request':'2000109',
    'nt-user-neverloggedon-target':'8353',
    'rhel-rhsa-2008-0175-update':'10514',
    'SMB_autoexec.bat_file_access':'11740',
    'nt-allocate-cdroms':'7977',
    'nt-guess-admin':'8112',
    'snort-frag3-detection-bypass':'5900002',
    'spyware-lopcom':'12626',
    'datamatrix-precis2-activex-file-overwrite':'1642',
    'nt-system-env':'8329',
    'win-ms11kb2494047-update':'5900002',
    'SMTP_Routing_Integer_Overflow':'2110072',
    'JavaScript_ActiveXObject_Obfuscation':'2110154',
    'RTF_Embedded_Executable':'5900002',
    'rc-path-missing':'9333',
    'mercur-imap-bo':'6988',
    'HTTP_iGateway_Overflow':'2121040',
    'rhel-rhsa-2009-1579-update':'5900002',
    'tftp-insecure':'13651',
    'HTTP IIS ISAPI DoS':'3509',
    'snmp-int-overflow':'12080',
    'conseal-firewall-dos':'1487',
    'postgresql-searchpath-privilege-escalation':'9074',
    'SNMP_bad_rqst_id':'12161',
    'ibm-tsmexpressserver-bo':'4581',
    'win-ms06kb923191-update':'14533',
    'afp-mp4-code-exec':'5900002',
    'http-cgi-fastgraf':'3573',
    'tomcat-cookieexample-xss':'13722',
    'HTTP_POST_CreateTable':'2106172',
    'Program_exited':'9123',
    'FTP_Get':'2926',
    'libtiff-rle-decoder-bo':'5886',
    'rhel-rhsa-2005-501-update':'9963',
    'TCP Invalid Urgent offset':'13369',
    'FTP PORT bounce to other system':'2808',
    'CompoundFile_Excel_HLink_BO':'2106228',
    'Media_Decompression_DirectShow_Exec':'5900002',
    'management-agent-file-read':'6928',
    'HTTP_Kolibri_Head_Overflow':'5900002',
    'malcode-RegAndFileStuff':'6446',
    'barcodewiz-loadproperties-bo':'5900002',
    'spyware-cashbar':'12482',
    'visualstudio-vbtovsi-file-overwrite':'14112',
    'rhel-rhsa-2006-0635-update':'10171',
    'FTP Mget DotDot':'2800',
    'win-ms08kb951208-update':'14657',
    'amd-bo':'344',
    'Image_ANI_RateNumber_DoS':'2116014',
    'HTTP_OracleApp_demo_sendmail':'2105031',
    'win-wmf-emf-bo':'14883',
    'vmware-comapi-guestinfo-bo':'14142',
    'mozilla-http-response-smuggling':'7083',
    'rhel-rhsa-2007-0540-update':'10337',
    'RPC_Cmsd_CDE_Overflow':'5900002',
    'HTTP_IE_ADODB_Stream_SaveToFile':'2120028',
    'aix-iy88688-fix':'290',
    'rhel-rhsa-2008-0239-update':'10538',
    'Telnet_login_name_well_known':'13577',
    'helixserver-setup-dos':'3277',
    'user-login-exec':'13975',
    'pdf-embedded-pdf':'8775',
    'SubSeven trojan horse activity':'13179',
    'ca-arcservebackup-lgserverservice-bo':'1067',
    'alis':'309',
    'nas-launchcustomrulewizard-bo':'7569',
    'IPSEC_policy_agent_disabled':'5351',
    'http-unencrypted-connect':'3699',
    'vnc-installed-rfb':'14155',
    'TFTP_System32_File_Write':'2110123',
    'rhel-rhsa-2007-0967-update':'10413',
    'rhel-rhsa-2008-0090-update':'10489',
    'bugzilla-buglist-sql-injection':'1036',
    'ie-cache-getelementsbytagname-dom-access':'4702',
    'iis-ms02062-patch':'4964',
    'SOCKS5_Username_BO':'2106054',
    'SNMP_BulkRqst_DoS':'2101019',
    'Script_FoxServer_DoCmd':'2122031',
    'apache-modproxybalancer-bo':'456',
    'socks-v4-misconf':'12337',
    'cisco-acs-ucp-csusercgi-bo':'5900002',
    'ms-smtp-dnsmx-dos':'5900002',
    'aix-iy72760-fix':'235',
    'nt-netbios-open':'8201',
    'nachi-ping-request-detected':'7541',
    'ypops-smtp-bo':'15351',
    'nt-forced-logoff':'8075',
    'Detector_Warning':'1781',
    'malcode-KazaaSearch':'6364',
    'supportsoft-activex-multiple-bo':'13254',
    'w3who-bo':'14194',
    'ms-sqlserver-sp4-update':'7218',
    'trojan-monkif':'5900002',
    'Failed_login-bad_username_or_password':'2426',
    'ie-same-origin-violation':'4826',
    'rhel-rhsa-2005-044-update':'9822',
    'bind-fdmax-dos':'844',
    'lprng-format-string':'6079',
    'aix-iy64389-fix':'196',
    'nt-disabled-users':'8045',
    'SSH2_Hostbased_auth_failed_DNS_spoofing':'13007',
    'Image_EMF_GDI_Filename_Overflow':'5069',
    'ie-incorrect-security-zone-variant':'4777',
    'sun-answerbook2-gettransbitmap-bo':'13201',
    'rpc.portmap_dump':'10917',
    'Asylum_Response':'2100006',
    'ftp-port-invalid':'2862',
    'UDP_Squid_WCCP_Cachelist_DOS':'2121016',
    'spyware-7search-browser-accelerator':'12423',
    'mirc-present':'7026',
    'http-nov-files':'3654',
    'spyware-mywebsearch-toolbar':'12658',
    'yahoo-messenger-peertopeer':'15320',
    'CGI htmlscript':'1143',
    'iis4-samples-installed':'5012',
    'Ident_Version':'2001904',
    'http-sgi-wrap':'3692',
    'prov-system-failed-login':'9132',
    'ITunes_OpenShare_Detected':'5571',
    'rhel-rhsa-2009-1157-update':'5900002',
    'ftp-pasv-dos':'2857',
    'pc4800-wlan-reveal-registry':'8753',
    'Swift_Request':'2001585',
    'lotus-domino-navigator-access':'6048',
    'mutt-folder-name-bo':'7493',
    'cisco-ios-memory-leak-dos':'1296',
    '.bash.history URL':'0',
    'RLOGIN port probe':'10799',
    'RIFF_Director_Movie_Detected':'5900002',
    'samba-sendmailslot-bo':'11276',
    'rhel-rhsa-2005-415-update':'9941',
    'MSRPC_MSDTC_Message_BO':'2118049',
    'backdoor-schwindler':'724',
    'Cdomain whois_raw.cgi':'1115',
    'rsagent-successful-login':'11142',
    'Norton_Antivirus_port_probe':'7905',
    'rhel-rhsa-2005-567-update':'9982',
    'sco-openserver-mmdf-spam':'11368',
    'reg-afd-backlog':'9384',
    'HTTP_PHP_Method_Bypass':'5900002',
    'wsftp-allo-bo':'15176',
    'pam-internal-error':'8708',
    'Suspect_portscan':'13264',
    'Trinoo_Daemon_activity':'13770',
    'smtp-expn-forward':'11860',
    'UDP_Probe_TFTP':'13858',
    'SMB_Wireshark_Console_Lua_Hijacking':'5900002',
    'SSH2_Common_auth_failed_user':'13005',
    'linux-groff-preprocessor-bo':'5932',
    'rsagent-suspect-time':'11156',
    'nfs-uid-anon-exist':'7819',
    'rhel-rhsa-kernel-pppoe-dos':'10703',
    'Firewall_Deny_Rule':'2647',
    'malcode-SPNE_Jmp_RegCreate':'6596',
    'dvips-system-execute-commands':'2018',
    'decod-smtp-subject':'1743',
    'spyware-best-phrases':'12461',
    'netmail-append-bo':'5900002',
    'JScript_CollectGarbage':'5684',
    'vivotek-rtspvapgdecodernew-activex-bo':'14114',
    'rhel-rhsa-2003-081-update':'9583',
    'TCP_Syn_With_Data':'2124092',
    'tftp-homedir-exist':'13648',
    'Statd_Format_Attack':'13146',
    'frontpage-ext-dvwssr-fileread':'2753',
    'apache-http-get-dos':'437',
    'win-ms09kb963093-update':'14721',
    'malcode-GenericDropper5':'6315',
    'Telnet login name overflow':'13515',
    'win-ms11kb2592799-update':'5900002',
    'passport-default-time-window':'8722',
    'imanager-class-bo':'5900002',
    'Email_Name_Overflow':'2001009',
    'IGMP_Zero_Delay_Query':'5900002',
    'RPC bad credentials':'10847',
    'HTTP_Long_Header_Name':'2110073',
    'win-dns-wpad-registration-spoofing':'14319',
    'passport-sample-site-exposure':'8727',
    'rhel-rhsa-2010-0122-update':'5900002',
    'plugandplay-overflow':'8965',
    'Exchange_unauthenticated_pop3_command_wrongargs':'2330',
    'malcode-DropperAgent2':'6230',
    'ISS_Wireless_Scanner_DHCP':'2113004',
    'http-get-createtable':'3621',
    'SMTP Auth Overflow':'11804',
    'tomcat-error-path-reveal':'13723',
    'win-ms06kb901190-update':'14467',
    'rpcrt4-bad-version':'11004',
    'database-service':'1638',
    'win-ms12kb2664258-update':'5900002',
    'Image_Contains_PHP_Script':'5900002',
    'ldap-modify-bo':'5821',
    'rsagent-ntlogin-attack':'11085',
    'xedni':'15215',
    'Mulitpart_PHP_Global_Bypass':'2109018',
    'SNMP_InvalidTag_RequestID':'2106088',
    'SMTP_Etrn_Overflow':'2001024',
    'oracle-tochar-bo':'8578',
    'SMB_Unicode_file_name_overflow':'11794',
    'SMB_RFParalyze':'2000508',
    'win-ms03040-patch':'14390',
    'ssh2-auth-failed-no-root':'12986',
    'mozilla-mozijssubscript-code-execution':'7100',
    'SMTP FROM_ field overflow':'11820',
    'malcode-generalInfection2':'6307',
    'hp-ovnnm-ovalarm-bo':'3328',
    'publisher-pub-memory-code-execution':'9163',
    'POP_Filename':'9019',
    'malcode-generalInfection4':'6309',
    'PmapUnset':'8977',
    'Security_access_granted':'11444',
    'Telnet_Auth_Null':'13554',
    'nefficientdownload-keycode-security-bypass':'7662',
    'solaris-printd-file-deletion':'12384',
    'win-ms12kb2654428-update':'5900002',
    'SNMP_Bad_BulkRqst_MaxRepeats':'12141',
    'ioctl-function-dos':'5261',
    'nt-guessed-domain-userpwd':'8120',
    'streaming-media-detected':'13157',
    'rhel-rhsa-mozilla-javascripturi-code-exec':'10722',
    'rhel-rhsa-gnugcc-fastjar-directory-traversal':'10697',
    'rdp-login':'9339',
    'dns-zonexfer-failed':'1893',
    'HTTP_Squid_HTTP_Response_DoS':'5900002',
    'rhel-rhsa-2004-041-update':'9662',
    'ruby-cgi-mime-dos':'11223',
    'URL contains Unicode encoding':'13933',
    'nt-domain-guest-userpwd':'8057',
    'iis-webdav-security-bypass':'5008',
    'HTTP_Tomcat_Nulllist':'2105065',
    'FTP_Cwd_concon':'2001353',
    'Logon_with_special_privileges':'6036',
    'smartcode-vnc-activex-dos':'5900002',
    'SNMP_Illegal_Octal_Value':'12212',
    'sendmail-forward-bypass-smrsh':'11494',
    'HTTP_DotDotDot':'2000617',
    'apache-aprpasswordvalidate-dos':'411',
    'Firewall_System_Error':'2657',
    'RPC_Corrupt_Credentials':'2001719',
    'rhel-rhsa-2009-1427-update':'5900002',
    'biztalk-http-receiver-bo':'897',
    'nss-parser-bo':'7949',
    'snmp-varbind-underflow':'12129',
    'FTP_SITE_EXEC_command':'2998',
    'nds-root-rights':'7617',
    'rhel-rhsa-2007-0336-update':'10288',
    'rhel-rhsa-2008-1036-update':'5900002',
    'high-vulnerability-event':'3284',
    'rhel-rhsa-2002-181-update':'9533',
    'rhel-rhsa-2005-080-update':'9839',
    'flushot-dos':'2691',
    'ssh-connect-host':'12973',
    'win-netbios-info-disclosure':'14798',
    'sol-sadmind-amslverify-bo':'12365',
    'Applix_Words_Document_Overflow':'537',
    'exchange-owa-email-fields-xss':'2290',
    'php-sapiheaderop-dos':'8902',
    'Zincite_Backdoor_FileExecute':'2113147',
    'TFTP Exe Transfer':'13630',
    'nt-dcom-config-writable':'8032',
    'icecast-multiple-bo':'4592',
    'win-ms06kb914798-update':'14496',
    'ie-fileupload-obtain-information':'4745',
    'HTTP_OrderLog':'2002548',
    'Interbase_Connect_Overflow':'5900002',
    'outlook-cache-bypass':'8672',
    'CiscoSccp_Stop_Media_Transmission':'1348',
    'xorg-server-cidafm-overflow':'15272',
    'email-from-field-bo':'2071',
    'Satan_FTP':'2102002',
    'win-ms12kb2707960-update':'5900002',
    'SSL_Hello_Msg_DoS':'2120023',
    'ida-activex-bo':'5900002',
    'Telnet_Term_Type_Overflow':'2000904',
    'excel-version-code-execution':'2268',
    'isa-file-extension-security-bypass':'5441',
    'oracle-database-adv-replication-unspecified':'5900002',
    'FTP_ProFTPD_Backdoor':'5900002',
    'php-gd-integer-overflow':'8861',
    'user-accounts-deleted':'13948',
    'win-ms06kb924164-update':'14540',
    'Oracle_Default_Username':'8593',
    'bat URL type':'804',
    'HTTP_FreePBX_Recording_Upload_Exec':'5900002',
    'picturepusher-activex-file-upload':'8943',
    'malcode-SPPE_MaxSect_PESig':'6682',
    'ike-association-failed-invalid-peer-proposal':'5026',
    'samba-tmpfile-symlink':'11284',
    'Tribe_Flood_Network':'13756',
    'FTP_Pass':'2960',
    'cisco-ios-ipv6-type0-dos':'1294',
    'mysql-query-logging-bypass':'7527',
    'FTP_Pasv':'2964',
    'file-default-profile-insecure':'2484',
    'rhel-rhsa-2011-0373-update':'5900002',
    'netscape-ie-password-dos':'7733',
    'OptixPro_TCP_Response':'2113221',
    'outlook-level1remove-exist':'8680',
    'UBB_suspicious_posting':'13825',
    'rhel-rhsa-2011-1103-update':'5900002',
    'linuxkernel-lsof-dos':'5993',
    'FTP_Site_Exec_DotDot':'2001324',
    'crontab-allowed-cronat':'1541',
    'Successful_login':'13196',
    'SMTP_Subject':'11941',
    'excel-object-bo':'2261',
    'HTML_Surplus_Onload':'5900002',
    'TCP_Probe_Sub7':'13452',
    'rhel-rhsa-2011-1341-update':'5900002',
    'gungho-loadprgax-code-execution':'3225',
    'QuickTime_GStreamer_Code_Execution':'9266',
    'Back Orifice 2000 response':'645',
    'Pict_UncompressedQuickTime_Underflow':'8940',
    'iis-sample-directory-present':'4981',
    'XML_PHP_Saxon_File_Creation':'5900002',
    'xmpp-session':'15264',
    'win-smb-packet-code-execution':'14845',
    'SMB_Measure_DLL_Hijacking':'5900002',
    'spyware-edise':'12540',
    'creativesoftware-autoupdate-cachefolder-bo':'1533',
    'realpage-activex-upload-info-disclosure':'5900002',
    'backdoor-crazzynet':'675',
    'Winamp_MP4_UserData_Overflow':'2101028',
    'HTTP_Put':'4343',
    'HTTP_eDirectory_AcceptLanguage_Overflow':'2124087',
    'chilkat-ftp2-activex-code-execution':'5900002',
    'SMB_TreeConnect_Path_DoS':'11792',
    'cisco-cucm-ctl-bo':'1273',
    'CompoundFile_Publisher_2007_Mem_Corruption':'2114055',
    'realplayer-smil-parameter-bo':'9367',
    'win-ms10kb981343-update':'5900002',
    'SNMP_Bad_ErrorStatus':'2106109',
    'win-ms12kb2651018-update':'5900002',
    'rhel-rhsa-openssh-sep-verificaton-weakness':'10745',
    'spyware-win32-spybot-worm':'12827',
    'malcode-Susp_MBR_Cmos':'6764',
    'win2k-desktop-separation':'14911',
    'snmp-trap-address-underflow':'12119',
    'malcode-RootkitDropper':'6498',
    'unzip-longname-bo':'13908',
    'user-mail-nofile':'13989',
    'IPOP3D_user_auto-logout':'5335',
    'win-ms09kb974112-update':'14759',
    'win-ms10kb2360937-update':'5900002',
    'adobe-acrobat-detected-rpm':'103',
    'yahoo-yshortcut-bo':'15330',
    'rhel-rhsa-2006-0605-update':'10159',
    'HTML_WinSCP_Command_Exec':'2109003',
    'HTTP_ColdFusion_Debug':'2002679',
    'win-ms07kb938829-update':'14600',
    'rsagent-ssh-username-overflow':'11140',
    'wins-packet-code-execution':'15077',
    'IRC_Join_From_Server':'2102062',
    'FTP SITE EXEC exploit':'2818',
    'NTP_Mode7_DoS':'5900002',
    'ip-fragment-length-change':'5274',
    'rhel-rhsa-2006-0257-update':'10101',
    'DNS_Format_String':'2000422',
    'oracle-workflow-response-form-xss':'5900002',
    'RIFF_WAV_DirectShow_Overflow':'10780',
    'SNMP hangup':'12002',
    'quicktime-flash-media-code-execution':'9219',
    'Infector':'5209',
    'PDF_Font_Large_maxCompositePoints':'5900002',
    'mcafee-saas-myasutil520603-code-execution':'5900002',
    'sip-version-detected':'11639',
    'HTTP_AVI_Open_Overflow':'2101050',
    'Incremental_Baseline_Finished':'5197',
    'wireshark-lua-code-execution':'5900002',
    'windows-auto-update-disabled':'15022',
    'vmware-searchpath-privilege-escalation':'14148',
    'outlook-oss-bo':'8689',
    'MSRPC_Registry_PolicySecrets':'2003206',
    'ms-smb-pathname-code-exec':'7205',
    'nt-autologonpwd-present':'7988',
    'nt-regfile':'8270',
    'ie-scriptlet-rendering-file-access':'4832',
    'Oracle_Failed_Connection':'8595',
    'win-ms07kb926436-update':'14562',
    'iscdhcp-dhclient-command-execution':'5900002',
    'CompoundFile_PowerPoint_TextBytes_Overflow':'5900002',
    'aix-iy55949-fix':'178',
    'win-ms09kb971657-update':'14747',
    'openiscsi-log-dos':'8450',
    'CompoundFile_PowerPoint_TextChars_Overflow':'5900002',
    'Telnet_Xdisplay_Overflow':'2000917',
    'spyware-goclick':'12576',
    'ekiga-loginsert-format-string':'2064',
    'realplayer-rm-script-execution':'9366',
    'rhel-rhsa-2009-1238-update':'5900002',
    'netscape-server-directory-indexing':'7738',
    'orinoco-as2000-present':'8628',
    'win-ms10kb979402-update':'5900002',
    'excel-csv-file-import-code-execution':'2253',
    'SMTP_Virus_Recipient':'2106167',
    'microsoft-jet-engine-mdb-bo':'7009',
    'adobe-xml-file-disclosure':'142',
    'rhel-rhsa-2008-0558-update':'10577',
    'malcode-SPCOM_AbsRdWrt':'6540',
    'aix-iy72713-fix':'233',
    'fathftp-fileexists-activex-bo':'5900002',
    'HTTP_POST_Content_Length_Negative':'2116010',
    'shellcode-detected':'11595',
    'spyware-marcadorcom':'12632',
    'malcode-VB_InternetAgent':'6841',
    'rhel-rhsa-2005-433-update':'9950',
    'ie-non-secure-submission':'4811',
    'vmware-decoder-frame-code-execution':'5900002',
    'ie-cache-createrange-dom-access':'4696',
    'apop-msgid-mitm':'493',
    'file-nail-backdoor':'2525',
    'ssm-list-bo':'13115',
    'HTTP_Java_Webadmin_BBS':'2002585',
    'win2k-mapped-account':'14942',
    'WFM_URL_Blocked':'14263',
    'archive-extraction-directory-traversal':'542',
    'vmware-viclient-code-exec':'5900002',
    'oracle-database-xmldb-privilege-escalation':'5900002',
    'Nmap_Scan':'7858',
    'mozilla-javascriptwatch-code-execution':'7093',
    'FTP file exec exploit':'2793',
    'spyware-clientman':'12496',
    'ms-visio-installed':'7223',
    'freetype-font-file-dos':'2735',
    'NewTear':'2000004',
    'rhel-rhsa-2003-297-update':'9635',
    'Finger_Generic_Intel_Overflow':'2104012',
    'notes-html-rtf-bo':'5900002',
    'ISAKMP_Certificate_Request_Overflow':'2110045',
    'AdvancedAccountingSystemModified':'145',
    'rhel-rhsa-2006-0117-update':'10075',
    'Image_Wmf_OLE_Automation_Underflow':'5900002',
    'iparty-dos':'5304',
    'NetTaxi_TCP_Response':'2113138',
    'win-ms10kb2269707-update':'5900002',
    'Rexd':'2001744',
    'ssh-brute-force':'12972',
    'vm-java-codebase-exe':'14120',
    'DB2_DAS_Heap_Overflow':'5900002',
    'malcode-generalInfection3':'6308',
    'FTP_DemiGlob':'2912',
    'HTML_JS_Window_Code_Exec':'2113233',
    'rhel-rhsa-2009-1522-update':'5900002',
    'screen-timeout-toolong':'11374',
    'backdoor-master-paradise':'703',
    'malcode-generalInfection1':'6306',
    'novell-iprint-getfilelist-bo':'7925',
    'adobe-reader-sandbox-sec-bypass':'5900002',
    'mozilla-email-messages-overflow':'7076',
    'SNMP_Activity':'12137',
    'boep-virwall':'959',
    'ftp-guest':'2848',
    'win-directshow-avi-code-execution':'14314',
    'file-not-in-baseline':'2531',
    'rhel-rhsa-2007-1155-update':'10465',
    'nis-tcp-running':'7842',
    'FTP_NetTerm_Ls_Overflow':'2001368',
    'DigitalRootBeer_TCP_Request':'2113067',
    'outlook-vcard-dos':'8693',
    'malcode-ADShide':'6131',
    'htdig-remote-read':'3363',
    'JavaScript_DOM_Insertion_Conflict':'5900002',
    'ftp-cwd-bo':'2836',
    'Cisco_H323_Overflow':'2107005',
    'slrn-wrapping-bo':'11697',
    'cesarftp-long-command-bo':'1126',
    'Trojan_Hupigon':'13789',
    'rhel-rhsa-mozilla-xulpopups-spoofing':'10732',
    'nt-display-last-username':'8046',
    'EPolicy_Orchestrator_Source_Overflow':'2109011',
    'Sslvpn_Auth':'13106',
    'NNTP_Subject':'7882',
    'Mime_Thunderbird_ExternalBody_Overflow':'7022',
    'backupexec-webadministration-bo':'780',
    'orinoco-as-default-ssid':'8625',
    'SNMP port probe':'12021',
    'nds-intruder-detection-disabled':'7604',
    'coreflood-worm-detected':'1519',
    'oracle-layer-sdocodesize-bo':'8563',
    'Imail admin':'5126',
    'rhel-rhsa-2005-060-update':'9828',
    'HTTP URL scan':'3538',
    'pgp-disk-detected':'8832',
    'ecware-dos':'2042',
    'user-preset-ras':'14003',
    'BrightStor_Discovery_UDP_Query_Overflow':'2106257',
    'malcode-SysDirRdr':'6789',
    'rhel-rhsa-2006-0276-update':'10110',
    'apache-env-configuration-bo':'430',
    'XML_RPC_PHP_CmdExec':'2113208',
    'webmin-dot-directory-traversal':'14243',
    'exim-pipe-hostname-commands':'2337',
    'Telnet_PolycomDoS':'2106128',
    'msn-chatcontrol-resdll-bo':'7275',
    'rhel-rhsa-2008-0630-update':'5900002',
    'WINS_DelAssoc_Bo':'2111035',
    'netxray3-probe':'7786',
    'FTP user name overflow':'2825',
    'vnc-installed-noconn':'14154',
    'Telnet_suspicious_variable':'13588',
    'HTML_TrendMicro_OfficeScan_ActiveX':'3458',
    'sol-sadmin-procedure':'12364',
    'HTTP_Media_Player_Code_Execution':'2120036',
    'gnupg-invalid-key-acceptance':'3135',
    'file-shared-object':'2544',
    'red-button':'9381',
    'nav-leave-secure-site':'7577',
    'HTTP_RpcNLog':'2106033',
    'win2k-schema-update':'14955',
    'fpse-image-file-existence':'2714',
    'umask':'13876',
    'rpc.sadmind_overflow':'10919',
    'FTP_Delete_Very_Long':'2001341',
    'hidepak-login-backdoor':'3280',
    'ISA_suspicious_demand_dial_connection':'5522',
    'Finger command':'2575',
    'ms-word-memory-code-exec':'5900002',
    'rhel-rhsa-2009-1463-update':'5900002',
    'oracle-jre-deployment-unspecified':'5900002',
    'IP_fragment_data_changed':'5285',
    'ie-incorrect-security-zone':'4778',
    'http-invalid-contentlength-detected':'3645',
    'openoffice-unspecified-bo':'5900002',
    'SNMP_bad_oid_tag':'12156',
    'HTTP_Digest_Authorization_Long_Parameter':'5900002',
    'multiple-browser-javascript-handler-dos':'7480',
    'rhel-rhsa-2009-1082-update':'10664',
    'winnt-dhcp-hardwareaddress-code-execution':'15059',
    'user-login-shell-pathname':'13985',
    'Rlogin login name overflow':'10796',
    'win-ms11kb2479628-update':'5900002',
    'win-ms11kb2630837-update':'5900002',
    'squirrelmail-magichtml-messages-xss':'12956',
    'rhel-rhsa-2009-1223-update':'5900002',
    'spyware-navpmc':'12661',
    'SMB_Service_Sweep':'11787',
    'rpc-export-nosuid':'10874',
    'HTTP_Wayboard_Fileview':'2002603',
    'HTTP_WebLogic_FileSourceRead':'2106047',
    'boep-aim':'945',
    'nds-user-no-password-change':'7638',
    'whatsup-scan':'14276',
    'Email_Virus_exploreZip':'2002205',
    'sql-injection-openrowset':'12880',
    'snmp-kill-auth-trap':'12083',
    'http-cgi-ccwhois':'3562',
    'PDF_Corrupt_Image':'5900002',
    'HTTP_OpenView_nnmrptconfig_Format_String':'5900002',
    'http-cgi-avsearch':'3554',
    'squid-urlregex-acl-bypass':'12948',
    'sccp-message-overflow':'11357',
    'php-safemodeexecdir-restriction-bypass':'8901',
    'dcom-scada-opc-bind':'1658',
    'rsagent-sqlserver-login-failed':'11113',
    'websuite-dos':'14261',
    'JPEG_Duqu_CnC':'5900002',
    'All_Proventia_protection_stopped':'313',
    'win-ms11kb2393802-update':'5900002',
    'mozilla-srcimgframe-security-bypass':'7128',
    'iscbind-dnsdbfindrdataset-dos':'5544',
    'nt-alteredsys-value':'7979',
    'FTP_List_dotdot':'2001364',
    'HTTP_IIS_Unicode_Wide_Encoding':'4084',
    'Kerberos_TGS_Renew_Or_Validate':'5900002',
    'mercury-search-bo':'6991',
    'msxml-headers-info-disclosure':'7471',
    'baseline-file-association':'801',
    'mdaemon-imap-status-bo':'6965',
    'kernel-sysfsreaddir-dos':'5764',
    'sfu-telnet-dos':'11567',
    'rhel-rhsa-2009-0336-update':'5900002',
    'linux-ip-route-input-dos':'5935',
    'rhel-rhsa-2006-0498-update':'10127',
    'apache-windows-share-info-disclosure':'492',
    'nt-group-single-process':'8108',
    'win-ms08kb951698-update':'14659',
    'rhel-rhsa-2007-0509-update':'10328',
    'nt-lock-memory-group':'8154',
    'kdm-pamkrb5-gain-privileges':'5697',
    'UPNP NOTIFY overflow':'13926',
    'anonftp-group':'358',
    'nt-messenger':'8182',
    'NfsMknod':'7827',
    'moxa-activex-bo':'5900002',
    'Suspect_Telnet':'13269',
    'rhel-rhsa-2010-0046-update':'5900002',
    'EICAR_AV_test':'2061',
    'rhel-rhsa-2011-0170-update':'5900002',
    'mailman-admin-login-xss':'5900002',
    'UDP Trojan Horse probe':'13831',
    'VOIP_DRDoS':'2106211',
    'PortalOfDoom_Response':'2001570',
    'HPUX_LPD_Overflow':'2113230',
    'macromedia-swdirdll-control-dos':'6100',
    'apache-modauthkerb-offbyone-bo':'446',
    'SSL_Unsolicited_Certificate':'13099',
    'rhel-rhsa-openldap-selfwrite-sec-bypass':'10740',
    'win-activedirectory-ldap-dos':'14287',
    'U3D_FileSize_Overflow':'5900002',
    'negative-integer-bo':'7663',
    'ie-ms02068-patch':'4798',
    'gtp-c-element-unexpected':'3200',
    'clam-antivirus-file-format-gain-access':'5900002',
    'SNMP_InvalidTag_OID':'2106105',
    'spss-vsview6-activex-code-execution':'5900002',
    'rhel-rhsa-2006-0568-update':'10141',
    'http-cgi-wwwboard-admin-pass-file-read':'3606',
    'TCP_Small_Segment_Size':'2000316',
    'FTP SITE ZIPCHK metacharacters':'2823',
    'Infector_TCP_Request':'2113104',
    'SNMP bad oid tag':'11974',
    'ie-tblinf32-code-execution':'4848',
    'RPC_BrightStor_ARCserve_Loggerd_BO':'10939',
    'HTTP_OpenView_NNM_OvOSLocale_Overflow':'2101085',
    'Configuration_File_Change':'1484',
    'foxpro-fpole-command-execution':'2709',
    'rhel-rhsa-2007-0244-update':'10278',
    'Password_change_failed':'8746',
    'exploit-MSWorks(100046)':'2382',
    'adobe-acrobat-extension-security-bypass':'105',
    'ISA_PF_Protocol_Violation':'5514',
    'inetd-tcp-wrappers':'5208',
    'http-server-identity-audit':'3687',
    'rhel-rhsa-2004-418-update':'9735',
    'dcom-default-launch-permission':'1657',
    'ike-quick-mode-association-ended':'5030',
    'spyware-wwwhoosh':'12839',
    'http-cgi-homefree-search':'3580',
    'HTTP_DLL_Transfer':'5900002',
    'primary-security-token-issued':'9104',
    'leadtools-getcolorres-dos':'5900002',
    'spyware-sexchat-dialer':'12735',
    'spyware-webdialer':'12803',
    'SNMP TFTP retrieval':'12027',
    'BackOrifice_Response':'2001505',
    'jakarta-tomcat-error-reveal-info':'5573',
    'Cisco_Ident':'2104013',
    'rhel-rhsa-2005-747-update':'10015',
    'rhel-rhsa-2006-0329-update':'10115',
    'coldfusion-rds-password-plaintext':'1398',
    'rservice-shell-wrapped':'11191',
    'HTTP_Apache_OnError_XSS':'2110124',
    'rhel-rhsa-2006-0500-update':'10128',
    'nt-priv-patch-unauthorized':'8245',
    'netbackup-bpjavamsvc-format-string':'7678',
    'hardware-errors-onceonly':'3264',
    'CVS_Request_Tag_Overflow':'2107025',
    'security-patch-installed':'11441',
    'haihaisoft-myactivex-bo':'5900002',
    'webex-gpccontainer-dos':'14231',
    'ConnectionBackdoor_Response':'2001546',
    'spyware-tgdcmd':'12765',
    'GirlFriend trojan horse activity':'3097',
    'RDP_Login':'9340',
    'Image_TIFF_LibTiff_FetchShortPair_Overflow':'5106',
    'Rlogin_login_name_well_known':'10817',
    'rhel-rhsa-2007-0097-update':'10250',
    'os-version':'8631',
    'quicktime-activex-bo':'5900002',
    'nt-guessed-acctoper-pwd':'8115',
    'DNS non-Internet lookup':'1853',
    'adobe-flash-player-xss':'5900002',
    'Content_Analyzer_US_Phone_Num':'2120079',
    'rhel-rhsa-2006-0272-update':'10109',
    'nt-pptp3-fix':'8241',
    'win-ms06kb917953-update':'14513',
    'win-ms03039-patch':'14389',
    'nt-take-owner':'8335',
    'kerberos-bf':'5698',
    'rhel-rhsa-apache-modstatus-xss':'10680',
    'smartserver-pop3-bo':'11699',
    'aix-iy73814-fix':'241',
    'skype-skype4com-uri-handler-bo':'11685',
    'SniperNet_Response':'2100012',
    '3com-ap-server-exposure':'12',
    'malcode-autoExecMacroCopy':'6153',
    'Bugs_Response':'2001543',
    'SSH_Root_login':'13055',
    'rhel-rhsa-2007-0358-update':'10301',
    'crackdown-backdoor':'1527',
    'malcode-IDT_Misc':'6337',
    'freebsd-fingerd-files':'2726',
    'lilbpng-integer-bo':'5911',
    'win-ms10kb2423930-update':'5900002',
    'IDENT newline':'4644',
    'Telnet_Polycom_Blank_Password':'2106035',
    'HTML_URI_Base64_Hiding':'5900002',
    'RTF_MFC_OLE_Overflow':'2110122',
    'zipwiz-zip-bo':'5900002',
    'rhel-rhsa-2005-323-update':'9896',
    'malloc-return-value-dos':'6921',
    'http-webdav-propfind-enabled':'3711',
    'apache-modcgi-info-disclosure':'447',
    'rhel-rhsa-2005-039-update':'9819',
    'network-icon-visible':'7773',
    'ARCserve_Backup_LGServer_Authentication_Overflow':'2101010',
    'edraw-viewer-ftpdownloadfile-bo':'2056',
    'win-message-queue-bo':'14383',
    'Echo_Denial_of_Service':'2000210',
    'win2k-account-deleted':'14894',
    'HTTP_VML_Detected':'4480',
    'smtp-integer-overflow':'11864',
    'skyfex-client-bo':'11681',
    'win-ms08kb957095-update':'14686',
    'rhel-rhsa-2009-0325-update':'10630',
    'Finger_Filename':'2001106',
    'win-ms11kb2563894-update':'5900002',
    'HTTP_cookieOverflow':'2000638',
    'http-repeated-char':'3680',
    'rhel-rhsa-2003-008-update':'9560',
    'rhel-rhsa-2008-0492-update':'10560',
    'malcode-VB_BackdoorClient':'6835',
    'SNMP snmpdx attack':'12024',
    'rhel-rhsa-2005-755-update':'10018',
    'rhel-rhsa-2002-289-update':'9551',
    'rhel-rhsa-2005-065-update':'9830',
    'file-cgi-bin':'2467',
    'RPC_Sadmind_Ping':'2001738',
    'win-ms11kb2484015-update':'5900002',
    'ie-utf8-html-execute-code':'4861',
    'linux-rsync-write-files':'5965',
    'SMB login failed':'11707',
    'rhel-rhsa-2006-0158-update':'10080',
    'HTTP_Field_With_Binary':'2000646',
    'gtrust-local-any':'3217',
    'ringzero-virus':'10782',
    'malcode-NETrojan2':'6385',
    'MSM_SystemError':'7267',
    'checkpoint-snx-code-execurtion':'5900002',
    'apache-get-directory-traversal':'434',
    'SNMP_InvalidTag_Trap_Timestamp':'2106086',
    'Oracle_PitrigTruncate_Overflow':'5900002',
    'Ghost_TCP_Response':'2113109',
    'SMTP ENVID overflow':'11814',
    'dns-tcp-port-abuse':'5900002',
    'rhel-rhsa-2008-0504-update':'10564',
    'web-browser-ftp-command-execution':'14216',
    'SIP_Long_Via_Host':'2114011',
    'mysql-comchangeuser-password-bypass':'7514',
    'rhel-rhsa-2006-0184-update':'10087',
    'active-directory-calculate-descriptor':'58',
    'rc-path-worldwritable':'9336',
    'livemessenger-connection-detected':'5999',
    'spyware-bearshare':'12460',
    'apache-servertokenvalue':'477',
    'ypserv-map-memory-leak':'15354',
    'Repeated accesses to same Web service':'9488',
    'rhel-rhsa-2008-0197-update':'10524',
    'HTTP_URL_contains_old_DOS_filename':'4448',
    'SubSeven':'13180',
    'swf-video-stream-detected':'13283',
    'nds-user-account-expiry':'7624',
    'ichat-aim-format-string':'4593',
    'gzip-unpack-buffer-underflow':'3233',
    'hp-instantsupport-startapp-code-execution':'3312',
    'wuftp-ftp-conversion':'15184',
    'evolution-gtkhtml-dos':'2241',
    'rhel-rhsa-2010-0935-update':'5900002',
    'SelSvcH':'2001732',
    'nt-writable-netbios':'8377',
    'win2k-install-admin-weakness':'14929',
    'Failed_login-account_locked_out':'2424',
    'ICMP_PingTunnel_Detected':'2121021',
    'ie-cache-clipboarddata-dom-access':'4695',
    'exploit-MSWord(100001)':'2373',
    'aix-iy75294-fix':'244',
    'smb-malformed-pipe':'11724',
    'HTTP_Icecast_mp3':'2002691',
    'RTF_Word_Do_Exec':'5900002',
    'novell-imanager-tree-dos':'7920',
    'win-ms06kb917285-update':'14505',
    'Script_HpSoftwareUpdate_ActiveX':'11385',
    'Firewall_IP_Spoofing':'2653',
    'FTP_MKD_directory_overflow':'2946',
    'iis-virtual-unc-share':'5002',
    'EOT_Malformed_OpenTypeFont_Detected':'5900002',
    'servuftp-mkd-dir-traversal':'11560',
    'bgp-notify-msg':'818',
    'aix-iy55950-fix':'179',
    'storm-worm':'13153',
    'win-tcpip-icmp-dos':'14854',
    'coldfusion-file-existence':'1394',
    'oracle-generatereplicationsupport-bo':'8555',
    'aix-IY88512-fix':'279',
    'HTTP_webgais':'2002534',
    'rhel-rhsa-2004-074-update':'9677',
    'rsagent-startup-progams':'11141',
    'modpython-imported-module-access':'7036',
    'mysql-show-grants-password':'7531',
    'internet-security-umxeventcli-file-overwrite':'5246',
    'msn-present':'7280',
    'Suspect_Netstat':'13261',
    'rhel-rhsa-2004-437-update':'9739',
    'SMB I_O using printer share':'11706',
    'DNS_Excessive_Requests':'2000419',
    'ASF_MP4S_Code_Execution':'5900002',
    'SNMP bad err status':'11971',
    'apache-moduserdir-info-disclosure':'465',
    'spyware-midaddle':'12643',
    'dns-maximum-packet-length':'1879',
    'nctvideostudio-activex-file-overwrite':'7595',
    'malcode-IEDefaults':'6338',
    'iis-htr-isapi-bo':'4941',
    'JavaScript_IE_Select_Element_CodeExec':'5900002',
    'firefox-settimeout-code-execution':'5900002',
    'netbios-domain-name-detected':'7684',
    'win-asn1-bo-ntlm-detected':'14291',
    'SNMP_VACM_community':'12294',
    'HTTP_IIS_Percent_Evasion':'2106052',
    'malcode-word6_02':'6887',
    'rhel-rhsa-2009-0315-update':'10629',
    'php-fopen-crlf-injection':'8858',
    'Repeated_accesses_to_same_Web_service':'9489',
    'nt-group-shutdown':'8106',
    '3com-ap-default-password':'10',
    'ARCserve_Backup_LGServer_Hex_Overflow':'547',
    'http-cgi-verity-search97':'3600',
    'pdf-invalid-reference-version-number':'8781',
    'malcode-word6_07':'6892',
    'LDAP_Tivoli_Directory_Server_Heap_Overflow':'5900002',
    'reg-share-server':'9441',
    'BOEP_lsass':'973',
    'win2k3-enable-delegation-privilege':'14991',
    'Registry_remote_edit_changed':'9466',
    'Sslvpn_Auth_Failed':'13107',
    'IP_Invalid_Option':'2110064',
    'cups-ipp-partial-dos':'1559',
    'SQL_Empty_Admin_Password':'2122005',
    'Calendar CGI exploit':'1092',
    'etc-profile-umask':'2196',
    'TFN2K_TCP_Command':'2001589',
    'lastlines-cgi-directory-traversal':'5810',
    'cisco-pingball':'1317',
    'SSDT_Modification_Detected':'12969',
    'rsagent-restriction-violation':'11104',
    'IIS malformed HTW request':'4890',
    'FTP_Windows_INI_File':'2003605',
    'Script_ATL_Stream_Load':'2114179',
    'echo-inetd':'2036',
    'ms-office-installed':'7191',
    'nds-user-no-home-rights':'7634',
    'kernel-rndis-bo':'5754',
    'SSH_Brute_Force':'2110069',
    'OSPF_Hello_Multicast':'8652',
    'malcode-Susp15':'6752',
    'Qaz_Command':'9172',
    'ethereal-socks-dissector-dos':'2214',
    'EventHorizon_Request':'2233',
    'HTTP_Login_Known_User':'2000641',
    'java-x11-win32graphicsdevice-unspecified':'5900002',
    'pmap-sunset':'8970',
    'LanMan_Share_Enum_Sweep':'2118003',
    'exploit-MSVisio(100023)':'2366',
    'nt-account-operator':'7962',
    'linux-tmpwatch-fuser':'5979',
    'rhel-rhsa-2008-1047-update':'5900002',
    'rhel-rhsa-2006-0729-update':'10199',
    'windows-registry-remote-audit':'15028',
    'Shopping cart order URL':'11601',
    'malcode-VB_EnumShares':'6839',
    'solaris-traceroute-argument-bo':'12389',
    'oscar-file-transfer':'8632',
    'rhel-rhsa-mozilla-bom-utf8-xss':'10709',
    'walld-inetd':'14199',
    'Oracle_InstantiateOnline_Bo':'2120047',
    'gracenote-cddbcontrol-activex-bo':'3168',
    'office-gif-bo':'8407',
    'ie-javaprxydll-execute-code':'4785',
    'boep-inetinfo':'951',
    'Oracle_Ctxsys_Drvdisp_Overflow':'5900002',
    'FTP Mkdir':'2802',
    'win-ms12kb2639185-update':'5900002',
    'decod-dns-all':'1678',
    'nt-create-object-onceonly':'8022',
    'ftp-wrapper-deny':'2882',
    'activex-warning':'84',
    'rhel-rhsa-2005-499-update':'9962',
    'win-ms06kb914451-update':'14495',
    'Unable_to_set_firewall_filter':'13878',
    'rhel-rhsa-2007-0203-update':'10273',
    'rhel-rhsa-2008-0245-update':'10542',
    'win-ms09kb974318-update':'14760',
    'macos-mysql-manager-blank-password':'6099',
    'ibm-soliddb-solid-dos':'4576',
    'HTTP_WebLogic_fileread':'2105070',
    'rservice-login-wrapper-deny':'11190',
    'HTTP_URL_MLog':'2002539',
    'brightstor-universalagent-command-execution':'1014',
    'HTTP_Fantasy_Sports':'3908',
    'win-activedirectory-ldap-request-dos':'14288',
    'blubster-piolet-rockitnet-file-transfer':'938',
    'IIS_Double-Byte_Code_attempt':'5015',
    'nt-take-owner-onceonly':'8334',
    'RLOGIN_port_probe':'10820',
    'Retina Scan':'9493',
    'apache-chunked-encoding-bo':'421',
    'excel-lotus123-bo':'2259',
    'SQL_port_probe':'12908',
    'rhel-rhsa-2004-395-update':'9726',
    'win-plugandplay-bo':'14809',
    'Voip_Control_Channel_BO':'2109020',
    'policymanager-activex-file-overwrite':'8980',
    'malcode-AssignOwnCode':'6139',
    'DNS_TSIG_Overflow':'2000421',
    'iis-activeperl-command-execution':'4896',
    'lotus-domino-smtp-bo':'6051',
    'sendmail-milter-dos':'11501',
    'mozilla-layout-dos':'7096',
    'Napster_Client_Update':'7559',
    'Exair sample ASP':'2248',
    'GTP_U_Recursion':'2111034',
    'loadrunner-xupload-code-execution':'6004',
    'jre-setdifficm-bo':'5900002',
    'win98-oshare-dos':'15006',
    'malcode-SPPE_LastSectEP':'6680',
    'HTTP_WebPALS':'2002656',
    'Application Compliance Warning':'505',
    'SSL_Cisco_Unified_Communications_CTL_BO':'13091',
    'IPV6_Bad_Fragment_Chain':'2110077',
    'Unexplained':'13880',
    'rhel-rhsa-2006-0101-update':'10074',
    'Content_Analyzer_Postal_Addr':'2120075',
    'DNS_BIND_version_request':'1902',
    'peachtreeaccounting-pawweb11-code-execution':'8822',
    'mailalias-invalid':'6111',
    'realplayer-enterprise-ram-bo':'9355',
    'only-root-cronat':'8441',
    'malcode-SPPE_Write_EXE':'6697',
    'Image_PNG_Malformed':'2102049',
    'lotus-domino-open-server':'6049',
    'rhel-rhsa-2009-1472-update':'5900002',
    'SSH2_Kerberos_auth_failed':'13014',
    'firefox-ogg-dos':'5900002',
    'FTP_User':'3018',
    'mysql-port-dos':'5900002',
    'ie-url-encoded-cookie-information':'4858',
    'oracle-oradc-code-execution':'8570',
    'HTTP_GET_data_contains_.._.._.._..':'3938',
    'WhatsUp scan':'14273',
    'malcode-SPMZ_cmos_morf':'6558',
    'SIP_Unknown_Via_Parameter':'2114013',
    'NNTP port probe':'7863',
    'SQL_Sybase_OpenServer_Exec':'5900002',
    'HTTP_PHPMyAdmin_EvalExecute':'2002697',
    'cobalt-raq-directory-traversal':'1374',
    'rhel-rhsa-2009-1075-update':'10663',
    'adobe-cooltype-overflow':'5900002',
    'reg-sec-poorly-protected':'9438',
    'SNMP ILMI community':'12005',
    'shadow-useradd-mail-access':'11572',
    'TIP_Identify_Wrong_Addr':'2106200',
    'accountingsoftware-length-bo':'41',
    'bind-chroot':'838',
    'spyware-subsearch':'12755',
    'bind-srv-dos':'863',
    'OTF_Windows_Cmap_Table_Corruption':'5900002',
    'IMAP_User':'5186',
    'quicktime-qtl-bo':'9242',
    'HTTP_MovieMaker_DLL_Hijacking':'5900002',
    'aix-iy82357-fix':'266',
    'openoffice-xpm-bo':'5900002',
    'MSRPC_SuspiciousEncryption':'7380',
    'malcode-ExeSeq44':'6286',
    'JavaScript_Multiple_Unescape_Eval':'2110186',
    'aix-iy67519-fix':'212',
    'share-sacl-change':'11579',
    'quicktime-obji-atoms-bo':'9237',
    'kerberos-svcauthgssvalidate-bo':'5709',
    'TCP_Probe_Proxy':'13447',
    'nt-locked-account':'8158',
    'HTML_OnLoad_Very_Large':'2110169',
    'ICC_Profile_Tag_Overflow':'2106194',
    'nds-user-no-logon-for-period':'7635',
    'Telnet ENV overflow':'13512',
    'win-ms07kb931906-update':'14579',
    'DHCP_Client_Overflow':'1800',
    'win-ms06kb917537-update':'14509',
    'Ringzero':'10783',
    'java-bytecode-verifier-bypass':'5579',
    'rhel-rhsa-2005-720-update':'10012',
    'ruser':'11231',
    'spyware-psn-private-search-network':'12698',
    'oracle-hyperion-activex-bo':'5900002',
    'TCP_Malformed_SACK_DoS':'13417',
    'FTP_Args_Overflow':'2001310',
    'tippingpoint-format-string':'5900002',
    'win-rpcss-dcom-bo':'14823',
    'solaris-fingerd-list-accounts':'12374',
    'malcode-ScriptActivatePassword':'6503',
    'Radius_AcctStatusType_Dos':'2107010',
    'mozilla-pac-code-execution':'7117',
    'rhel-rhsa-mozilla-diskcache-info-disclosure':'10715',
    'spyware-gamespyarcade':'12568',
    'HTTP_Shell_Handler_Executable':'2113155',
    'nt-dcom-auth-level':'8031',
    'ms-outlook-mail-client-overflow':'5900002',
    'iis-absent-directory-dos':'4895',
    'DHCP_Request':'1812',
    'SMB_Request_DoS':'5900002',
    'RTSP_Helix_Setup_DoS':'11217',
    'TCP_Overlap_Data':'13424',
    'blackice-application-protection-stopped':'910',
    'macrovision-flexnet-file-overwrite':'6104',
    'rhel-rhsa-2007-0963-update':'5900002',
    'php-wordwrap-bo':'8915',
    'beast-backdoor':'809',
    'rhel-rhsa-2010-0500-update':'5900002',
    'ssl-certificate-expired':'13074',
    'fax-voice-activex-code-execution':'5900002',
    'POP3_APOP_name_overflow':'9002',
    'svcaclcnf-detected':'13279',
    'chilkatftp-chilkatcert-file-overwrite':'1238',
    'file-default-replaceable':'2486',
    'win-useraccounts-login-not-used':'14869',
    'Swf_Launch_Shell':'5900002',
    'Probing_of_important_files':'9110',
    'DB2_Connect_DoS':'1649',
    'win2k-ms03007-patch':'14944',
    'mozilla-javascriptengine-code-execution':'7091',
    'realserver-malformed-remote-dos':'9374',
    'rhel-rhsa-2007-0912-update':'10397',
    'ie-url-code-execution':'4857',
    'sql-injection-unionselect':'12884',
    'inetd-permissions':'5206',
    'blackice-startup-failed':'929',
    'SNMP_OID_Underflow':'2106101',
    'informix-long-username-bo':'5214',
    'http-htmlscript-file-access':'3631',
    'Telnet_Client_SLC_Long_Reply':'2116018',
    'sendmail-check-relay-bypass':'11482',
    'rhel-rhsa-2005-049-update':'9824',
    'interface-exportname-dir-traversal':'5900002',
    'rhel-rhsa-2005-303-update':'9891',
    'Suspect_Systat':'13268',
    'TCP_SynAck_With_Data':'2124062',
    'PDF_PrintSeps_Overflow':'5900002',
    'backdoor-subseven-client':'731',
    'HTTP_IE_HTA_Remote_Exec':'2106234',
    'SSH2_Pubkey_auth_failed':'13022',
    'IKE_association_negotiation_failed':'5035',
    'rhel-rhsa-2006-0543-update':'10136',
    'http-cgi-imagemap-bo':'3581',
    'decod-irc-msg':'1708',
    'LDAP_blacklist_permanent':'5837',
    'Allaire_JRun_ViewDirectory':'328',
    'rhel-rhsa-2008-0031-update':'10478',
    'msvm-verifier-java':'7469',
    'kerberos-inject-base64-encode':'5701',
    'libtiff-jpeg-decoder-bo':'5884',
    'rhel-rhsa-2007-1086-update':'10457',
    'Image_WMF_GDI_Image_Overflow':'5109',
    'malcode-StealPasswordFile':'6731',
    'smtp-debug':'11853',
    'exchange-owa-execute-code':'2292',
    'TCP_SYN_flood':'13464',
    'HTTP_Cdomain':'2106042',
    'user-shutdown-onceonly':'14015',
    'HTTP_Novell_Files':'2106026',
    'file-exists-noncompliant':'2498',
    'exploit-MSPowerpoint(100015)':'2364',
    'ibm-lenovo-acpcontroller-format-string':'4570',
    'PDF_Launch':'8804',
    'SMB_Indeo_Filter_DLL_Hijacking':'5900002',
    'malcode-VB_3':'6822',
    'snmp-backdoor-password':'12041',
    'pdftops-integer-overflow':'8812',
    'cipe-packet-handling-dos':'1251',
    'HTTP POST data contains _...':'3522',
    'win-ms07kb936548-update':'14593',
    'leadtools-common-dialogs-dos':'5900002',
    'mambo-phpsessid-gain-privileges':'6923',
    'slapper-worm-c':'11688',
    'Xanadu_TCP_Request':'2113165',
    'Update_Installation':'13924',
    'exploit-MSExcel(100025)':'2354',
    'SNMP SUN hidden community':'12025',
    'Sensor_Warning':'11525',
    'Sockets_de_Troie':'12324',
    'rhel-rhsa-2010-0112-update':'5900002',
    'ghost-backdoor':'3081',
    'SSH_agent_auth._failure':'13029',
    'rhel-rhsa-2002-125-update':'9516',
    'honeywell-scanserver-code-exec':'5900002',
    'DHCP_Broadcast_Assignment':'1799',
    'sdp-ansi-escape':'11404',
    'flexgrid-activex-bo':'5900002',
    'spyware-egroup':'12542',
    'IPM_Quarantine_Rule_Added':'5325',
    'backdoor-truva12':'740',
    'OEM_Not_Installed':'8405',
    'win2k-mapped-account-failed':'14941',
    'sun-jre-imagelibrary-privilege-escalation':'13216',
    'root-path-onceonly':'10839',
    'linux-glibc-read-files':'5931',
    'decod-robots-check':'1732',
    'MSRPC_Spoolss_Overflow':'2119020',
    'HTTP GET AltaVista password':'3495',
    'Oxon_TCP_Response':'2113223',
    'http-rpc-request-detected':'3684',
    'XDMCP_gdm_exploit':'15210',
    'rhel-rhsa-2010-0258-update':'5900002',
    'php-libxmlrpc-bo':'8869',
    'ssreader-pdg2-bo':'13119',
    'rhel-rhsa-2010-0349-update':'5900002',
    'Image_EMF_Long_Description':'2104039',
    'Telnet Bad Environment':'13508',
    'wireshark-mq-format-string':'15127',
    'openssl-ssl3-sessionid-bo':'8499',
    'FTP session status DoS':'2814',
    'winnt-indexserver-sqlqhit-asp':'15062',
    'Session_disconnected':'11562',
    'Exchange_imap_authentication_failures':'2315',
    'win-ms06kb917336-update':'14506',
    'nt-power-user-blankpwd':'8236',
    'rsagent-ipop3d-bruteforce':'11058',
    'c2-auditing-disabled':'1056',
    'TFTP Web Transfer':'13639',
    'hpdi-hpodio08-file-overwrite':'5900002',
    '3com-ap-accept-broadcast':'7',
    'Logon_with_admin_privileges':'6033',
    'HTTP_double-encoded_.._':'3889',
    'adobe-dirapi-bo':'5900002',
    'win-rdp-checksum-leak':'14815',
    'nt-ppt-patch':'8240',
    'samba-sidparse-bo':'5900002',
    'weblogic-banner-enabled':'14234',
    'cisco-acl-established':'1253',
    'win-ms03043-patch':'14393',
    'Gauntlet_ICMP_DoS':'2106008',
    'voip-brute-force':'14169',
    'win-ms11kb2489979-update':'5900002',
    'Critical_File_Deleted':'1535',
    'BIFF_Excel_Lotus123_CodeExec':'2106247',
    'apache-modproxy-information-disclosure':'5900002',
    'firefox-addmicrosummary-info-disclosure':'2617',
    'bind-inverse-query-disclosure':'848',
    'SNMP_bad_varbind_tag':'12169',
    'vscan2001-trojan':'14186',
    'HTTP_Nfuse_Path':'2002753',
    'sendmail-ruleset-parsing-bo':'11509',
    'IPM_Rogue_TCP_Packet':'5331',
    'IPV6_Fragment_Overlap':'2108002',
    'User_account_locked_out':'14032',
    'xml-large-document-dos':'15242',
    'ms-dns-code-execution':'5900002',
    'sendmail-relaying-features':'11508',
    'rhel-rhsa-2008-0194-update':'10522',
    'malcode-ChangingIEStartPageOnSpecificTime':'6173',
    'mozilla-javascript-code-execution':'7085',
    'BGP_Route_Unreachable':'824',
    'trojan-turkojan':'13784',
    'exploiter-backdoor':'2394',
    'DNS crack successful':'1844',
    'openssl-ascii-int-bo':'8484',
    'jre-toolkit-command-execution':'5900002',
    'file-not-frozen':'2530',
    'rhel-rhsa-ipsectools-isakmpinforecv-dos':'10699',
    'ms-smb-pool-code-execution':'7206',
    'Rendezvous_Detected':'9487',
    'BlackBerry_SRP_DoS':'2106279',
    'win2k3-group-sync-agent-privilege':'14994',
    'dns_name_offset':'1938',
    'webserver-ssl-version-detected':'14249',
    'AIX_Pdnsd_BO':'302',
    'win-ms10kb978706-update':'14789',
    'RUN_reg_hack':'11229',
    'snmp-set-any':'12105',
    'MOV_Detected':'7049',
    'SecurityTablesAccessed':'11475',
    'mozilla-principal-code-execution':'7122',
    'Trinoo_master_activity':'13771',
    'rhel-rhsa-2005-173-update':'9869',
    'win-ms10kb2079403-update':'5900002',
    'realplayer-avi-bo':'5900002',
    'nds-user-with-logon-script':'7658',
    'adobe-compactfont-code-execution':'5900002',
    'kerberos-krb5klogsyslog-bo':'5704',
    'user-homedir-norx':'13966',
    'spyware-netpal':'12665',
    'rpc-pcnfsd':'10880',
    'Back_Orifice_2000_auth':'650',
    'Hack-a-tack_ping':'3251',
    'coldfusion-webpublish-execute-code':'1402',
    'winxp-digital-encryption-disabled':'15095',
    'friendly-createurlshortcut-bo':'2742',
    'baidu-baidubar-code-execution':'787',
    'HTTP_IE_FileViewer_Code_Exec':'4015',
    'Runlevel_Switched':'11230',
    'MIDI_Malformed':'5900002',
    'CGI websendmail':'1168',
    'HTTP_WinHTTP_Chunked_Overflow':'2110195',
    'BGP_Notify_Msg_Unknown_Code':'5900002',
    'SSH2_DNS_lookup_failed':'13006',
    'RIP_Malformed':'5900002',
    'ypbind-ypset-root':'15346',
    'nntp-post':'7866',
    'php-base64encode-integer-overflow':'8851',
    'decod-packet-capture-remote':'1720',
    'nt-lock-memory-onceonly':'8155',
    'win-ms09kb962238-update':'14719',
    'ftp-glob-tilde-brace':'2847',
    'SSH2_Login_General':'13016',
    'wireshark-gsm-bssmap-dos':'15117',
    'ICC_Ace_Corruption':'5900002',
    'solaris-yppasswd-bo':'12391',
    'SSH2_Illegal_port_forwarding':'13013',
    'win-ms12kb2691442-update':'5900002',
    'Cold_Fusion_cache_URL':'1387',
    'HTTP_MSCS_ProfileSvc_Overflow':'2106154',
    'thttpd-ifmodifiedsince-header':'13694',
    'malcode-PackedVBStrong':'6421',
    'mysql-sqlparcecc-information-disclosure':'7532',
    'HTML_GoogleApps_Command_Exec':'3397',
    'file-owner-valid':'2536',
    'update-file-baseline':'13915',
    'malcode-ExeSeq22_Ren':'6272',
    'citrix-provisioning-code-execution':'5900002',
    'IMAP4 login failed':'5151',
    'EvilFTP_trojan_horse_activity':'2240',
    'mysql-comtabledump-dos':'7516',
    'multiple-browser-charset-xss':'7479',
    'rpc.portmap dump':'10914',
    'Telnet terminal type overflow':'13523',
    'ie-mshtml-bo':'4807',
    'sendmail-xheader-bo':'11516',
    'rhel-rhsa-php-multiple-unspecified-bo':'10753',
    'nt-rpc-ver':'8287',
    'IMAP_Password':'5183',
    'HTML_MMc_XSS':'2113259',
    'easyfilesharing-obtain-information':'2022',
    'minicom-xmodem-format-string':'7023',
    'file-insecure-setuid':'2516',
    'ie-save-picture-spoofing':'4828',
    'opera-contentlength-bo':'5900002',
    'downloadject-javascript-execution':'1991',
    'SecretService_Response':'2001578',
    'rhel-rhsa-2002-173-update':'9531',
    'mozilla-browser-code-exec':'5900002',
    'POP_User':'9041',
    'decod-imap4-command-long':'1705',
    'nt-lock-duration':'8153',
    'malcode-SPNE_Srch_Wrt_DTA':'6613',
    'rhel-rhsa-2005-514-update':'9969',
    'SDP_Integer_Overflow':'2106296',
    'snmp-rmon-getevent':'12103',
    'hp-instantsupport-deletesingle-file-deletion':'3305',
    'HTTP_Oracle_Appserver_ViewInfo':'2106159',
    'RPC_Tooltalkd_Overflow':'2001703',
    'snmp-oid-underflow':'12096',
    'CGI_formmail.pl':'1185',
    'HTTP URL contains %00':'3531',
    'zenworks-zam-code-execution':'5900002',
    'nctaudiofile2-activex-bo':'7593',
    'HTTP_Bash_Shell_History':'2002544',
    'nt-nprpc-dos':'8212',
    'rhel-rhsa-2007-0389-update':'10308',
    'win2k-session-reconnected':'14964',
    'aix-iy79092-fix':'260',
    'RPC CALLIT unknown':'10851',
    'boep-cmd':'947',
    'ms-win-dfs-code-exec':'5900002',
    'vaio-activex-bo':'5900002',
    'allaire-jrun-ssifilter-url':'318',
    'Spyware_PH_MySearchBar':'2113176',
    'win-ms06kb910729-update':'14480',
    'QuickTime_Image_SignExt_Code_Execution':'9269',
    'adobe-trust-manager-security-bypass':'5900002',
    'second-life-detected':'11427',
    'nt-chronicle-present':'8018',
    'FTP_WUFTP_RealPath_BO':'2110025',
    'rhel-rhsa-2004-373-update':'9722',
    'html-script-extension-evasion':'3368',
    'HTTP_YouSendIt_Email_Attachment':'4539',
    'aix-iy89178-fix':'297',
    'spyware-onflow':'12682',
    'rhel-rhsa-2009-1185-update':'5900002',
    'nt-user-neverloggedon':'8354',
    'RTF_OpenOffice_prtdata_Overflow':'5900002',
    'sncp5-prmsetnetworkparam-bo':'11958',
    'nis-compatible-mode':'7834',
    'JSON_Hijacking':'2122038',
    'HTTP_OpenView_NNM_snmpviewer_Overflow':'5900002',
    'HTML_YGP_PicEditor_DoS':'2114085',
    'ssl-ca-certificate-spoofing':'13072',
    'HTTP POST sam._ file':'3527',
    'HTTP_Apache_ModProxy_Bo':'2118016',
    'rhel-rhsa-2007-0002-update':'10213',
    'win2k-ldap-change-passwords':'14933',
    'HTTP_eDirectory_AcceptLanguage_Overflow2':'5900002',
    'CGI_perl':'1201',
    'WebStore admin URL':'14258',
    'PRC_Bad_Reference':'5900002',
    'kernel-nfconntrack-security-bypass':'5746',
    'malcode-VBAInfectAutoOwnCodeSus':'6856',
    'file-target-notfrozen':'2552',
    'opera-escape-sequence-dos':'5900002',
    'modperl-pathinfo-dos':'7035',
    'file-uucp-group':'2557',
    'rhel-rhsa-2004-047-update':'9665',
    'XML_JNLP_j2se_Tag_Overflow':'15251',
    'boep-fwenc':'949',
    'sojourn.cgi_argument_contains_%00':'12362',
    'rhel-rhsa-2007-0166-update':'10270',
    'win-license-code-execution':'14361',
    'MSMessenger_Login':'7269',
    'powerpoint-mso-code-execution':'9082',
    'Local_group_user_added':'6012',
    'HTTP_PHF_CommandExec':'2002524',
    'malcode-SPNE_SC_KbdHook':'6606',
    'Bigorna_TCP_Response':'2113087',
    'rsagent-suspect-ftp':'11144',
    'outlook-nntp-response-parsing-bo':'8687',
    'malcode-SPPE_DLL_WrtToSect_Bound':'6659',
    'awstats-require-plugin-include':'638',
    'ie-css-string-code-execution':'4723',
    'works-section-header-code-execution':'15166',
    'html-body-tag-onload-large':'3364',
    'Nachi_Ping_Protection':'2110038',
    'iis-samples-codebrws':'4982',
    'spyware-toolbarcc':'12771',
    'Email_Extensionless_File_URI':'2103',
    'ie-sameoriginpolicy-bypass':'4827',
    'netscape-enter-secure':'7724',
    'Application_Communication_Blocked':'524',
    'Telnet_Password_Overflow':'2000903',
    'openlink-remote-execute':'8457',
    'win-winverifytrust-code-execution':'5900002',
    'fileview-winzip-activex-code-execution':'2571',
    'ICMPv6_Route_Information_Exec':'4626',
    'rhel-rhsa-2008-0945-update':'10608',
    'aix-iy81476-fix':'264',
    'netbackup-long-request-bo':'5900002',
    'leaktest-detected':'5857',
    'FTP CWD directory overflow':'2789',
    'TFTP_WinIni_File':'2003705',
    'false_positive':'2438',
    'File_Integrity_Monitoring_Policy_Invalid':'2566',
    'SMTP_ParseAddr_Overflow':'2110011',
    'Helix_RealServer_Overflow':'2110052',
    'nt-ciscoscanner-present':'8019',
    'wordtrans-web-php-xss':'15163',
    'rdp-enabled':'9338',
    'dovecot-mboxstorage-directory-traversal':'1990',
    'malcode-Susp_MBR_Time':'6769',
    'win2k-universalgroup-member-added':'14987',
    'office-pict-image-code-execution':'8412',
    'intel-wireless-driver-code-execution':'5241',
    'xml-long-name-overflow':'15243',
    'CGI_wwwboard.pl':'1219',
    'spyware-2seek-toolbar':'12419',
    'globallink-glitemcom-bo':'3118',
    'nfs-portmap':'7808',
    'network-interface-promiscuous':'7774',
    'malcode-HTMLUsingWordActiveXCtrl':'6336',
    'postgresql-insecure-perms':'9068',
    'safari-chrome-style-dos':'5900002',
    'ipswitch-imail-imailsec-bo':'5355',
    'smtp-server-plaintext-credentials':'11877',
    'rhel-rhsa-2008-1007-update':'5900002',
    'win-lsass-bo':'14364',
    'NNTP_Group':'7872',
    'spyware-iemsg-hijacker':'12603',
    'HTTP_POST_JBoss_Traversal':'2109012',
    'nt-filesys':'8073',
    'win-isapi-nsiislog-bo':'14354',
    'realpath-bo':'9352',
    'tcp-oob-sent':'13389',
    'reg-syskey-encryption':'9450',
    'Email_Outlook_Date_Overflow':'2102016',
    'Infector_FTP_Response':'2100010',
    'zone-file-download':'15382',
    'HTTP_IIS_Index_Server_Overflow':'2002608',
    'spyware-gigexagent-speeddelivery':'12571',
    'mozilla-xslt-code-execution':'7143',
    'sshd-info':'13068',
    'nt-group-batch':'8086',
    'SSH_Version':'13064',
    'global-village-modem-dos':'3111',
    'Nimda RICHED20.DLL':'7830',
    'SNMP_Cisco_VACM_MIB':'2106000',
    'passwd-wrong-sequence':'8739',
    'RMP_Filename_Path_Traversal':'2110120',
    'realplayer-qcp-media-bo':'5900002',
    'HTTP_Oracle_Appserver_Overflow':'2002641',
    'rlpr-msg-format-string':'10825',
    'aix-iy55360-fix':'172',
    'nt-getadmin':'8081',
    'rhel-rhsa-2010-0101-update':'5900002',
    'wireshark-xot-dos':'15144',
    'RPC_Mountd_Packet_Length_Corrupt':'2116031',
    'IP fragment overlap':'5265',
    'novell-iprint-uploadresource-bo':'7936',
    'rhel-rhsa-2005-793-update':'10035',
    'javascript-keyword-trickery':'5590',
    'rhel-rhsa-2007-0709-update':'10356',
    'incommand-backdoor':'5195',
    'rhel-rhsa-2003-087-update':'9585',
    'php-file-include':'8856',
    'win-mmc-resource-xss':'14386',
    'HP_NNM_AlarmSrv_Overflow':'2101082',
    'vulnerable-mozilla-product-detected':'14189',
    'iis-chunked-encoding-dos':'4919',
    'mozilla-javascript-garbage-race-condition':'7088',
    'quicktime-pixdata-bo':'9240',
    'BackOrifice2K_TCP_Auth_Response':'2001513',
    'Security_disabled_global_group_member_removed':'11452',
    'Image_EMF_OpenOffice_Integer_Overflow':'5900002',
    'acrobat-reader-gp-bo':'5900002',
    'rhel-rhsa-2005-782-update':'10030',
    'realmedia-file-detected':'9347',
    'Application Terminated':'509',
    'exploit-MSWord(100003)':'2375',
    'rpc.sadmind overflow':'10918',
    'aol-icq-code-execution':'381',
    'iis-http-host-dos':'4944',
    'MS_rpc_dump':'7239',
    'SQL_OpenRowSet_Overflow':'2113021',
    'Ascend_Kill_II':'2000204',
    'malcode-SPNE_SuspStr_Inet':'6615',
    'soliddb-auth-bypass':'5900002',
    'rhel-rhsa-2009-0001-update':'5900002',
    'Rwhod_Malformed':'11240',
    'nt-iis-rds':'8138',
    'Email_Notes_Attribute_Overflow':'5900002',
    'ca-scm-ecsqdmn-dos':'1084',
    'squid-httpversion-number-dos':'12939',
    'solaris-telnet-authentication-bypass':'12387',
    'Thinking_Arts_directory_traversal':'13693',
    'SNMP_VarBind_Underflow':'2106104',
    'xinetd-signal-leak-dos':'15231',
    'win-ms08kb950974-update':'14653',
    'malcode-SPDL_HDRO_Bnd':'6553',
    'win-ms06kb911565-update':'14484',
    'OTF_Uniscribe_Font_Parse_Corruption':'5900002',
    'win-ms08kb951376-update':'14658',
    'win-ms07kb925939-update':'14560',
    'spyware-expedioware':'12550',
    'tftp-get':'13646',
    'Sslvpn_Data':'13108',
    'mailsite-get-overflow':'6127',
    'rhel-rhsa-2005-583-update':'9987',
    'adobe-shockwave-swctl-bo':'136',
    'oracle-java-jre-unspecified':'5900002',
    'emf-malformed-polyline-detected':'2167',
    'forms-vuln-patch':'2705',
    'MSRPC_Srvsvc_Bo':'2118077',
    'malcode-AttribIndicator2':'6150',
    'Bind_Version_Request':'870',
    'SQL HTTP xp_cmdshell':'12876',
    'rhel-rhsa-2005-299-update':'5900002',
    'rhel-rhsa-2010-0503-update':'5900002',
    'rhel-rhsa-2003-386-update':'9645',
    'win-ms06kb908531-update':'14478',
    'aardvark-path-disclosure':'32',
    'IIS_password_change':'5019',
    'S2_Scan_Completed':'11247',
    'qpopper-auth-bo':'9180',
    'mozilla-content-type-bo':'7067',
    'Oracle_KUPW_Worker_Injection':'5900002',
    'ms-iis-url-auth-bypass':'5900002',
    'Fore_Response':'2701',
    'SSL_SoftEther_Detected':'13097',
    'ms-ie-memcorrupt-code-execution':'5900002',
    'netmail-webadmin-bo':'7711',
    'TCP_Timestamps_Code_Execution':'13469',
    'malcode-SPMZ_MCB_MZSig':'6572',
    'rsa-securid-web-agent-bo':'11008',
    'PDF_XFA_Script':'5900002',
    'AVI_DirectShow_MPEG3_Overflow':'5900002',
    'HTTP_Groupwise_Path':'2105012',
    'spyware-whenu-clocksync':'12806',
    'ipop3d-overflow':'5332',
    'LDAP_Lotus_Domino_OctetString_Heap_Overflow':'5846',
    'rhel-rhsa-2002-211-update':'9536',
    'CompoundFile_Word_Code_Exec':'2106260',
    'malcode-SystemBuddy':'6790',
    'libtiff-unchecked-arithmetic-dos':'5892',
    'amanda-backdoor':'341',
    'win-ms06kb913580-update':'14492',
    'Pict_Office_Filter_Overflow':'8935',
    'firefox-imagegraphics-code-execution':'2625',
    'Suspect_Netbus':'13260',
    'malcode-word6_FormatDrive':'6904',
    'HTTP_Answerbook_AddAdmin':'2105054',
    'yahoomsg-file-transfer':'15331',
    'HTTP_HyperHelp_Exe_Hijacking':'5900002',
    'cero-backdoor':'1122',
    'rhel-rhsa-2007-0473-update':'10321',
    'rsagent-registry-remote-edit-changed':'11103',
    'nt-registry-request-dos':'8275',
    'win-ms10kb2207566-update':'5900002',
    'icmp-nofragment-lowmtu-dos':'4599',
    'malcode-Susp_Srch_sys_hid':'6775',
    'malcode-SPMZ_Jmp_WrtFile_int':'6570',
    'Sun_Java_Web_SOCKS5_BO':'13233',
    'Last2000_TCP_Request':'2113117',
    'DB2_Kuddb2_DoS':'1650',
    'tcp-synack-with-data':'13399',
    'realvnc-auth-bypass':'9376',
    'Search97.vts':'11423',
    'JavaScript_Suspicious_Encoded_Content':'2110187',
    'pdf-obfuscated-stream':'8784',
    'rhel-rhsa-2007-0342-update':'10290',
    'hpsoftware-hpediag-information-disclosure':'3343',
    'Oracle_Warehouse_Builder_Injection':'5900002',
    'win-ms11kb2618444-update':'5900002',
    'iis-passive-ftp-w3svc':'4971',
    'DNS_IQuery':'2000409',
    'low-vulnerability-event':'6063',
    'TFTP_Nachi_Worm':'2110031',
    'nt-shutdown-without-logon':'8309',
    'Sybase_Failed_Connection':'13297',
    'HTTP_SAP_Message_Group_Overflow':'5900002',
    'dns-cache-snoop':'1865',
    'HTTP_WebManager_Httpsave_overflow':'2002631',
    'RPC_Kerberos_Credentials_Exec':'5900002',
    'CGI_view-source':'1212',
    'ASM_Email_Received':'569',
    'SMIL_WallClock_Time_Overflow':'5900002',
    'FTP_Glob_TildeBrace_Vulns':'2106067',
    'Chargen_Denial_of_Service':'2000211',
    'opera-unicode-spoofing':'8510',
    'media-file-bo':'6973',
    'servu-mdtm-bo':'11559',
    'ftp-hostsfile-transfer':'2850',
    'rhel-rhsa-2006-0598-update':'10154',
    'rhel-rhsa-2012-0142-update':'5900002',
    'QwertosRat_TCP_Response':'2113057',
    'bo-syslog':'943',
    'rhel-rhsa-2010-0636-update':'5900002',
    'linux-keyringsearchone-dos':'5943',
    'aix-iy67472-fix':'211',
    'Rlogin_Name_Very_Long':'2002102',
    'InstallShield_Silent_Installer':'2103034',
    'spyware-kontiki':'12623',
    'rhel-rhsa-2010-0705-update':'5900002',
    'HTTP_DosDevice':'2002655',
    'DPAPI_auditable_data_unprotected':'1997',
    'Finger_Root':'2111010',
    'reg-echo CGI':'9395',
    'vnc-weak-authentication':'14159',
    'decod-nntp-user':'1719',
    'win-ms07kb936542-update':'14592',
    'tomcat-proxy-directory-traversal':'13729',
    'brightstor-arcserve-tapeeng-bo':'1002',
    'Oracle_InterConvFuncts_Bo':'2120048',
    'aurigma-imageuploader-bo':'608',
    'rhel-rhsa-2007-0376-update':'10303',
    'javawebstart-unspecified-priv-escalation':'5655',
    'rhel-rhsa-2007-1016-update':'10425',
    'HTTP_GET_Filename_pwl':'2003804',
    'spyware-wishbone-toolbar':'12835',
    'Synthesized_Host_Attack_Flood':'2102035',
    'ie-uninitialized-code-exec':'4854',
    'Scada_KingView_History_Generic_Overflow':'5900002',
    'multiple-databases-guest-gain-access':'7482',
    'winsmtp-helo-bo':'15087',
    'SMTP_Attack':'11886',
    'rhel-rhsa-2004-604-update':'9776',
    'google-skia-code-execution':'5900002',
    'AVI_Malformed_Header':'629',
    'ARCserve_Backup_LGServer_rxrlogin_BO':'2101009',
    'mysql-udfinit-gain-access':'7533',
    'nt-policy-audit-failure':'8230',
    'nt-ntpwdll':'8213',
    'linux-execve-gain-privileges':'5927',
    'malcode-KazaaDropper':'6363',
    'rhel-rhsa-2009-0057-update':'5900002',
    'spyware-eroswoman':'12545',
    'user-homedir-user-owned':'13974',
    'rlogin-froot':'10801',
    'rhel-rhsa-2009-1163-update':'10676',
    'microsoftwindowsbackup-dll-ce':'5900002',
    'sun-rpc-statd':'13231',
    'TFTP_PWL_File':'2003704',
    'ISA_PF_Interface_Bind_Failure':'5511',
    'malcode-VB_29':'6821',
    'malcode-VB_26':'6818',
    'HTTP_WebLogic_FileServlet_Show_Code':'4498',
    'malcode-VB_24':'6817',
    'quicktime-poly-type-bo':'9241',
    'IMAP_Literal_Contents_Overflow':'5900002',
    'malcode-VB_20':'6814',
    'malcode-VB_21':'6815',
    'openldap-ldap-protos-dos':'8453',
    'rpc-cachefsd-service-enabled':'10870',
    'isa-conn-limit-exceed-disconnected':'5432',
    'DHCP_Param_Overflow':'1810',
    'SNMP value underflow':'12036',
    'http-multiple-binary-fields':'3649',
    'web-conferencing-code-injection':'14217',
    'JavaScript_Unescape_Obfuscation':'2110151',
    'sip-invalid-invite-address-detected':'11619',
    'XML_NFuse_Citrix_Web_Password_Exec':'5900002',
    'ethereal-dissectors-code-execution':'2204',
    'ldap-response-asn1-error':'5900002',
    'HTTP_Windows_Executable':'2002595',
    'apache-http-host-xss':'438',
    'HTML_DOMINO_Web_Access_Overflow':'2110156',
    'CGI webgais':'1167',
    'http-unknown-protocol':'3702',
    'Mstream handler activity':'7451',
    'flash-linux-swf-code-execution':'5900002',
    'Oracle_Shutdown':'8609',
    'HTTP_SharePoint_Auth_Bypass':'2113036',
    'malcode-HalfInfection':'6322',
    'system32-directory-file-written':'13340',
    'intralaunch-activex-code-execution':'5254',
    'brightstor-lgserver-port1900-bo':'1009',
    'storm-activex-bo':'13152',
    'Y3K ICQ pager URL':'15294',
    'SNMP_TooManyVariables':'2106121',
    'ruler-backdoor':'11225',
    'FTP_hosts_file':'2934',
    'SNMP_hangup':'12206',
    'IIS data service query':'4887',
    'exim-header-bo':'5900002',
    'mpg321-long-filename-bo':'7147',
    'Chmod_setuid':'1246',
    'DHCP_ClientID_DoS':'2101000',
    'ie-active-scripting':'4681',
    'nt-snmpagent-leak':'8314',
    'rhel-rhsa-2006-0669-update':'10180',
    'evt_openfail':'2246',
    'smtp-exec':'11858',
    'rsagent-exchange-pop3-auth-fail':'11034',
    'sdp-null-in-value':'11411',
    'isa-pf-protocol-violation':'5464',
    'win-ms08kb945553-update':'14629',
    'tetex-lprng-tmp-race':'13617',
    'Content_Analyzer_Social_Security_Num':'2120076',
    'win-ms08kb933103-update':'14620',
    'RPC_CALLIT_attack':'10943',
    'bind-hostname-disclosure':'847',
    'rhel-rhsa-2005-864-update':'10062',
    'bind-nxt-bo':'853',
    'BIFF_Lotus_123_OutsideIn_Exec':'5900002',
    'nt-group-load-driver':'8095',
    'rhel-rhsa-2008-0180-update':'10518',
    'WINS_PointerHijack':'2111036',
    'PDF_GetAnnots_CodeExec':'2124064',
    'user-mntdev-character':'13992',
    'cde-dtspcd-bo':'1113',
    'rhel-rhsa-mozilla-email-messages-overflow':'10717',
    'reg-logon-username-hidden':'9407',
    'SMB_NT_Transact_OPEN2_Bo':'2118143',
    'FTP_File_Exec':'2001316',
    'rsagent-account-expired':'11010',
    'HTTP_POST_data_contains_.._.._.._..':'4307',
    'Melissa_virus':'6986',
    'decod-http-tilde':'1701',
    'HTTP_GET_passwd_file':'3952',
    'exploit-MSPowerpoint(100013)':'2362',
    'http-unreslink':'3703',
    'Spyware_PH_BroadcastPC':'2113179',
    'rhel-rhsa-2004-434-update':'9737',
    'malcode-SPPE30_Orig':'6642',
    'Oracle_TNS_Remote_Registration':'5900002',
    'win-ms11kb2571621-update':'5900002',
    'rhel-rhsa-2006-0602-update':'10156',
    'groupwise-web-path':'3186',
    'starteam-server-bo':'13136',
    'win-ms10kb2032276-update':'5900002',
    'wireshark-ntp-format-string':'15133',
    'rhel-rhsa-mozilla-valueof-sandbox-bypass':'10728',
    'TFTP_MSBlaster_Worm':'2110022',
    'sun-syslogd-bo':'13232',
    'gauntlet-dos':'3062',
    'AOLIM_Password_Change':'398',
    'TLS_Server_Cipher_Renegotiation':'13719',
    'OfficeOCX_ActiveX_Multiple_BO':'2124054',
    'wuftp-glob-heap-corruption':'15185',
    'weblogic-http-version-disclosure':'14237',
    'win-ms10kb968095-update':'5900002',
    'rhel-rhsa-2005-880-update':'10067',
    'snmp-requestid-invalidtag':'12102',
    'reg-sys-log-recent':'9448',
    'HTTP_IndexServer_IDQ':'2106024',
    'application-added-known-list':'510',
    'TotalEclypse_Response':'2001593',
    'acrobatreader-xfdf-bo':'53',
    'TFTP_Get_Filename_Format_Specifier':'5900002',
    'nt-rlogin':'8286',
    'openview-nnm-getnnmdata-bo':'5900002',
    'SNMP SET sysContact':'12023',
    'ms-sql-ms00092-patch':'7210',
    'ethereal-sip-packet-dos':'2211',
    'michal-backdoor':'7000',
    'rhel-rhsa-2005-771-update':'10027',
    'excel-selection-bo':'2263',
    'rhel-rhsa-2006-0298-update':'10113',
    'powerpoint-record-code-execution':'9084',
    'spyware-loverspy-demo':'12627',
    'sunjava-webadmin-bbs':'13237',
    'ms-time-binary-code-execution':'5900002',
    'Hidepak_Rootkit_Login':'2116003',
    'HTTP_IDS_Script_Injection':'2121034',
    'ssh2-common-auth-failed-user':'12991',
    'quicktime-pict-bo':'9239',
    'flash-flv-malformed':'2673',
    'winxp-signing-client-agrees':'15101',
    'win-media-encoder-code-exec':'5900002',
    'nt-domain-guest-nopwd':'8056',
    'CompoundFile_Excel_Invalid_Version':'2106277',
    'win-ms06kb928088-update':'14551',
    'sdp-equal-overflow':'11405',
    'TLS_Large_Client_Certificate':'5900002',
    'http-cgi-textcounter':'3598',
    'Symantec_AMS_Size_Exec':'5900002',
    'samba-negotiate-protocol-dos':'5900002',
    'rhel-rhsa-2007-0777-update':'10374',
    'cw10-wlan-reveal-registry':'1587',
    'rpc.bootparam_whoami_mismatch':'10899',
    'malcode-SPgen_ExpImport_IniMod':'6554',
    'pdfpro-activex-bo':'5900002',
    'kernel-listxattr-dos':'5741',
    'ms-sqlserver-sp2-update':'7216',
    'user-file-restricted':'13956',
    'SIP_Contact_From_Id_Mismatch':'2106289',
    'shockwave-swdir-activex-bo':'11600',
    'rhel-rhsa-2004-152-update':'9688',
    'HTTP_PHP_SQuery_LibPath_Include':'5900002',
    'rhel-rhsa-2004-615-update':'9780',
    'nt-account-audit':'7961',
    'SMTP_Ipswitch_IMail_Mime_BO':'11910',
    'rhel-rhsa-2005-344-update':'9909',
    'cobalt-shp-overflow-privileges':'1378',
    'NT_RASMAN_Privilege_Escalation_attempt':'8379',
    'HTTP_ASP_AppFolder_Disclosure':'2106218',
    'ie-win2k-com-dos':'5900002',
    'ie-com-kilbit-code-execution':'4714',
    'XML_JNLP_Encoding_CodeExec':'5900002',
    'rhel-rhsa-2007-1048-update':'10443',
    'is-scan-policy-status':'5421',
    'netraider-backdoor':'7718',
    'BackConstruction':'659',
    'spyware-turbodownload':'12781',
    'IP source route end':'5268',
    'http-pipelined-connection-detected':'3662',
    'Email_Expn':'2001004',
    'apache-header-hrs':'435',
    'telnet-running':'13542',
    'proftpd-ftpserver-backdoor':'5900002',
    'win-ms09kb975539-update':'14769',
    'FTP NLST directory overflow':'2803',
    'tftp':'13657',
    'HTTP URL contains _._':'3534',
    'tcpmux':'13483',
    'solaris-newgrp-bo':'12382',
    'FTP_Stor_Very_Long':'2001354',
    'MJPEG_Compression_Mismatch':'5900002',
    'FTP_Epsv':'2914',
    'ca-arcservebackup-lgserver-bo':'1066',
    'totaldefense-uncsw-code-execution':'5900002',
    'openviewnnm-activex-bo':'8508',
    'black-angel-backdoor':'900',
    'rpc.nfs_mknod':'10908',
    'DNS spoof attempt':'1856',
    'malcode-Win32_Sober_N':'6883',
    'DNS_Chaos_Request':'2000411',
    'reg-ras-service-installed':'9427',
    'ISAKMP_Dead_Peer_Detection_DoS':'5900002',
    'ms-officeweb-html-code-execution':'7193',
    'sccp-invalid-messageid':'11356',
    'dns-dot-query':'1869',
    'mail-attachment-name-suspicious':'6107',
    'malcode-IRCUDPFlood':'6358',
    'rhel-rhsa-2007-0257-update':'10281',
    'rhel-rhsa-2010-0162-update':'5900002',
    'malcode-VBACountMacrosInfectSus':'6853',
    'HTTP_Weblogic_SSIServlet_ShowCode':'2106050',
    'netscape-enterprise-invalid-command-dos':'7727',
    'FTP login failed':'2799',
    'Scada_IGSSdataServer_Dir_Traversal':'5900002',
    'JavaScript_Packer_Epsilon':'2114165',
    'SNMP_bad_rqst_Id_tag':'12162',
    'Telnet_Inline_Demo_Capslock':'13571',
    'SNMP_trap_addr_invalid':'12278',
    'decod-snmp-set':'1746',
    'LDAP_Active_Directory_Paged_Request_DoS':'2106303',
    'ms-sqlserver-sp1-update':'7215',
    'linux-mgetty-symlink':'5945',
    'nt-fpnwclnt-incorrect':'8078',
    'SNMP_InvalidTag_SpecificTrap':'2106113',
    'cisco-secure-activex-code-execution':'5900002',
    'TFTP Traversal':'13638',
    'image22-activex-drawicon-bo':'5900002',
    'UDP_Probe_DNS':'13848',
    'baofeng-mpsstormplayer-bo':'794',
    'openunix-unixware-pasv-hijacking':'8504',
    'win2k-telnet-pipe-privileges':'14977',
    'kerberos-version5-running':'5713',
    'user-homedir-root-fs':'13970',
    'rhel-rhsa-2005-361-update':'9916',
    'HTTP_Sabpab_Trojan_Message':'5900002',
    'Image_RIFF_Malformed':'2102058',
    'malcode-Susp_MBR_Trk79':'6771',
    'winvnc-server-bo':'15091',
    'ASN1_X509_OID_Malformed':'578',
    'win-ms09kb973525-update':'14754',
    'HTTP_MayDay_Request':'4150',
    'DNS_WINS_DoS':'1967',
    'SNMP_PDU_Underflow':'2106079',
    'PDF_Server_Side_Script':'5900002',
    'malcode-SPPE_RsrcExec_Poly_A':'6687',
    'HTTP Pfdisplay Read':'3515',
    'Borland_Interbase_ServiceAttach_Overflow':'999',
    'spyware-factorynetwork-dialer':'12554',
    'realpage-activex-desturl-bo':'5900002',
    'backdoor-swift':'733',
    'apache-aprpsprintf-code-execution':'412',
    'NNTP_Password':'7878',
    'VmStoppingEvent':'14137',
    'php-phpinfo-function-xss':'8895',
    'CGI_machineinfo':'1194',
    'CyberCop_Scanner_TFTP':'2102005',
    'malcode-SPPE_Jmp_RelocExec':'6677',
    'spyware-sahagent':'12714',
    'NCP_eDirectory_Dsvread_BO':'2124074',
    'kde-konqueror-plaintext-password':'5693',
    'spyware-statblaster':'12752',
    'Email_ReplyTo_Executable':'2102024',
    'spyware-wintools':'12834',
    '3com-easy-setup-web-access':'16',
    'Telnet AUTH USER overflow':'13507',
    'win-object-packager-code-exec':'5900002',
    'mssql-oledb-adhoc-bo':'7419',
    'openbsd-ipv6-dos':'8445',
    'HTTP_Htimage_Exe':'2002577',
    'ie-gopher-bo':'4759',
    'Oracle_ConvertToLrsLayer_Injection':'5900002',
    'windows-gdi-emf-bo':'5900002',
    'TCP_OS_Fingerprint':'2000313',
    'bushtrommel-backdoor':'1049',
    'ident-port-probe':'4653',
    'win-vista-smbv2-code-execution':'14873',
    'mozilla-xpcom-memory-corruption':'7142',
    'Script_IE_Dev_Toolbar_Corruption':'5900002',
    'imap4-long-password':'5157',
    'subversion-date-parsing-command-execution':'13192',
    'Symantec_Management_Overflow':'2121059',
    'linux-kernel-ipv6-jumbogram-dos':'5938',
    'ssl-certificate-info':'13077',
    'Doly':'1978',
    'FTP_NetTerm_Mkd_Overflow':'2001335',
    'sql-injection-select-count':'12881',
    'Veritas_Vnetd_CodeExec':'5900002',
    'rhel-rhsa-2005-045-update':'9823',
    'smtp-helo-spoof':'11863',
    'msxml-dtd-information-disclosure':'5900002',
    'Sunrpc_rwall_Message':'13249',
    'TCP small segment size':'13377',
    'win-permanent-password-detected':'14807',
    'kerberos-telnet-security-bypass':'5710',
    'netware-get-directory-listing':'7768',
    'rhel-rhsa-2008-0244-update':'10541',
    'rhel-rhsa-2008-0178-update':'10517',
    'snmp-specifictrap-invalidtag':'12112',
    'Email_Auth_Failed':'2001609',
    'iis-internal-ip-disclosure':'4952',
    'rhel-rhsa-2005-413-update':'9940',
    'RPC_bad_credentials':'10937',
    'SMB_Malformed_Old':'11761',
    'spyware-donationtree':'12523',
    'backupexec-null-pointer-dos':'776',
    'win-srv2sys-code-execution':'14848',
    'HTTP_POST_data_with_repeated_char':'4310',
    'rhel-rhsa-2005-427-update':'9946',
    'spyware-z-search':'12841',
    'helixserver-rtsp-setup-bo':'3276',
    'system-monitor-activex-bo':'13337',
    'hp-dpm-rds-dos':'5900002',
    'user-passed-cronat':'13998',
    'UPX_Packed_Executable':'2103032',
    'sunrpc-rwall-message-detected':'13243',
    'HTTP_Favorites_Icon_Overflow':'2002555',
    'HTML_Access_Snapshot_Viewer_ActiveX':'3369',
    'lpd-wrapper-allow':'6070',
    'HTTP_OrderLogV12Dat':'2002549',
    'HTTP_IE3_URL':'4007',
    'rhel-rhsa-2005-271-update':'9885',
    'openssl-dochangecipherspec-dos':'8491',
    'spyware-btvDialer':'12476',
    'win-ms04kb870763-update':'14414',
    'ldap-detected':'5816',
    'PCAnywhere login failed':'8754',
    'aix-iy55681-fix':'174',
    'samba-msrpc-heap-corruption':'11268',
    'malcode-Susp_ProtectMode_WrtExe':'6773',
    'YahooMSG_Message':'15339',
    'bbzlphp-index-file-include':'5900002',
    'openbsd-isakmp-delete-dos':'8446',
    'zope-legacy-names':'15397',
    'tcp-mss-dos':'13388',
    'platinumftpserver-cd-command-dos':'8963',
    'rhel-rhsa-2007-0107-update':'10253',
    'SNMP bad rqst Id tag':'11977',
    'PingOfDeath':'2000012',
    'rsagent-user-added-global-admin':'11170',
    'win-wpad-netbios-spoofing':'5900002',
    'dataflood':'1640',
    'nt-rras-incoming':'8289',
    'nds-user-template-without-address-restriction':'7654',
    'FTP_Glob_Overflow':'2930',
    'win2k-named-pipes':'14945',
    'win-ms11kb2524426-update':'5900002',
    'verydoc-pdfview-activex-openpdf-bo':'14079',
    'nds-login-script-includes':'7609',
    'ie-dhtml-xss':'4729',
    'malcode-ChangingIEStartPageToPornSite':'6174',
    'tcp-zero-length-option':'13401',
    'tdfc-boot-timeout':'13485',
    'nt-audit-categories-onceonly':'7983',
    'rhel-rhsa-2009-1095-update':'10666',
    'rhel-rhsa-2007-0519-update':'10331',
    'spyware-twister':'12784',
    'yahoo-datagrid-bo':'15311',
    'oracle-appserver-modplsql-bo':'8522',
    'whatsup-maincfgret-bo':'14274',
    'SMB_Samba_SecurityDescriptor_Bo':'2118028',
    'rhel-rhsa-2004-378-update':'9723',
    'file-login-group':'2520',
    'NetBus_port_probe':'7702',
    'nfs-ultrix':'7822',
    'win2k-telnet-username-dos':'14979',
    'xoops-tinycontent-spawcontrol-file-include':'15268',
    'ms-directx-midi-bo':'7173',
    'adobe-unspecified-response-splitting':'141',
    'nntp-pipe-shell-metacharacters':'7864',
    'SMB_Cisco_Packet_Tracer_DLL_Hijacking':'5900002',
    'HTTP_3com_AirConnect_SecuritySetup':'2106015',
    'HTTP_IIS_Ida_Overflow':'4057',
    'rhel-rhsa-2009-1199-update':'5900002',
    'TFN2000':'13621',
    'Email_Listserv_Overflow':'2001034',
    'cisco-ios-snmp-server-community':'1303',
    'spyware-allhyperlinks':'12447',
    'trillian-xml-code-execution':'13761',
    'HTTP_Pfdisplay_Read':'4260',
    'nt-posix-sub-onceonly':'8234',
    'nav-outdated':'7581',
    'QuickTime_QTVR_String_Exec':'5900002',
    'radius-asndecodestring-bo':'9288',
    'active-directory-sid-inherit':'75',
    'win-ms09kb975254-update':'14766',
    'IPM_Quarantine_Rules_Cleared':'5329',
    'allaire-jrun-webinf-dotslash':'324',
    'SSH2_Pam_auth_failed':'13017',
    'office-ua-control':'8415',
    'cyrus-imsp-abookdbname-bo':'1609',
    'account-name-changed':'38',
    'rhel-rhsa-2009-0361-update':'10646',
    'FTP passwd file':'2804',
    'HTTP_Large_Request_Content':'5900002',
    'rpc-statd-enabled':'10887',
    'rhel-rhsa-2009-1550-update':'5900002',
    'rhel-rhsa-2006-0582-update':'10150',
    'realnetworks-gamehouse-dldisplay-bo':'9351',
    'ARKFailureEvent':'5900002',
    'excel-calendar-code-execution':'2251',
    'ultracrypto-cryptox-bo':'13872',
    'reg-ras-unencrypted-data':'9428',
    'Snort_Frag3_DoS':'5900002',
    'malcode-modifyingCode':'6376',
    'rpc-nlog.pl_CGI_command':'10879',
    'Nmap_OS_Fingerprint':'2000314',
    'HTTP_URL_contains__...':'4446',
    'PDF_Extraneous_Bytes':'5900002',
    'HTTP_Sametime_STMUX_Bo':'4361',
    'RPC_Portmap_Set':'2001708',
    '3com-baseline-dhcp-dos':'15',
    'udp-bomb':'13832',
    'CGI_imagemap.exe':'1191',
    'snmp-pdu-invalidtag':'12099',
    'Unknown_IP_protocol':'13903',
    'ie-codebase-execute-programs':'4713',
    'sfu-rpc-parameter-bo':'11566',
    'bittorrent-protocol-header-detection':'888',
    'Tini':'13702',
    'Flash_Jpeg_Overflow':'2678',
    'mozilla-netscape-xmlhttprequest-redirect':'7112',
    'noop-sled-double-escaped':'7899',
    'SNMP_Community':'12181',
    'http-sgi-webdist':'3691',
    'interscan-viruswall-httpsavec-bo':'5250',
    'POP_Password_Overflow':'2000702',
    'rhel-rhsa-2003-050-update':'9573',
    'active-directory-replication-link-success':'72',
    'etc-writable-dir':'2197',
    'PPTP_PoPToP_Ctrl_Packet_BO':'2110138',
    'FTP_Root':'2989',
    'DHCP_Long_Discover_Message':'2110065',
    'rhel-rhsa-2009-0275-update':'10624',
    'SIP_SQL_Injection':'11668',
    'oracle-subscriptionname-sql-injection':'5900002',
    'Napster_Search':'7567',
    'rsagent-oracle-connect-failed':'11087',
    'nt-sys-key':'8324',
    'fix-suspicious-message-detected':'2664',
    'ms-win-dns-dos':'5900002',
    'DNS_TMG_Overflow':'5900002',
    'win-ms07kb933729-update':'14583',
    'netware-bitmap':'7767',
    'win-netbus-installed':'14800',
    'win-ms11kb2496930-update':'5900002',
    'HTML_Java_Web_Start_ActiveX':'5900002',
    'directx-media-sdk-traffic-detected':'1827',
    'Sunrpc_rwall_Msg_Format_String':'2110053',
    'malcode-SPTRJ_Hide_Inet_Srv':'6712',
    'apache-modalias-modrewrite-bo':'445',
    'nt-guest-user':'8128',
    'adobe-certificate-spoofing':'116',
    'FTP_dotdotdot':'2001360',
    'Y3K_Ping':'2001536',
    'xfree86-xfs-dos':'15220',
    'OTF_Win64_Font_Unvalidated_Ptr':'5900002',
    'malcode-SPPE32':'6647',
    'cvs-request-path-detected':'1574',
    'aix-iy53519-fix':'170',
    'RFPoison attack':'9505',
    'dhcp-discover':'1793',
    'FTP_command_line_overflow':'2895',
    'SMTP MIME filename repeated blanks':'11829',
    'ipv6-detected':'5360',
    'nt-server-oper-user-pwd':'8303',
    'ms-win-helpctr-command-execution':'5900002',
    'Saihyousen Attack':'11257',
    'fw1-fwa1-auth-replay':'3045',
    'Agent Type Changed':'149',
    'HTML_IE_Embedded_Object_Code_Execution':'3403',
    'IKE_association_failed_Peer_Auth':'5034',
    'rhel-rhsa-2004-180-update':'9697',
    'TFTP_Web_Transfer':'13683',
    'OTF_Windows_Bad_Font_Index':'5900002',
    'HTTP_AnswerBook2_DocServer':'2105042',
    'win-ms05kb899588-update':'14451',
    'RPC_Legato_Portmap_Set':'2116023',
    'POP_Filename_Space_Overflow':'2000708',
    'MSSQL7_Shutdown':'7442',
    'M3U_Long_Filename_Overflow':'5900002',
    'smtp-multiple-login-failed':'11868',
    'SQL_SSRP_DoS':'2113018',
    'HTML_OneNote_URL_Code_Execution':'3445',
    'netxray-3probe-nopass':'7785',
    'yahoo-webcam-viewer-bo':'15328',
    'openssl-bnfrom-information-disclosure':'8489',
    'spyware-rightfinder':'12712',
    'tls-zero-length-record':'5900002',
    'sip-Long-method-name':'11625',
    'Security_disabled_global_group_member_added':'11451',
    'memcpy-bo':'6987',
    'google-chrome-notifications-code-exec':'5900002',
    'rhel-rhsa-2010-0060-update':'5900002',
    'rhel-rhsa-2012-0060-update':'5900002',
    'SNMP trap addr invalid':'12029',
    'hp-opennnm-nnmrptconfig-format-string':'5900002',
    'rhel-rhsa-2005-803-update':'10040',
    'quicktime-jpeg-bo':'9234',
    'Index Server reg hack':'5200',
    'SMB_Startup_File_Access':'2002706',
    'rhel-rhsa-openiscsi-mgmtipc-dos':'10739',
    'cmail-admin-default':'1362',
    'HTTP_Apache_DOS_Batch_Command':'3753',
    'UDP_Probe_NFS_Lockd':'13853',
    'Ohhara_Rootkit_Login':'2116007',
    'reg-install-file-location':'9399',
    'ms-win-ole-code-execution':'5900002',
    'SIP_Incomplete_Message':'2114003',
    'legal-case-information-disclosure':'5862',
    'IMAP_Authenticate_Overflow':'5167',
    'HTTP_Header_Request_Smuggle':'5900002',
    'sip-shell-command-execution':'11635',
    'shockwave-director-memory-code-exec':'5900002',
    'rpc-ttdbserverd-enabled':'10889',
    'pipiplayer-activex-control-bo':'5900002',
    'ident-newline':'4652',
    'tftp-file-brute-force-detected':'13644',
    'sql-injection-unionallselect':'12883',
    'irix-telnetd-syslog-format':'5418',
    'background-tag-visible':'751',
    'compound-document-detected':'5900002',
    'HTTP_Telnet_Exe_Hijacking':'5900002',
    'zhm-zfhipcnd-bo':'5900002',
    'FTP_Rmd_Very_Long':'2001346',
    'SNMP_Missing_Required_Field':'2101056',
    'win2k-grouptype-changed':'14926',
    'user-password-minage-off':'14002',
    'rhel-rhsa-2002-287-update':'9550',
    'ipv6-fragment-overlap':'5361',
    'rhel-rhsa-2005-551-update':'9979',
    'rhel-rhsa-2007-0555-update':'10339',
    'IMAP4_command_overflow':'5160',
    'rquotad':'11006',
    'epolicy-computerlist-format-string':'2177',
    'fsp-fspd':'2778',
    'nt-group-sec-audit':'8104',
    'mdaemon-webconfig-dos':'6967',
    'rhel-rhsa-2005-336-update':'9905',
    'apache-server-status-detected':'473',
    'rhel-rhsa-2004-064-update':'9672',
    'http-referrer-header-tag-detected':'3679',
    'spyware-l3merpl-irc':'12624',
    'CompoundFile_Excel_Style_BO':'2106246',
    'SNMP_Value_Underflow':'2106106',
    'TLS_Cipher_Renegotiation':'13717',
    'win-ms07kb939373-update':'14601',
    'URL contains UTF-8 encoding':'13934',
    'Image_JPEG_IE_Size_Overflow':'2106198',
    'spyware-alfa-search':'12446',
    'frozen-file-perms-changed':'2773',
    'active-directory-out-replication-disabled':'69',
    'rhel-rhsa-2005-751-update':'10017',
    'User_account_disabled':'14030',
    'rhel-rhsa-2007-0384-update':'10304',
    'SNMP_bad_err_status_tag':'12149',
    'win-ms08kb958644-update':'14693',
    'HTTP URL with blank appended':'3541',
    'SNMP WINS deletion':'12040',
    'kernel-nfnetlink-dos':'5747',
    'cisco-ios-eigrp-dos':'1284',
    'EMail_Generic_Intel_Overflow':'2104006',
    'SSL_Malformed_Certificate':'2120013',
    'Connection_Backdoor':'1485',
    'decod-nntp-group':'1717',
    'pound-logmsg-format-string':'9079',
    'gnupg-parsepacket-bo':'3140',
    'dhcp-zero-length-dos':'5900002',
    'sun-jre-jaxws-unauth-access':'13218',
    'HTTP_iPlanet_Search_BO':'2106131',
    'ethereal-bgp-dissector-dos':'2203',
    'win-smb-code-execution':'14841',
    'decod-dns-zone':'1682',
    'ms-win-clickonce-code-exec':'5900002',
    'Image_JPEG_Quicktime_Bo':'2118053',
    'RDS reg hack':'9342',
    'Image_Pattern_Overflow':'5095',
    'helixserver-rtsp-dos':'5900002',
    'linux-rsync-root-access':'5964',
    'rhel-rhsa-2006-0493-update':'10126',
    'csswebinstaller-activex-bo':'5900002',
    'malcode-REPA1':'6457',
    'VNC login failed':'14151',
    'SOLIDDB_Solid_ArrayIndex_DoS':'12396',
    'ms-win-unicode-code-execution':'5900002',
    'Global_group_user_added':'3115',
    'win2k-kerberos-dos':'14932',
    'lotus-dll-dynamic-bo':'6043',
    'freeradius-eap-mschapv2-auth-bypass':'2731',
    'FTP Site Exec DotDot':'2817',
    'aix-iy82866-fix':'268',
    'TFTP_Get':'13666',
    'HTTP_WhatsUpGold_Instance_Overflow':'2122018',
    'rhel-rhsa-2007-0740-update':'10369',
    'FTP_ZIPCHK_Meta':'2001320',
    'malcode-ProcessInjector2':'6430',
    'DHCP_Minires_Format_Overflow':'2115005',
    'SSH_Successful_rhosts_auth.':'13062',
    'malcode-CreateBinaryScriptAndShellsIt1':'6188',
    'ftp-cmds-binary-detected':'2833',
    'malcode-CreateBinaryScriptAndShellsIt2':'6189',
    'rhel-rhsa-2008-0008-update':'10475',
    'CiscoSccp_Message_Underflow':'2119008',
    'RPC_PcnfsdShell':'2001748',
    'TCP_Probe_PPTP':'13446',
    'malcode-DeleteStartupFiles':'6198',
    'win-ms11kb2640045-update':'5900002',
    'JavaScript_Keyword_Trickery':'2114176',
    'rhel-rhsa-2007-1082-update':'10454',
    'DNS_All':'1896',
    'showcode.asp':'11605',
    'SMTP_Groupwise_Email_Code_Exec':'11909',
    'hp-jetadmin-program-execution':'3314',
    'win2k3-user-sync-agent-privilege':'15001',
    'SMTP relay attempt':'11836',
    'win-ms08kb948881-update':'14641',
    'ospf-link-state-request':'8644',
    'nt-interactive-guest':'8144',
    'win-ms11kb2560656-update':'5900002',
    'SSH_Banner_Length':'2115002',
    'file-htaccess':'2509',
    'htdig-htsearch-infinite-loop':'3361',
    'spyware-zuviocom':'12846',
    'SMB_Rename_CodeExec':'5900002',
    'spyware-ipinsight':'12615',
    'ms-active-dll-code-execution':'5900002',
    'HTTP_Second_Life_Client':'4368',
    'linux-uselib-gain-privileges':'5983',
    'wuimapd-authenticated-user-bo':'15191',
    'openiscsi-mgmtipc-dos':'8451',
    'cpio-hardlink-unauthorized-access':'1525',
    'rhel-rhsa-2003-180-update':'9606',
    'rhel-rhsa-2005-384-update':'9927',
    'win2k3-create-global-privilege':'14989',
    'sharutils-uudecode-symlink':'11586',
    'HTTP_Oracle_SecureBackup_Privilege_Escalation':'5900002',
    'kernel-tcpv6synrecvsoc-dos':'5766',
    'Email_Decode':'2001013',
    'ms-uag-null-dos':'5900002',
    'adobe-ibfs32-code-exec':'5900002',
    'riff-director-movie-detected':'5900002',
    'innd-cancel-overflow':'5229',
    'Gnutella_Download':'3151',
    'pdf-embedded-goto-action':'8774',
    'NDMP_Veritas_BackupExec_RemoteAccess':'2113210',
    'quickbooks-activex-file-overwrite':'9210',
    'goahead-script-source-disclosure':'3156',
    'FFF_KeyView_Foliosr_BO':'2457',
    'malcode-CopyAndShellFile':'6184',
    'TCP_Port_Scan':'2000301',
    'helixserver-agentx-code-execution':'5900002',
    'HTTP POST contains group%by':'3519',
    'AVI_Integer_Overflow':'628',
    'Group_type_changed':'3182',
    'RAM_Domain_Overflow':'2121026',
    'SMTP_Xchg_Auth':'11954',
    'CGI rguest.exe':'1157',
    'HTTP_Waledac_Message':'2118145',
    'Sadmind_Ping':'11251',
    'javascript-large-unescape':'5592',
    'sccp-message-underflow':'11358',
    'spyware-msview':'12652',
    '3cserver-ftp-running':'26',
    'JavaScript_Large_FromCharCode':'2114167',
    'HTTP_Media_Player_Detected':'4158',
    'aix-iy78222-fix':'251',
    'SMTP_corrupted_MAIL_command':'11890',
    'Sybase_No_Configuration_File':'13298',
    'XDMCP_Session_Accepted':'15213',
    'sun-irunbook-information-disclosure':'13204',
    'afp-sec-bypass-ce':'5900002',
    'nt-ssl-fix':'8320',
    'file-lnk-content-detected':'5900002',
    'RPC_Amd_Overflow':'2001718',
    'SSL_PCT1_Overflow':'2113023',
    'win-ms06kb912919-update':'14489',
    'antisniff-dnstest':'372',
    'reg-trojan-pw-synch':'9454',
    'win-ms07kb921585-update':'14554',
    'nessus-scanctrl-file-overwrite':'7667',
    'RIPAdd':'10788',
    'malcode-SPNE_OverWrt_Regedit':'6602',
    'crystalreports-enterprisetree-bo':'1550',
    'win-ms10kb2347290-update':'5900002',
    'win-ms03042-patch':'14392',
    'U3D_Adobe_Content_Exec':'5900002',
    'phpcatalog-idparameter-sql-injection':'8922',
    'exploit-MSOutlook(100017)':'2360',
    'Skype_Detected':'11686',
    'hp-instantsupport-getfiletime-bo':'3309',
    'scp-cliproxy-activex-bo':'11370',
    'nt-local-logon':'8151',
    'symantec-rar-multiple-bo':'13313',
    'rsagent-exchange-login-other-mailbox':'11027',
    'Email_Outlook_Malformed_Vevent':'2114032',
    'spyware-overpro':'12687',
    'SMTP MIME null charset':'11832',
    'eclass-sslvpn-endpoint-format-string':'5900002',
    'spyware-purity-scan':'12700',
    'ipswitch-imail-bo':'5354',
    'nt-disabled-account-blankpwd':'8042',
    'Java_Sandbox_Breach_Dos':'5900002',
    'epolicy-source-header-bo':'2186',
    'smartvmd-activex-mutiple-file-overwrite':'11702',
    'firefox-libvorbis-code-execution':'5900002',
    'oracle-appserver-soap-components':'8532',
    'DNS_Bind_SIG_Overflow':'2106162',
    'HTTP_Mambo_Phpsessid':'2002696',
    'Fore':'2700',
    'pdf-javascript-detected':'8782',
    'POP3 port probe':'8997',
    'malcode-RebootsFromHTML':'6445',
    'rhel-rhsa-2008-0514-update':'10566',
    'rhel-rhsa-2007-1013-update':'10424',
    'officeviewer-save-file-overwrite':'8427',
    'rhel-rhsa-2004-421-update':'9736',
    'outlook-express-false-attachment':'8676',
    'adobe-shockwave-code-execution':'5900002',
    'YahooMSG_PeertoPeer':'15341',
    'UDP_Syslogd_BO':'2118026',
    'nav-warning':'7585',
    'ca-discovery-service-bo':'5900002',
    'HTML_IE_ActiveX_Loader_Heap_Corruption':'2106196',
    'altnet-download-activex-bo':'335',
    'switch-user-onceonly':'13293',
    'spyware-webhancer':'12804',
    'sendtemp-pl-read-files':'11518',
    'usermanager-activex-bo':'5900002',
    'malcode-CO3':'6177',
    'CGI_guestbook.pl':'1188',
    'malcode-CO1':'6176',
    'UPnP_Request_Overflow':'2110133',
    'Malformed LSA request':'6916',
    'malcode-CO4':'6178',
    'FTP_Netware_Delete_Overflow':'5900002',
    'win-ms08kb949785-update':'14646',
    'rhel-rhsa-2011-0422-update':'5900002',
    'Scada_Modbus_ReadDeviceID':'11345',
    'Image_EMF_OpenOffice_Heap_Overflow':'5900002',
    'System_Info_Alert':'13345',
    'rhel-rhsa-2005-529-update':'9975',
    'uusee-sendlogaction-bo':'5900002',
    'exploit-MSWorks(100018)':'2381',
    'nds-root-trustee-rights':'7618',
    'rhel-rhsa-2005-472-update':'9953',
    '3com-special-functions-web-access':'24',
    'rhel-rhsa-2007-0150-update':'10263',
    'php-ftpputcmd-crlf-injection':'8860',
    'HTTP_POST_SQL_UnionSelect':'2113030',
    'win2k-ncm-gain-privileges':'14946',
    'win-ms10kb2160841-update':'5900002',
    'HTML_Mozilla_ChromeURI_Traversal':'2118121',
    'rhel-rhsa-2004-670-update':'9789',
    'favicon.ico_bad_format':'2442',
    'Dameware_Spoof_Overflow':'2113137',
    'wuftpd-skey-bo':'15190',
    'zone-low-java':'15387',
    'rsh-spoof':'11197',
    'rhel-rhsa-2007-0391-update':'10309',
    'win-server-xp-land-dos':'14832',
    'http-webgais-query':'3712',
    'ms-money-prtstb06-dos':'5900002',
    'rhel-rhsa-2010-0549-update':'5900002',
    'UDP_Port_Scan':'2000201',
    'Finger Scan':'2583',
    'EPolicy_Orchestrator_POST_Overflow':'2113241',
    'Mantis_TCP_Response':'2113074',
    'nt-changedservice-error':'8009',
    'RPC TCP port probe':'10863',
    'HTTP_OpenView_NNM_OvLaunch_Overflow':'2101087',
    'rsagent-probing-files':'11096',
    'rhel-rhsa-2007-0001-update':'10212',
    'expertpdfeditorx-activex-file-overwrite':'2340',
    'sun-java-web-socks-bo':'13210',
    'spyware-iesearchbar':'12606',
    'IP_PingOfDeath_Jolt2':'2000018',
    'HTTP_Reversed_Byte_Range':'5900002',
    'malcode-SPPE_DO_WrtSect_Spawn':'6673',
    'Back_Orifice_scan_seen':'656',
    'prov-update-uninstall':'9139',
    'SMB_DeskPan_Clsid_DLL_Hijacking':'5900002',
    'rhel-rhsa-2007-0732-update':'10366',
    'XML_Document_Too_Large':'2119012',
    'decod-smtp-invalid-command':'1739',
    'LDAP_Active_Directory_App_Mode_DoS':'5829',
    'ftp-proxy':'2864',
    'ie-data-stream-code-execution':'4725',
    'rhel-rhsa-2009-0474-update':'10656',
    'IRC_port_probe':'5402',
    'exploit-MSExcel(100022)':'2351',
    'HTTP_Webevent':'2002596',
    'Email_VCF_Overflow':'2002906',
    'win-ms07kb932554-update':'14581',
    'rhel-rhsa-2009-0408-update':'5900002',
    'rhel-rhsa-2006-0574-update':'10144',
    'mailman-headers-dos':'6120',
    'malcode-SuspTruncation':'6783',
    'sdp-value-format-string':'11412',
    'HTTP_GotoMyPCDOTCom_Connection':'3973',
    'Configuration File Change':'1483',
    'win-ms06kb923689-update':'14535',
    'spyware-powerstrip':'12693',
    'nt-ip-source-route':'8145',
    'novell-iprint-getprinterurllist-bo':'7927',
    'rhel-rhsa-2003-045-update':'9570',
    'Bonk attack':'983',
    'HSRP_Resign':'2111007',
    'scada-modbus-forcelistenonly-mode':'11325',
    'win-ms08kb942831-update':'14625',
    'ie-modal-read-files':'4796',
    'ie-url-bo':'4855',
    'Oracle_Connect_Internal':'8592',
    'Failed_login-unknown_error':'2432',
    'file-inet-group':'2512',
    'ftp-exec':'2841',
    'sql-injection':'12886',
    'ethereal-wcp-dissector-bo':'2215',
    'toshiba-recordsend-bo':'13741',
    'win-ms08kb956391-update':'14680',
    'Prosiak_Response':'2001572',
    'mutt-imap-format-string':'7495',
    'rsagent-suspect-www':'11158',
    'Video_Flic_Color_BO':'2114023',
    'SMB_IO_Printer_Share':'2000503',
    'rhel-rhsa-2007-0878-update':'10388',
    'thunder-xpplayer-bo':'13696',
    'mysql-authentication':'7510',
    'rhel-rhsa-2007-0157-update':'10268',
    'isa-ip-half-scan-detected':'5450',
    'asterisk-iax2protocol-ack-dos':'5900002',
    'spyware-Clariadatemanager':'12489',
    'ipcs-messq':'5305',
    'rsagent-account-disabled':'11009',
    'SIS_Unsigned_Installer_Detected':'5900002',
    'VoodooDoll_TCP_Request':'2113084',
    'rhel-rhsa-2002-221-update':'9539',
    'ie-adodb-stream-disabled':'4685',
    'phppgadmin-sqlphp-include-file':'8927',
    'HTTP_Get_Content_Length':'2114173',
    'boep-lsass':'954',
    'gtp-c-element-overflow':'3198',
    'Ping_Flood':'2000102',
    'win2k-prewin2k-compatible-access':'14949',
    'nap-login':'7552',
    'ms-aspdotnet-stateserver-bo':'7157',
    'microsoft-truetype-code-exec':'5900002',
    'malcode-Susp_MBR_TimeTrig':'6770',
    'SNMP discovery broadcast':'11996',
    'HTTP_Html_In_Ref':'2121001',
    'ie-mht-bo':'4792',
    'rhel-rhsa-2006-0178-update':'10085',
    'http-post-createtable':'3665',
    'rhel-rhsa-2005-325-update':'9897',
    'NokNok_TCP_Response':'2113144',
    'Telnet_Too_Many_AYTs':'2000918',
    'sendmail-debug-signed-int-overflow':'11488',
    'TSMRCAS_DSMAgent_BO':'13815',
    'win-printspooler-bo':'14813',
    'malcode-ExeSeq22_DateTime':'6269',
    'Telnet bad TERM':'13510',
    'SMB_Lnk_File_Accessed':'5900002',
    'rservice-login-wrapper-allow':'11189',
    'aix-iy73850-fix':'242',
    'kernel-elf-dos':'5730',
    'malcode-SPNE_AbsWrt_Misc':'6585',
    'isa-incorrect-dialup-ip':'5447',
    'HTTP_EZMall2000':'3903',
    'WINS_Replication_Partner_Overflow':'15083',
    'pdf-encoded-javascript-tag':'8776',
    'gtp-c-apn-corrupt':'3196',
    'rhel-rhsa-2007-0520-update':'10332',
    'oracle-appserver-owautil-gain-information':'8527',
    'Bionet ICQ pager URL':'872',
    'datev-dvbsexecall-command-execution':'5900002',
    'reg-print-insecure-installation':'9417',
    'SMTP Listserv Overflow':'11821',
    'Script_Indexing_Service_Corruption':'11388',
    'rhel-rhsa-2004-153-update':'9689',
    'xterm-envbo':'15284',
    'rhel-rhsa-2003-312-update':'9638',
    'Firebird_Username_Overflow':'2615',
    'gnorpm-temp-symlink':'3127',
    'msrpc-webclient-message-bo':'7300',
    'reg-tcpip-filtering-enabled':'9452',
    'Update_Available':'13922',
    'windows-gdi-emf-code-exec':'5900002',
    'ms-win-dns-code-execution':'5900002',
    'smtp-syslog':'11879',
    'mssql-sqldmo-bo':'7430',
    'tls-weak-certificate':'5900002',
    'lycosfileuploader-fileuploader-activex-bo':'6091',
    'hsrp-suspicious-priority':'3355',
    'ibiz-fiprofile20-file-overwrite':'4560',
    'snort-stream4-reassemble-bo':'12309',
    'interbasexe-connect-bo':'5900002',
    'TCP_Split_Handshake':'5900002',
    'Scheduled_Baseline_Comparision_Finished':'11363',
    'file-secure-writable':'2541',
    'mercury-authcrammd5-bo':'6989',
    'wingate-pop3-user-bo':'15053',
    'Script_OWC_Heap':'11397',
    'scanssh-detected':'11353',
    'malcode-Susp14a_COM':'6743',
    'FTP_ProFTPD_IAC_Overflow':'5900002',
    'squirrelmail-options-path-disclosure':'12961',
    'retrospect-client-bo':'9498',
    'dns_maxlen_pkt':'1937',
    'BigGluck':'831',
    'win-ms11kb2535512-update':'5900002',
    'rhel-rhsa-2005-569-update':'9983',
    'rhel-rhsa-2007-1037-update':'10439',
    'HTML_Image_Source_Executable':'3421',
    'POP_Command_Overflow':'2000704',
    'HTML_Mozilla_XBL_Exec':'3440',
    'proftpd-prnetiotelnelgets-bo':'5900002',
    'U3D_Adobe_Memory_Corruption':'5900002',
    'SubSeven_CGI_notification':'13181',
    'VPS_File_Size_Exceeds_Scan_Limit':'14183',
    'rhel-rhsa-2008-0555-update':'5900002',
    'win-ms06kb920213-update':'14518',
    'rhel-rhsa-2007-0992-update':'10421',
    'rhel-rhsa-2009-1206-update':'5900002',
    'Telnet login name well known':'13516',
    'Content_Incorrect_Extension':'2106191',
    'nt-user-account-disabled':'8345',
    'spyware-web3000':'12802',
    'imanager-tree-dos':'5900002',
    'HTTP_POST_contains_group%by':'4303',
    'lpr-port-probe':'6077',
    'javascript-unescape-eval-man':'5598',
    'http-sql-shell':'3693',
    'spyware-date-regon':'12512',
    'RPC CALLIT ping':'10850',
    'HTTP_Content_Disposition_DotDot':'2120037',
    'CGI_info2www':'1192',
    'malcode-FunnyDropper':'6305',
    'imagxpress-imagxpress8-file-overwrite':'5125',
    'malcode-REO2':'6456',
    'ms-asf-file-detected':'7156',
    'rhel-rhsa-2004-002-update':'9652',
    'IIS .printer overflow':'4886',
    'malcode-SPPE_DO_Exec_Reg':'6665',
    'win2k-globalgroup-created':'14921',
    'AVI_Streams_Value_Overflow':'5900002',
    'FTP PORT restricted':'2810',
    'mozilla-vcard-doublefree-memory-corruption':'7137',
    'malwareprotectionengine-data-dos':'6922',
    'ie-meta-refresh-script-injection':'4791',
    'win-ms06kb921645-update':'14525',
    'rhel-rhsa-2004-650-update':'9786',
    'decod-ftp-mkdir':'1688',
    'TFN2K_UDP_Command':'2001590',
    'iscbind-rrsigrrsets-dos':'5900002',
    'squirrelmail-loadprefs-execute-code':'12955',
    'Hack-a-tack trojan horse activity':'3249',
    'LDAP_Malformed':'5900002',
    'dhcp-param-underflow':'1795',
    'reg-ups-interval':'9456',
    'HTML_Java_Web_Start_Jailbreak':'5900002',
    'AgentManagerDatabaseConnectionFailure':'160',
    'ms-windows-ldap-code-execution':'7229',
    'nt-group-logon':'8096',
    'nsemntd':'7945',
    'TheThing_Response':'2001591',
    'SSPING attack':'13117',
    'rhel-rhsa-mozilla-firefox-textbox-file-access':'10718',
    'lotus-mifsr-mif-bo':'5900002',
    'HTTP_Response_Set_Cookie_XSS':'4352',
    'coldfusion-cfcache':'1390',
    'android-malware-detected':'5900002',
    'IM_Password_Change':'5053',
    'nt-operator-blankpwd':'8219',
    'HTML_Akamai_DownloadManagerV2_ActiveX':'3373',
    'ZenWorks_hhMgr_op2_Overflow':'5900002',
    'HTTP_LastlinesCgi_CmdExecute':'2106062',
    'malcode-OtherAS':'6413',
    'iis-passive-ftp-wam':'4972',
    'StealthSpy':'13149',
    'Critical_File_Read':'1537',
    'msvm-html-applet-dos':'7461',
    'rhel-rhsa-2006-0194-update':'10089',
    'sccp-start-media-transmission':'11360',
    'isc-dhcp-packet-dos':'5900002',
    'Syphillis_Response':'2100015',
    'Content_Analyzer_Dollar_Amount':'2120077',
    'RPC_Pcnfsd_Sysname_Overflow':'5900002',
    'excel-style-repair-bo':'2266',
    'HTTP_POST_GroupBy':'2106173',
    'file-inet-root':'2513',
    'iis-passive-ftp-infocomm':'4970',
    'DNS_Cache_Poison_PortGuessing_Attack':'2101072',
    'IRDP_Gateway_Spoof':'2000107',
    'winamp-controller-bo':'5900002',
    'Unable to set firewall filter':'13877',
    'reg-sec-log-overwritten':'9434',
    'groupwise-web-read-files':'3187',
    'blackberry-srp-dos':'903',
    'win-avi-code-execution':'14297',
    'rhel-rhsa-2009-1278-update':'5900002',
    'yahoo-messenger-imvironment-bo':'15318',
    'rsagent-suspect-systat':'11154',
    'user-unused':'14026',
    'rhel-rhsa-2004-156-update':'9690',
    'win2k3-group-impersonate-client-privilege':'14993',
    '3com-modem-setup-web-access':'20',
    'coldfusion-source-display':'1399',
    'finger-bomb':'2585',
    'aix-iy77624-fix':'248',
    'Squid cachemgr.cgi':'12927',
    'gia-smtp-code-execution':'3089',
    'maxdb-webdbm-bo':'6944',
    'httpd-root-symlink':'4543',
    'trust-local-root':'13800',
    'rhel-rhsa-2004-467-update':'9752',
    'rhel-rhsa-openssl-sslgetsharedcip-bo':'10748',
    'reg-nt-vers-not-installed':'9412',
    'SMB2_SessionSetup_Resp_Overflow':'5900002',
    'confickere-worm-detected':'1479',
    'rhel-rhsa-2003-257-update':'9623',
    'smartserver3-smtp-bo':'11700',
    'reg-ras-gateway-enabled':'9423',
    'Content_Analyzer_User_Combined_5':'2120095',
    'Content_Analyzer_User_Combined_4':'2120094',
    'Content_Analyzer_User_Combined_7':'2120097',
    'vipw-world-readable-files':'14094',
    'Content_Analyzer_User_Combined_1':'2120091',
    'Content_Analyzer_User_Combined_0':'2120090',
    'Content_Analyzer_User_Combined_3':'2120093',
    'Content_Analyzer_User_Combined_2':'2120092',
    'HTTP_ColdFusion_Email_ExampleApp':'2002622',
    'nt-netbios-guestaccess':'8198',
    'kernel-clipmkip-dos':'5725',
    'eyeofgnome-image-format-string':'2405',
    'rhds-acceptlanguage-bo':'9509',
    'rhel-rhsa-2004-031-update':'9659',
    'chilkathttp-activex-file-overwrite':'1239',
    'RPC_Legato_Portmap_RemoteExec_Overflow':'5900002',
    'rhel-rhsa-2007-0074-update':'10238',
    'Satan_Scan':'11310',
    'ibm-ids-oninit-bo':'5900002',
    'dns-invalid-domain-offset':'1872',
    'ssh-protocol-version':'12979',
    'Radius_User_Buffer_Overflow':'2002911',
    'HTTP_RPC_Connect':'4358',
    'Unistim_Audio_Hijack':'2114100',
    'Y3K email':'15293',
    'SMTP_Recipient_with_trailing_dot':'11933',
    'Java_Admin_Servlet_backdoor_URL':'5586',
    'macrovision-isusweb-bo':'6105',
    'SMTP From':'11819',
    'adobe-flash-response-xss':'126',
    'IIS_system32_command':'5022',
    'ssl-certificate-improper-usage':'13076',
    't0rn-port-probe':'13352',
    'HTTP_Netscape_WPauth':'2105009',
    'gdb-dwarf-bo':'3069',
    'nt-domain-guest':'8058',
    'html-nullchar-evasion':'3367',
    'DNS_Query_All':'1949',
    'ms-word-code-execution':'7233',
    'novell-edir-ncp-dos':'5900002',
    'Cross_Site_Scripting':'2110173',
    'rhel-rhsa-2007-0631-update':'10346',
    'TFTP_File_Brute_Force':'2113224',
    'malcode-SPPE13':'6628',
    'malcode-SPPE12':'6627',
    'RIP_Metric_Change':'10787',
    'malcode-SPPE10':'6626',
    'malcode-SPPE17':'6631',
    'malcode-SPPE16':'6630',
    'SMB_ASN1_Overflow':'2107009',
    'rhel-rhsa-2010-0545-update':'5900002',
    'rpc-stat':'10886',
    'backupexec-registry-gain-privileges':'777',
    'malcode-SPPE18':'6632',
    'dcomsrv_deny':'1670',
    'malcode-NoIconInternet':'6389',
    'SNMP uint underflow':'12033',
    'ms-win-smb-responses-ce':'5900002',
    'citrix-streamprocess-bo':'5900002',
    'rhel-rhsa-2007-0933-update':'10400',
    'malcode-Odd_ThreadExec':'6392',
    'file-created':'2469',
    'virus-W97M.Marker.a':'14098',
    'SubSeven_ICQ_pager_URL':'13183',
    'backdoor-infra-trojan':'698',
    'Code Red I':'1379',
    'backdoor-kuang2v':'700',
    'programchecker-navigateurl-code-execution':'9124',
    'TheRevenger_Response':'2113058',
    'snmp-sequence-incorrect-length':'12104',
    'IRC_Litmus':'2105046',
    'aolphobosplaylist-phobos-bo':'401',
    'FTP command too long':'2787',
    'NFS port probe':'7792',
    'malcode-Susp_Fmt_WriteMZ':'6762',
    'mms-symbian-installer':'5900002',
    'rhel-rhsa-2008-0835-update':'10583',
    'ie-msradio-bo':'4809',
    'sol-snoop-getquota-bo':'12367',
    'decod-ssh':'1748',
    'HTTP_Guestbook':'2002514',
    'nt-security-id-lookup':'8300',
    'ms-smb-client-code-execution':'7204',
    'ISA_PF_Dropping_Packets':'5508',
    'Object_indirectly_accessed':'8399',
    'ms-ie-telnet-code-exec':'5900002',
    'kernel-trrx-dos':'5767',
    'HTML_VML_Overflow':'2110106',
    'Security_Management_StringSize_Overflow':'2106265',
    'DNS_Truncated_Response':'1959',
    'squid-cache-running':'12929',
    'mozilla-backslash-dos':'7060',
    'snmp-bad-trap-oid':'12049',
    'SNMP_Corrupt_Traffic':'2002001',
    'Netbios_Session_Request':'7696',
    'win2k-dnsupdate':'14915',
    'ca-arcserve-listctrl-bo':'1061',
    'win-ms06kb914388-update':'14493',
    'cmail-fileread':'1364',
    'CompoundFile_Excel_Sheet_Name_Overflow':'1438',
    'symantec-firewalls-nbns-bo':'13308',
    'openldap-bind-dos':'8452',
    'QuickTime_QTIF_ColorTable_Overflow':'5900002',
    'up2date-gpg-automatic-install':'13913',
    'ibm-lotus-domino-smtp-bo':'5900002',
    'rhel-rhsa-2008-0131-update':'10496',
    'ftgate-invalid-user-requests':'2784',
    'trillian-installed':'13759',
    'safari-documentwrite-code-execution':'5900002',
    'CGI tcsh':'1161',
    'MOV_UDTA_Overflow':'2114041',
    'UBB suspicious posting':'13824',
    'HTTP_Webmin_Traversal':'2106066',
    'spyware-teknum-updater':'12764',
    'C07h2250v4-attacktool-malformed-packets':'1055',
    'rhel-rhsa-2011-1402-update':'5900002',
    'squid-sslconnecttimeout-dos':'12946',
    'rhel-rhsa-2009-0410-update':'10651',
    'win-ms11kb2543893-update':'5900002',
    'HTTP_Gmail_Email_Attachment':'3969',
    'HTTP Form field name overflow':'3493',
    'spyware-winfavorites':'12831',
    'spyware-bookedspace':'12468',
    'Script_IE_Document_Corruption':'5900002',
    'psychward-backdoor':'9158',
    'hpvirtualrooms-unspecified-code-execution':'3349',
    'nortel-ipphone-spoof-dos':'7901',
    'java-iccprofilegetinstance-dir-traversal':'5900002',
    'nds-organizational-users':'7613',
    'rsagent-ssh-rsa-refused':'11137',
    'Telnet_Solaris_Forced_Login':'2103021',
    'DarkConnectionInside_TCP_Response':'2113092',
    'create-registry-baseline':'1532',
    'win-ms10kb980182-update':'5900002',
    'dot-net-text-executable':'1988',
    'Veritas_NetBackup_Request_Overflow':'5900002',
    'hp-opennnm-nameparams-bo':'5900002',
    'msn-ms04010-patch':'7279',
    'malcode-RestoreExe':'6462',
    'accesscnf-detected':'37',
    'POP3_false_attachment':'9008',
    'rhel-rhsa-2007-0057-update':'10228',
    'HTTP_Aglimpse':'2002503',
    'jintegra-activexc-code-execution':'5900002',
    'reg-not-frozen':'9410',
    'googlechrome-javascript-bo':'3166',
    'Backdoor_CIA_Response':'2110088',
    'rhel-rhsa-2007-0064-update':'10231',
    'HTTP_Oleacc_DLL_Hijacking':'5900002',
    'hp-advancestack-bypass-auth':'3299',
    'ospf-hello':'8641',
    'spyware':'12848',
    'user-mntdev-access':'13990',
    'win-ms05kb890923-update':'14433',
    'malcode-SWFSaveANDExec':'6787',
    'win-ms07kb925938-update':'14559',
    'novell-ndps-obtain-information':'7939',
    'HTTP_Apache_DOS':'2106039',
    'cross-site-request-forgery':'1547',
    'javase-jre-cve20120500':'5900002',
    'RPC_Mount_Overflow':'2001706',
    'dns_inv_dom':'1926',
    'Y3K_ICQ_pager_URL':'15299',
    'javase-jre-cve20120506':'5900002',
    'Media_File_BO':'2122016',
    'Rlogin_Session':'10821',
    'ms-tmg-firewall-bo':'5900002',
    'rhel-rhsa-firefox-lochostname-sec-bypass':'10689',
    'captiva-pixtools-activex-file-overwrite':'1098',
    'rhel-rhsa-2005-013-update':'9801',
    'irfanview-tiff-bo':'5900002',
    'TCP_Probe_Trojan':'13456',
    'LandeskXFR_Execute_FileShare':'5900002',
    'subscribe-me-command-execution':'13172',
    'kernel-seqfile-ipv6-dos':'5758',
    'DTr_TCP_Response':'2113097',
    'HTTP_Novell_Convert':'2002507',
    'rhel-rhsa-2008-0192-update':'10521',
    'Linuxconf_port_probe':'5992',
    'rsagent-localgroup-useradded':'11070',
    'firefox-mozilla-updater-priv-esc':'5900002',
    'rhel-rhsa-2009-0341-update':'10639',
    'leadtools-drivername-dos':'5900002',
    'AVI_Windows_Shmedia_DoS':'5900002',
    'ms-mfc-code-execution':'7186',
    'QuickTime_DirectShow_Code_Execution':'2101088',
    'kerberos-kadmind-code-execution':'5703',
    'sql-spida-worm':'12890',
    'novell-iprint-getserverversion-bo':'7928',
    'CGI nph-test-cgi':'1152',
    'Telnet_Known_User':'2000915',
    'hp-easy-printer-code-execution':'5900002',
    'http-win.ini-transfer':'3716',
    'nt-dcom-launch-permission':'8035',
    'rhel-rhsa-2008-0129-update':'10495',
    'nagios-plugins-checksnmp-bo':'7545',
    'malcode-SPCOM_MBR_CpySelf':'6548',
    'MSRPC_LSASS_Request_Detected':'7323',
    'win-posix-bo':'14810',
    'kernel-icmp-ipoptionsecho-dos':'5736',
    'DNS_HINFO_query':'1919',
    'Script_Lycos_FileUploader_BO':'2122035',
    'rhel-rhsa-firefox-passmgr-info-disclosure':'10691',
    'php-fopen-wrappers-bypass-security':'8859',
    'Cart32_ChangeAdminPassword_URL':'1107',
    'spyware-topsearch':'12774',
    'HTTP_Openwsman_Authentication_Header_Overflow':'2124090',
    'SNMP bad PDU tag':'11976',
    'socks4-connection-audit':'12339',
    'rhel-rhsa-2008-0512-update':'10565',
    'bugzilla-process-bug':'1040',
    'Script_OLE_Automation_Underflow':'5900002',
    'malcode-SPNE_Write_Sys_Dll':'6622',
    'rhel-rhsa-2005-112-update':'9854',
    'ms-winlivemessenger-dwmapi-code-exec':'5900002',
    'night-dragon-botnet-detected':'5900002',
    'LSA Secrets attempt':'6085',
    'Devil_Request':'2001550',
    'HackATack':'3253',
    'nt-dns-dos':'8047',
    'HTTP_iManager_POST_DOS':'2109010',
    'powerpointviewer-save-file-overwrite':'9086',
    'SMTP_Listserv_Overflow':'11911',
    'malcode-SPMZ_Kbd_CMOS':'6571',
    'file-device-location':'2491',
    'flipviewer-fviewerloading-bo':'2689',
    'solaris-fsauto-execute-code':'12375',
    'iis-ftp-bo':'4931',
    'ipswitch-imail-search-bo':'5900002',
    'DNS_Zone_Transfer':'2000401',
    'sendmail-mime-bo2':'11503',
    'Frenzy':'2740',
    'malcode-Susp14e_File':'6748',
    'blackberry-insresobject-code-execution':'902',
    'rhel-rhsa-2006-0052-update':'10073',
    'rhel-rhsa-2004-404-update':'9729',
    'bind-negative-cache-dos':'851',
    'rhel-rhsa-2009-0478-update':'5900002',
    'POP3 AUTH overflow':'8988',
    'WindowsMedia_ASF_Invalid_Stream':'5900002',
    'HTTP_User-Agent_overflow':'4473',
    'rhel-rhsa-2007-0154-update':'10266',
    'IBM_Cognos_Express_Default_Password':'5900002',
    'analogx-proxy-socks4a-bo':'352',
    'hp-ovnnm-execvpnc-bo':'5900002',
    'mozilla-multiple-memory-corruption':'7107',
    'zone-desktop-install':'15381',
    'php-view-source-code':'8913',
    'quicktime-hreftrack-code-execution':'9227',
    'rhel-rhsa-2010-0488-update':'5900002',
    'SecretService':'11428',
    'malcode-SPCOM_Jmp_Poly':'6546',
    'phprocket-directory-traversal':'8928',
    'Email_Calendar_RRULE_Exec':'5900002',
    'NFS-LOCKD_port_probe':'7801',
    'win-ms07kb931784-update':'14577',
    'rhel-rhsa-2006-0267-update':'10106',
    'Firewall_General_Attack':'2650',
    'rhel-rhsa-2004-412-update':'9732',
    'gnutls-rsakey-security-bypass':'3155',
    'malcode-VB_EmailsAndCopiesItself':'6838',
    'securetransport-filetransfer-activex-bo':'11433',
    'win-ms09kb968557-update':'14726',
    'RTF_Long_Control_Word':'5900002',
    'FTP_NetTerm_Dele_Overflow':'2001339',
    'netscape-directory-server-bo':'7723',
    'quicktime-quicktimestreaming-bo':'5900002',
    'HTTP_POST_Filename_sam':'2003902',
    'Script_YahooAssistant_ActiveX':'11402',
    'malcode-GenMalcodeLoader0':'6321',
    'aix-iy67807-fix':'218',
    'http-dropload-email-attachment':'3615',
    'IDENT suspicious ID':'4647',
    'dcforum-cgi-admin-access':'1656',
    'mailmanage-mmex-file-include':'6125',
    'win-ms08kb948745-update':'14640',
    'ExploreZip_virus':'2401',
    'PDF_Missing_endobj':'5900002',
    'HTTP_WebLogic_PluginBO':'2106048',
    'malcode-PackedVBInfector':'6420',
    'adobe-flash-authplay-code-execution':'5900002',
    'Linux_v2_Rootkit_Login':'2116005',
    'firefox-be-code-exec-var1':'5900002',
    'SOCKS_ShellCode_Detected':'12353',
    'firefox-javascript-code-execution':'2626',
    'InfoSearch_CGI_exploit':'5220',
    'malcode-Susp13a':'6739',
    'wireshark-nmas-ndps-offbyone-win':'15130',
    'adobe-asfunction-protocol-xss':'114',
    'nt-event-full':'8064',
    'dns-invalid-domain-packet':'1873',
    'http-powerdynamo-dotdotslash':'3674',
    'Oshare_Attack':'8637',
    'cisco-ios-ftp-unauthorized-access':'1287',
    'imc-configuration-file-info-disc':'5900002',
    'QuickTime_Table_Atom_Overflow':'9273',
    'ftp-lnk-directory-traversal':'2852',
    'SMTP_MIME_filename_repeated_chars':'11925',
    'kernel-copyfromuser-information-disclosure':'5727',
    'eserv-fileread':'2193',
    'Solaris_LPD_Overflow':'2100031',
    'win-ms11kb2478935-update':'5900002',
    'HTTP_Axis_Storpoint':'2002615',
    'dpc-execcmd-perl-code-execution':'5900002',
    'nt-autoshareserver':'7991',
    'rhel-rhsa-2008-1044-update':'5900002',
    'iis-index-dir-traverse':'4950',
    'win2k3-impersonate-client-privilege':'14996',
    'rhel-rhsa-2007-1028-update':'10434',
    'mozilla-http-referer-spoofing':'7081',
    'iis-check-enable-port-attack':'4913',
    'fetchmail-address-header-bo':'2448',
    'spyware-win32-backdoor-lixyb':'12816',
    'spyware-xupiter':'12840',
    'smtp-timeout-bo':'11880',
    'novell-edirectory-dhost-dos':'7911',
    'http-iis-aspsource':'3637',
    'sambar-http-post-bo':'11288',
    'jre-getsoundbank-bo':'5900002',
    'kernel-sysperfmon-dos':'5765',
    'rhel-rhsa-2005-476-update':'9956',
    'win-ms04kb889293-update':'14420',
    'SIP_Header_XSS':'2106290',
    'HTML_AIM_Away_Overflow':'2110060',
    'Domino_iCalendar_Organizer_Overflow':'5900002',
    'http-post-data-audit':'3666',
    'Possible_Fraggle_attack_initiated':'9056',
    'xdmcp-query':'15208',
    'rhel-rhsa-2005-745-update':'10014',
    'JavaScript_Flash_AddressBar_Spoofing':'2113249',
    'oracle-database-ctxdoc-sql-injection':'8541',
    'spyware-searchsquire':'12729',
    'virus-papa':'14097',
    'word-string-code-execution':'15158',
    'HTTP_OracleAdmin_help_overflow':'2105020',
    'HTML_Onunload_Trap':'2114045',
    'http-ie-lnkurl':'3633',
    'chilkat-crypt-activex-file-overwrite':'1236',
    'sshd-1223':'13067',
    'rhel-rhsa-2006-0177-update':'10084',
    'MSRPC_RemoteActivate_Overflow':'7362',
    'nt-sp4-auth-error':'8316',
    'JavaScript_Malicious_Aim_URI':'2114039',
    'analogx-proxy-http-bo':'351',
    'rhel-rhsa-2012-0033-update':'5900002',
    'mozilla-nss-security-bypass':'7113',
    'snmp-mib-readonly':'12090',
    'IPv6_Linux_Jumbogram_DoS':'2118128',
    'ie-html-directive-bo':'4766',
    'BackOrifice':'752',
    'winxp-client-signing-disabled':'15093',
    'services-running-system':'11554',
    'HTTP_IndexServer_SQLQHit':'2002688',
    'spyware-e2give':'12535',
    'Telnet_Auth_User_Overflow':'2000913',
    'WinTrin00_Daemon_Response':'2100003',
    'Oracle_WorkspaceMgr_Injection':'5900002',
    'HTTP_Htaccess':'2002561',
    'flowchart-edimage-code-execution':'5900002',
    'win-media-spn-code-execution':'14376',
    'win-wmex-activex-bo':'14881',
    'lockout-disabled-onceonly':'6017',
    'exploit-MSExcel(100024)':'2353',
    'Image_WMF_MaxRecordSize_Overflow':'5114',
    'Back_Orifice_response':'655',
    'ActiveX_Ignorelist':'87',
    'cisco-tracer-dll-code-exec':'5900002',
    'Security_disabled_universal_group_member_added':'11461',
    'nav-accept-cookies':'7571',
    'spyware-dwcomcom':'12532',
    'nt-multihomed':'8189',
    'misplaced-files':'7027',
    'win-ms11kb2497640-update':'5900002',
    'MicroSpy_TCP_Response':'2113085',
    'rhel-rhsa-2004-465-update':'9750',
    'tivoli-storage-mount-code-exec':'5900002',
    'iis-samples-showcode':'4983',
    'rhel-rhsa-2006-0368-update':'10118',
    'HTTP_Apache_Chunked_DoS':'3751',
    'win-msrpc-memalloc-dos':'14794',
    'nt-netmon':'8206',
    'linux-pamxauth-gain-privileges':'5952',
    'HTTP_TrendVCS_Auth_Bypass':'4431',
    'sip-request-sql-injection':'11630',
    'rsagent-oracle-object-successful':'11091',
    'chargen':'1230',
    'realplayer-activex-unauth-access':'5900002',
    'tcp-seq-predict':'13395',
    'php-lwzreadbyte-bo':'8871',
    'rhel-rhsa-mailman-unspecified-xss':'10707',
    'rhel-rhsa-2010-0458-update':'5900002',
    'Java_Deserialization_Privilege_Escalation':'5900002',
    'openview-nnm-ovactiond-execution':'8506',
    'MGCP_Long_Endpoint':'2104035',
    'ffmpeg-fourxmreadheader-code-execution':'5900002',
    'RDP_Brute_Force':'5900002',
    'squid-http-accelerator-portscanning':'12936',
    'google-chrome-websockets-dos':'5900002',
    'CompoundFile_ReleaseAfterFree_Exec':'5900002',
    'zope-dtmlmethods-gain-privileges':'15395',
    'Pict_Office_Filter_Underflow':'8936',
    'win-ms06kb911927-update':'14486',
    'Spyware_PH_GameSpyArcade':'2113187',
    'Oracle_Username_Bo':'2120031',
    'HTTP_IDS_Server_Detected':'4006',
    'teechart-activex-code-execution':'5900002',
    'Chupacabra':'1247',
    'mysql-command-insecure-file':'7515',
    'Exchange_anonymous_logon':'2314',
    'mysql-union-dos':'7534',
    'SMTP_encapsulated_relay':'11897',
    'rhel-rhsa-2007-0892-update':'10393',
    'rhel-rhsa-2005-034-update':'9814',
    'rpc.nfs_uid_is_zero':'10909',
    'SNMP community underflow':'11989',
    'rhel-rhsa-2011-1212-update':'5900002',
    'rsagent-space-shortage':'11107',
    'malcode-BackupExe':'6169',
    'SMB_BrightStor_Mailslot_Bo':'2118103',
    'rhel-rhsa-2008-0636-update':'5900002',
    'MSRPC_TrendMicro_ServerProtect_Bo':'7384',
    'win-ms08kb954593-update':'14673',
    'rhel-rhsa-2010-0102-update':'5900002',
    'HTTP_POST_dotdotdot_data':'2000624',
    'Empty_fragment':'2169',
    'unix-change-user-environ-file':'13891',
    'Swf_RealPlayer_Frame_Overflow':'2114141',
    'rsagent-exchange-pop3-unauth-wrongargnum':'11038',
    'nt-act-system-onceonly':'7965',
    'AOLIM_Message':'397',
    'HTTP_GET_Content_Length_Negative':'5900002',
    'rhel-rhsa-2007-0077-update':'10241',
    'http-crlf-injection':'3612',
    'aol-iwinamp-bo':'383',
    'HTTP URL with +.htr appended':'3539',
    'Napster_Sharing':'7568',
    'HTTP_Sambar_cgitest':'2105011',
    'HTTP_WebDAV_XML_Attribute_DoS':'2107037',
    'epolicy-long-post-bo':'2182',
    'HTTP_OpenView_NNM_CgiArgs_Overflow':'2101068',
    'Exchange_security_attribute_change':'2322',
    'rhel-rhsa-2011-0292-update':'5900002',
    'HTTP_GET_data_contains__...':'3939',
    'spyware-ilookup':'12610',
    'eperl-isindex-query':'2176',
    'securecrt-ssh1-identifier-bo':'11432',
    'TFN2K_ICMP_Command':'2001588',
    'web3d-activex-bo':'14221',
    'XML_Entity_System_File_Disclosure':'5900002',
    'tcpdump-isakmp-dos':'13480',
    'HTTP_Shells_C':'2002508',
    'Firewall_VPN':'2658',
    'mailman-java-css':'6121',
    'HTTP_ActiveX':'3733',
    'ms-win-duqu-code-execution':'5900002',
    'mozilla-javascript-engine-code-exec':'5900002',
    'siemens-activex-file-overwrite':'5900002',
    'SNMP_PDU_Incorrect_Length':'2101062',
    'Email_Uuencoded_Data':'5900002',
    'win-ms08kb947081-update':'14634',
    'HTML_BlackIce_BITIFF_ActiveX':'3383',
    'rhel-rhsa-2005-012-update':'9800',
    'TCP_Probe_BitTorrent':'13429',
    'nt-ppt-patch-missing':'8239',
    'wireshark-ansimap-format-string':'15109',
    'nt-privil-audit':'8246',
    'http-acunetix-wvs-scan-detected':'3548',
    'microsoft-directspeech-activex-bo':'7004',
    'netscape-client-html-bo':'7722',
    'rhel-rhsa-2006-0597-update':'10153',
    'rhel-rhsa-2004-260-update':'9714',
    'informix-username-bo':'5216',
    'win2k-event-viewer-bo':'14919',
    'SNMP_Unsupported_Version':'2101055',
    'openbsd-isakmp-ipsec-dos':'8447',
    'blackice-agenttype-changed':'906',
    'sendmail-debug-gain-root':'11487',
    'win-ms06kb919007-update':'14517',
    'Back_Orifice_ping':'654',
    'Zip_Password_Protected':'15373',
    'rhel-rhsa-2005-709-update':'10011',
    'CVS_Argumentx_Double_Free':'2107020',
    'rhel-rhsa-2005-007-update':'9796',
    'ILOVEYOU worm':'5041',
    'rhel-rhsa-2005-386-update':'9928',
    'nds-trustee-rights':'7620',
    'Snoop_GetQuota_Overflow':'2001745',
    'HTTP_Skype':'4396',
    'IP_Flushot':'2000022',
    'linux-mprotect-security-bypass':'5950',
    'win-ms09kb970811-update':'14739',
    'cobalt-poprelayd-mail-relay':'1373',
    'win-wins-gsflag-dos':'14878',
    'solaris-answerbook2-remote-execution':'12369',
    'TCP_Zero_Length_Option':'2000315',
    'trendmicro-officescan-objremovectrl-bo':'13754',
    'aix-tcpstack-dos':'5900002',
    'apache-tomcat-default-account':'485',
    'PGM_Options_DoS':'5900002',
    'wireshark-sscop-dos-win':'15136',
    'nt-force-logoff':'8074',
    'malcode-SPPE_DO_WrtSect_Misc':'6672',
    'nt-modem-dialtone':'8186',
    'win-ms09kb972652-update':'14751',
    'Telnet_login_failed':'13575',
    'SMTP_Relay_Not_Allowed':'2110002',
    'Exchange55_unauthenticated_pop3_command_invalid':'2308',
    'HTTP_AIMExpress':'3738',
    'msxml-request-code-execution':'7472',
    'novell-zenworks-remote-management-bo':'5900002',
    'jsws-webdav-format-string':'5900002',
    'nt-minage':'8184',
    'win-rdp-activex-bo':'14814',
    'win2k-brute-force':'14903',
    'fpse-smarthtml-interpreter-bo':'2716',
    'mozilla-javascript-engine-overflow':'7086',
    'rhel-rhsa-2006-0666-update':'10177',
    'adobe-acrobat-reader-code-exec':'5900002',
    'MSSQL7_Successful_Non-Trusted_Connection':'7444',
    'cisco-ios-ipv6-dos':'1291',
    'Local_group_changed':'6009',
    'NetAdministrator_TCP_Response':'2113131',
    'BGP_New_Route':'821',
    'rhel-rhsa-2006-0576-update':'10146',
    'zune-activex-file-overwrite':'15400',
    'XWINDOWS_port_probe':'15291',
    'iconics-activex-control-code-execution':'5900002',
    'HTTP_Apache_Trailing_Slash':'2125000',
    'SNMP_SMI_Counter64_Found':'12265',
    'nds-user-not-security-equiv-of-group':'7640',
    'net-administrator-backdoor':'7674',
    'sharepoint-default-pathinfo-xss':'11583',
    'login-shell-not-frozen':'6025',
    'spyware-freescratchcards':'12564',
    'rhel-rhsa-2004-546-update':'9764',
    'spyware-vx2bc777-sitehlprbho':'12798',
    'win-sharepoint-services-xss':'14837',
    'adobe-swf-bo':'138',
    'ddos-mstream-master':'1673',
    'rhel-rhsa-2005-018-update':'9805',
    'user-netrc-exists':'13994',
    'Sensor_Error':'11522',
    'win-asn1-library-bo':'14294',
    'python-execvpe-tmpfile-symlink':'9166',
    'SQL_PreAuth_Overflow':'2120002',
    'HTTP_URL_Snork_Bat':'2002541',
    'aix-iy55790-fix':'177',
    'SOAP_ASPNet_RCP_Encode_DoS':'2110096',
    'CGI guestbook.pl':'1141',
    'backdoor-hackersparadise':'694',
    'win-ms05kb893086-update':'14438',
    'FTP_compress_exec_exploit':'2899',
    'NNTP Message-ID too long':'7860',
    'nt-eventlog-anon':'8065',
    'squirrelmail-multiple-xss':'12960',
    'Informix_Session_Password_Overflow':'5900002',
    'spyware-download-accelerator':'12527',
    'JavaScript_Firefox_nsTreeRange':'5900002',
    'ie-cache-getelementbyid-dom-access':'4700',
    'file-mail-unmatched':'2524',
    'malcode-SPNE_IniMod':'6593',
    'ike-association-negotiation-failed':'5028',
    'squid-snmp-dos':'12945',
    'Security_disabled_global_group_changed':'11448',
    'r0xr4t-backdoor':'9283',
    'Rlogin password overflow':'10798',
    'google-desktop-indexing-detected':'3160',
    'rhel-rhsa-2009-0398-update':'10649',
    'SMTP_Ehlo':'11894',
    'rhel-rhsa-2009-0446-update':'5900002',
    'rhel-rhsa-2003-077-update':'9582',
    'HTTP_MCMS_CrossSiteScripting':'2106269',
    'squirrelmail-display-xss':'12954',
    'Critical_File_Added':'1534',
    'malcode-SPCOM_WrtMBR':'6552',
    'rhel-rhsa-2002-119-update':'9510',
    'decod-lsa-connect':'1710',
    'TLS_DigiNotar_Untrusted_Certificate':'5900002',
    'linux-rsync-heap-overflow':'5963',
    'shockwave-shockwave-bo':'11599',
    'goodtech-multiple-rcptto-bo':'3158',
    'win-cfv-code-execution':'5900002',
    'rhel-rhsa-2005-358-update':'9915',
    'TCP_Probe_Finger':'13431',
    'rhel-rhsa-2007-1025-update':'10432',
    'rhel-rhsa-2010-0720-update':'5900002',
    'databasecomparer-comparerax-bo':'1639',
    'CyberCop_Scanner_HTTP':'2102000',
    'persits-xupload-bo':'8830',
    'IS_High_Vulnerability_Found':'5423',
    'win-gdi-png-image-bo':'14331',
    'snmp-discovery-broadcast':'12062',
    'oracle-converttolrslayer-sql-injection':'5900002',
    'showfhd':'11606',
    'aix-iy64523-fix':'198',
    'sdp-integer-overflow':'11407',
    'nt-service-user':'8306',
    'http-host-repeat':'3629',
    'HTTP_iManager_ClassName_Overflow':'5900002',
    'malcode-Susp_Write_EXE':'6779',
    'wlrbt-wlan-reveal-registry':'15147',
    'struts-cookieinterceptor-command-exec':'5900002',
    'one-012-beta-backdoor':'8435',
    'rhel-rhsa-2010-0383-update':'5900002',
    'IRC_Join_Attempt':'5394',
    'cisco-ios-cable-docsis':'1282',
    'HTTP IIS5 PROPFIND DAV attack':'3510',
    'SMTP_mail_to_decode_alias':'11915',
    'nt-create-token':'8027',
    'LHA_File_Path_Overflow':'2120062',
    'win2k-globalgroup-member-removed':'14923',
    'Startup_of_important_programs':'13142',
    'aix-iy78800-fix':'257',
    'VmSuspendedEvent':'14138',
    'automountd-dos':'614',
    'Replication_link_add_failure':'9491',
    'nt-user-sid':'8358',
    'rhel-rhsa-2010-0490-update':'5900002',
    'radius-vendor-attribute-dos':'9291',
    'TCP_Probe_Imap4':'13436',
    'Image_TIFF_Invalid_Resolution':'5900002',
    'apache-chroot':'420',
    'SNMP_empty_packet':'12199',
    'nt-backoffice-setup':'7992',
    'adobe-useafterfree-code-exec':'5900002',
    'Flv_Winamp_H263_Dimension_Overflow':'5900002',
    'rhel-rhsa-2003-167-update':'9603',
    'portmaster-reboot':'9052',
    '3com-ap-acl-disabled':'8',
    'ICMP_Modem_DoS':'2113035',
    'nt-domain-guest-blankpwd':'8055',
    'HTTP_LiveMessenger_Detected':'4127',
    'nt-user-account-enabled':'8346',
    'PDF_JavaScript_Hex':'2114131',
    'rhel-rhsa-2006-0526-update':'10132',
    'nt-audit-resources':'7985',
    'spyware-dividix':'12520',
    'win-ms05kb902400-update':'14456',
    'Image_Contains_Script':'2114149',
    'win-gdi-emf-code-exec':'5900002',
    'HTTP_Win_Repair':'2002563',
    'backdoor-priority':'715',
    'ExploreZip virus':'2400',
    'FTP_Allo_Overflow':'5900002',
    'Sun_SNMP_Backdoor':'2002022',
    'scada-dnp-stop-application':'11320',
    'Gnutella_Worm':'2102015',
    'bind-banner':'836',
    'ripapp':'10789',
    'smtp-875bo':'11848',
    'netterm-ftp-mkd-bo':'7764',
    'smtp-excessive-connections-dos':'11856',
    'RAR_Encrypted_Archive':'5900002',
    'linux-splitvt':'5972',
    'Sybase_Successful_Connection':'13301',
    'ms-win-dvrms-code-exec':'5900002',
    'aix-iy88687-fix':'289',
    'win-dtc-tip-dos':'14320',
    'rhel-rhsa-2006-0676-update':'10183',
    'java-vm-session-hijacking':'5584',
    'IPv6_Teredo':'5370',
    'spyware-spyarsenal-home-keylogger':'12747',
    'Guptachar_Response':'2110090',
    'HTML_JRE_Codebase_Exec':'5900002',
    'spyware-adblaster':'12431',
    'panda-activescan-file-download':'8717',
    'UDP_Probe_MSDNS':'13850',
    'socks-shellcode-detected':'12334',
    'HTML_Win32_API_Code_Execution':'2114052',
    'nt-pwd-nochange':'8255',
    'HTTP_URL_repeated_char':'2000625',
    'win-ms12kb2663830-update':'5900002',
    'FrontPage_Publishing_DoS':'2766',
    'JavaScript_NOOP_Splitting':'5630',
    'win-ms09kb971055-update':'14743',
    'mssql-serverdetect-tcp':'7429',
    'DHCP Domain Metachar':'1788',
    'kerberos-kadmind-bo':'5702',
    'http-website-winsample':'3715',
    'rhel-rhsa-2005-377-update':'9923',
    'POP_User_Root':'9042',
    'usb-storage-installed':'13942',
    'win-ms10kb2183461-update':'5900002',
    'Finger filename':'2577',
    'javascript-suspicious-encoded-content':'5595',
    'CompoundFile_Windows_Thumbnail_Overflow':'5900002',
    'HTML_ClassID_Overflow':'2114016',
    'RIFF_Shockwave_Atom_Size_DoS':'5900002',
    'bugzilla-describe-components':'1038',
    'IRC_Global_Threat':'2113009',
    'IP_SourceRoute':'2000013',
    'kt3-trojan':'5794',
    'win-ms11kb2620712-update':'5900002',
    'win2k-preauth-failed':'14948',
    'ie-download-behavior':'4734',
    'CrazzyNet':'1529',
    'qt-pixmap-overflow':'9194',
    'malcode-Pretender':'6427',
    'nt-changedservice-current':'8007',
    'HTML_IRC_URL_Overflow':'2110057',
    'HTTP_PDGSoft':'4253',
    'NNTP_MesgID_Overflow':'2002403',
    'reg-assoc-changed-nonadmin':'9393',
    'HTTP_Proxy_Cache_Poisoning':'2116017',
    'http-php-script-injection':'3661',
    'RPC_selection_svc_hold_file':'10982',
    'easymail-activex-bo':'2024',
    'LPD_Cachefsd_Overflow':'2113243',
    'rhel-rhsa-2009-0466-update':'5900002',
    'decod-rexec':'1727',
    'ras-auth-rasfail':'9308',
    'ids-server-script-injection':'4674',
    'SNMP HP OpenView hidden community':'12003',
    'shadow-utils-useradd-file-permission':'11573',
    'scada-dnp-unknown-protocol':'11321',
    'rsagent-user-rights':'11172',
    'decod-whisker':'1757',
    'HTTP_CgiCounterLong':'2002652',
    'HTTP_CGI_Guestbook_Generic':'2105059',
    'netiware-activex-code-execution':'5900002',
    'fetchmail-fetchmailconf-tmpfile-symlink':'2450',
    'Napster_Public_Msg':'7566',
    'php-session-id-xss':'8903',
    'MSRPC_Anon_User_Enumeration':'2121014',
    'EOT_Data_Record_Heap_Overflow':'2174',
    'SSM_List_BO':'2122015',
    'mutt-imap-namespace-bo':'7496',
    'sendmail-multipart-mime-dos':'11504',
    'nt-screen-saver':'8297',
    'win-ms05kb887981-update':'14427',
    'backup-invalid-input':'766',
    'Failed_login-account_expired':'2423',
    'kdelibs-kdesu-insecure-tmpfile':'5696',
    'spyware-clicktilluwin':'12495',
    'ascend-kill':'564',
    'win-ms04031-patch':'14408',
    'Telnet port probe':'13520',
    'decod-http-connect':'1696',
    'IRC_DCC_Chat':'5387',
    'win-ms05kb899591-update':'14453',
    'nds-login-script-no-default':'7610',
    'rhel-rhsa-2011-0303-update':'5900002',
    'Kerberos_User_Snarf':'2104017',
    'TFTP_Long_Client_Error':'5900002',
    'irc-rogue-session':'5380',
    'winny-detected':'15069',
    'squirrelmail-webmail-compose-xss':'12963',
    'nss-nssnodbinit-code-exec':'5900002',
    'rhel-rhsa-2009-0352-update':'10642',
    'rhel-rhsa-2005-366-update':'9919',
    'wins-ms04028-patch':'15076',
    'win-ms06kb923414-update':'14534',
    'ApplicationExecutionAllowed':'533',
    'ICQ_File_Transfer':'4633',
    'ssh2-dns-lookup-failed':'12992',
    'CBO_Syllabus_Overflow':'2118075',
    'rsagent-exchange-imap-unauth-command':'11025',
    'cmail-helo-bo':'1365',
    'ms-data-access-code-exec':'5900002',
    'openbsd-tcp4-stack-dos':'8448',
    'finger-names':'2587',
    'myspace-myspaceuploader-bo':'7507',
    'netbsd-unaligned-ip-options':'7698',
    'UDP_Ares_Galaxy':'13838',
    'spyware-rasdial':'12707',
    'POP3 false attachment':'8991',
    'STUN_Message':'13165',
    'win-ms06kb916281-update':'14498',
    'rhel-rhsa-2008-0988-update':'10619',
    'HTML_IE_Table_Spoof':'2121007',
    'AntiSniff_DNS_Exploit':'374',
    'SNMP_Sun_Backdoor':'2002012',
    'Scada_IGSSdataServer_RMS_Overflow':'5900002',
    'Trojan_Bifrose':'13785',
    'netscreen-username-enumeration':'7744',
    'javascript-large-eval':'5591',
    'win-ms07kb935807-update':'14587',
    'operating-systems-discovery-mechanisms':'8511',
    'netterm-ftp-pass-bo':'7765',
    'igmp-dos':'4883',
    'STUN_KPhone_DoS':'2107013',
    'imlib-malloc-heap-corruption':'5191',
    'POP3_RETR_overflow':'9015',
    'rhel-rhsa-2012-0016-update':'5900002',
    'rhel-rhsa-2008-0009-update':'5900002',
    'Cisco_CR_DoS':'2103010',
    'ewave-servletexec-file-upload':'2247',
    'ms-ie-cacheddata-security-bypass':'7179',
    'locator-service-enabled':'6015',
    'HTTP_Y3K_ICQ_Pager':'2002609',
    'rhel-rhsa-2010-0041-update':'5900002',
    'rhel-rhsa-2008-0104-update':'10492',
    'outlook-date-overflow':'8674',
    'zone-unsigned-activex-download':'15391',
    'nt-eventlog-open-failed':'8067',
    'unicode-url-stack-overflow':'13884',
    'ncompress-decompress-underflow':'7589',
    'shockwave-iml32-ce':'5900002',
    'licq-url-execute-commands':'5909',
    'HTTP_asp_with_._Appended':'3775',
    'libspf2-spfdnsresolvlookup-bo':'5881',
    'nt-debug':'8041',
    'ibm-rational-tomcat-code-execution':'5900002',
    'openssh-separation-verificaton-weakness':'8477',
    'mac-kernel-version-detected':'6097',
    'MSRPC_MSDTC_Message_DoS':'2118050',
    'borland-packet-bo':'995',
    'nt-group-network':'8099',
    'ftp-pwless':'2865',
    'SMTP login name overflow':'11823',
    'malcode-DropNgo':'6222',
    'piranha-default-password':'8960',
    'glworld-hangameplugincn18-bo':'3121',
    'SQL_Empty_Password':'2113232',
    'rlogin TERM overflow':'10800',
    'overnet-running':'8694',
    'archive-file-underflow':'543',
    'InfraTrojan':'5221',
    'vintra-mail-dos':'14093',
    'BitTorrent_Request':'895',
    'RIFF_Director_Key_Image_Corruption':'5900002',
    'User_environment_file_change':'14038',
    'win2k-driver-signing':'14917',
    'rhel-rhsa-2006-0575-update':'10145',
    'multimedia-codec-stack-bo':'7475',
    'rhel-rhsa-2004-245-update':'9711',
    'geovision-liveaudio-activex-dos':'3076',
    'application-movie-file-bo':'515',
    'win-ms11kb2545814-update':'5900002',
    'rpc.statd_with_automount':'10925',
    'mcafee-mcsubmgr-bo':'6949',
    'Nimda_RICHED20.DLL':'7832',
    'DataProtector_Opcode20_Exec':'5900002',
    'HTTP_BigBrother_History':'2105071',
    'IRC_Generic_Trojan':'2113159',
    'rhel-rhsa-2007-1095-update':'10458',
    'directory-manager-execute-commands':'1825',
    'management-audit-events':'6929',
    'HTTP_Whois':'2002566',
    'reg-ras-auditing-disabled':'9419',
    'openssh-gssapi-gain-privileges':'8468',
    'sendmail-prescan-bo':'11506',
    'rservice-shell-wrapper-deny':'11193',
    'wireshark-nfs-bo':'15129',
    'Ultors':'13870',
    'nt-pwlen-onceonly':'8258',
    'msvm-applet-path-disclosure':'7458',
    'jre-networking-info-disclosure':'5900002',
    'mssql-sqlexecutivecmdexec-password':'7431',
    'adobe-acrobat-alert-dos':'5900002',
    'http-chuncked-transfer-encoding-bo':'3609',
    'LDAP_Long_Integer_Length':'5900002',
    'HTTP_PhatBot_AgoBot':'2110048',
    'spyware-aflooder':'12444',
    'ie-wininet-code-execution':'4870',
    'SMTP command overflow':'11805',
    'Email_HTML_File_URI':'2110079',
    'Cabinet_Cabview_Corruption':'5900002',
    'rhel-rhsa-2003-021-update':'9564',
    'php-mail-ascii-injection':'8873',
    'rhel-rhsa-2005-850-update':'10061',
    'adobe-acrobat-activex-dos':'101',
    'SSPING_attack':'13118',
    'mozilla-password-file-corruption':'7119',
    'rhel-rhsa-2005-043-update':'9821',
    'HTTP_Skype_DLL_Hijacking':'5900002',
    'oracle-base-table-data-manipulation':'8534',
    'msrpc-samr-queryuserinfo-enum':'7295',
    'malcode-InappropriateSYS':'6343',
    'kernel-netlinkfiblookup-dos':'5745',
    'samba-smb1-code-execution':'5900002',
    'rhel-rhsa-2003-389-update':'9646',
    'Email_Autonomy_KeyView_HTML_Multiple_Bo':'2124041',
    'nfs-uid-anon-root':'7820',
    'intrust-annotatex-code-execution':'5900002',
    'RTF_Office_Mismatch_Exec':'5900002',
    'jcomband-isregistered-bo':'5665',
    'HTTP_Microsoft_Error_Report':'4165',
    'Scada_Modbus_SlaveBusyDelay':'11348',
    'aix-iy64355-fix':'193',
    'XML_Notation_Enumeration_DoS':'5900002',
    'HTTP_Connect_Proxy_Bypass_SMTP':'2116011',
    'rhel-rhsa-2002-138-update':'9523',
    'HTTP_POST_PeopleSoft_IClientServlet':'2113040',
    'rhel-rhsa-2008-0818-update':'10582',
    'malcode-DataLogger':'6192',
    'TCP_Small_Window_DoS':'13463',
    'malcode-SPPE_srv_srch_HDRO':'6695',
    'user-login-gid':'13979',
    'epolicy-orchestrator-mem-corr-not-installed':'2184',
    'IIS Double-Byte Code attempt':'4888',
    'Agentx_HelixServer_OpenPDU_DoS':'5900002',
    'DNS_RRDataLength_Underflow':'2121049',
    'SNMP_Bad_Generic_Trap':'2106084',
    'SMB_Client_Cleartext_Password':'2000507',
    'imail-whois-overflow':'5134',
    'weblogic-file-source-read':'14235',
    'win-pgm-fragment-option-dos':'5900002',
    'sunrpc-xdr-array-bo':'13245',
    'lotus-notes-cai-code-execution':'5900002',
    'malcode-SPCOM_DO_DTA':'6541',
    'InCommand_TCP_Request':'2113115',
    'rhel-rhsa-2010-0362-update':'5900002',
    'squid-ftp-data-injection':'12931',
    'reader-unspec-code-exec':'5900002',
    'php-multiple-bo':'8882',
    'System_Info':'13344',
    'spyware-win32-sober-a':'12825',
    'gmail-email-attachment':'3122',
    'Freak88':'2724',
    'ie-improper-thirdparty-rendering':'4776',
    'win-ms10kb2405882-update':'5900002',
    'raptor-ipoptions-dos':'9302',
    'FTP_Retr_Very_Long':'2001355',
    'rhel-rhsa-2008-0957-update':'10610',
    'javase-jre-dos':'5900002',
    'HTTP_URL_Requests_Too_Often':'2000644',
    'HTTP_Hassan_Execute':'2002681',
    'oneofthelasttrojans-backdoor':'8438',
    'rhel-rhsa-2008-0243-update':'10540',
    'Flushot_attack':'2692',
    'Visibroker_OSAgent_BO':'2124076',
    'Finger search':'2584',
    'Generic_Intel_Overflow':'3075',
    'WordPerfect_Notes_Corrupt_Font':'5900002',
    'Qpopper_Permission_Problem':'9189',
    'nt-mwcredbuttonscan-present':'8193',
    'ms-hostintegration-tcp-dos':'5900002',
    'DNS_NXT_Overflow':'2000415',
    'Image_WMF_Polygon_Overflow':'2121061',
    'HTTP_Shells_Rksh':'2002527',
    'IPOP3D_user_login_to_remote_host_successful':'5339',
    'CGI jj exploit':'1146',
    'win-ms10kb2296199-update':'5900002',
    'opera-filehandler-bo':'5900002',
    'IPSEC_policy_agent_failed':'5352',
    'win-ms09kb970238-update':'14736',
    'smtp-outdated':'11869',
    'malcode-SPTRJ_Reg_Hide_Attr':'6723',
    'rhel-rhsa-2006-0533-update':'10133',
    'quicktime-colortable-atom-bo':'9215',
    'gtp-c-ppp-login':'3202',
    'SNMP bad err index':'11969',
    'win-ms11kb2537146-update':'5900002',
    'fetchmail-plaintext-information-disclosure':'2454',
    'jetaudio-downloadfrommusic-code-execution':'5669',
    'Suspect_SMTP':'13265',
    'mscs-owc-installer-bo':'7246',
    'HTML_DirectX_Media_SDK':'3387',
    'iis-badescapes':'4907',
    'FTP_XM_NLST_DoS':'2124002',
    'Zlib_Inflate_Table_BO':'2106197',
    'decod-cybercop':'1677',
    'malcode-RemoteDropper1':'6452',
    'win2k-html-save-damage':'14928',
    'scada-dnp-malformed':'11319',
    'W2K_domain_controller_attack':'14192',
    'rhel-rhsa-2005-708-update':'10010',
    'HTTP_Cisco_CSuserCGI_Overflow':'5900002',
    'HTTP URL contains old DOS filename':'3535',
    'nt-passfilt-not-found':'8225',
    'malcode-AutoStartWorm0':'6159',
    'spyware-coolwebsearch-svinit':'12503',
    'RPC_GETPORT_Request':'2001721',
    'count.cgi':'1523',
    'nt-ras-reboot':'8262',
    'LSA_Secrets_attempt':'6086',
    'win-mediaplayer-asf-code-execution':'14378',
    'Microsoft_ICMP_SourceRoute_BO':'2106217',
    'dhclient-remote-root-compromise':'1787',
    'win-ms06kb926121-update':'14548',
    'mozilla-shell-command-line-execution':'5900002',
    'SNMP VACM community':'12035',
    'gimp-sunras-plugin-bo':'3095',
    'HTTP_IIS_Trailing_Slash':'2000630',
    'rhel-rhsa-2004-033-update':'9660',
    'Borland_Interbase_Create_Overflow':'996',
    'rhel-rhsa-2007-0348-update':'10296',
    'Email_Encap_Exch_Relay':'2001019',
    'microsoft-works-wkimgsrv-code-execution':'7014',
    'DNS_Malformed':'2000405',
    'http-sgi-handler':'3690',
    'xm-ftp-nlst-dos':'15237',
    'rhel-rhsa-2007-1052-update':'10446',
    'win-ms08kb946456-update':'14631',
    'CompoundFile_Works_Converter_Overflow':'1465',
    'HTML_IE_Corrupt_Virtual_Func':'5900002',
    'TSM_ADSMDLL_Overflow':'2124085',
    'softek-barcode-activex-bo':'5900002',
    'HTTP_BearShare':'3797',
    'reg-smb-not-required':'9444',
    'Applix_Graphics_Kpagrdr_DoS':'2124056',
    'FTP_pipe_in_filename':'2968',
    'malcode-SPMZ_Rare_SnkInt':'6574',
    'ie-print-template':'4824',
    'sun-jre-activex-bo':'13214',
    'win-ms07kb937986-update':'14597',
    'YahooMSG_Login':'15338',
    'Telnet_Auth_Failed':'2001608',
    'rhel-rhsa-2009-1060-update':'10661',
    'iis-remote-ftp':'4978',
    'nt-admin-group':'7970',
    'CDP_DeviceID_Overflow':'5900002',
    'win-ms10kb979683-update':'5900002',
    'gnu-ncurses-window-bo':'3131',
    'CGI_finger.cgi':'1182',
    'OSPF_Link_State_Ack':'8654',
    'CompoundFile_Excel_ColInfo_BO':'2106224',
    'decod-http-get':'1698',
    'php-cgi-sapi-access':'8852',
    'win-ms06kb923789-update':'14537',
    'rhel-rhsa-2003-147-update':'9598',
    'frozen-file-type-changed':'2775',
    'FrontPage_service.pwd':'2767',
    'spyware-netviewer':'12670',
    'linux-modprobe-bo':'5947',
    'adobe-unspecified-javascript-bo':'140',
    'instant-messenger-traffic-detected':'5240',
    'nt-lock-window':'8157',
    'ms-ie-uninit-code-execution':'5900002',
    'ms-time-element-code-execution':'5900002',
    'scrollkeeper-tmp-file-symlink':'11403',
    'YahooMSG_UserID_Overflow':'2110036',
    'Oracle_One_Byte_Packet_DoS':'2101004',
    'malcode-DropExciter2':'6220',
    'email-html-file-uri-detected':'2072',
    'ibmdb2-kuddb2-dos':'4584',
    'HTTP_MCMS_CodeExec':'2106270',
    'file-inadvisable-permissions':'2510',
    'sudo-password-expansion-overflow':'13198',
    'aol-radio-ampx-bo':'384',
    'rhel-rhsa-2007-1029-update':'10435',
    'RTSP_Darwin_UserAgent_DoS':'5900002',
    'hp-instantsupport-append-file-overwrite':'3304',
    'malcode-VBAAutoInstallChkSus':'6851',
    'SMB_Trans_ParamDataCount_Bo':'5900002',
    'sendmail-parsing-redirection':'11505',
    'ISAKMP_Brute_Force':'2121031',
    'nb-rootshare':'7588',
    'apache-modnegotiation-response-splitting':'451',
    'bfup-activex-bo':'815',
    'Trojan_horse_response':'13788',
    'Trojan_Koobface':'13790',
    'activex-ignorelist':'83',
    'HTTP_PHP_CRLF_Injection':'2110137',
    'SNMP pdu underflow':'12020',
    'user-shell-writable':'14012',
    'All Proventia protection stopped':'311',
    'SMB malformed':'11708',
    'exchange-server-public-folder-dos':'2299',
    'apache-modssl-dos':'459',
    'RTF_Word_Drawing_Exec':'2122032',
    'LeakTest_Request':'2001532',
    'DHCP_Zero_Length_ClientID_DoS':'5900002',
    'rpc.nfs_lockd_attack':'10907',
    'rhel-rhsa-2007-1126-update':'10461',
    'desktopcontroller-warning':'1775',
    'HTTP_Measure_DLL_Hijacking':'5900002',
    'file-symbolic-links':'2550',
    'HTTP_PHP_Phorum':'2105013',
    'HTTP_Packager_Exe_Hijacking':'5900002',
    'samba-password-change-bo':'11272',
    'nt-bypass-traverse':'8003',
    'ms-ie-layout-code-execution':'5900002',
    'DNS cache poison BlackICE only':'1842',
    'UDP_Probe_MSRPC':'13851',
    'blackice-firewall-dos':'918',
    'wftpd-appe-bo':'14265',
    'HTTP_ACCEPT__field_overflow':'3729',
    'tcp-port-bind':'13392',
    'User_admin_right_revoked':'14037',
    'pam-localuser-bo':'8709',
    'html-java-web-start-activex':'5900002',
    'ie-malformed-component-attribute':'4790',
    'user-login-exist':'13976',
    'DNS_ISC_BIND_DoS':'1932',
    'malcode-RiskWare7':'6493',
    'snmp-suspicious-version-size':'12115',
    'RPC_NIS_Overflow':'2001715',
    'nt-network-priv':'8208',
    'License Expired':'5898',
    'spyware-eventures-nv':'12546',
    'rhel-rhsa-2011-0451-update':'5900002',
    'squirrelmail-mimeheader-xss':'12959',
    'snmp-suspicious-get':'12113',
    'QAZ_Backdoor_Response':'2001531',
    'filsys-mountable-character':'2573',
    'CHARGEN port probe':'1226',
    'HTTP_Imagemap_Exe':'2002564',
    'frontpage-pwd-users':'2763',
    'QuickTime_Atom_Too_Small':'2101037',
    'Spyware_PH_MoeMoneyMaker':'2113178',
    'windows-registry-remote-write-audit':'15029',
    'anonftp-file-perms':'357',
    'ms-owc-ms02044-patch':'7196',
    'winnt-indexserver-search-bo':'15061',
    'Oracle_AQELM_Overflow':'5900002',
    'win-ms08kb950760-update':'14651',
    'win-ms07kb927051-update':'14563',
    'msvm-xml-methods-access':'7470',
    'openssh-access-control-bypass':'8463',
    'nds-user-not-security-equiv-of-org':'7641',
    'rhel-rhsa-2007-0085-update':'10246',
    'nssldap-nscd-dos':'7951',
    'iis-htr-chunked-encoding-bo':'4940',
    'wikkitikkitavi-include-template':'14282',
    'malcode-Old11':'6402',
    'win-ms07kb931768-update':'14576',
    'rhel-rhsa-2009-1144-update':'5900002',
    'rsagent-ssh-rsa-restricted':'11138',
    'programchecker-sasatl-bo':'9125',
    'malcode-Old10':'6401',
    'popimap-bo':'9044',
    'remote-revise-backdoor':'9469',
    'vixiecron-hardlinks-dos':'14117',
    'multiple-lotus123-code-execution':'5900002',
    'rhel-rhsaA-2006-0695-update':'10772',
    'Suspect_Time':'13270',
    'nt-changedservice-display':'8008',
    'SOAP_AccessDenied':'2119005',
    'rhel-rhsa-2012-0034-update':'5900002',
    'SNMP_Illegal_String_Length':'12213',
    'nosecure-backdoor':'7906',
    'rhel-rhsa-2004-061-update':'9671',
    'onlinemedia-avsmjpegfile-bo':'8440',
    'Adobe_Flash_Player_MP4_Exec':'5900002',
    'malcode-AssumedRAT4':'6145',
    'spyware-peopleonpage':'12688',
    'malcode-AssumedRAT6':'6147',
    'MSRPC_Registry_Write_Run':'2003202',
    'HTTP_Network_Management_Overflow':'4192',
    'DNS_I-Query_exploit':'1923',
    'simpleserver-long-url-dos':'11610',
    'win-cmd-shell-banner':'14304',
    'IMAP_Long_Password':'2000802',
    'Netbios_Session_Granted':'7694',
    'rhel-rhsa-ekiga-unspecified-format-string':'10686',
    'rsagent-unixroot-sufailure':'11168',
    'consona-activex-file-overwrite':'5900002',
    'Millenium':'7019',
    'iis-asp-bo':'4898',
    'wireshark-wbxml-dos':'15141',
    'spyware-flyswat':'12562',
    'Lotus Domino directory traversal':'6039',
    'HTTP_GetAccess_helpwin':'2105002',
    'rhel-rhsa-2006-0619-update':'10168',
    'diaxfig-xfig-import-bo':'1818',
    'HTTP_SCO_View-Source':'4364',
    'malcode-AssumedRAT5':'6146',
    'PDF_Stray_Stream':'5900002',
    'HTTP_MaxDB_Percent_BO':'2106213',
    'win2k-account-used-logon':'14897',
    'malcode-Old7':'6410',
    'SMTP Vrfy Overflow':'11845',
    'malcode-Old5':'6408',
    'malcode-Old4':'6407',
    'novell-edirectory-imonitor-dos':'7915',
    'alvgus-backdoor':'336',
    'malcode-Old1':'6400',
    'win-ms11kb2507938-update':'5900002',
    'malcode-AssumedRAT0':'6141',
    'http-url-dot-path':'3704',
    'rhel-rhsa-2006-0604-update':'10158',
    'WinNuke attack':'15067',
    'MSRPC_ARCserve_TapeEngine_CreateJobHandle_DoS':'5900002',
    'libwmf-wmf-bo':'5893',
    'pmap-unset':'8971',
    'Finger_Forwarding':'2001102',
    'rhel-rhsa-2007-0395-update':'10310',
    'malcode-AssumedRAT2':'6143',
    'HTTP_IISHTR_Overflow':'2002559',
    'passwd-blank-lines':'8731',
    'malcode-AssumedRAT3':'6144',
    'shell-path-worldwritable':'11593',
    'nds-intruder-attempt-reset-interval':'7603',
    'ssh2-illegal-port-forwarding':'12993',
    'proftpd-info-disclosure':'9114',
    'BrightStor_Discovery_TCP_Overflow':'2106254',
    'aix-iy79485-fix':'261',
    'skype-installed':'11684',
    'XML_JNLP_Command_Exec':'5900002',
    'solaris-cachefsd-mount-bo':'12371',
    'dns-crack':'1867',
    'Suspicious_URL_Event':'13278',
    'HTTP_Nfuse_Script':'2105034',
    'JavaScript_FloatingPoint_Value_Overflow':'5900002',
    'HTML_WebConf_Code_Injection':'2113237',
    'License_Expired':'5904',
    'IMAP2bis_server_user_logout':'5147',
    'FTP Site Exec Tar':'2820',
    'eftp-plaintext-password':'2059',
    'IM_Login':'5051',
    'rhel-rhsa-2007-0674-update':'10350',
    'qpopper-command-bo':'9182',
    'tivoli-lcf-file-read':'13707',
    'TFTP_Long_Transfer_Mode':'5900002',
    'rhel-rhsa-2005-805-update':'10041',
    'chrome-sandbox-unspecified':'5900002',
    'Config-log_files_deleted':'1482',
    'HTTP_GET_data_with_repeated_char':'3942',
    'SMTP_DEBUG_command':'11893',
    'IMAP2bis_server_brute_force_attack':'5142',
    'UDP short header':'13830',
    'rhel-rhsa-2008-0208-update':'10527',
    'HTTP_GET_Filename_mgtstate':'2003806',
    'exploit-PE(100032)':'2386',
    'DNS_Address_Length':'2000406',
    'mozilla-parser-security-bypass':'7118',
    'fp-unspecified-code-exec':'5900002',
    'shockwave-activex-installer-bo':'11598',
    'ie-style-comment-dos':'4845',
    'telnet-hostile-environment-string':'13540',
    'linux-kernel-packets-dos':'5940',
    'malcode-Susp_MBR_IntMod':'6766',
    'gaim-jabber-module-bo':'3051',
    'Rlogin_Password_Overflow':'2002103',
    'nt-file-deleted':'8071',
    'ms-ie-xslt-code-exec':'5900002',
    'InfraTrojan_Request':'2113010',
    'HTTP GET contains group%by':'3498',
    'SNMP 3Com communities':'11964',
    'apache-server-token-not-set':'474',
    'rhel-rhsa-2005-812-update':'10048',
    'ms-ie-uninitialized-code-exec':'7182',
    'ftpxq-directory-traversal':'3038',
    'dlink-vapgdecoder-activex-bo':'1838',
    'Failed_change_of_important_files':'2420',
    'sun-java-ldap-dos':'13209',
    'ftp-stor-bo':'2871',
    'smtp-dcod':'11852',
    'win-pptp-packet-bo':'14811',
    'Finger_Overflow':'2001107',
    'Hidesource_Rootkit_Login':'2116001',
    'HTTP several fields with binary':'3529',
    'gtk-gdkpixbufloader-dos':'3194',
    'Nestea_attack':'7673',
    'Zero length TCP option':'15364',
    'laplink-installed':'5806',
    'HTTP_MSRemote_Desktop_DLL_Hijacking':'5900002',
    '2xapplication-activex-file-overwrite':'5900002',
    'winamp-playlist-filename-bo':'5900002',
    'MSRPC_Registry_SAM':'2003201',
    'FTP_Mget_DotDot':'2001332',
    'ms-win-adam-ldap-dos':'7224',
    'sendmail-backdoor':'11481',
    'SSH2_Hostbased_auth_failed_packet_error':'13010',
    'nt-group-remote-shutdown':'8101',
    'spyware-clipgenie':'12497',
    'script-suspicious-score':'5900002',
    'SNMP scanner':'12022',
    'aix-iy78221-fix':'250',
    'ca-license-getconfig-bo':'1080',
    'winnt-rpc-endpoint-dos':'15066',
    'citrix-ima-imasrv-bo':'1351',
    'msrpc-invalid-request':'7289',
    'cde-dtspcd-running':'1114',
    'rsagent-ldap-blacklist-shortterm':'11066',
    'HP_OpenView_NNM_Overflow':'2100038',
    'rhel-rhsa-2007-1176-update':'10468',
    'jrun-long-url-bo':'5683',
    'Finger_Bomb':'2594',
    'ourgame-gliedown2-code-execution':'8665',
    'ascend-kill2-snmp':'565',
    'MSRPC_Spoolss_FindFirstPrinterNotify_Exec':'5900002',
    'http-cgi-webcom-guestbook':'3603',
    'spyware-browseraid':'12474',
    'Site_Server_sample_URL':'11675',
    'bi-soap-envelope-overflow':'826',
    'ebay-activex-code-execution':'2028',
    'malcode-ContainsShellCode':'6183',
    'NetBus_Pro_Request':'2100027',
    'HTTP_WebDAV_Overflow':'4491',
    'realplayer-smil-bo':'5900002',
    'SSH_IP_options_used':'13043',
    'HTTP_POST_PeopleSoft_XXE':'2103022',
    'rlogin_TERM_overflow':'10822',
    'DHCP_Param_Underflow':'2106271',
    'Telnet Environment Format String Attack':'13513',
    'RPC Statd Format Attack':'10860',
    'tcp-sequence-invalid-range':'13396',
    'rpc.nfs mknod':'10904',
    'malcode-Old6':'6409',
    'componentone-flexgrid-bo':'1422',
    'SSH_RSA_auth._failed':'13056',
    'backdoor-wcrat':'744',
    'NokNok_TCP_Request':'2113141',
    'malcode-BackdoorWorm':'6168',
    'nt-bypass':'8004',
    'HTTP_Symantec_WebGateway_Traversal':'5900002',
    'XferWan_Overflow':'5900002',
    'malcode-Old3':'6406',
    'TCP port probe':'13372',
    'nessus-hydra-brute-force':'7665',
    'win2k-partition-weak-permissions':'14947',
    'exploit-MSExcel(100009)':'2347',
    'sendmail-setregid-gain-privileges':'11511',
    'google-chrome-extensions-info-disclosure':'5900002',
    'nt-sec-audit-onceonly':'8298',
    'talkd-flash':'13358',
    'ISS_Scan_FTP':'2102004',
    'RPC_Generic_Intel_Overflow':'2104007',
    'reg-sec-log-maxsize':'9433',
    'Qpopper_Username_too_long':'9192',
    'file-paf-insecure':'2537',
    'mozilla-deleted-frame-code-execution':'7071',
    'malcode-SPPE_Copy_ini':'6655',
    'CSimple.asp_overflow':'1554',
    'IKE_association_failed_Invalid_Peer_Proposal':'5033',
    'rhel-rhsa-2009-1540-update':'5900002',
    'DNS_IQuery_bo':'2000410',
    'Trinoo Daemon activity':'13768',
    'Word_Notes_Overflow':'5900002',
    'win-time-zone-update':'14861',
    'NetController_TCP_Response':'2113136',
    'malcode-REGInetPage':'6449',
    'HTTP_GET_Dotdotdot_Data':'2000618',
    'rsagent-ipop3d-loginfailure':'11060',
    'BOEP_blackd':'964',
    'malcode-VB_9':'6834',
    'ie-wmf-code-execution':'4871',
    'uucp-argument-gain-privileges':'14049',
    'malcode-VB_5':'6832',
    'malcode-Old8':'6411',
    'realplayer-realaudioobjects-dos':'9361',
    'malcode-VB_2':'6813',
    'malcode-VB_1':'6806',
    'win-ms10kb978542-update':'5900002',
    'HSRP_Coup':'2111006',
    'HTTP_Unexpanded_Path_Binary_Planting':'5900002',
    'gnugcc-fastjar-directory-traversal':'3132',
    'XPATH_Injection':'2110183',
    'Syslog_Cisco_Zero_Size_DoS':'2103011',
    'rhel-rhsa-2006-0754-update':'10208',
    'rhel-rhsa-2003-058-update':'9576',
    'dns-host-ovf':'1870',
    'HTTP_Apache_Authentication_DoS':'2110146',
    'Telnet abuse':'13506',
    'hotmail-email-attachment':'3295',
    'win-ms09kb961371-update':'14715',
    'malcode-SPNE_OverWrt_Sys':'6603',
    'adobe-acrobat-command-execution':'102',
    'malcode-SPNE_OCX':'6598',
    'rhel-rhsa-2007-0114-update':'10255',
    'LDAP_Injection':'2110185',
    'peoplesoft-xxe-read-files':'8826',
    'ethereal-bgp-dissector-bo':'2202',
    'rhel-rhsa-2005-430-update':'9948',
    'spyware-cydoor':'12508',
    'ghostscript-sym-link':'3087',
    'User_logoff_initiated':'14039',
    'linux-pcilynx-root-privileges':'5953',
    'start-subfolders-visible':'13132',
    'entrust-getaccess-execute-commands':'2171',
    'squirrelmail-compose-variable-overwrite':'12953',
    'rsagent-trusted-domainadded':'11164',
    'wireshark-xml-format-string':'15143',
    'win-ms08kb944338-update':'14627',
    'SSH_ScanSSH':'2109017',
    'proxy-port-probe':'9150',
    'FTP_Size_Very_Long':'2001351',
    'FTP_SITE_ZIPCHK_metacharacters':'3006',
    'war-trojan-backdoor':'14202',
    'malcode-InfectStartup':'6349',
    'HTTP_LDAP_Mod_Rewrite_BO':'2109006',
    'IDENT port probe':'4645',
    'proventia-desktop-not-installed':'9142',
    'hummingbird-xweb-activex-hclxweb-bo':'4553',
    'afp-unspec-xss':'5900002',
    'rhel-rhsa-2002-191-update':'9534',
    'cisco-catalyst-udp-dos':'1268',
    'ms-sql-ms02043-patch':'7212',
    'HTTP POST passwd file':'3525',
    'SMB_Mailslot_Election_Overflow':'5900002',
    'rhel-rhsa-2002-301-update':'9554',
    'inn-bo':'5225',
    'eselleratesdk-getwebstore-bo':'2192',
    'HTTP GET data contains _...':'3500',
    'win-ms11kb2562485-update':'5900002',
    'compoundfile-releaseafterfree-code-execution':'5900002',
    'License_Error':'5903',
    'SNMP_UInt_Overflow':'2106096',
    'rhel-rhsa-2003-111-update':'9591',
    'HTTP_WebDAV_Long_Rqst_BO':'2110009',
    'kon-command-line-bo':'5788',
    'rhel-rhsa-2009-0411-update':'10652',
    'rhel-rhsa-2011-0833-update':'5900002',
    'rhel-rhsa-2010-0697-update':'5900002',
    'exchange-owa-xss':'2297',
    'winmx-file-retrieval-detected':'15054',
    'malcode-SPNE_SC_SuspStr':'6607',
    'limewire-present':'5912',
    'TCP_Probe_LinuxConf':'13438',
    'BOEP_svchost':'977',
    'pcvue-deletepage-code-execution':'5900002',
    'win-ms11kb2559049-update':'5900002',
    'HTTP_BrownOrifice':'2004101',
    'rhel-rhsa-2008-0287-update':'10549',
    'MSRPC_CA_ASDBLoginToComputer_Overflow':'5900002',
    'yahoo-messenger-ft60-code-execution':'15317',
    'backdoor-remote-storm':'720',
    'dns-tunnel-detected':'5900002',
    'Network_Quiet':'7783',
    'win-ms09kb969856-update':'14731',
    'keyview-eml-bo':'5776',
    'nt-act-system':'7966',
    'JavaScript_ADO_MDAC_Exec':'5900002',
    'Remote_root_login':'9472',
    'Script_BitDefender_Compromise':'11382',
    'nt-profile-system':'8251',
    'rhel-rhsa-2006-0618-update':'10167',
    'nds-user-no-description':'7632',
    'rhel-rhsa-2008-0153-update':'10504',
    'rhel-rhsa-2003-013-update':'9562',
    'DNS_crack_successful':'1912',
    'evolution-uuencoded-header-dos':'2242',
    'rtrust-perms':'11211',
    'MHTML_Embed_Abuse':'5900002',
    'lotus-domino-replicaid-access':'6050',
    'HTTP_Eva_Forms_Bo':'2105006',
    'rhel-rhsa-2006-0159-update':'10081',
    'mdac-get-request-audit':'6956',
    'sascam-webcam-activex-bo':'5900002',
    'snmp-varbindlist-invalidtag':'12130',
    'iplanet-chunked-encoding-bo':'5311',
    'malcode-SPNE_time_ini':'6619',
    'malcode-SPMZ_Jmp_RdSTDIN':'6569',
    'gamehouse-shellctl-code-execution':'5900002',
    'ASM_Spam_Detected':'570',
    'decod-dns-nonaddress':'1681',
    'ssl-pct1-bo':'13083',
    'HTTP_Trace':'4427',
    'nds-user-with-address-restriction':'7657',
    'IRC_Y3K_Notification':'2001804',
    'Malformed_Packet_Storm':'2110012',
    'spyware-jethousebot':'12620',
    'Sunrpc_BackupProduct_String_Overflow':'2118085',
    'HTTP_Twiki_Image_Include_CmdExec':'2125011',
    'watchguard-soho-passcfg-reset':'14204',
    'rhel-rhsa-2007-1051-update':'10445',
    'HTTP_Google_File_Upload':'3972',
    'nt-user-pwnoexpire':'8356',
    'rlogin-multiple-login-failed':'10804',
    'oracle-cpu-april-2008':'8536',
    'MSRPC_LSASS_Bo':'2120022',
    'zone-unsafe-scripting':'15390',
    'rhel-rhsa-2009-1239-update':'5900002',
    'pop3-mime-filename-audit':'9001',
    'gigabyte-activex-code-execution':'5900002',
    'Global_group_deleted':'3114',
    'war-ftpd':'14201',
    'OTF_Parsing_Misallocation':'5900002',
    'nis-superuser':'7841',
    'RPC_NsrIndexd_MachineName_Overflow':'5900002',
    'CiscoSccp_Invalid_MessageID':'2119010',
    'samba-rpc-code-execution':'5900002',
    'Registry_autorun_changed':'9463',
    'mdaemon-hashcash-bo':'5900002',
    'spyware-w32-sobigf':'12799',
    'php-multiple-safemode-bypass':'8883',
    'http-head':'3627',
    'MSRPC_Spoolss_EnumPrinters_Bo':'7371',
    'rhel-rhsa-2006-0271-update':'10108',
    'NfsUid':'7828',
    'rhel-rhsa-2006-0608-update':'10160',
    'backdoor-deepthroat':'677',
    'rhel-rhsa-2009-0427-update':'5900002',
    'HTTP_EZMall_Malllogfile':'2002551',
    'rhel-rhsa-2005-037-update':'9817',
    'win-weak-password-encryption':'14874',
    'SMB_Oleacc_DLL_Hijacking':'5900002',
    'nav-mixed-doc':'7578',
    'httptunnel-traffic-detected':'4551',
    'ie-bypass-cookie-restrictions':'4694',
    'rsagent-useradmin-rightrevoked':'11178',
    'openssh-buffer-code-execution':'8465',
    'win-ms06kb918547-update':'14515',
    'bind-bo':'837',
    'XML_Safari_Saxon_File_Creation':'5900002',
    'yahoo-messenger-victimid-bo':'15322',
    'HTTP_SubSeven_ICQ_Pager':'2002572',
    'Core_event_setuid':'1518',
    'nt-profile-system-onceonly':'8250',
    'SubSeven_port_probe':'13187',
    'Firewall_Ping_of_Death':'2654',
    'win-ms12kb2663860-update':'5900002',
    'aix-iy88524-fix':'280',
    'dansie-form-element-backdoor':'1628',
    'H225_Invalid_Length_DoS':'3240',
    'ie-dragdrop-code-execution':'4735',
    'FTP_User_Root':'2111008',
    'linux-getfdbentries-integer-overflow':'5930',
    'Fore_TCP_Request':'2113107',
    'rhel-rhsa-2006-0710-update':'10192',
    'spyware-minibug':'12645',
    'linux-ptrace-root-privileges':'5958',
    'malcode-Susp_ProtectMode_IntMod':'6772',
    'file-uucpperm-directories':'2560',
    'spyware-myfastaccess-toolbar':'12655',
    'service-scan':'11548',
    'quicktime-sorenson-code-execution':'9250',
    'Scan by sscan program':'11350',
    'spyware-internetdelivery':'12612',
    'http-path-exe':'3659',
    'kerberos-gssrpcsvcauthgssapi-code-execution':'5699',
    'MySQL_User_Password_Overflow':'2107035',
    'mssql-mdac-openrowset-bo':'7412',
    'nachi-worm':'7542',
    'sshd-rhosts':'13069',
    'samba-smbd-filerename-dos':'11281',
    'rhel-rhsa-2006-0420-update':'10120',
    'firefox-thunderbird-browser-code-execution':'2637',
    'icmp-protocol-unreachable-tcp':'4600',
    'nt-null-session':'8215',
    'win-ani-ratenumber-dos':'14290',
    'win-ms11kb2587505-update':'5900002',
    'ie-ms05kb890175-update':'4805',
    'tooltalk-ttdbserverd-format-string':'13736',
    'win2k-domain-controller-dos':'14916',
    'Image_ANI_Header_Overflow':'2106182',
    'CGI finger':'1136',
    'xfree86-mitshm-memory-access':'15219',
    'gzip-lhz-dos':'3231',
    'SOCKS_connect':'12349',
    'allaire-jrun-view-source':'322',
    'win-ms09kb971557-update':'14745',
    'security-management-integer-underflow':'11439',
    'servu-ftp-site-bo':'11558',
    'hp-softwareupdate-hpufunction-code-execution':'3332',
    'bind-query':'855',
    'Email_Rpmmail_Alias':'2001020',
    'Poison_Ivy_CnC':'5900002',
    'broker-ftp-delete-files':'1027',
    'malcode-OddServiceRequest':'6395',
    'exchange-owa-embedded-script-execution':'2291',
    'flac-metadata-block-bo':'2667',
    'http-cgi-counter-long':'3569',
    'motd-contents':'7042',
    'IM_File_Xfer_Double_Extension':'2110081',
    'HTTP_Winzip_FileView_Code_Exec':'2109013',
    'RPC_SGI_Fam_Access':'2001723',
    'snmp-dialup-number':'12060',
    'PCAnywhere ping':'8755',
    'rhel-rhsa-libwpd-wp6-integer-overflow':'10705',
    'sapgui-tabone-bo':'11302',
    'nt-process-audit':'8249',
    'WarTrojan_TCP_Request':'2113157',
    'reg-pipes-exempt':'9416',
    'Local_group_deleted':'6011',
    'snmp-show-rmon':'12109',
    'exchange-client-hang':'2281',
    'SOCKS_Bounce':'2004001',
    'Celine_TCP_Response':'2113089',
    'asterisk-sipchannel-dos':'587',
    'Realwin_Scada_Fcinfotagsetcontrol_Bo':'9378',
    'smb-autoexec-access':'11718',
    'http-cgi-viewsrc':'3601',
    'rhel-rhsa-2005-498-update':'9961',
    'HTTP_AllaireJrun_ViewDirectory':'2106070',
    'RPC_BrightStor_ARCserve_Dos':'2109026',
    'HTTP_WindMail_FileRead':'2106038',
    'snmp-int-underflow':'12081',
    'PDF_iPhone_Jailbreak':'5900002',
    'rhel-rhsa-2003-007-update':'9559',
    'Chargen Denial of Service':'1225',
    'HTTP Cross site scripting':'3490',
    'snmp-kill-interface':'12084',
    'malcode-Rootkit0':'6497',
    'file-default-su':'2488',
    'CompoundFile_Detected':'5900002',
    'quicktime-qtvr-bo':'9244',
    'fw-cisco':'3042',
    'Email_Y3K':'2004403',
    'win-ms12kb2603381-update':'5900002',
    'CA_License_Server_Command_Overflow':'5900002',
    'RIFF_Codec_Overflow':'10779',
    'PICTURE.EXE_virus':'8942',
    'spyware-dbestrelief':'12514',
    'ibm-db2-datastream-dos':'4565',
    'mozilla-bom-utf8-xss':'7061',
    'MIDI_Invalid_Controller':'5900002',
    'Email_Mailman_Date_DoS':'2110130',
    'HTML_AIM_URL_Overflow':'2122020',
    'nfs-root-all':'7810',
    'frozen-file-sacl':'2774',
    'exchange-store-dos':'2302',
    'SMB_DFS_Response_Exec':'5900002',
    'win-hyperterminal-telnet-bo':'14347',
    'malcode-Susp1_EPEnd':'6753',
    'mozilla-multiple-javascript-code-execution':'7104',
    'rpc.statd_overflow':'10924',
    'win-ms08kb950762-update':'14652',
    'CompoundFile_Excel_Selection_BO':'2106223',
    'rhel-rhsa-2004-449-update':'9745',
    'Veritas_NetBackup_ConnectOptions_Overflow':'5900002',
    'malcode-Susp14e_1st_Snky':'6746',
    'DNS_TCP_Port_Abuse':'5900002',
    'msrpc-upnp-detected':'7299',
    'trillian-xmltags-bo':'13762',
    'reg-antivirus-startup':'9389',
    'cisco-logging-disabled':'1312',
    'Fore_TCP_Response':'2113108',
    'ISA_detected_possible_IP_half_scan_attack':'5489',
    'rhel-rhsa-2007-0123-update':'10256',
    'win-gdi-bmp-bo':'14326',
    'LDAP_Message':'5847',
    'TelnetAuthNull':'13600',
    'aim-express-detected':'164',
    'AOLIM_AddExternalApp_Overflow':'2113007',
    'Bionet email':'871',
    'ISA_Alert_Failed_Log':'5482',
    'TMG_Client_Hostname_Overflow':'5900002',
    'win-ms12kb2641653-update':'5900002',
    'SSH_Kerberos_auth._successful':'13045',
    'inactive-acct':'5193',
    'auction-weaver-execute-commands':'596',
    'spyware-charitybuy':'12485',
    'RDS_reg_hack':'9344',
    'win-ms06kb922616-update':'14528',
    'aix-iy73497-fix':'239',
    'nt-spynet-present':'8318',
    'win-ms10kb2416400-update':'5900002',
    'HTTP_IIS_ASP_Header_Overflow':'4043',
    'rhel-rhsa-2010-0504-update':'5900002',
    'HTTP_IERedir_Zone_Bypass':'2116004',
    'SNMP null in string':'12015',
    'db2-connect-attach-dos':'1647',
    'winxp-digital-signing-disabled':'15096',
    'Homefree_search_CGI':'3289',
    'SNMP_NullInCommunity':'2106122',
    'malcode-SPCOM_DO_SuspStr':'6543',
    'malcode-Win32_Kelvir_l':'6880',
    'rhel-rhsa-2005-232-update':'9878',
    'nedit-print-symlink':'7660',
    'win-ms11kb2530548-update':'5900002',
    'bugzilla-group-permissions-removal':'1039',
    'nt-guest-in-group':'8127',
    'backweb-activex-liteinstactivator-bo':'781',
    'sonicwall-activex-bo':'5900002',
    'SNMP_Illegal_SubId':'12214',
    'UNIX_Root_Su_Failure':'13900',
    'HTTP_Script_Bypass':'2102028',
    'SIP_Shell_Command_Injection':'11667',
    'surgeftp-listing-dos':'13256',
    'yahoo-present':'15325',
    'iis-unicode-encoding-detected':'4993',
    'HTTP_PowerPoint_DLL_Hijacking':'5900002',
    'Phatbot_P2P':'2120019',
    'SMB_pwl_file_type':'11776',
    'phoenician-flashax-bo':'8841',
    'sendmail-signal-handling':'11512',
    'cisco-securedesktop-activex-code-execution':'5900002',
    'spyware-tmksoft':'12770',
    'Security_disabled_global_group_deleted':'11450',
    'rhel-rhsa-2008-0891-update':'10597',
    'PAM_Internal_Error':'5900000',
    'rhel-rhsa-2004-045-update':'9664',
    'snmp-varbindlist-underflow':'12131',
    'irix-xfsmd-execute-commands':'5419',
    'TelnetXdisplayLong':'13615',
    'SubSeven port probe':'13178',
    'Unistim_Flood':'2114098',
    'spyware-magiccontrol':'12630',
    'macos-argb-code-execution':'5900002',
    'oracle-appserver-opmn-unspecified':'8525',
    'SQL_Sp_ReplWriteToVarBin_Overflow':'5900002',
    'mozilla-layout-code-execution':'7095',
    'malcode-AntiqueVBTrojan':'6138',
    'mac-address-detected':'6095',
    'java-classloader-priv-escalation':'5900002',
    'rhel-rhsa-2008-0816-update':'5900002',
    'RPC_NFS_UID_Zero':'2001713',
    'spyware-clearsearch':'12493',
    'NCX_Backdoor':'7596',
    'rsagent-exchange-pop3-unauth-command-invalid':'11035',
    'WinNuke_Attack':'2000303',
    'FTP_user_login':'3019',
    'win2k-localgroup-changed':'14935',
    'rhel-rhsa-2008-0849-update':'10588',
    'datamatrix-activex-file-overwrite':'1641',
    'wireshark-ssh-dos-win':'15138',
    'backdoor-infector':'697',
    'PDF_JavaScript_Bad_Btn_Ptr':'5900002',
    'DNS HINFO query':'1845',
    'win-media-asf-code-execution':'14371',
    'tfn-dos':'13620',
    'WebStore_admin_URL':'14260',
    'win-ms11kb2489256-update':'5900002',
    'rhel-rhsa-2007-0066-update':'10233',
    'SMB_Pwl_Filetype':'2002704',
    'apache-authldap-format-string':'413',
    'cisco-tcp-ipv4-dos':'1326',
    'ms-aspnet-open-redirect':'5900002',
    'apache-500-cgi':'408',
    'ie-ms04025-patch':'4801',
    'registry-compliance':'9460',
    'SMB_Samba_PIDL_Overflow':'5900002',
    'MSRPC_Registry_Write_RDS':'2003203',
    'netperformer-telnet-username-bo':'5900002',
    'HTTP_GET_SQL_OpenRowSet':'2113031',
    'borland-ibserver-bo':'993',
    'rsagent-ssh-rootexecution':'11134',
    'frontpage-pwd-authors':'2761',
    'WINS_DelAssoc_DoS':'2110068',
    'win-ms10kb2387149-update':'5900002',
    'ftp-inetd':'2851',
    'Oracle_Olap_Table_Overflow':'5900002',
    'rhel-rhsa-2005-506-update':'9967',
    'rsagent-exchange-imap-auth-fail':'11024',
    'blackice-license-rejected':'920',
    'rhel-rhsa-2002-154-update':'9525',
    'http-cgi-bigbrother-bbhist':'3555',
    'jre-png-bo':'5680',
    'rpc.amd_overflow':'10895',
    'HTML_URL_Homograph':'2121018',
    'nis-passwd-wrong-sequence':'7840',
    'smb-user-rw-detected':'11732',
    'nt-account-audit-failure':'7959',
    'Image_PNG_tRNS_BO':'2102048',
    'net4switch-activex-bo':'5900002',
    'Sunrpc_rwall_Message_Overflow':'2110054',
    'HTTP_Cisco_IOS_DOS':'2106044',
    'xlog-backdoor':'15234',
    'xpath-injection':'15279',
    'win-ms11kb2566220-update':'5900002',
    'drives-not-hidden':'2009',
    'sip-invalid-to-detected':'11620',
    'http-post-negative-bo':'3669',
    'ARCserve_Backup_LGServer_Authentication_Bypass':'2101012',
    'rhel-rhsa-2007-0936-update':'10401',
    'wireshark-xml-format-string-win':'15142',
    'nt-batch-logon':'8001',
    'Statd_Overflow':'13147',
    'rhel-rhsa-2005-867-update':'10063',
    'oracle-kupwworker-sql-injection':'8561',
    'RADIUS Pass Overflow':'9285',
    'winace-arj-header-bo':'15011',
    'XDMCP_Overflow':'2002904',
    'nds-unknown-object':'7621',
    'HTTP_URLscan':'2000619',
    'management-agent-dos':'6927',
    'win-ms10kb983539-update':'5900002',
    'TelnetExcessiveTabs':'13610',
    'ISS_SunRPC':'2102009',
    'kernel-keyallocserial-dos':'5740',
    'nautilus-metafile-xml-symlink':'7570',
    'HTTP_GET_contains_compute%sum':'3933',
    'jpeg-malformed-image-transfer':'5675',
    'realplayer-activex-rm-bo':'9354',
    'Nachi_Ping_Sweep':'2110028',
    'win-ms10kb982214-update':'5900002',
    'TLS_Connections_Rate_Flood':'5900002',
    'spyware-myway-search-bar':'12656',
    'skype-dll-code-execution':'5900002',
    'rhel-rhsa-2009-1672-update':'5900002',
    'nt-increase-priority':'8140',
    'maxdb-http-get-bo':'6941',
    'win-httpservices-parameter-underflow':'14346',
    'active-directory-unauth-login-attempt':'76',
    'javascript-packer-dean-edwards':'5900002',
    'LDAP_BER_Sequence_Dos':'2118054',
    'helix-view-code-execution':'3271',
    'CGI_mylog.html':'1197',
    'HTTP_cgi_starting_with_php':'3817',
    'crazytalk-activex-bo':'5900002',
    'malcode-Susp14e_Spawn':'6750',
    'MySQL_Select_Into_OutFile':'5900002',
    'HTTP_iManager_Tree_DoS':'5900002',
    'IDENT_port_probe':'4664',
    'xorg-server-scancidfont-overflow':'15273',
    'Overnet_Search':'8695',
    'Tini_Response':'2001592',
    'file-insecure-setgid':'2515',
    'cisco-ios-crash':'1283',
    'java-plugin-unspecified-security-bypass':'5580',
    'legacy-activex-local-drive':'5861',
    'netsprint-toolbar-bo':'5900002',
    'HTTP_Chunked_Encoding_Overflow':'2120041',
    'iis-double-byte-code-page':'4925',
    'msvm-ssm-restriction-bypass':'7468',
    'tcpdump-sizeof-memory-corruption':'13482',
    'malcode-CO6':'6179',
    'IMAP_Generic_Intel_Overflow':'2104004',
    'nt-users-descriptions':'8362',
    'SMB sam file':'11712',
    'HTTP HOST_ field overflow':'3507',
    'ms-vba-property-bo':'7222',
    'IMAP_Long_Login':'2000801',
    'outlook-mailtourl-execute-code':'8682',
    'php-globals-bypass-security':'8863',
    'SMB_GTK_Uxtheme_DLL_Hijacking':'5900002',
    'JavaScript_Eleonore_Exploit_Kit':'5900002',
    'user-101-defined':'13945',
    'lateralarts-uploader-activex-bo':'5811',
    'HTTP_Apache_ModCache_DOS':'5900002',
    'excel-unspecified-code-execution':'2267',
    'WindowsMedia_Detected':'15046',
    'executor-backdoor':'2335',
    'nt-expired-accounts':'8069',
    'rsagent-ssh-dns-spoofing-reverse-diff':'11121',
    'win-ms06kb922819-update':'14531',
    'WinCrash_TCP_Response':'2113170',
    'flashplayer-swf-code-execution':'2681',
    'mozilla-netscape-bmp-bo':'7108',
    'HTML_IE_DragDrop_Executable':'2120044',
    'win-emf-file-name-bo':'14322',
    'mcms-http-request-xss':'6953',
    'JBIG2_Malformed':'2114147',
    'file-world-read':'2562',
    'malcode-SPNE_SC_DelFile':'6605',
    'allaire-jrun-webinf-access':'323',
    'rhel-rhsa-2010-0679-update':'5900002',
    'decod-mount':'1712',
    'HTTP_QuickTime_Java_Code_Exec':'2122012',
    'kernel-randomnumber-weak-security':'5752',
    'dns_inv_dom_pkt':'1928',
    'rsagent-group-changed':'11044',
    'PDF_CustomDictionaryOpen_CodeExec':'2124095',
    'decod-http-cookie':'1697',
    'phpmyadmin-eval-execute-commands':'8923',
    'nt-group-take-owner':'8111',
    'autoproducer-dxttextouteffect-activex-bo':'622',
    'nt-netbios-nullsession':'8199',
    'nfs-root-host':'7811',
    'HTTP_IIS_Host_DoS':'2106165',
    'apache-modinclude-bo':'449',
    'ISA_WPS_Terminated':'5525',
    'oracle-net-services-dos':'8569',
    'safari-topsites-phishing':'11254',
    'nfs-export':'7797',
    'rhel-rhsa-2006-0600-update':'10155',
    'rhel-rhsa-2005-512-update':'9968',
    'DCOM_Scada_Opc_Bind':'1665',
    'rhel-rhsa-2005-094-update':'9843',
    'malcode-SPMZ_DTA_IVT_Srch':'6562',
    'HTTP_Slingbox_Detected':'4398',
    'rpc.statd with automount':'10922',
    'TCP_Seq_OutOfRange':'13458',
    'rhel-rhsa-2005-601-update':'9994',
    'rhel-rhsa-2007-0721-update':'10359',
    'malcode-SPPE3':'6641',
    'malcode-SPPE1':'6625',
    'samba-lsaiotransnames-bo':'11267',
    'ms-aspdotnet-padding-info-disclosure':'5900002',
    'malcode-SPPE6':'6652',
    'malcode-SPPE5':'6651',
    'kernel-sctp-privilege-escalation':'5756',
    'phatbot-running':'8839',
    'bootp':'988',
    'InfoSearch CGI exploit':'5219',
    'msn-web-messenger-detected':'7281',
    'UDP_Probe_SNMP':'13857',
    'apache-mpm-dos':'5900002',
    'lcdproc-remote-overflow':'5813',
    'Informix_CmdLine_ParamNum_Overflow':'5900002',
    'malcode-RegDropper':'6448',
    'spyware-carpediem':'12480',
    'Oracle_Data_Flags_DoS':'5900002',
    'file-frozen-recommend':'2503',
    'rsagent-suspect-netstat':'11147',
    'rsagent-ssh-rootlogin':'11135',
    'nt-object-audit':'8218',
    'snmp-packet-underflow':'12097',
    'win-ms11kb2640241-update':'5900002',
    'Systems_Management_Stack_BO':'2106267',
    'TFTP Echo Bounce':'13629',
    'windowsmoviemaker-avi-bo':'5900002',
    'nt-backup-domain-controller':'7993',
    'http-cgi-vuln':'3602',
    'nt-printer-spooler-bo':'8243',
    'rhel-rhsa-2004-188-update':'9699',
    'nt-start-stopped':'8322',
    'MP3_Decoder_Overflow':'5900002',
    'xorg-bdf-font-bo':'15269',
    'HTTP POST data contains script':'3523',
    'msvm-jdbc-dll-execution':'7464',
    'Back Orifice ping':'646',
    'SIP_Message_Termination_Incorrect':'2114008',
    'hp-lp-bo':'3315',
    '3com-security-setup-web-access':'22',
    'rsagent-suspect-sunrpc':'11153',
    'scada-modbus-readdeviceid-obtain-information':'11328',
    'hp-nnm-ovalarmsrv-dos':'3320',
    'adobe-array-u3d-code-execution':'5900002',
    'solaris-ftp-shadow-recovery':'12376',
    'win-ms09kb970957-update':'14741',
    'group-length':'3173',
    'Failed_domain_group_admin_right_grant_attempt':'2421',
    'ASF_DVR_MS_Code_Exec':'5900002',
    'dnaeditormodule-packagefiles-code-execution':'1840',
    'Mstream_Zombie_Response':'2001528',
    'rhel-rhsa-2005-132-update':'9858',
    'HTTP_Road_Search':'2002604',
    'JavaScript_Shellcode_Detected':'2113247',
    'phpnuke-index-command-execution':'8925',
    'rhel-rhsa-2007-0387-update':'10307',
    'win-ms06kb925674-update':'14547',
    'win-ms05kb905414-update':'14460',
    'spamassassin-url-dos':'12413',
    'malcode-SPPE_Jmp_cpySelf':'6675',
    'novell-client-username-bo':'7910',
    'nt-4-sp3':'7957',
    'ipcs-sem':'5306',
    'HTTP_ZmlCgi':'2106060',
    'RPC_Automountd_Overflow':'2001701',
    'cups-udp-dos':'1565',
    'win-ms05kb890261-update':'14431',
    'typo3-password-csrf':'5900002',
    'win-upnp-notify-bo':'14865',
    'XML_Entity_Name_Overflow':'5900002',
    'gateway-weblaunch-bo':'3058',
    'spyware-aureate':'12453',
    'rhel-rhsa-2005-033-update':'9813',
    'arkiea-backup-nlserverd-remote-dos':'559',
    'win-ms07kb941522-update':'14606',
    'malcode-SPPE_cpy_rsrc_wrtsect':'6658',
    'win-ms08kb955048-update':'14675',
    'win-ms05kb890859-update':'14432',
    'ie-invalid-frame-image-certificate':'4782',
    'decod-rip-timeout':'1730',
    'HTTP_Fields_With_Binary':'2000647',
    'netware-remote-admin-overflow':'7769',
    'yahoo-widgets-ydpctl-bo':'15329',
    'SSL_V2_OpenSSL_Get_Shared_Ciphers_BO':'2122008',
    'imap4-long-parm':'5156',
    'aix-iy64277-fix':'190',
    'user-group-superuser':'13958',
    'HTTP_Location_Bypass_Restriction':'2116012',
    'nds-login-script-attach-password':'7608',
    'passport-passportlog-exposure':'8725',
    'IM_AOL_Game_Overflow':'5048',
    'rhel-rhsa-mozilla-svg-code-execution':'10726',
    'file-unprintable-character':'2554',
    'rhel-rhsa-2004-592-update':'9773',
    'win-ms07kb933566-update':'14582',
    'kerberos-running':'5707',
    'malcode-RemoveService':'6454',
    'realplayer-swf-bo':'9369',
    'dns-tcp-malformed':'5900002',
    'ISA_detected_possible_all_port_scan_attack':'5487',
    'MSRPC_Registry_Write':'7355',
    'classifieds.cgi':'1357',
    'bind-complain-bo':'839',
    'HTML_Notes_Library_Execution':'5900002',
    'win-ms06kb924496-update':'14543',
    'favicon.ico bad format':'2441',
    'oracle-sb-sbc-unspecified':'5900002',
    'spyware-memorymeter':'12637',
    'php-realpath-safemode-bypass':'8898',
    'mysql-running':'7529',
    'nt-newuser':'8209',
    'HTTP_Verity_Search':'2002614',
    'hp-storage-code-exec':'5900002',
    'Image_PNG_GDI_Integer_Overflow':'5097',
    'bugzilla-show-dependency-tree':'1045',
    'DOS DoS URL':'1986',
    'nimda-worm-propagation':'7831',
    'compaq-web-management-bo':'1415',
    'reg-rras-tracing-enabled':'9432',
    'rhel-rhsa-2005-517-update':'9970',
    'application-control-request-overflow':'512',
    'backdoor-global-threat':'692',
    'planetintra-pi-bo':'8962',
    'win-ms05kb893066-update':'14437',
    'malcode-SPPE_AutoStrt_ExpImp':'6654',
    'smtp-relay-uucp':'11873',
    'AgentManager_Info':'156',
    'HTTP_CRLF_Injection_Response_Splitting':'2125006',
    'IMAP_Long_Parm':'5178',
    'RPC_Large_Fragmented':'2115006',
    'SNMP_bad_PDU_tag':'12159',
    'postgresql-readsqlconstruct-bo':'9072',
    'SMB_AccountName_Overflow':'5900002',
    'Sasser_Propagation':'2120025',
    'rhel-rhsa-2007-0968-update':'10414',
    'win2k-iomega-parallel-port':'14931',
    'oracle-database-dbmsaqelm-bo':'5900002',
    'quicktime-flipfiletypeatombton-overflow':'9222',
    'FTP DemiGlob':'2792',
    'coldfusion-email-view-files':'1392',
    'win-htmlhelp-execute-code':'14345',
    'SNMP length underflow':'12010',
    'User_account_used_for_logon':'14033',
    'Psychward_TCP_Response':'2120016',
    'boep-blackd':'946',
    'groupwise-accept-language-bo':'3183',
    'file-default-passwd-notfrozen':'2482',
    'trust-local-nonroot':'13799',
    'rhel-rhsa-2007-0338-update':'10289',
    'SYN_Bandwidth_Flood':'5900002',
    'msrpc-pipe-null-eventlog-information-disc':'7293',
    'freetype-ftutil-dos':'2736',
    'aix-iy67455-fix':'209',
    'win-ms08kb954156-update':'14671',
    'HTTP_NS_Enterprise_Invalid_Command_DOS':'4202',
    'rhel-rhsa-2005-150-update':'9866',
    'oscar-message':'8634',
    'nisd-reserved':'7852',
    'malcode-SPPE_CopySCRfile':'6657',
    'Dir_Svc_Db_init_failure':'1821',
    'SNMP_Bad_Specific_Trap':'2106085',
    'BNBSurvey survey.cgi':'941',
    'win-ms07kb923810-update':'14556',
    'gtp-c-element-underflow':'3199',
    'ie-ftp-response-execute-code':'4757',
    'ftp-suspicious-zip':'2873',
    'DNS name overflow':'1852',
    'OSPF_Database_Desc':'8649',
    'cisco-ip-directed-broadcast-enabled':'1308',
    'win-ms06kb917284-update':'14504',
    'CGI_handler':'1189',
    'rservice-login-wrapped':'11188',
    'Sadmind_Amslverify_Overflow':'2001722',
    'rhel-rhsa-2002-307-update':'9556',
    'rhel-rhsa-2009-1125-update':'10670',
    'EventHorizon_TCP_Request':'2113102',
    'voip-filename-overflow':'14170',
    'rhel-rhsa-2008-1018-update':'5900002',
    'cisco-aironet-allows-browsing':'1255',
    'wireshark-cpfw1-format-string':'15111',
    'SNMP_Delete_WINS':'2002006',
    'Oracle_ChangeDataCapture_Injection':'5900002',
    'malcode-VBADeletesSus':'6855',
    'Email_SMTP_Uuencoded_Long_Filename':'5900002',
    'spyware-msconnect':'12649',
    'MSRPC_Netware_Get_User_DoS':'2122001',
    'rhel-rhsa-2005-674-update':'10006',
    'explorer-file-menu':'2397',
    'mozilla-valueof-sandbox-bypass':'7135',
    'oracle-securebackup-ndmp-bo':'8573',
    'update-user-baseline':'13921',
    'DNS_Malformed_CompressedName':'2118013',
    'CGI_webgais':'1214',
    'oracle-xdbdbmx-xmlschema-bo':'5900002',
    'freepbx-menu-file-upload':'5900002',
    'bind-zone-xfer':'867',
    'ie-phishing-filter-active':'4821',
    'sip-request-xss':'11632',
    'DNS_Dot_Query':'2101063',
    'sudo-unclean-env-root':'13199',
    'interscan-webmanager-httpsave-bo':'5252',
    'nav-java-enabled':'7574',
    'win2k-sp2':'14969',
    'rhel-rhsa-2005-261-update':'9882',
    'ms-win-rdp-code-exec':'5900002',
    'Content_Analyzer_User_Defined_5':'2120087',
    'Mstream_Master':'2001566',
    'TCP_Probe_IRC':'13437',
    'canna-improper-request-validation':'1096',
    'malcode-SPTRJ_Inet_SysSnap':'6721',
    'Cerebus_Scanner':'2009206',
    'earthresource-ncsview-bo':'2021',
    'nt-repair':'8279',
    'Content_Analyzer_User_Defined_3':'2120085',
    'Spyware_PH_GAIN':'2113188',
    'google-gmail-file-upload':'3162',
    'XMPP_Session':'15266',
    'Soulseek_Login_Detected':'12408',
    'Symantec_UPX_BO':'2103030',
    'HTTP_iHTML_Merchant_File_Access':'2002653',
    'SMB_Guessable_Password':'2102033',
    'SMTP_MailEnable_NTLM_Type1_Overflow':'2106244',
    'file-default-not-frozen':'2478',
    'win-ms05kb885250-update':'14425',
    'rhel-rhsa-2009-0429-update':'5900002',
    'bugzilla-reports-crosssite':'1041',
    'malcode-SPPE_Copy_Time':'6656',
    'MSRPC_CA_Arcserv_ASCORE_Op13_DoS':'5900002',
    'CiscoSccp_Open_Receive_Channel':'1346',
    'windows-printspooler-dos':'15026',
    'rhel-rhsa-postgresql-rollback-commit-dos':'10763',
    'HTTP_port_probe':'4298',
    'h323-netmeeting-traffic-detected':'3244',
    'isa-scs-stop':'5468',
    'cisco-webex-wrf-file-bo':'5900002',
    'Network Access Blocked':'7771',
    'ms-powerpoint-viewer-textbytesatom-bo':'5900002',
    'ibm-db2-multiple-bo':'4566',
    'FTP_Wildcard_DoS':'2105066',
    'win95-smb-password':'15005',
    'JavaScript_Packer_Beta':'2114162',
    'service-defined':'11545',
    'Oracle_Successful_Object_Access':'8612',
    'Telnet_XDISPLOC':'13596',
    'YahooMSG_AddView':'15335',
    'ms-telnet-option-bo':'7220',
    'isa-ip-address-removed':'5449',
    'win-msmq-bo':'14792',
    'exploit-PDF(100019)':'2385',
    'windowsindeofilter-dll-ce':'5900002',
    'tftp-shell':'13655',
    'dns-netbios-name-service-malformed':'5900002',
    'TCP sequence out-of-range':'13375',
    'novell-edirectory-imonitor-bo':'7914',
    'nt-backuprestore-audit':'7999',
    'spyware-my-search-bar':'12653',
    'spyware-clariadashbar':'12488',
    'SNTP malformed':'12313',
    'image-halftone-bo':'5056',
    'sol-sadmind-command-execution':'12366',
    'rhel-rhsa-2007-0556-update':'10340',
    'win-ms03kb815495-update':'14402',
    'finger-unused-accounts':'2591',
    'HTTP_OracleApp_oprocmgr_status':'2105028',
    'Nestea':'2000015',
    'HTTP_Apache_ServerStatus':'3765',
    'malcode-SPPE_Tasm_Misc':'6696',
    'SMTP_Nondeliverable_Notification':'11928',
    'MSDNS port probe':'7249',
    'CompoundFile_Word_HLink_BO':'2106229',
    'cmd_URL_type':'1370',
    'NTP_Readvar_Overflow':'2002907',
    'Talk_Flash':'2103018',
    'rsagent-exchange-login-view-administrative':'11028',
    'HTTP_Cachemgr':'2002594',
    'rhel-rhsa-2009-1218-update':'5900002',
    'rhel-rhsa-2009-1585-update':'5900002',
    'decod-pop-auth-failure':'1722',
    'spyware-dashbar':'12511',
    'rhel-rhsa-2006-0720-update':'10195',
    'carboncopy32-installed':'1099',
    'active-directory-replication-link-failed':'71',
    'IPP_CUPS_Tag_Overflow':'5343',
    'sametime-login-detected':'11291',
    'POP3_user_name_overflow':'9016',
    'firefox-variantdatatojs-code-execution':'5900002',
    'ca-brightstor-msgengine-rpc-security-bypass':'5900002',
    'SQL port probe':'12878',
    'ie-vml-record-bo':'4865',
    'rhel-rhsa-2009-0338-update':'10636',
    'rhel-rhsa-2011-1851-update':'5900002',
    'frontpage-extension-directory-vtipvt-present':'2759',
    'ActiveX_AcroPDF':'5900002',
    'win-ms10kb2265906-update':'5900002',
    'win-smb-variable-dos':'5900002',
    'oracle-database-name-detected':'8543',
    'mozilla-stylesheet-information-disclosure':'7129',
    'ECware.exe_CGI':'2044',
    'rsagent-ldap-blacklist-failed':'11064',
    'vlcmediaplayer-activex-memory-overwrite':'14118',
    'SMB_Reflected_Authentication':'2118138',
    'HTTP_Webspeed_Admin':'2002570',
    'crontab-relative-pathnames':'1546',
    'win-ms10kb2267960-update':'5900002',
    'rlogin-long-username-bo':'10803',
    'spyware-ndg-systems':'12663',
    'CGI wwwboard.pl':'1172',
    'aix-iy88565-fix':'282',
    'http-alibaba-dotdot':'3549',
    'rhel-rhsa-2005-393-update':'9931',
    'ldap-nullbase':'5824',
    'nntp-subject':'7868',
    'maxdb-webdav-getlocktokenheader-bo':'6943',
    'HTTP_Compaq_Insight_Fileread':'2109002',
    'dbus-matchruleequal-dos':'1653',
    'SQLServer_login_failed_not_valid_user':'12925',
    'malcode-ExeSeq03':'6250',
    'malcode-ExeSeq02':'6249',
    'nap-download':'7551',
    'rhel-rhsa-2010-0442-update':'5900002',
    'HTTP_WeaknessCGIScanner':'2102030',
    'MSRPC_ARCserve_BackupDBEngine_DoS':'5900002',
    'malcode-ExeSeq09':'6256',
    'malcode-ExeSeq08':'6255',
    'file-link-nonexistant':'2518',
    'CompoundFile_Excel_DateTime_BO':'2106245',
    'user-ras-caller-set':'14006',
    'malcode-Psuedo_SPPE4':'6431',
    'license-gcr-bo':'5901',
    'iis-check-parent-paths':'4916',
    'apache-mod-imap-xss':'444',
    'SMTP_Expn_Overflow':'11904',
    'thinkmanagement-serversetup-file-upload':'5900002',
    'installshield-updateservice-bo':'5238',
    'win-ms12kb2675157-update':'5900002',
    'Email_Vrfy':'2001005',
    'rhel-rhsa-2005-434-update':'9951',
    'OTF_Silverlight_Code_Execution':'5900002',
    'oracle-instantiateonline-bo':'8557',
    'rhel-rhsa-2004-402-update':'9728',
    'smtp-sendmail-version5':'11875',
    'HTTP_Get_Malformed':'2116013',
    'sdp-invalid-utf8':'11409',
    'aix-iy63364-fix':'188',
    'Commerce.cgi_directory_traversal':'1409',
    'SMB pwl file type':'11711',
    'SOCKS login failed':'12327',
    'snmp-port-probe':'12101',
    'java-script-patch':'5581',
    'CGI mylog.html':'1150',
    'macos-apache-directory-disclosure':'6098',
    'ms-uag-applet-code-execution':'5900002',
    'HTTP_WebFinger':'2002510',
    'Inbound_replication_disabled':'5194',
    'SMB_Exception':'2116009',
    'openldap-selfwrite-security-bypass':'8454',
    'HTTP_Domino_Web_Access':'2110007',
    'HTTP_JRun_ISAPI_Host':'2105048',
    'IRC_Generic_Intel_Overflow':'2104000',
    'MSRPC_ARCserver_TapeEngine_Bo':'2118102',
    'passwd-nis-root':'8735',
    'Exchange55_administrator_login_as_user':'2305',
    'Image_PNG_Row_Data_Overflow':'5900002',
    'Finger_Perl':'2605',
    'RPC_suspicious_lookup':'10993',
    'socks5-auth-malformed':'12341',
    'vsftpd-tcpwrappers-gain-access':'14188',
    'macrovision-dwupdate-command-execution':'6103',
    'DNS_cache_poison_BlackICE_only':'1904',
    'yabb-file-access':'15308',
    'rhel-rhsa-2005-073-update':'9837',
    'http-teamtrack-file-read':'3695',
    'ie-argument-data-code-execution':'4690',
    'win-script-dll-code-exec':'5900002',
    'admin-usage-security-log':'95',
    'malcode-InappropriateMBR':'6340',
    'frozen-file-length-changed':'2772',
    'SMTP MIME filename repeated chars':'11830',
    'Bionet_trojan_horse_activity':'877',
    'adobe-unspecified-dos':'5900002',
    'mssql-procedure-perms':'7421',
    'RemoteHack_TCP_Response':'2113050',
    'spamassassin-symlink-dos':'12412',
    'jsws-trace-bo':'5900002',
    'ie-mhtml-mid-bo':'4794',
    'LDAP_Active_Directory_Search_Overflow':'5833',
    'BOEP_aim':'963',
    'javase-jre-deployment-unspecified-var3':'5900002',
    'lotus-domino-version-banner':'6054',
    'win-gdi-emfplusfont-dos':'14328',
    'HTTP_Nuclear_Notification':'4204',
    'vampire-virus':'14064',
    'MSRPC_MSDNS_Request':'7327',
    'rhel-rhsa-2007-0723-update':'10361',
    'microspy-backdoor':'7017',
    'icecap-app-terminated':'4588',
    'aix-iy72712-fix':'232',
    'http-cgi-guestbook':'3579',
    'mozilla-javascripteng-code-execution':'7090',
    'win-malformed-icon-detected':'14368',
    'spyware-taskmgrdv':'12762',
    'DataProtector_GET_FILE_Traversal':'5900002',
    'malcode-TASM0':'6797',
    'malcode-SPTRJ_Hide_Inet_Misc':'6711',
    'nt-snmp':'8313',
    'win-ms05kb892944-update':'14436',
    'spyware-msiebhostub-bho':'12650',
    'win2k-account-locked':'14895',
    'HTTP_GET_data_contains_script':'3940',
    'icmp-redirect':'4602',
    'exploit-MSExcel(100011)':'2349',
    'rhel-rhsa-2007-0710-update':'10357',
    'ie-content-disposition-variant2':'4717',
    'rhel-rhsa-2008-0055-update':'10483',
    'documentcapture-blackicedevmode-code-exec':'1976',
    'SOCKS4_Connect':'12340',
    'AgentManagerConnectionRestored':'159',
    'JBIG2_Detected':'5661',
    'malcode-BackdoorApp6':'6165',
    'malcode-BackdoorApp7':'6166',
    'GateCrasher':'3054',
    'malcode-BackdoorApp1':'6161',
    'Citrix_IMA_Service_BO':'2101025',
    'malcode-BackdoorApp3':'6162',
    'HTTP_GET_Filename_sam':'2003802',
    'DPS_Magic_Number_DoS':'2106241',
    'desktop-changes-saved':'1771',
    'rsagent-suspect-netbus':'11146',
    'cisco-http-enabled':'1276',
    'rhel-rhsa-2005-014-update':'9802',
    'malcode-SWFExecDebug':'6786',
    'malcode-SPNE_Srch_and_Del':'6610',
    'malcode-VB_6':'6833',
    'win-ms06kb923980-update':'14538',
    'user-profile':'14004',
    'JavaScript_VMware_GuestInfo':'2118132',
    'bind-rrsets-dos':'859',
    'admin-group-security-descriptor-set':'93',
    'iis-passive-ftp-asp':'4969',
    'OSPF_Null_Authentication':'8660',
    'TFTP Alcatel Update':'13628',
    'malcode-SPTRJ_Inet_reg_SEH':'6718',
    'W97M.Marker.a virus':'14195',
    'SNMP_Community_Long':'2002018',
    'mdac-ms02065-patch':'6957',
    'HTTP_Twiki_Search_CmdExec':'2106178',
    'http-iis-cmd':'3639',
    'Scada_IGSS_Collection_Traversal':'5900002',
    'SMTP pipe in mail address':'11833',
    'VmResettingEvent':'14134',
    'rhel-rhsa-2007-0469-update':'10320',
    'Frenzy_Response':'2001557',
    'win-rpcss-rpcmessage-dos':'14824',
    'backdoor-gatecrasher':'688',
    'imail-registry':'5132',
    'rhel-rhsa-samba-smbd-connection-dos':'10767',
    'nt-operator-userpw':'8220',
    'openview-nnm-ovet-code-execution':'5900002',
    'iis-ism-file-access':'4959',
    'nav-pop-user':'7582',
    'rhel-rhsa-2003-268-update':'9626',
    'spyware-redhotnetworks':'12710',
    'rhel-rhsa-2009-0010-update':'5900002',
    'decod-generic-overflow':'1694',
    'NetBus_Response':'2001502',
    'BackOrifice2K_TCP_Request':'2001514',
    'JavaScript_DirectAnimation_Overflow':'2113251',
    'mozilla-netscape-nonascii-bo':'7110',
    'win-ms10kb978037-update':'14784',
    'win-ms05kb871250-update':'14421',
    'malcode-Format':'6304',
    'HVL_RAT_Response':'2001561',
    'snmp-extra-bytes':'12069',
    'mssql-lpc-bo':'7408',
    'dcom-server-deny':'1660',
    'nt-hkey-local':'8135',
    'Buttman_TCP_Request':'2113047',
    'spyware-win32-narrator-trojan':'12823',
    'FTP_Fname_Eftp2':'2003608',
    'SDP_Value_Format_String':'2106294',
    'win-ms11kb2483185-update':'5900002',
    'SIP_Invalid_Auth_Response':'2114009',
    'IMAP_Outlook_Date_Overflow':'5181',
    'HTTP_ASP_Security_Bypass':'2113156',
    'rhel-rhsa-2004-119-update':'9684',
    'IRC Trinity agent':'5373',
    'GTP_C_APN_Corrupt':'2111031',
    'http-user-agent-bo':'3708',
    'apple-sa20060110-update':'499',
    'Order_Form_data_URL':'8619',
    'malcode-SPPE_DO_PolyMorph':'6668',
    'server-critical-event':'11531',
    'PDF_Contains_GIF':'5900002',
    'Firewall_Syn_Flood':'2656',
    'Email_Lotus_Domino':'2001050',
    'HTTP_IExplorer_Command_Exec':'2110032',
    'Email_Exchange_Calendar_DoS':'2114050',
    'HTTP_WhatsUp_Login_DoS':'2118059',
    'SSI_safety_overflow':'13071',
    'home-rhosts-netgroup':'3286',
    'OTF_Degenerate_Table':'5900002',
    'Script_Concealed_Content':'5900002',
    'rhel-rhsa-2010-0356-update':'5900002',
    'rhel-rhsa-2005-134-update':'9860',
    'encrypted-session-policy-abuse':'5900002',
    'scada-modbus-clear-registers':'11324',
    'ie-clsid-file-extension-spoofing':'4712',
    'HTTP_Cisco_IOS_Admin_Access':'2002640',
    'Spyware_PH_DownloadAcceleratorPlus':'2113181',
    'TFTP pwl file type':'13636',
    'creativesoftware-autoupdate-engine-bo':'5900002',
    'malcode-SPNE_Sys_Rd_Wrt':'6617',
    'xwork-parameterinterceptor-sec-bypass':'5900002',
    'cia-door-backdoor':'1249',
    'SQL_Jet_Query_Overflow':'2120038',
    'NetMeeting_Directory_Traversal':'2120000',
    'ms-ie-selection-object-code-exec':'5900002',
    'ISA_client_conn_limit_exceeded_disconnected':'5484',
    'HTTP_3com_AirConnect_FilteringSetup':'2106010',
    'http-cgi-regecho':'3595',
    'oracle-database-link-bo':'8542',
    'spyware-seksilolita':'12734',
    'CGI test-cgi.tcl':'1163',
    'ISS_Ident':'2102011',
    'Content_TNEF_Exchange_Code_Execution':'1517',
    'PmapSetSpoof':'8976',
    'DNS_name_overflow_contains_%':'1940',
    'safari-webkit-floating-bo':'11255',
    'backdoor-devil13':'680',
    'spyware-dogpile-toolbar':'12522',
    'rhel-rhsa-2009-1503-update':'5900002',
    'rhel-rhsa-2007-0286-update':'10283',
    'DNS_Zone_Transfer_Failed':'1972',
    'google-desktop-detected':'3159',
    'DNS_Crack_Success':'2009100',
    'RealSecure_Kill':'2103004',
    'spyware-coulomb-dialer':'12505',
    'samba-swat-base64-bo':'11283',
    'malcode-SPPE_DLL_WrtToSect_LastSectEP':'6660',
    'Email_VCF_Mozilla_Overflow':'2107034',
    'macrovision-isusweb-code-execution':'6106',
    'CGI info2www':'1145',
    'FTP file name overflow':'2794',
    'malcode-SPNE_srch_dll':'6611',
    'rhel-rhsa-2005-791-update':'10034',
    'HTML_Win_Grpconv_Overflow':'2121006',
    'Citrix_IMA_DoS':'5900002',
    'ie-urlmon-bo':'4860',
    'adobe-acrobatreader-code-execution':'112',
    'win2k-localgroup-member-added':'14938',
    'HTTP URL contains .._.._.._..':'3532',
    'rhel-rhsa-2003-223-update':'9614',
    'SNMP Echo Bounce':'11997',
    'HTTP_WebSphere_reveal_path':'2002630',
    'Ident_Invalid_Response':'2001901',
    'user-login-shell-missing':'13984',
    'msdtc-message-dos':'7253',
    'rendezvous-running':'9486',
    'SMTP_STARTTLS_Command_Injection':'5900002',
    'agentmanager-info':'153',
    'http-cgi-phpfileread':'3594',
    'pict-region-overflow':'5900002',
    '180search-assistant-spyware':'5',
    'hpvirtualrooms-hpvirtualrooms14-activex-bo':'3348',
    'nt-wins-snmp2':'8373',
    'rhel-rhsa-mult-browser-javascript-handler-dos':'10733',
    'HTML_Mozilla_Multiple_Layout_Exec':'3438',
    'netware-cifsnlm-bo':'5900002',
    'ibm-runtimes-java-class-dos':'5900002',
    'HTTP_Netscape_List_Directories':'2000649',
    'rhel-rhsa-2007-0346-update':'10294',
    'bigant-messenger-activex-bo':'5900002',
    'flexcell-grid-file-overwrite':'2686',
    'zone-low-channel':'15386',
    'FTP_Restart_LargeFile':'5900002',
    'IPOP3D_user_login_failure':'5337',
    'rsagent-suspect-ssh':'11152',
    'Email_Virus_PICTURE_EXE':'2002203',
    'allaire-jrun-read-sample-files':'316',
    'VmCreatedEvent':'14122',
    'wow23-backdoor':'15173',
    'passwd-nonexistant-onceonly':'8737',
    'Truva_Response':'2001595',
    'malcode-RemoteDoS':'6451',
    'HTTP_eScan_ForgotPassword':'5900002',
    'mozilla-settimeout-code-execution':'7126',
    'netbios-name-server-spoofing':'7687',
    'statd':'13143',
    'SNMP_bad_specific_trap_tag':'12164',
    'HTML_JS_Webex_ActiveX':'3428',
    'firefox-javascript-engine-code-execution':'2627',
    'spyware-central-24dialer':'12484',
    'cisco-aironet-webconfig':'1260',
    'edrawoffice-httpdownloadfile-file-overwrite':'2058',
    'Swf_Data_Beyond_ActionEndFlag':'2114124',
    'win-ms12kb2663841-update':'5900002',
    'win-ms08kb951066-update':'14654',
    'ActiveX_Detected':'86',
    'win-ms12kb2695502-update':'5900002',
    'rsagent-failedchange-files':'11043',
    'spyware-epsystems-dialmaker':'12544',
    'Javascript_COM_Object':'2113262',
    'hp-data-protector-code-exec':'5900002',
    'win-ms08kb952044-update':'14660',
    'googlechrome-buffers-code-execution':'3165',
    'ie-table-status-spoofing':'4847',
    'SNMP disable authen-traps':'11995',
    'rhel-rhsa-2007-1003-update':'10423',
    'HTTP_W3Who_Bo':'2118024',
    'Out_of_virtual_memory':'8670',
    'SIP_Message_Detected':'11661',
    'odb-cdc-unspecified':'5900002',
    'nt-dcomperms':'8039',
    'apache-sslciphersuite-restriction-bypass':'481',
    'fathftp-activex-file-deletion':'2440',
    'http-post-triple-dot':'3673',
    'malcode-SPTRJ_Inet_NotNrml':'6717',
    'MSRPC_Suspicious_UUID':'7379',
    'win2k-deny-logon-batch':'14908',
    'ca-arcservebackup-xdrrwsstring-bo':'1072',
    'WRF_ATDL_Buffer_Overflow':'5900002',
    'Email_Error':'2001015',
    'rhel-rhsa-2007-0964-update':'10411',
    'bootpdom':'992',
    'rhel-rhsa-2008-0207-update':'10526',
    'SMB win.ini file':'11715',
    'Firewall_Access_Statistics':'2644',
    'rhel-rhsa-2008-0176-update':'10515',
    'HTTP_IExplorer_Cache_Exec':'2120015',
    'win-ms06kb905553-update':'14469',
    'rhel-rhsa-2008-0133-update':'5900002',
    'ssh2-auth-successful':'12989',
    'adobe-heap-code-exec':'5900002',
    'php-strrepeat-bo':'8909',
    'FTP_Glob_Expansion':'2001356',
    'backdoor-pbbser':'711',
    'HTTP_MyDoom_DoS':'4175',
    'openssh-signal-handler-race-condition':'8479',
    'rhel-rhsa-2005-371-update':'9920',
    'FTP Glob Overflow':'2795',
    'Stacheldraht_Handler':'2001583',
    'starteam-pgmwebhandlerparserequest-bo':'13135',
    'login-authentication':'6022',
    'rhel-rhsa-2004-612-update':'9779',
    'ie-parameter-code-execution':'4819',
    'rhel-rhsa-2008-0648-update':'10579',
    'win-shell-bo':'14838',
    'win-ms06kb916803-update':'14500',
    'sol-hidden-commstr':'12363',
    'Hack-a-tack ICQ pager URL':'3247',
    'arcserve-detected':'544',
    'exchange-smtp-verb-bo':'2300',
    'GTP_U_StationToStation':'2111038',
    'rhel-rhsa-2008-0297-update':'10554',
    'ssl-pct-enabled':'13082',
    'Email_Exchange_Mime_Decoding':'2114051',
    'HTTP_Novell_iMonitor_BO':'2106212',
    'AVI_INFO_Chunk_Overflow':'5900002',
    'badblue-ext-reveal-path':'783',
    'CGI_jj_exploit':'1193',
    'hp-easyprinter-activex-code-execution':'5900002',
    'xstat-phpinfo-reveal-info':'15283',
    'postgresql-sqlfunctions-info-disclosure':'9076',
    'Syslog_Flood':'5900002',
    'SMB_MediaPlayer_Classic_DLL_Hijacking':'5900002',
    'Security_audit_setup_attempt_failed':'11447',
    'egatherer-activex-runegatherer-bo':'2060',
    'MSCHAPv2_Authentication_Bypass':'7244',
    'http-cgi-count':'3568',
    'nds-user-template-unique-password':'7652',
    'http-resp-set-cookie-xss':'3683',
    'akamai-file-download-code-exec':'5900002',
    'win-ms06kb917159-update':'14502',
    'libmagick-expandfilenames-bo':'5873',
    'FTP MKD directory overflow':'2801',
    'HTTP_JJ':'4110',
    'rhel-rhsa-2007-0729-update':'10363',
    'Trojan horse response':'13778',
    'Quake backdoor':'9196',
    'Tagged_Packet':'13354',
    'FTP_WSFTP_Allo_BO':'2118018',
    'HTTP_PhpBB_Viewtopic_Highlight':'2121011',
    'pcanywhere32-installed':'8763',
    'rhel-rhsa-2006-0268-update':'10107',
    'rhel-rhsa-2008-0537-update':'10574',
    'winxp-sam-anonymous-enumeration':'15099',
    'TCP_Probe_NetBIOS':'13441',
    'baofeng-activex-bo':'791',
    'sigplus-activex-bo':'5900002',
    'UDP_Probe_Qotd':'13856',
    'Kerberos_Server_Name_Referral_DoS':'5900002',
    'rhel-rhsa-pamldap-passpol-security-bypass':'10751',
    'sip-invalid-uri-detected':'11621',
    'office-pict-code-execution':'8411',
    'AntiSniff_ARP_Test':'2002302',
    'registry-key-exists':'9461',
    'win-ms10kb2315011-update':'5900002',
    'utillinux-pamlimits-gain-privileges':'14048',
    'nss-mastersecret-bo':'7948',
    'FTP_PrivilegedPort':'2001303',
    'HTTP_PHP_Memory_Limit':'2121029',
    'Audit_TFTP_Get_Filename':'607',
    'aolradio-ampx-activex-bo':'402',
    'axis-storpoint-auth':'640',
    'u3d-block-overflow':'5900002',
    'rhel-rhsa-2005-378-update':'9924',
    'Image_WMF_RecordSize_Overflow':'2116026',
    'Security_disabled_universal_group_deleted':'11460',
    'spyware-sidestep':'12743',
    'JavaScript_Oracle_UpdateRecord':'2114044',
    'PDF_GetIcon_Overflow':'8797',
    'spyware-spyarsenal-family-keylogger':'12746',
    'rhel-rhsa-2009-0337-update':'10635',
    'dns-iquery':'1876',
    'leadtools-bitmap-dos':'5900002',
    'netterm-ftp-dir-bo':'7762',
    'tftpd32-request-format-string':'5900002',
    'group-member-changes':'3174',
    'tcp-syn-with-data':'13398',
    'rocketlife-activex-bo':'5900002',
    'RPC_AutoFS_Shell':'2001755',
    'idautomation-activex-file-overwrite':'4642',
    'CompoundFile_Excel_Autofilter_Malformed_Size':'2118094',
    'quicktime-activex-code-execution':'5900002',
    'HTTP_IE_IFrame_BO':'2107036',
    'email-mime-msg-attachment':'5900002',
    'Imail_ldap_Overflow':'5136',
    'msrpc-plugandplay-devicebo':'7294',
    'group-added':'3169',
    'MSRPC_WksSvc_UserEnum_DoS':'2118104',
    'Echo storm':'2035',
    'User_added_to_local_admin_group':'14035',
    'linux-snmp-nathelper-dos':'5971',
    'wireshark-mount-dos-win':'15124',
    'rhel-rhsa-2002-165-update':'9528',
    'Email_Subject':'2143',
    'easygrid-activex-dosavefile-file-overwrite':'2023',
    'rhel-rhsa-2006-0541-update':'10135',
    'MSRPC_ARCserve_MessageEngine_Insecure_Method':'5900002',
    'sun-jre-javascript-unauthorized-access':'13217',
    'rhel-rhsa-2005-392-update':'9930',
    'decod-rsh':'1733',
    'bladerunner-backdoor':'930',
    'nt-passfilt-checksum':'8224',
    'php-phpinfo-disclose-memory':'8894',
    'adobe-acrobat-activex-control-dos':'100',
    'smtp-ehlo':'11854',
    'X_ZToo_Backdoor_Response':'2110093',
    'gtrust-local-same':'3218',
    'mssql-bulk-insert-bo':'7398',
    'ftp-write':'2883',
    'SMB_Filename_Overflow':'2000505',
    'rhel-rhsa-2005-343-update':'9908',
    'backdoor-secretservice':'725',
    'malcode-SystemHijack':'6792',
    'XML_EntityRef_DoS':'2119013',
    'decod-smtp-from':'1738',
    'MOV_STSD_Atom_Overflow':'2121047',
    'DNS I-Query':'1847',
    'rhel-rhsa-2008-0271-update':'10547',
    'rhel-rhsa-2007-0079-update':'10243',
    'ms-win-mjpeg-code-execution':'5900002',
    'linux-fault-handler-gain-privileges':'5928',
    'HTTP_HomeFree_Search':'2106023',
    'accountingsoftware-magic-number-dos':'42',
    'modauthany-command-execution':'7033',
    'File_Does_Not_Exist':'5900002',
    'openssl-prng-brute-force':'8495',
    'VmUuidAssignedEvent':'14140',
    'TotalEclypse':'13742',
    'SNMP_Dialup_Hangup':'2002010',
    'nt-clearpage':'8020',
    'HTTP_Media_Player_setItemInfo_CodeExec':'2118029',
    'snmp-pdu-incorrect-length':'12098',
    'rhel-rhsa-2006-0501-update':'10129',
    'rhel-rhsa-2004-480-update':'9755',
    'flashplayer-swf-string-bo':'2683',
    'hacker-defender-packet-detected':'3258',
    'mssql-c-runtime-format-string':'7399',
    'IP_source_route_end':'5297',
    'webevent-script-access':'14229',
    'Email_Expn_Overflow':'2001032',
    'hp-opennnm-ovas-bo':'5900002',
    'HTTP_ContentDisposition_LongFile':'5900002',
    'cisco-ntp-enabled':'1313',
    'malcode-rexx_18':'6476',
    'malcode-rexx_19':'6477',
    'koobface-worm-detected':'5791',
    'rhel-rhsa-2005-036-update':'9816',
    'malcode-rexx_10':'6468',
    'malcode-rexx_11':'6469',
    'malcode-rexx_12':'6470',
    'malcode-rexx_13':'6471',
    'malcode-rexx_14':'6472',
    'malcode-rexx_15':'6473',
    'malcode-rexx_16':'6474',
    'malcode-rexx_17':'6475',
    'rhel-rhsa-2008-0836-update':'10584',
    'malcode-AutostartManiac':'6158',
    'bugzilla-show-activity':'1042',
    'outlook-express-ms04013-patch':'8678',
    'proventia-detection-stopped-block':'9143',
    'HTTP_WebSite_Uploader':'2002538',
    'HTTP_IIS_Media_Services':'2105082',
    'webplus-reveal-source-code':'14247',
    'blackice-filter-failed':'917',
    'rsagent-sybase-connect-successful':'11161',
    'rhel-rhsa-2004-191-update':'9701',
    'mailman-pipermail-index-css':'6122',
    'RTSP_Helix_Describe_Overflow':'5900002',
    'kingview-historysvr-bo':'5900002',
    'decod-smb-filename-long':'1734',
    'rsagent-auditpolicy-changed':'11015',
    'Computer_account_created':'1467',
    'rsagent-change-files':'11017',
    'rhel-rhsa-2006-0204-update':'10095',
    'DOS_DoS_URL':'1987',
    'HTTP Form filename overflow':'3494',
    'rhel-rhsa-2006-0199-update':'10092',
    'rhel-rhsa-2008-0146-update':'10503',
    'Agent_Type_Changed':'151',
    'user-admin-lock':'13950',
    'SNMP_Bad_Trap_AgentAddr':'2106082',
    'Email_UUDecode_Alias':'2001014',
    'nt-system-audit-success':'8326',
    'spyware-netzany':'12673',
    'ldap-nullsubtree':'5826',
    'HTTP_Post':'4299',
    'malcode-SirReadAlot':'6527',
    'libwww-htboundaryputblock-dos':'5896',
    'wordlist':'15160',
    'adobe-reader-cooltype-code-execution':'5900002',
    'IMAP_Search_Charset_Overflow':'5900002',
    'Saint Scan':'11259',
    '.lnk URL type':'2',
    'javase-jre-cve20120499':'5900002',
    'Cero_TCP_Response':'2120010',
    'rhel-rhsa-2009-0225-update':'10621',
    'Telnet_NetPerformer_Username_Overflow':'5900002',
    'HTTP_Php_Include_Bypass':'2121013',
    'MSRPC_HostIntegration_NullSession_Exec':'7313',
    'ypbind-reserved':'15345',
    'aix-ftpd-bo':'168',
    'rshd-tcp-bo':'5900002',
    'malcode-StrongConditional':'6733',
    'nt-ras-reg-perms':'8263',
    'rhel-rhsa-2007-1023-update':'10430',
    'novell-zhm-zfhipcnd-bo':'5900002',
    'rhel-rhsa-2004-019-update':'9657',
    'rhel-rhsa-2007-0033-update':'10225',
    'Ganglia_Process_Path_Overflow':'5900002',
    'JavaScript_Blackhole_Exploit_Kit':'5900002',
    'rsagent-useraccount-deleted':'11175',
    'tftp-echo-bounce':'13643',
    'CompoundFile_Duqu_Font':'5900002',
    'HTTP_Pi3Web_TstIsapiDll':'2002661',
    'MSRPC_AV_Heap_Overflow':'2114029',
    'HTTP_Suspicious_Unknown_Content':'5900002',
    'FTP_NetTerm_Rmdir_Overflow':'2001336',
    'active-directory-in-replication-disabled':'65',
    'rhel-rhsa-kernel-ipv6-type0-dos':'10702',
    'iis-unicode-asp-disclosure':'4992',
    'DNS_BIND_Zero_Rdata_DoS':'5900002',
    'home-xhost':'3287',
    'win-ms09kb958687-update':'14703',
    'rhel-rhsa-2007-0937-update':'10402',
    'HTTP_WebSite_Sample':'2002536',
    'win2k-catalog-remove-hotfixes':'14905',
    'rhel-rhsa-2005-267-update':'9884',
    'linux-aiofreering-dos':'5916',
    'fpse-debug-bo':'2713',
    'h225-invalid-field-dos':'3234',
    'HTTP_BAT_Execute':'2002501',
    'win-ms06kb915384-update':'14497',
    'SNMP_Discovery_Broadcast':'2002004',
    'aix-iy87894-fix':'276',
    'HTTP_POST_Filename_passwd':'2003901',
    'fedora-admconf-information-disclosure':'2445',
    'SMB_Negotiate_MaxSize_Overflow':'11766',
    'exploit-MSVisio(100030)':'2368',
    'NNTP_User':'7883',
    'ssl-malformed-certificate':'13080',
    'rhel-rhsa-2005-346-update':'9911',
    'QuickTime_STSD_Sample_BO':'9272',
    'rhel-rhsa-2009-0382-update':'5900002',
    'uucp-homedir':'14054',
    'rhel-rhsa-2010-0464-update':'5900002',
    'RPC_Portmap_Unset':'2001709',
    'XMLDsig_Tampering':'5900002',
    'adobe-reader-u3d-tiff-bo':'5900002',
    'rhel-rhsa-2006-0191-update':'10088',
    'LDAP_Lotus_Domino_OctetString_Overflow':'5900002',
    'chargen-port-probe':'1229',
    'HTTP_IIS_Directory_Auth_Bypass':'5900002',
    'symantec-autofixtool-bo':'13304',
    'VmFailedToPowerOnEvent':'14123',
    'IMAP2bis_server_preauthenticated_user_login_successful':'5143',
    'JavaScript_WebViewFolderIcon_Overflow':'2110111',
    'win-server-pointer-driver-dos':'14830',
    'FTP_invalid_PORT_command':'2937',
    'Rlogin_Trusted_Login':'10824',
    'cisco-bgp-auth-enabled':'1263',
    'realplayer-realaudioobjects-code-execution':'9360',
    'Edonkey_Download':'2053',
    'malcode-SPMZ_int3_tun_IVT':'6565',
    'HTTP_Expect_Header_Malformed':'5900002',
    'Xanadu_TCP_Response':'2113166',
    'TFTP_Filename_Overflow':'2111002',
    'irc-worm-detected':'5383',
    'malcode-Overwriter':'6415',
    'HTTP_BranchCache_DLL_Hijacking':'5900002',
    'irc-notice':'5378',
    'kde-ps-command-execution':'5694',
    'HTTP_NTLM_Authorization_Overflow':'5900002',
    'ssl-rsa-information-leak':'13085',
    'pdf-invalidstreamlength-detected':'5900002',
    'spyware-hightrafficaddsbho':'12584',
    'Scada_Modbus_RestartCommunications':'11347',
    'ARCserve_Backup_LGServer_Hex_Underflow':'548',
    'commerce-cgi-view-files':'1407',
    'tcp-syn-urg-flag':'13397',
    'QuickTime_Pascal_String_Overflow':'5900002',
    'FTP_Cwd_Overflow':'2001308',
    'MSM_ResourceError':'7264',
    'rsagent-ssh-authattempt':'11116',
    'malcode-ExeSeq29':'6276',
    'dns_inv_dom_offset':'1927',
    'lotus-domino-ldap-bo':'6046',
    'RPC SGI FAM access':'10857',
    'HTML_IE_SPAN_Objects_Code_Exec':'3412',
    'malcode-ExeSeq21':'6266',
    'malcode-ExeSeq20':'6265',
    'malcode-ExeSeq23':'6274',
    'SNMP_Suspicious_Set':'2104020',
    'malcode-ExeSeq24':'6275',
    'WinTrin00_Daemon_Request':'2100002',
    'rhel-rhsa-2004-172-update':'9694',
    'Telnet XDISPLOC':'13524',
    'winscp-uri-handler-command-execution':'15086',
    'rhel-rhsa-2007-0980-update':'10419',
    'FTP_IIS_Wildcard_Overflow':'2935',
    'gv-sscanf-function-bo':'3228',
    'CGI glimpse':'1139',
    'HTTP_GET_sam.__file':'3954',
    'OSPF_Database_Desc_Multicast':'8650',
    'lpd-enabled-aix':'6067',
    'rhel-rhsa-2008-0618-update':'5900002',
    'google-chrome-homographic-spoofing':'5900002',
    'windowsserverccp-dll-ce':'5900002',
    'IMAP4 authentication overflow':'5149',
    'malcode-DelExisting1':'6203',
    'malcode-Multiplying':'6382',
    'snmp-bad-trap-agentaddr':'12048',
    'file-default-profile-notfrozen':'2485',
    'win-ms06kb924554-update':'14544',
    'HTTP_Apache_Struts2_Exec':'5900002',
    'AVI_DirectShow_MJPEG_Decompression':'627',
    'Spyware_PH_MarketScore':'2113198',
    'windmail-fileread':'15019',
    'HTTP_Apache_LF_Memory_DoS':'2122006',
    'bgp-new-route':'817',
    'win-ms06kb922770-update':'14530',
    'SNMP_Default_Backdoor':'2002003',
    'inetd-internal':'5204',
    'eot-detected':'2172',
    'netmon-start':'7715',
    'iis-iisadmpwd':'4947',
    'igss-dc-directiory-traversal':'5900002',
    'HTTP_FileTypeLnk':'2002546',
    'quicktime-crgn-atom-bo':'9216',
    'getplus-activex-gpocx-bo':'3079',
    'Svg_Rect_Transform_Overflow':'5900002',
    'icmp-unsolicited-echo-reply':'4608',
    'rhel-rhsa-2008-0290-update':'10552',
    'JavaScript_Obfuscation_Rue':'2114166',
    'iis-hex-evasion':'4937',
    'win-ms11kb2567951-update':'5900002',
    'start-taskbar-enabled':'13133',
    'rhel-rhsa-2008-0275-update':'10548',
    'backdoor-transscout':'739',
    'rhel-rhsa-postgresql-anyarray-dos':'10761',
    'rhel-rhsa-2010-0505-update':'5900002',
    'avaya-cajun-default-snmp':'624',
    'HTTP_IIS_ISMDLL_Overflow':'4067',
    'openssh-running':'8475',
    'HTTP_PHP_View_Files':'4280',
    'spyware-navexcel':'12659',
    'SMB Unicode file name overflow':'11714',
    'rhel-rhsa-2010-0459-update':'5900002',
    'win-mediaplayer-skin-header-code-execution':'14381',
    'win-ms10kb972270-update':'14774',
    'malcode-Dropper2':'6226',
    'malcode-Dropper3':'6227',
    'malcode-Dropper0':'6224',
    'malcode-Dropper1':'6225',
    'cisco-ios-admin-access':'1280',
    'RealMedia_Integer_Overflow':'2121024',
    'malcode-Dropper4':'6228',
    'HTTP_ASP_Form_UserName_Bypass':'5900002',
    'Scada_DNP_BroadcastRequest':'11333',
    'rhel-rhsa-2011-0357-update':'5900002',
    'ie-image-source-redirect':'4775',
    'rhel-rhsa-2004-050-update':'9666',
    'TrinooMasterAttempt':'13776',
    'win-ms11kb2618451-update':'5900002',
    'SQL_SSRP_Slammer_Worm':'2113022',
    'nt-os2-sub-c2':'8221',
    'System_Failed_Login':'13342',
    'XMPP_Message':'15265',
    'HTTP_GET_pwl_file_type':'3953',
    'rhel-rhsa-2008-0503-update':'10563',
    'office-html-object-tag':'8408',
    'reg-logon-text-incorrect':'9406',
    'telnet-auth-loki':'13527',
    'win2k-universalgroup-deleted':'14986',
    'rhel-rhsa-2005-357-update':'9914',
    'malcode-SPMZ_ICEBP_Poly':'6564',
    'Duddie_TCP_Request':'2113099',
    'HTTP_CobaltRAQ_OverflowCGI':'2106175',
    'slapper-worm-b':'11687',
    'RPC_TCP_port_probe':'10994',
    'spyware-scbar':'12717',
    'divxwebplayer-npUpload-dos':'1836',
    'libpng-rowdata-bo':'5900002',
    'malcode-ExeSeq22_Attribs':'6267',
    'BrightStor_Discovery_Overflow':'1018',
    'kernel-pppoe-dos':'5749',
    'Oracle_XMLSchema_Overflow':'5900002',
    'nfuse-launch-xss':'5900002',
    'CGI anyform2':'1129',
    'adobe-flash-declarefunction2-bo':'121',
    'nt-guest':'8129',
    'HTTP_RingZero':'2104022',
    'malcode-WormIndicator3':'6911',
    'spyware-win-logon-exe':'12812',
    'nds-user-home-accessible':'7629',
    'HTTP_Code_Red_II_Plus':'2004603',
    'RPC suspicious lookup':'10862',
    'HTTP_IE_Script_HRAlign_Overflow':'2110056',
    'malcode-SPNE_Selec_Cond':'6609',
    'Swf_ActionScript_Exploit':'5900002',
    'Finger_port_probe':'2606',
    'RealMedia_Detected':'9348',
    'win2k-authticket-request-failed':'14901',
    'SNMP_bad_community_tag':'12144',
    'rhel-rhsa-ekiga-gmmain-format-string':'10685',
    'SOAP_Envelope_Overflow':'2119004',
    'sendmail-mime-bo':'11502',
    'apache-server-info-detected':'472',
    'Napster_Create_Account':'7561',
    'SNMP long oid':'12012',
    'nt-single-process':'8312',
    'malcode-Office_Worm':'6399',
    'FTP_CWD_~root_command':'2906',
    'malcode-SuspiciousFIO':'6782',
    'phAse Zero trojan horse activity':'8834',
    'rhel-rhsa-2006-0760-update':'10211',
    'HTTPS_ClearText_Session':'2110099',
    'tcpdump-afs-packet-overflow':'13478',
    'rhel-rhsa-2009-1337-update':'5900002',
    'NNTP_Xchg_Auth':'2002405',
    'rhel-rhsa-fetchmail-plaintext-info-disclosure':'10688',
    'ie-showhelp-directory-traversal':'4841',
    'rhel-rhsa-2005-480-update':'9957',
    'nap-search':'7556',
    'pdf-hexadecimal-literal-javascript-detected':'8779',
    'openview-nnm-snmpviewer-bo':'5900002',
    'TFTP passwd file':'13634',
    'isakmp-improper-packet-handling':'5527',
    'ras-auth-timeout':'9309',
    'FTP command line overflow':'2786',
    'http-post-repeated-characters':'3670',
    'nis-uid-gid':'7846',
    'tomcat-null-thread-dos':'13728',
    'ssh2-auth-failed-pubkey':'12988',
    'SQL login failed':'12877',
    'pcanywhere-weak-encryption-allowed':'8762',
    'aix-iy88528-fix':'281',
    'MDB_Jet_Engine_Stack_Overflow':'6970',
    'file-sgid-binary':'2542',
    'snmp-trap-timestamp-underflow':'12120',
    'spyware-sandboxer':'12715',
    'malcode-EmailBuddy':'6237',
    'nt-lsakey':'8174',
    'spyware-twistedhumor':'12783',
    'SMB_Client_Response_Exec':'5900002',
    'gnutella-connect':'3144',
    'ie-scriplet-fileread':'4829',
    'jre-jdk-audiosystem-priv-escalation':'5679',
    'rhel-rhsa-2002-121-update':'9512',
    'unix-setuid-chmod':'13897',
    'apache-weak-encryption':'491',
    'ms-ie-toolbar-code-exec':'5900002',
    'rhel-rhsa-2005-768-update':'10024',
    'ms-win-htmlhelpa-code-execution':'5900002',
    'TLS_Weak_X509_Certificate':'5900002',
    'Oracle_Successful_Connection':'8611',
    'SIP_Invalid_Invite_Address':'2114020',
    'illusionmailer-backdoor':'5040',
    'fpdb-wrong-group':'2710',
    'rhel-rhsa-2008-0154-update':'10505',
    'rhel-rhsa-2004-222-update':'9704',
    'POP3_login_failed':'9009',
    'rpc.mountd_overflow':'10903',
    'HTTP_OpenView_NNM_CmdExec':'2106207',
    'user-rsh':'14010',
    'sendmail-header-processing-bo':'11495',
    'SNMP trap addr underflow':'12030',
    'SMB_Password_File':'2002701',
    'rhel-rhsa-2004-005-update':'9654',
    'rhel-rhsa-2011-0305-update':'5900002',
    'KT3_Trojan_Response':'2110126',
    'reg-file-assoc':'9397',
    'HTTP_LotsOf_Byte_Ranges':'5900002',
    'isa-conn-limit-exceed-rejected':'5433',
    'Login_Backdoor':'6026',
    'rservice-exec-wrapper-allow':'11185',
    'ohhara-linux-rootkit-login':'8428',
    'GTP_C_PPP_Login':'3212',
    'rhel-rhsa-2005-306-update':'9893',
    'DNS Chaos lookup':'1843',
    'snmp-community-embedded-null':'12051',
    'Failed_login-time_restriction_violation':'2431',
    'HTTP_OpenView_NNM_URL_Overflow':'5900002',
    'BGP_Open_Malformed':'2106183',
    'MIDI_Invalid_Channel':'5900002',
    'AeDebug reg hack':'146',
    'Fragment_Resources_Exhausted':'2000011',
    'win-ms10kb2418042-update':'5900002',
    'Content_Analyzer_User_Combined_6':'2120096',
    'QuickTime_Very_Large_Atom':'9274',
    'dialogwrapper-activex-bo':'1817',
    'pdf-printseps':'5900002',
    'win-ms07kb932168-update':'14580',
    'nt-group-deleted':'8092',
    'win-ms10kb982381-update':'5900002',
    'sip-large-max-forward':'11623',
    'Windows_Access_Error':'15032',
    'ms-win-tcpip-ipv6-dos':'5900002',
    'nt-logover':'8171',
    'apache-user':'490',
    'rhel-rhsa-2007-0858-update':'10383',
    'HTTP ACCEPT_ field overflow':'3481',
    'spyware-sexnow-dialer':'12737',
    'http-php-method-bypass':'5900002',
    'Swf_Cross_Site_Scripting':'5900002',
    'wireshark-ansimap-format-string-win':'15108',
    'HTTP_Kaneva_Client':'4116',
    'XDMCP_Query':'15212',
    'tomcat-requestparamexample-xss':'13730',
    'HTTP_Mozilla_Nonascii_URL_BO':'2107033',
    'issymbol-internationalorder-bo':'5900002',
    'exploit-MediaPlayer(100040)':'2343',
    'visualstudio-dwmapi-dll-ce':'5900002',
    'RemoteWindowsShutdown':'9484',
    'rpc.amd overflow':'10894',
    'malcode-WormDropper2':'6908',
    'HTTP Authentication overflow':'3485',
    'richfx-nprfxins-bo':'10776',
    'ms-legacytext-activex-bo':'7183',
    'registry-sam-access':'9462',
    'javascript-noop-shenanigans':'5593',
    'win-ms05kb899589-update':'14452',
    'Password_reset_successful':'8748',
    'reg-sec-log-recent-overwritten':'9435',
    'Content_Analyzer_Date':'2120078',
    'SNMP_Trap_Enterprise_Invalid':'2106080',
    'CompoundFile_Word_Malformed_Stack':'2114015',
    'Secu_Descptr_propgtr_abnormal_termination':'11431',
    'rsagent-ssh-execution':'11122',
    'SMTP Attack':'11803',
    'rhel-rhsa-2007-0153-update':'10265',
    'rsagent-change-password-attack':'11019',
    'igss-logtext-format-string':'5900002',
    'Win_MessengerPopup_Bo':'2111018',
    'mcafee-mcsubmgr-activex-bo':'6948',
    'hp-photo-activex-bo':'5900002',
    'win-ms11kb2638420-update':'5900002',
    'ca-arcservebackup-credentials-code-execution':'1064',
    'win-malformed-rtf-control-word':'14369',
    'MSRPC_Invalid_Request':'2118081',
    'mysql-password-bo':'7526',
    'TelnetAuthUser':'13603',
    'HTTP_Sharepoint_Privilege_Escalation':'2124043',
    'rhel-rhsa-2007-0747-update':'10371',
    'snmpv2-discovery':'12302',
    'FTP_ProFTPD_Username_SQL_Injection':'5900002',
    'HTTP_SoftCart_Order_Info':'2106032',
    'malcode-SPNE_SC_uint21':'6608',
    'iss-host-scan':'5549',
    'CSS_String_Heap_Corruption':'2110141',
    'rpc.automountd_overflow':'10897',
    'win-ms08kb957280-update':'14690',
    'LPR_port_probe':'6078',
    'novell-iprint-unspecified-bo':'7934',
    'win-wsh-running':'14888',
    'rpc.statd overflow':'10921',
    'rhel-rhsa-2006-0742-update':'10205',
    'spyware-zorg-goldxsites':'12845',
    'msrpc-lsass-request-detected':'7292',
    'malcode-StrangeDropper1':'6732',
    'ISA_detected_possible_Window_OOB_attack':'5495',
    'rhel-rhsa-2010-0501-update':'5900002',
    'ntp-ntpd-bo':'8388',
    'UDP_Probe_Echo':'13849',
    'spyware-netster-searchbar':'12669',
    'squid-http-cache-poisoning':'12937',
    'http-cgi-ultimatebb':'3599',
    'executable-smb-file-access-attempt':'2334',
    'cisco-ios-tcp-dos':'1305',
    'decode-png-malformed':'1760',
    'Script_Firefox_MChannel_Exec':'5900002',
    'Alvgus_TCP_Request':'2113076',
    'win-dcom-remoteactivate':'14309',
    'ie-about-cookie-information':'4676',
    'malcode-SPPE_Wrt_PastEOF':'6698',
    'libgtop-format-string':'5871',
    'Alvgus_TCP_Response':'2113098',
    'HTTP_Apache_Macros_dir':'2002682',
    'rpc-snmp':'10885',
    'ip-forwarding':'5272',
    'fpse-smarthtml-interpreter-dos':'2717',
    'stumbler-trojan':'13159',
    'Land attack':'5798',
    'win-script-engine-bo':'14828',
    'MSRPC_Popup_Message':'7346',
    'ASN1_IE_CryptoAPI_Bypass':'575',
    'rhel-rhsa-2005-761-update':'10020',
    'DNS_null':'1944',
    'win-ms11kb2506223-update':'5900002',
    'kernel-ipv6-type0-dos':'5737',
    'DNS_Zone_High_Port':'1970',
    'rhel-rhsa-2004-632-update':'9781',
    'http-iis-aspdot':'3636',
    'cisco-ip-option-code-execution':'1309',
    'No_Adapters_Open':'7887',
    'DNS_Iquery':'1930',
    'win-otf-format-code-execution':'5900002',
    'Ping_of_death':'8955',
    'HTTP_Sharepoint_Help_DoS':'5900002',
    'pgp-outlook-heap-overflow':'8833',
    'rpc-bad-credentials':'10869',
    'SMB_Unicode_Filename_Overflow':'2000506',
    'PDF_Swf_Detected':'8810',
    'win-ms09kb956844-update':'14698',
    'firefox-windowopen-url-spoofing':'5900002',
    'MS_share_dump':'7241',
    'dns-hostname':'1871',
    'rhel-rhsa-2004-577-update':'9768',
    'TCP_header_fragmentation':'13413',
    'malcode-Ring4':'6484',
    'JavaScript_Large_Eval':'2110157',
    'rhel-rhsa-2008-0206-update':'10525',
    'rhel-rhsa-2005-016-update':'9804',
    'sun-jsasp-command-execution':'13229',
    'abb-robnetscanhost-bo':'5900002',
    'rhel-rhsa-2006-0708-update':'10191',
    'udp-scan':'13836',
    'rhel-rhsa-2011-1065-update':'5900002',
    'spyware-igetnet':'12609',
    'http-header-illegal-character':'3628',
    'HTTP_POST_data_contains_script':'4309',
    'DCOM_RemoteGetClassObject_DoS':'2111016',
    'excel-register-function':'2262',
    'apache-errorlog-escape-injection':'431',
    'rhel-rhsa-2010-0680-update':'5900002',
    'SNMP_bad_err_status':'12148',
    'smb-signing-not-enabled':'11729',
    'oracle-tns-listener-bo':'8575',
    'image-pattern-region-bo':'5058',
    'SNMP null in community':'12014',
    'samba-nmbd-mailslot-dos':'11271',
    'HTTP_PlanetIntra_Overflow':'2002686',
    'CGI_finger':'1183',
    'nfs-utils-offbyone-bo':'7823',
    'rsagent-user-logout':'11171',
    'nt-wins-snmp':'8372',
    'Symantec_AMS_Alert_Privilege_Escalation':'5900002',
    'HTTP_Apache_Expect_XSS':'2118082',
    'MSRPC_NetDDE_Bo':'2120057',
    'printer-sharing-read-access':'9107',
    'backdoor-ncx':'706',
    'Spyware_PH_QuickSearchBar':'2113194',
    'win-ms08kb952954-update':'14661',
    'wlluc-wlan-reveal-registry':'15146',
    'RTSP_Detected':'11215',
    'rsagent-unixroot-su':'11167',
    'yahoo-messenger-ymsgr-bo':'15323',
    'rhel-rhsa-2010-0558-update':'5900002',
    'HTTP_Softcart':'4402',
    'ebay-activex-command-execution':'2029',
    'win-ms07kb942624-update':'14613',
    'etc-hostslpd-char':'2195',
    'Mstream_Zombie_Request':'2001529',
    'Windows_URI_Command_Exec':'2122023',
    'rhel-rhsa-2006-0730-update':'10200',
    'sunlink-mapper':'13239',
    'tron-backdoor':'13795',
    'rhel-rhsa-2008-0789-update':'10580',
    'RPC_Statd_DotDot':'2001711',
    'malcode-DropIRCVirusFile':'6221',
    'win-ms10kb978213-update':'5900002',
    'rhel-rhsa-2008-0939-update':'10607',
    'NetSphere_Client':'2001527',
    'cart32-admin-password':'1104',
    'SNMP_Extension_Octet':'12202',
    'hp-nnm-openview5-bo':'3318',
    'FTP_root_login':'2990',
    'rhel-rhsa-2006-0578-update':'10148',
    'URL_contains_UTF-8_encoding':'13938',
    'rsagent-username-password':'11179',
    'SDP_Equal_Overflow':'2106300',
    'kolibri-head-bo':'5900002',
    'oracle-weblogic-plugins-code-execution':'8586',
    'rhel-rhsa-2009-0014-update':'5900002',
    'Ace_Filename_Overflow':'2121050',
    'win-ms11kb2508272-update':'5900002',
    'FTP_pwl_file_type':'2981',
    'SMB_Password_Overflow':'2000504',
    'malcode-DropperAgent3':'6231',
    'macromedia-swf-dos':'6101',
    'ie-helpactivexcontrol-save-file':'4760',
    'SSL2_Master_Key_Overflow':'2110005',
    'tomcat-acceptlanguage-xss':'13721',
    'reg-ras-auth-timelimit':'9422',
    'nt-group-create-object':'8088',
    'Solaris_D13HH_Rootkit_Login':'2116008',
    'ISA_detected_possible_UDP_bomb_attack':'5494',
    'Compaq_Insight_Fileread':'1419',
    'nfuse-launch-css':'7829',
    'boep-ypager':'961',
    'Security_disabled_universal_group_changed':'11458',
    'rpc-suspicious-credentials':'10888',
    'ftp-user-bo':'2877',
    'oracle-pitrig-dropmetadata-bo':'5900002',
    'MS_WMP_Decompress_Overflow':'2118108',
    'socks5-hostname-offbyone-bo':'12343',
    'cron-badcompath':'1540',
    'unix-setauid-by-nonadmin':'13895',
    'Itunes_Playlist_Long_URL_Overflow':'5900002',
    'malcode-WinlogonHijack':'6885',
    'rtf-embedded-exec':'5900002',
    'ms-directshow-wav-code-execution':'7170',
    'mozilla-multiple-dos':'7102',
    'http-cgi-phf':'3590',
    'backdoor-evilftp':'684',
    'ie-html-layout-code-execution':'4768',
    'rhel-rhsa-2006-0667-update':'10178',
    'man-ultimate-source-bo':'6926',
    'HTTP_Shells':'4383',
    'nt-manage-log':'8179',
    'file-not-owned-user':'2533',
    'CGI sh':'1159',
    'mediaplayer-mp3-code-execution':'6979',
    'apache-esc-seq-injection':'432',
    'MSRPC_RRaS_Reg_BO':'2118070',
    'Loadrunner_Agent_Field_Overflow':'2106280',
    'nds-user-access-rights':'7622',
    'License Rejected':'5899',
    'Privileged_operation_on_object_performed':'9108',
    'win-startup-folder-access':'14850',
    'malcode-SPMZ_Int_Tunnel':'6567',
    'sprayd':'12416',
    'Mime_Autonomy_SDK_ContentType_Bo':'7021',
    'RTSP_Helix_SetParameter_DoS':'5900002',
    'win-netdde-gain-privileges':'14803',
    'kerberos-gssrpcsvcauthunix-bo':'5700',
    'HTTP_phpBB2':'2105018',
    'rhel-rhsa-mozilla-dataurl-xss':'10713',
    'IP_Option_Linux_DoS':'2118061',
    'Sensor_shutdown':'11524',
    'win-ms07kb941672-update':'14609',
    'java-jpegjfif-privilege-escalation':'5900002',
    'apache-byterange-dos':'414',
    'SSL_V2_MySQL_Hello_Overflow':'5900002',
    'win-ms07kb927802-update':'14566',
    'MSRPC_Svcctl_Remote_Control':'2106188',
    'netscape-javascript':'7736',
    'DNS_Bind_Negative_Cache_DoS':'5900002',
    'RDP_Code_Exec':'5900002',
    'MSRPC_Pipe_SAMR_Failed':'2118032',
    'ms-sql-ms02034-update':'7211',
    'HTTP_Oracle_TimesTend_DoS':'5900002',
    'mozilla-domproperties-info-disclosure':'5900002',
    'rsagent-logonprocess-registered':'11072',
    'java-jar-jnlp-unspecified':'5900002',
    'spyware-custom-toolbar':'12507',
    'PDF_PrintSepsWithParams_Overflow':'8807',
    'win-kernel-font-code-execution':'14357',
    'Object_handle_duplicated':'8398',
    'CART32 expdate':'1103',
    'asp-http-xss':'579',
    'rservice-login-enabled':'11187',
    'nt-users-without-fullnames':'8364',
    'Borland_Interbase_Packet_Overflow':'998',
    'backdoor-phasezero':'712',
    'ftp-default':'2838',
    'bind-null-dereference-dos':'852',
    'wftpd-list-bo':'14266',
    'malcode-word6_Payload':'6905',
    'freetype-ttgload-bo':'2738',
    'ie-frame-script-execution':'4752',
    'adobe-printsepswithparams-overflow':'132',
    'iisadmin-dir-detected':'5023',
    'FTP data too long':'2791',
    'nfs-shared-root-write':'7817',
    'win-ms09kb961501-update':'14717',
    'ICMP_Subnet_Mask_Request':'2000105',
    'SMTP_WIZ_command':'11953',
    'rhel-rhsa-2004-635-update':'9783',
    'Oracle_MD2_SdoCodeSize_Bo':'2120050',
    'rhel-rhsa-2007-0981-update':'10420',
    'mssql-no-sapassword':'7418',
    'backdoor-bo2k':'668',
    'xfs-queryxbitmaps-queryxextents-bo':'15223',
    'Zip_Impossible_Compression':'5900002',
    'PAM_Configuration_Error':'5900001',
    'Sensor_Info':'11523',
    'rhel-rhsa-2010-0475-update':'5900002',
    'hp-printer-activex-code-execution':'5900002',
    'System_time_changed':'13347',
    'nt-trusted-domain':'8341',
    'HTTP_Campas':'2002506',
    'rhel-rhsa-2007-1059-update':'10447',
    'HTML_JS_Layout_Position':'2113260',
    'backdoor-unexplained10':'742',
    'mirc-privmsg-bo':'5900002',
    'malcode-SPPE4a':'6650',
    'sip-message-detected':'11627',
    'openssl-asn1-error-dos':'8486',
    'rhel-rhsa-2010-0062-update':'5900002',
    'solaris-authdes-gain-privileges':'12370',
    'rhel-rhsa-2007-0276-update':'10282',
    'PDF_CollectEmailInfo_Overflow':'8788',
    'ISS_Scan_ICMP':'2001508',
    'snmp-improper-request-handling':'12076',
    'HTML_VML_Heap_Overflow':'2106261',
    'spyware-svccpy':'12760',
    'man-myxsprintf-code-execution':'6924',
    'malcode-VB_PWStealerAOL01':'6845',
    'decod-bootp-whoami':'1676',
    'mailenable-https-bo':'6116',
    'rhel-rhsa-php-ftpputcmd-crlf-injection':'10752',
    'tivoli-smexecutewdsfsession-bo':'13711',
    'rhel-rhsa-2008-0489-update':'10559',
    'malcode-RiskWareDropper':'6495',
    'arj-archive-long-filename-detected':'555',
    'SMB_MSOffice_Groove_DLL_Hijacking':'5900002',
    'pam-smb-authentication-bo':'8710',
    'rhel-rhsa-2011-0182-update':'5900002',
    'ms-lync-dll-code-execution':'5900002',
    'javascript-unescape-obfuscation':'5599',
    'sun-java-activex-code-execution':'13205',
    'Java_Possibly_Malicious_Applet':'5900002',
    'win-otf-fd-code-execution':'5900002',
    'upx-packed-executable-detected':'13930',
    'PDF_Destroyed_Memory_Reference':'5900002',
    'FTP_data_too_long':'2909',
    'openpgp-private-key-disclosure':'8462',
    'http-cgi-phpbo':'3593',
    'rsagent-suspect-imap':'11145',
    'INN_Overflow':'5228',
    'HTTP_POST_SQL_OpenRowSet':'2113032',
    'kernel-ptinterp-info-disclosure':'5751',
    'ca-arcservebackup-tape-engine-dos':'5900002',
    'HSRP_Invalid_IPTTL':'2111011',
    'HTTP_PHPNuke_ModulesPhp_DOS':'2002671',
    'SMTP Turn':'11842',
    'spyware-mainpean-dialer':'12631',
    'squirrelmail-compose-csrf':'12952',
    'win-ms08kb959807-update':'14696',
    'ISA_PF_Insecure_Config':'5510',
    'Security_disabled_global_group_created':'11449',
    'isa-scs-init-failed':'5467',
    'win-smb-rename-dos':'5900002',
    'ident-version-scan':'4656',
    'MSRPC_WksSvc_Mgmnt_Bo':'2110034',
    'cddbd-detect':'1112',
    'openssh-sftp-bypass-restrictions':'8478',
    'YahooMSG_URL_Handler_Overflow':'2113012',
    'win-nntp-bo':'14804',
    'TCP_Within_Window_DoS':'2120024',
    'HTTP_Java_Class':'4107',
    'ssh2-login-general':'12994',
    'malcode-DeleteSystemFolder':'6201',
    'ftp-epsv-command':'2840',
    'bind-sigrecord-dos':'861',
    'Telnet many AYTs':'13517',
    'rhel-rhsa-php-superglobal-dos':'10757',
    'malcode-NETrojan3':'6386',
    'malcode-NETrojan0':'6384',
    'nt-process-audit-failure':'8247',
    'QuickTime_DirectShow_Pointer_Code_Execution':'9264',
    'ldap-null-fields':'5823',
    'ms-sp6-installation-dos':'7209',
    'JBIG2_Adobe_Index_Error':'5659',
    'User_account_enabled':'14031',
    'Proventia_Network_Mail_Security_System__1.0':'9145',
    'rsagent-ssh-connection-host':'11117',
    'SMB_MDAC_Bidlab_DLL_Hijacking':'5900002',
    'rhel-rhsa-2002-130-update':'9519',
    'groupwise-messenger-client-bo':'5900002',
    'imsecure-present':'5192',
    'rhel-rhsa-2010-0922-update':'5900002',
    'win-ms08kb950582-update':'14648',
    'rhel-rhsa-2010-0625-update':'5900002',
    'LDAP_Distinguished_Name_Overflow':'2107016',
    'Oracle_MD2_ValidateGeom_Bo':'2120051',
    'projectnext-backdoor':'9127',
    'rlogin login failed':'10795',
    'malcode-IRCUnexpectedSendFile':'6360',
    'FTP_FileName_Bdl':'2003607',
    'VmPoweredOffEvent':'14128',
    'php-print-odbcresultall-format-string':'8896',
    'SMB_WinScript_DLL_Hijacking':'5900002',
    'FAX_Coversheet_Detected':'5900002',
    'scada-modbus-ack-exception':'11323',
    'aix-iy75283-fix':'243',
    'rational-architect-activebar-ce':'5900002',
    'ICMP_Redirect':'4616',
    'decod-snmp-commstr':'1745',
    'rhel-rhsa-2005-564-update':'9981',
    'leadtools-browsedir-dos':'5900002',
    'DNS_Hostname_Overflow_Verylong':'2000423',
    'SIP_0_Response_Code':'2114048',
    'camshot-http-get-overflow':'1095',
    'mdaemon-smtp-bo':'6966',
    'icqtoolbar-toolbaru-dos':'4637',
    'URL ends with ~':'13935',
    'ip-dup':'5271',
    'snmp-bad-generic-trap':'12044',
    'ssreader-register-bo':'13120',
    'rhel-rhsa-2004-466-update':'9751',
    'HTML_Exploit_Fingerprint':'5900002',
    'Radius_Generic_Intel_Overflow':'2104009',
    'win-ms11kb2485663-update':'5900002',
    'nt-critical-key-permissions':'8028',
    'desktopcontroller-info':'1774',
    'cisco-remote-services-enabled':'1318',
    'malcode-Pretender2':'6428',
    'mysql-remote-access':'7528',
    'HTTP_ColdFusion_Expr_Evaluator':'2002554',
    'TCP_Probe_Other':'13444',
    'rhel-rhsa-2009-0297-update':'10627',
    'FTP_Port_Very_Long':'2001343',
    'win-ms07kb943460-update':'14616',
    'rhel-rhsa-2007-0344-update':'10292',
    'nt-dnsver':'8049',
    'SMTP_uucp-style_recipient':'11949',
    'ppstream-powerplayer-bo':'9090',
    'rhel-rhsa-2005-773-update':'10029',
    'SOCKS over SOCKS':'12328',
    'win-ms08kb960714-update':'14697',
    'win-ms08kb943485-update':'14626',
    'adobe-acrobat-acropdf-code-execution':'5900002',
    'ms-owc-datasourcecontrol-dos':'7195',
    'SMTP uucp-style recipient':'11843',
    'TNEF_MsgClass_Attribute_DoS':'5900002',
    'aix-iy67136-fix':'207',
    'rhel-rhsa-2008-0897-update':'10602',
    'CGI newdsn.exe':'1151',
    'Unify UploadServlet':'13885',
    'iis-exec-command':'4928',
    'sizerone-tab-bo':'11679',
    'JavaScript_Mozilla_LoadSubScript_Abuse':'5626',
    'openssh-scp-command-execution':'8476',
    'RPC_BrightStor_ARCserve_String_DoS':'5900002',
    'h323-traffic-detected':'3245',
    'mediaplayer-asx-bo':'6977',
    'FrontPage htimage.exe URL':'2746',
    'rpc-mountd-enabled':'10877',
    'gnupg-multiple-statusfd-security-bypass':'3137',
    'mgcp-long-field-bo':'6995',
    'HTML_Win32k_Iframe_Exec':'5900002',
    'telnet-auth-rsa':'13529',
    'rhel-rhsa-2003-177-update':'9605',
    'apache-cgi-modules':'416',
    'malcode-ExeSeq49':'6291',
    'rhel-rhsa-2008-0834-update':'5900002',
    'snmp-conf-community':'12055',
    'malcode-ExeSeq46':'6288',
    'malcode-ExeSeq45':'6287',
    'HTTP_Winamp_Detected':'4526',
    'ISA_PF_IP_PF_Create_Failure':'5512',
    'HTTP_Propfind_Very_Long':'2000642',
    'SnidX2_Response':'2001580',
    'cwdleak':'1588',
    'HTTP_GET_SQL_Select_Count':'2110109',
    'rhel-rhsa-2006-0160-update':'10082',
    'BrightStor_Discovery_Hostname_Overflow':'5900002',
    'rhel-rhsa-2003-048-update':'9572',
    'igss-rms-bo':'5900002',
    'spyware-hotbar':'12590',
    'ie-https-proxy-information-disclosure':'4772',
    'win-ms11kb2617657-update':'5900002',
    'http-password':'3658',
    'win-ms10kb2423089-update':'5900002',
    'JavaScript_Suspicious_MethodCall':'5900002',
    'win-ms05kb905495-update':'14461',
    'iis-frontpage-info':'4930',
    'win-ms06kb920670-update':'14520',
    'meetthelamer-backdoor':'6983',
    'malcode-AggressiveCode2':'6133',
    'rhel-rhsa-2011-1479-update':'5900002',
    'Image_GIF_GDI_Parsing':'5080',
    'rpc.nisd_long_name':'10911',
    'fsecure-activexcontrol-buffer-overflow':'5900002',
    'HTTP_IE_rpawinet_DLL_Hijacking':'5900002',
    'inetd-frozen':'5203',
    'ascend-config-kill':'563',
    'script-temporary-file-overwrite':'11378',
    'quicktime-itunes-mov-bo':'9232',
    'malcode-SPCOM_MBR_Poly':'6549',
    'ms-smb-protocol-code-exec':'5900002',
    'rhel-rhsa-2007-0672-update':'10349',
    'rhel-rhsa-2007-0875-update':'10387',
    'cisco-csdwebinstaller-code-execution':'5900002',
    'linux-drivers-gain-privileges':'5925',
    'nt-unencrypted-pwd-smb':'8342',
    'kernel-fput-ioctl-dos':'5733',
    'malcode-HTMLHidingItself':'6331',
    'ibm-db2-das-server-bo':'5900002',
    'itunes-itms-bo':'5569',
    'spyware-virtualbouncer':'12793',
    'http-gotomypcdotcom-connection':'3626',
    'nt-netbios-shareguest':'8205',
    'FTP_Oracle_XML_Test_Overflow':'5900002',
    'backdoor-backconstruction':'663',
    'ms-sql-slammer-patch':'7214',
    'nt-eventlog-systemlog':'8068',
    'wu-ftpd-exec':'15182',
    'file-acls-perm-check':'2459',
    'lotus-domino-icalendar-bo':'5900002',
    'win-shadowscan-present':'14836',
    'win-messenger-popup-bo':'14384',
    'ie-tif-draganddrop-information-disclosure':'4851',
    'malcode-GenericDropper2':'6312',
    'malcode-GenericDropper3':'6313',
    'malcode-GenericDropper0':'6310',
    'malcode-GenericDropper1':'6311',
    'malcode-GenericDropper6':'6316',
    'ldap-config':'5815',
    'malcode-GenericDropper4':'6314',
    'win-ms08kb950749-update':'14649',
    'spyware-tps108':'12775',
    'Napster_Command_Long':'7560',
    'NDMP_Veritas_BackupExec_Auth_Overflow':'2113206',
    'waledac-worm-detected':'14198',
    'rhel-rhsa-2008-0364-update':'10556',
    'ICMP subnet mask request':'4595',
    'NetBIOS_Name_Service_Malformed':'5900002',
    'sip-request-uri-dos':'11631',
    'rhel-rhsa-2003-419-update':'9651',
    'ISA_Server_Init_Failed_Corrupt':'5518',
    'win-ms08kb950183-update':'14647',
    'Java_Scripting_Privilege_Escalation':'5900002',
    'HTTP_OpenView_NNM_CgiArg_Overflow':'2101067',
    'yahoo-mediagrid-bo':'15313',
    'nt-guest-enabled':'8125',
    'sun-jre-activex-code-execution':'13215',
    'FW1_Auth_Replay':'2103014',
    'rhel-rhsa-2011-0885-update':'5900002',
    'Content_RAR_Missing_Extension':'1515',
    'win-dde-elevate-privileges':'14311',
    'RPC_KCMS_File_Retrieval':'2118002',
    'exploit-ArchiveSizeUnderflow(100033)':'2342',
    'cgi-perl-mail-programs':'1173',
    'lprng-supplementary-groups':'6081',
    'YaBB_exploit':'15309',
    'snmp-length-underflow':'12085',
    'SNMP_InvalidTag_VarBindList':'2106091',
    'isa-failed-to-start':'5440',
    'http-cgi-cgiproc-file-read':'3565',
    'hpsoftware-rulesengine-file-overwrite':'3344',
    'HTTP_GET_contains_group%by':'3935',
    'malcode-Susp_SYS_SearchFile':'6777',
    'spyware-zyncosmark':'12847',
    'file-preconf-overwritten':'2539',
    'gnu-mailutils-imap4d-format-string':'5900002',
    'rhel-rhsa-2007-1026-update':'10433',
    'HP_DP_Cell_Manager_DoS':'5900002',
    'rhel-rhsa-2007-1063-update':'10448',
    'Incremental_Baseline_Started':'5198',
    'file-dir-ww-owner':'2493',
    'sql-slammer-worm':'12889',
    'excelviewer-activex-open-bo':'2273',
    'rhel-rhsa-2005-128-update':'9857',
    'rc-command-owner':'9326',
    'sinadloader-activex-file-overwrite':'11611',
    'rsagent-ssh-kerberos-passauthfailed':'11127',
    'rhel-rhsa-2003-408-update':'9650',
    'ssl-certificate-self-signed':'13078',
    'rhel-rhsa-2009-0358-update':'10645',
    'nt-backup-operator-blankpwd':'7995',
    'rhel-rhsa-2005-518-update':'9971',
    'rhel-rhsa-openssh-signal-handler-race-cond':'10746',
    'Kika_TCP_Request':'2113152',
    'kernel-audit-dos':'5720',
    'ISS scan':'5547',
    'rhel-rhsa-2008-0059-update':'10485',
    'Blazer5_Response':'2001542',
    'Whisker_URL_fingerprint':'14280',
    'Suspect_Whois':'13271',
    'rhel-rhsa-2007-0829-update':'10379',
    'win-ms11kb2451858-update':'5900002',
    'socks-connect':'12330',
    'FTP_NLST_Overflow':'2001319',
    'Tivoli_LCF_File_Read':'2102027',
    'sambar-batfiles':'11286',
    'RADIUS_User_Overflow':'9298',
    'flash-activex-information-disclosure':'5900002',
    'php-exifreaddata-bo':'8854',
    'win-ms06kb922968-update':'14532',
    'way-board cgi file access':'14207',
    'rhel-rhsa-2007-0073-update':'10237',
    'IPOP3D_Overflow':'5334',
    'FTP_Cwd_Root':'2001304',
    'excelviewer-save-file-overwrite':'2276',
    'IPOP3D_user_logout':'5340',
    'adobe-illustrator-eps-bo':'128',
    'TCP_Service_Sweep':'2103006',
    'HTTP_Count':'2002588',
    'rhel-rhsa-2005-878-update':'10066',
    'tls-renegotiation-weak-security':'13715',
    'rhel-rhsa-2009-1287-update':'5900002',
    'sip-unknown-method-name':'11637',
    'service-deleted':'11546',
    'POP3_port_probe':'9014',
    'FTP_Data_Overflow':'2001318',
    'SAMETIME_Login':'11293',
    'php-memorylimit-code-execution':'8879',
    'rhel-rhsa-2002-129-update':'9518',
    'rhel-rhsa-2007-0539-update':'10336',
    'win2k-add-sid-failure':'14898',
    'rsagent-config-logfiles-deleted':'11020',
    'win-ms09kb960803-update':'14712',
    'mail-suspicious-zip-exe':'6109',
    'lotusinotes-dwa85w-bo':'5900002',
    'HTTP_MaxDB_websql_BO':'2118025',
    'WRF_ATAS_BB_Subrecords_Integer_Overflow':'5900002',
    'Winny_P2P_Detected':'15070',
    'cisco-snmp-improper-trap-handling':'1323',
    'BackOrifice2K_UDP_Auth_Response':'2100017',
    'nfs-mount':'7803',
    'scada-modbus-slavebusy':'11331',
    'amavis-command-execute':'343',
    'rhel-rhsa-2006-0749-update':'10207',
    'DNS NXT record overflow':'1855',
    'ypserv-nis-dos':'15355',
    'FTP_Long_MKD':'2121005',
    'malcode-SPCOM_WrtDev':'6551',
    'SMTP Expn Overflow':'11817',
    'rhel-rhsa-2006-0594-update':'10152',
    'backdoor-hackatack':'693',
    'source-routing':'12410',
    'konik-backdoor':'5789',
    'Worm_extensions':'15171',
    'nds-user-logon-script-rights':'7631',
    'FTP pipe in filename':'2807',
    'ms-ie-memory-info-disc':'5900002',
    'Image_EMF_Integer_Overflow':'2104050',
    'JavaScript_Suspicious_Hex_String':'5645',
    'Swf_ActionScript2_Contingent_Range':'5900002',
    'Email_Almail_Overflow':'2001048',
    'TheRevenger_Request':'2113059',
    'rhel-rhsa-2006-0668-update':'10179',
    'gssl-3lib-gssapi-gain-privileges':'3192',
    'win-sspi-credential-forwarding':'14849',
    'rhel-rhsa-2008-0825-update':'5900002',
    'reg-assoc-changed':'9394',
    'AntiSniff DNS Exploit':'369',
    'win-ms09kb960477-update':'14710',
    'rhel-sendmail-ssl2-weak-security':'10774',
    'blackice-application-compliance-warning':'908',
    'file-cgi':'2468',
    'bittorrent-dht-findnode-detected':'884',
    'php-multipart-handler-bo':'8881',
    'backdoor-chupacabra':'670',
    'EvilFTP trojan horse activity':'2237',
    'Cybercop_FTP_scan':'1591',
    'libesmtp-smtp-readsmtpresponse-bo':'5869',
    'HTTP_OpenView_NNM_getnnmdata_Overflow':'5900002',
    'kerberos-processtgsreq-code-execution':'5900002',
    'frontpage-extension-directory-vtibin-present':'2758',
    'Edonkey_Session_Detected':'2054',
    'backdoor-aol-admin':'661',
    'permissions-generous':'8829',
    'windows-rdp-dos':'15027',
    'HTTP_ColdFusion_ViewExample':'2002619',
    'audit-events-exist':'599',
    'DNS_NAPTR_Overflow':'5900002',
    'SMTP_Loopback_Bounce':'2001054',
    'malcode-ScriptInstallCheck':'6506',
    'malcode-W32_Trojan':'6871',
    'win-ms09kb957634-update':'14701',
    'TelnetAuthKerb5':'13598',
    'TelnetAuthKerb4':'13597',
    'rhel-rhsa-2006-0354-update':'10117',
    'HTTP_OracleApp_XSQL':'2105022',
    'AVI_Very_Large':'630',
    'http-nuclear-notification':'3656',
    'HTTP_IE_ShellExecute':'2120034',
    'SSH2_Pubkey_auth_successful':'13024',
    'SMTP_Reply-to_exec':'11936',
    'malcode-Odd_ThreadExec2':'6393',
    'rhel-rhsa-2004-408-update':'9730',
    'Telnet_Excessive_Tabs':'2103003',
    'Application Compliance Error':'504',
    'flash-air-data-code-execution':'5900002',
    'SNMP_Set':'2104018',
    'win-ms08kb941693-update':'14623',
    'user-password-invalid':'14000',
    'Image_Halftone_Corruption':'5087',
    'iis-isapi-printer-bo':'4958',
    'micq-0xfe-dos':'7002',
    'cisco-catalyst-crash':'1266',
    'linux-sctp-control-chunk-dos':'5966',
    'win-ms11kb2555917-update':'5900002',
    'rhel-rhsa-2002-224-update':'9540',
    'Flac_Metadata_Block_BO':'2124000',
    'zenworks-uploadservelet-code-execution':'5900002',
    'PDF_Launch_Program':'5900002',
    'CompoundFile_Office_Document_CodeExec':'2106266',
    'SMTP_Probe_Root':'2111009',
    'start-shutdown-enabled':'13131',
    'rpc-update':'10891',
    'HTTP_PHP_Script_Injection':'2110177',
    'isa-tmg-packet-dos':'5474',
    'ISAKMP_Hdr_BadVersion':'5535',
    'wireshark-nfs-bo-win':'15128',
    'remotelypossible32-installed':'9478',
    'http-cgi-campas':'3561',
    'malcode-Keylogger1':'6368',
    'malcode-Keylogger0':'6367',
    'HTTP_HCP_Code_Execution':'2113075',
    'DNS_Internet_not_4_bytes':'1925',
    'ftp-command-argument-bo':'2834',
    'TCP_Probe_Socks':'13450',
    'win2k-authticket-granted':'14900',
    'malcode-AssumedIRC':'6140',
    'nt-registry-insecure':'8272',
    'ms-iis-request-header-bo':'5900002',
    'webmoney-activex-dos':'5900002',
    'openssh-pam-info-leak':'8474',
    'DNS_DNSSEC_Type_Mismatch':'2106190',
    'Y3K trojan horse activity':'15296',
    'orinoco-as-closed-system-off':'8624',
    'spyware-holysticdialer':'12587',
    'spyware-dial-xs':'12517',
    'aix-iy53673-fix':'171',
    'UserLogoutSessionEvent':'14045',
    'atl-activex-bo':'592',
    'rhel-rhsa-2005-283-update':'9887',
    'quicktime-media-link-detected':'9236',
    'ISA_conn_rejected_exceeded_max_limit_for_rule':'5485',
    'rhel-rhsa-2006-0232-update':'10100',
    'udp-flood':'13834',
    'rhel-rhsa-2007-0065-update':'10232',
    'ie-frame-restrictions-bypass':'4751',
    'HTTP_Post_LanDesk_FileUpload':'5900002',
    'http-cgi-bigbrother-bbhostsvc':'3556',
    'ISA_Abnormal_Termination':'5481',
    'malcode-Downloader7':'6218',
    'word-parsing-code-execution':'15154',
    'backdoor-codered2':'671',
    'rhel-rhsa-2003-119-update':'9593',
    'malcode-Downloader4':'6215',
    'javase-javab-mixersequencer-ce':'5900002',
    'rhel-rhsa-2009-1662-update':'5900002',
    'rsagent-mssql65-shutdown':'11077',
    'rhel-rhsa-2006-0156-update':'10079',
    'IPP_Detected':'5344',
    'hp-openview-data-ce':'5900002',
    'win-media-asf-bo':'14370',
    'adobe-swf-code-execution':'139',
    'ISAKMP_SPI_Overflow':'2107018',
    'rhel-rhsa-2012-0434-update':'5900002',
    'rhel-rhsa-2006-0045-update':'10072',
    'nt-passfilt-not-inst':'8226',
    'irdp-gateway-spoof':'5413',
    'HTTP_CONNECTION__field_overflow':'3862',
    'SNMP_Long_OID':'2106114',
    'word-unspec-code-execution':'15159',
    'win-ms09kb973908-update':'14757',
    'trillian-aim-bo':'13757',
    'dcshop-cgi-retrieve-information':'1671',
    'spyware-dssagent':'12531',
    'win-rdp-packet-dos':'14816',
    'FTP_Virus_Suspicious_Zip':'2110142',
    'sensitive-information-network-traverse':'11519',
    'mozilla-webgl-bo':'5900002',
    'ie-cookie-script-access':'4720',
    'spyware-globalcs-dialer':'12573',
    'image-dictionary-bo':'5055',
    'SMB_Printing_Mem_Alloc':'2114132',
    'OSPF_Lnk_State_Req_Multicast':'8659',
    'libxml2-notation-enumeration-dos':'5900002',
    'rsh-equiv':'11195',
    'BrightStor_BackupAgent_Overflow':'2113211',
    'spyware-ietop100':'12607',
    'sun-java-webstart-javaws-bo':'13212',
    'SNMP unknown tag':'12034',
    'SpyEye_Trojan_CnC':'5900002',
    'LeGuardien_TCP_Request':'2113118',
    'malcode-Uninstaller':'6805',
    'win-service-user-detected':'14835',
    'rhel-rhsa-2007-1020-update':'10427',
    'pine-tmp-file-symlink':'8947',
    'SNMP_Bad_Header':'12154',
    'rhel-rhsa-2010-0659-update':'5900002',
    'win-pgm-bo':'14808',
    'SoftCart password URL':'12355',
    'malcode-SPPE_RsrcExec_Poly_B':'6688',
    'apache-dos-batch-command-execution':'427',
    'SNMP_InvalidTag_Community':'2106076',
    'FTP_Site_Chown_Overflow':'2001327',
    'ebcrypt-ebcprngenerator-dos':'2030',
    'HTTP_SCO_View_Source':'2002532',
    'anonftp-shadow':'363',
    'spyware-promulgate':'12697',
    'cisco-password-unencrypted-config':'1316',
    'plotlinecontrol-activex-overflow':'5900002',
    'HTTP_Pfdisplay_Execute':'4259',
    'Veritas_VEA_Overflow':'14076',
    'SNMP bad generic trap':'11973',
    'tdfc-smaliases-05':'13492',
    'ie-speech-code-execution':'4843',
    'anonftp-home-owner':'359',
    'rhel-rhsa-2005-806-update':'10042',
    'squid-ftp-dir-bo':'12932',
    'rhel-rhsa-2009-0331-update':'10632',
    'RPC UDP port probe':'10864',
    'wireshark-http-dos':'15118',
    'rhel-rhsa-2009-0295-update':'10625',
    'SMTP_command_overflow':'11889',
    'VNC no authentication':'14152',
    'Michal_TCP_Response':'2113044',
    'Arp':'560',
    'ISAKMP_Vendor_Id':'5539',
    'malcode-Susp_MBR_Cmos2':'6765',
    'rhel-rhsa-2009-0981-update':'10659',
    'LPRng_Format_String':'2100030',
    'spyware-spediabar':'12745',
    'ssh2-pubkey-auth-failed-root':'12999',
    'chilkatxml-chilkatutil-file-overwrite':'1242',
    'telnet-login-name-audit':'13541',
    'adobe-fonts-code-execution':'5900002',
    'PDF_Invalid_Reference_Version':'8800',
    'win-ms11kb2475792-update':'5900002',
    'Satan':'11308',
    'malcode-SPNE_exe_cpy_self':'6591',
    'malcode-WritesToSelf':'6913',
    'POP_QPopAuth_Overflow':'2000705',
    'nds-user-template-account-expiry':'7645',
    'HTTP_Apache_ModUserDir_Disclosure':'2113045',
    'malcode-SendEmailFromAutoProc':'6512',
    'Back Orifice response':'647',
    'online-virus-activex-bo':'5900002',
    'snmpv1-discovery':'12301',
    'QuickTime_VR_Panoramic_Sample_Overflow':'9275',
    'Teardrop_attack':'13501',
    'ie-hta-fileshare-command-execution':'4762',
    'Email_Mime_Header_Overflow':'2113250',
    'SNMP_Int_Underflow':'2106095',
    'housecall-library-code-execution':'3296',
    'ezshopper-loadpage-cgi':'2411',
    'malcode-InappropriateRPC':'6342',
    'mozilla-xulpopups-spoofing':'7145',
    'Sslvpn_TCP_Close':'13111',
    'FTP_Commands_With_Binary':'2110026',
    'pingtunnel-traffic-detected':'8959',
    'foxitreader-pdf-authentication-bypass':'2707',
    'create-file-baseline':'1531',
    'isa-wps-terminated':'5480',
    'skincrafter-activex-control-bo':'5900002',
    'malcode-Dropola':'6223',
    'broadwin-activex-format-string':'5900002',
    'ibm-wte-helpout-dos':'4583',
    'medium-vulnerability-event':'6982',
    'win-ms06kb905758-update':'14476',
    'mydoom-sco-synflood':'7501',
    'rhel-rhsa-2005-756-update':'10019',
    'VNC_HTTP_Get_Overflow':'2102012',
    'mcafee-virusscan-detected':'6950',
    'spyware-netword-agent':'12671',
    'VNC_RealVNC_Auth_Bypass':'2118065',
    'rhel-rhsa-2009-1659-update':'5900002',
    'netscape-enterprise-http-method-bo':'7726',
    'snmp-get-any':'12072',
    'H323_Detected':'3246',
    'novell-iprint-getdriverfile-bo':'7924',
    'exploit-MSExcel(100036)':'2355',
    'SNMP oid underflow':'12017',
    'apache-modrewrite-offbyone-bo':'457',
    'Authentication_ticket_granted':'611',
    'acrobat-reader-jpxdecode-code-exec':'50',
    'malcode-Susp12':'6738',
    'malcode-Susp10':'6737',
    'helixserver-dataconvertbuffer-bo':'5900002',
    'adobe-shockwave-tsac-code-execution':'5900002',
    'RedHat_LPD_Print_Control':'2100029',
    'mozilla-javascript-code-exec':'5900002',
    'first4internetdrm-sony-rootkit':'2662',
    'iplanet-running':'5313',
    'RIFF_4XM_Track_Overflow':'5900002',
    'perl-fingerd':'8828',
    'Telnet_Env_Termcap':'2000911',
    'yahoo-messenger-script-injection':'15321',
    'Balistix_Request':'2113081',
    'win-hsc-hcp-bo':'14341',
    'Application_Terminated':'531',
    'Allaire_JRun_WebInf_SlashSlash':'2004902',
    'application-unauth-admin-access':'520',
    'TLS_Zero_Length_Record':'5900002',
    'win-ms10kb977290-update':'14780',
    'SMTP false attachment':'11818',
    'ca-dos-detected':'1075',
    'WhatsUp_scan':'14277',
    'malcode-IRCUnexpectedRun':'6359',
    'ethereal-x11-dissector-bo':'2216',
    'compaq-insightmanager-taglist-disclosure':'1414',
    'backdoor-frenzy':'687',
    'edirectory-acceptlanguage-bo':'2045',
    'kernel-cmtprecvinteropmsg-bo':'5726',
    'postgresql-fetch-makefetchstmt-bo':'9067',
    'ethereal-rsvp-dissector-dos':'2210',
    'Scada_Modbus_ReportSlaveID':'11346',
    'WindowsMedia_Voice_Sample_Rate_RCE':'15047',
    'POP_MS_MailClient_Overflow':'5900002',
    'HTTP_Generic_Intel_Overflow':'2104008',
    'TFTP_Invalid_Blksize':'5900002',
    'FIX_Suspicious_MessageType':'2104028',
    'NetworkTerrorist_TCP_Response':'2113139',
    'malcode-PasswordStealer':'6424',
    'Trojan_Prorat':'13791',
    'http-activeweb':'3547',
    'HTTP_Netscape_URI_Overflow':'2106002',
    'RPC_Statd_Automount_Exec':'2001716',
    'ca-arcservebackup-netbackup-file-upload':'1069',
    'malcode-SPPE_Pack_Misc':'6685',
    'win-wmf-bo':'14882',
    'ovnnm-getproxiedstorageaddress-bo':'5900002',
    'Win_IP_Src_Route':'2000023',
    '3com-firmware-setup-web-access':'18',
    'SNMP_bad_version_size':'12172',
    'malcode-AggressiveCode':'6132',
    'file-cronat-owned':'2472',
    'object-handle-duplicated':'8396',
    'iconaspa-downloaderactivex-code-execution':'4628',
    'mysql-dateformat-format-string':'5900002',
    'HTTP_Quicktime_RTSP_Overflow':'2118088',
    'google-chrome-focus-dos':'5900002',
    'telnet-default':'13536',
    'SMB_Empty_Password_Failed':'11746',
    'win-ms05kb885834-update':'14426',
    'HTTP_Webinf_Dot_FileRetrieval':'2106156',
    'powerpoint-pp7x32-dll-ce':'5900002',
    'file-cronat-owner':'2473',
    'nt-domain-admin-blankpwd':'8050',
    'symantec-multiple-firewall-patch':'13310',
    'traceroute':'13747',
    'cisco-ipsource-routing-enabled':'1310',
    'AntiSniff_DNS_Test':'2106005',
    'nt-file-stream':'8072',
    'Finger forwarding overflow':'2578',
    'user-account-created':'13946',
    'Symantec_AMS_Alert_DoS':'5900002',
    'passport-verbose-mode-exposure':'8730',
    'FTP HELP Overflow':'2796',
    'sql-injection-select':'12882',
    'rhel-rhsa-2009-1154-update':'10675',
    'spyware-bdsearch-plugin':'12459',
    'wireshark-dhcp-dos-win':'15112',
    'flexcell-grid-activex-file-overwrite':'2685',
    'Telnet_Auth_Loki':'13553',
    'irc-bitchx-dns-bo':'5375',
    'nds-user-account-disabled':'7623',
    'wins-memory-pointer-hijack':'15075',
    'rsagent-ssh-connection-user':'11118',
    'brightstor-discovery-bo':'1004',
    'Order Form data URL':'8617',
    'mozilla-auto-update-dns-spoofing':'7059',
    'iis-https-reveal-address':'4945',
    'Statd_DotDot':'13145',
    'spyware-rads01-quadrogram':'12705',
    'linuxconf-port-probe':'5990',
    'edraw-viewer-officeviewer-bo':'2057',
    'isa-spoof-attack-detected':'5472',
    'rlogin-spoof':'10807',
    'HTTP_Mailsite_Wconsole':'2002583',
    'win-mailslot-bo':'14367',
    'HTTP_Frontpage_Extensions_RAD_Overflow':'2002624',
    'ISS_UDP_scan':'5564',
    'http-cgi-webwhoplus':'3604',
    'active-directory-sd-propagator-terminated':'74',
    'malcode-PackedDaemon':'6416',
    'rhel-rhsa-2007-0951-update':'10406',
    'rhel-rhsa-2005-304-update':'9892',
    'spyware-whenusearch-toolbar':'12809',
    'xinetd-rejected-connections-dos':'15230',
    'netscape-enterprise-revlog-dos':'7729',
    'backupexec-remoteagent-security-bypass':'778',
    'rhel-rhsa-2004-674-update':'9790',
    'Email_Mime_Name_Overflow':'2102021',
    'TCP_sequence_out-of-range':'13459',
    'malcode-SPTRJ_Inet_srch_srv':'6720',
    'logmein-ractrl-bo':'6028',
    'SNMP_Cisco_Passwd':'2002017',
    'malcode-SPNE_100b_ZM':'6580',
    'user-login-shell-exec':'13982',
    'rhel-rhsa-2009-0326-update':'10631',
    'generic-heuristic':'3074',
    'win-ms10kb980094-update':'5900002',
    'nt-dcom-default-access':'8033',
    'cisco-snmp-vacm':'1324',
    'VRTSWeb_Validation_Error':'5900002',
    'HTTP_GET_DotDot_Data':'2000609',
    'thunderbird-mimetypes-bo':'13697',
    'serverprotect-tmregchange-bo':'11540',
    'pxe-dhcp-dos':'9165',
    'frozen-file-changed':'2770',
    'chargen-inetd':'1227',
    'CGI perl':'1154',
    'alcatel-tftp-wan-access':'306',
    'nt-guessed-powerwd':'8122',
    'rhel-rhsa-2007-0848-update':'10382',
    'hp-instantsupport-movefile-bo':'3310',
    'movemedia-quantum-streaming-bo':'7054',
    'rhel-rhsa-2010-0544-update':'5900002',
    'network-terrorist-backdoor':'7778',
    'exploit-MSVisio(100034)':'2370',
    'ca-version-detected':'1085',
    'rhel-rhsa-2002-214-update':'9537',
    'Balistix_Response':'2113082',
    'HTTP POST win.ini file':'3528',
    'netscape-enterprise-uri-bo':'7730',
    'spyware-404search':'12420',
    'SNMP varbind underflow':'12037',
    'chargen-patch':'1228',
    'file-all-permissions':'2461',
    'Swf_ActionScript2_Range':'5900002',
    'linux-sctp-ecne-chunk-dos':'5967',
    'iis-server-exec':'4985',
    'win-ms11kb2566454-update':'5900002',
    'SMTP_Groupwise_Code_Exec':'11908',
    'gia-email-code-execution':'3088',
    'frozen-file-acl-changed':'2768',
    'ICMP_Timestamp_Request':'2000113',
    'v5password':'14060',
    'ToolTalk_Overflow':'13738',
    'keyworks-keyhelp-activex-bo':'5777',
    'HTML_RavWare_Mas_Flic_Overflow':'3453',
    'is-scan-started':'5422',
    'IPOP3D_user_kiss_of_death_logout':'5336',
    'malcode-SPPE_Move_Spawn':'6683',
    'Too much IP fragmentation':'13733',
    'rhel-rhsa-2007-0013-update':'10219',
    'up2date-migration-dos':'13914',
    'icecast-format-string':'4590',
    'CompoundFile_Excel_Header_Overflow':'1429',
    'http-cgi-info2www':'3582',
    'kernel-doipv6setsockopt-dos':'5729',
    'Schwindler_Response':'2001577',
    'win-ms12kb2643584-update':'5900002',
    'IP microfragment':'5267',
    'Email_GoodTech_MultipleRcpt_Bo':'2118043',
    'HTTP_Cross_Site_Scripting':'2004201',
    'nds-print-queue-operators':'7614',
    'CHM_DirChunkSize_Bo':'2118039',
    'HTTP_MSOfficeGroove_DLL_Hijacking':'5900002',
    'imail-ldap-tag-bo':'5130',
    'FW1_GetTopology':'2103015',
    'anonftp-file-owner':'356',
    'GateCrasher_trojan_horse_activity':'3056',
    'NetSpy':'7754',
    'excel-datetime-bo':'2254',
    'iis-url-redirection-dos':'4999',
    'shell-path-missing':'11590',
    'HTTP_IE_Help_Overflow':'2113024',
    'dragon-fire-ids-metachar':'2005',
    'rhel-rhsa-2008-0261-update':'10543',
    'ssl-premaster-information-leak':'13084',
    'DNS_Zero_Size_UDP':'2000426',
    'sunjavasystem-asp-server-bo':'13238',
    'SAM_notification_package_loaded':'11263',
    'win-ms12kb2709162-update':'5900002',
    'uucp-root-permissions':'14057',
    'exchange-msg-attribute-dos':'2289',
    'tracking-audit-events':'13748',
    'Failed_login-not_authorized_for_console_login':'2428',
    'wu-ftpd-dir-name':'15181',
    'linux-nfs3xdr-packet-dos':'5951',
    'SSH_command_execution':'13034',
    'HTTP_GETargscript':'2000640',
    'CGI mlog.html':'1149',
    'rhel-rhsa-2010-0987-update':'5900002',
    'ASX_WindowsMedia_Playlist_Overflow':'2114026',
    'win-ms08kb955047-update':'14674',
    'SMB_Samba_Transaction2_bo':'2118004',
    'oracle-instantiateoffline-bo':'8556',
    'HTTP_Netmail_WebAdmin_Overflow':'2114012',
    'zenturi-programchecker-fill-bo':'15361',
    'excel-fngroupcount-bo':'2255',
    'altirix-express-activex-code-execution':'334',
    'VOIP_Account_Without_Passwd':'14173',
    'SDP_Long_Value':'2106295',
    'http-indexserver-dirtrans':'3642',
    'rhel-rhsa-2005-417-update':'9943',
    'SoftEther_Hub_Administration':'12359',
    'ISA_suspect_IP_addr_assign_to_demand_dial':'5520',
    'chrome-autocomplete-entries-unspecified':'5900002',
    'IMAP4 Attack':'5148',
    'snmp-show-interfaces':'12108',
    'win2k-telnetserver-dos':'14980',
    'W97M.Marker.a_virus':'14196',
    'cisco-aironet-broadcast-ssid':'1256',
    'oracle-jre-deserialization-unspecified':'5900002',
    'oscar-password-change':'8635',
    'cobalt-raq-service-dos':'1377',
    'Suspicious_router_advertisement':'13277',
    'paltalk-activex-file-overwrite':'5900002',
    'spyware-adlogix':'12435',
    'malcode-RiskWare1':'6487',
    'malcode-RiskWare3':'6489',
    'easymail-emimap4-activex-bo':'2026',
    'win-ms12kb2709100-update':'5900002',
    'malcode-ServiceInstaller':'6516',
    'mdaemon-imap-create-bo':'6963',
    'malcode-RiskWare6':'6492',
    'malcode-RiskWare8':'6494',
    'rhel-rhsa-2009-1204-update':'5900002',
    'MoonPie_TCP_Response':'2113127',
    'spyware-aaabest-home-page':'12424',
    'malcode-Old13':'6403',
    'rhel-rhsa-firefox-popup-blocker-xss':'10692',
    'YaBB exploit':'15307',
    'malcode-Old15':'6405',
    'malcode-Old14':'6404',
    'win-ms10kb2436673-update':'5900002',
    'POP_Server_Identity':'9037',
    'ISA_Failed_To_Start':'5496',
    'netsnmp-handlevarrequests-dos':'7746',
    'UDP port probe':'13828',
    'IIS system32 command':'4893',
    'samba-sessionandx-dos':'5900002',
    'http-cgi-formmail-use':'3576',
    'ntalk':'8381',
    'IP_Unaligned_Timestamp':'5302',
    'win-ms11kb2525694-update':'5900002',
    'DNS I-Query exploit':'1846',
    'bind-named-service-dos':'850',
    'snmp-conf-traphost':'12058',
    'rhel-rhsa-2005-504-update':'9965',
    'ls-dos':'6084',
    'hp-pki-activex-dos':'5900002',
    'Kerberos_Bad_MsgType_DoS':'5900002',
    'cyrus-sasl-saslauthd-bo':'1612',
    'XML_Word_Access_Violation':'5900002',
    'HTML_IE_MSDDS_Heap_Corruption':'2121033',
    'HTTP GET pwl file type':'3505',
    'ie-cache-execcommand-dom-access':'4698',
    'malcode-CPA1':'6186',
    'malcode-CPA3':'6187',
    'ie-form-file-upload':'4747',
    'Netbios_Name_Scan':'2106161',
    'DPAPI_key_recovery_attempted':'1998',
    'Syphillis_Scan_Response':'2100014',
    'yahoo-open-bo':'5900002',
    'email-mime-filename-spaces':'2073',
    'nt-user-dormant-days':'8349',
    'rhel-rhsa-2007-1177-update':'10469',
    'winamp-noteon-bo':'5900002',
    'Startup_file_access':'13141',
    'Web_site_copying':'14222',
    'Admind':'98',
    'spyware-brilliantdigital':'12471',
    'mysql-case-privilege-escalation':'7511',
    'nt-system-time-onceonly':'8331',
    'Subversion_Date_Parsing_BO':'2110136',
    'HTTP_AnswerBook2_Admin':'2002754',
    'iis-relative-path-privilege-elevation':'4977',
    'ie-outdated':'4818',
    'mysql-comchangeuser-password-bo':'7513',
    'nds-print-queue-users':'7615',
    'rhel-rhsa-2003-065-update':'9579',
    'rhel-rhsa-2007-1022-update':'10429',
    'javawebstart-application-priv-escalation':'5653',
    'malcode-DataLoggerX':'6193',
    'spyware-newnet':'12676',
    'nt-web8.3':'8367',
    'HTTP_Cookie':'3868',
    'win-ms11kb2511455-update':'5900002',
    'use-audit-events':'13943',
    'IMAP2bis_server_user_login_successful':'5146',
    'Imail_admin':'5135',
    'soap-body-detected':'12318',
    'aix-iy64312-fix':'191',
    'faxcoversheet-detected':'5900002',
    'Land_Attack':'2000001',
    'Application Communication Blocked':'503',
    'SYNFlood_Protection':'5900002',
    'rhel-rhsa-2010-0271-update':'5900002',
    'spyware-navisearch-404':'12660',
    'shell-command-execution':'11587',
    'YahooMSG_File_Transfer':'15336',
    'FTP_List_eTrust_Overflow':'2124084',
    'win-ms08kb957699-update':'14691',
    'MySQL_Create_Function_Injection':'7537',
    'rhel-rhsa-2004-044-update':'9663',
    'DCOM_SystemActivation':'1667',
    'rhel-rhsa-2008-0061-update':'10486',
    'http-iis-cgi':'3638',
    'firefox-popup-blocker-xss':'2634',
    'photoshop-tiff-code-execution':'5900002',
    'adobe-reader-multiple-unspecified':'134',
    'malcode-ModifySettings0':'6378',
    'POP_Response_Client_Bo':'2107003',
    'malcode-X97M_Virus':'6915',
    'VmFailedToResetEvent':'14124',
    'rhel-rhsa-2005-412-update':'9939',
    'tcp-invalid-urgent-offset':'13385',
    'Image_BMP_Win_GDI_Bo':'5065',
    'Rsh':'11199',
    'hpux-rlpd-bo':'3345',
    'smb-mass-login-detected':'11725',
    'Audit_policy_change':'606',
    'rhel-rhsa-2004-549-update':'9765',
    'texinfo-texindex-bo':'13619',
    'realplayer-ram-bo':'9359',
    'nt-adminblankpw':'7971',
    'rsagent-netlogin-notactive':'11082',
    'linux-tmpwatch-fork-dos':'5978',
    'trust-remote-root':'13802',
    'ms-netbt-open-ip-ports':'7189',
    'JavaScript_NOOP_Sled':'2110107',
    'sql-keyword-xpcmdshell-detected':'12887',
    'win-gre-wmf-code-execution':'14335',
    'IRC_Rogue_Session':'2118046',
    'nt-domain-user-nopwd':'8060',
    'isa-fw-stop':'5444',
    'HTTP_Trace_Long_URI':'5900002',
    'eiqnetworks-esa-licensemanager-bo':'2062',
    'mssql-dbcc-bo':'7402',
    'Shellcode_Detected':'2110116',
    'iis-htw-cross-scripting':'4946',
    'ASP_Chunked_Overflow':'2110010',
    'ie-cache-showmodaldialog-dom-access':'4705',
    'SNMP_Dialup_Username':'2002014',
    'IMAP4_login_failed':'5161',
    'rumpus-ftp-directory-dos':'11227',
    'reg-passwd-not-installed':'9415',
    'keyhelpmodule-keyhelp-activex-bo':'5900002',
    'ie-frame-verification-variant':'4754',
    'libpcap-file-detected':'5900002',
    'HTML_Lenovo_AcpController_Code_Exec':'3430',
    'nt-install-unattend-file':'8143',
    'rhel-rhsa-2008-0196-update':'10523',
    'wireshark-tcpdissector-dos':'15140',
    'HTML_UTF8_Overflow':'2113253',
    'Scada_IGSSdataServer_Command_Overflow':'5900002',
    'apache-apr-fnmatch-dos':'5900002',
    'MSRPC UDP port probe':'7286',
    'symantec-xfr-code-execution':'5900002',
    'decod-ftp-user':'1693',
    'savant-get-bo':'11314',
    'MSRPC_Share_Enum_Sweep':'2118001',
    'rsagent-admin-privileges':'11013',
    'Email_Virus_Papa':'2002202',
    'local-computers-visable':'6006',
    'rhel-rhsa-2007-0400-update':'10311',
    'SMB_AddressBook_DLL_Hijacking':'5900002',
    'baofeng-isdvdpath-bo':'793',
    'BackOrifice2000':'753',
    'TCP_Probe_XWindows':'13457',
    'chrome-type-confusion-code-exec':'5900002',
    'user-login-fail':'13977',
    'cisco-ios-ipv6-packet-command-execution':'1293',
    'ip-unknown':'5281',
    'RPC_Ypbind_DirClimb':'2001730',
    'snork-dos':'12306',
    'email-executable-content':'2070',
    'IGMP_fragments':'4884',
    'spyware-netsource':'12668',
    'rhel-rhsa-2010-0751-update':'5900002',
    'quicktime-atom-too-small':'9214',
    'HTTP_DotDot':'2000603',
    'redhat-lpd-print-control':'9382',
    'word-hlink-reference-bo':'15150',
    'rhel-rhsa-2005-535-update':'9976',
    'rsagent-sqlserver-login-failed-nottrusted':'11110',
    'Intruzzo':'5255',
    'rhel-rhsa-2010-0719-update':'5900002',
    'Content_Analyzer_User_Defined_7':'2120089',
    'Content_Analyzer_User_Defined_4':'2120086',
    'rhel-rhsa-2007-0152-update':'10264',
    'Content_Analyzer_User_Defined_2':'2120084',
    'isa-webproxy-redirect-dos':'5477',
    'Content_Analyzer_User_Defined_0':'2120082',
    'Content_Analyzer_User_Defined_1':'2120083',
    'malcode-REGDisableAV':'6447',
    'HTTP_EPerl_isindex':'2105014',
    'decod-telnet-service':'1752',
    'pdgsoft-changepw-bo':'8814',
    'SMTP_Vrfy_Overflow':'11952',
    'Program_execution_started':'9122',
    'HTTP_Commerce':'2002600',
    'HTTP_Alternates_Corrupt':'2114142',
    'RAS_URQ_Inconsistent_Address':'2106306',
    'Content_Analyzer_Person_Name':'2120081',
    'HTTP_Borland_StarTeam_WebHandler_BO':'3801',
    'zbserver-get-bo':'15360',
    'win-ms05kb899587-update':'14450',
    'ICMPv6_Router_Advertisement_Exec':'4627',
    'dns-socket-entropy-spoofing':'1887',
    'outlook-codebase-execute-programs':'8673',
    'win-ms03041-patch':'14391',
    'wincrash-backdoor':'15017',
    'MSRPC_SRVSVC_SetFileSec_Samba_Bo':'2118099',
    'fetchmail-signed-integer-index':'2455',
    'ASF_DVR_MS_Code_Exec_2':'5900002',
    'win-ms09kb970927-update':'14740',
    'adobe-bmp-image-file-bo':'115',
    'win-ms06kb911562-update':'14482',
    'GayOL':'3065',
    'VPN_Hamachi_Client':'14182',
    'apache-apgetmimeheaderscore-dos':'410',
    'HTML_DLink_ShmAudio_BO':'2118125',
    'spyware-win32-holar-g':'12819',
    'pict-detected':'8931',
    'win-ms05kb896358-update':'14442',
    'ms-aspnet-security-bypass':'7161',
    'Kerberos_Heap_Overflow':'5900002',
    'rhel-rhsa-2009-1341-update':'5900002',
    'http-service-unavailable':'3689',
    'HTTP_Cisco_IOS_Query_DOS':'2106045',
    'snmp-bad-errorstatus':'12043',
    'talk':'13355',
    'office-png-bo':'8413',
    'Trojan_Pushdo':'13792',
    'iloveyou-worm':'5042',
    'exploit-PDF(100016)':'2384',
    'TLS_Unknown_Cipher_Suite':'5900002',
    'service-type-change':'11549',
    'ms-directx-directplay-dos':'7171',
    'Worm extensions':'15169',
    'cisco-aironet-telnet-enabled':'1259',
    'http-apache-cookie':'3551',
    'consona-activex-bo':'5900002',
    'DNS_Version_Request':'2000417',
    'IP_OShare':'2000024',
    'malcode-REGPayload':'6450',
    'sendmail-elevate-privileges':'11491',
    'http-get-malformed-detected':'3625',
    'nt-logon-hours':'8166',
    'tcp-overlap':'13391',
    'mozilla-url-bo':'7134',
    'firefox-jse-code-execution':'5900002',
    'spyware-iwon':'12618',
    'HTTP_Adpassword_Text':'2002565',
    'snmp-version-invalidtag':'12132',
    'cmail-command-bo':'1363',
    'explorer-menu-enabled':'2398',
    'MSM_DailyReport':'7258',
    'ethereal-afs-dissector-dos':'2200',
    'mozilla-onkeypress-xpi-install':'7114',
    'NoAccessUserEvent':'7888',
    'Script_IE9_Null_Byte_Disclosure':'5900002',
    'NetBIOS_port_probe':'7693',
    'malcode-SPCOM_DO_Spawn':'6542',
    'iis-web-form-submit':'5003',
    'HTTP_Server_Side_Include_Injection':'2110178',
    'SatansBackdoor':'11312',
    'gnupg-parsecomment-overflow':'3139',
    'IDENT invalid response':'4643',
    'rhel-rhsa-2008-0211-update':'10529',
    'safari-exif-bo':'11252',
    'rhel-rhsa-2005-114-update':'9855',
    'rhel-rhsa-2003-182-update':'9607',
    'asa-pix-tcp-dos':'561',
    'malcode-TriggerScript3':'6801',
    'malcode-TriggerScript2':'6800',
    'malcode-TriggerScript1':'6799',
    'ethereal-afs-bo':'2199',
    'SDP_Illegal_Space':'2106299',
    'Quake_Exploit':'9206',
    'reg-rras-filetracing-enabled':'9430',
    'MSRPC_RRaS_BO':'2121060',
    'HTML_IE_ARG_Code_Exec':'3401',
    'Itunes_Playlist_FileExt_Overflow':'5900002',
    'SMB empty password':'11704',
    'boep-svchost':'958',
    'security-patch-possibly-needed':'11443',
    'msrpc-encrypted-session-detected':'7288',
    'HTTP GET data contains script':'3501',
    'winrar-archives-code-execution':'15072',
    'spyware-favoriteman':'12557',
    'nt-user-logon-restricted':'8352',
    'SMB password overflow':'11710',
    'cisco-syslog-crash':'1325',
    'aix-iy78227-fix':'256',
    'nt-no-logon':'8210',
    'HTTP_AWStats_LoadPlugin':'2113201',
    'icqtoolbar-activex-toolbaru-dos':'4636',
    'spyware-download-accelerator-plus':'12526',
    'win-ms12kb2645640-update':'5900002',
    'malcode-EndlessLoop':'6239',
    'HTTP_IIS_Hex_Evasion':'2106055',
    'user-homedir-gx':'13965',
    'SMB_Malformed':'2000501',
    'ibm-websphere-reveals-path':'4582',
    'malcode-SpawnExeSus2':'6536',
    'PKG_EPO_Directory_Traversal':'2113263',
    'ieee80211-wepkey-access':'4880',
    'SSH_Successful_password_auth.':'13061',
    'win-ms11kb2503665-update':'5900002',
    'thinkmanagement-vulcore-dir-traversal':'5900002',
    'MHTML_Script_Detected':'5900002',
    'nt-group-bypass':'8087',
    'decisiontools-activex-code-execution':'5900002',
    'DHCP_Domain_Metachar':'2004301',
    'FTP_Floppy_DoS':'2001358',
    'HTTP_EMC_Documentum_File_Overwrite':'3897',
    'win-ms08kb954154-update':'14670',
    'nt-backup-operator-userpwd':'7996',
    'win-ms10kb977377-update':'14781',
    'malcode-PackedFileInfector':'6417',
    'boep-services':'956',
    'sun-java-webproxy-security-bypass':'13211',
    'LDAP_OpenLdap_ModRDN_Exec':'5900002',
    'rc-path-cwd':'9331',
    'rhel-rhsa-2012-0387-update':'5900002',
    'nds-user-template-password-length':'7650',
    'rhel-rhsa-2004-610-update':'9778',
    'lotus-notesdomino-insecure-permissions':'5900002',
    'HTTP_IIS_Request_Header_Overflow':'5900002',
    'Webevent_admin':'14230',
    'sdk-jre-applet-restriction-bypass':'5900002',
    'HTTP_URL_Many_Slashes':'2000606',
    'libtiff-pixarlog-decoder-bo':'5885',
    'libpng-trns-chunk-dos':'5879',
    'ie-vml-bo':'4864',
    'rhel-rhsa-2010-0610-update':'5900002',
    'aix-iy64356-fix':'194',
    'spyware-shopforgood':'12739',
    'ie-html-objects-code-execution':'4769',
    'HTTP_IIS_ssi':'2105038',
    'HTTP_CheckLoginPhp':'2002664',
    'cups-ssl-dos':'1564',
    'HTTP_PHPNuke_Prefix_Admin':'2002672',
    'HTML_URL_Unicode_Stack_Overflow':'3460',
    'rhel-rhsa-2010-0130-update':'5900002',
    'postgresql-rollback-commit-dos':'9073',
    'twiki-configure-image-command-execution':'13818',
    'AgentManagerClockDifference':'158',
    'MSM_RuntimeError':'7265',
    'nettaxi-backdoor':'7759',
    'TCP_Fragmented_Header':'2000306',
    'spyware-winlocator-bho':'12833',
    'html-microsoft-agent-detected':'3366',
    'broker-user-dos':'1028',
    'win-ms11kb2648048-update':'5900002',
    'spyware-nez':'12678',
    'subnet-sweep':'13171',
    'groupwise-webaccess-gwinter-bo':'3188',
    'slmail-vrfyexpn-overflow':'11695',
    'semi-tmp-file-symlink':'11478',
    'isc-bind-rdata-dos':'5900002',
    'mozilla-firefox-browser-code-exec':'5900002',
    'TFTP hosts file':'13633',
    'rhel-rhsa-mailman-headers-dos':'10706',
    'ISS':'5554',
    'TCP_Orphaned_Sessions_DoS':'2101083',
    'Microsoft_SnaBase_Memory_DoS':'5900002',
    'HTTP_PHPNuke_Admin_Overwrite':'2002680',
    'web-directories-readable':'14218',
    'CompoundFile_Excel_Label_BO':'2106227',
    'Keystrokes_monitored':'5775',
    'imagemagick-propuserunit-bo':'5120',
    'ms-ie-installed':'7180',
    'dns-bad-packets':'1863',
    'SSH_ChallengeResponse_Bo':'2106130',
    'teardrop-mod':'13496',
    'kernel-utracesupport-dos':'5771',
    'rhel-rhsa-2004-183-update':'9698',
    'nt-system-time':'8332',
    'multiple-tool-flood-dos':'7486',
    'rhel-rhsa-2005-405-update':'9935',
    'rpc.cmsd_overflow':'10901',
    'DHCP_Format_String_BO':'2110013',
    'win-ms05kb896727-update':'14449',
    'rhel-rhsa-2010-0676-update':'5900002',
    'uucp-directory-permissions':'14052',
    'CHM_Listing_Name_Length_Overflow':'5900002',
    'malcode-SPMZ_1K_Cmos':'6555',
    'mydoom-detected':'7500',
    'Trojan_Opachki':'5900002',
    'rhel-rhsa-2005-035-update':'9815',
    'sendmail-ident-logging-bypass':'11497',
    'way-board_cgi_file_access':'14208',
    'win-ms09kb975467-update':'14767',
    'rhel-rhsa-2007-0969-update':'10415',
    'snmp-long-field-length':'12087',
    'spyware-savenow':'12716',
    'RuxTick_Request':'2001575',
    'spyware-rapidblaster':'12706',
    'rsagent-userright-granted':'11180',
    'squid-gopher-bo':'12934',
    'spyware-surf':'12758',
    'asset-export-list':'583',
    'SMIL_QuickTime_Overflow':'11800',
    'http-cgi-faxsurvey':'3574',
    'helix-rtsp-bo':'3269',
    'HTTP_Dropload_Email_Attachment':'3891',
    'ipsectools-isakmpinforecv-dos':'5353',
    'Citrix_IMA_Heap_Overflow':'5900002',
    'rhel-rhsa-2005-235-update':'9879',
    'backdoor-tini':'737',
    'win-ms09kb974378-update':'14761',
    'SSLv2_Detected':'13105',
    'win-ms11kb2560978-update':'5900002',
    'SSH_Vulnerable_OpenSSH':'2110049',
    'POP3 login failed':'8992',
    'SNMP_Format_String':'12204',
    'hp-nnm-toolbar-bo':'3323',
    'exchange-imc-ehlo-bo':'2286',
    'Domain_removed_from_enterprise':'1980',
    'OTF_Windows_Double_Free':'5900002',
    'webhmi-activex-bo':'5900002',
    'sunone-viewlog-directory-traversal':'13241',
    'nt-35':'7954',
    'Bonk_attack':'985',
    'nt-multiprotocol-ipx-spx':'8190',
    'php-nuke-url-redirect':'8889',
    'aix-iy55789-fix':'176',
    'default-profile-onceonly':'1765',
    'iis-specialized-header':'4987',
    'http-cgi-cgiproc-dos':'3564',
    'Mneah_TCP_Request':'2113125',
    'BackOrifice_Request':'2001501',
    'HTTP_Suspicious_Executable_Transfer':'4417',
    'autonomy-keyview-applix-multiple-bo':'616',
    'clusterproject-processclient-bo':'1361',
    'papyrusafp-activex-bo':'5900002',
    'ipswitch-replyto-bo':'5900002',
    'HP_Remote_watch':'3338',
    'rhel-rhsa-2011-0259-update':'5900002',
    'HTTP_Webplus':'2002593',
    'login-log-onceonly':'6024',
    'IPOP3D_brute_force_attack':'5333',
    'rhel-rhsa-2005-769-update':'10025',
    'Global_group_created':'3113',
    'ms-device-driver-privs':'7166',
    'Exchange_logon_failure':'2316',
    'Excessive_DNS_requests':'2278',
    'winxp-ms05kb888302-update':'15097',
    'malcode-Downloader2':'6213',
    'SMTP_Exchange_Verb_DoS':'2110033',
    'malcode-Downloader0':'6211',
    'IM_File_Transfer':'5049',
    'malcode-Downloader6':'6217',
    'CGI_formmail':'1184',
    'rhel-rhsa-2010-0533-update':'5900002',
    'malcode-Downloader5':'6216',
    'stunnel-client-format-string':'13167',
    'ethereal-ntlmssp-bo':'2209',
    'rhel-rhsa-2011-1109-update':'5900002',
    'win-ms09kb957638-update':'14702',
    'FTP_NetTerm_Pass_Overflow':'2001337',
    'jre-calendar-privilege-escalation':'5900002',
    'malcode-W32_Rootkit':'6869',
    'rhel-rhsa-2005-010-update':'9798',
    'spyware-other':'12686',
    'rhel-rhsa-2005-416-update':'9942',
    'rhel-rhsa-2010-0079-update':'5900002',
    'smartftp-directory-traversal':'11698',
    'ExecutorController_TCP_Request':'2113103',
    'trillian':'13763',
    'spyware-dluca':'12521',
    'dafolo-baseurl-bo':'1615',
    'rhel-rhsa-2005-659-update':'10001',
    'rhel-rhsa-2005-505-update':'9966',
    'malcode-VBATimeTrigInfectSus':'6863',
    'bittorrent-dht-announcepeer-detected':'883',
    'EZshopper loadpage CGI':'2409',
    'IPM_Quarantine_Rule_Expired':'5326',
    'vantage-answerworks-bo':'14066',
    'ie-file-download-ext-spoof':'4742',
    'kernel-redhat-restoreall-dos':'5753',
    'nt-print-operator':'8242',
    'nis-machine-type':'7837',
    'win-ms12kb2711167-update':'5900002',
    'Realwin_Scada_HMI_Multiple_Overflow':'5900002',
    'win2k-secenabled-universalgroup-memberremoved':'14960',
    'rhel-rhsa-2010-0681-update':'5900002',
    'backdoor-telecommando':'735',
    'rhel-rhsa-2007-0349-update':'10297',
    'malcode-HelpFileWithCallbackFunctions':'6323',
    'SubSeven_Scan_Response':'2100023',
    'ftp-args':'2829',
    'MSM_MailReleased':'7263',
    'ftp-stor-retr-audit':'2872',
    'rhel-rhsa-2011-1282-update':'5900002',
    'decod-ftp-auth-failure':'1686',
    'RIFF_CorelDraw_Overflow_DoS':'5900002',
    'java-pluggable-unspecified':'5900002',
    'icecap-application-blocked':'4589',
    'Hack-a-tack_ICQ_pager_URL':'3250',
    'snmp-v3-incorrect-tag':'12126',
    'admin-allowed-ftp':'92',
    'RFParalyze exploit':'9503',
    'HTTP_SAPDB_Wahttp_BO':'4362',
    'HTTP_IE_WMI_Object_Broker':'2114025',
    'Content_Analyzer_User_Defined_6':'2120088',
    'mozilla-doccookie-dos':'7073',
    'symantec-antivirus-client-bo':'13303',
    'malcode-SpawnDropper0':'6533',
    'malcode-SpawnDropper1':'6534',
    'symantec-web-file-include':'5900002',
    'rhel-rhsa-2006-0603-update':'10157',
    'SMTP VRFY command':'11844',
    'rhel-rhsa-2007-0075-update':'10239',
    'nav-non-secure-submission':'7579',
    'winamp-mtrk-code-execution':'5900002',
    'wuftp-site-newer-dos':'15188',
    'HTML_Expeditor_Rcplauncher_Code_Execution':'3394',
    'smtp-message-audit':'11866',
    'win-rras-bo':'14825',
    'rhel-rhsa-2007-0817-update':'10378',
    'nt-changeduser-privs':'8017',
    'back-orifice-large-ping':'649',
    'HTTP GET data contains .._.._.._..':'3499',
    'HTTP_Content_Disposition_Spoofing':'2111023',
    'sunrpc-xdrmemgetbytes-integer-overflow':'13246',
    'ms-office-activex-code-execution':'5900002',
    'Conficker_P2P_Exec_Transfer':'2110198',
    'firefox-font-glyph-bo':'5900002',
    'malcode-SideEffectMBR':'6525',
    'rhel-rhsa-2008-0030-update':'10477',
    'helix-rtsp-setup-bo':'3270',
    'win-ms12kb2681578-update':'5900002',
    'snmp-netbios':'12092',
    'Domino_Calendar_Name_Overflow':'5900002',
    'rhel-rhsa-2005-332-update':'9902',
    'Telnet_Bad_IFS':'2000907',
    'nt-user-home-directory':'8350',
    'CrackDown_TCP_Response':'2113090',
    'SAMI_MPlayer_Overflow':'5900002',
    'user-trust-local-account':'14019',
    'x25':'15196',
    'Compaq_Insight_DoS':'1418',
    'Startup file access':'13140',
    'aix-iy72711-fix':'231',
    'MSRPC_Registry_Key':'7348',
    'SNMP bad err status tag':'11970',
    'icmp-timestamp':'4606',
    'dameware-spoof-packet-bo':'1621',
    'HTTP_Domino_Navigator':'2105033',
    'dcomdef_deny':'1669',
    'malcode-Attribution':'6151',
    'apache-cgi-shells':'418',
    'win-ms07kb929969-update':'14572',
    'HTML_IBM_Installation_Mgr_Code_Exec':'3399',
    'win-ms11kb2514842-update':'5900002',
    'MountdExport':'2001731',
    'Trace_Route_UDP':'2102017',
    'Y3K_TCP_Response':'2100033',
    'decod-snmp':'1747',
    'SNMP_Bad_OID':'12155',
    'POP3_command_overflow':'9006',
    'XML_Name_Overflow':'2119003',
    'nt-applog-overwrite':'7981',
    'ie-html-bo':'4764',
    'nfs-lockd-port-probe':'7800',
    'SSL_Google_Desktop_Indexing':'13092',
    'visualstudio-maskededit-bo':'14110',
    'ms-visual-dll-code-exec':'5900002',
    'Allaire_JRun_SSIFilter':'2004903',
    'Ticket_granted_renewed':'13699',
    'win-ms09kb974455-update':'14763',
    'SNMP_NonZeroLength_NullType':'2106119',
    'BOOTP_ISC_DHCP_DoS':'5900002',
    'ISA_PF_Create_PF_Failure':'5506',
    'Email_Mime_Filename':'2118',
    'win2k-account-created':'14893',
    'Napster_Login':'7563',
    'malcode-Sus_SearchEXE':'6735',
    'FTP_Site_Exec_Tar':'2001326',
    'ServeMe_Response':'2001579',
    'Napster_Download':'7562',
    'MSRPC_Svcctl_Remote_Query':'7382',
    'IMAP4_user_name_overflow':'5164',
    'IPOP3D_user_login_successful':'5338',
    'openview-data-ce':'5900002',
    'nt-no-profile':'8211',
    'Melissa virus':'6985',
    'IRC_DCC_Request':'5388',
    'rhel-rhsa-2007-0970-update':'10416',
    'nt-group-act-system':'8083',
    'rhel-rhsa-2004-543-update':'9763',
    'gator-installed':'3060',
    'Cisco_ASA_PIX_DoS':'1331',
    'mdaemon-worldclient-dos':'6969',
    'Admin_group_security_descriptor_set':'97',
    'rhel-rhsa-2007-0465-update':'10319',
    'HTML_IE_Rendering_Combination_Corruption':'3411',
    'ie-sysimage-obtain-info':'4846',
    'HTTP_IE_Objects_Code_Execution':'4024',
    'citrix-nfuse-path-disclosure':'1352',
    'win-kernel-gdi-code-execution':'14358',
    'HTTP_WinScript_DLL_Hijacking':'5900002',
    'rhel-rhsa-2009-0346-update':'5900002',
    'nt-power-user':'8238',
    'rhel-rhsa-2010-0752-update':'5900002',
    'rhel-rhsa-2009-0373-update':'5900002',
    'malcode-DeleteMultipleFiles':'6195',
    'HTTP_Post_Filename_pwl':'2003904',
    'rc-path-owner':'9335',
    'HTTP_Cisco_Aironet_Webconfig':'2106018',
    'win-ms09kb957488-update':'14699',
    'H225_Length_Bo':'2107001',
    'H225_Invalid_Field_DoS':'3239',
    'rhel-rhsa-2005-550-update':'9978',
    'php-nuke-opendir-read-files':'8887',
    'decod-smtp-long-emailname':'1742',
    'imail-listmailer-bo':'5900002',
    'rhel-rhsa-2009-1200-update':'5900002',
    'rhel-rhsa-2006-0201-update':'10094',
    'JavaScript_IE_findText_DoS':'5619',
    'rhel-rhsa-2007-0169-update':'10272',
    'rhel-rhsa-2011-0336-update':'5900002',
    'SMTP_email_name_overflow':'11895',
    'ie-activexloader-bo':'4684',
    'gtp-c-discovery':'3197',
    'IPM_Packet_Dropped':'5324',
    'rppppoe-zero-length-dos':'11005',
    'rhel-rhsa-2007-0860-update':'10384',
    'aix-iy88642-fix':'287',
    'rhel-rhsa-2005-802-update':'10039',
    'gigabyte-activex-file-download':'5900002',
    'designreview-liveupdate-unauth-access':'1770',
    'ospf-link-state-update':'8645',
    'JavaScript_Packer_Gamma':'2114163',
    'http-cross-site-scripting':'3613',
    'scm_logon_fail':'11367',
    'symantec-antivirus-alert-priv-escalation':'5900002',
    'netpbm-multiple-bo':'7717',
    'Flv_Detected':'2694',
    'rhel-rhsa-2007-1128-update':'10462',
    'adobe-flash-authplay-ce':'5900002',
    'mailman-pipermail-index-xss':'5900002',
    'spyware-zeropopup':'12843',
    'jbig2-image-detected':'5657',
    'mdac-rds-server-bo':'6959',
    'multiple-json-information-disclosure':'7483',
    'nt-knowndlls-list':'8147',
    'rhel-rhsa-2008-1021-update':'5900002',
    'CGI handler':'1142',
    'spyware-keyspy':'12621',
    'rhel-rhsa-2007-0662-update':'10347',
    'MSRPC_AV_ScanConfig_BO':'7306',
    'myspace-im-detected':'7505',
    'adobe-acrobat-pdf-csrf':'108',
    'nds-user-template-acl-rights':'7646',
    'rservice-shell-wrapper-allow':'11192',
    'OWA_Script_UTF_Encoding':'8696',
    'nss-certificate-security-bypass':'7946',
    'HTML_Pdf_XSS':'2109016',
    'malcode-ScriptDropper':'6504',
    'aix-iy59205-fix':'180',
    'HTTPS_Apache_ClearText_DoS':'2114033',
    'spyware-earnwithads':'12536',
    'icc-profile-bo':'4586',
    'SSH_connection_for_user_not_allowed_From_Host':'13037',
    'irc-port-probe':'5379',
    'user-unprintable':'14025',
    'RPC selection_svc hold file':'10856',
    'RPC_NFS_FHSize_Overflow':'2120006',
    'fw1-format-string':'3044',
    'HTTP_IIS_IndexSearch':'2002638',
    'dell-activex-getdata-dir-traversal':'5900002',
    'Stacheldraht_DOS':'13125',
    'win2k-directory-service':'14913',
    'palmetto-ftpd-bo':'8706',
    'malcode-VBS_DropNgo':'6864',
    'WhatsUpPing':'2001511',
    'EPolicy_Orchestrator_Vulnerable_Server':'2190',
    'rhel-rhsa-2005-110-update':'9853',
    'JavaScript_Firefox_JSDBGAPI_Code_Exec':'5614',
    'win-ms09kb974571-update':'14764',
    'reg-print-unprotected':'9418',
    'rhel-rhsa-2005-835-update':'10055',
    'ie-version7-installed':'4863',
    'acrobat-reader-u3d-code-execution':'51',
    'cisco-ios-aaa-auth':'1278',
    'Trusted_domain_added':'13804',
    'nap-logininfo':'7553',
    'Alvgus_Request':'2113071',
    'Rlogin_Froot':'2002101',
    'spyware-armbender':'12449',
    'win2k3-user-create-global-privilege':'14998',
    'rhel-rhsa-2005-175-update':'9870',
    'vsf-vxschedservice-code-execution':'14187',
    'win-ms09kb969947-update':'14735',
    'HTTP_IE_HRAlign_Overflow':'4017',
    'RPC_ypbind_directory_climb':'11001',
    'phpmyadmin-sqlphp-include-file':'8924',
    'ie-html-rendering-code-execution':'4770',
    'file-group-root':'2505',
    'utillinux-chfn-race-condition':'14046',
    'prov-system-error':'9131',
    'TSM_String_Overflow':'2114059',
    'GSpot_TCP_Request':'2113111',
    'xdm-xdmcp-remote-bo':'15206',
    'VRRP_Detected':'14185',
    'spyware-topicks':'12772',
    'novell-iprint-getfilelist-info-disclosure':'7926',
    'malcode-SPNE_Odd_LDT':'6599',
    'ISA_LOG_File_Write_Failed':'5504',
    'nt-group-create-token':'8090',
    'rhel-rhsa-2004-392-update':'9725',
    'HTTP_Accept_Language_Overflow':'3730',
    'rhel-rhsa-2008-0638-update':'5900002',
    'poptop-ctrlpacket-packet-bo':'9045',
    'reg-syskey-sam':'9451',
    'allowed-cronat':'331',
    'HTTP_Feed_URL_SuspiciousChar':'5900002',
    'rhn-memory-leak':'10775',
    'spyware-searchv':'12730',
    'malcode-W32_Adware_Generic':'6867',
    'network-management-buffer-overflow':'7776',
    'snmp-get-guess':'12073',
    'Spyware_PH_IEPlugin':'2113190',
    'HTTP_Content_Type_HTA':'2111019',
    'mozilla-javascript-expression-bo':'7087',
    'XML_RealPix_FormatString':'2113229',
    'Symantec_NBNS_Heap_Corruption':'2107019',
    'solaris-kcms-directory-traversal':'12380',
    'ie-secure-site-entering':'4834',
    'win-ms09kb960225-update':'14709',
    'nds-supervisor-rights':'7619',
    'nt-trojan-key-perm':'8340',
    'win2k-logon-account':'14940',
    'RPC ypbind directory climb':'10865',
    'TFTP_Image_Transfer':'2001205',
    'rhel-rhsa-2007-0082-update':'10245',
    'Telnet_Bad_Term':'2000910',
    'Security_disabled_universal_group_created':'11459',
    'backdoor-rux-tick':'721',
    'reg-passwd-not-enforced':'9414',
    'win-ms08kb949030-update':'14643',
    'aix-iy70028-fix':'225',
    'UDP_port_probe':'13845',
    'danske-esec-activex-bo':'1632',
    'Nestea attack':'7670',
    'Critical_File_Renamed':'1538',
    'prettypark-worm':'9102',
    'Application_Communication_Allowed':'523',
    'exploit-RTF(100028)':'2388',
    'HTTP_PHPNuke_ReadFiles':'2002659',
    'ipswitch-ftplogserver-dos':'5900002',
    'LDAP_OpenLdap_ModRDN_DoS':'5900002',
    'smb-admin-credentials-verified':'11717',
    'mozilla-nschildview-code-exec':'5900002',
    'HTTP_IIS_MSSQL_XML_Script':'2105052',
    'rhel-rhsa-2005-562-update':'9980',
    'gzip-lhz-bo':'3230',
    'Scada_Modbus_TooLarge':'2118036',
    'java-vm-applet':'5583',
    'rhel-rhsa-mult-libexif-exifdataloadentry-bo':'10734',
    'iis-ms03018-patch':'4965',
    'Brute_force_login_attack':'1030',
    'Windows_Registry_Read':'15040',
    'http-iframe-tag-injection':'3634',
    'NetSphere_FTP_Response':'2100011',
    'pe-overlapping-header':'8816',
    'ssh2-auth-failed-dns-spoofing':'12984',
    'win-otf-cmap-code-execution':'5900002',
    'php-phphandlejpeg-dos':'8893',
    'RTSP_Helix_Setup_BO':'2124068',
    'yahoo-messenger-message-bo':'15319',
    'HTTP_Wireshark_Console_Lua_Hijacking':'5900002',
    'nt-adminuserpw':'7974',
    'remote-user-login-success':'9471',
    'JavaScript_Double_Escaped_NOOP_Sled':'2114151',
    'openssl-cms-code-execution':'5900002',
    'HTTP_Frontpage_Publish':'2002602',
    'rwhoisd-syslog-format-string':'11242',
    'http-noindex':'3652',
    'coldfusion-sourcewindow':'1400',
    'rhel-rhsa-openoffice-rtf-bo':'10741',
    'iss-host-status':'5550',
    'rhel-rhsa-2008-0300-update':'10555',
    'installshield-silent-installer':'5237',
    'IPM_Dynamic_Rule_Removed':'5319',
    'rhel-rhsa-2005-373-update':'9921',
    'rsagent-ssh-connection':'11119',
    'win-ms10kb2229593-update':'5900002',
    'fingerd-backdoor-detected':'2612',
    'ms-win-xmlcore-code-execution':'5900002',
    'Email_HTML_HREF_URI_Local_Exec':'5900002',
    'starteam-tmsgbufmsgdeserializeex-bo':'13137',
    'malcode-AttachFileWithMultipleExtensions':'6148',
    'TrinooDaemonRegister':'13775',
    'nt-user-account-locked':'8347',
    'backdoor-bionet':'666',
    'HTTP_WebcartCgi_Execute':'2106069',
    'rhel-rhsa-2008-0064-update':'10487',
    'SMTP_NTLM_Auth_Generic_Overflow':'5900002',
    'nds-user-template-account-disabled':'7644',
    'ie-dhtml-script-code-execution':'4728',
    'IKE_association_failed_Bad_Auth_Params':'5032',
    'DNS_Generic_Intel_Overflow':'2104010',
    'HTTP_testcgi':'2002531',
    'HTTP_EZShopper_Search':'2106022',
    'IIS malformed HTR request':'4889',
    'SMTP corrupted MAIL command':'11806',
    'Application_Protection_Stopped':'530',
    'Application_Execution_Allowed':'528',
    'rhel-rhsa-2006-0525-update':'10131',
    'CGI_campas':'1178',
    'SNMP_HP_Route_Metachar':'2002020',
    'nis-operating-level':'7839',
    'SOLIDDB_Solid_Memory_DoS':'12398',
    'rsagent-ssh-dns-spoofing-no-reverse':'11120',
    'rhel-rhsa-2005-473-update':'9954',
    'HTTP_DataProtector_SQL_Injection':'5900002',
    'rhel-rhsa-2003-274-update':'9628',
    'rhel-rhsa-2008-0164-update':'10511',
    'jakarta-tomcat-modjk-format-string':'5574',
    'HackersParadise':'3260',
    'HTTP_IE_Style_Heap_BO':'2107032',
    'WINS_Service_Failed':'5900002',
    'rhel-rhsa-2007-0354-update':'10299',
    'rhel-rhsa-2010-0429-update':'5900002',
    'Brute_force_login_likely_successful':'1031',
    'officescan-cgichkmasterpwd-auth-bypass':'8422',
    'openssl-x509-dos':'8503',
    'mozilla-xpcnativewrapper-xss':'7141',
    'SNTP buffer overflow':'12312',
    'POP_SilentRunner_User_Overflow':'2103001',
    'win-ms10kb2259922-update':'5900002',
    'adpassword.txt_URL':'144',
    'gdm-xdmcp-continue-dos':'3072',
    'malcode-SysDeletionScript':'6788',
    'win-ms04kb873339-update':'14415',
    'TCP_Probe_T0rn':'13454',
    'rhel-rhsa-2004-236-update':'9707',
    'ca-arcservebackup-caloggerd-code-execution':'1062',
    'Suspect_FTP':'13258',
    'DNS UDP port probe':'1860',
    'user-netrc-passwd':'13996',
    'Dragon-Fire CGI':'2004',
    'telnet-tab-bo':'13543',
    'rhel-rhsa-2003-009-update':'9561',
    'rsagent-ssh-rsa-authfailed':'11136',
    'lotus-ag-applix-bo':'6041',
    'FTP SITE EXEC command':'2816',
    'unix-root-core-access':'13894',
    'HP_NNM_AlarmSrv_DoS':'2101081',
    'apache-modssl-plain-dos':'462',
    'mozilla-viewimage-xss':'7138',
    'rhel-rhsa-2005-217-update':'9877',
    'Email_Invalid_Command':'2001008',
    'snmp-suspicious-set':'12114',
    'winfax-faxviewer-activex-bo':'15051',
    'msvm-jdbc-odbc-access':'7467',
    'rhel-rhsa-2009-0013-update':'5900002',
    'diskeeper-dkservice-information-disclosure':'1830',
    'solaris-lpd-bo':'12381',
    'http-connection-field-bo':'3610',
    'rhel-rhsa-2004-591-update':'9772',
    'SMTP WIZ command':'11846',
    'HTTP_Sunone_Viewlog':'2105067',
    'linux-rpcstatd-format-overwrite':'5962',
    'Cerebus Scan':'1119',
    'win-workstation-rpc-code-execution':'14886',
    'LandeskXFR_Execute_Shell':'5900002',
    'dbguestbook-dbsbasepath-file-include':'5900002',
    'VmSuspendingEvent':'14139',
    'barcodeax-activex-beginprint-bo':'800',
    'powerpoint-bit-code-execution':'9081',
    'vim-feedkeyswritefile-command-execution':'14091',
    'Glacier_Server_Request':'2113056',
    'slapper-worm-variants':'11689',
    'rhel-rhsa-2011-1344-update':'5900002',
    'PDF_FoxIt_Launch_Overflow':'2114159',
    'rsagent-sybase-connect-failed':'11160',
    'IPM_Dynamic_Rule_Added':'5317',
    'aix-IY88735-fix':'293',
    'swf-actionscript-actionendflag-detected':'13281',
    'netscape-get-bo':'7732',
    'backdoor-doly15':'681',
    'FTP_CWD_directory_overflow':'2901',
    'reg-netbt-block-increment':'9408',
    'Failure on Startup':'2436',
    'webstore-misconfig':'14259',
    'sql-injection-benchmark-detected':'5900002',
    'acrobat-image-decoder-code-execution':'5900002',
    'hassan-cart-command-execution':'3265',
    'apache-symlink':'483',
    'win-ms08kb956802-update':'14683',
    'HTTP_$DATA_Source_Disclosed':'2000607',
    'win-smb-bo':'14840',
    'rsagent-exchange-mail-sentas':'11031',
    'Radius_Acct_FormatString_Exec':'5900002',
    'TelnetExcessiveAYTs':'13609',
    'HTTP cookie overflow':'3489',
    'rsagent-special-privileges':'11108',
    'solaris-snmpxdmid-bo':'12386',
    'nt-schedule':'8295',
    'rhel-rhsa-2007-1077-update':'10452',
    'FTP_ProFTPD':'2001313',
    'SMB_Trans2_QueryFS_Exec':'5900002',
    'Statd_Automount_Exec':'13144',
    'rhel-rhsa-2008-0848-update':'10587',
    'HTTP_IIS$DATA':'4039',
    'wsftp-rest-dos':'5900002',
    'SMTP_Malformed_Rcpt_Cmd':'2001010',
    'realplayer-swf-frame-bo':'9370',
    'Oracle_AuthAlterSession_SqlExec':'2106220',
    'win-ms07kb921503-update':'14553',
    'firefox-flashbug-dos':'5900002',
    'zone-safe-scripting':'15388',
    'IPDuplicate':'5308',
    'win-ms10kb2442962-update':'5900002',
    'nss-clientmasterkey-bo':'7947',
    'cisco-ios-xauth-gain-access':'1307',
    'FTP_PASV_Invalid_Response':'2966',
    'norton-is-launchurl-command-execution':'7904',
    'win-ms09kb972260-update':'14750',
    'rhel-rhsa-2008-0209-update':'10528',
    'ICMP_Unreachable_Storm':'2000104',
    'rhel-rhsa-2004-464-update':'9749',
    'jre-gif-file-bo':'5678',
    'malcode-GenericRAT1':'6318',
    'malcode-GenericRAT0':'6317',
    'microsoft-office-rtf-code-execution':'5900002',
    'malcode-GenericRAT2':'6319',
    'rsagent-useraccount-changed':'11173',
    'ms-win-coreservices-code-exec':'5900002',
    'HTTP_AWStats_PluginMode_Exec':'2113199',
    'CGI_convert.bas':'1179',
    'IDENT scan':'4646',
    'Cybercop FTP scan':'1589',
    'IRC_Msg_IP':'5398',
    'start-groups-enabled':'13128',
    'MSSQL_Startup':'7447',
    'Logon_with_explicit_credentials_failure':'6034',
    'visualbasic-vbp-bo':'14109',
    'rsagent-registry-eventlog-settings-changed':'11102',
    'rsagent-sqlserver-login-failed-toomany':'11111',
    'IPProtocolViolation':'5346',
    'ipsec-policy-agent-changed':'5347',
    'spyware-win32-backdoor-sdbot':'12817',
    'rhel-rhsa-2007-0345-update':'10293',
    'JavaScript_WScript_Shell_Object':'2110113',
    'SMB_MaxBuffer_Bo':'2118035',
    'IM_Message':'5052',
    'ca-brightstor-dbasvr-code-execution':'5900002',
    'itunes-pls-bo':'5900002',
    'HTML_FoxPro_ActiveX_Overflow':'2114071',
    'malcode-Smallola':'6528',
    'RPC_NFS_Mknod':'2001714',
    'webpals-library-cgi-url':'14245',
    'UDP_Flood_DoS':'2106268',
    'linux-kernel-multiple-bo':'5939',
    'POP_Password':'9030',
    'user-homedir-group':'13963',
    'IM_AOL_AddExternalApp_Overflow':'5047',
    'spyware-nowbox':'12680',
    'SNMP_WINS_deletion':'12299',
    'pine-check-mail-bo':'8944',
    'ISA_invalid_address_range':'5501',
    'wsftp-site-cpwd-bo':'15179',
    'BitTorrent_DHT_AnnouncePeer':'889',
    'edonkey-present':'2050',
    'spyware-cytron':'12509',
    'win-ms10kb974145-update':'14775',
    'ms-activex-control-code-execution':'5900002',
    'rhel-rhsa-2008-0210-update':'5900002',
    'Novell_iPrint_ActiveX_Bo':'2124005',
    'Sybase_Startup':'13300',
    'win-ms10kb2296011-update':'5900002',
    'orinoco-as-client-publan':'8623',
    'JavaScript_Unescape_fromCharCode':'5900002',
    'hp-nnm-ovalarmsrv-subargument-dos':'5900002',
    'decod-imap-user':'1704',
    'group-changed':'3170',
    'remotehack-backdoor':'9474',
    'bf-evolution-backdoor':'812',
    'Email_Qmail_Length':'2001051',
    'rhel-rhsa-2009-1580-update':'5900002',
    'rhel-rhsa-2004-569-update':'9767',
    'ISAKMP_ASN1_Overflow':'2107008',
    'RFPoison_attack':'9506',
    'CGI imagemap.exe':'1144',
    'w3m-html-frame-xss':'14193',
    'HTTP_3com_AirConnect_SystemSetup':'2106017',
    'nt-guestuserpw':'8132',
    'uiplayer-uicheck-activex-bo':'13869',
    'MSSQL_Successful_Non-Trusted_Connection':'7448',
    'change-audit-events':'1221',
    'rhel-rhsa-2007-0939-update':'10404',
    'malcode-SPPE30_SysDir_SecWrt':'6645',
    'isakmp-vulnerable-vpn':'5530',
    'ie-uninit-object-code-execution':'4853',
    'win2k-shell32dll-shellexecute-bo':'14966',
    'zone-auto-authenticate':'15380',
    'sapdb-wahttp-bo':'11299',
    'rhel-rhsa-2002-136-update':'9521',
    'win-ms10kb977816-update':'5900002',
    'snmp-errorstatus-invalidtag':'12067',
    'softartisans-xfile-filemanager-bo':'12354',
    'backdoor-mavericks-matrix':'704',
    'session-cookie-remote-retrieval':'11561',
    'lotus-aw-applix-bo':'6042',
    'kernel-lsm-security-bypass':'5743',
    'RPC_Legato_Portmap_Unset':'2116024',
    'ISA_detected_possible_spoof_attack':'5492',
    'win-ms06kb923694-update':'14536',
    'rhel-rhsa-2005-320-update':'9895',
    'nt-fpnwclnt':'8079',
    'smtp-vrfy-bo':'11883',
    'win-ms12kb2653956-update':'5900002',
    'Dansie shopping cart':'1627',
    'rsagent-ssh-kerberos-KDC-spoofing':'11125',
    'nt-domain-user-blankpwd':'8059',
    'Oracle_Listener_Debug_DoS':'2113011',
    'CGI_mlog.html':'1196',
    'rhel-rhsa-2009-1490-update':'5900002',
    'lotus-domino-web-access':'6055',
    'linux-at-exetime-heap-corruption':'5918',
    'foxit-reader-title-bo':'5900002',
    'iis-404-sp-check':'4894',
    'HTTP_ColdFusion_SyntaxChecker_DOS':'2002618',
    'rhel-rhsa-2003-151-update':'9600',
    'PCAP_File_Detected':'5900002',
    'gdm-slavec-symlink':'3071',
    'RPC_NFS_Guess':'2103012',
    'user-homedir-or':'13967',
    'wireshark-ntp-format-string-win':'15132',
    'Image_EMF_GDI_Code_Execution':'5068',
    'rhel-rhsa-postgresql-update-dos':'10766',
    'rhel-rhsa-2011-0206-update':'5900002',
    'http-cgi-classifieds-read':'3567',
    'Firewall_Error':'2649',
    'user-homedir-ox':'13969',
    'HTTP_Empower':'2002694',
    'rhel-rhsa-2008-0617-update':'5900002',
    'POP3 date overflow':'8990',
    'LeakTest_trojan_horse_activity':'5859',
    'multiple-xupload-bo':'7490',
    'lanman-sec':'5803',
    'Oracle_Startup':'8610',
    'igame-cgagent-bo':'4881',
    'ibm-soliddb-solid-format-string':'4577',
    'Script_BitDefender_Code_Execution':'11381',
    'rsagent-exchange-nntp-unauth-command':'11033',
    'spyware-urlblaze':'12789',
    'sccp-stop-media-transmission':'11361',
    'timbuktu-login-bo':'5900002',
    'kernel-setsockopt-information-disclosure':'5759',
    'cisco-ios-bgp-packetdos':'1281',
    'spyware-grupox':'12581',
    'SNMP bad specific trap tag':'11979',
    'LPD_Delete_DotDot_Traversal':'2110098',
    'HTTP_PHP_Magic_Quote_Dir':'2121012',
    'sip-header-dos':'11615',
    'citrix-imaserver-dos':'5900002',
    'DCOM_RemoteActivate':'1663',
    'nt-dcom-access-permission':'8030',
    'rhel-rhsa-2011-0282-update':'5900002',
    'ISS UDP scan':'5548',
    'isa-server-nat-insecure':'5471',
    'barcode-bidib-code-execution':'797',
    'HTTP_OpenView_NNM_OvAcceptLang_Overflow':'5900002',
    'SNMP_Suspicious_Get':'2104019',
    'malcode-SPMZ_SoftIce_DO':'6575',
    'TCP OS fingerprint':'13371',
    'SNMP_Bad_Variable_Type':'2106118',
    'javascript-byte-splitting':'5589',
    'weakness-scanner':'14211',
    'nav-outdated-404':'7580',
    'Email_Recipient_Dot':'2001026',
    'desktop-elements-visible':'1772',
    'inotes-activex-bo':'5900002',
    'SNMP_InvalidTag_ErrorIndex':'2106090',
    'Exchange55_unauthenticated_pop3_command_invalidargs':'2309',
    'HTTP_Polycom_Reveal_Password':'2106127',
    'Script_KingSoft_SetUninstallName':'2114104',
    'win-rpc-dcom-bo':'14819',
    'Lotus_Domino_SMTP_Overflow':'6061',
    'kerberos-crossrealm-dos':'5900002',
    'DNS_IDN_Query':'1924',
    'ie-secure-site':'4836',
    'HTML_CMAILSvr_POP3_ActiveX':'3386',
    'voip-protocol-state-table-dos':'14172',
    'HTTP_iPlanet_Search_ViewFiles':'2106132',
    'ms-sqlserver-sp3-update':'7217',
    'SQL_MultipleXP_Overflow':'2121000',
    'SSH2_Hostbased_auth_failed_for_user':'13008',
    'Image_GIF_Malformed_Size':'2113256',
    'nt-network-guest':'8207',
    'decod-ftp-site':'1691',
    'win-ms09kb969883-update':'14732',
    'power-manager-login-bo':'9080',
    'win-ms08kb941203-update':'14621',
    'officescan-admin-access':'8421',
    'HTTP_Compaq_Insight_FormatString':'2113033',
    'malcode-EPA2':'6244',
    'malcode-EPA3':'6245',
    'passport-test-site-exposure':'8729',
    'cisco-land':'1311',
    'TCP_Probe_Lpr':'13439',
    'rhel-rhsa-2006-0437-update':'10123',
    'malcode-EPA4':'6246',
    'malcode-EPA5':'6247',
    'SSH_Kerberos_ticket_auth._failed':'13050',
    'XWINDOWS port probe':'15290',
    'FTP_Mkdir':'2948',
    'SNMP bad community tag':'11966',
    'meteor-ftpd-directory-traversal':'6994',
    'LHA_Lotus_Notes_Overflow':'5900002',
    'Ident_Newline':'2001905',
    'HTTP_Htimage_Dir':'2105007',
    'SMB_Skype_DLL_Hijacking':'5900002',
    'Bionet_email':'874',
    'keriomailserver-spam-filter-bo':'5718',
    'rhel-rhsa-2005-523-update':'9972',
    'rhel-rhsa-2004-136-update':'9687',
    'HTTP_GET_CreateTable':'2106169',
    'ldap-large-filter-detected':'5820',
    'nds-user-description':'7626',
    'fileview-activex-createnewfolder-bo':'2570',
    'Spyware_PH_BargainBuddy':'2113174',
    'malcode-Susp14e_ReEnter':'6749',
    'BackConstruction_Response':'2001539',
    'BOEP_detected':'966',
    'eva-forms-bo':'2223',
    'RIP_Add':'10785',
    'security-patch-needed':'11442',
    'openoffice-shell-command-execution':'8459',
    'win-2000-gdi32dll-dos':'14284',
    'shell-path-notdir':'11591',
    'blackberry-playbook-samba-code-execution':'5900002',
    'sam-file':'11261',
    'ie-xmlobject-code-execution':'4875',
    'malcode-Susp1_Write':'6754',
    'SSL_V3_MySQL_Hello_Overflow':'5900002',
    'mssql-xp-paraminfo-bo':'7437',
    'SAMI_DirectShow_Overflow':'11294',
    'tsm-cad-bo':'13809',
    'Privileged_service_called':'9109',
    'qpopper-pass-overflow':'9184',
    'jre-untrustedobject-ce':'5900002',
    'kingsoft-updateocx2-bo':'5783',
    'IMAP4 password overflow':'5152',
    'DNS ZXFR':'1862',
    'exchange-owa-ms04002-patch':'2294',
    'HTTP_FrontPage_Authors':'2105073',
    'maxdb-null-pointer-dos':'6942',
    'rhel-rhsa-2007-0208-update':'10274',
    'CompoundFile_PowerPoint_TextByte_BO':'2118083',
    'Swf_Bytecode_Stream_Spray':'5900002',
    'nlockmgr':'7853',
    'decod-netbios-grant':'1713',
    'Email_Mime_Filename_Overflow':'2102020',
    'IPM_Blocked_TCP_Connection':'5316',
    'EventCollector_Error':'2229',
    'HTTP_Google_Desktop_Installed':'3971',
    'Invalid User Settings':'5258',
    'snmp-bad-specific-trap':'12047',
    'firefox-liboggplay-code-execution':'5900002',
    'nt-guess-guest':'8113',
    'windowsmediaservices-callhtmlhelp-bo':'15049',
    'HTTP_WhiskerScan':'2000620',
    'spyware-beweb-srl':'12462',
    'cygwin-filename-bo':'1601',
    'uusee-play-code-execution':'5900002',
    'Telnet_NTLM_Tickle':'2000905',
    'ftpusers-onceonly':'3037',
    'ddos-mstream-zombie':'1674',
    'win-ms07kb944653-update':'14617',
    'rhel-rhsa-2007-0720-update':'10358',
    'AOLIM_File_Xfer':'394',
    'malcode-SPPE_SEHx2_DLLx2':'6692',
    'win-jscript-code-execution':'14356',
    'rhel-rhsa-2005-839-update':'10057',
    'EventHorizon':'2232',
    'HTTP GET data with repeated char':'3503',
    'ms-ie-tostatichtml-info-disc':'5900002',
    'imap4-long-mbox':'5155',
    'CGI_phf':'1203',
    'iis-cross-site-scripting':'4922',
    'man-s-bo':'6925',
    'spyware-piratos':'12689',
    'Image_EMF_Points_Write_Overflow':'2118051',
    'wuimapd-crammd5-gain-access':'15192',
    'malcode-SH2':'6523',
    'malcode-SH3':'6524',
    'malcode-VBASpawnsSus':'6861',
    'malcode-SH1':'6522',
    '95-verv-tcp':'29',
    'HTML_Panda_ActiveScan_BO':'2124026',
    'SNMP_snmpdx_attack':'12266',
    'ias-helpercom-dos':'4559',
    'package-deleted':'8703',
    'malcode-SPPE33b':'6648',
    'MSRPC TCP port probe':'7285',
    'rhel-rhsa-2011-0017-update':'5900002',
    'BackDoor_TCP_Response':'2113080',
    'ie-location-restriction-bypass':'4789',
    'icmp-timestamp-request':'4605',
    'rhel-rhsa-2007-0060-update':'10229',
    'Known_Rootkit_Login':'2116000',
    'oracle-appserver-oraclejsp-view-info':'8526',
    'xwin-installed':'15287',
    'SMS_Remote_Service_DoS':'2113114',
    'ms-win-file-code-execution':'5900002',
    'sasser-detected':'11304',
    'ssh-user-access':'12982',
    'IPSEC_policy_agent_changed':'5350',
    'HTTP_Manolito':'4145',
    'ASN1_Constr_BitStr_Heap_Corruption':'2120072',
    'citrix-ima-management-bo':'5900002',
    'komahayown-detected':'5787',
    'MSRPC_NETAPI_GetDomainInfo_Dos':'5900002',
    'apple-quicktime-pict-bo':'495',
    'HTTP_Csvform_Execute':'2106068',
    'rlogin-termbo':'10808',
    'bind-enabled':'843',
    'recoverymanager-fileuploadclass-file-upload':'5900002',
    'RIP_Expire':'10786',
    'oracle-database-aq-bo':'8540',
    'rpc.tooltalkd_overflow':'10927',
    'mailbee-mailbee-file-overwrite':'6114',
    'rhel-rhsa-2007-0323-update':'10286',
    'outlook-url-spoofing':'8691',
    'malcode-OutlookWorm':'6414',
    'http-post-compute-sum':'3664',
    'HTTP_Tivoli_Prov_Mgr_Malformed_Post':'2114134',
    'Trinoo master activity':'13769',
    'MSRPC_Srvsvc_Path_Bo':'2118139',
    'ISA_server_auth_failed':'5517',
    'Optix_Pro_Backdoor_Request':'2110092',
    'HTTP_WebDAV_Long_Rqst_DOS':'2106003',
    'adobe-reader-pdf-code-execution':'135',
    'squery-file-include':'5900002',
    'smtp-helo-bo':'11862',
    'TCP_Probe_DNS':'13430',
    'file-suid-dlink':'2547',
    'ident-invalid-response':'4651',
    'Finger_Command':'2001104',
    'win-emf-bo':'14321',
    'apache-rewrite-view-files':'470',
    'MSSQL65_Startup':'7440',
    'Sslvpn_TCP_Connect_Denied':'13113',
    'SSH_connection':'13035',
    'HTML_IE_URL_Exec':'3417',
    'TFTP_Alcatel_Update':'2003707',
    'win-ms06kb925486-update':'14546',
    'win2k3-deny-terminal-logon-privilege':'14990',
    'SSI safety overflow':'13070',
    'BGP_Notify_Msg':'822',
    'rhel-rhsa-2008-1017-update':'5900002',
    'HTTP_OrderLogDat':'2002550',
    'RPC_Mountd_Mnt':'10961',
    'NetRaider_TCP_Request':'2113133',
    'pcre-posixcharacter-dos':'8771',
    'win-ms10kb2345316-update':'5900002',
    'excel-hlink-bo':'2256',
    'joe-symlink-corruption':'5672',
    'MDB_MSJet_File_Overflow':'2113204',
    'openwsman-authentication-header-bo':'8509',
    'win-ms03051-patch':'14401',
    'mdaemon-webservices-dos':'6968',
    'bisonftp-bdl-directory-traversal':'878',
    'activereports-arview2-file-overwrite':'78',
    'sql-login-succeeded-audit':'12888',
    'Scada_IGSSdataServer_LogText_Format_String':'5900002',
    'Image_TIFF_libTiff_ThunderDecoder_Exec':'5900002',
    'busybox-passwd-weak-security':'1051',
    'CompoundFile_PowerPoint_SlideList_CodeExec':'2106233',
    'HTTP_Groupwise_WebAccess_GWinter_Bo':'3976',
    'Email_Virus_Suspicious_Zip':'2111020',
    'win2k-session-disconnect':'14963',
    'spyware-radlight':'12704',
    'fetchmail-multidrop-bo':'2452',
    'checkpoint-pasv-ftp':'1233',
    'win-ms12kb2661637-update':'5900002',
    'SMB_file_name_overflow':'11749',
    'frontpage-ext-device-name-dos':'2750',
    'ie-server-side-redirect':'4838',
    'malcode-SPCOM_MBR_AutoStrt':'6547',
    'backupexec-status-value-dos':'779',
    'openoffice-word-sprmtdeftable-bo':'5900002',
    'HP_NNM_AlarmSrv_Args_DoS':'5900002',
    'rhel-rhsa-2005-021-update':'9808',
    'rhel-rhsa-2010-0585-update':'5900002',
    'reg-tcpip-request':'9453',
    'Image_JPEG_IE_Component_Overflow':'2106199',
    'cisco-csmars-oracle-account':'1272',
    'rhel-rhsa-2003-246-update':'9621',
    'http-formmail':'3618',
    'win-ms11kb2570947-update':'5900002',
    'postgresql-makeselectstmt-input-bo':'9071',
    'ms-certificate-authority-spoofing':'5900002',
    'HTTP_ECware_DOS':'2106020',
    'ISS ping scan':'5546',
    'nt-posix-sub-c2':'8233',
    'freesshd-packet-dos':'5900002',
    'texinfo-sortoffline-symlink':'13618',
    'ssh-password-length-unauth-access':'12977',
    'glibc-glob-bo':'3108',
    'PmapSet':'8975',
    'nt-usernopw':'8359',
    'badtrans-worm':'784',
    'HTTP_Mdaemon_Form2Raw_BO':'2120014',
    'nt-systemlog':'8333',
    'avirt-pop3-pass-bo':'632',
    'win-ms09kb961373-update':'14716',
    'ldap-auth-failed':'5814',
    'ie-webviewfoldericon-code-execution':'4869',
    'HTTP_Acrobat_ActiveX_Overflow':'2113169',
    'tsc2-ctab-bo':'13808',
    'ca-brightstor-discovery-mailslot-bo':'1074',
    'update-group-baseline':'13916',
    'trojan-icmp-obtain-information':'13782',
    'helixserver-agentx-bo':'5900002',
    'rsagent-sqlserver-login-failed-userinvalid':'11112',
    'oracle9ias-application-cache-url-bypass':'8588',
    'telnet-env-long':'13538',
    'pdf-contains-gif':'5900002',
    'HTTP_PHP_Read':'4275',
    'igss-igssdataserver-dir-traversal':'5900002',
    'xmail-long-apop-bo':'15239',
    'Sslvpn_TCP_Connect_Failed':'13114',
    'win-ms03047-patch':'14397',
    'ie-frame-domain-verification':'4750',
    'win-ms12kb2597981-update':'5900002',
    'nt-shutdown-priv':'8308',
    'spyware-vizu-langochat':'12796',
    'HTTP_POST_TooMany_Parameters_DoS':'5900002',
    'winnt-pptp-dos':'15065',
    'ibm-ids-portmap-bo':'5900002',
    'Trojan_Coreflood':'13787',
    'rpc.nfs_lockd attack':'10906',
    'isa-h323-ms04001-patch':'5445',
    'nt-logon-batch':'8164',
    'rhel-rhsa-2009-1470-update':'5900002',
    'malcode-RCO2':'6434',
    'malcode-RCO3':'6435',
    'thunderbird-seamonkey-xbl-code-execution':'13698',
    'malcode-RCO1':'6433',
    'malcode-RCO6':'6438',
    'nt-netbios-allaccess':'8194',
    'nt-telnet':'8338',
    'malcode-RCO5':'6437',
    'realplayer-rjbdll-activex-bo':'9362',
    'Land_UDP':'5802',
    'Email_Mime_ContentType_Overflow':'2113226',
    'exploit-MSExcel(100006)':'2344',
    'malcode-EatVcisDatabase':'6235',
    'adobe-flash-content-code-execution':'5900002',
    'win-ms08kb946026-update':'14630',
    'adobe-acrobat-reader-image-bo':'110',
    'rhel-rhsa-2005-381-update':'9925',
    'adobe-geticon-bo':'127',
    'apache-tomcat-url-information-disclosure':'488',
    'HTTP_IIS_Trailing_Incomplete_Unicode':'2000612',
    'ie-installenginectl-setciffile-bo':'4781',
    'rc-command-missing':'9325',
    'rhel-rhsa-2002-255-update':'9544',
    'SSH_connection_for_user_not_allowed':'13036',
    'wsftp-xcrc-xsha1-xmd5-bo':'15180',
    'malcode-SPPE_WrtToSect_MaxSect':'6707',
    'http-get-arguments-audit':'3619',
    'rsagent-exchange-connect-administrative':'11023',
    'iis-utf8-evasion':'5000',
    'System_Warning':'13348',
    'HP_OpenView_SNMP_Backdoor':'2002021',
    'Infector_TCP_Response':'2113116',
    'HTTP_rguestexe':'2002525',
    'nt-guest-change-passwords':'8124',
    'spyware-gigatech-superbar':'12570',
    'crystalreports-file-deletion':'1551',
    'SNMP_SET_sysContact':'12263',
    'HTTP_IIS_ASP_Chunked_Overflow':'2105045',
    'sendmail-maillocal-dos':'11500',
    'ie-css-read-files':'4722',
    'print-jobs':'9106',
    'mercury-multiple-agent-bo':'6990',
    'Pict_PixData_Scanline_Overflow':'2114122',
    'PDF_Encoded_JavaScript_Tag':'2114161',
    'POP3 RETR overflow':'8998',
    'SOCKS_port_probe':'12352',
    'mozilla-chrome-information-disclosure':'7064',
    'HTTP_Content_Length_Invalid':'2125005',
    'metatreex-savetobmp-file-overwrite':'6993',
    'HTTP_Cgiproc_DoS':'2111015',
    'Mapped_account':'6933',
    'win2k-localgroup-created':'14936',
    'IIS password change':'4891',
    'Possible Fraggle attack initiated':'9054',
    'nav3-non-secure-submission':'7586',
    'rhel-rhsa-2006-0567-update':'10140',
    'apache-ipv6-aprutil-dos':'442',
    'malcode-SpawnsEncrypted':'6537',
    'display-properties-visible':'1834',
    'word-mail-merge-code-execution':'15152',
    'BOOTP_File_Overflow':'989',
    'LDAP_eDirectory_MonitorEventsRequest_Free':'2106284',
    'novell-edirectory-acceptlanguage-bo':'5900002',
    'FSP_Write_File':'2782',
    'rhel-rhsa-2005-524-update':'9973',
    'multimedia-file-integer-overflow':'7476',
    'rhel-rhsa-2008-0533-update':'10573',
    'RSS_Vista_Headline_Gadget_Code_Exec':'2114064',
    'rhel-rhsa-2007-0730-update':'10364',
    'globalscape-secure-ftp-bo':'3120',
    'aix-iy72701-fix':'228',
    'hellz-addiction-backdoor':'3278',
    'DNS_Authors_Request':'2106186',
    'irc-bo':'5376',
    'malformed-http-status-response':'6917',
    'Progenic':'9120',
    'passwd-comment':'8733',
    'HTTP_ISA_Rules_Engine_Bypass':'2120032',
    'MSM_GenericInformation':'7260',
    'aix-iy55361-fix':'173',
    'google-chrome-kernel-unspecified':'5900002',
    'CompoundFile_Excel_GIF_Malformed_Size':'2106231',
    'URL_File_URI_Overflow':'2110115',
    'afp-unspec-ce':'5900002',
    'logon-logoff-audit-events':'6029',
    'TFTP_TransportMode_Overflow':'5900002',
    'UDP port loopback':'13827',
    'Rootkit_install':'10842',
    'ieee80211-wep-disabled':'4879',
    'ms-hostintegration-udp-dos':'5900002',
    'win2k-deny-logon-locally':'14909',
    'isa-log-service-stopped-logging-failure':'5454',
    'excel-index-value-code-execution':'2257',
    'security-management-ping-bo':'11440',
    'rlogin-port-probe':'10806',
    'bind-qusedns-bo':'856',
    'COM_Killbit_Evasion':'1404',
    'HTTP_Calender_Admin':'2002582',
    'FTP_Syst':'3011',
    'rhel-rhsa-2008-0389-update':'10557',
    'EPolicy_Orchestrator_Format_String':'2113037',
    'MGCP_Long_Tid':'2104036',
    'malcode-VB_27':'6819',
    'spyware-win-pup32':'12814',
    'Sendmail_ParseAddr_BO':'11517',
    'rhel-rhsa-mozilla-javascript-code-execution':'10720',
    'MSRPC_MSDTC_VA_DoS':'2121052',
    'FTP_sam.__file':'2991',
    'rsagent-exchange-service-password-change':'11041',
    'exploit-WinApi(100042)':'2390',
    'win2k-message-queue-bo':'14943',
    'scada-modbus-reportslaveid-information':'11329',
    'Suspicious router advertisement':'13273',
    'SNMP_Dialup_Phone_Number':'2002015',
    'lion-linux-worm':'5994',
    'ie-activex-multiple-properties-dos':'4683',
    'skkddskk-temporary-files-insecure':'11680',
    'IAX_Malformed_Request':'5900002',
    'baofeng-backimage-titleimage-bo':'792',
    'iis-asp-data-check':'4900',
    'SNMP_bad_err_index_tag':'12147',
    'IPM_Dynamic_Rule_Expired':'5318',
    'apache-modjk2-bo':'450',
    'ms-sharepoint-privilege-escalation':'7203',
    'SNMP_Show_LMUsers':'2104031',
    'conficker-worm-detected':'1472',
    'CompoundFile_Excel_MSOPropertyTable_CodeExec':'2118095',
    'SQL_SSRP_Enum_Response':'12914',
    'nt-object-audit-success':'8217',
    'CGI view-source':'1165',
    'CGI_aglimpse':'1175',
    'rhel-rhsa-2005-019-update':'9806',
    'php-magicquotesgpc-directory-traversal':'8872',
    'vnc-installed':'14156',
    'HTTP_ApcRunner_ExecuteCode':'2118022',
    'pam-status-event':'8711',
    'multiple-libexif-exifdataloaddataentry-bo':'7484',
    'access-snapshot-viewer-bo':'36',
    'apache-403-cgi':'406',
    'Failed_to_add_object_security_descriptor':'2434',
    'malcode-SPNE_CrtRoot_Wrt':'6589',
    'nt-lookout-present':'8172',
    'malcode-VBAInstallCheck':'6858',
    'divisdvr-activeview-activex-bo':'1835',
    'YPPasswdOverflow':'15353',
    'malcode-SPPE9':'6653',
    'audit-ruleset-deletion':'603',
    'Doly_Response':'2001551',
    'ie-object-memory-corruption':'4815',
    'links-smbclient-command-execution':'5914',
    'HTML_Hostname_Overflow':'2113202',
    'HTTP_Unknown_Protocol':'2110094',
    'HTTP_VBA_Word_DLL_Hijacking':'5900002',
    'broadwin-activex-code-execution':'5900002',
    'rhel-rhsa-2007-1084-update':'10456',
    'shareaza-detected':'11580',
    'rhel-rhsa-2007-0095-update':'10249',
    'system-time-changed':'13339',
    'script-shell-command':'11377',
    'NFS_port_probe':'7825',
    'linux-identd-dos':'5933',
    'SMB_Real_Path':'2121008',
    'Image_EMF_GDI_Integer_Overflow':'5900002',
    'rsagent-localgroup-changed':'11067',
    'CART32_expdate':'1109',
    'realwin-scada-fcinfotagsetcontrol-bo':'9377',
    'backdoor-fore':'686',
    'IP_Fragment_Empty':'2000016',
    'CGI aglimpse':'1128',
    'TelnetLinkerBug':'13611',
    'blubster-piolet-rockitnet-request':'939',
    'SMB_Filename':'11750',
    'sslv2-detected':'13104',
    'rhel-rhsa-2003-305-update':'9636',
    'rhel-rhsa-2003-028-update':'9566',
    'win-upnp-http-bo':'14864',
    'ICQ_Witty_Worm':'2113063',
    'win2k-globalgroup-memberadded':'14924',
    'Virus_Found_In_File':'14101',
    'malcode-SPNE_Str_DTA_Srch':'6614',
    'SMB_Admin_Sneak':'2111017',
    'HTTP_CGI_Guestbook_Meta':'2002515',
    'rhel-rhsa-2011-0028-update':'5900002',
    'shockwave-director-bo':'5900002',
    'S2_Scan_Vulnerability_Found':'11249',
    'bind-version':'866',
    'proftpd-long-dir-bo':'9115',
    'decod-nmap':'1716',
    'spyware-softomate-toolbar':'12744',
    'firewall-config':'2641',
    'IRC_Trinity':'5406',
    'etherstatd':'2219',
    'backdoor-total-eclypse':'738',
    'ip-frag':'5273',
    'spyware-friend-toolbar':'12565',
    'linux-coredump-privilege-escalation':'5920',
    'FTP_AIX_Overflow':'2001328',
    'apache-debian-usrdoc':'423',
    'rhel-rhsa-2009-0436-update':'5900002',
    'nds-user-security-equivalent':'7643',
    'file-bin-not-stripped':'2464',
    'win-ms06kb917008-update':'14501',
    'aix-iy81424-fix':'263',
    'Session_reconnected':'11563',
    'IS_Low_Vulnerability_Found':'5424',
    'dafolo-stringparsing-bo':'1618',
    'firefox-autocomplete-dos':'2618',
    'rhel-rhsa-2004-105-update':'9682',
    'WRF_ATAS_CacheSize_Integer_Overflow':'5900002',
    'desktopcontroller-error':'1773',
    'MSM_StartStop':'7266',
    'win-ms06kb917283-update':'14503',
    'content-disposition-directory-traversal':'1488',
    'Informix_Long_Username_Overflow':'2114036',
    'JavaScript_Quantum_UploadLogs_Bo':'5640',
    'samba-calltrans2open-bo':'11264',
    'SNMP bad rqst id':'11978',
    'Email_Escaped_Quote':'5900002',
    'HTTP_OracleApp_Info':'2105021',
    'winamp-mp4-bo':'15014',
    'witty-worm-propagation':'15145',
    'rhel-rhsa-2005-020-update':'9807',
    'http-webadverts-adpassword':'3709',
    'PE_WinVerifyTrust_Signature_Exec':'5900002',
    'rhel-rhsa-2004-066-update':'9673',
    'php-mime-array-execute-code':'8880',
    'rhel-rhsa-2002-251-update':'9543',
    'services':'11555',
    'gnome-gdm-bo':'3124',
    'ms-kerberos-spoofing':'5900002',
    'win-ms08kb954211-update':'14672',
    'RPC_GetPort':'10951',
    'DNS name overflow very long':'1851',
    'rhel-rhsa-httpserver-expect-header-xss':'10698',
    'FTP_session_status_DoS':'2993',
    'user-ras-callback':'14005',
    'rhel-rhsa-2008-0980-update':'10617',
    'mozilla-rfc2047-bo':'7124',
    'sambar-dump-env':'11287',
    'rsagent-ipop3d-userlogin':'11062',
    'CompoundFile_Excel_Unspecified_BO':'2106230',
    'rhel-rhsa-2005-026-update':'9810',
    'sapgui-saplpd-bo':'5900002',
    'systems-management-bo':'13349',
    'Invalid_User_Settings':'5260',
    'bddt-backdoor':'806',
    'hsrp-default-password':'3352',
    'Registry_eventlog_settings_changed':'9464',
    'nds-user-no-logon':'7637',
    'malcode-SearchToInfect':'6511',
    'JavaScript_Unescape_Regex':'2110150',
    'ie-content-disposition-variant':'4716',
    'rhel-rhsa-2003-068-update':'9580',
    'spyware-ncase':'12662',
    'excelviewer-httpdownloadfile-file-download':'2274',
    'ISAKMP_Delete_SPI_DOS':'2107017',
    'mountd-file-exists':'7044',
    'trons-session-logging':'13798',
    'kernel-socketbuffer-dos':'5762',
    'CompoundFile_Publisher_String_BO':'2106239',
    'Finger Enumeration':'2576',
    'sendmail-debug-gain-information':'11486',
    'WAB_Overflow':'2109014',
    'Spyware_Gator_Detected':'2113216',
    'HTTP_PHP_Addslashes_ViewFiles':'2113171',
    'spyware-searchwww-hijacker':'12731',
    'HTTP_3com_AirConnect_RFSetup':'2106013',
    'HTTP_Tomcat_AcceptLanguage_DoS':'5900002',
    'spyware-deal-helper':'12515',
    'ntservicecontrol-smbpipe-access-detected':'8394',
    'hp-esupportdiagnostics-info-disclosure':'3303',
    'openssh-channel-error':'8467',
    'pamldap-config-format-string':'8714',
    'isa-server-auth-failed':'5469',
    'RPC prog grind':'10854',
    'rhel-rhsa-2011-0429-update':'5900002',
    'JavaScript_Agent_URL_Parsing':'2114046',
    'nds-alias-object':'7602',
    'rhel-rhsa-2005-481-update':'9958',
    'FTP_Pasv_DOS':'2001331',
    'HTTP_Swat_AuthBo':'2118010',
    'Firewall_Allow_Rule':'2645',
    'linux-tftp':'5977',
    'h225-length-bo':'3236',
    'mozilla-onunload-security-bypass':'7116',
    'unix-possible-rootkit-install':'13893',
    'allaire-jrun-view-directory':'319',
    'wireshark-cpfw1-format-string-win':'15110',
    'Rlogin_TERM_Very_Long':'2002104',
    'php-hash-dos':'5900002',
    'iis-ms04030-patch':'4967',
    'win-ms11kb2451879-update':'5900002',
    'rhel-rhsa-2005-348-update':'9912',
    'componentone-vsflexgrid-bo':'1423',
    'routed':'10843',
    'rhel-rhsa-2008-0855-update':'10589',
    'html-image-source-executable':'3365',
    'TCP ACK ping':'13364',
    'realplayer-mp3-id3-bo':'9357',
    'xchat-dns-execute-commands':'15204',
    'bennettec-activex-file-overwrite':'5900002',
    'oracle-appserver-plsql-pls-dos':'8529',
    'win-ms11kb2607670-update':'5900002',
    'vnc-rand-weak-cookie':'14158',
    'OpenView_NNM_Overflow':'8507',
    'nt-logon-script':'8168',
    'spyware-rbase01ath':'12708',
    'malcode-Susp13b':'6740',
    'malcode-Susp13c':'6741',
    'RPC_Xfsmd_Execute':'2115000',
    'spyware-radiate':'12703',
    'backupexec-calendar-file-overwrite':'773',
    'malcode-IRCNaughtyFileActions':'6357',
    'http-webdav-long-request':'3710',
    'mozilla-multiple-browser-code-execution':'7101',
    'ms-explorer-code-exec':'5900002',
    'netscape-javascript-access-data':'7735',
    'rhel-rhsa-2004-219-update':'9703',
    'win-ms09kb969516-update':'14730',
    'mayday-worm':'6946',
    'rhel-rhsa-2010-0678-update':'5900002',
    'jrun-forwardslash-auth-bypass':'5681',
    'rhel-rhsa-2007-1017-update':'10426',
    'SMTP_MIME_name_overflow':'11926',
    'win-ms11kb2509553-update':'5900002',
    'ie-frame-verification-read-files':'4753',
    'rsagent-exchange-pop3-unauth-invalidargs':'11037',
    'kernel-hid0-dos':'5734',
    'DNS_TCP_port_probe':'1958',
    'xinetd-insecure-permissions':'15229',
    'ms-iis-onsenddata-bo':'5900002',
    'rhel-rhsa-2007-0099-update':'10251',
    'malcode-SPTRJ_VB_Wrt_Serv':'6724',
    'asterisk-username-info-disclosure':'588',
    'HTTP_IE_URI_Arg_Injection':'2122017',
    'rhel-rhsa-2007-0061-update':'10230',
    'provideo-isscamcontrol-bo':'9146',
    'rhel-rhsa-2009-0018-update':'5900002',
    'DeltaSource_Response':'2001549',
    'malcode-ExeSeq01':'6248',
    'exploit-MSExcel(100038)':'2357',
    'mozilla-layoutengine-dos':'7098',
    'insane-network-trojan':'5231',
    'Citrix_Provisioning_Services_Overflow':'5900002',
    'javascript-suspicious-methodcall':'5900002',
    'http-track-detected':'3698',
    'malcode-HTMLDeletesFiles':'6327',
    'rhel-rhsa-2005-811-update':'10047',
    'HTTP_Oracle_Weblogic_Plugins_Code_Exec':'2124088',
    'nds-user-template-with-address-restriction':'7653',
    'spyware-gxb-dialer':'12582',
    'win-ms11kb2501584-update':'5900002',
    'HTTP_Google_Earth_DLL_Hijacking':'5900002',
    'rhel-rhsa-2007-0347-update':'10295',
    'spyware-purityscan':'12701',
    'HTTP_Frontpage_Path':'2105081',
    'SMTP_login_failed':'11912',
    'kernel-sg-dos':'5760',
    'HTML_CDF_XZone_Script':'2121015',
    'win-ms08kb949031-update':'14644',
    'win-ms07kb939653-update':'14602',
    'HTTP_IBM_Director_CIM_Consumer_DoS':'4002',
    'rpc.nfs uid is zero':'10905',
    'SNMP HP Route Metachar':'12004',
    'HTTP_Abyss_Conf':'2105035',
    'DPS_String_Overflow':'2106243',
    'HTTP_Adobe_ibfs32_DLL_Hijacking':'5900002',
    'HTTP_ColdFusion_Admin':'2002616',
    'CiscoSccp_Message_Overflow':'2119007',
    'rhel-rhsa-kernel-randomnum-weak-security':'10704',
    'mssql-resolution-service-bo2':'7428',
    'rhel-rhsa-2002-137-update':'9522',
    'mysql-select-data-into-file':'5900002',
    'Script_AOL_SuperBuddy_ActiveX_Code_Exec':'2124050',
    'sonicwall-nelaunchctrl-multiple-bo':'12401',
    'rpc.statd_dotdot_file_create':'10923',
    'reg-antivirus-not-installed':'9388',
    'oracle-bea-ssl-bo':'5900002',
    'sysstat':'13335',
    'rhel-rhsa-2009-0347-update':'5900002',
    'spyware-win32-spybot-b':'12826',
    'tls-ssl-over-http':'13716',
    'hp-emanate-default-snmp':'3302',
    'Failed_attempt_to_remove_DC_from_enterprise':'2419',
    'HTML_IE_TableInfo_Code_Exec':'2110140',
    'rpc.cmsd overflow':'10900',
    'CompoundFile_PowerPoint_TableProp_Overflow':'2106248',
    'RPC_PCNFSD_Backdoor':'2001710',
    'malcode-ObscureBrowser2':'6391',
    'ras_noaccess':'9317',
    'smb-shut-down-request':'11727',
    'gnupg-detached-sig-modify':'3134',
    'Reboot_Detected':'9380',
    'snmp-sysdescr':'12116',
    'RPC CALLIT mount':'10849',
    'HTTP_testcgitcl':'2002530',
    'ftp-anon':'2828',
    'iis-authentication-error-messages':'4906',
    'httptunnel-detected':'4550',
    'DarkConnectionInside_TCP_Request':'2113091',
    'network-login-successful':'7775',
    'spyware-ibis-toolbar':'12599',
    'spyware-huntbar':'12596',
    'SOLIDDB_Solid_Null_DoS':'12399',
    'stun-detected':'13163',
    'adobe-library-bo':'5900002',
    'officeocx-vulnerable-activex-detected':'8419',
    'exploit-MSWord(100027)':'2380',
    'Scada_Modbus_AckExceptionDelay':'11341',
    'apache-tomcat-nativeconnector-weak-security':'487',
    'OSPF_Unknown_Msg_Type':'2110016',
    'trellian-pasv-bo':'5900002',
    'word-malformed-string-code-execution':'15153',
    'mssql-spreplwritetovarbin-bo':'5900002',
    'win-ms09kb973965-update':'14758',
    'Image_BMP_Office_Code_Exec':'5064',
    'FTP_Cisco_IOS_MKD_BO':'2892',
    'TCP_ACK_Ping':'2000310',
    'MountdMnt':'7047',
    'TCP_FIN_or_RST_seq_out-of-range':'13407',
    'Infector_Response':'5211',
    'spyware-ebates-moneymaker':'12539',
    'POP_Filename_Chars':'2000707',
    'win2k-telnet-domain-authentication':'14973',
    'malcode-RemoteDropper2':'6453',
    'HTML_Webbrowser_Object_Code_Execution':'2109023',
    'rhel-rhsa-php-print-odbc-format-string':'10754',
    'FTP_Lnk_File_Accessed':'5900002',
    'SNMP_V3_Flags_Overflow':'2101060',
    'brightstor-lgserver-port2200-bo':'1010',
    'dameware-username-bo':'1622',
    'FTP_Virus_Wm_Marker_A':'2002204',
    'nt-increase-priority-onceonly':'8139',
    'Gnutella_Connect':'3150',
    'HTTP_3com_AirConnect_ModemSetup':'2106012',
    'ms-sharepoint-xml-file-disclosure':'5900002',
    'aix-iy61954-fix':'184',
    'rsagent-ipop3d-autologout':'11057',
    'RPC_BrightStor_ARCserve_XDR_BO':'10940',
    'iis-special-chars':'4986',
    'libpng-pnghandle-bo':'5876',
    'rc-file-owner':'9329',
    'SensorStatistics_Cumulative':'11527',
    'http-parameter-pollution':'5900002',
    'ie-cache-script-injection':'4704',
    'mediaplayer-html-shortcut':'6978',
    'ms-ie-cached-code-execution':'5900002',
    'rhel-rhsa-2005-767-update':'10023',
    'NetBus port probe':'7699',
    'RAS_URQ_EndpointId_Change':'2106308',
    'ie-title-change-code-exec':'5900002',
    'cisco-linksys-wvc200-activex-bo':'5900002',
    'cisco-ios-udp-dos':'5900002',
    'CyberCop Scan':'1590',
    'cvs-doublefree-memory-corruption':'1568',
    '3com-ap-wep-key':'14',
    'SNMP_Bad_BulkRqst_Id':'12140',
    'snmp-enterprise-invalidtag':'12065',
    'rhel-rhsa-2003-094-update':'9587',
    'Rlogin_Known_User':'2002105',
    'win-ms11kb2451910-update':'5900002',
    'HTTP_Bugbear_Backdoor':'2106163',
    'rhel-rhsa-2008-0839-update':'10585',
    'TCP_Hijacking_Tool':'13414',
    'kernel-ipv6getsockoptsticky-dos':'5738',
    'SDP_Asterisk_RTP_Codec_Payload_BO':'11414',
    'Pict_Poly_Underflow':'8939',
    'snmp-generictrap-invalidtag':'12071',
    'sametime-stmux-bo':'11292',
    'winamp-ioffsetmusic-bo':'5900002',
    'telephonedirectory2008-code-id-sql-injection':'13505',
    'ppmedia-class-activex-bo':'9088',
    'rhel-rhsa-2008-0267-update':'10545',
    'datapark-hostname-sql-injection':'1643',
    'ie-iframe-document-script-execution':'4773',
    'HTTP_Dansie_Infoleak':'2002751',
    'win-ms07kb929123-update':'14570',
    'backdoor-coma':'672',
    'Cart32 Clientlist URL':'1102',
    'dhcp-request':'1796',
    'ms-smb-transaction-code-exec':'5900002',
    'documentum-dmcltrace-file-overwrite':'1977',
    'rhel-rhsa-2005-829-update':'10052',
    'avax-vector-activex-bo':'623',
    'win-ms04008-patch':'14403',
    'PPTP_malformed':'9096',
    'ourgame-gliedown2-activex-gameinfo-bo':'8664',
    'spyware-intotel-srl':'12613',
    'Sslvpn_TCP_Connect':'13112',
    'CyberCop_Scanner_Radius':'2102007',
    'FTP_Initial_Response_Format_String':'5900002',
    'rhel-rhsa-2003-280-update':'9629',
    'SNMP nonzero len null type':'12013',
    'openssl-ssl2-masterkey-bo':'8497',
    'HTTP_URL_contains_%00':'4444',
    'AOLIM_Trillian_Encrypt_Handshake':'399',
    'Swf_Suspicious_ActionScript':'2114168',
    'HTTP_PHP_TooMany_Parameters_Array_Overflow':'5900002',
    'HTTP_Tomcat_TransferEncoding_DoS':'5900002',
    'whois':'14281',
    'xfs-protocol-requests-bo':'15222',
    'Telnet_Environment_Format_String_Attack':'13569',
    'Telnet_Xdisplay':'13594',
    'ruby-socket-dos':'11224',
    'gnuradius-sqllog-format-string':'5900002',
    'ie-frame-domain-file-access':'4749',
    'firefox-be-code-exec':'2619',
    'rhel-rhsa-2008-0976-update':'10614',
    'Ident_User':'4667',
    'cvs-long-tag-detected':'1572',
    'rhel-rhsa-2006-0697-update':'10189',
    'Image_GDI_EMFPlusFont_DoS':'2101079',
    'win-ms07kb940965-update':'14604',
    'MHTML_CRLF_Injection':'5900002',
    'ibm-db2-adminserver-privilege-escalation':'4563',
    'XML_QuickTime_QTL_Long_Type':'15256',
    'gtrust-perms':'3219',
    'rhel-rhsa-2007-0533-update':'10334',
    'rhel-rhsa-2007-0068-update':'10234',
    'mozilla-dataurl-xss':'7070',
    'rhel-rhsa-2007-0966-update':'10412',
    'backdoor-progenic':'716',
    'hpinfo-hpinfo-command-execution':'3339',
    'malcode-Susp_MBR_SectorWrite':'6767',
    'snmp-null-in-string':'12094',
    'EventCollector_Warning':'2231',
    'gift-download-detected':'3092',
    'autonomy-keyview-kvdocve-bo':'620',
    'Possible Smurf attack initiated':'9055',
    'HP_NNM_Topology_DoS':'2101080',
    'oracledatabase-tnslistener-spoofing':'5900002',
    'sojourn-file-read':'12360',
    'soundconverter-sndconverter-file-overwrite':'12409',
    'winxp-sp3-not-installed':'15105',
    'realwin-scada-sprintf-bo':'5900002',
    'rhel-rhsa-2003-103-update':'9590',
    'mssql-resolution-keepalive-dos':'7426',
    'msql-detect':'7284',
    'TCP_Connections_Rate_Flood':'5900002',
    'rhel-rhsa-2006-0695-update':'10188',
    'rhel-rhsa-2005-406-update':'9936',
    'HTTP_JSP_SourceRead':'2000632',
    'ident-error':'4650',
    'IP last fragment length changed':'5266',
    'mailman-unspecified-xss':'6124',
    'rhel-rhsa-2007-0126-update':'10259',
    'RealServer_Denial-of-service_URL':'9375',
    'eleonore-exploit-kit-detected':'5900002',
    'ms-win-phonebook-code-exec':'5900002',
    'mdac-ms04003-patch':'6958',
    'BitTorrent_DHT_Ping':'892',
    'rhel-rhsa-2005-420-update':'9944',
    'Stumbler_Probe':'2103025',
    'Massaker_TCP_Response':'2113122',
    'HTTP_IIS_Obtain_Code':'2000633',
    'mssql-registry-insecure-permissions':'7424',
    'ca-psform-activex-code-execution':'5900002',
    'win-ms10kb983235-update':'5900002',
    'BackOrifice2K_UDP_Request':'2100018',
    'hpdataprotector-http-dos':'5900002',
    'HTTP_Oracle_Weblogic_Connector_BO':'4228',
    'backup-product-buffer-overflow':'767',
    'SubSeven_IRC_notification':'13184',
    'IMAP_NTLM_Authenticate_Overflow':'5900002',
    'ms-smb-ntlm-priv-esc':'5900002',
    'malcode-ExploitCodeExe':'6301',
    'rhel-rhsa-2002-271-update':'9549',
    'firefox-webworkers-js-code-execution':'5900002',
    'User_logout':'14040',
    'openview-nnm-ovparsella-bo':'5900002',
    'mozilla-addeventlistener-xss':'7058',
    'QuickTime_OBJI_Overflow':'9270',
    'malcode-SPNE_mal_dll':'6597',
    'SIP_Long_Header_Value':'2120065',
    'SSH_Kerberos_TGT_rejected':'13049',
    'CGI_tcsh':'1208',
    'weblogic-plugin-bo':'14240',
    'rsagent-authpackage-loaded':'11016',
    'HTTP_Smuggling_Apache_Chunked':'2118040',
    'malcode-SPNE_int3_IVT':'6594',
    'HTML_IE_Title_Change_Exec':'5900002',
    'adobe-flash-dnsrebinding-security-bypass1':'122',
    'file-link-absolute':'2517',
    'HTML_IE_Selection_Object_Execution':'5900002',
    'ie-ms04038-patch':'4802',
    'nortel-ipphone-unistim-audio-hijacking':'7902',
    'nt-restore':'8284',
    'SNMP int overflow':'12006',
    'google-desktop-installed':'3161',
    'celine-backdoor':'1117',
    'HTTP_OfficeScan_Auth_Bypass':'4206',
    'Rsh_Session':'11200',
    'HTTP_CGI_CsGuestbook_Code_Execution':'2114057',
    'IDT_Modification_Detected':'4675',
    'silentrunner-collector-poppass-bo':'11608',
    'Exchange_unauthenticated_pop3_command':'2327',
    'PhaseZero_Response':'2001518',
    'win-sid-gain-privileges':'14839',
    'ie-adodbstream-code-execution':'4687',
    'tivoli-rembo-bo':'13710',
    'rhel-rhsa-2008-0885-update':'10594',
    'HTTP_CGI_Fastgraf':'2002662',
    'blackice-adapter-connect-failed':'905',
    'DNS name overflow contains %':'1850',
    'imail-status-bo':'5133',
    'DataProtector_EXEC_CMD_Exec':'5900002',
    'SNMP_FormatString':'2106116',
    'HTTP_AuthFilter_ISAPI_Overflow':'2113002',
    'DNS_WPAD_Registration':'2101070',
    'firefox-documentwrite-bo':'5900002',
    'iis-ftp-session-status-dos':'4934',
    'rhel-rhsa-2009-0270-update':'10623',
    'HTTP_GET_Filename_mysql':'2003807',
    'application-rpc-config1-bo':'517',
    'aix-iy67655-fix':'214',
    'sapgui-sapbexcommon-command-exec':'5900002',
    'movenetworks-qmpupgrade-bo':'7056',
    'HTML_Element_Location_Traversal':'3392',
    'win-ms05kb873333-update':'14422',
    'SNMP version underflow':'12039',
    'ike-association-failed-bad-auth-params':'5025',
    'spyware-getmirar':'12569',
    'XML_WebDAV_MiniRedirector_BO':'15261',
    'Oshare attack':'8636',
    'ms-directshow-mjpeg-code-execution':'7168',
    'officeviewer-openwebfile-file-execution':'8426',
    'Fraggle_Attack':'2000205',
    'nt-rasman-pathname':'8265',
    'TCP_Probe_MSRPC':'13440',
    'backdoor-snidx2':'727',
    'exploit-MSWord(100004)':'2376',
    'exploit-WinApi(100044)':'2392',
    'IP_Ping_Of_Death_Jolt':'2000019',
    'Global_group_changed':'3112',
    'netcontroller-backdoor':'7706',
    'rhel-rhsa-2009-1459-update':'5900002',
    'nis-uid-unique':'7847',
    'http-prorat-notification':'3675',
    'rpc.ypupdated command':'10928',
    'realplayer-pls-bo':'9358',
    'PDF_Stream_Hiding':'8809',
    'spyware-windupdates':'12830',
    'spyware-wotch-mediaman':'12837',
    'telnet-env-all':'13537',
    'cbc-pnllmcli-file-overwrite':'5900002',
    'Bonk':'2000007',
    'snmp-community-invalidtag':'12053',
    'CHARGEN_port_probe':'1232',
    'mediaplayerclassic-ehtrace-code-exec':'5900002',
    'NetSphere_Response':'2001523',
    'malcode-W32_Worm':'6872',
    'Oblivion_TCP_Response':'2113077',
    'rhel-rhsa-2004-056-update':'9668',
    'HTTP_repeated_character':'2000611',
    'firebirdsql-opconnectrequest-dos':'5900002',
    'win-ms11kb2567943-update':'5900002',
    'FTP_login_failed':'2941',
    'IPFrag':'5309',
    'win2003-sp1-not-installed':'14889',
    'tivoli-rembo-dos':'5900002',
    'nt-tcpip-security':'8336',
    'file-suid-script':'2548',
    'lotus-kvarcve-directory-traversal':'6057',
    'HTTP URL with repeated char':'3543',
    'spyware-claria':'12487',
    'rhel-rhsa-2011-0511-update':'5900002',
    'win-ms06kb913433-update':'14490',
    'spyware-starr-pro':'12751',
    'rhel-rhsa-2009-0008-update':'5900002',
    'anonymous-ftp-onceonly':'364',
    'HTTP_WmvDownloader_B':'2106185',
    'malcode-InvalidDLL':'6353',
    'nt-netbios-everyoneaccess-printer':'8196',
    'Email_Mime_Filename_Blanks':'2102018',
    'SQL_Empty_Password_Failed':'12896',
    'SMB_win.ini_file':'11796',
    'snmp-set-guess':'12106',
    'nfs-uid':'7821',
    'QuickTime_Shellcode_Detected':'5900002',
    'easymail-emimap4-activex-code-execution':'2027',
    'win-ms07kb927779-update':'14565',
    'sfu-nfs-dos':'11565',
    'ms-powerpoint-file-path-bo':'5900002',
    'nt-backup-operator':'7997',
    'ip-hijack':'5277',
    'nt-group-restore':'8103',
    'ebuddy-detected':'2032',
    'gtp-u-station-to-station':'3205',
    'Coma':'1405',
    'office-drawing-code-execution':'8406',
    'win-igmpv3-dos':'14348',
    'kernel-sctpnew-dos':'5757',
    'ms-office-groove-code-exec':'5900002',
    'Y3K_RAT':'15302',
    'solaris-xsun-xprt-command-execution':'12390',
    'rhel-rhsa-2005-040-update':'9820',
    'rhel-rhsa-2004-479-update':'9754',
    'win-system-time-changed':'14851',
    'spyware-stoppop':'12753',
    'rsagent-program-exited':'11097',
    'win-server-rpc-code-execution':'14831',
    'SSH2_Username_too_long':'13028',
    'reg-sec-notrestricted-admin':'9437',
    'iis-files-accessible':'4929',
    'installshield-oneclick-code-execution':'5236',
    'ca-arcservebackup-rxrlogin-bo':'1070',
    'cyn-backdoor':'1602',
    'Citrix_Provisioning_Services_Exec':'5900002',
    'ms-officeweb-activex-code-execution':'7192',
    'RPC_Netware_Callit_Overflow':'5900002',
    'ms-win-cover-code-execution':'5900002',
    'openview-dopost-code-execution':'5900002',
    'LDAP_Null_Field':'5849',
    'SECURITY_SAM_reg_hack':'11474',
    'H225_Signaling_Message_Order':'3242',
    'VmRegisteredEvent':'14131',
    'Telnet_Auth_User':'13557',
    'rhel-rhsa-2008-1025-update':'5900002',
    'win-taskscheduler-bo':'14852',
    'decod-trin00-master-connect':'1755',
    'icmp-source-quench':'4604',
    'Bootparam':'2001727',
    'viavideo-webserver-get-bo':'14080',
    'vmware-createprocess-code-execution':'14143',
    'Trin00_Daemon_Response':'2001525',
    'glibc-getgrouplist-bo':'3107',
    'rhel-rhsa-2010-0607-update':'5900002',
    'ms-win-otf-priv-escalation':'5900002',
    'ms-win-explorer-bo':'5900002',
    'HTTP_SoftCart_StoreMgrPw':'2002553',
    'IIS sample URL':'4892',
    'SubSeven_trojan_horse_activity':'13191',
    'ezmall2000-misconfig':'2407',
    'Land':'5800',
    'Global_group_user_removed':'3116',
    'novell-edirectory-httpstk-bo':'7913',
    'rhel-rhsa-2007-0125-update':'10258',
    'FTP_command_too_long':'2897',
    'malcode-RestrictedFIO':'6463',
    'aix-iy72761-fix':'236',
    'zone-activeX-execution':'15379',
    'spyware-7fasst':'12422',
    'DNS_RDATA_TXT_Overflow':'1951',
    'postgresql-contribintagg-dos':'9064',
    'ie-html-helpfile-execute':'4767',
    'HTTP_KnowledgeBuilder_CodeExecution':'2107006',
    'win-ms09kb969897-update':'14733',
    'FTP hosts file':'2797',
    'Firewall_DNS_and_ICMP':'2648',
    'backdoor-millenium':'705',
    'apache-modssl-error-dos':'460',
    'Content_Analyzer_Email_Addr':'2120080',
    'ssl-weak-cipher-support':'13087',
    'cafeini-backdoor':'1090',
    'kernel-ule-dos':'5770',
    'sendmail-running':'11510',
    'oracle-dbmsstats-sql-injection':'8548',
    'yahoo-webcam-upload-bo':'15327',
    'rhel-rhsa-2004-096-update':'9680',
    'libxml2-dtd-dos':'5900002',
    'rhel-rhsa-2003-404-update':'9649',
    'Dameware_UserName_Overflow':'2113215',
    'multiple-users-onceonly':'7488',
    'wireshark-ssh-dos':'15139',
    'nt-power-user-pwd':'8237',
    'malcode-SmallWritesVirus':'6529',
    'GateCrasher trojan horse activity':'3053',
    'SNMP varbindlist underflow':'12038',
    'spyware-win32-hllw-nebiwo':'12818',
    'SMB_Dwmapi_DLL_Hijacking':'5900002',
    'intel-wireless-driver-privilege-escalation':'5242',
    'HTML_Rendering_Memory_Corrupt':'2109007',
    'isa-pf-dial-out-rebind-failure':'5457',
    'tomcat-httpservletresponse-xss':'13724',
    'malcode-NetExploits':'6383',
    'rsagent-suspect-telnet':'11155',
    'dpapi-auditable-data-unprotected':'1994',
    'HTTP_IIS_Track':'2118014',
    'linux-diffutils-sdiff-symlink':'5922',
    'win-ms07kb942099-update':'14611',
    'telnet-terminaltype':'13545',
    'SMB_Win_ini_file':'2002705',
    'freepbx-callerid-command-execution':'2729',
    'NetBIOS port probe':'7683',
    'SNMP uint overflow':'12032',
    'TelnetAuthLoki':'13599',
    'malcode-SPPE_WrtSect65_Wk':'6706',
    'spyware-vx2-betterinternet':'12797',
    'rhel-rhsa-2005-238-update':'9880',
    'ms-ias-privilege-escalation':'7178',
    'tcp-os-fingerprint':'13390',
    'serverprotect-stcommondll-bo':'11538',
    'win-ms10kb981997-update':'5900002',
    'iscbind-update-dos':'5900002',
    'xorg-xserver-render-overflow':'15278',
    'win-ms05kb908523-update':'14465',
    'rhel-rhsa-2003-372-update':'9644',
    'RPC suspicious credentials':'10861',
    'nt-guest-group':'8126',
    'mdac-broadcastrequest-bo':'6955',
    'cgiscript-url-execute-commands':'1220',
    'rhel-rhsa-2010-0704-update':'5900002',
    'rhel-rhsa-2005-256-update':'9881',
    'sun-java-image-bo':'13206',
    'share-enumeration':'11577',
    'HTTP_Lnk_File_Accessed':'5900002',
    'win-ms07kb938127-update':'14598',
    'iis-redirect-bo':'4976',
    'rhel-rhsa-2007-1038-update':'10440',
    'Rlogin login name well known':'10797',
    'nt-os2-sub-onceonly':'8222',
    'rhel-rhsa-2006-0759-update':'10210',
    'mozilla-svg-code-execution':'7130',
    'win-ms10kb980150-update':'14790',
    'http-url-repeated-characters':'3705',
    'SSH_Rhosts_auth._refused':'13053',
    'Java Admin Servlet backdoor URL':'5575',
    'PDF_Submission_Heap_Abuse':'5900002',
    'win2k-universalgroup-changed':'14984',
    'malcode-DropExciter':'6219',
    'apache-mime-information-disclosure':'443',
    'rhel-rhsa-2003-399-update':'9648',
    'SIP_Invalid_To':'2114010',
    'powertcp-ftp-activex-bo':'9087',
    'rhel-rhsa-2003-085-update':'9584',
    'Helix_Universal_Transport_Overflow':'2118105',
    'isa-corrupt-storage-svc-failed':'5435',
    'MIF_Notes_Token_Overflow':'5900002',
    'share-owner-change':'11578',
    'spyware-shopnav-hijacker':'12740',
    'nt-add-workstation':'7969',
    'FastTrack_Download':'2439',
    'HTTP_GET_ComputeSum':'2106171',
    'HTML_Windows_Mail_Exec':'2109029',
    'file-insecure-permissions':'2514',
    'edonkey-detected':'2049',
    'win-named-pipe-information-disclosure':'14797',
    'xwindow-port-probe':'15289',
    'win-ms09kb973309-update':'14752',
    'openswan-strongswan-dpd-dos':'5900002',
    'DNS_NXT_record_overflow':'1947',
    'RADIUS User Overflow':'9286',
    'group-members':'3176',
    'HTTP_Java_Hotspot_Hijack':'5900002',
    'spyware-whenusave':'12807',
    'ms-office-tiff-bo':'5900002',
    'brightstor-lgserver-dos':'1008',
    'malcode-W32_Dialer_Generic':'6868',
    'nt-access-network':'7958',
    'Application_Compliance_Warning':'526',
    'ras_auth_rasfail':'9315',
    'cvs-long-argument-detected':'1570',
    'NNTP_XchgAuth':'7885',
    'nis-version':'7849',
    'win-ms10kb975561-update':'14777',
    'DNS_Malformed_Flood':'2103038',
    'HTTP_Win_ADFS_Code_Exec':'4524',
    'iis-webdav-xml-dos':'5010',
    'win-ms08kb953155-update':'14662',
    'phpadsnew-logout-sql-injection':'8919',
    'password-not-changed':'8743',
    'cisco-aaa-tcl-auth-bypass':'1252',
    'mssql-text-message-bo':'7435',
    'win-ms08kb947108-update':'14636',
    'mozilla-js-constructor-code-execution':'7094',
    'IMAP_Imail_Overflow':'2103002',
    'Image_GIF_CompressionError':'2111022',
    'frontpage-ext-shtml-multiple-dos':'2756',
    'NetBus response':'7700',
    'aix-iy70026-fix':'223',
    'win-ms07kb926122-update':'14561',
    'net-devil-backdoor':'7675',
    'spyware-freeaccess':'12563',
    'tivoli-endpoint-lcfd-bo':'5900002',
    'service-added':'11541',
    'RFProwl_exploit':'9508',
    'rhel-rhsa-2007-0957-update':'10408',
    'rhel-rhsa-2005-059-update':'9827',
    'phpbb-view-sql-injection':'8921',
    'nt-beta':'8002',
    'Script_Odd_Location_Assignment':'5900002',
    'icmp-read-memory':'4601',
    'IGMP fragments':'4882',
    'HTTP_HP_PowerManager_Login_BO':'3991',
    'audit-rule-deletion':'602',
    'nt-backup-onceonly':'7994',
    'rpc-getport-probe':'10876',
    'Excel_Style_Record_Exec':'5900002',
    'rhel-rhsa-2012-0677-update':'5900002',
    'CGI_nph-test-cgi':'1199',
    'FTP_Restart_Very_Long':'2001345',
    'NetRaider_TCP_Response':'2113134',
    'HTR localstart overflow':'3479',
    'msrpc-lsa-lookupnames-dos':'7290',
    'darwin-describe-request-dos':'5900002',
    'rhel-rhsa-2005-307-update':'9894',
    'RIFF_CorelDraw_Integer_Overflow':'5900002',
    'xcheck-keystroke':'15205',
    'mirc-ircprotocol-execute-code':'7025',
    'mysql-select-bo':'7530',
    'backdoor-netsphere13':'709',
    'antisniff-arptest':'370',
    'kernel-cifs-security-bypass':'5724',
    'reg-ras-auth-retires':'9421',
    'rsagent-qpopper-userprobe':'11100',
    'reg-logon-password-caching':'9405',
    'rhel-rhsa-dbus-matchruleequal-dos':'10684',
    'ezshopper-search-cgi':'2412',
    'cisco-ios-snmp-udp-dos':'1304',
    'rhel-rhsa-2007-0124-update':'10257',
    'irr-bbf-code-execution':'5900002',
    'rhel-rhsa-2008-0039-update':'10481',
    'ms-outlook-smb-code-execution':'5900002',
    'unzip-dotdot-directory-traversal':'13907',
    'ie-telnet-command-execution-variant':'4849',
    'HTTP_DCForum_File_Upload':'2002669',
    'HTTP_GET_SQL_UnionAllSelect':'2113027',
    'malcode-VB_DropNgo':'6837',
    'spyware-trusttoolbar':'12780',
    'malcode-Susp_SnkInt_MCB_BiosMem':'6774',
    'Exchange55_unauthenticated_pop3_command':'2307',
    'HTML_ASP_Malformed':'2113255',
    'Virus_Found_In_Encapsulating_Object':'14100',
    'file-wtmp-insecure':'2563',
    'nt-netbios-open-printer':'8200',
    'ie-msdauth-code-execution':'4806',
    'rhel-rhsa-2003-239-update':'9618',
    'Quake_Backdoor_Request':'2001503',
    'SMTP_ENVID_overflow':'11898',
    'ID3_Win_Media_MP3_Code_Exec':'4638',
    'Script_Yahoo_WebCam_Upload_Bo':'2124058',
    'rpc.pcnfs backdoor':'10912',
    'Finger_Search':'2001108',
    'NNTP_Control':'7870',
    'Viewexample.cfm':'14083',
    'rhel-rhsa-2006-0689-update':'10187',
    'win-ms07kb943078-update':'14615',
    'Flash_Director_Corrupt_Lscr':'5900002',
    'rhel-rhsa-2010-0977-update':'5900002',
    'Finger':'2592',
    'ftp-exectar':'2843',
    'trin00-daemon':'13764',
    'MSRPC_Locator_BO':'2102032',
    'file-nonexistant-gid':'2529',
    'TCP_Flag_SynUrg':'2000317',
    'rhel-rhsa-2009-1107-update':'10668',
    'Glacier_Response':'3104',
    'SNMP_Corrupt':'12187',
    'TLS_OpenSSL_ECDH_DoS':'5900002',
    'nt-4-postsp2':'7956',
    'FTP_win.ini_file':'3025',
    'exploit-MSExcel(100045)':'2359',
    'openssh-packet-bo':'8472',
    'Rlogin_login_name_overflow':'10816',
    'ms-ie-vml-code-exec':'5900002',
    'apache-ssi':'480',
    'rhel-rhsa-2009-1233-update':'5900002',
    'anonftp-mail':'361',
    'novell-edirectory-ldap-bo':'5900002',
    'iis-authchangeurl-dos':'4905',
    'Android_Malware_Detected':'5900002',
    'Application_Compliance_Error':'525',
    'spyware-openme':'12683',
    'malcode-vba93_02':'6847',
    'rhel-rhsa-2006-0738-update':'10204',
    'mssql-jet-oledb-enabled':'7407',
    'group-not-unique':'3178',
    'rsagent-sybase-configuration-file':'11159',
    'rsagent-localgroup-userremoved':'11071',
    'malcode-vba93_04':'6849',
    'NIS_Overflow':'7850',
    'RIFF_Director_Pointer_Overwrite':'5900002',
    'wireshark-lltdissector-dos':'15122',
    'malcode-HTMLSusFileIO':'6335',
    'spyware-abetterinternet':'12426',
    'rc-path-notdir':'9334',
    'HTTP_IIS5_PROPFIND_DAV_attack':'4041',
    'imagestation-axruploadserver-bo':'5124',
    'aix-iy89434-fix':'298',
    'spyware-cnsmin':'12498',
    'FW1_Auth_As_Local':'2103013',
    'win-ms10kb978262-update':'14788',
    'path-cwd':'8750',
    'spyware-unknown':'12787',
    'rhel-rhsa-2009-0334-update':'10634',
    'icq-present':'4631',
    'excel-style-record-code-execution':'5900002',
    'POP3_MIME_filename_repeated_chars':'9012',
    'HTTP_RobotsTxt':'4357',
    'msvm-bytecode-improper-validation':'7459',
    'Finger_Overflow_RTM':'2103007',
    'service-pathname-change':'11547',
    'AOM_Url_Overflow':'2109019',
    'MSRPC_TrendMicro_Suspicious_Call':'7386',
    'wuftpd-restrictedgid-gain-access':'15189',
    'rhel-rhsa-2007-1129-update':'10463',
    'cobalt-raq-history-exposure':'1375',
    'Asylum':'590',
    'softcart-misconfig':'12356',
    'HTTP_POST_NetworkNodeManager_Overflow':'5900002',
    'TelnetAuthSpx':'13602',
    'quicktime-pnsize-pict-file-bo':'5900002',
    'netscape-view-mixed':'7742',
    'mneah-backdoor':'7030',
    'scada-modbus-pdu-length':'11327',
    'frontpage-pwd-administrators':'2760',
    'Oracle_Failed_Object_Access':'8596',
    'Script_IE_HTML_Same_Id':'5900002',
    'spyware-ibsdialer':'12600',
    'HTTP_OpenView_NNM_jovgraph_Overflow':'5900002',
    'SNMP_Long_String':'12242',
    'ca-arcserve-ascore-dos':'1060',
    'msvm-java-applet-redirect':'7462',
    'decod-nntp-passwd':'1718',
    'spyware-invictus-mediaupdate':'12614',
    'rsagent-exchange-unauth-logon':'11042',
    'HTML_Oracle_Jinitiator_Overflow':'2114073',
    'rhel-rhsa-mozilla-javascripteng-code-exec':'10721',
    'novell-edirectory-replica-bo':'7918',
    'SMTP MIME file name overflow':'11828',
    'ibm-soliddb-arrayindex-dos':'4574',
    'http-get-dotdotdot-data':'3622',
    'win-ms06kb921883-update':'14526',
    'malcode-SPPE_SEH_MemZero_ExecR':'6689',
    'nt-group-system-time':'8110',
    'vlcmediaplayer-udp-format-string':'5900002',
    'ms-mediaplayer-rtsp-code-execution':'5900002',
    'system-rebooted-onceonly':'13338',
    'ca-license-putolf-bo':'1081',
    'google-chrome-jre7-security-bypass':'5900002',
    'malcode-SPNE_AbsWrite_SuspStr':'6584',
    'rhel-rhsa-2009-1335-update':'5900002',
    'linux-zerolength-fragment':'5985',
    'gnupg-askoutfilename-bo':'3133',
    'NfsGuess':'7826',
    'HTTP_IEShims_DLL_Hijacking':'5900002',
    'Portmaster_Reboot':'2104021',
    'reader-spellcustom-code-execution':'9346',
    'esone-cgi-directory-traversal':'2194',
    'rhel-rhsa-2003-176-update':'9604',
    'squirrelmail-readbody-xss':'12962',
    'user-shell-invalid':'14011',
    'freetype-lwfn-overflow':'2737',
    'balistix-backdoor':'788',
    'realplayer-file-deletion':'9356',
    'Saint_Scan':'11260',
    'reg-value-changed':'9459',
    'mssql-sqlvdir-bo':'7432',
    'DNS_Spoof_Success':'2000408',
    'spyware-zapspot':'12842',
    'HTTP_Auth_TooLong':'2000622',
    'rhel-rhsa-2003-055-update':'9575',
    'MSRPC_MSMQ_GetRemoteQueue_Request':'7333',
    'nt-guess-user':'8114',
    'EarthAgent_ServerProtect_TMReg_Overflow':'2101007',
    'learn2-strunner-activex-bo':'5860',
    'visualbasic-common-avi-bo':'14108',
    'ie-select-element-code-execution':'5900002',
    'rhel-rhsa-2004-249-update':'9712',
    'mscs-profile-service-bo':'7247',
    'DNS_non-Internet_lookup':'1942',
    'blackice-licensekey-invalid':'922',
    'CSS_Import_Corruption':'5900002',
    'aardvark-multiple-sql-injection':'31',
    'bind':'869',
    'malcode-ExeSeq04_FTime':'6252',
    'webinf-dot-file-retrieval':'14233',
    'makewhatis-man-root-privileges':'6129',
    'Email_Mime_Outlook_MSG_File':'5900002',
    'rhel-rhsa-2008-0167-update':'10513',
    'Stacheldraht_Agent':'2001582',
    'mssql-ms02039-patch':'7414',
    'spyware-shieldblss':'12738',
    'RIFF_Director_Corrupt_mmap':'5900002',
    'adobe-shockwave-rcsl-code-exec':'5900002',
    'hp-nnm-ovalarmsrv-bo':'3319',
    'CVS_Request_EntryLine_Overflow':'2120040',
    'DCOM_Scada_Opc_Bo':'2102042',
    'rpc-cmsd-enabled':'10872',
    'sigplus-sigmessage-file-overwrite':'5900002',
    'win-ms09kb969514-update':'14729',
    'HTTP URL with repeated .':'3542',
    'Nessus_Scanner':'2009203',
    'win2k-terminal-msgina-permissions':'14981',
    'Application Execution Allowed':'506',
    'rhel-rhsa-2009-1465-update':'5900002',
    'nt-rras':'8290',
    'malcode-SPPE_SEH_MemZero_ICEBP_2':'6690',
    'backdoor-y3k-rat':'745',
    'win-ms09kb969059-update':'14727',
    'rhel-rhsa-2004-681-update':'9791',
    'SMTP Too many recipients':'11841',
    'pdgsoftcart-misconfig':'8815',
    'decod-pop-passwd':'1723',
    'MSRPC_Malformed_DOS':'2102037',
    'rhel-rhsa-2005-334-update':'9903',
    'SMB_DFS_Response_DoS':'5900002',
    'HTTP POST data contains .._.._.._..':'3521',
    'Finger overflow':'2581',
    'win-rpc-dcom-bo-detected':'14818',
    'flash-activex-swremote-bo':'2671',
    'spyware-egroup-dialer':'12541',
    'facebook-login-detected':'2417',
    'HTML_Malicious_Aim_URI':'2114038',
    'confickerp2pdatatransfer-detected':'1480',
    'movemedia-quantum-uploadlogs-bo':'7055',
    'rhel-rhsa-2005-387-update':'9929',
    'IMAP_Ipswitch_Imail_Login_Bo':'5172',
    'spyware-praize-toolbar':'12694',
    'malcode-ExeSeq04_DO':'6251',
    'interscan-viruswall-change-configuration':'5248',
    'spyware-scrath-and-win':'12719',
    'VCF attachment overflow':'14068',
    'mutt-address-handling-bo':'7492',
    'ibm-lotusdomino-acceptlanguage-bo':'4573',
    'HTTP_Forced_Browsing_Probe':'2114001',
    'ping-buf-bo':'8951',
    'win-ms10kb2293386-update':'5900002',
    'HTTP_PHP_HPEinc_Include':'5900002',
    'rhel-rhsa-2006-0044-update':'10071',
    'SMB_Executable_Access':'11748',
    'rservice-exec-wrapped':'11184',
    'nt-accountblankpw':'7963',
    'iplanet-host-header-bo':'5312',
    'FAX_Coversheet_Shellcode_Detected':'5900002',
    'POP_APOP_Name_Overflow':'2000710',
    'win-ms12kb2690533-update':'5900002',
    'rhel-rhsa-2005-799-update':'10036',
    'SMB_HyperHelp_Exe_Hijacking':'5900002',
    'malcode-word6_03':'6888',
    'microsoft-snapshotviewer-code-execution':'7013',
    'malcode-word6_01':'6886',
    'TFTP_port_probe':'13675',
    'malcode-word6_06':'6891',
    'malcode-word6_05':'6890',
    'malcode-word6_04':'6889',
    'malcode-word6_09':'6894',
    'malcode-word6_08':'6893',
    'firefox-rdf-files-code-execution':'2636',
    'HTTP_CiscoCNS_Default_Admin_Login':'5900002',
    'win-pgm-option-length-dos':'5900002',
    'spyware-fairtale-dialer':'12555',
    'msprc-dns-detected':'7283',
    'quicktime-file-detected':'9218',
    'vixie-crontab-bo':'14116',
    'CSS_IE_Layout_d0cS4vage':'5900002',
    'Bionet trojan horse activity':'873',
    'nfs-rhosts':'7809',
    'adobe-svg-domain-access':'137',
    'NT_system_backup_URL':'8380',
    'nt-remote-shutdown':'8278',
    'file-dir-owner':'2492',
    'HTTP_HotMail_Email_Attachment':'3989',
    'realnetworks-chunked-transferencoding-bo':'9350',
    'nctaudioinformation2-activex-bo':'7594',
    'HTTP_Squid_Cache_Poisoning':'4408',
    'oracle-appserver-sendmail-sample':'8531',
    'Y3K_trojan_horse_ping':'15305',
    'rhel-rhsa-2007-1166-update':'10467',
    'kerberos-user-grab':'5711',
    'IMAP4_authentication_overflow':'5159',
    'hpopenview-ovas-bo':'5900002',
    'samr-failed-connection-attempt':'11296',
    'getaccess-shellscripts-retrieve-files':'3078',
    'ftp-pass-bo':'2856',
    'leadtoools-leadraster-bo':'5900002',
    'phAse_Zero_trojan_horse_activity':'8835',
    'Email_Mime_Null':'2102022',
    'asn1-decoding-bo':'572',
    'http-mediaplayer-detected':'3648',
    'gtkhtml-dos':'3195',
    'MMS_Protocol_Overflow':'5900002',
    'win-ms05kb883939-update':'14424',
    'old-sendmail':'8430',
    'ARCserve_Backup_LGServer_Stack_Overflow':'552',
    'libgsf-metabat-bo':'5870',
    'postgresql-circlepoly-integer-overflow':'9063',
    'kernel-ia64-sparc-elf-dos':'5735',
    'SMB_Transact_Bo':'2106150',
    'HTTP_Shopper_Conf':'2106027',
    'win-ms09kb971032-update':'14742',
    'exploit-MSWorks(100047)':'2383',
    'HP_IMC_Dbman_Overflow':'5900002',
    'oracle-database-rdbms-dos':'5900002',
    'mozilla-script-code-execution':'7125',
    'Radius_AccessPacket_DoS':'2110040',
    'frozen-file-update-changed':'2776',
    'pamldap-passwordpolicy-security-bypass':'8715',
    'viewstation-telnet-login-dos':'14087',
    'spyware-actualnames':'12429',
    'RJS_Decompress_Overflow':'5900002',
    'HTTP_OracleApp_soap':'2105023',
    'win-ms06kb924191-update':'14541',
    'rsagent-notauthorized-consolelogin':'11083',
    'spyware-spywarenuker':'12749',
    'backdoor-qaz':'718',
    'aurigma-imageuploader41-bo':'609',
    'HTTP POST contains xp_cmdshell':'3520',
    'Service_ticket_request_failed':'11552',
    'win-netbus-pro-installed':'14801',
    'MSRPC_EventLog_Null_Session':'2118052',
    'pasv-pizza-thief-dos':'8749',
    'cisco-acl-tacacs':'1254',
    'orinoco-snmp-community-exposed':'8629',
    'rhel-rhsa-2005-138-update':'9864',
    'rhel-rhsa-2004-597-update':'9774',
    'IRC_Automated_Client':'2106177',
    'LDAP_Request_Failed':'5851',
    'http-unix-passwords':'3701',
    'nortel-ipphone-register-dos':'7900',
    'rhel-rhsa-2002-161-update':'9527',
    'HTTP_Slowloris':'2114174',
    'HTTP_UAG_Vulnerable_JAR':'5900002',
    'vlc-mp4boxdumpstructure-bo':'5900002',
    'nt-eventlog-corrupt':'8066',
    'HTTP_POUND_LogMsg_Bo':'2110076',
    'HTML_Vulnerable_ActiveX':'3464',
    'HTTP_MSRadio_Overflow':'2002627',
    'ldap-monitor':'5822',
    'platinumftpserver-dir-directory-traversal':'8964',
    'mssql-ms02038-patch':'7413',
    'axis-media-_activex-code-execution':'5900002',
    'samba-receivesmbraw-bo':'11273',
    'user-nuucp-shell':'13997',
    'Scan_by_sscan_program':'11351',
    'ganglia-processpath-bo':'5900002',
    'http-ncsa-longurl':'3651',
    'MSMessenger_FileXfer':'7268',
    'HTTP_IISExAir_DOS':'2106046',
    'win-ms06kb916768-update':'14499',
    'ie-cached-pages':'4707',
    'rhel-rhsa-2004-383-update':'9724',
    'snmp-timestamp-tag-invalid':'12117',
    'Syphillis':'13327',
    'rhel-rhsa-2009-0257-update':'5900002',
    'rsagent-group-created':'11045',
    'TCP_Probe_SunRPC':'13453',
    'rhel-rhsa-2009-0349-update':'5900002',
    'webex-atas32dll-bo':'5900002',
    'FTP_Auth_Failed':'2001601',
    'IP unaligned timestamp':'5270',
    'HTTP_Compaq_Insight_Cpqlogin_Overflow':'2109000',
    'active-directory-object-operation-performed':'67',
    'IP fragment data changed':'5264',
    'VBScript_MsgBox_Help':'5900002',
    'qpopper-permission-problem':'9185',
    'dns-updates':'1892',
    'smtp-turn':'11881',
    'rhel-rhsa-2011-1317-update':'5900002',
    'shell-path-groupwritable':'11589',
    'rhel-rhsa-openssl-sslv2-client-dos':'10749',
    'SNMP bad enterprise tag':'11967',
    'PDF_Resource_Access':'5900002',
    'apache-cgi-handler':'415',
    'netware-callername-bo':'5900002',
    'Prosiak':'9128',
    'HTML_Mozilla_PluginsPage_Exec':'2113214',
    'rhel-rhsa-2003-249-update':'9622',
    'isa-address-range-invalid':'5429',
    'FTP_PrivilegedBounce':'2001323',
    'HTTP_IIS_WebDAV_Security_Bypass':'2124070',
    'spyware-mscnt':'12648',
    'Satan Scan':'11306',
    'rhel-rhsa-2006-0674-update':'10181',
    'HTTP_Oracle_Appserver_rwcgi60':'2105050',
    'nds-user-last-logged-on':'7630',
    'spyware-commonname':'12500',
    'update-service-baseline':'13918',
    'win-ms10kb975416-update':'14776',
    'trin00-master':'13765',
    'remotely-anywhere-present':'9476',
    'selsvc-holdfile':'11476',
    'malcode-Table_XS':'6796',
    'HTTP attack':'3484',
    'CGI convert.bas':'1132',
    'lotus-domino-bounced-message-dos':'6044',
    'IRC_Vscan':'2105000',
    'Specific_Virus_Flood':'12414',
    'adobe-unspec-priv-escalation':'5900002',
    'mozilla-interface-spoofing':'7084',
    'Spyware_PH_WhenUSearch':'2113180',
    'HTTP_DeskPan_Clsid_DLL_Hijacking':'5900002',
    'rhel-rhsa-squirrelmail-magichtml-mess-xss':'10769',
    'snmp-enabled':'12064',
    'NTLM_MultiProto_Reflection':'2118144',
    'ActiveX_Quicktime':'5900002',
    'phpbb-db-command-execution':'8920',
    'Email_Zip_Executable_Content':'5900002',
    'win-print-spooler-code-execution':'5900002',
    'IIS_malformed_HTW_request':'5018',
    'HTTP_Code_Red_II':'2004602',
    'Telnet_Environ_FTA':'2000908',
    'malcode-IRCWorm0':'6362',
    'Authentication_package_loaded':'610',
    'win2k-universalgroup-member-removed':'14988',
    'HTTP_PHP_Realpath_Bypass':'2118023',
    'HTTP_QuikStore':'2002552',
    'TFTP_Exe_Transfer':'2001204',
    'http-indexserver-path':'3643',
    'HackersParadise_Response':'2001559',
    'application-movie-bo':'514',
    'Shell_Command_Injection':'2110132',
    'squid-snmp-asnparseheader-dos':'12944',
    'netsnmp-getbulk-dos':'7745',
    'nt-legal-notice':'8148',
    'GTP_C_Element_Overflow':'2111024',
    'win-ms11kb2536275-update':'5900002',
    'isa-alert-failed-log':'5430',
    'smartvmd-activex-bo':'11701',
    'rhel-rhsa-2005-748-update':'10016',
    'aix-iy67124-fix':'206',
    'SSH2_Kerberos_auth_successful':'13015',
    'aix-iy82992-fix':'269',
    'spyware-adsincontext':'12440',
    'FTP port probe':'2809',
    'ISS_BOEP_Abnormal_Termination':'5555',
    'smb-dll-transfer':'5900002',
    'reg-apm-powerdown':'9390',
    'HTTP_attack':'3777',
    'office-string-code-execution':'8414',
    'VmRemovedEvent':'14132',
    'win-ms05kb896428-update':'14447',
    'SIP_Unregistered_Endpoint_Invite':'2106304',
    '.url URL type':'3',
    'PDF_Header_Variation':'8798',
    'script-dir-readable':'11375',
    'user-rhosts-exists':'14008',
    'msjet-query-execute-code':'7256',
    'rhel-rhsa-spamassassin-symlink-dos':'10768',
    'HTTP_Negotiate_SSP_ASN1_Overflow':'2120027',
    'lprng-remote-jobs-dos':'6080',
    's2-scan-started':'11244',
    'allaire-jrun-servlet-dos':'317',
    'rsagent-ssh-kerberos-tgt':'11128',
    'postgresql-anyarray-dos':'9060',
    'rhel-rhsa-2008-1016-update':'5900002',
    'spyware-absystemspy':'12427',
    'ms-win-authenticode-code-exec':'5900002',
    'HTTP GET contains compute%sum':'3496',
    'PCAnywhere_port_probe':'8767',
    'win-ms10kb2264072-update':'5900002',
    'DHCP_Long_Hardware_Address':'2110070',
    'Password_change_successful':'8747',
    'nt-group-manage-log':'8097',
    'ourgame-gliedown2-groupname-bo':'8667',
    'MSRPC_PlugAndPlay_GetDevList_DoS':'2118090',
    'malcode-CmosWriter':'6175',
    'rhel-rhsa-2009-1307-update':'5900002',
    'lncbm-lnresobject-activex-dos':'6002',
    'ike-security-association-established':'5031',
    'acrobat-unspec-bo':'5900002',
    'tcltk-insecure-library-search':'13363',
    'rhel-rhsa-2009-0296-update':'10626',
    'rhel-rhsa-2007-0322-update':'10285',
    'rhel-rhsa-2005-106-update':'9850',
    'ldap-request-failed-detected':'5827',
    'win-ms07kb929434-update':'14571',
    'rhel-rhsa-2002-263-update':'9548',
    'bind-rndc-weak-security':'858',
    'rhel-rhsa-2010-0470-update':'5900002',
    'peekabooty-present':'8823',
    'linux-sctp-parameter-dos':'5969',
    'foxpro-fpole-activex-bo':'2708',
    'vmware-vmci-code-execution':'14150',
    'kernel-prsetpdeathsig-privilege-escalation':'5750',
    'User_admin_right_granted':'14036',
    'SMB_Samba_Unicode_Mismatch_DoS':'5900002',
    'tomcat-troubleshooter-servlet-detected':'13732',
    'Oracle_PitrigDrop_Overflow':'5900002',
    'HTTP_AresGalaxy':'3771',
    'rhel-rhsa-2008-0223-update':'10532',
    'smtp-exchangedos':'11857',
    'HTML_AMX_NetLinx_Overflow':'2114065',
    'win-workstation-bo':'14885',
    'File_Added':'2564',
    'win-ms08kb953230-update':'14663',
    'Index_Server_null.htw_exploit':'5201',
    'IKE_quick_mode_association_ended':'5037',
    'FTP_Port':'2969',
    'php-phpbinary-information-disclosure':'8891',
    'Exchange_administrator_connect':'2312',
    'spyware-ezsearchbar':'12551',
    'epolicy-epo-directory-traversal':'2178',
    'ie-directanimation-keyframe-bo':'4733',
    'ie-firefoxurl-command-execution':'4746',
    'ms-wmp-asf-bo':'7232',
    'netmeeting-dotdot-directory-traversal':'7713',
    'firefox-jarfile-code-execution':'5900002',
    'netscape-accept-bo':'7721',
    'win-ms11kb2578230-update':'5900002',
    'novell-localexec-command-execution':'7938',
    'leadtools-leadraster-bo':'5900002',
    'UDP_Probe_Other':'13855',
    'ciscoios-system-timers-execute-code':'1342',
    'MSRPC_Spoolss_GetDocPrinter_Exec':'5900002',
    'DNS_Windows_SMTP_Overflow':'2113154',
    'frontpage-ext-rad-bo':'2755',
    'vista-feed-gadget-code-execution':'14106',
    'ftp-port-audit':'2861',
    'Gauntlet_CyberDaemon_Overflow':'2100028',
    'mutt-gecos-bo':'7494',
    'win-certificate-enrollment-dos':'14302',
    'iis-check-script':'4918',
    'FTP_MKDIR_dotdot':'2949',
    'VNC_Detected':'14160',
    'Commerce.cgi directory traversal':'1408',
    'nt-hypertrace-present':'8137',
    'http-post-dotdot-path':'3667',
    'active-directory-replication-connection':'70',
    'ICMP_Source_Quench':'4618',
    'IPHalfScan':'5310',
    'HTML_AIM_GetFile_Overflow':'2103029',
    'ssh-banner-detected':'12971',
    'group-members-not-valid':'3175',
    'SNMP_Int_Overflow':'2106094',
    'win-ms11kb2508062-update':'5900002',
    'Ident_Suspicious_ID':'2001903',
    'rhel-rhsa-2004-478-update':'9753',
    'edraw-flowchart-edimage-file-overwrite':'2055',
    'ethereal-asn1-dos':'2201',
    'mailalias-ow':'6112',
    'shockwave-unspecified-dos':'5900002',
    'quicktime-atom-length':'9213',
    'kerberos-renameprincipal2svc-bo':'5706',
    'malcode-SPPE_WrtSect65_02':'6702',
    'malcode-SPPE_WrtSect65_03':'6703',
    'Oracle_GenReplSupport_Bo':'2120042',
    'malcode-SPPE_WrtSect65_04':'6704',
    'SOCKS5_Connect':'12344',
    'rar-password-protected':'5900002',
    'Auction_Weaver_CGI_exploit':'597',
    'cisco-nxos-packet-dos':'5900002',
    'Telnet_Auth_Rsa':'13555',
    'TCP_Probe_Ident':'13435',
    'Oracle_Listener_Services_DoS':'2101001',
    'http-cgi-classifieds-exe':'3566',
    'sun-jre-scripting-unauth-access':'13222',
    'file-inet-correct':'2511',
    'yahoo-email-attachment':'15312',
    'win-ms11kb2639142-update':'5900002',
    'apache-incomplete-request-dos':'440',
    'ISAKMP_ProtosTool':'5537',
    'rhel-rhsa-2007-0722-update':'10360',
    'atl-stream-stack-bo':'593',
    'HTTP_Compaq_Insight_DoS':'2109001',
    'excel-xlm':'2270',
    'HTTP_IIS_Device_Asp':'2002673',
    'phatbot-backdoor':'8838',
    'firefox-javascript-code-exec':'5900002',
    'win-ms09kb971726-update':'14748',
    'BOEP_sqlservr':'976',
    'imapd-core':'5188',
    'hosts-exists-onceonly':'3292',
    'HTTP_URL_Name_Very_Long':'2000601',
    'fathftp-activex-bo':'5900002',
    'IS_Scan_Started':'5427',
    'qvodplayer-activex-bo':'9279',
    'firefox-xultree-code-execution':'5900002',
    'rhel-rhsa-2009-1087-update':'5900002',
    'MlsEvent':'7028',
    'rhel-rhsa-2007-0909-update':'10396',
    'exploit-fingerprint':'5900002',
    'ras-urq-inconsistent-address':'9314',
    'HTTP_Passwd_Txt':'2002562',
    'spyware-exactsearchbar':'12549',
    'HTTP_Translate_F_SourceRead':'2102038',
    'ISA_incorrect_IP_addr_assigned_to_dialup':'5500',
    'gnomelokkit-forward-bypass-firewall':'3126',
    'moonpie-backdoor':'7037',
    'rhel-rhsa-mozilla-mult-layout-code-execution':'10723',
    'win-ms12kb2671387-update':'5900002',
    'linksys-apply-handler-bo':'5915',
    'ICMP_Flood':'2000110',
    'kernel-netfilter-ipv6-security-bypass':'5744',
    'HTTP_Parameter_Abuse':'5900002',
    'SNMP_Bad_BulkRqst_NonRepeaters':'12142',
    'SNMP_InvalidTag_PDU':'2106078',
    'oscar-login':'8633',
    'wireshark-mq-format-string-win':'15126',
    'rhel-rhsa-2010-0519-update':'5900002',
    'http-get-groupby':'3624',
    'korgo-backdoor':'5792',
    'rhel-rhsa-2008-1037-update':'5900002',
    'Jolt2':'5674',
    'SIP_Large_Max_Forwards':'2120068',
    'dvrhost-pdvrocx-bo':'2019',
    'SMTP_MIME_filename_repeated_blanks':'11924',
    'aix-iy88641-fix':'286',
    'spyware-acontidialer':'12428',
    'Content_TNEF_Outlook_Attachment_Exec':'5900002',
    'screen-not-password-protected':'11372',
    'win-ms11kb2588516-update':'5900002',
    'Osiris_TCP_Response':'2113217',
    'HTTP_IIS_ISAPI_Nsiislog_Overflow':'2113041',
    'SMB_NSS_PKCS11txt':'5900002',
    'php-extcurl-extgd-bypass-security':'8855',
    'hp-imc-dbman-bo':'5900002',
    'rsagent-suspect-whois':'11157',
    'citrix-provisioning-streamprocess-bo':'5900002',
    'POP_QPopCommand_Overflow':'9033',
    'Cyn_TCP_Request':'2113095',
    'HTTP_OracleApp_Spy':'2105026',
    'CGI uploader.exe':'1164',
    'win-hcpurl-code-execution':'14339',
    'DHTML_Object_Overflow':'2113203',
    'MSRPC_Registry_Write_RASMan':'2003205',
    'blackice-opengiffile-bo':'926',
    'linux-rootkit2-login-detected':'5960',
    'Chupacabra_Request':'2001544',
    'SNMP_bad_packet_tag':'12158',
    'communicator-domain-security-bypass':'1410',
    'win-media-info-packet-bo':'5900002',
    'TelnetAuthRsa':'13601',
    'user-homedir-root-owned':'13971',
    'rhel-rhsa-2011-1845-update':'5900002',
    'decod-portmap-call':'1725',
    'HTTP_Web_App_Cmd_Exec':'4487',
    'windows-wins-replication-bo':'15030',
    'PDF_Deep_Nesting':'5900002',
    'aix-iy82994-fix':'271',
    'FTP_Login_Overflow':'2001306',
    'word-rtf-poly-bo':'15155',
    'oo-smlog':'8442',
    'LNK_File_Detected':'5900002',
    'mw6-barcode-bo':'7498',
    'POP3 MIME filename repeated chars':'8995',
    'tftp-port-probe':'13653',
    'IMAP_Long_Authname':'2000803',
    'win-ms12kb2719177-update':'5900002',
    'rhel-rhsa-2011-0196-update':'5900002',
    'microsoft-heartbeatctl-bo':'7008',
    'spyware-coolwebsearch':'12504',
    'Exchange55_administrator_connect':'2304',
    'rhel-rhsa-2004-090-update':'9679',
    'postfix-smtp-log-dos':'9059',
    'CA_License_Server_Request_Bo':'2106189',
    'Block While Proventia Detection Stopped':'935',
    'IPM_Invalid_Protocol':'5323',
    'SIS_Installer_Blacklisted':'5900002',
    'nt-without-logon-script':'8375',
    'win-ms03010-patch':'14387',
    'SMB unencrypted password':'11713',
    'HTML_Image_Source_DoubleExec':'2121056',
    'noknok-backdoor':'7890',
    'spyware-bigtgp-dialer':'12463',
    'HTTP_Orion_JSP_SourceRead':'2110119',
    'win-ms08kb953733-update':'14665',
    'RTF_Word_Grouping_Exec':'2122011',
    'sun-jre-xslt-privilege-escalation':'13227',
    'frozen-file-changed-quick':'2769',
    'php-shmopwrite-outofbounds-memory':'8906',
    'aix-iy82739-fix':'267',
    'reg-share-workstation':'9442',
    'asn1-x509-oid-malformed':'573',
    'ibm-informix-oninit-bo':'5900002',
    'ms-ie-obj-ce':'5900002',
    'Suspect_POP3':'13263',
    'win-jpeg-bo':'14355',
    'SNMP_Extra_Bytes':'2101054',
    'win-service-exception-detected':'14833',
    'HTTP_POST_contains_create%table':'4302',
    'web-server-url-encoding':'14219',
    'DNS_Zone_Transfer_High':'1973',
    'malcode-VBSThatOpensExecutables':'6866',
    'firefox-nsftpstate-information-disclosure':'2631',
    'ldap-exchange-overflow':'5818',
    'rhel-rhsa-2008-0100-update':'10490',
    'sendmail-address-parser-bo':'11479',
    'autonomy-keyview-wp6sr-bo':'5900002',
    'HTTP_Cgiproc_File_Read':'2111014',
    'win-dns-client-bo':'14315',
    'apple-quicktime-pict-image-bo':'496',
    'malcode-SPPE_Srv_reg_srch':'6694',
    'rsagent-passchange-failed':'11094',
    'iis-asp-info-disclosure':'4903',
    'Firewall_Rule_Not_Found':'2655',
    'rhel-rhsa-2011-0260-update':'5900002',
    'bootp-remote-bo':'987',
    'oracle-webcache-http-bo':'8583',
    'backdoor-dagger':'676',
    'HTTP_OpenView_NNM_OVParseLLA_Overflow':'5900002',
    'hp-storageworks-doubletake-bo':'5900002',
    'BNBSurvey_survey.cgi':'942',
    'VagrNocker_TCP_Response':'2113068',
    'procmail-signal-handling-race':'9111',
    'FTP_PWD_Response_ZeroLen_Directory':'5900002',
    'Ping of death':'8949',
    'Back Orifice 2000 auth':'642',
    'FTP AIX Overflow':'2785',
    'rhel-rhsa-2003-293-update':'9634',
    'exploit-MSPowerpoint(100016)':'2365',
    'rhel-rhsa-2009-1339-update':'5900002',
    'URL_contains_Unicode___255':'13936',
    'win-ms05kb903672-update':'14458',
    'apache-tomcat-exception-info-disclosure':'486',
    'Exchange_mail_sent_as':'2317',
    'avirt-voice-get-bo':'633',
    'TFTP_Filename_VeryLong':'2001202',
    'QuikStore_configuration_URL':'9278',
    'HTTP_POST_repeated_char':'2000626',
    'SynDrop':'2000005',
    'SNMP_null_in_community':'12247',
    'rhel-rhsa-2007-0401-update':'10312',
    'Excel_Name_Index_Error':'5900002',
    'rhel-rhsa-2007-0737-update':'10368',
    'script-hyper-concatenation':'11376',
    'exchange-relay':'2298',
    'Weakness_CGI_scan':'14212',
    'pdf-info-reference':'8780',
    'uucp':'14058',
    'rstatd':'11204',
    'orbitdownloader-activex-file-deletion':'8616',
    'bind-dos':'842',
    'Ping sweep':'8950',
    'aix-iy55682-fix':'175',
    'HTTP_PHPMyAdmin_SqlPhp':'2002676',
    'spyware-win32-keyhost':'12820',
    'Index Server null.htw exploit':'5199',
    'bind-opt-rr-dos':'854',
    'linux-syncookie-bypass-filter':'5975',
    'file-nobody':'2528',
    'HTTP_IE_InstallEngineCtl_Overflow':'2120056',
    'rhel-rhsa-2009-1432-update':'5900002',
    'PDF_FoxIt_Title_Overflow':'5900002',
    'DB2_XMLQUERY_Overflow':'5900002',
    'SNMP_ILMI_community':'12215',
    'surgemail-webmail-bo':'5900002',
    'asterisk-originate-command-exec':'5900002',
    'FTP_Generic_Intel_Overflow':'2104011',
    'sip-short-request':'11636',
    'SSH2_Passwd_auth_failed_empty_passwd':'13018',
    'malcode-SPPE_HRDO_iniMod_cpy':'6674',
    'user-group-ngroupmax':'13957',
    'Exchange55_view_administrator_login':'2311',
    'SNMP_SysContact':'2002007',
    'SMB_Nimda_Worm':'2002710',
    'win-ms09kb958690-update':'14704',
    'ipp-detected':'5341',
    'hp-ovnnm-ovoslocale-bo':'3329',
    'vml-dectected':'14127',
    'google-chrome-v8-ce':'5900002',
    'SSH2_Hostbased_auth_failed_pubkey':'13011',
    'rhel-rhsa-2007-1165-update':'10466',
    'dns-resolver-lib-read-bo':'1884',
    'RPC_Cachefsd_Overflow':'2111000',
    'win-ms06kb920683-update':'14521',
    'win-ms10kb977935-update':'14783',
    'Script_IE_IsComponentInstalled_BO':'2106208',
    'malcode-TimeBandit':'6798',
    'aix-iy78225-fix':'254',
    'Oracle_TransformLayer_Overflow':'5900002',
    'FTP_Delete_dotdot':'2001363',
    'rhel-rhsa-php-zendhashinit-dos':'10760',
    'Zip_Directory_Traversal':'2121054',
    'malcode-SPPE_Srch_Wrt_EXE':'6693',
    'rhel-rhsa-2008-0145-update':'10502',
    'nt-domain-ctlr':'8054',
    'prov-update-installation':'9138',
    'R0xR4t_TCP_Response':'2113054',
    'rhel-rhsa-postgresql-searchpath-priv-esc':'10764',
    'rhel-rhsa-2012-0465-update':'5900002',
    'network-computers-viisible':'7772',
    'blackice-configfile-changed':'913',
    'sip-header-name-dos':'11616',
    'win-ms08kb956695-update':'14682',
    'malcode-Susp_SYS_ChangeFile':'6776',
    'backdoor-netmonitor':'708',
    'XMPP_TLS_Encrypted_Session':'15267',
    'win2k-account-changed':'14892',
    'rhel-rhsa-2007-0081-update':'10244',
    'nt-local-user':'8152',
    'Zero_length_IP_option':'15365',
    'CompoundFile_OSS_Detected':'1445',
    'Telnet_Auth_Spx':'13556',
    'qpopper-username-too-long':'9187',
    'PE_DotNet_Loader_Exec':'2122013',
    'sun-jre-jpegimage-bo':'5900002',
    'adobe-sandbox-dos':'5900002',
    'TCP_Probe_Netbus':'13442',
    'http-443-protocol-unknown':'3546',
    'outlook-malformed-email-header-dos':'8683',
    'ypops-pop3-bo':'15350',
    'rsagent-mssql7-connect-nontrusted-successful':'11079',
    'PDF_Bitmap_Overflow':'5900002',
    'HTTP_PDGSoft_Changepw':'2002651',
    'pop2-fold-bo':'8985',
    'ms-win-explorer-shmedia-dos':'5900002',
    'win-ms11kb2544893-update':'5900002',
    'SMB_ICS_Wizard_DLL_Hijacking':'5900002',
    'malcode-VB_28':'6820',
    'SYNFlood':'2000302',
    'SMB_Samba_SessionAndX_DoS':'5900002',
    'swiftview-activex-plugin-bo':'13292',
    'win-ms10kb2316074-update':'5900002',
    'HTML_IE_Help_Save_File':'2106179',
    'dmail-etrn-dos':'1839',
    'ssh2-tcpip-forwarding-denied':'13002',
    'rhel-rhsa-2008-0224-update':'10533',
    'rhel-rhsa-2005-584-update':'9988',
    'Email_ReplyTo_IpSwitch_Overflow':'5900002',
    'FTP_Args':'2886',
    'win-ms12kb2636391-update':'5900002',
    'reg-logon-caption-incorrect':'9401',
    'xloadimage-faces-bo':'15233',
    'rsagent-mssql65-connect-nontrusted-successful':'11076',
    'flash-air-jpeg-bo':'5900002',
    'UDP_Bomb':'2000212',
    'Application_Protection_Started':'529',
    'HTTPS_Proxy_Info_Disclosure':'4547',
    'rhel-rhsa-2006-0611-update':'10163',
    'PlugAndPlay_BO':'2118030',
    'cyberlink-clsetting-file-overwrite':'1600',
    'win2k-trusted-for-delegation':'14983',
    'HTTP_Pfdispaly_Read':'2002611',
    'carello-file-duplication':'1100',
    'quicktime-image-description-code-exec':'9229',
    'novell-iprint-bo':'7922',
    'excel-virus-warning':'2269',
    'win-autorun-enabled':'14296',
    'jre-externalgeneralentities-security-bypass':'5676',
    'bind-sig-rr-bo':'860',
    'spyware-asianraw-dialer':'12450',
    'symantec-firewall-dns-dos':'13307',
    'quicktime-rtsp-contenttype-bo':'9246',
    'win-ms12kb2707956-update':'5900002',
    'JavaScript_Mozilla_PKCS11_Weakness':'5627',
    'Email_Relay_Attempt':'2001011',
    'PCAnywhere port probe':'8756',
    'IRC_PrettyPark_Worm':'2002207',
    'win-mfc-findfile-bo':'14385',
    'IMAP_Tag_Overflow':'2110082',
    'HTTP_MySpace_Login':'4176',
    'NNTP name overflow':'7861',
    'SIP_SDP_Connection_IP_Mismatch':'2106292',
    'sql-injection-waitfordelay':'12885',
    'LNK_MsWin_Code_Execution':'5900002',
    'rpc.portmap.unset':'10916',
    'rhel-rhsa-2005-421-update':'9945',
    'HTTP_Dir_Manager_exe':'2002683',
    'BOEP_iplanet':'971',
    'decod-irc-channel':'1707',
    'rhel-rhsa-2010-0698-update':'5900002',
    'ms-win-signup-code-execution':'5900002',
    'rhel-rhsa-2006-0713-update':'10193',
    'win-ms11kb2590602-update':'5900002',
    'dns-reverse':'1885',
    'quicktime713-update':'9258',
    'malcode-InfectorX':'6344',
    'win-searchmsprotocol-code-execution':'14829',
    'cineplayer-sonicmediaplaer-bo':'5900002',
    'HTTP_HP_JetAdmin_ExecuteFile':'2118012',
    'rhel-rhsa-2004-505-update':'9760',
    'oracle-db-netauth-unspecified':'8546',
    'rsagent-ntlogin-successful':'11086',
    'fpse-image-reveal-path':'2715',
    'Quake_backdoor':'9204',
    'ibm-lotus-domino-hpragentname-bo':'5900002',
    'adobe-reader-ace-code-execution':'5900002',
    'spyware-asinlover':'12451',
    'explorer-relative-path-name':'2399',
    'rhel-rhsa-2002-261-update':'9547',
    'wireshark-sscop-dos':'15137',
    'win-ms07kb931212-update':'14574',
    'psa-php-reveal-source':'9153',
    'ms-dotnet-pe-loader-bo':'7175',
    'multiple-mozilla-layout-code-execution':'7485',
    'firefox-popup-security-bypass':'2635',
    'http-cgi-whois-meta':'3605',
    'GTP_C_Element_Unexpected':'2111021',
    'clamav-clamavmilter-code-execution':'5900002',
    'HTTP_HOST__repeated_many_times':'3985',
    'snmp-long-oid':'12088',
    'outlook-ms04009-patch':'8685',
    'apache-device-name-dos':'426',
    'URL_contains_Unicode_encoding':'13937',
    'backdoor-netdemon':'707',
    'tdfc-export-worldmountable':'13487',
    'appscan-activex-file-overwrite':'538',
    'start-options-enabled':'13129',
    'DeepThroat':'1762',
    'nt-found-modem':'8076',
    'excel-autofilter-code-execution':'2250',
    'NokNok_FTP_Response':'2113145',
    'aix-iy67457-fix':'210',
    'spyware-redv':'12711',
    'win-dcom-system-activation':'14310',
    'WindowsMedia_Compressed_Audio_Heap_Corruption':'15045',
    'rhel-rhsa-2007-0235-update':'10277',
    'rsagent-oracle-connect-successful':'11089',
    'lha-file-name-overflow':'5866',
    'HTTP_Shells_Perl_Exe':'2002522',
    'Security_enabled_universal_group_created':'11464',
    'HTTP GET passwd file':'3504',
    'rhel-rhsa-2005-685-update':'10007',
    'FTP_Site_Cpwd':'2105057',
    'cisco-tftp-filename-bo':'1328',
    'File_Modified':'2567',
    'IP_fragment_overlap':'5287',
    'smtp-service-detected':'11878',
    'rsagent-exchange-nntp-auth-fail':'11032',
    'malcode-Susp_MBR_SnkInt':'6768',
    'mssql-manager-password':'7411',
    'win-ms06kb918899-update':'14516',
    'rhel-rhsa-2011-1187-update':'5900002',
    'h225-signaling-message-order':'3237',
    'rpc.bootparam whoami mismatch':'10898',
    'rhel-rhsa-2009-1146-update':'5900002',
    'malcode-VB_23':'6816',
    'Image_BMP_Header_Overflow':'2120039',
    'snmp':'12135',
    'user-login-insecure':'13980',
    'multiple-uri-command-execution':'7487',
    'FTP_IIS_Directory_Listings_DoS':'5900002',
    'malcode-ExplicitlyImportNormalTemplate':'6300',
    'Back Orifice scan seen':'648',
    'win-asn1-http-bo':'14293',
    'user-changed':'13952',
    'hp-jetadmin-path-disclosure':'3313',
    'google-chrome-images-security-bypass':'5900002',
    'rhel-rhsa-2008-0978-update':'10616',
    'photoparade-phpinfo-bo':'8847',
    'MSRPC_PlugAndPlay_DeviceSlashBo':'2118048',
    'YahooMSG_Message_Chat':'15340',
    'akamai-download-code-execution':'304',
    'wget-ftp-filename-traversal':'14270',
    'Telnet_bad_TERMCAP':'13562',
    'aix-iy87943-fix':'277',
    'IMAP_Search_Date_Overflow':'5900002',
    'Unlicensed_Feature':'13905',
    'cyrus-imap-preauth-bo':'1607',
    'xwin-tmp-perms':'15288',
    'malcode-VB_Deleter':'6836',
    'squid-wccp-dos':'12949',
    'surgeftp-concon-dos':'13255',
    'nt-pwdcache-enable':'8257',
    'FBackdoor_TCP_Response':'2113105',
    'user-homedir-ow':'13968',
    'HTTP_GET_SQL_UnionSelect':'2113029',
    'mcafee-saas-mycioscn-code-execution':'5900002',
    'TFTP_Traversal':'2001203',
    'http-scriptalias':'3686',
    'wordviewer-save-file-overwrite':'15165',
    'file-group-readable':'2504',
    'IRC_Notice_Msg':'5401',
    'rhel-rhsa-2007-0252-update':'10280',
    'rhel-rhsa-2008-0238-update':'10537',
    'nt-guessed-domain-adminpwd':'8118',
    'kaneva-detected':'5688',
    'rhel-rhsa-2006-0544-update':'10137',
    'IPM_Resource_Error':'5330',
    'MS share dump':'7152',
    'rpc-callit-ping':'10871',
    'LDAP_Non_Anonymous_Empty_Password':'5900002',
    'ie-virtual-function-code-execution':'5900002',
    'firefox-webforgery-security-bypass':'5900002',
    'rhel-rhsa-2009-1102-update':'10667',
    'adobe-reader-unspec-sec-bypass':'5900002',
    'apple-safari-webkit-libxslt-ce':'5900002',
    'HTTP_Pfdispaly_Execute':'2002610',
    'bind-complain-format-string':'840',
    'rsagent-ssh-kerberos-authfailed':'11124',
    'xchat-ctcp-ping-command':'15203',
    'nt-replicator':'8282',
    'mssql-multiple-xp-bo':'7415',
    'allaire-jrun-view-jsp':'321',
    'com-killbit-evasion-detected':'1403',
    'Qaz trojan horse activity':'9168',
    'quicktime-indeo-video-bo':'9230',
    'security-management-integer-overflow':'11438',
    'NewSilencer_TCP_Response':'2113140',
    'Spyware_PH_KeenValue':'2113182',
    'apache-running':'471',
    'Firebird_SQL_Connect_Request_DoS':'5900002',
    'WRF_ATDL_Heap_Corruption':'5900002',
    'win-ms11kb2478960-update':'5900002',
    'bugzilla-show-dependency-graph':'1044',
    'mdropper-h-trojan':'6972',
    'icq-client-detect':'4629',
    'Suspicious URL Event':'13274',
    'vmware-hgfs-bo':'14144',
    'aix-iy64522-fix':'197',
    'win-ms08kb956390-update':'14679',
    'NetController_TCP_Request':'2113135',
    'oracle-hyperion-activex-file-overwrite':'5900002',
    'sun-cmsd-bo':'13203',
    'spyware-teenfestival':'12763',
    'rhel-rhsa-2008-0029-update':'10476',
    'autonomy-keyview-applix-dos':'615',
    'soliddb-solid-dos':'12394',
    'freeradius-accesspacket-dos':'2730',
    'oracle-database-remove-sql-injection':'5900002',
    'tns-oracle-invalid-login-detected':'13720',
    'smtp-ntlm-auth-generic-overflow':'5900002',
    'HTML_Microsoft_Agent_Detected':'3435',
    'MavericksMatrix_Response':'2113123',
    'NetSpyV12_Response':'2001569',
    'rpc-snmp-xdmid-enabled':'10884',
    'trojan-bifrost':'13779',
    'cvs-long-option-detected':'1571',
    'TransScout_Request':'2001594',
    'backdoor-portal-of-doom':'714',
    'iis-samples-viewcode':'4984',
    'PDF_Degenerate_Stream':'5900002',
    'snmp-information-disclosure':'12079',
    'ICMP unreachable storm':'4596',
    'rpc-service-search':'10883',
    'ms-media-dvrms-code-execution':'5900002',
    'win-hcp-code-execution':'14338',
    'malcode-StealLocalInformation':'6730',
    'rlogin_login_failed':'10815',
    'Security_Management_Post_Overflow':'2106263',
    'ie-object-memory-code-exec':'4814',
    'HTTP_Skype_Callto_Overflow':'2118015',
    'malcode-DelExisting0':'6202',
    'rhel-rhsa-2010-0834-update':'5900002',
    'SNMP too many vars':'12028',
    'Security_enabled_universal_group_changed':'11463',
    'application-rpc-interface-bo':'518',
    'rhel-rhsa-2008-0967-update':'5900002',
    'spyware-stoptodaru':'12754',
    'malcode-AttribIndicator':'6149',
    'rhel-rhsa-mozilla-srcimgframe-sec-bypass':'10725',
    'OSPF_Link_State_Update':'8656',
    'imagemagick-readsgiimage-bo':'5122',
    'malcode-SPPE_NonExist_OSmsg':'6684',
    'rhel-rhsa-2010-0657-update':'5900002',
    'Video_Flic_Malformed':'2114022',
    'apache-dos':'428',
    'postgresql-blank-password':'9062',
    'win-ms10kb2305420-update':'5900002',
    'HTML_IE_File_URI_Encode':'2106184',
    'rhel-rhsa-2004-498-update':'9759',
    'SMB_unencrypted_password':'11793',
    'realserver-g2-pw-bo':'9373',
    'Java contains Brown Orifice attack':'5576',
    'win-ms06kb905755-update':'14473',
    'ISA_suspect_IP_addr_assign_to_dialup':'5521',
    'HTTP_Symantec_BackupExec_File_Upload':'5900002',
    'ntp-mode7-dos':'5900002',
    'sunjava-iccprofile-overflow':'5900002',
    '3com-hiper-comm-name':'19',
    'pmap-set':'8968',
    'win-dcom-large-body-extension':'14308',
    'msrpc-lsa-lookupsids-dos':'7291',
    'ms-csnw-dos':'7165',
    'HTTP_Media_Encoder_DLL_Hijacking':'5900002',
    'snmp-v3-field-underflow':'12124',
    'TransScout':'13749',
    'Image_EMF_GDI_Kernel_Code_Execution':'5071',
    'flash-swf-bo':'2675',
    'java-timezonegettimezone-info-disclosure':'5900002',
    'cisco-fragmented-attacks':'1274',
    'malcode-WormDropper1':'6907',
    'malcode-WormDropper0':'6906',
    'blackice-networkaccess-blocked':'923',
    'win-ms11kb2556532-update':'5900002',
    'rhel-rhsa-2006-0617-update':'10166',
    'IKE_security_association_established':'5038',
    'malicious-pdf':'5900002',
    'rsh-null':'11196',
    'nt-adminexists':'7972',
    'exd-qexplain2-file-overwrite':'5900002',
    'SSH2_Hostbased_auth_failed_no_root':'13009',
    'ISAPI_dumpvariables_overflow':'5542',
    'HTTP_DataProtector_SignIn_Overflow':'5900002',
    'exploit-MSWord(100000)':'2372',
    'ms-ie-tostatichtml-xss':'5900002',
    'HTML_Yahoo_DataGrid_BO':'2110163',
    'quake3-arena-connectre-bo':'9200',
    'licq-logging-bo':'5908',
    'xscreensaver-getpwuid-authentication-bypass':'15282',
    'malcode-EnumPassword':'6240',
    'rhel-rhsa-2006-0515-update':'10130',
    'SNMP lanmanger enumeration':'12008',
    'rhel-rhsa-2010-0970-update':'5900002',
    'SNMP_trapAuthFailure':'2104032',
    'oracle-timesten-evtdump-format-string':'8574',
    'Veritas_BackupExec_BO':'2110075',
    'adobe-reader-installer-code-execution':'5900002',
    'isa-ip-address-denied':'5448',
    'xfree86-glx-array-dos':'15218',
    'win-ms11kb2567680-update':'5900002',
    'HTML_Blur_Corruption':'5900002',
    'malcode-DropperAgent4':'6232',
    'malcode-DropperAgent5':'6233',
    'SNMP long field length':'12011',
    'kde2-kdesu-retrieve-passwords':'5695',
    'HTTP_PHP_Overflow':'2106030',
    'rhel-rhsa-2012-0324-update':'5900002',
    'spyware-densmail':'12516',
    'Local_host_not_gcs':'6014',
    'POP3_password_overflow':'9013',
    'spyware-powerscan':'12692',
    'HTML_Element_Filename_Traversal':'3391',
    'rspmp3-activex-bo':'5900002',
    'orion-jsp-source-disclosure':'8630',
    'RPC_prog_grind':'10980',
    'win-ms11kb2489293-update':'5900002',
    'Excel_BIFF_Exec':'5900002',
    'php-include-bypass-security':'8867',
    'win-ms12kb2655992-update':'5900002',
    'excel-ms04033-patch':'2260',
    'hotfix-compliance':'3294',
    'NTP_SNTP_Malformed':'2002903',
    'HTTP_PHPNuke_Index_File':'2105010',
    'rhel-rhsa-2004-489-update':'9757',
    'finger-out':'2588',
    'poison-ivy-detected':'5900002',
    'iis-ssl-patch':'4990',
    'frontpage-ext-bad-permissions':'2749',
    'rhel-rhsa-2010-0173-update':'5900002',
    'spyware-bloiscom-dialer':'12465',
    'Cabinet_Header_Filename_Overflow':'5900002',
    'HTML_Img_Src_Script_Exec':'2121028',
    'rhel-rhsa-2007-0385-update':'10305',
    'CGI_rksh':'1205',
    'lpd-enabled':'6068',
    'rhel-rhsa-2005-410-update':'9938',
    'Listserv_CGI_exploit':'5997',
    'javawebstart-unspecified-bo':'5654',
    'nt-userrights-audit-success':'8361',
    'rhel-rhsa-2009-0004-update':'5900002',
    'SocketsDeTroie_Request':'2001581',
    'passfilt-version':'8720',
    'shell-path-owner':'11592',
    'cursor-malformed-image-transfer':'1566',
    'backupexec-calendar-bo':'772',
    'win-ms09kb959454-update':'14708',
    'orderform-misconfig':'8621',
    'linux-iso9660-bo':'5936',
    'user-shutdown-anysystem':'14014',
    'Scada_Modbus_ClearRegisters':'11342',
    'malcode-ExeSeq06':'6254',
    'spyware-goindirect':'12578',
    'DeltaSource':'1766',
    'morto-backdoor-detected':'5900002',
    'nntp-read':'7867',
    'spyware-alexa':'12445',
    'rsagent-ssh-kerberos-tickauthfailed':'11129',
    'IRC_DCC_Send':'5389',
    'ca-alertnotificationserver-bo':'5900002',
    'directconnect-traffic-detected':'1822',
    'ICQ_PAM_Parser_Overflow':'2113053',
    'Windows_Shell_Pathname_Exec':'5900002',
    'http-get-dotdotdot':'3623',
    'brightstor-tapeengine-rpc-bo':'5900002',
    'CompoundFile_Embedded_SWF':'5900002',
    'backdoor-rat':'719',
    'sec-log-evts':'11424',
    'siteserver-cis-cookie-cache':'11676',
    'rhel-rhsa-mozilla-xpcnativewrapper-xss':'10731',
    'malcode-SpawnSuspeciousFile':'6538',
    'SMTP Ehlo':'11810',
    'security-management-bo':'11437',
    'backdoor-picture':'713',
    'mozilla-garbage-collection-object-deletion':'7080',
    'HTTP_WebStore':'4516',
    'http-cgi-php-mlog':'3591',
    'oracle-jinitiator-beans-bo':'8559',
    'isa-land-attack-detected':'5452',
    'rhel-rhsa-2003-161-update':'9601',
    'win-ms09kb961260-update':'14714',
    'sip-unknown-via-detected':'11638',
    'crystalreport-activex-bo':'5900002',
    'rhel-rhsa-2004-441-update':'9741',
    'HTTP_Dansie_Backdoor':'2002750',
    'knowledgebuilder-indexphp-file-include':'5785',
    'rpc.mountd overflow':'10902',
    'CVS_Notify_Underflow':'2107029',
    'malcode-SPCOM_FmtHDD':'6544',
    'samba-smbconf-command-execution':'11279',
    'iis-ms04021-patch':'4966',
    'License Will Expire Soon':'5900',
    'win-ms08kb957097-update':'14687',
    'FTP_Cwd_Tilde':'2001340',
    'rhel-rhsa-2006-0207-update':'10098',
    'stick-ids-dos':'13151',
    'apple-quicktime-stsd-atoms-bo':'498',
    'HTML_Asp_Dot_Net_XSS':'2109008',
    'msvm-codebase-read-files':'7460',
    'ourgame-gliedown2-iestartnative-bo':'8668',
    'satan-scan':'11307',
    'isa-all-port-scan-detected':'5431',
    'malcode-SPPE30_SysDir_Bound':'6643',
    'XML_XSLT_IE_Memory_Corruption_Exec':'5900002',
    'trojan-hypigon':'13781',
    'nt-autologon':'7987',
    'icmp-netmask':'4598',
    'CGI pfdispaly.cgi':'1155',
    'http-webgais-smail':'3713',
    'rje-mapper':'10793',
    'rhel-rhsa-2011-0027-update':'5900002',
    'RIFF_CorelDraw_Stack_Overflow':'5900002',
    'rhel-rhsa-2008-0515-update':'10567',
    'HTTP_Lotus_Domino_Obtain_Info':'2113142',
    'noop-multiple-instructions-detected':'7898',
    'DNS null':'1854',
    'Realplayer-activex-unspecified':'5900002',
    'webbrowser-object-code-execution':'14226',
    'aix-iy68825-fix':'222',
    'ospf-unknown-message-type':'8648',
    'pdf-deep-nesting':'5900002',
    'MSSQL_Shutdown':'7446',
    'malcode-SPCOM_int3_SuspStr':'6545',
    'BrightStor_Uniagent_Overflow':'2110087',
    'PDE_Renew_Host':'8772',
    'QPopper_user_login_failure':'9191',
    'win-ms08kb953838-update':'14667',
    'msrpc-tcp-port-probe':'7297',
    'HTTP login name well known':'3513',
    'prov-system-successful-login':'9134',
    'fna-home-file-include':'5900002',
    'SNMP_Lanman_Enum':'2002008',
    'actinvr-deletexmlfile-file-overwrite':'54',
    'Oracle_ToChar_Bo':'2120049',
    'CGI csh':'1133',
    'malcode-SPPE_DO_DLL_PolyMorph':'6663',
    'nt-changedscanfile':'8006',
    'Local_group_created':'6010',
    'nt-ssping':'8321',
    'rhel-rhsa-2004-103-update':'9681',
    'iis-ms02018-patch':'4963',
    'asn1-constructed-heap-overflow':'571',
    'exploit-MSExcel(100041)':'2358',
    'HTTP_FrontPage_DeviceName':'2002586',
    'CGI_test-cgi.tcl':'1210',
    'CyberCop_Scanner_RPC':'2102008',
    'IMAP_Login':'5174',
    'ms-smtp-data-transfer-dos':'7207',
    'aix-iy82285-fix':'265',
    'malcode-ModifyAttribs':'6375',
    'ms-ie-javscript-info-disc':'5900002',
    'mdaemon-imap-foldername-dos':'6964',
    'nds-user-no-logon-script':'7636',
    'ie-scripterror-code-execution':'4830',
    'fw1-gettopo-noauth':'3046',
    'spyware-meridian-popupper':'12639',
    'rhel-rhsa-2009-1156-update':'5900002',
    'vmware-host-dos':'14146',
    'HTTP_cgi_with_~_appended':'3818',
    'rsagent-trusted-domainremoved':'11165',
    'spyware-helpexpress':'12583',
    'User_account_deleted':'14029',
    'http-cgi-dmailweb-bo':'3570',
    'idrop-activex-bo':'4672',
    'nav-javascript-enabled':'7576',
    'IPM_Internal_Error':'5321',
    'backdoor-subseven':'732',
    'enjoysap-kweditcontrolkwedit1-bo':'2170',
    'ARCserve_Backup_LGServer_parameter_BO':'2101008',
    'QOTD port probe':'9177',
    'TFTP_Nimda_Response':'2111004',
    'malcode-ExistingDropper':'6298',
    'spyware-adshooter':'12439',
    'SMTP_MailEnable_NTLM_Type3_Overflow':'2106249',
    'TCP_port_probe':'13426',
    'malcode-VB_38':'6831',
    'malcode-VB_35':'6828',
    'malcode-VB_34':'6827',
    'malcode-VB_37':'6830',
    'malcode-VB_36':'6829',
    'malcode-VB_31':'6824',
    'malcode-VB_30':'6823',
    'malcode-VB_33':'6826',
    'malcode-VB_32':'6825',
    'DNS_NULL_Query':'2000416',
    'ms-aspnet-rcpencoded-dos':'7160',
    'irc-server':'5381',
    'ABB_Robotic_NetScan_Overflow':'5900002',
    'quicktime-rtsp-url-bo':'9248',
    'rhel-rhsa-2002-259-update':'9546',
    'SNMP Corrupt':'11990',
    'javase-javab-jre-unspecified':'5900002',
    'share-dacl-change':'11574',
    'rhel-rhsa-2008-0502-update':'10562',
    'rexec-default':'9501',
    'reg-ras-unencrypted-passwords':'9429',
    'HTTP_ACCEPT_Overflow':'2000615',
    'SMB_Unexpanded_Path_Binary_Planting':'5900002',
    'Glacier_Client_Request':'2113055',
    'MSRPC_Registry_Read_MS_Index_Server':'2003204',
    'rhel-rhsa-2006-0734-update':'10202',
    'nds-intruder-lockout-reset-interval':'7605',
    'aol-superbuddy-activex-code-execution':'386',
    'cups-ipp-dos':'1558',
    'Email_To_TooManyQuotes':'2147',
    'Ruler_TCP_Response':'2113060',
    'spyware-browserpal':'12475',
    'Thinking Arts directory traversal':'13692',
    'windows-mite-backdoor':'15025',
    'win-ms05kb896424-update':'14445',
    'BrightStor_Authentication_DoS':'2109027',
    'TCP XMAS scan':'13381',
    'HTTP_Outlook_Codebase_Execute':'4248',
    'rhel-rhsa-2005-575-update':'9985',
    'firefox-getrawder-code-execution':'2624',
    'user-homedir-gr':'13961',
    'user-homedir-gw':'13964',
    'cmd URL type':'1369',
    'rhel-rhsa-2007-0605-update':'10345',
    'Script_Suspicious_Score':'5900002',
    'msdtc-message-bo':'7252',
    'tivoli-lcf-default-password':'13706',
    'pdf417-mw6pdf417-file-overwrite':'8787',
    'Mstream_handler_activity':'7453',
    'rhel-rhsa-2006-0265-update':'10104',
    'sfu-invalid-rpc-dos':'11564',
    'Sensor shutdown':'11520',
    'mesg':'6992',
    'HTTP_Facebook_Login':'3907',
    'All Proventia protection started':'310',
    'service-control-change':'11543',
    'rhel-rhsa-2009-0313-update':'10628',
    'oe-wab-bo':'8403',
    'spyware-atztecmarketing-syscpy':'12452',
    'LPR port probe':'6076',
    'Image_TIFF_Kodak_Img_Viewer_Code_Exec':'2114072',
    'ie-popup-code-execution':'4823',
    'adobe-flash-netstream-code-exec':'5900002',
    'forced-browsing-probe':'2697',
    'TCP_post_connection_SYN':'13428',
    'rhel-rhsa-2005-770-update':'10026',
    'audit-results-file-deletion':'601',
    'rhel-rhsa-2010-0054-update':'5900002',
    'openssl-sslgetsharedciphers-bo':'8500',
    'user-failed-logon':'13954',
    'iis-ftp-domain-authentication':'4932',
    'TCP_Timestamp_DoS':'2120071',
    'ca-brightstor-messageengine-bo':'5900002',
    'snmp-set-public':'12107',
    'HTTP_OracleApp_dms0':'2105024',
    'admin-account-blank-password':'91',
    'win-browser-reset-frame':'14299',
    'Illusion_Backdoor_Response':'2110091',
    'exploit-MSPowerpoint(100014)':'2363',
    'Email_Amavis_Exec':'2001049',
    'IPM_Invalid_Checksum':'5322',
    'squid-htcp-enabled':'12935',
    'TFTP_Passwd_File':'2003701',
    'rhel-rhsa-2008-0538-update':'10575',
    'Nmap_Ping':'2001526',
    'ssh2-pubkey-auth-failed':'13000',
    'gift-backdoor':'3091',
    'apache-http-byterange-dos':'5900002',
    'ISA_detected_possible_enum_port_scan_attack':'5488',
    'nt-autorun-enabled':'7990',
    'SMB_Samba_AndX_Exec':'5900002',
    'iis-incorrect-permissions':'4949',
    'HTTP_lotsOfURLs':'2000621',
    'ssh2-common-auth-failed-host':'12990',
    'malcode-copyFile':'6185',
    'group-gid':'3172',
    'SNMP_RMON_Collections':'2104030',
    'SOCKS port probe':'12329',
    'win-tcpip-printing-dos':'14857',
    'rhel-rhsa-2011-1327-update':'5900002',
    'aix-iy61953-fix':'183',
    'DNS_Bind_Update_DoS':'5900002',
    'sgi-dispaly-patch-vuln':'11568',
    'ICC_Ace_Overflow':'5900002',
    'object-indirectly-accessed':'8397',
    'spyware-hyperbar':'12598',
    'win-ms08kb955702-update':'14678',
    'snmp-varbind-invalidtag':'12128',
    'isakmp-vendor-id':'5529',
    'identd-vuln':'4669',
    'CoalescerStatistics_Cumulative':'1372',
    'rhel-rhsa-2003-030-update':'9567',
    'HTTP_IIS_SSI_Safety_Overflow':'4077',
    'javascript-window-code-execution':'5601',
    'spyware-prodyne-webinstall':'12696',
    'SMB_IEShims_DLL_Hijacking':'5900002',
    'rhel-rhsa-2008-0966-update':'5900002',
    'raiden-ftpd-present':'9299',
    'sip-inconsistent-contact-ip-address':'11617',
    'win-ms06kb905756-update':'14474',
    'FSP_Delete_File':'2779',
    'SNMP_Indefinite_Length':'2106098',
    'SNMP enterprise invalid':'11999',
    'coldfusion-expression-evaluator':'1393',
    'winamp-multiple-bo':'5900002',
    'SynDrop attack':'13321',
    'firefox-sm-gif-bo':'5900002',
    'oracle-xml-bo':'5900002',
    'backdoor-backdoor2':'664',
    'cisco-ios-ospf-bo':'1299',
    'symantec-console-utilities-bo':'13306',
    'HTTP_IIS_Request_Header_DoS':'5900002',
    'TCP_Dabber_Sweep':'2118021',
    'UDP_Short_Header':'2000207',
    'Informix_DbInfo_Version_Overflow':'5900002',
    'publisher-pub-code-execution':'9162',
    'HTTP_BadBlue_DOS':'2002648',
    'Spyware_PH_WildTangent':'2113197',
    'oracle-jre-deployment-unspec':'5900002',
    'MoSucker_TCP_Response':'2113129',
    'newvcommon-activex-command-execution':'5900002',
    'Initial_SSDT_Not_Good':'5224',
    'rhel-rhsa-2005-785-update':'10031',
    'SSH2_Agent_forwarding_denied':'13003',
    'rhel-rhsa-2008-0516-update':'10568',
    'bisonware-port-crash':'880',
    'CA_InternetSecurity_UmxEventCli_ActiveX':'2124020',
    'SoftCart_password_URL':'12357',
    'ie-web-content-controlled-xss':'4867',
    'viruswall-helo-bo':'14102',
    'spyware-buddypictures':'12478',
    'nt-hkey-classeswrite':'8134',
    'rhel-rhsa-2005-808-update':'10044',
    'Oracle_DropSiteInstant_Bo':'2120045',
    'malcode-SPVD_SC_SEH_Misc':'6725',
    'spyware-searchit':'12725',
    'spyware-easysoftru-irc':'12537',
    'cyrus-sasl-format-string':'1610',
    'openoffice-vba-sec-bypass':'5900002',
    'rhel-rhsa-2007-0559-update':'10341',
    'rhel-rhsa-2009-1139-update':'10673',
    'SMTP encapsulated Exchange relay':'11812',
    'pi3web-isapi-bo':'8930',
    'HTTP_Gator_Installed':'3928',
    'HTTP_Dansie_Cart':'2002752',
    'AVM_Internal_Error':'634',
    'rhel-rhsa-firefox-nsftpstate-info-disclosure':'10690',
    'rhel-rhsa-2008-0890-update':'10596',
    'sendmail-daemon-enabled':'11483',
    'win-ms07kb931832-update':'14578',
    'aix-iy72752-fix':'234',
    'rhel-rhsa-2003-102-update':'9589',
    'ie5-import-export-favorites':'4876',
    'win-ms10kb981169-update':'5900002',
    'novell-iprint-targetframe-bo':'7932',
    'jboss-jmxconsole-security-bypass':'5900002',
    'HTTP_zenWorks_uploadServlet_Exec':'5900002',
    'exchange-mime-base64-code-execution':'2288',
    'rhel-rhsa-2008-1023-update':'5900002',
    'rhel-rhsa-postgresql-sqlfunc-info-disclosure':'10765',
    'nt-registry-nullopen':'8273',
    'coldfusion-admin-dos':'1389',
    'HTTP_AuthResponse_Possible_CSRF':'2110184',
    'pcanywhere-login-failed':'8757',
    'file-default-console':'2475',
    'win-ms09kb959239-update':'14705',
    'gui-kwedit-activex-code-execution':'5900002',
    'mysql-libmysqlclient-readonerow-bo':'7521',
    'rhel-rhsa-2004-157-update':'9691',
    'h225-suspicious-field-length':'3238',
    'nt-recycle-bin-access':'8267',
    'rhel-rhsa-2012-0103-update':'5900002',
    'MS security ID lookup':'7151',
    'win-ms11kb2476687-update':'5900002',
    'apache-modssl-speculative-dos':'463',
    'DonaldDick_Response':'2001552',
    'rhel-rhsa-2006-0615-update':'10165',
    'malcode-IRCDangerousContext':'6356',
    'pdfpro-uploadftp-file-overwrite':'5900002',
    'xml-recursive-entity-declaration-dos':'15244',
    'rhel-rhsa-2008-0884-update':'10593',
    'elonfmt-activex-bo':'5900002',
    'Telnet_Bad_Environment':'13559',
    'Oracle_ValidateRemoteRC_Injection':'5900002',
    'default-login-onceonly':'1764',
    'BDDT_TCP_Response':'2113083',
    'VmReconfiguredEvent':'14130',
    'administrative-user-does-not-exist':'99',
    'win-ms08kb951207-update':'14656',
    'spyware-cashtoolbar':'12483',
    'SMTP_EXPN_command':'11902',
    'DNS_Length_Overflow':'1933',
    'trend-micro-activex-code-execution':'5900002',
    'exploit-MSExcel(100008)':'2346',
    'ypserv-reserved':'15356',
    'IMAP_WU_Imapd_BO':'2106176',
    'SMB_Empty_Password':'2000502',
    'rhel-rhsa-2008-0528-update':'10571',
    'SMB_I_O_using_printer_share':'11754',
    'RPC_CALLIT_Request':'2001735',
    'HTTP_ChEtcPasswd':'2110125',
    'zlib-doublefree-memory-corruption':'15374',
    'netscape-server-pageservices':'7739',
    'php-phpcgi-code-execution':'5900002',
    'HTTP_Info2WWW':'2002518',
    'FTP_Tar_Exec':'2001315',
    'aix-iy78926-fix':'259',
    'Non-Compliance Warning':'7894',
    'ffbconfig-bo':'2456',
    'malcode-SPMZ_DO_HDD_AT':'6560',
    'VmPoweredOnEvent':'14129',
    'SSH2_Pubkey_auth_failed_root':'13023',
    'nfs-cache':'7794',
    'rhel-rhsa-2010-0428-update':'5900002',
    'openldap-modrdn-request-dos':'5900002',
    'realplayer-wav-bo':'5900002',
    'rhel-rhsa-2004-562-update':'9766',
    'nt-group-create-pagefile':'8089',
    'mdac-broadcast-request-bo':'6954',
    'uucp-ftpuser':'14053',
    'Email_Envid_Overflow':'2001030',
    'accountingsoftware-string-handling':'43',
    'backdoor-girlfriend':'690',
    'adobe-player-unspec-bo':'5900002',
    'JavaScript_Obfuscated_MethodName':'5900002',
    'rhel-rhsa-2006-0283-update':'10112',
    'Web site copying':'14213',
    'nt-workstation-not-restricted':'8376',
    'aix-iy79595-fix':'262',
    'Windows_LSA_Connect':'15034',
    'dhcpd-minires-multiple-bo':'1813',
    'isa-conn-limit-exceed-rule-rejected':'5434',
    'Weakness CGI scan':'14210',
    'SMB_Shutdown_Request':'11788',
    'domino-dwa7w-bo':'1981',
    'malcode-Downloader3':'6214',
    'ssh2-pam-auth-failed':'12995',
    'Critical_File_Modified':'1536',
    'HTTP_Dwmapi_Dll_Hijacking':'5900002',
    'fuseware-popmail-bo':'3039',
    'novell-edirectory-dsvread-bo':'7912',
    'wayboard-cgi-view-files':'14209',
    'IRC_Join':'5393',
    'scarab-backdoor':'11354',
    'forcecontrol-readandwrite-bo':'5900002',
    'rhel-rhsa-2009-1431-update':'5900002',
    'libwpd-multiple-bo':'5894',
    'alibaba-url-file-manipulation':'308',
    'rhel-rhsa-openssh-block-dos':'10744',
    'fdformat-bo':'2444',
    'ssl-weak-cipher-choice':'13086',
    'win-ms-branchcache-code-execution':'5900002',
    'rhel-rhsa-2005-595-update':'9992',
    'malcode-INFUpdateAutoBat':'6350',
    'decod-rlogin':'1731',
    'Homefree search CGI':'3288',
    'SNMP_Header_Underflow':'12207',
    'gnutella-worm':'3148',
    'qpopper-auth-failed-for-user':'9181',
    'java-servlet-crosssite-scripting':'5582',
    'SQL Exec Passwd':'12875',
    'rhel-rhsa-2007-0022-update':'10224',
    'servicecnf-detected':'11553',
    'win-ms11kb2586448-update':'5900002',
    'quicktime-tiff-overflow':'9252',
    'malcode-DropperPlus':'6234',
    'comodo-antivirus-command-execution':'1411',
    'apache-apachebench-response-bo':'409',
    'libtiff-custom-tag-dos':'5882',
    'rsagent-imap2-preauthenticated':'11054',
    'HTTP_MediaWiki_Executable_Upload':'2106181',
    'malcode-PackedSuspicious':'6418',
    'SMTP_Expn_Metachar':'2111013',
    'Nonroot_setauid':'7896',
    'nt-sec-audit':'8299',
    'nds-user-template-no-password':'7649',
    'cproxy-http-dos':'1526',
    'idrive-activex-file-overwrite':'5900002',
    'file-never-accessed':'2527',
    'Windows_OOB':'15037',
    'SNMP_bad_varbindlist_tag':'12170',
    'DNS_Zonexfer_High':'2000424',
    'Cyn_Request':'2113100',
    'rwhod-vuln':'11238',
    'rhel-rhsa-2007-0019-update':'10223',
    'ldap-nullbind':'5825',
    'Unauthenticated_logon_connection_rejected':'13879',
    'Danton_TCP_Response':'2113046',
    'FTP_XM_ABOR_Format_String':'3032',
    'user-homedir-group-root':'13962',
    'tftp-home-perms':'13647',
    'kernel-stack-expansion-dos':'5763',
    'TelnetEnvAll':'13606',
    'yahoomsg-yauto-activex-bo':'15334',
    'ie-dximagetransform-execute-code':'4736',
    'NMAP ping':'7855',
    'samba-reply-nttrans-bo':'11274',
    'HTTP_IIS_URL_Decoding':'4085',
    'DNS Internet not 4 bytes':'1848',
    'ruby-alias-directory-security-bypass':'11222',
    'rhel-rhsa-2004-120-update':'9685',
    'Oracle_SnapInternal_Overflow':'5900002',
    'mozilla-focus-information-disclosure':'7078',
    'BitTorrent_mDNS_Request':'894',
    'snmp-bad-variable-type':'12050',
    'rhel-rhsa-2008-0857-update':'5900002',
    'HTTP_BioNet_ICQ_Pager':'2002606',
    'win-ms07kb925902-update':'14558',
    'nt-audit-disabled-onceonly':'7984',
    'TelnetEnvLong':'13607',
    'spyware-ietray':'12608',
    'file-force-reboot':'2501',
    'helixserver-ntlm-bo':'5900002',
    'win-ms05kb901214-update':'14455',
    'Application Protection Stopped':'508',
    'spyware-homepageware':'12588',
    'SubSeven ICQ pager URL':'13175',
    'rhel-rhsa-2005-025-update':'9809',
    'rhel-rhsa-2010-0198-update':'5900002',
    'oracle-dropsiteinstantiation-bo':'8552',
    'sun-java-dll-code-execution':'5900002',
    'SOCKS_Authentication_Malformed':'12347',
    'HTML_IE_OWC_Code_Exec':'3408',
    'rhel-rhsa-mozilla-deleted-frame-code-execution':'10714',
    'Exchange_mail_sent_on_behalf':'2318',
    'friendly-registryvalue-info-disclosure':'2743',
    'Corrupt_IP_Options':'2000108',
    'nds-user-unique-password':'7655',
    'HTTP_OracleApp_AggreSpy':'2105027',
    'adobe-acrobat-integer-dos':'106',
    'dafolo-filenames-bo':'1616',
    'isakmp-spi-size-bo':'5528',
    'FTP_Windows_Drive_Path':'2001361',
    'win-smb-pool-code-exec':'5900002',
    'mdaemon-form2raw-from-bo':'6961',
    'win-ms07kb927198-update':'14564',
    'uoc-ultraofficecontrol-file-overwrite':'13911',
    'cups-logic-error-dos':'1562',
    'win-emf-wmf-header-bo':'14323',
    'rhel-rhsa-2010-0221-update':'5900002',
    'nt-netbios-share-printer':'8203',
    'group-first-character':'3171',
    'http-iis-2e':'3635',
    'snmp-info':'12078',
    'prov-update-available':'9136',
    'rhel-rhsa-2007-0813-update':'10377',
    'urlscan-http-head-detection':'13941',
    'rootkit-login-backdoor':'10841',
    'malcode-SPNE_WrtEPEOF_Str':'6623',
    'acrobat-reader-unspec-dos':'52',
    'ping-flood':'8953',
    'oracle-character-conversion-gain-privileges':'8535',
    'Mstream_Zombie':'7455',
    'malcode-SPPE_WrtSect65_St':'6705',
    'HTTP_Bigsam':'2105017',
    'sip-length-mismatch':'11624',
    'HTTP_PhpRocket_Traversal':'2106063',
    'HTTP_Vmware_ISAPI_Extension_DoS':'5900002',
    'HTTP cgi with ~ appended':'3487',
    'ARJ_AV_Evasion':'2121038',
    'SNMP counter64':'11991',
    'SNMP_enterprise_invalid':'12200',
    'HTTP_URL_MS_ADC_Samples':'2002557',
    'snmp-improper-trap-handling':'12077',
    'HTTP_mailnews_post':'2002601',
    'bittorrent-dht-ping-detected':'886',
    'php-certificate-unspecified':'5900002',
    'JavaScript_OLE_Overflow':'2113265',
    'HTTP_URL_with_blank_appended':'4468',
    'hp-lp-dos':'3316',
    'rhel-rhsa-2011-1005-update':'5900002',
    'wh00t-backdoor':'14271',
    'SNMP_unknown_tag':'12287',
    'UDP_Probe_Norton_AV':'13854',
    'Image_Pattern_Corruption':'5094',
    'vmware-intraprocesslogging-file-overwrite':'14147',
    'HTTP_Netscape_PageServices':'2106025',
    'cisco-ios-saa-dos':'1301',
    'HTML_File_URI_Overflow':'5900002',
    'Flv_Very_Large_Array_Size':'5900002',
    'ibm-ids-unspecified-privilege-escalation':'5900002',
    'pine-display-parameters-bo':'8945',
    'malcode-VB_10':'6807',
    'win-ms05kb873352-update':'14423',
    'rhel-rhsa-2005-122-update':'9856',
    'malcode-VB_17':'6810',
    'LDAP_Active_Directory_Request_DoS':'2106286',
    'ms-office-rtf-bo':'5900002',
    'HTTP_Apache_Error_Cookie_Disclosure':'5900002',
    'SMB_Negotiate_Duplicate_Resp_Exec':'11765',
    'CVS_Directory_Double_Free':'2107023',
    'javase-jre-saaj-unspecified':'5900002',
    'trojan-hotword':'13780',
    'PDF_Obfuscated_Stream':'2114160',
    'adobe-sandbox-sec-bypass':'5900002',
    'malcode-DelTreeStrong':'6206',
    'http-indexserver-asp-source':'3641',
    'rsagent-suspect-pop2':'11149',
    'apache-child-process-dos':'419',
    'gnupg-openpgp-code-execution':'3138',
    'php-safemode-elevate-privileges':'8900',
    'spyware-hiwire':'12586',
    'kernel-udp-ipv6-dos':'5769',
    'Exchange_view_administrator_login':'2332',
    'owc-spreadsheet-host-script-execution':'8697',
    'rhel-rhsa-2007-0167-update':'10271',
    'threedify-activex-file-overwrite':'5900002',
    'SNMP_InvalidTag_VarBind':'2106103',
    'aix-iy78224-fix':'253',
    'shoutcast-format-string':'11604',
    'nt-applog':'7982',
    'win-cryptoapi-asn-spoofing':'14306',
    'HTTP_eDirectory_Host_Overflow':'2106275',
    'spyware-avatar-resources':'12455',
    'rhel-rhsa-openssl-x509-dos':'10750',
    'dcforum-az-directory-traversal':'1654',
    'quikstore-misconfig':'9277',
    'win-ms10kb2455005-update':'5900002',
    'telnet-auth-null':'13528',
    'rhel-rhsa-2010-0061-update':'5900002',
    'JavaScript_Large_Unescape':'2110149',
    'HTTP_Application_Server_Stack_Bo':'3769',
    'malcode-SPNE_RareDLL_Jmp':'6604',
    'TFTP_Sam_File':'2003702',
    'group-rootequiv':'3181',
    'SMB winreg file':'11716',
    'rhel-rhsa-2012-0071-update':'5900002',
    'malcode-SPPE28':'6640',
    'windows-media-player-installed':'15024',
    'ca-message-queue-bo':'1083',
    'malcode-SPPE22':'6634',
    'malcode-SPPE23':'6635',
    'malcode-SPPE20':'6633',
    'malcode-SPPE26':'6638',
    'malcode-SPPE27':'6639',
    'malcode-SPPE24':'6636',
    'malcode-SPPE25':'6637',
    'ie-scripting-bypass':'4831',
    'win2k-ticketgranted-renewed':'14982',
    'xftp-pwd-bo':'5900002',
    'win-ms10kb982132-update':'5900002',
    'win-htmlhelp-code-execution':'14344',
    'rhel-rhsa-2003-074-update':'9581',
    'ras_auth_timeout':'9316',
    'malcode-SpawnSuspiciousFile':'6539',
    'exploit-MSWord(100002)':'2374',
    'Mstream_agent_activity':'7452',
    'FTP_Filename_Overflow':'2001309',
    'rhel-rhsa-2006-0539-update':'10134',
    'flash-same-domain-disclosure':'2674',
    'RTSP_MediaPlayer_Vulnerable_Client':'2118131',
    'rhel-rhsa-mozilla-contentdef-code-execution':'10711',
    'HTTP_NetwareWebserver_Traversal':'2106065',
    'nt-single-process-onceonly':'8311',
    'login-attempt-retry':'6021',
    'HTTP_MDAC_RDS_Overflow':'2110008',
    'nt-multiprotocol':'8192',
    'SSH2_Rhosts_auth_failed':'13025',
    'netdde-remote':'7709',
    'nsed':'7944',
    'TheThing':'13690',
    'MSRPC_CA_Arcserve_Agent_Overflow':'5900002',
    'Y3K trojan horse ping':'15297',
    'ftp-user-access':'2876',
    'chrome-counter-nodes-code-execution':'5900002',
    'optix-backdoor':'8512',
    'HTTP_GroupWise_Client_Overflow':'5900002',
    'jasper-jpccoxgetcompparms-bo':'5900002',
    'ServiceScan':'11556',
    'win-smb-packet-bo':'14844',
    'CVS_Auth_User_Success':'1579',
    'nt-applog-overwrite-oldevents':'7980',
    'rhel-rhsa-2009-1531-update':'5900002',
    'SMB_MSRemote_Desktop_DLL_Hijacking':'5900002',
    'CGI formmail.pl':'1138',
    'LDAP_Oracle_Bind_Dos':'5900002',
    'SQL_SSRP_StackBo':'2106151',
    'rhel-rhsa-2003-052-update':'9574',
    'Security_disabled_local_group_deleted':'11455',
    'HTTP_Webgais':'4495',
    'httpserver-expect-header-xss':'4549',
    'win-ms11kb2507618-update':'5900002',
    'Satan_UDP':'2102003',
    'boep-iplanet':'952',
    'uucp-directories-accessed':'14051',
    'nt-malformed-dialer':'8176',
    'win-his-rpc-code-execution':'14340',
    'malcode-BackdoorApp4':'6163',
    'java-bmp-dos':'5900002',
    'nfs-running':'7815',
    'malcode-BackdoorApp5':'6164',
    'tftp-homedir-own':'13649',
    'outlook-email-long-header-dos':'8675',
    'rhel-rhsa-xorg-fontsdir-bo':'10771',
    'aix-iy76483-fix':'246',
    'tftp-put':'13654',
    'win-ms09kb970710-update':'14738',
    'rhel-rhsa-2009-0020-update':'5900002',
    'prepare-file-baseline-list':'9100',
    'Ident_Overflow':'2001906',
    'nt-service-logon':'8304',
    'user-account-deleted':'13947',
    'RPC_getport_probe':'10952',
    'IDENT_Generic_Intel_Overflow':'2104002',
    'malcode-BackdoorApp0':'6160',
    'rds-enabled':'9343',
    'multiple-vendor-tcp-dos':'7489',
    'WindowsMedia_Asf_Code_Exec':'15043',
    'snmp-bad-requestid':'12046',
    'rhel-rhsa-2009-1083-update':'10665',
    'wins-updateversionrequest-bo':'15078',
    'quicktime-applet-information-disclosure':'9212',
    'win-gdi-wmf-image-code-execution':'14333',
    'spyware-winad':'12829',
    'malcode-ExeSeq40':'6284',
    'cisco-rttmon-kill':'1319',
    'HTTP_IIS3_Asp_Dot':'2000604',
    'SMB_MovieMaker_DLL_Hijacking':'5900002',
    'HTTP_Eva_Forms_Dir':'2105005',
    'win-ms08kb949029-update':'14642',
    'NetDevil_TCP_Response':'2113132',
    'oracle-version':'8581',
    'iis-hithighlighting-security-bypass':'4938',
    'smtp-pipe':'11870',
    'SNMP_length_indefinite':'12237',
    'cisco-catalyst-remote-commands':'1267',
    'CGI_win-c-sample.exe':'1218',
    'XML_JNLP_Codebase_BO':'2122021',
    'LDAP_Long_ASN1_Length':'5900002',
    'pcre-library-subpattern-dos':'8770',
    'HP_OpenView_NNM_ovas_Exec':'5900002',
    'backdoor-hvlrat':'696',
    'win-ms11kb2604926-update':'5900002',
    'ms-agent-acf-bo':'7153',
    'rhel-rhsa-2008-0151-update':'5900002',
    'SMTP_Too_many_recipients':'11946',
    'http-cgi-wwwboard-default':'3607',
    'rhel-rhsa-2007-0841-update':'10380',
    'HTML_Mshtml_Overflow':'2113245',
    'ActiveX_IE6':'5900002',
    'inn-controlmsg':'5226',
    'MSRPC_Security_Id_Lookup':'2002805',
    'rhel-rhsa-2007-0132-update':'10262',
    'win-ms07kb941202-update':'14605',
    'win-ms04035-patch':'14411',
    'CompoundFile_Excel_Sheet_Malformed_Size':'2110117',
    'sgmltools-symlink':'11571',
    'pdf-swf-detected':'8786',
    'mailman-admin-login-css':'6118',
    'actinvr-savexmlfile-file-overwrite':'55',
    'cisco-ios-ipv4-dos':'1290',
    'wftpd-mkd-bo':'14267',
    'Xanadu_UDP_Response':'2113168',
    'malcode-SPMZ_BasicInt':'6557',
    'stacheldraht-dos':'13123',
    'php-gd-overflow':'8862',
    'nt-netbios-everyoneaccess':'8197',
    'reg-netbt-blocks':'9409',
    'WINS_WPAD_Registration':'2101071',
    'visibroker-osagent-bo':'14103',
    'HTTP_ColdFusion_WebPublish_ExampleApp':'2002621',
    'SSH2_Passwd_auth_failed_root':'13019',
    'application-execution-allowed':'513',
    'gomplayer-gomwebctrl-bo':'3157',
    'win2k-globalgroup-changed':'14920',
    'RTF_Shellcode_Detected':'5900002',
    'interactual-iamce-bo':'5244',
    'webalizer-html-tags-keywords':'14224',
    'win2k-secenabled-universalgroup-created':'14957',
    'HTTP_Redirect_Memory_Corruption':'5900002',
    'dark-connection-inside-backdoor':'1635',
    'CGI_faxsurvey':'1181',
    'win-ms06kb905757-update':'14475',
    'rhel-rhsa-2008-0908-update':'10605',
    'FTP_SITE_PSWD_exploit':'3004',
    'rhel-rhsa-2006-0330-update':'10116',
    'telnetd-option-telrcv-bo':'13605',
    'nfs-cd':'7795',
    'BitTorrent_DHT_GetPeers':'891',
    'CyberCop_Scanner_ICMP':'2102010',
    'sip-authenticate-parameter-detected':'11612',
    'HTTP_WikkiTikkiTavi_Remote_Template':'2106071',
    'Cert_rejected_not_trusted':'1125',
    'Cafeini_TCP_Response':'2113065',
    'ibm-informix-dbinfo-bo':'5900002',
    'libtiff-tifffetchdata-overflow':'5888',
    'sascam-webcamserver-bo':'11303',
    'mozilla-shell-program-execution':'7127',
    '3270-mapper':'6',
    'rhel-rhsa-2007-1024-update':'10431',
    'cisco-secret-disabled':'1320',
    'rhel-rhsa-2008-0134-update':'10498',
    'rhel-rhsa-2007-0696-update':'10352',
    'http-header-request-smuggling':'5900002',
    'openssh-uselogin-execute-code':'8481',
    'rhel-rhsa-openoffice-starcalc-bo':'10743',
    'win-ms10kb980195-update':'5900002',
    'hp-procurve-snmp-write-dos':'3330',
    'ident-users':'4655',
    'Finger_Enumeration':'2001111',
    'sched':'11362',
    'win-schannel-code-execution':'14827',
    'Tron_TCP_Request':'2113161',
    'Cyn_TCP_Response':'2113096',
    'win2k3-group-create-global-privilege':'14992',
    'excel-name-code-execution':'5900002',
    'rhel-rhsa-2005-489-update':'9959',
    'rhel-rhsa-2007-0513-update':'10330',
    'msnmessenger-video-bo':'7282',
    'MeetTheLamer_TCP_Request':'2113124',
    'Lotus_Domino_directory_traversal':'6060',
    'HTTP_Auctionweaver':'2002587',
    'ID3_Winamp_Tag_Overflow':'5900002',
    'rhel-rhsa-2005-337-update':'9906',
    'rhel-rhsa-2005-868-update':'10064',
    'pop-user-root':'8984',
    'isa-pf-ip-pf-create-failure':'5462',
    'Authentication_ticket_request_failed':'612',
    'rhel-rhsa-bind-rrsets-dos':'10683',
    'win-mediaplayer-audio-code-execution':'14379',
    'win-ms11kb2560847-update':'5900002',
    'csc-dcsclictrl-bo':'5900002',
    'email-smtp-uuencoded-long-filename':'5900002',
    'Squid_cachemgr.cgi':'12951',
    'ms-win-mpegl3-code-execution':'5900002',
    'HTML_JS_showHelp_Code_Exec':'2118058',
    'rsagent-auditlog-cleared':'11014',
    'SDP_Ansi_Escape':'2106297',
    'newsilencer-backdoor':'7787',
    'win-media-player-png-bo':'14375',
    'dns-zonexfer':'1894',
    'snmp-version-underflow':'12133',
    'TCP_Trojan_Numeric_Response':'2120018',
    'dns_cname':'1910',
    'backdoor-intruzzo':'699',
    'malcode-VB_19':'6812',
    'malcode-VB_18':'6811',
    'kernel-sctp-dos':'5755',
    'MSRPC_Spoolss_GetPrinterData_DoS':'2110129',
    'boep-iexplore':'950',
    'SMTP ETRN overflow':'11815',
    'malcode-VB_11':'6808',
    'isa-abnormal-termination':'5428',
    'fix-logon-detected':'2663',
    'HTTP_OpenView_NNM_ovet_Exec':'5900002',
    'malcode-VB_15':'6809',
    'WparManaged':'15175',
    'SourceRoute':'12411',
    'Devil':'1782',
    'freeradius-token-sqlunixodbc-dos':'2733',
    'ms-iis-repeated-post-dos':'5900002',
    'nt-guest-account':'8123',
    'TFTP_Hosts_File':'2003706',
    'sipproxy-i3sipmsg-bo':'11673',
    'timbuktu-plughntcommand-bo':'13701',
    'Scada_DNP_DisableUnsolResponses':'11335',
    'win-active-setup':'14286',
    'rhel-rhsa-2005-640-update':'10000',
    'pushdo-worm-detected':'9164',
    'dns-invalid-domain':'1874',
    'malicious-file':'6920',
    'spyware-searchmiracle':'12727',
    'Computer_account_changed':'1466',
    'rhel-rhsa-2007-1076-update':'10451',
    'SNMP_bad_enterprise_tag':'12145',
    'Code_Red_II':'1383',
    'msrpc-suspicious-uuid':'7296',
    'Listserv CGI exploit':'5996',
    'vnc-login-failed':'14157',
    'sun-jre-socks-info-disclosure':'5900002',
    'win-ms03045-patch':'14395',
    'nav-java-enabled-execution':'7573',
    'HTTP_POST_SQL_WaitForDelay':'2113026',
    'win-ms07kb941569-update':'14608',
    'orinoco-as-ppp-reveals-credentials':'8627',
    'netterm-ftp-dele-bo':'7761',
    'javascript-obfuscation-tokens':'5594',
    'Telnet_Auth_Kerb5':'13552',
    'Telnet_Auth_Kerb4':'13551',
    'Image_WMF_HeaderFileSize_Underflow':'2121048',
    'visualstudio-wmiscriptuti-code-execution':'14113',
    'rhel-rhsa-2005-801-update':'10038',
    'SMB_MFC_DLL_Hijacking':'5900002',
    'terminal-emulator-window-title':'13616',
    'oxon-backdoor':'8698',
    'nt-logon-audit-failure':'8161',
    'CGI_mailnews_suspicious_field':'1195',
    'icmp-unreachable':'4607',
    'mssql-sqlxml-script-injection':'7434',
    'IIS_sample_URL':'5021',
    'HTTP_CobaltRAQ_alert':'2105016',
    'linux-ugidd':'5980',
    'clamav-chmunpack-dos':'5900002',
    'HTML_BlackIce_BarCode_ActiveX':'3382',
    'HTTP_Linksys_ApplyCgi_BO':'2106206',
    'bind-solinger-dos':'862',
    'FTP SITE ZIPCHK buffer overflow':'2822',
    'decod-http-java':'1699',
    'sms-remote-service-dos':'11801',
    'EvilFTP_Backdoor':'2238',
    'win-gdi-emf-code-execution':'14327',
    'kernel-aacraid-privilege-escalation':'5719',
    'ftp-win.ini-transfer':'2879',
    'decod-mount-export':'1711',
    'iis-htmlencode-code-execution':'4939',
    'smtp-server-identity-audit':'11876',
    'HTTP_URL_with_repeated_.':'4469',
    'edraw-edd-bo':'5900002',
    'win-media-player-bmp-bo':'14374',
    'exchange-anonymous-imap':'2279',
    'HTTP_PHP_LoadPrefs':'2002687',
    'MHTML_Handler_Detected':'5900002',
    'safari-feed-dos':'5900002',
    'bind-dns-libresolv-bo':'841',
    'decod-irc-nick':'1709',
    'HTTP GET sam._ file':'3506',
    'winamp-id3v2-bo':'5900002',
    'SNMP_backdoor':'12139',
    'win-components-dll-code-execution':'5900002',
    'sendmail-daemon-mode':'11484',
    'win-ms08kb959070-update':'14694',
    'exploit-MSPowerpoint(100012)':'2361',
    'Rlogin_Auth_Failed':'2001605',
    'mozilla-xmlprototype-code-execution':'7139',
    'malcode-Masquerade':'6371',
    'ofm-outside-oif-dos':'5900002',
    'multiple-starttls-command-execution':'5900002',
    'DPAPI_master_key_backup_attempted':'1999',
    'SMTP mail to decode alias':'11824',
    'mssql-resolution-service-bo':'7427',
    'Allaire_JRun_WebInf_DotSlash':'2004901',
    'malcode-ProcessInjector':'6429',
    'libxml2-entitynames-bo':'5900002',
    'reg-smb-redirector':'9445',
    'lv-program-execution':'6090',
    'Email_ServerID':'2142',
    'realwin-scada-multiple-bo':'5900002',
    'reg-uninstall':'9455',
    'multiple-symantec-vrtsweb-code-execution':'5900002',
    'decod-smtp-invalid-rcpt-command':'1741',
    'HTTP_Omnihttp':'2002692',
    'iis-myriad-escape-chars':'4968',
    'Security_Management_Heap_BO':'2106264',
    'samba-version-detected':'11285',
    'nt-dnscrash':'8048',
    'backdoor-netspy12':'710',
    'IMAP_Too_Many_Connects':'2110004',
    'Evaluation_Period_Has_Ended':'2226',
    'HTTP_QuickTime_RTSP_Response_BO':'4346',
    'wsftp-ftp-command-bo':'15177',
    'publisher-file-format-code-execution':'9160',
    'HTTP_IIS_Double_Eval_Evasion':'2106051',
    'webtrends-rpt-serv-install-password':'14262',
    'SMTP_From':'11906',
    'rhel-rhsa-2007-0015-update':'10221',
    'rsync-write-files':'11205',
    'IMAP_Tagname_FormatString':'5900002',
    'ms-server-service-bo':'7202',
    'malcode-HTMLScriptletTypelibAndOther':'6334',
    'rhel-rhsa-2004-436-update':'9738',
    'Security_disabled_universal_group_member_removed':'11462',
    'Trojan_Turkojan':'13793',
    'Unlicensed Feature':'13904',
    'IRC_SubSeven_Notification':'2001802',
    'Proxy_port_probe':'9152',
    'ms-win-lsass-privilege-escalation':'5900002',
    'ttymon-saf':'13816',
    'PE_MS_Protection_Engine_DoS':'2122037',
    'AeDebug_reg_hack':'147',
    'groupwise-arg-path-disclosure':'3184',
    'HTTP_Orderform':'4243',
    'WindowsMedia_Mscvrt_Corruption':'5900002',
    'rhel-rhsa-2003-282-update':'9630',
    'HTTP_IIS_HTR_Chunked_Overflow':'2114002',
    'malcode-AutorunBandit':'6154',
    'cisco-ios-modify-snmp':'1297',
    'win-kodak-image-code-execution':'14360',
    'malcode-AssumedRAT1':'6142',
    'aix-iy68463-fix':'220',
    'ms-wmi-wbemsingleview-ce':'5900002',
    'webspeed-adminutil-auth':'14253',
    'exploit-MSExcel(100021)':'2350',
    'MobiLink_Login_Overflow':'5900002',
    'HTTP_POST_XP_Cmdshell':'2004502',
    'ppp':'9089',
    'adobe-com-code-execution':'5900002',
    'rhel-rhsa-2009-1601-update':'5900002',
    'cisco-ios-http-dos':'1288',
    'SIP_Blank_Header_Value':'2120069',
    'rhel-rhsa-2009-1694-update':'5900002',
    'sun-jre-unspecified-privilege-escalation':'13224',
    'nt-winreg-all':'8369',
    'ie-xml-redirect-read-files':'4874',
    'SIP_Inconsistent_Contact_IP_Address':'2106291',
    'rhel-rhsa-2002-180-update':'9532',
    'alibaba-post-dos':'307',
    'win-ms07kb934232-update':'14584',
    'apache-modphp-process-hijack':'453',
    'rsagent-guest-user-login':'11049',
    'POP_Login_Overflow':'2000701',
    'winzip-wzfldvw-dos':'5900002',
    'aix-iy78801-fix':'258',
    'nt-backup':'7998',
    'http-post-script':'3671',
    'PE_MS_Authenticode_Validation':'5900002',
    'rhel-rhsa-2003-193-update':'9608',
    'netscape-ssl-disabled':'7741',
    'HTTP_ASP_Stateserver_Overflow':'2113019',
    'FTP_Passive_Very_Long':'2001344',
    'rhel-rhsa-2008-0580-update':'10578',
    'rhel-rhsa-2009-0348-update':'5900002',
    'QuickTime_FTYP_Flip_Overflow':'9265',
    'RemoteWatch':'9482',
    'rsagent-imap2-bruteforce':'11052',
    'Telnet_Resolve_Host_Conf':'2000909',
    'rhel-rhsa-2007-0430-update':'10316',
    'rhel-rhsa-2005-495-update':'9960',
    'javascript-obfuscated-methodname':'5900002',
    'CompoundFile_Excel_Object_Validation':'2114133',
    'HTTP_MediaServices_CallHTMLHelp':'4161',
    'blackice-execution-failure':'915',
    'gstreamer-qtdemuxparsesamples-bo':'3193',
    'netbackup-vmd-sscanf-bo':'7681',
    'Spyware_PH_WeatherBug':'2113192',
    'Ascend attack':'562',
    'FTP_NetTerm_Dir_Overflow':'2001338',
    'FTP_RNTO_dotdot':'5900002',
    'CA_License_GCR_Overflow':'5900002',
    'ie-form-redirection':'4748',
    'SNMP empty packet':'11998',
    'HTTP_IIS_Invalid_File_Parsing':'2113039',
    'RADIUS_Pass_Overflow':'9295',
    'rhel-rhsa-2005-586-update':'9989',
    'sojourn.cgi argument contains %00':'12361',
    'spyware-spyarsenal-internet-spy':'12748',
    'ip-options-corrupt':'5278',
    'malcode-ExeSeq48':'6290',
    'rhel-rhsa-2009-1618-update':'5900002',
    'reg-hotfix-installed':'9398',
    'autonomy-keyview-html-multiple-bo':'619',
    'MSRPC_LSA_LookupSids_Samba_Bo':'2118100',
    'dameware-obtain-information':'1620',
    'win-lsass-dos':'14365',
    'rhel-rhsa-2007-0940-update':'10405',
    'ISA_WPS_Stop':'5524',
    'oracle-listener-information-disclosure':'8566',
    'spyware-bluefudelta':'12466',
    'uucp-mail-dotforward':'14055',
    'itunes-m3u-pls-bo':'5900002',
    'wildtangent-wthoster-webdriver-bo':'14283',
    'BackOrifice2K_UDP_Response':'2100019',
    'Oracle_Findricset_Injection':'5900002',
    'malcode-ExeSeq47':'6289',
    'HTTP_IndexServer_Webhits':'2002568',
    'HTTP HOST_ repeated many times':'3508',
    'win-ms05kb900725-update':'14454',
    'ssh2-agent-forwarding-denied':'12983',
    'spyware-messenger-plus':'12641',
    'Suspect_Sunrpc':'13267',
    'aix-iy67741-fix':'215',
    'ISAKMP_Payload_Overflow':'2107014',
    'ntmail-relay':'8387',
    'Preauthentication_failed':'9099',
    'HTTP_IIS_ISAPI_Printer_Overflow':'2002607',
    'active-directory-grant-attempt':'63',
    'malcode-DropperAgent':'6229',
    'malcode-ActivateRegEditInStartup':'6130',
    'FTP_PWD_Response_Overflow':'5900002',
    'HTTP_Windows_Backup_Mgr_DLL_Hijacking':'5900002',
    'PmapMnt':'2001726',
    'win-mediaplayer-plugin-embed-bo':'14380',
    'linux-dcc-port-access':'5921',
    'nis-dom':'7835',
    'HTTP_MDAC_Get':'4154',
    'typsoft-ftp-directory-traversal':'13823',
    'Image_WMF_NumObjects_Corrupt':'2116030',
    'ssh-group-access':'12975',
    'anonftp-dir-perms':'355',
    'firefox-wallpaper-code-execution':'2640',
    'DHCP_Host_Metachar':'5900002',
    'trust-remote-nonroot':'13801',
    'msdns-port-probe':'7250',
    'Telnet Bad IFS':'13509',
    'spyware-suninfoconnect':'12756',
    'tcp-ack-ping':'13382',
    'spyware-gratisware':'12580',
    'Kuang2Virus_Response':'2001562',
    'file-net666-virus':'2526',
    'psbanner-tmpfile-symlink':'9154',
    'SQL_Exec_Passwd':'12897',
    'mssql-named-pipe-dos':'7416',
    'active-directory-replication-rejected':'73',
    'cisco-bruteadmin':'1264',
    'avirt-directory-create':'631',
    'rhel-rhsa-2005-571-update':'9984',
    'rhel-rhsa-2010-0603-update':'5900002',
    'MSRPC_Domaindump':'2002803',
    'spyware-memorywatcher':'12638',
    'HTTP_Nimda_Worm':'2106148',
    'aix-iy85518-fix':'274',
    'HTTP_ProvMail_Load_Evasion':'5900002',
    'tor-detected':'13739',
    'aix-iy88183-fix':'278',
    'adobe-acrobat-reader-heap-bo':'5900002',
    'Cyn_Response':'2113101',
    'win-ms09kb971633-update':'14746',
    'rhel-rhsa-2006-0200-update':'10093',
    'qq-vqqplayer-bo':'9193',
    'HTML_Win_SearchProtocol_Code_Exec':'3469',
    'nt-gina-clipboard':'8082',
    'squid-ftpbuildtitleurl-bo':'12933',
    'wordviewer-openwebfile-file-execution':'15164',
    'SNMP_Bad_OID_Type':'12157',
    'ServeMe':'11529',
    'user-trust-other-host':'14021',
    'NMAP OS fingerprint':'7854',
    'win-ms06kb917627-update':'14510',
    'rsagent-qpopper-loginfailure':'11099',
    'user-trust-perms':'14022',
    'rhel-rhsa-2012-0125-update':'5900002',
    'rhel-rhsa-2005-090-update':'9841',
    'win-ms05kb891711-update':'14434',
    'ie-hhctrl-bo':'4761',
    'win-ms11kb2546250-update':'5900002',
    'UDP_Ipswitch_Logging_Server_DOS':'5900002',
    'SIP_Authenticate_Parameter':'2114028',
    'rhel-rhsa-2005-294-update':'9889',
    'HTTP_Object_Type_Overflow':'2104014',
    'Exchange_unauthenticated_nntp_command':'2326',
    'pdf-stream-detected':'8785',
    'llockmgr':'6001',
    'hp-imc-tftpserver-bo':'5900002',
    'IIS_FTP_Session_Status_DoS':'2113000',
    'nis-udp':'7845',
    'proxy-http-connect-detected':'9149',
    'rhel-rhsa-2005-136-update':'9862',
    'nt-changedservice-owner':'8011',
    'win2k-group-policy-block':'14925',
    'rhel-rhsa-2004-323-update':'9716',
    'FTP_Mdtm_Very_Long':'2001347',
    'decod-trin00-daemon-register':'1753',
    'PrettyPark_worm':'9103',
    'pdf-degenerate-stream':'5900002',
    'MSRPC_Srvsvc_Netname_Bo':'2118146',
    'rsagent-lp-expired':'11073',
    'win-ms10kb982335-update':'5900002',
    'snmp-echo-bounce':'12063',
    'TCP_FIN_Scan':'2000305',
    'win-ms09kb960715-update':'14711',
    'malcode-SearchSystemCreate':'6510',
    'rhel-rhsa-2011-1401-update':'5900002',
    'sdp-invalid-header-type':'11408',
    'WFM_URL_Requested':'14264',
    'client-certificate-unsolicited':'1359',
    'iis-webdav-dos':'5004',
    'win-ms12kb2699988-update':'5900002',
    'rhel-rhsa-2004-349-update':'9718',
    'groupwise-gxmim1-activex-dos':'3185',
    'apache-moddav-lock-dos':'448',
    'HTTP_NSS_PKCS11txt':'5900002',
    'Tron_TCP_Response':'2113162',
    'LDAP_blacklist_short-term':'5838',
    'Failed_to_calculate_new_security_descriptor':'2435',
    'FTP_PORT_restricted':'2973',
    'HTTP_CompaqInsightManager_Taglist':'2105072',
    'ida-idaiehlp-bo':'4640',
    'arcadegames-activex-command-execution':'5900002',
    'lpc-memory-consumption':'6064',
    'nt-autologonpwd':'7989',
    'FTP_Unix_Passwd_File_Accessed':'2110194',
    'rservice-exec-wrapper-deny':'11186',
    'pdf-encoded-streamfilter-tag-detected':'8777',
    'PICTURE.EXE virus':'8941',
    'rsagent-sybase-startup':'11163',
    'win-dns-spoof-information-disclosure':'14318',
    'BOEP_inetinfo':'970',
    'rhel-rhsa-2004-354-update':'9720',
    'CompoundFile_Excel_Object_BO':'2106225',
    'dbsoftware-vimpax1-bo':'1652',
    'firewall-trust':'2643',
    'win-vista-dhcp-dos':'14872',
    'ie-bmp-integer-overflow':'4691',
    'MyDoom_SYNFlood':'2110042',
    'mountd-reserved':'7045',
    'ident-suspicious-id':'4654',
    'RIFF_Shockwave_Dirapi_Overflow':'5900002',
    'malcode-SPPE_DO_Wrt_Bound':'6670',
    'win-ms04029-patch':'14407',
    'malcode-DisableAV2':'6209',
    'Suspicious_ActiveX_Installer':'2103033',
    'boep-sqlservr':'957',
    'zoomifyviewer-zactivex-bo':'15393',
    'HTTP_SGI_Infosrch':'2002578',
    'iis-rootfolder-privilege-escalation':'4979',
    'SMB_NTLM_ExtendedSec_Privilege_Escalation':'5900002',
    'HTML_SkyFex_Client_Overflow':'3457',
    'file-group-writeable':'2506',
    'SMTP_Turn':'11947',
    'linux-zlibinflate-dos':'5986',
    'MyDoom_Backdoor':'2113052',
    'ProFTPD_snprintf_exploit':'9119',
    'NDMP_Veritas_BackupExec_ErrorField_BO':'2101002',
    'Image_JPEG_Monkif':'5900002',
    'lpd-control-file-shell-command':'6066',
    'win-ms11kb2624667-update':'5900002',
    'php-imagecolortransparent-unspecified':'5900002',
    'win-ms10kb978207-update':'14785',
    'spyware-win32-thunk':'12828',
    'HTTP_PHP_Memchr_BO':'2106123',
    'nap-clientupdate':'7549',
    'malcode-DisableAV':'6208',
    'ie-html-combination-code-execution':'4765',
    'activex-executable-detected':'82',
    'HTML_IE_Javaprxy_Heap_Corruption':'2106195',
    'PGM_Detected':'8831',
    'flash-air-corruption-code-execution':'5900002',
    'frontpage-ext-image-map':'2754',
    'quicktime-m3u-bo':'5900002',
    'shockwave-pami-riff-code-execution':'5900002',
    'win2k-secenabled-universalgroup-changed':'14956',
    'win-ms12kb2607664-update':'5900002',
    'ca-arcservebackup-casdscvc-dos':'1063',
    'ypxfrd':'15359',
    'rhel-rhsa-2005-603-update':'9995',
    'lotus-123fileviewer-bo':'6040',
    'once-only-multihomed':'8434',
    'minivend-viewpage-sample':'7024',
    'CGI_guestbook':'1187',
    'rhel-rhsa-2005-345-update':'9910',
    'TOR_Client_Request':'13740',
    'win-smb-policy-modification':'14846',
    'rhel-rhsa-2008-0485-update':'10558',
    'SMB_Samba_SidParse_Overflow':'5900002',
    'win-rpc-race-condition':'14822',
    'win-ms11kb2506014-update':'5900002',
    'ie-style-comment-bo':'4844',
    'shell-disabled-account':'11588',
    'win-ms10kb2385678-update':'5900002',
    'malcode-SPNE__4_16K_DateTime':'6583',
    'Rsh_Command_Overflow':'5900002',
    'leadtools-multimedia-file-overwrite':'5855',
    'exec-mod':'2333',
    'Ident_Scan':'2001902',
    'spyware-orbitexplorer':'12685',
    'ca-etrust-scm-ftp-bo':'1079',
    'Oracle_Too_Many_Useless_Sessions':'8614',
    'Finger Backdoor':'2574',
    'acer-acerctrls-code-execution':'45',
    'rsagent-ssh-authattempt-refused':'11115',
    'ActiveX_Warning':'88',
    'nt-ras-dialin':'8261',
    'winwhatwhere-investigator':'15092',
    'Script_IE_toStaticHTML_XSS':'5900002',
    'ms-windows-cover-page-bo':'5900002',
    'RPC_Probe':'10979',
    'winrar-unacev2-ace-bo':'15073',
    'malcode-SPPE31':'6646',
    'Image_WMF_Code_Exec_Function':'2121044',
    'Project_Next_Response':'2107012',
    'haihaisoft-activex-bo':'5900002',
    'HellzAddiction_TCP_Response':'2113113',
    'rsagent-account-locked':'11011',
    'oblivion-backdoor':'8400',
    'win-ms12kb2646524-update':'5900002',
    'nt-policy-audit-success':'8231',
    'MSRPC_Share_Dump':'2002802',
    'SOAP_Message_Body':'12323',
    'Oracle_Invalid_Login':'8601',
    'blackice-application-compliance-error':'907',
    'malcode-SPPE34':'6649',
    'Firewall_Info':'2651',
    'win-ms08kb924090-update':'14618',
    'hp-remote':'3331',
    'spyware-locatorscomToolbar':'12625',
    'netware-dele-bo':'5900002',
    'ie-cache-getelementsbyname-dom-access':'4701',
    'HTTP_PsaPhp_RevealSource':'2106064',
    'HTTP_login_failed':'4130',
    'Windows_Printing_Service_DOS':'2102039',
    'roads cgi file access':'10829',
    'NETBIOS names query':'7682',
    'http-option-method-detected':'3657',
    'user-shutdown':'14016',
    'ms-smb-message-code-exec':'5900002',
    'file-default-passreq':'2480',
    'OpenSSH_Auth_Failed':'8482',
    'Timbuktu_Login_Overflow':'5900002',
    'rhel-rhsa-2009-0259-update':'5900002',
    'oracle-transform-layer-bo':'5900002',
    'Log_on_to_account_failed':'6018',
    'aix-iy62006-fix':'186',
    'win-ms10kb981160-update':'5900002',
    'SSH_DNS_spoofing_attack-no_reverse_mapping':'13041',
    'apache-servertokens':'476',
    'admin-usage-system-log':'96',
    'spyware-dotsworlds-client':'12524',
    'XFS_Query_Range_Swap_Overflow':'15227',
    'retrospect-backup-packet-dos':'9497',
    'HackATack_UDP_Response':'2100021',
    'pine-url-handler-commands':'8948',
    'icecast-http-remote-dos':'4591',
    'POP3_Auth_Failed':'2001604',
    'FTP_Rnto_Very_Long':'2001350',
    'openssl-asn1-dos':'8485',
    'cart32-expdate':'1106',
    'SNMP_Nagios_Plugins_CheckSNMP_BO':'12244',
    'SMB_VBA_Word_DLL_Hijacking':'5900002',
    'SNMP_enterprise_underflow':'12201',
    'rhel-rhsa-2007-0883-update':'10389',
    'ibm-ratth-bbfb-code-execution':'5900002',
    'HTTP_ColdFusion_RDS_Null_Password':'3848',
    'HTTP_InterscanViruswall_Smtpscan':'2002633',
    'email-attachment-extension-detected':'2069',
    'nis-tcp':'7843',
    'rhel-rhsa-2005-670-update':'10003',
    'Image_TIFF_Office_Heap_Overflow':'5900002',
    'SMIL_QuickTime_SrcURL_Overflow':'5900002',
    'open-proxy-server-running':'8444',
    'rhel-rhsa-2003-231-update':'9616',
    'Zip_JavaSE_Jre_Dos':'5900002',
    'rhel-rhsa-2011-1241-update':'5900002',
    'totaldefense-multiple-sql-injection':'5900002',
    'rhel-rhsa-2005-881-update':'10068',
    'WRF_ATAS_Overflow':'5900002',
    'Gift_Download':'3093',
    'login-failures-onceonly':'6023',
    'win-ms12kb2718523-update':'5900002',
    'HTTP_URL_FrontPage_Service_Password':'2002543',
    'MSRPC_Lookupnames':'2002804',
    'win2k-rpc-tcp135-dos':'14954',
    'bitdefender-bdelev-activex-code-execution':'881',
    'HTTP_DCShop_info':'2002628',
    'Evaluation Period Has Ended':'2225',
    'TCP_Probe_SQL':'13451',
    'solaris-tl-driver-dos':'12388',
    'cgi-startform-xss':'1174',
    'SOLIDDB_Format_String':'12395',
    'CGI test-cgi':'1162',
    'Script_NamoInstaller_ActiveX':'2114103',
    'rhel-rhsa-2007-0356-update':'10300',
    'postgresql-update-dos':'9077',
    'backdoor-connection':'673',
    'ie-embed':'4737',
    'MavericksMatrix':'6939',
    'win-ms11kb2544521-update':'5900002',
    'tcpdump-nfs-bo':'13481',
    'malcode-PackedVBDropper':'6419',
    'SNMP_bad_generic_trap_tag':'12153',
    'file-log-replaceable':'2519',
    'PE_ClamAV_PE_UPX_Overflow':'2106221',
    'WRF_ATDL_Integer_Overflow':'5900002',
    'malcode-HTMLDropHTASus':'6328',
    'HTML_Tabular_Data_URL_Overflow':'5900002',
    'UDP_Probe_Trojan':'13859',
    'rhel-rhsa-2004-053-update':'9667',
    'http-icq-request':'3632',
    'ms-winobj-view-jet500':'7230',
    'linux-kernel-tf-dos':'5942',
    'malcode-DeleteFiles':'6194',
    'nfs-nfsd':'7806',
    'IRC_Nick':'5399',
    'Buttman_TCP_Response':'2113048',
    'malcode-ExeSeq22_FirstGen':'6271',
    'domino-imap-crammd5-bo':'1982',
    'comraider-activex-vbdevkit-file-overwrite':'1470',
    'hamachi-vpn-detected':'3263',
    'HTTP_MSIS_Script':'2105080',
    'HTTP_Sojourn':'2002574',
    'rhel-rhsa-2008-0135-update':'10499',
    'rhel-rhsa-2006-0132-update':'10077',
    'HTTP_Shells_Tcsh':'2002529',
    'proficy-activex-bo':'5900002',
    'OSPF_Hello':'8651',
    'SubSeven CGI notification':'13173',
    'CFF_Invalid_Offset_Size':'5900002',
    'win-service-pack':'14834',
    'Tivoli_LCF_Post_Overflow':'5900002',
    'Image_TIFF_Invalid_DateTime':'5900002',
    'HTTP_Unify_UploadServelet':'2002597',
    'rhel-rhsa-2008-0498-update':'10561',
    'quicktime-crgn-bo':'9217',
    'rhel-rhsa-2009-0445-update':'10654',
    'ie-setrequestheader-security-bypass':'4839',
    'rhel-rhsa-2003-138-update':'9596',
    'malcode-VBAAutoSpawnSystemSus':'6852',
    'win-ms08kb954066-update':'14669',
    'rhel-rhsa-2005-032-update':'9812',
    'malcode-BlankRAS':'6170',
    'rhel-rhsa-2002-157-update':'9526',
    'solaris-cachefsd-name-bo':'12372',
    'spyware-imlserver-ieplugin':'12611',
    'win-ms11kb2482017-update':'5900002',
    'FTP_Cisco_IOS_Multiple_BO':'2893',
    'Config-log_files_delete_failed':'1481',
    'isakmp-hdr-bad-version':'5526',
    'jws-jnlp-code-execution':'5687',
    'rhel-rhsa-2003-096-update':'9588',
    'win-ms03046-patch':'14396',
    'Scada_DNP_WarmRestart':'11339',
    'virtualization-vdi-cve20113571':'5900002',
    'iis-ms01044-patch':'4962',
    'backdoor-event-horizon':'683',
    'malcode-OffensiveScript':'6398',
    'win-ms10kb975558-update':'5900002',
    'odbs-text-ctxsys-tablefuncasown-bo':'5900002',
    'rhel-rhsa-2004-035-update':'9661',
    'dns-data-string-bo':'1868',
    'zeus-zbot-detected':'15367',
    'scada-modbus-incorrect-length':'11326',
    'rhel-rhsa-2004-413-update':'9733',
    'informix-nfx-bo':'5215',
    'Domino_Content_Execution':'5900002',
    'SNMP packet underflow':'12018',
    'share-deleted':'11575',
    'CGI_uploader.exe':'1211',
    'IMAP2bis_server_user_login_failure':'5145',
    'NTLM_Auth_Response_DoS':'8384',
    'FTP_Fname_Lnk':'2003609',
    'sendmail-version':'11514',
    'disney-search-info':'1831',
    'javascript-suspicious-hex-encoding':'5596',
    'exchange-ical-dos':'2284',
    'ssh-tcp-forwarding':'12980',
    'lotus-domino-directory-traversal':'6045',
    'rhel-rhsa-2007-0890-update':'10392',
    'jrun-isapi-host-bo':'5682',
    'smtp-buffer-overflow':'11851',
    'malcode-SPNE_Sys_cpy_self':'6616',
    'HTML_XSS_Attempt':'2116020',
    'spyware-tintl-dialer':'12769',
    'win2k-account-logon':'14896',
    'SNMP_Suspicious_Version_Size':'2106107',
    'NNTP_port_probe':'7881',
    'malcode-Susp_Jmp_DO_SnkInt':'6763',
    'ssh-plaintext-length-field':'12978',
    'MSRPC_Registry_Permissions':'2113042',
    'rhel-rhsa-2007-0158-update':'10269',
    'Email_Encap_Relay':'2001018',
    'ms-win-wsdapi-code-execution':'7228',
    'RAR_SubBlock_IO':'2121042',
    'VmStartingEvent':'14136',
    'URL_ends_with_~':'13939',
    'spyware-adbutler':'12433',
    's2-scan-completed':'11243',
    'rhel-rhsa-2009-1145-update':'5900002',
    'Script_Microsoft_XML_Core_Attack':'5900002',
    'iis-cgi-overflow':'4910',
    'winxp-signing-server-agrees':'15102',
    'mozilla-layoutengine-code-execution':'7097',
    'openssl-asn1-ssl-dos':'8488',
    'Gnutella_Shareaza':'3153',
    'rhel-rhsa-2011-0857-update':'5900002',
    'netterm-ftp-rmdir-bo':'7766',
    'Worm address':'15168',
    'rhel-rhsa-2004-638-update':'9785',
    'SMB_Motorola_Timbuktu_Plughntcommand_Exec':'11764',
    'ekiga-gmmainwindowflash-format-string':'2063',
    'HTTP UTF8 backtick':'3545',
    'Back_Orifice_2000_response':'653',
    'foxitreader-activex-bo':'5900002',
    'SniperNet':'11962',
    'nt-netbios-share-print-guest':'8202',
    'user-trust-local-own':'14020',
    'iis-ssi-safety-check-bo':'4989',
    'hpe-hpeinc-file-include':'5900002',
    'SQL_Injection':'2110128',
    'LDAP_eDirectory_ExtensionBuffer_Overflow':'5900002',
    'Zero_length_TCP_option':'15366',
    'decod-ftp-get':'1687',
    'amd-pid':'345',
    'hp-nnm-getcvdata-bo':'3317',
    'HTTP_User_Agent':'4474',
    'walld':'14200',
    'win-ms11kb2633171-update':'5900002',
    'msrpc-udp-port-probe':'7298',
    'mail-recipient-suspicious':'6108',
    'rhel-rhsa-2010-0616-update':'5900002',
    'adobe-flash-filereference-file-upload':'124',
    'rhel-rhsa-2011-1326-update':'5900002',
    'nt-server-oper-blank-pwd':'8302',
    'domino-ldap-bo':'5900002',
    'sabpab-malware-detected':'5900002',
    'SSL_Voip_Data_Collector_BO':'2109021',
    'POP_YPOPs_Overflow':'2121002',
    'samsung-netiviewer-activex-bo':'5900002',
    'NetSpy_v12':'7756',
    'hpov-hidden-snmp-comm':'3341',
    'HTTP_Novell_iManager_File_Upload':'5900002',
    'VNC_NoAuthentication':'2002905',
    'MSRPC_NTLM_Reset_DoS':'2118112',
    'phpnuke-pwd-admin-access':'8926',
    'movicon-contentlength-bo':'5900002',
    'SNMP backdoor':'11965',
    'Allaire_JRun_Sample_Files':'2004905',
    'decod-dns-hinfo':'1679',
    'spyware-hoterotik-dialer':'12591',
    'viewstation-unicode-retrieve-password':'14088',
    'Synthesized_Network_Attack_Flood':'2102036',
    'Pict_PackBitsRgn_Underflow':'8937',
    'ms-win-gre-bo':'5900002',
    'glftpd-site-zipchk':'3106',
    'rhel-rhsa-2010-0557-update':'5900002',
    'WINS_UDP_Pointer_Code_Exec':'2110170',
    'phpsecurepages-checklogin-execute-code':'8929',
    'SSH_Rhosts_auth._attempt_from_unprivileged_port':'13052',
    'epolicy-orchestrator-bo':'2183',
    'malcode-VB_MultiplePEImages':'6843',
    'euniverse-spyware':'2222',
    'FTP_Help_Overflow':'2001329',
    'rsagent-registry-autorun-changed':'11101',
    'Telnet_Abuse':'2000901',
    'win-ms09kb967183-update':'14722',
    'TFTP_Nimda_Query':'2111003',
    'oracle-tns-onetcp-dos':'8577',
    'rhel-rhsa-2009-0339-update':'10637',
    'rpc.nisd long name':'10910',
    'SSH_SecurID_auth._required':'13060',
    'Queso_Scan':'2000321',
    'win-ms06kb917422-update':'14508',
    'hp-digital-hpqvwocx-file-overwrite':'3301',
    'POP_QPopUser_Overflow':'2104003',
    'VCF_Contacts_Gadget_Exec':'5900002',
    'ms-sharepoint-help-dos':'5900002',
    'telnet-env-termcap':'13539',
    'PPTP_port_probe':'9098',
    'Spyware_PH_DownloadWare':'2113183',
    'ms-ole-wmf-code-exec':'5900002',
    'nt-autoboot-enabled':'7986',
    'iis2-check-samples':'5011',
    'rhel-rhsa-2007-0368-update':'10302',
    'SMTP_Sendmail_XHeader_Overflow':'11940',
    'Security Policy Compliance Renewed':'11434',
    'rhel-rhsa-2009-0355-update':'10644',
    'VmGuestShutdownEvent':'14126',
    'agentmanager-warning':'154',
    'win-ms10kb982799-update':'5900002',
    'malcode-ScriptSusRegistry':'6508',
    'Coma_Response':'2001545',
    'HTTP_ScanMail_Auth_Bypass':'4363',
    'win-ms05kb894320-update':'14440',
    'IS_Scan_Completed':'5426',
    'SNMP bad version tag':'11985',
    'rhel-rhsa-2010-0633-update':'5900002',
    'SNMP_trap_addr_underflow':'12279',
    'rhel-rhsa-2005-800-update':'10037',
    'Xanadu_UDP_Request':'2113167',
    'fw1-encoded-characters-directory-traversal':'3043',
    'IMAP4_Very_Long_Command':'2102041',
    'tfsd':'13627',
    'HTML_MS_HelpCenter_CMD_Exec':'5900002',
    'malcode-SuspWorm1':'6785',
    'win-ms07kb938827-update':'14599',
    'HTTP_UserAgent_Too_Long':'2000629',
    'SMTP_Routing_Overflow':'2110071',
    'sendmail-dns-map-dos':'11489',
    'Content_Analyzer_Credit_Card_Num':'2120060',
    'ssh2-passwd-auth-failed-root':'12997',
    'Fragment_Differential_Size':'2000010',
    'FTP_NLST_directory_overflow':'2957',
    'win-tcpip-orphaned-connections-dos':'14856',
    'wireshark-dect-bo':'5900002',
    'hp-openview-node-manager-command-execution':'3325',
    'uuencoded-data':'5900002',
    'HTTP_IE_Status_Spoof':'2121004',
    'bind-recursion':'857',
    'rhel-rhsa-2007-0486-update':'10322',
    'intrust-ardoc-file-overwrite':'5900002',
    'rhel-rhsa-2009-1148-update':'10674',
    'Complete_Baseline_Started':'1421',
    'win-ms08kb958215-update':'14692',
    'rsagent-passchange-successful':'11095',
    'Oracle_Admin_SdoCodeSize_Bo':'2120052',
    'Image_PNG_Inflate_Integer_Overflow':'5900002',
    'HTTP_POST_contains_xp_cmdshell':'4304',
    'JavaScript_Agent_URL_Handling':'2114047',
    'rhel-rhsa-2004-023-update':'9658',
    'ie-webfolder-script-injection':'4868',
    'http-pcclient-message':'3660',
    'Exchange_PST_passwords_saved':'2321',
    'WinAmp_Playlist_Long_Filename_Overflow':'5900002',
    'java-color-profiles-privilege-escalation':'5900002',
    'rhel-rhsa-2005-137-update':'9863',
    'spyware-adroar':'12437',
    'oracle-appserver-modplsql-traversal':'8523',
    'win-ms06kb917736-update':'14512',
    'Image_PNG_Height_Bo':'2107030',
    'solaris-inrwhod-command-execution':'12378',
    'samba-smbionotifyoptiontypedata-bo':'11282',
    'malcode-SPNE_Un21_RdSelf':'6620',
    'malcode-Win32_Mytob_bf':'6881',
    'spyware-world-wide-webmarketing':'12836',
    'ie-cdf-execute-code':'4708',
    'SMTP_encapsulated_Exchange_relay':'11896',
    'unix-setruid-by-nonadmin':'13896',
    'spyware-marketscore-netsetter':'12635',
    'mozilla-http-referrer-spoofing':'7082',
    'exploit-MSExcel(100023)':'2352',
    'Gnutella_LimeWire':'3152',
    'hp-openview-ovtrace-bo':'3326',
    'ms-win-dfs-dos':'5900002',
    'ftp-user-login-success':'2878',
    'ibm-ids-librpc-bo':'5900002',
    'malcode-Comp1':'6181',
    'malcode-Comp2':'6182',
    'iis-check-indexed':'4914',
    'Certificate_Authority_Spoofing':'5900002',
    'CyberCop_Scanner_SMTP':'2102006',
    'Finger forwarding':'2579',
    'rsagent-ssh-rhostsauth':'11133',
    'user-mail-forward':'13988',
    'symantec-msgsys-bo':'13309',
    'BackOrifice_Large_Ping':'2121032',
    'malcode-Win32_Mytob_bi':'6882',
    'win-ms10kb2121546-update':'5900002',
    'Boink':'2000008',
    'csl-returnconnection-code-execution':'1555',
    'FTP_Site_Pswd':'2001314',
    'rhel-rhsa-2005-364-update':'9917',
    'spyware-allinone-telecom':'12448',
    'malcode-KazaaWorm1':'6366',
    'malcode-KazaaWorm0':'6365',
    'audit-compliance':'598',
    'rhel-rhsa-2002-250-update':'9542',
    'nt-logon-audit-success':'8162',
    'backdoor-sockets-de-troie':'729',
    'Image_EMF_GDI_RecordType_Exec':'5900002',
    'spyware-ieplugin':'12605',
    'nds-user-grace-logins':'7628',
    'nt-restricted-workstations':'8285',
    'ms-office-bmp-code-execution':'7190',
    'rshd':'11201',
    'malcode-RiskWare2':'6488',
    'proftpd-percent-sql-injection':'5900002',
    'dameware-detected':'1619',
    'Telnet_User_Environment_Bypass':'2109025',
    'tfn2k-dos':'13622',
    'TCP_Fin_OutOfRange':'2000312',
    'decod-imap-passwd':'1703',
    'RPC_Portmap_Getport':'10973',
    'unrestricted-shell-extensions':'13906',
    'spyware-netconnect':'12664',
    'bind-fetch-glue':'845',
    'Ident_Flood':'2103005',
    'pdf-javascript-exploit':'8783',
    'LDAP_Server_ASN1_Overflow':'2110046',
    'JavaScript_Packer_Alpha':'2114158',
    'apache-encoded-directory-traversal':'429',
    'ie-dhtml-bo':'4726',
    'Oracle_SubscriptionName_Injection':'5900002',
    'malcode-RiskWare5':'6491',
    'massaker-backdoor':'6935',
    'novell-iprint-uploadprinterdriver-bo':'7935',
    'Oracle batch file URL':'8515',
    'sgi-machineinfo':'11569',
    'IMAP4_Attack':'5158',
    'FTP_Site_Cmd':'2001305',
    'aix-iy70032-fix':'226',
    'IPv6_Netfilter_Bypass':'2108001',
    'file-timer':'2553',
    'TFTP_Echo_Bounce':'2001206',
    'postgresql-ascii-bo':'9061',
    'acro-reader-unspecifed-code-execution':'47',
    'malcode-InjectionInstall':'6352',
    'ssh2-pubkey-auth-successful':'13001',
    'rpc.tooltalkd overflow':'10926',
    'aix-iy59206-fix':'181',
    'communicrypt-activex-bo':'5900002',
    'Content_Compound_File_Bad_Extension':'2106192',
    'AVI_Cinepak_Codec_Exec':'5900002',
    'squirrelmail-mailbox-imap-injection':'12958',
    'malcode-RiskWare4':'6490',
    'wftpd-path-disclosure':'14268',
    'aol-window-immessage-code-execution':'387',
    'cisco-ios-icmp-redirect':'1289',
    'rhel-rhsa-2007-1049-update':'10444',
    'HTTP_StillImaging_DLL_Hijacking':'5900002',
    'Ident_Linux_DoS':'4661',
    'promotic-activex-code-exec':'5900002',
    'netscape-leave-secure':'7737',
    'rhel-rhsa-2005-396-update':'9933',
    'mysql-mysqld-dos':'5900002',
    'libgtop-permitted-bo':'5872',
    'SNTP_buffer_overflow':'12316',
    'tcp-split-handshake':'5900002',
    'RPC Yppasswd Overflow':'10866',
    'adobe-reader-jbig2-symbol-bo':'133',
    'mozilla-timerdialog-security-bypass':'7131',
    'global-allowed-cronat':'3109',
    'HTTP_ColdFusion_FileExists':'2002620',
    'win-ms05kb893756-update':'14439',
    'ethernet-driver-information-leak':'2218',
    'iis-v2':'5001',
    'CGI_newdsn.exe':'1198',
    'UDP_Service_Sweep':'2103024',
    'MSRPC_AV_Stack_BO':'2118078',
    'excel-sheet-name-bo':'2265',
    'Rwhod_Overflow':'2001401',
    'rhel-rhsa-2011-0926-update':'5900002',
    'php-htaccess-unauth-access':'8864',
    'win-ms08kb953839-update':'14668',
    'kerberos-as-tgs-dos':'5900002',
    'SQL_Spida_Worm':'2113008',
    'malcode-ChangeRegWithHTAFile':'6172',
    'Backdoor_CYN_Request':'2110089',
    'rhel-rhsa-2007-0310-update':'10284',
    'BitTorrent_Get_Request':'893',
    'CGI webdist.cgi':'1166',
    'SMTP_MIME_file_name_overflow':'11923',
    'HTTP_IE_BAT':'4011',
    'ie-png-inflate-bo':'4822',
    'powerpoint-object-code-execution':'9083',
    'VagrNoker_Response':'14063',
    'UDP_Network_Sweep':'2102046',
    'su-onceonly':'13170',
    'CompoundFile_Improper_Memory_Access':'2110105',
    'IPM_Quarantine_Rule_Matched':'5327',
    'malcode-Ring1':'6481',
    'Napster_Login_Info':'7564',
    'malcode-Ring3':'6483',
    'iis-group-iusr':'4936',
    'starteam-mpx-dos':'13134',
    'MSM_MailProcessed':'7262',
    'ISA_LOG_Service_Stopped_Logging_Failure':'5505',
    'malcode-Ring6':'6486',
    'HTTP_IIS_ASP_WebResource_Fetch_Error':'5900002',
    'HTTP_Httptunnel_Detected':'2118066',
    'HTTP_Kazaa':'4117',
    'rhel-rhsa-2010-0474-update':'5900002',
    'blackice-compliance-restored':'912',
    'rhel-rhsa-2008-0006-update':'10474',
    'telnet-xdisplay':'13547',
    'squid-auth-header-forwarding':'12928',
    'rhel-rhsa-2011-1267-update':'5900002',
    'nctaudioeditor-nctaudiograbber2-bo':'7592',
    'HTTP_MHTML_Redirect':'2114014',
    'xfree86-font-integer-overflow':'15217',
    'openview-dparm-omniinet-bo':'8505',
    'rhel-rhsa-2007-0993-update':'10422',
    'SQLServer_login_failed':'12922',
    'CBO_User_Overflow':'2121025',
    'openssh-block-dos':'8464',
    'Trusted_domain_removed':'13805',
    'HTTP_Squid_NTLM_Password_Bo':'2120055',
    'win-html-help-bo':'14342',
    'rhel-rhsa-2007-0905-update':'10395',
    'SSH_User_name_length_overflow_attack':'13063',
    'win2k-dns-resolver':'14914',
    'squid-http-response-dos':'12938',
    'Script_Shell_Command':'2110108',
    'POP3 MIME filename repeated blanks':'8994',
    'aix-iy88566-fix':'283',
    'spyware-bonzibuddy':'12467',
    'CGI snork.bat':'1160',
    'SMTP_Auth_Overflow':'11887',
    'Scada_DNP_Unknown_Protocol':'2118044',
    'le-gardien-backdoor':'5854',
    'ntlm-ssp-elevate-privileges':'8383',
    'webpage-cgi-view-info':'14244',
    'spyware-virusek-hijacker':'12794',
    'HTTP_URL_BackslashDotDot':'2106149',
    'HTTP_Form_filename_overflow':'3919',
    'HTTP_Authentication':'3782',
    'iis-url-extension-data-dos':'4997',
    'AIX_Pdnsd_Overflow':'2100022',
    'ethereal3-gpp2a11-bo':'2217',
    'dns-memory-leak':'1880',
    'MS_Compressed_Folders_Overflow':'2103031',
    'CGI rksh':'1158',
    'gnupg-message-modify':'3136',
    'rhel-rhsa-2008-0815-update':'10581',
    'aix-iy88615-fix':'285',
    'gnutar-gnutypenames-symlink':'3143',
    'nt-policy-audit':'8232',
    'HTTP_IE_Script_Error_Code_Execution':'2122002',
    'file-su-insecure':'2545',
    'nt-drwatson-stack-overflow':'8063',
    'malcode-HTMLEndlessLoopGUI1':'6329',
    'win-ms07kb937894-update':'14596',
    'malcode-HTMLEndlessLoopGUI2':'6330',
    'rhel-rhsa-2009-1321-update':'5900002',
    'rhel-rhsa-2005-612-update':'9997',
    'photostockplus-uploader-bo':'8848',
    'iis-unicode-translation':'4994',
    'PPTP port probe':'9093',
    'Papa virus':'8718',
    'HTTP_IIS_htr_isapi':'2105037',
    'btd-zom-mail-bo':'1032',
    'xfs-service-enabled':'15224',
    'Spyware_PH_MyWebSearch':'2113193',
    'HTTP_HOST__field_overflow':'3984',
    'malcode-WeakWorm0':'6876',
    'malcode-WeakWorm1':'6877',
    'malcode-WeakWorm2':'6878',
    'exploit-MSWord(100020)':'2378',
    'ibm-proventia-load-crlf-injection':'5900002',
    'isa-server-init-failed-corrupt':'5470',
    'MSRPC_Dump':'2002801',
    'cfinger-user-enumeration':'1127',
    'flashplayer-actiondefinefunction-code-exec':'2680',
    'HTTP_IIS_Unicode_Translation':'4083',
    'bla-backdoor':'898',
    'rhel-rhsa-2007-0569-update':'10343',
    'Block_While_Proventia_Detection_Stopped':'936',
    'Sslvpn_Logout':'13110',
    'sdp-illegal-space':'11406',
    'spyware-tib-browser':'12767',
    'RemoteStorm_Response':'2001573',
    'nap-privmsg':'7554',
    'malcode-Susp14f':'6751',
    'NFS-LOCKD port probe':'7799',
    'ftp-servu':'2869',
    'SMTP_mail_to_rpmmail_alias':'11916',
    'rhel-rhsa-2005-408-update':'9937',
    'agent-shutdown-controller':'150',
    'http-cgi-glimpse':'3578',
    'hp-instantsupport-registrystring-bo':'3311',
    'rhel-rhsa-2007-0724-update':'10362',
    'M3U_UDP_Filename_Format_String':'5900002',
    'iis-webdav-long-request-dos':'5006',
    'RPC snmpXdmid overflow':'10859',
    'Windows_PWL_Access':'15039',
    'CSimple.asp overflow':'1553',
    'aix-iy72942-fix':'238',
    'Pict_Malformed':'2114115',
    'reg-assoc-added':'9392',
    'mdac-ado-code-execution':'5900002',
    'BOEP_iexplore':'969',
    'nt-increase-quota':'8142',
    'ie-frame-verification-variant2':'4755',
    'Security_Management_Integer_Underflow':'2106262',
    'conficker-worm':'1473',
    'Exchange_unauthenticated_imap_command':'2324',
    'aix-iy88722-fix':'292',
    'SNMP_bad_err_index':'12146',
    'mailalias-root-owned':'6113',
    'HTTP_Realserver_Noarg':'2002584',
    'mdaemon-helo-bo':'6962',
    'vnc-installed-noauth':'14153',
    'sunone-jsp-source-disclosure':'13240',
    'sonicwall-nelaunchctrl-addrouteentry-bo':'12400',
    'msvm-jdbc-ie-dos':'7466',
    'ids-server-detected':'4673',
    'HTTP_XStat':'2105019',
    'BitTorrent_Response':'896',
    'SSH2_TCPIP_forwarding_denied':'13027',
    'nt-changeduser-groups':'8016',
    'win-netlogon-dos':'5900002',
    'PsExec_Installed':'2110083',
    'nt-sequence-prediction-sp4':'8301',
    'ldap-schema':'5828',
    'Failed_login-account_locked_out_New':'2425',
    'flash-activex-movie-bo':'2670',
    'Finger port probe':'2582',
    'ms-aspnet-hash-dos':'5900002',
    'rhel-rhsa-2008-0529-update':'10572',
    'sysstat-inetd':'13334',
    'ipsec-policy-agent-disabled':'5348',
    'win2k-sp1':'14968',
    'Informix_ExplainFile_Overflow':'5900002',
    'Smurf':'11956',
    'Retina_Scanner':'2009207',
    'apple-quicktime-itunes-mov-bo':'494',
    'SMTP EXPN command':'11816',
    'blackice-settings-invalid':'928',
    'isa-pod-attack-detected':'5465',
    'coldfusion-mx-jrundll-bo':'1396',
    'spyware-starinstall-mainpean':'12750',
    'anonftp-home-perms':'360',
    'answerbook2-admin-scripts-access':'365',
    'nt-pwlen':'8259',
    'nt-rras-dun-cache':'8288',
    'win2k3-user-enable-delegation-privilege':'14999',
    'rhel-rhsa-2006-0547-update':'10138',
    'gdpicture-saveaspdf-file-overwrite':'3073',
    'netware-callitrpc-bo':'5900002',
    'PingFlood':'8957',
    'vpn1-asn1-decoding-bo':'14180',
    'unicast-service-dos':'13882',
    'malcode-TrojanInterface1':'6804',
    'GTP_C_Err_SystemFailure':'2111026',
    'HTTP_POST_pwl_file_type':'4324',
    'backage-backdoor':'657',
    'SMTP_relay_attempt':'11934',
    'security-access-granted':'11435',
    'HTTP double-encoded .._':'3491',
    'Failed_login-not_authorized_for_this_type_of_login':'2429',
    'HTTP_IIS_MSSQL_xml':'2105051',
    'wireshark-esp-offbyone':'15115',
    'crontab-denied-cronat':'1542',
    'POP3_MIME_file_name_overflow':'9010',
    'php-unspecified-integer-overflow':'8912',
    'win-ms04kb886185-update':'14419',
    'rhel-rhsa-nss-clientmasterkey-bo':'10737',
    'HTTP port probe':'3516',
    'magnetosoft-activex-bo':'5900002',
    'TCP_Multiple_Syns':'13418',
    'DNS_Hostname_Overflow':'2000403',
    'BackOrifice2K_TCP_Response':'2001515',
    'Telnet suspicious variable':'13522',
    'SNMP_Bad_Community_String':'12143',
    'QAZ_Backdoor_Request':'2100000',
    'NT system backup URL':'7953',
    'nt-guessed-backup':'8116',
    'nt-changedservice-sacl':'8012',
    'nt-regfileperm':'8271',
    'SNMP_InvalidTag_Version':'2106074',
    'file-cronat-group':'2471',
    'malcode-RCO4':'6436',
    'user-netrc-otheruser':'13995',
    'snmp-invalid-msgsecuritymodel':'12082',
    'snmp-missing-required-field':'12091',
    'nt-dcom-runas':'8036',
    'realplayer-activex-bo':'9353',
    'rhel-rhsa-2003-200-update':'9611',
    'rhel-rhsa-2010-0542-update':'5900002',
    'sun-jsasp-admin-auth-bypass':'13228',
    'win-user32-aniheader-overflow':'14866',
    'rhel-rhsa-2011-0486-update':'5900002',
    'Image_GIF_Netscape_Extension_BO':'2106187',
    'ibm-db2-connect-stream-dos':'4564',
    'SMB2_Write_Offset_Exec':'5900002',
    'httpd-cgi-scripts':'4542',
    'malcode-ScriptletTypelibUsage':'6507',
    'Failed_login-net_logon_not_active':'2427',
    'weblogic-jsp-source-read':'14239',
    'win-ms10kb2443105-update':'5900002',
    'mount-swap-world-readable':'7043',
    'HTTP_InterScan_VirusWall_Overflow':'2002657',
    'POP3 user name overflow':'8999',
    'malcode-Downloader1':'6212',
    'EZshopper search CGI':'2410',
    'snmp-community-format-string':'12052',
    'ftp-mget-directory-traversal':'2853',
    'password-shadowing-onceonly':'8745',
    'ldap-distinguished-name-detected':'5817',
    'HTML_IE_Sysimage_Disclosure':'2118027',
    'php-multiple-unspecified-bo':'8884',
    'incredimail-imshextu-code-execution':'5900002',
    'spyware-wildtangent':'12811',
    'adobe-navigatetourl-xss':'131',
    'malcode-IEHijackScript':'6339',
    'FTP_List_Long_Line':'2114094',
    'inetd-root-owned':'5207',
    'sntp-malformed-packet':'12314',
    'RIFF_Shockwave_tSAC_Exec':'5900002',
    'isa-pf-insecure-config':'5460',
    'SMTP_Exchange_Verb_BO':'2106281',
    'SQL_SSRP_MDAC_Client_Overflow':'2120008',
    'nfs-write':'7824',
    'ie-chained-css-code-execution':'4711',
    'HTTP_POST_sam.__file':'4326',
    'win-ms09kb957632-update':'14700',
    'Telnet_Terminal_Type':'13590',
    'rhel-rhsa-2006-0726-update':'10197',
    'Primary_security_token_issued':'9105',
    'officescan-decryption-bo':'8424',
    'rhel-rhsa-2005-038-update':'9818',
    'HTML_IE_Cached_Object_Exec':'5900002',
    'HTTP_Officescan_Config':'2105004',
    'imagemagick-graphicsmagick-dcm-bo':'5118',
    'ms-agent-url-code-execution':'7155',
    'servu-rnto-file-overwrite':'5900002',
    'rhel-rhsa-2007-0675-update':'10351',
    'MSRPC_Registry_Read_Sql_Execpass':'2003209',
    'cisco-ios-mpls-dos':'1298',
    'nt-thres-lockout':'8339',
    'Telnet_terminal_type_overflow':'13591',
    'malcode-ExeSeq33':'6280',
    'HTTP_TektronixPrinter':'2002677',
    'syslog-flood':'13332',
    'kerberos-setuid-privilege-escalation':'5708',
    'rhel-rhsa-mozilla-dom-method-xss':'10716',
    'hp-opennnm-schdparams-bo':'5900002',
    'malcode-ExeSeq31':'6278',
    'HTTP_IIS_dumpvariables':'2105039',
    'IPv6_Invalid_Hop_by_Hop_Header':'5900002',
    'expressfs-command-bo':'2402',
    'SMTP_Sendmail_Header_Parse_Overflow':'2115004',
    'nt-modem-autoanswer':'8185',
    'rlogin-password-bo':'10805',
    'malcode-SPNE_Srch_Write':'6612',
    'openoffice-wmf-emf-bo':'8461',
    'rhel-rhsa-2010-0342-update':'5900002',
    'win2003-sp2-not-installed':'14890',
    'win-ms11kb2536276-update':'5900002',
    'rhel-rhsa-2009-0344-update':'10640',
    'User_added_to_global_admin_group':'14034',
    'rc-command-worldwritable':'9327',
    'TCP_Probe_Telnet':'13455',
    'malcode-HideAutorun':'6324',
    'nfs-mountd':'7804',
    'rhel-rhsa-mozilla-addeventlistener-xss':'10708',
    'IDA_Pro_Discover':'4641',
    'viksoe-gmailfs-detected':'14089',
    'answerbook2-dwhttpd-format-string':'366',
    'win-ms06kb917734-update':'14511',
    'shockwave-3d-code-exec':'5900002',
    'malcode-SeachInXS':'6509',
    'lotus-domino-ldap-dos':'6047',
    'HTTP_URL_contains_.._.._.._..':'4445',
    'ICMP_TCP_MTU_DoS':'2118020',
    'linux-proc-race-condition':'5955',
    'mediaplayer-skin-code-execution':'6980',
    'Email_Auth_Overflow':'2001036',
    'FTP sam._ file':'2813',
    'nt-domain-userpwd':'8061',
    'mysql-mysqlhotcopy-insecure-file':'7525',
    'spyware-omniupdate':'12681',
    'openoffice-starcalc-bo':'8460',
    'win-ms07kb941568-update':'14607',
    'kernel-igmpheardquery-dos':'5900002',
    'IMAP_Fetch_Body_MsgPart_Overflow':'5900002',
    'malcode-IRCUnsolicitedSendFile':'6361',
    'ie-ahref-status-spoofing':'4688',
    'reg-ras-auditing':'9420',
    'spyware-blazing-tools-perfect-keylogger':'12464',
    'decod-rip-addentry':'1728',
    'file-fileprintf-bo':'2500',
    'BigGluck_Response':'2001541',
    'win-ms07kb942615-update':'14612',
    'malcode-SPPE_Jmp_DLL_StkExec':'6676',
    'portd':'9049',
    'Exchange_unauthenticated_pop3_command_invalid':'2328',
    'malcode-W32_Spyware':'6870',
    'malcode-VBAInstallChkDeleteFilesSus':'6859',
    'FTP_Unix_Password_File':'2003601',
    'file-dir-ww-perms':'2494',
    'backupexec-adminpluspack-bo':'770',
    'directx-dxtlipi-bo':'1826',
    'Cisco_CallMgrDB_DoS':'2120061',
    'sun-jre-unspecified-priv-escalation':'13223',
    'cameracontrol-activex-bo':'1094',
    'file-unusual-name':'2556',
    'PDF_JavaScript_Detected':'8801',
    'rhel-rhsa-2010-0578-update':'5900002',
    'php-sessiondecode-code-execution':'8904',
    'rsagent-userright-revoked':'11181',
    'spyware-search4all':'12720',
    'HTTP_3com_AirConnect_FirmwareSetup':'2106011',
    'win-ms05kb896426-update':'14446',
    'libtiff-tifftorgb-dos':'5890',
    'Kerberos_Weak_Encryption':'5900002',
    'rhel-rhsa-2011-0262-update':'5900002',
    'sql-injection-convert':'12879',
    'libwpd-wp6general-integer-overflow':'5895',
    'HTTP_IE_Cachedata_Security_Bypass':'2125017',
    'Oxon_TCP_Request':'2113222',
    'linux-ftdi-sio-dos':'5929',
    'xorg-fontsdir-bo':'15270',
    'application-rpc-bo':'516',
    'rhel-rhsa-2002-131-update':'9520',
    'win-tnef-overflow':'14862',
    'rhel-rhsa-2010-0782-update':'5900002',
    'decod-smtp-errors':'1737',
    'sybase-login-code-execution':'5900002',
    'SSH_Kerberos_KDC_possible_spoofing':'13046',
    'ms-win-msgbox-code-execution':'7226',
    'designreview-adview-file-overwrite':'1769',
    'reg-ras-not-logged':'9424',
    'ldap-injection-detected':'5819',
    'U3D_Block_Overflow':'5900002',
    'spyware-netradar':'12666',
    'bind-rrsig-dos':'5900002',
    'socks-multiple-login-failed':'12332',
    'afp-sequence-code-exec':'5900002',
    'ipv6-ipv4-tunnel-detection':'5362',
    'ip-options-invalid':'5279',
    'rhel-rhsa-2009-0428-update':'5900002',
    'spyware-Clariaprecisiontime':'12490',
    'HTTP_IE_MHT_Overflow':'2118000',
    'dns-poison-ns':'1882',
    'Flv_Malformed':'2114067',
    'POP_Fuseware_Overflow':'2000712',
    'win-nsiislog-post-bo':'14805',
    'GayOL_Request':'2001558',
    'SNMP_bad_trap_timestamp_tag':'12168',
    'rsh-svc':'11198',
    'mssql-jet-ods-bo':'7406',
    'RPC_suspicious_credentials':'10991',
    'TLS_Weak_Cipher_Suite':'5900002',
    'rhel-rhsa-2009-0016-update':'5900002',
    'T0rn_port_probe':'13353',
    'spyware-tracking-cookie':'12776',
    'CrazzyNet_Response':'2001547',
    'Spyware_PH_ShopAtHomeSelect':'2113196',
    'SubSeven IRC notification':'13176',
    'file-arp-insecure':'2462',
    'rsagent-group-deleted':'11046',
    'nt-object-audit-failure':'8216',
    'SQL_SSRP_Malformed_Enum_Response':'2120009',
    'HTTP_MSWord_Doc_Overflow':'2113160',
    'PHP_CGI_overflow':'8918',
    'fedora-xen-qemuvnc-information-disclosure':'2447',
    'qwertos-backdoor':'9281',
    'HTTP_Response_ContentLength_Overflow':'5900002',
    'SQL_SSRP_HeapBo':'2106152',
    'LPD_Unix_Shell_Command':'2110101',
    'RIFF_AVI_DirectShow_Overflow':'2110100',
    'kerio-mailserver-imap-dos':'5717',
    'JScript_OnRowsInserted_Corruption':'5900002',
    'rhel-rhsa-2003-022-update':'9565',
    'mailman-java-xss':'5900002',
    'win-ms10kb975713-update':'14778',
    'ppstream-ppsmedialist-bo':'9091',
    'SMTP_Exim_Header_Config_Code_Exec':'5900002',
    'aix-iy89169-fix':'296',
    'FTP_Put':'2980',
    'wireshark-scsi-dos':'15135',
    'Talk_Request':'13357',
    'Image_PNG_GDI_Heap_Overflow':'5096',
    'IRC_Msg':'5397',
    'group-right-changes':'3180',
    'file-hist-su':'2508',
    'aix-iy64852-fix':'200',
    'rhel-rhsa-2008-0161-update':'10510',
    'Email_Virus_Melissa':'2158',
    'rhel-rhsa-2009-1066-update':'10662',
    'tdfc-inet-24':'13491',
    'hsrp-resign':'3354',
    'sigplus-keystring-bo':'5900002',
    'rpc.admind_auth':'10893',
    'CGI_glimpse':'1186',
    'nav-enter-secure-site':'7572',
    'ftp-cwd':'2837',
    'freesshd-key-exchange-bo':'2734',
    'serverprotect-notification-bo':'11536',
    'RIFF_Director_Pointer_Mismatch':'5900002',
    'malcode-VBATimeTrigDeleteSus':'6862',
    'oracle-username-bo':'8579',
    'win-mediaplayer-arbitrary-code':'14377',
    'RemoteWatch_Response':'2102047',
    'decod-finger-user':'1685',
    'win-ms11kb2623699-update':'5900002',
    'rhel-rhsa-2003-003-update':'9558',
    'firefly-http-header-dos':'2616',
    'SOCKS_login_failed':'12350',
    'rhel-rhsa-2010-0018-update':'5900002',
    'SOLIDDB_Solid_DoS':'12397',
    'TearDrop2_attack':'13500',
    'TLS_Client_Certificate_Request_DoS':'5900002',
    'XDMCP gdm exploit':'15207',
    'SNMP bad varbindlist tag':'11983',
    'snmp-get-public':'12074',
    'DPS_Server_Critical_Event':'2002',
    'BOEP_fwenc':'968',
    'nt-guestnopw':'8131',
    'startech-pop3-overflow':'13139',
    'jintegra-activex-bo':'5900002',
    'rhel-rhsa-2008-0136-update':'10500',
    'utillinux-pamacctmgmt-security-bypass':'14047',
    'elm-messageid-bo':'2067',
    'wireshark-mime-dos':'15123',
    'RFProwl exploit':'9507',
    'ms-win-rdc-code-execution':'5900002',
    'spyware-downloadplus':'12528',
    'win2k-high-encryption-pack':'14927',
    'IRC port probe':'5372',
    'MSSQL65_Successful_Non-Trusted_Connection':'7441',
    'rhel-rhsa-2002-291-update':'9552',
    'nt-group-replace-token':'8102',
    'SNMP oid overflow':'12016',
    'win-ms04034-patch':'14410',
    'sopcast-setexternalplayer-code-execution':'12403',
    'reg-rras-permitted':'9431',
    'ms-office-dll-code-execution':'5900002',
    'adobe-reader-unspec-code-exec':'5900002',
    'skype-callto-bo':'11683',
    'imagemagick-rasterfile-bo':'5121',
    'win-ms08kb947077-update':'14633',
    'smtp-listserv':'11865',
    'HTTP_Lock_Method_DOS':'2106001',
    'rhel-rhsa-gdb-dwarf-bo':'10696',
    'rhel-rhsa-2005-057-update':'9826',
    'MSRPC_Pipe_SAMR':'7341',
    'appscan-scan-detected':'539',
    'rsagent-exchange-security-attribute-change':'11040',
    'SSL_V3_OpenSSL_Get_Shared_Ciphers_BO':'2122009',
    'rhel-rhsa-2005-395-update':'9932',
    'rhel-rhsa-2011-1392-update':'5900002',
    'oracle-appserv-internetdirectory-dos':'5900002',
    'SIP_Unknown_Method_Name':'2119016',
    'vpn1-ike-bo':'14181',
    'TFTP_File_Not_Found':'2001201',
    'SNMP_InvalidTag_GenericTrap':'2106112',
    'Symantec_NBNS_Bo':'2120026',
    'IP_Hdr_Options_Zero_Length':'2000014',
    'HTTP_PHP_ReadFile':'2106029',
    'TCP trojan horse probe':'13380',
    'nt-restore-onceonly':'8283',
    'rhel-rhsa-2004-451-update':'9746',
    'adobe-multiple-bo':'5900002',
    'mozilla-pluginspage-command-execution':'7121',
    'tcp-trojan-horse-probe':'13400',
    'rdist-bo':'9337',
    'win-ms04032-patch':'14409',
    'NETBIOS_names_query':'7691',
    'aix-iy76102-fix':'245',
    'rhel-rhsa-2003-314-update':'9639',
    'rhel-rhsa-2010-0675-update':'5900002',
    'win-ms08kb956841-update':'14685',
    'telnet-auth-user-long':'13531',
    'adobe-unspecified-overflow':'5900002',
    'apache-http-lf-dos':'439',
    'vba-document-bo':'14067',
    'nt-passfilt':'8227',
    'win-oob':'14806',
    'linux-dvdreadbca-bo':'5926',
    'javawebstart-useencodingdecl-bo':'5656',
    'JavaScript_DocCapture_BlackIceDevMode_Exec':'5612',
    'Netbios_NetDDE_Bo':'2120058',
    'isa-pf-create-pf-failure':'5456',
    'win-mup-bo':'14796',
    'POP_SilentRunner_Pass_Overflow':'2103000',
    'spyware-mpgcom-toolbar':'12647',
    'evt_logfull':'2245',
    'rhel-rhsa-2008-0556-update':'10576',
    'SMTP mail to uudecode alias':'11826',
    'win-tcpip-timestamps-code-execution':'14860',
    'RSync_Vulnerable_Server':'11206',
    'tdfc-group-formatted':'13489',
    'ms-win-smbresponse-code-exec':'5900002',
    'rhel-rhsa-mozilla-interface-spoofing':'10719',
    'rsagent-exchange-pop3-unauth-command':'11036',
    'rhel-rhsa-2004-654-update':'9788',
    'irc-trinity':'5382',
    'worksite-webtransferctrl-code-execution':'15167',
    'rpc-sadmind-enabled':'10881',
    'TFTP_Long_Client_Data':'5900002',
    'proftpd-modtls-bo':'9116',
    'phoenix-backdoor':'8842',
    'malcode-Susp2':'6755',
    'malcode-Susp5':'6756',
    'malcode-Susp6':'6757',
    'malcode-Susp7':'6758',
    'malcode-Susp8':'6759',
    'yahoo-messenger-filename-bo':'15316',
    'SMB_passwd_file':'11771',
    'sendmail-tmpfile-insecure':'11513',
    'oracle-appserver-config-file-access':'8518',
    'rhel-rhsa-2006-0016-update':'10070',
    'mysql-mysqlchangeuser-doublefree-dos':'7524',
    'rhel-rhsa-2006-0548-update':'10139',
    'sendmail-file-locking-dos':'11493',
    'ms-messenger-activex-bo':'5900002',
    'domino-webaccess-javascript-xss':'1983',
    'MastersParadise98_Response':'2001563',
    'win2k-empty-tcp-dos':'14918',
    'Ping_Sweep':'2000106',
    'mozilla-vcard-base64-bo':'7136',
    'win-media-mp3-code-execution':'14373',
    'XML_Groupwise_ContactList_Overflow':'5900002',
    'Mstream agent activity':'7450',
    'confickerb-worm-detected':'1478',
    'dns-tcp-port-probe':'1888',
    'CGI finger.cgi':'1135',
    'HTTP_URL_Frontpage_Ext_Backdoor':'2002576',
    'iss-service-scan':'5552',
    'flash-air-unspecified-code-execution':'5900002',
    'PmapUnsetSpoof':'8978',
    'PDF_Null_Media_NewPlayer':'8805',
    'snmp-mib-authtrap':'12089',
    'rhel-rhsa-2005-687-update':'10008',
    'HTTP_Listserv_Waexe':'2002581',
    'rhel-rhsa-2004-689-update':'9793',
    'gtrust-remote-same':'3221',
    'file-exrc-perms':'2499',
    'AOL_w00w00_attack':'390',
    'HTTP_GET_GroupBy':'2106170',
    'FTP SITE PSWD exploit':'2821',
    'user-login-frozen':'13978',
    'novell-iprint-multiple-bo':'7931',
    'zone-active-scripting':'15378',
    'netscape-enterprise-http-brute-force':'7725',
    'HTTP_OpenView_NNM_OvSessionMgr_Overflow':'4215',
    'nt-load-driver-onceonly':'8149',
    'autonomy-mimesr-bo':'621',
    'serverprotect-strpcsrv-bo':'11539',
    'MSRPC_PlugAndPlay_Detected':'7343',
    'virtualization-vdi-code-execution':'5900002',
    'rhel-rhsa-2007-0229-update':'10276',
    'dcom-service-enabled':'1661',
    'Webplus CGI exploit':'14246',
    '3com-ap-telnet-enabled':'13',
    'Email_Helo_Overflow':'2001003',
    'Spyware_PH_ExactSearchBar':'2113185',
    'rpc.admind auth':'10892',
    'IMAP_Append_Date_Parameter_Overflow':'5900002',
    'adobe-reader-javascript-code-exec':'5900002',
    'Swf_Detected':'13285',
    'pdfbuilderx-savetofile-file-overwrite':'8811',
    'ms-sql-ms815495-update':'7213',
    'rc-path-groupwritable':'9332',
    'malcode-EmailWorm_Indicator':'6238',
    'backdoor-leapfrog':'701',
    'pdf-program-launch':'5900002',
    'SIP_Response_Invalid_Characters':'2114007',
    'netmon_start':'7716',
    'groupwise-nmx-bo':'5900002',
    'lpd-wrapper-deny':'6071',
    'tftpserversp-errormessage-bo':'5900002',
    'ms-project-installed':'7198',
    'adobe-acrobat-u3d-code-exec':'5900002',
    'qmail-leng':'9175',
    'libtiff-estimatestripbytecounts-dos':'5883',
    'HTTP_KCeasy':'4118',
    'ISA_denied_IP_address_assignment':'5486',
    'bittorrent-dht-getpeers-detected':'885',
    'rhel-rhsa-2009-1177-update':'10677',
    'Suspect_SSH':'13266',
    'zone-file-launch':'15383',
    'oracle-cpu-jan2007':'8537',
    'JScript_IE_Time_Element_Corruption':'5900002',
    'SunSolstice_AdminSuite_ADMBuildPath_BO':'13253',
    'RPC_Kerberos_rename_principal_Overflow':'5900002',
    'sam-notification-package-loaded':'11262',
    'netbackup-vnetd-bo':'5900002',
    'sun-alert57708-patch':'13200',
    'mplayersamisubtitle-subreader-bo':'5900002',
    'winamp-installed':'15013',
    'rhel-rhsa-apop-msgid-mitm':'10681',
    'IP_source_route':'5296',
    'HTTP_Get':'3930',
    'Image_BMP_Bit_Overflow':'5061',
    'ie-browser-window-spoofing':'4693',
    'aix-IY88818-fix':'294',
    'user-password-change-logon':'13999',
    'win2k-serviceticket-requestfailed':'14962',
    'rhel-rhsa-2003-046-update':'9571',
    'RemoteStorm':'9480',
    'imap-tag-overflow':'5140',
    'TCP_Large_Send_Offload_DoS':'5900002',
    'rhel-rhsa-2008-0159-update':'10509',
    'MySQL_Change_User_Auth_Bypass':'2120030',
    'IMAP_Mdaemon_Foldername_DoS':'2118063',
    'rhel-rhsa-2008-0222-update':'10531',
    'RPC high-port portmap':'10853',
    'Image_ICON_Malformed':'2119001',
    'DNS_Poison':'2000402',
    'openssl-kerberos-ciphersuites-dos':'8493',
    'HTTP_Glassfish_Get_Bypass':'5900002',
    'ftgate-fileread':'2783',
    'nt-winreg-net':'8370',
    'malcode-Susp14_Search':'6742',
    'im-file-xfer-double-extension':'5044',
    'spyware-featuredresults':'12558',
    '3com-ap-default-ssid':'11',
    'POP3 password overflow':'8996',
    'backdoor-the-thing':'736',
    'vim-modeline-command-execution':'14092',
    'QuickTime_ColorTable_Overflow':'9260',
    'blueskychat-v2-bo':'940',
    'IMAP_Imail_Status_Overflow':'2118038',
    'cvs-request-entry-line-bo':'1573',
    'rhel-rhsa-2008-0629-update':'5900002',
    'mssql-convert-bo':'7400',
    'win-indexingservice-activex-code-execution':'14350',
    'JavaScript_RDP_ActiveX_Overflow':'5641',
    'MOV_Container_Overflow':'2114042',
    'win-ms06kb924270-update':'14542',
    'FTP_Bounce':'2890',
    'AVI_Stream_Header_Overflow':'5900002',
    'SNMP_Bad_Trap_OID':'12166',
    'HTTP_FileTypeUrl':'2002545',
    'spyware-showbar':'12741',
    'ms-win-schannel-dos':'5900002',
    'DNS_I-Query':'1922',
    'malcode-ModifyPolicy':'6377',
    'Firewall_Invalid_Packet':'2652',
    'rsagent-imap2-anon':'11050',
    'HTTP_Host_Invalid_Char':'3986',
    'rhel-rhsa-2003-395-update':'9647',
    'Progenic_Response':'2001571',
    'smtp-expn-bo':'11859',
    'Telnet_Login_Overflow':'2000902',
    'pcAnywhere_Login':'8764',
    'malcode-SPNE_DLL':'6590',
    'FTP_ProFTPD_Translate_Overflow':'2110020',
    'HTTP_zenWorks_uploadDirectory_Exec':'5900002',
    'win-guestaccount-unchanged':'14337',
    'nt-disabled-account-userpwd':'8043',
    'FTP_user_name_overflow':'3020',
    'LPD_FileDelete_Queuename_Contains_Path':'5900002',
    'Linux_v4_Rootkit_Login':'2116006',
    'ping-death':'8952',
    'DNS_Spoof_Failed':'2000414',
    'malcode-SPPE_DO_Exec_File':'6664',
    'quicktime-h264-movie-bo':'9224',
    'WindowsMedia_WMP_Heap_Overflow':'15048',
    'nb-dotdot':'7587',
    'rhel-rhsa-2005-706-update':'10009',
    'SQL_HTTP_xp_cmdshell':'12898',
    'viewstation-default-blank-password':'14086',
    'HTTP_Acunetix_WVS_Scan':'3734',
    'HTTP_Oracle_TimesTen_evtdump_FmtString':'2125019',
    'AOL w00w00 attack':'380',
    'win-moviemake-code-execution':'5900002',
    'gmaxplayer-activex-bo':'5900002',
    'HTTP_Code_Red':'2004601',
    'rhel-rhsa-openssl-asn1-error-dos':'10747',
    'HTTP_URL_TooMany_Parameters_DoS':'5900002',
    'rhel-rhsa-2005-838-update':'10056',
    'rhel-rhsa-2012-0311-update':'5900002',
    'reg-logon-incorrect':'9403',
    'http-html-tag-injection':'3630',
    'win-ms10kb2286198-update':'5900002',
    'linux-mincore-dos':'5946',
    'ssl-unknown-cipher-support':'5900002',
    'IP_last_fragment_length_changed':'5290',
    'msn-messenger-file-transfer':'7276',
    'malcode-SPTRJ_Inet_reg_Wrt':'6719',
    'decod-telnet-auth-failure':'1750',
    'malcode-VBADeleteDocumentContents':'6854',
    'win-gdi-png-code-execution':'14330',
    'RPC CALLIT attack':'10848',
    'mailto-piped-address':'6128',
    'FrontPage extension backdoor URL':'2745',
    'SNMP Crack':'11992',
    'rhel-rhsa-2005-099-update':'9844',
    'rhel-rhsa-2006-0205-update':'10096',
    'nt-sql-server':'8319',
    'proftpd-path-string':'9117',
    'PDF_Embedded_PDF':'8792',
    'rhel-rhsa-2007-0108-update':'10254',
    'eva-forms-reveal-path':'2224',
    'rsagent-imap2-loginfailure':'11053',
    'rhel-rhsa-2007-0938-update':'10403',
    '3com-rf-setup-web-access':'21',
    'Email_Executable_Extension_Block':'2100',
    'win2k-localgroup-deleted':'14937',
    'SSH_Root_command_execution':'13054',
    'rhel-rhsa-2004-073-update':'9676',
    'malcode-ScripletTypeLibObject2':'6502',
    'win-useraccount-password-unchanged':'14868',
    'explorer-desktop-commands':'2396',
    'Ascend_attack':'566',
    'HTTP_URL_with_repeated_char':'4470',
    'pc-anywhere-detect':'8752',
    'rhel-rhsa-2005-133-update':'9859',
    'malcode-ScripletTypeLibObject1':'6501',
    'spyware-hungryhands-bho':'12595',
    'Email_BioNet':'2004402',
    'HTTP_Apache_Jakarta_Format_String':'2110027',
    'FIX_Logon':'2665',
    'spyware-cjbmanagement':'12486',
    'Pict_QuickDraw_Color_Corruption':'5900002',
    'swf-actionendflag-data-detected':'13280',
    'crontab-perms-group':'1544',
    'win-ms12kb2643719-update':'5900002',
    'SMB_BranchCache_DLL_Hijacking':'5900002',
    'win-ms06kb920958-update':'14523',
    'HTTP_GET_SQL_Select_Top_1':'2110063',
    'microsoft-forms-fm20-dos':'7006',
    'Agentx_HelixServer_Stack_Overflow':'5900002',
    'cisco-tftp-enabled':'1327',
    'rhel-rhsa-2007-1065-update':'10449',
    'Flash_Asfunction':'2114084',
    'malcode-SPNE_OverWriteSelf':'6600',
    'is-scan-completed':'5420',
    'HTTP_3com_AirConnect_SpecialFunctions':'2106016',
    'AVI_DirectShow_AVI_Overflow':'626',
    'qotd-port-probe':'9178',
    'webalizer-html-tag-host':'14223',
    'HTTP_GoAhead_ASP_CodeRetrieval':'2107004',
    'nt-group-add-workstation':'8084',
    'ISAPI dumpvariables overflow':'5540',
    'mobilink-login-bo':'5900002',
    'gtp-u-recursion':'3204',
    'HTTP_IIS_Csimple':'2105036',
    'rhel-rhsa-2006-0179-update':'10086',
    'isa-pf-filtering-disabled':'5459',
    'EZMall data URL':'2406',
    'Compaq Insight DMI overflow':'1412',
    'RIFF_ANI_biClrUsed_DoS':'5900002',
    'malcode-ExploitCompoundDoc':'6302',
    'DNS_RRSIG_Query':'5900002',
    'HTTP_Auth_ContainsBinary':'2118033',
    'browsers-shell-exe-detected':'1029',
    'ios-enable-shell':'5262',
    'HTTP_IE_DHTML_Script_Code_Execution':'2122003',
    'mydoom-worm':'7502',
    'rhel-rhsa-2011-1132-update':'5900002',
    'spyware-weathercast':'12801',
    'http-cgi-listserv-wa-bo':'3584',
    'MSRPC_TrendMicro_SyncTask_BO':'2118113',
    'SNMP_scanner':'12260',
    'spyware-crontel-ltd':'12506',
    'malcode-VB_NonPackedVBDropper':'6844',
    'HTTP_Head':'3981',
    'firefox-domattrmodified-code-exec':'5900002',
    'MS_domain_dump':'7235',
    'ihtml-merchant-file-access':'4885',
    'telnet-auth-user':'13532',
    'blackhole-exploit-kit-detected':'5900002',
    'officescan-config-file-access':'8423',
    'Pict_Quicktime_PnSize_Width_Overflow':'5900002',
    'Account_policy_change':'40',
    'ms-url-bo':'7221',
    'ipcs-shm':'5307',
    'samba-netdfsiodfsenuminfod-bo':'11270',
    'win-ms09kb974783-update':'14765',
    'malcode-SendItselfByEmail':'6514',
    'HTTP_POST_data_contains__...':'4308',
    'SNMP_ipForwarding':'2104027',
    'file-frozen-directory':'2502',
    'realplayer-rm-datapacket-bo':'9365',
    'rhel-rhsa-2009-1143-update':'5900002',
    'rhel-rhsa-2007-1021-update':'10428',
    'IIS_Reveal_Address':'2105001',
    'DNS_TippingPoint_INPTR_Format_String':'5900002',
    'rhel-rhsa-2007-0353-update':'10298',
    'Port_Scan':'9046',
    'decod-telnet-password-very-long':'1751',
    'rhel-rhsa-2008-0237-update':'10536',
    'malcode-SPTRJ_Dir_Rd_Misc':'6709',
    'malcode-SPPE_DllChk_and_Exit':'6662',
    'oracle-username-connectid-bo':'8580',
    'SMB autoexec.bat file access':'11703',
    'SMB_IEFrame_DLL_Hijacking':'5900002',
    'ISA_PF_Filtering_Disabled':'5509',
    'CGI_webdist.cgi':'1213',
    'msvm-jdbc-gain-access':'7465',
    'HTTP_Server_ID':'4370',
    'MSRPC_MSDTC_Message_GUID_BO':'2118064',
    'malcode-alteredVolatileDefaultDocument':'6134',
    'ms-powerpoint-viewer-textcharsatom-bo':'5900002',
    'napster-present':'7558',
    'registrypro-activex-epregpro-bo':'9467',
    'spyware-ukvideo2-dialer':'12786',
    'isa-pf-interface-bind-failure':'5461',
    'FTP_Glob_Heap_Corruption':'2928',
    'logexplorer-mssql-xplogattach-bo':'6019',
    'DNS_Bind_OPT_DoS':'2115003',
    'spyware-quicksearch':'12702',
    'HTML_Outlook_MailTo_Code_Execution':'2113143',
    'rr-bcf-code-execution':'5900002',
    'slapper-worm':'11690',
    'exchange-dos':'2283',
    'aix-iy64354-fix':'192',
    'TLS_OpenSSL_Version_DoS':'5900002',
    'SMB_PowerPoint_DLL_Hijacking':'5900002',
    'lpd-wrapped':'6069',
    'User_account_changed':'14027',
    'win-ms08kb953235-update':'14664',
    'nfs-sbin-secure':'7816',
    'SNMP dialup phone number':'11993',
    'ISS_Wireless':'5565',
    'tivoli-directory-ldap-dos':'5900002',
    'Win-msdds-command-execution':'14791',
    'xdmcp-session-acceptec':'15209',
    'NNTP pipe seen':'7862',
    'http-proxy-pen':'3676',
    'win-ms04kb885836-update':'14418',
    'sybase-passwordarray-bo':'13295',
    'bind-findtype-dos':'846',
    'ie-file-url-encode':'4744',
    'win-interactivetraining-bookmarkfile-bo':'14352',
    'gtrust-unknown-any':'3222',
    'rhel-rhsa-2007-0406-update':'10315',
    'flash-player-unspec-ce':'5900002',
    'proventia-server-windows-installed':'9144',
    'acrobat-reader-download-manager-bo':'5900002',
    'win-ms06kb889167-update':'14466',
    'FTP_passwd_file':'2962',
    'win-ms11kb2544641-update':'5900002',
    'HTTP_Struts_CookieInterceptor_Exec':'5900002',
    'rhel-rhsa-2008-0879-update':'10591',
    'win-ms10kb981832-update':'5900002',
    'JavaScript_Obfuscation_Fre':'2114169',
    'win-ms10kb981852-update':'5900002',
    'icmpv6-malformed-option':'4624',
    'malcode-SPMZ_Int_IVT':'6566',
    'office-onenote-url-code-execution':'8410',
    'rhel-rhsa-2011-0279-update':'5900002',
    'file-etc-root':'2497',
    'SMTP_Ipswitch_IMail_Format_String':'5900002',
    'agentmanager-error':'152',
    'malcode-SendEmailWithLLFile':'6513',
    'rhel-rhsa-2002-294-update':'9553',
    'pdf-ffilter':'5900002',
    'ie-data-code-execution':'4724',
    'rsagent-ipop3d-remote':'11061',
    'ftp-home':'2849',
    'iss-scan':'5551',
    'SMB_QuerySecdes_Resp_Exec':'5900002',
    'SMTP many quotes in recipient':'11827',
    'Image_EMF_MSCMS_Heap_Overflow':'5074',
    'rhel-rhsa-2011-1245-update':'5900002',
    'powerpointviewer-openwebfile-file-execution':'9085',
    'openoffice-emf-bo':'5900002',
    'PlugAndPlay_DoS':'2118031',
    'ICMP6_BSD_Dos':'2118009',
    'FTP_Stat_Very_Long':'2001352',
    'nefficientdload-neffylauncher-dir-traversal':'7661',
    'java-swing-unspecified':'5900002',
    'dell-wmiattributesofinterest-info-disc':'5900002',
    'RIFF_Shockwave_Pami_Exec':'5900002',
    'rhel-rhsa-2006-0015-update':'10069',
    'msde-mssql-default-password':'7248',
    'win2k-add-sid-success':'14899',
    'User_right_granted':'14042',
    'Email_Virus_Double_Extension':'2106168',
    'badblue-ext-dos':'782',
    'SMTP_VRFY_command':'11951',
    'sambar-server-defaults':'11289',
    'HTTP_MailEnable_Auth_Overflow':'2113246',
    'slocate-heap-execute-code':'11696',
    'snmpc-snmptrap-bo':'5900002',
    'osiris-backdoor':'8638',
    'Intruzzo_TCP_Response':'2113006',
    'networker-nsrexecd-bo':'5900002',
    'nt-y2k':'8378',
    'libpng-file-offset-bo':'5875',
    'RIFF_QCP_FmtRecord_Overflow':'5900002',
    'ie-index-execute-code':'4779',
    'backdoor-blazer5':'667',
    'ethereal-dns-dissector-dos':'2205',
    'spyware-searchbarcash':'12722',
    'malcode-SPNE_3to5_DLL':'6581',
    'hidesource-login-backdoor':'3282',
    'nds-user-without-address-restriction':'7659',
    'SYN_Bandwidth_Flood_Protection':'5900002',
    'Telnet_Encryption_Key_Overflow':'5900002',
    'listrecpl-remote-command-execution':'5995',
    'chrome-notifications-code-execution':'5900002',
    'openssl-dtls-code-execution':'8492',
    'HTML_Script_Extension_Evasion':'2114175',
    'DNS_Chaos_lookup':'1907',
    'ibm-acprunner-execute-code':'4562',
    'rhel-rhsa-2010-0423-update':'5900002',
    'wireshark-nmas-ndps-offbyone':'15131',
    'cmail-smtp-bo':'1366',
    'udp-trojan-horse-probe':'13837',
    'samba-lsaioprivilegeset-bo':'11266',
    'lpd-command-file-overflow':'6065',
    'Allaire_JRun_JSP_Execute':'2004904',
    'phorum-admin-users-information':'8844',
    'win-ms10kb979902-update':'5900002',
    'MSMessenger_Video_Request':'7271',
    'nt-multiprotocol-netbios':'8191',
    'edraw-office-weburl-bo':'5900002',
    'content-php-embedding':'5900002',
    'spyware-new-dial':'12674',
    'OSPF_Short_Header':'2110019',
    'rhel-rhsa-2009-0002-update':'5900002',
    'mailman-subscription-option-xss':'6123',
    'HTTP_Cisco_Catalyst_Exec':'2106043',
    'mw6technologies-qrcode-file-overwrite':'7499',
    'frontpage-ext-directory-vtilog-present':'2751',
    'Swf_Function_Overflow':'5900002',
    'win-ms07kb936227-update':'14591',
    'HTTP_ASP_Login_Redirect':'5900002',
    'SNMP_ipRouteTable':'2104029',
    'iis-url-memory-corruption':'4998',
    'fedora-ber-bad-sequence-dos':'2446',
    'netstat':'7758',
    'rhel-rhsa-2011-0180-update':'5900002',
    'spyware-topmoxie':'12773',
    'rhel-rhsa-2005-435-update':'9952',
    'HTTP_SubSevenCGI':'2000643',
    'solaris-rwall-format-string':'12385',
    'HTML_Baofeng_Storm_Sparser_Overflow':'2101020',
    'dns-leng-ovf':'1877',
    'HTTP_IIS_ISAPI_Filter_Error_DoS':'2113003',
    'isa-udp-bomb-attack-detected':'5475',
    'gnupg-tty-format-string':'3142',
    'ident-bo':'4649',
    'RDP_Login_Read_Overflow':'2121027',
    'sql-injection-declare-exec':'5900002',
    'HTTP_OracleApp_DMSDump':'2105025',
    'DHCP_Hostname_Overflow':'2110055',
    'nfs-bugadmin':'7793',
    'Email_OWA_XSS':'2114114',
    'UserLoginSessionEvent':'14044',
    'Image_WMF_Generic_RecordSize_Overflow':'2121043',
    'decod-smtp-to':'1744',
    's2-scan-vulnerability-found':'11245',
    'win-utilitymanager-gain-privileges':'14870',
    'HTTP_Listrec_Execute':'2002684',
    'rhel-rhsa-2010-0339-update':'5900002',
    'POP_Overflow':'9029',
    'RPC_Veritas_Registry_Access':'10998',
    'rhel-rhsa-2010-0978-update':'5900002',
    'McAfee_Ebiz_Packet_Code_Execution':'6951',
    'coldfusion-mx-file-disclosure':'1395',
    'BackOrifice2K_TCP_Auth_Request':'2001512',
    'MySQL_Check_Scramble_Auth_Bypass':'2120054',
    'TCP_Null_Scan':'2000309',
    'libpng-pngsetsplt-dos':'5877',
    'Ypupdate_Exec':'15358',
    'rhel-rhsa-2004-414-update':'9734',
    'rhel-rhsa-2003-310-update':'9637',
    'symantec-navcomui-code-execution':'13311',
    'Image_JPEG_Malformed':'2102050',
    'malcode-InvalidPE':'6354',
    'ms-win-smb-null-dos':'7227',
    'win-ms06kb925454-update':'14545',
    'exploit-Publisher(100035)':'2387',
    'nt-baseobject-audit':'8000',
    'hp-nnm-ovlaunch-bo':'3321',
    'SubSeven password-protected activity':'13177',
    'win-ms12kb2722479-update':'5900002',
    'Email_Ipswitch_Subject_Overflow':'5900002',
    'nt-changedservice-tag':'8015',
    'squid-ntlm-bo':'12942',
    'edirectory-imonitor-acceptlanguage-bo':'2047',
    'QuickTime_CRGN_Boundary_Overflow':'9261',
    'mm-tmpfile-symlink':'7029',
    'adobe-fp-unspecified-code-execution':'5900002',
    'ISAPI_extension_overflow':'5543',
    'apache-modphp-descriptor-leak':'452',
    'unisys-tcp-bo':'5900002',
    'ftp-server-identity-audit':'2868',
    'oracle-weblistener-remote-attack':'8584',
    'novell-client-unspecified-dos':'7909',
    'exchange-owa-script-execution':'2296',
    'rhel-rhsa-2005-639-update':'9999',
    'HTTP_Lighttpd_Header_Overflow':'2114070',
    'HTTP_RegEcho':'2106034',
    'cisco-ios-ftp-mkd-bo':'1285',
    'DNS_MS_Query_DoS':'5900002',
    'SubSeven_Pass_Response':'2001530',
    'viewpoint-media-multiple-bo':'14084',
    'openldap-slurpd-bo':'8456',
    'gzip-huftbuild-code-execution':'3229',
    'HTTP User-Agent overflow':'3544',
    'file-default-passwd':'2483',
    'win-ms12kb2660465-update':'5900002',
    'mcafee-virtual-activex-code-execution':'5900002',
    'spyware-surfairy':'12759',
    'ISA_SCS_Stop':'5516',
    'HTTP_Powerpoint7_DLL_Hijacking':'5900002',
    'rhel-rhsa-2009-0476-update':'10657',
    'quake-server-vuln':'9199',
    'wireshark-ldap-dos':'15121',
    'HTTP_GET_WPAD_Proxy_Hijack':'5900002',
    'unzip-toctou-race-condition':'13909',
    'rhel-rhsa-2004-308-update':'9715',
    'win-ms10kb978251-update':'14787',
    'statmon':'13148',
    'rhel-rhsa-2006-0451-update':'10124',
    'registryocx-activex-bo':'5900002',
    'http-cgi-dnews-bo':'3571',
    'logitech-multiple-activex-bo':'6027',
    'HackATack_TCP_Response':'2001533',
    'malcode-AntiqueDropper':'6136',
    'wvc54gc-netcamplayerweb-bo':'15194',
    'PDF_Shellcode_Detected':'2123001',
    'cpio-file-size-bo':'1524',
    'win-ms07kb928255-update':'14568',
    'Replication_link_add_success':'9492',
    'HTTP_Form_field_name_overflow':'3918',
    'SMIL_ScreenSize_Attribute_Overflow':'5900002',
    'ibm-tsm-cad-bo':'4578',
    'Back_Orifice_2000_ping':'652',
    'rhel-rhsa-2009-0345-update':'10641',
    'nds-user-no-full-name':'7633',
    'sophos-cpio-bo':'12404',
    'Stream_DoS':'2103017',
    'CompoundFile_Mscomctl_View_Exec':'5900002',
    'Content_TNEF_Attribute_Overflow':'2106204',
    'SMB_Sam_File':'2002702',
    'Telnet_Env_All':'13565',
    'PDF_Excess_Overflow':'5900002',
    'Y3K IRC notification':'15295',
    'wingate-http-proxy-bo':'15052',
    'BitTorrent_DHT_FindNode':'890',
    'TCP_Network_Sweep':'2102045',
    'HTTP_GroupWise_InternetAgent_Overflow':'5900002',
    'telnet-auth-spx':'13530',
    'ie-cache-info':'4703',
    'kernel-ext3fsdirhash-dos':'5732',
    'ras-rrq-low-time-to-live':'9312',
    'adobe-prc-code-execution':'5900002',
    'XML_QuickTime_QTL_Code_Execution':'15255',
    'aix-iy72763-fix':'237',
    'passwd.txt URL':'8740',
    'rhel-rhsa-2010-1000-update':'5900002',
    'HTTP_OracleApp_demo_info':'2105030',
    'MySQL_Date_Format_FormatString':'5900002',
    'helix-realplayer-error-format-string':'3268',
    'rsagent-localgroup-created':'11068',
    'rhel-rhsa-2004-174-update':'9695',
    'MS rpc dump':'7150',
    'JavaScript_Citrix_Wfica_BO':'2114034',
    'rhel-rhsa-2005-072-update':'9836',
    'slmail-helo-overflow':'11693',
    'MSRPC_RemoteActivate_Bo':'2118006',
    'ISA_FW_Start_Failed_Corrupt':'5498',
    'ISA_IP_address_removed_from_network':'5502',
    'kernel-cardman4040drivers-bo':'5722',
    'adobe-acrobat-clodmeshdeclaration-bo':'5900002',
    'activescan-as2stubie-code-execution':'5900002',
    'Email_Calendar_Code_Exec':'2110147',
    'User_account_created':'14028',
    'rhel-rhsa-2007-1104-update':'10459',
    'ms-clip-organizer-activex-dos':'5900002',
    'rhel-rhsa-2009-1243-update':'5900002',
    'rhel-rhsa-2005-277-update':'9886',
    'SMTP mail to rpmmail alias':'11825',
    'HTTP_GET_AltaVista_password':'3931',
    'HTTP POST pwl file type':'3526',
    'adobe-flash-objecttype-code-exec':'5900002',
    'passport-registry-permission':'8726',
    'prov-update-error':'9137',
    'SNMP_Long_Community_String':'12239',
    'update-trusted-hosts-baseline':'13920',
    'firebird-xdrprotocol-integer-overflow':'5900002',
    'html-uri-hiding':'5900002',
    'nt-telnet-ntlm':'8337',
    'PsExec_Service_Accessed':'2110084',
    'MSRPC_MaliciousEncryption':'2118067',
    'TCP_Port':'13425',
    'rhel-rhsa-2007-0072-update':'10236',
    'win-ms10kb2293194-update':'5900002',
    'Security_access_removed':'11445',
    'SNMP_Bad_ErrorIndex':'2106110',
    'taskbar-menu-eabled':'13360',
    'rhel-rhsa-2005-875-update':'10065',
    'http-cgi-bnbsurvey':'3558',
    'UDP_Squid_WCCP_Overflow':'2114031',
    'mcms-http-get-code-execution':'6952',
    'RIPExpire':'10790',
    'xunlei-webthunder-activex-bo':'15286',
    'spyware-cometcursor':'12499',
    'rsagent-virtual-memory':'11182',
    'HTTP_POST_Tivoli_Register_SQL_Injection':'5900002',
    'HTTP GET contains create%table':'3497',
    'basic-hell-backdoor':'802',
    'aim-getfile-screenname-bo':'166',
    'adobe-acrobat-reader-ce':'5900002',
    'snmp-unsupported-version':'12123',
    'CompoundFile_Word_Mem_Corruption':'1461',
    'solaris-cde-code-execution':'5900002',
    'nds-irf-no-supervisor-rights':'7607',
    'malcode-SPMZ_SrchInfect':'6577',
    'IIS_malformed_HTR_request':'5017',
    'malcode-SPPE_DLL_WrtToSect_RsrcEP':'6661',
    'socks-username-bo':'12336',
    'spyware-updateloader-malware':'12788',
    'oracle-extproc-bo':'8553',
    'malcode-VB_Keylogger':'6842',
    'IRC_TrinityV3_Notification':'2001803',
    'nt-service-user-pwd':'8305',
    'unitymail-web-dos':'13890',
    'openssl-asn1-parser-dos':'8487',
    'cisco-ios-ftp-multiple-bo':'1286',
    'rhel-rhsa-2005-627-update':'9998',
    'HTTP_AWStats_ConfigDir_Exec':'2113200',
    'CGI machineinfo':'1147',
    'yahoo-toolbar-ythelper-bo':'15326',
    'ddos-freak88':'1672',
    'freetype2-font-file-bo':'2739',
    'SNMP_NullInString':'2106115',
    'telnet-default-passwords':'13535',
    'snmp-community-underflow':'12054',
    'starteam-tmsgbufmsgdeserializeex-dos':'13138',
    'SubSeven_Scan':'13189',
    'malcode-SPMZ_Srch_invalid':'6576',
    'sshd-1217':'13066',
    'mailman-date-dos':'6119',
    'Symantec_AMS_Component_Overflow':'5900002',
    'ISA_PF_No_Ext_Interface':'5513',
    'TCP FIN or RST seq out-of-range':'13366',
    'samba-file-access':'11265',
    'solaris-nfs-unauthorized-access':'12383',
    'RPC_snmpXdmid_Overflow':'2001734',
    'win-ms06kb912812-update':'14488',
    'SMTP_Timeout_Bo':'2118057',
    'ieee80211-ssid-access':'4878',
    'radius-radprintrequest-dos':'9290',
    'mozilla-xpcnativewrapper-code-execution':'7140',
    'malcode-OrganizerCopy':'6412',
    'SnidX2':'11959',
    'snmp-bad-oid-type':'12045',
    'rhel-rhsa-2009-0340-update':'10638',
    'rhel-rhsa-2007-0774-update':'10373',
    'appstream-installappmgr-file-execution':'540',
    'Changes_to_important_files':'1224',
    'win-ms11kb2485376-update':'5900002',
    'kernel-loadkeys-privilege-escalation':'5742',
    'rhel-rhsa-2002-152-update':'9524',
    'vmware-startprocess-code-execution':'14149',
    'rhel-rhsa-php-sapiheaderop-dos':'10755',
    'rhel-rhsa-2003-063-update':'9578',
    'win-ms07kb931261-update':'14575',
    'BlackAngel_TCP_Response':'2120011',
    'proventia-desktop-installed':'9141',
    'rhel-rhsa-2008-0004-update':'10472',
    'win-ms06kb922760-update':'14529',
    'nfs-guess':'7798',
    'boep-ntoskrnl':'955',
    'adobe-acc-icc-code-execution':'5900002',
    'novell-iprint-ippgetdriversettings-bo':'7930',
    'win-smb-ntlm-code-execution':'14843',
    'backdoor-glacier':'691',
    'Veritas_NetBackup_VolumeMgr_Overflow':'2113235',
    'MOV_H264_Integer_Overflow':'7050',
    'rhel-rhsa-2005-069-update':'9833',
    'smb-filename-bo':'11722',
    'web-application-command-execution':'14214',
    'malcode-MrVirus':'6380',
    'rhel-rhsa-2004-537-update':'9762',
    'asterisk-rtp-codecpayload-bo':'586',
    'rhel-rhsa-2010-0723-update':'5900002',
    'mercur-imap-ntlm-bo':'5900002',
    'HTTP_Header_CrossDomain_Smuggle':'2114109',
    'SMTP_User_Unknown':'2110003',
    'SNMP_Null_In_String':'12248',
    'Swf_Missing_ActionEndFlag':'2114125',
    'malcode-CreateHTMLFileInWindowsDir':'6190',
    'dns-udp-port-probe':'1890',
    'rhel-rhsa-2008-0965-update':'10611',
    'file-default-su-replaced':'2487',
    'brightstor-catirpc-dos':'1003',
    'mozilla-liveconnect-code-execution':'7099',
    'IM_Activity':'5046',
    'spyware-hunttoolbar':'12597',
    'MSRPC_RemoteActivate_Path_BO':'2110030',
    'dns-cname-loop':'1866',
    'Scada_DNP_StopApplication':'11337',
    'VmQuarantinedEvent':'5900002',
    'backupexec-ndmp-gain-access':'775',
    'Helix_DNA_LoadTestPassword_Overflow':'2118101',
    'firefox-pkcs11-weak-security':'2633',
    'ECware.exe CGI':'2043',
    'malcode-SPMZ_IVT_Snk_TSR':'6568',
    'SNMP bad generic trap tag':'11972',
    'Mneah_TCP_Response':'2113126',
    'Index_Server_reg_hack':'5202',
    'niprint-bo':'7833',
    'mozilla-multiple-layout-code-execution':'7105',
    'barcode-bitiff-bo':'799',
    'win-ms09kb975517-update':'14768',
    'malcode-InfectorX3':'6346',
    'rhel-rhsa-2008-0896-update':'10601',
    'sip-long-via-host-detected':'11626',
    '3com-filtering-setup-web-access':'17',
    'yppasswdd':'15352',
    'tls-negotiation-dos':'5900002',
    'ida-detected':'4639',
    'rhel-rhsa-2008-0110-update':'10494',
    'oracle-database-sdocs-bo':'8545',
    'ICMP_Protocol_Unreachable_TCP':'2110061',
    'winmysqladmin-password-plaintext':'15057',
    'RPC_Kerberos_Auth_BO':'2101006',
    'SNMP_Length_Underflow':'2106099',
    'spyware-golden-palace-casino':'12579',
    'spyware-flashtrack':'12561',
    'RAR_Password_Protected':'5900002',
    'spyware-clariawebsecurealert':'12492',
    'Firewall_Warning':'2659',
    'snort-uricontent-rule-bypass':'12310',
    'passport-iis-log-permission-exposure':'8724',
    'HTTP_IFRAME_Tag_Injection':'2110175',
    'ie-access-vba-code-execute':'4678',
    'malcode-MalSpawn':'6370',
    'imail-imap-overflow':'5128',
    'TelnetTerminaltype':'13612',
    'nt-ntsniff-present':'8214',
    'nt-system-audit-failure':'8325',
    'spyware-fastwebfinder':'12556',
    'HTTP_EDonkey':'3896',
    'realplayer-activex-code-execution':'5900002',
    'pdfviewer-activex-dos':'5900002',
    'HTTP_NT8.3_Filename':'2000614',
    'FragRoute_TCP_Chaff_PAWS':'2103020',
    'php-mbparsestr-weak-security':'8877',
    'ISS_Scan_7_0_ICMP':'2102034',
    'attachmate-reflection-activex-bo':'5900002',
    'word-rtf-drawing-code-execution':'5900002',
    'MOV_Malicious_HREFTrack':'2114037',
    'firefox-string-conversion-bo':'5900002',
    'HTTP_GetAccess_login':'2105003',
    'HTTP_Apache_CookieName_DoS':'5900002',
    'mozilla-chromeuri-directory-traversal':'7066',
    'HTTP_PostQueryCgi':'2002636',
    'novell-edirectory-ncp-code-execution':'7917',
    'nt-system-audit':'8327',
    'quicktime-very-large-atom':'9256',
    'Exchange_unauthenticated_pop3_command_invalidargs':'2329',
    'rhel-rhsa-2009-1673-update':'5900002',
    'Script_MSXML_CoreSvc_Corruption':'5900002',
    'win-ms06kb908519-update':'14477',
    'DNS_spoof_attempt':'1954',
    'rhel-rhsa-2005-671-update':'10004',
    'excel-biff-file-format-bo':'5900002',
    'win-ms09kb973812-update':'14756',
    'malcode-VBSThatCreatesExecutables':'6865',
    'HTTP URL with __$DATA appended':'3540',
    'Script_Hyperconcatenation':'2114178',
    'TCP SYN with URG flag':'13379',
    'http-post-groupby':'3668',
    'Queso Scan':'9207',
    'mozilla-dom-method-xss':'7075',
    'dns-name-offset':'1881',
    'DB2_Mismatch':'1651',
    'HTTP_URL_contains__._':'4447',
    'realplayer-openurlindefaultbrowser-code-exe':'5900002',
    'rsagent-mssql7-startup':'11081',
    'RealServer Denial-of-service URL':'9372',
    'HTTP_Snort_Uricontent_Bypass':'2106216',
    'audioextractor-activex-security-bypass':'5900002',
    'trend-vcs-weak-encryption':'13751',
    'Email_Rcpt_TooManyQuotes':'2001053',
    'fw-checkpoint':'3041',
    'CGI_whois_suspicious_field':'1217',
    'HTTP_URL_with___$DATA_appended':'4467',
    'win-asn1-bo-smtp-detected':'14292',
    'mssql-query-abuse':'7423',
    'ibm-tsm-dsmagent-bo':'4579',
    'isa-enum-port-scan-detected':'5439',
    'spyware-networkessentials':'12672',
    'MSSQL65_Shutdown':'7439',
    'Script_IE_insertRow_Exec':'5900002',
    'rhel-rhsa-2003-061-update':'9577',
    'SNMP_too_many_vars':'12276',
    'malcode-WritePEheader':'6912',
    'NNTP_pipe_seen':'7880',
    'Update_Error':'13923',
    'SNMP length indefinite':'12009',
    'nt-syncstormpatch':'8323',
    'rip':'10784',
    'IPM_Dynamic_Table_Cleared':'5320',
    'file-device-insecure':'2490',
    'trendmicro-cgi-bo':'13753',
    'SSL_Challenge_Length_Overflow':'2110051',
    'win-ms05kb891781-update':'14435',
    'liveupdate-host-verification':'6000',
    'spyware-dialerofflline':'12519',
    'nt-unknown-svc':'8344',
    'php-strip-tag-bypass':'8908',
    'HTTP_Vulnerable_Client':'4481',
    'Email_Relay_Spam':'2001047',
    'VmBeingCreatedEvent':'14121',
    'RPC Sadmind Ping':'10855',
    'SOCKS_Over_SOCKS':'2004002',
    'apache-descriptor-leak':'425',
    'hummingbird-run-command-execution':'4552',
    'ie-file-download-display':'4740',
    'HTTP_Sun_JRE_Malformed_GIF_BO':'2118079',
    'TearDrop':'2000003',
    'blackice-feature-unlicensed':'916',
    'rhel-rhsa-2004-342-update':'9717',
    'whatsup-nmservice-dos':'14275',
    'quake-detect':'9198',
    'rhel-rhsa-2009-1203-update':'5900002',
    'spyware-newton-knows':'12677',
    'malcode-NoIcon0':'6388',
    'Worm_address':'15170',
    'policy-withdrawn':'8979',
    'XFS_Query_Range_Integer_Overflow':'15226',
    'epolicy-get-format-string':'2180',
    'HTTP_IE_ADODB_Connection_Exec':'2110127',
    'squid-msnt-helper-bo':'12941',
    'rhel-rhsa-2002-195-update':'9535',
    'sybase-open-server-code-execution':'5900002',
    'file-unused':'2555',
    'imap-excessive-connections-dos':'5138',
    'nt-accountuserpw':'7964',
    'win-ms10kb2269638-update':'5900002',
    'win-ms12kb2584146-update':'5900002',
    'Invalid License Key':'5257',
    'win-ms11kb2527308-update':'5900002',
    'javascript-suspicious-xor':'5597',
    'ASP_IIS_File_Change_Notification':'2114090',
    'openssh-ldap-dos':'8469',
    'Installation_Failure':'5234',
    'win2k3-group-undock-privilege':'14995',
    'ms-win-lnk-code-execution':'5900002',
    'authentium-command-antivirus-activex-bo':'613',
    'rhel-rhsa-2011-0327-update':'5900002',
    'irix-infosrch-fname':'5417',
    'quicktime-packbitsrgn-bo':'9238',
    'win-ms03049-patch':'14399',
    'Flushot attack':'2690',
    'Image_EMF_Polyline_Overflow':'2101065',
    'CSS_Data_URL':'5900002',
    'java-jpegimagewriter-priv-escalation':'5900002',
    'ZenWorks_remMgr_Overflow':'5900002',
    'spyware-adgoblin':'12434',
    'aoadvdcreator-initlicenkeys-bo':'5900002',
    'rhel-rhsa-2004-242-update':'9709',
    'namo-activesquare-bo':'7547',
    'QOTD_port_probe':'9179',
    'Email_From_Overflow':'2102023',
    'win-ms11kb2478953-update':'5900002',
    'db-activex-vimpx-bo':'1645',
    'php-nuke-admin-file-overwrite':'8885',
    'ms-ie-unspec-code-exec':'5900002',
    'adobe-flash-mem-code-execution':'5900002',
    'php-unserialize-code-execution':'8911',
    'LDAP_blacklist_failed':'5836',
    'rsagent-ssh-kerberos':'11130',
    'sip-invalid-auth-response':'11618',
    'win-ms05kb888113-update':'14428',
    'aol-ygp-picture-editor-dos':'388',
    'HTTP Pfdisplay Execute':'3514',
    'Interscan_Viruswall_Httpsave':'2002632',
    'nt-reg-permissions':'8269',
    'ms-ie-onrowsinserted-code-exec':'5900002',
    'Email_Potential_BO_Attachment':'2120035',
    'NCP_eDirectory_Replica_BO':'2124072',
    'ssl-ciphers':'13079',
    'sun-automountd':'13202',
    'reg-subsys-disabled':'9446',
    'rhel-rhsa-2009-1036-update':'10660',
    'HTTP_cookie_overflow':'3869',
    'savewebportal-multiple-xss':'11315',
    'ISA_svc_failed_to_start_corrupt_storage':'5523',
    'Truva':'13806',
    'photochannel-photo-upload-bo':'8846',
    'rhel-rhsa-2007-0386-update':'10306',
    'TrinooMasterConnect':'13777',
    'vixie-cron-docommand-gain-privilege':'14115',
    'quicktime-quicktime-content-code-execution':'9245',
    'backdoor-litmus':'702',
    'SatansBackdoor_Response':'2001576',
    'rhel-rhsa-2008-0893-update':'10599',
    'foxitreader-openexecute-pdf-bo':'2706',
    'oracle-cpu-july-2006':'8538',
    'dbpoweramp-audioplayer-activex-bo':'5900002',
    'scada-dnp-warmrestart':'11322',
    'rhel-rhsa-2010-0237-update':'5900002',
    'ypmap':'15348',
    'HTTP_Oracle2_BO':'2121036',
    'POP3 APOP name overflow':'8986',
    'PDF_JpxDecode_Corruption':'5900002',
    'qpopper-username-bo':'9186',
    'adobe-jpeg-2000-code-execution':'5900002',
    'IPP_Malformed':'2114088',
    '4xem-vatdecoder-activex-bo':'27',
    'HTTP_IIS_Ism_dll_Overflow':'4066',
    'malcode-Misc_DropNgo':'6372',
    'spyware-secondthought':'12732',
    'rhel-rhsa-2005-327-update':'9898',
    'quicktime-itunes-checkstackcookie-bo':'9231',
    'spyware-madfinder':'12629',
    'groupwise-interface-bo':'5900002',
    'isa-http-header-cache-poisoning':'5446',
    'aix-pdnsd-bo':'300',
    'hp-openviewnnm-ovsessionmgr-bo':'3327',
    'coldfusion-syntax-checker':'1401',
    'SNMP dialup username':'11994',
    'HTTP_MaxDB_WebDBM_Database_Overflow':'2122014',
    'HTTP_ICS_Wizard_DLL_Hijacking':'5900002',
    'smb-credentials-not-valid':'11720',
    'bind-zxfr-dos':'868',
    'Shopping_cart_order_URL':'11603',
    'oracle-appserver-webcachemanager-dos':'8533',
    'pdf-headercomment-detected':'8778',
    'malcode-SPMZ_AbsWrt_Int':'6556',
    'win-ms05kb890169-update':'14430',
    'C2_AUDIT_IS_OFF':'1057',
    'rumbaftp-activex-bo':'5900002',
    'rhel-rhsa-2005-066-update':'9831',
    'UDP port scan':'13829',
    'clampi-worm-detected':'1356',
    'user-compliance':'13953',
    'PDF_Swf_AuthPlay_Corruption':'5900002',
    'NNTP_Pipe':'2002402',
    'apache-default-content':'424',
    'Script_IE_toStaticHTML_Bypass':'5900002',
    'SMB_Adobe_ibfs32_DLL_Hijacking':'5900002',
    'novell-iprint-ienipp-activex-bo':'5900002',
    'ie-favicon':'4739',
    'coldfusion-debug-reveal-path':'1391',
    'solaris-ipadmin1m-file-overwrite':'12379',
    'malcode-TrojanInterface0':'6803',
    'XLog_TCP_Response':'2113164',
    'rhel-rhsa-2007-1031-update':'10437',
    'HTTP_SendTempPl':'2002660',
    'QuikStore configuration URL':'9276',
    'hsrp-invalid-ipttl':'3353',
    'nntp-port-probe':'7865',
    'PDF_Filter_On_External_File':'5900002',
    'rtf-long-control-word':'5900002',
    'smtp-bdat-length-detected':'11850',
    'win-ms08kb946538-update':'14632',
    'nt-process-audit-success':'8248',
    'rhel-rhsa-2011-0428-update':'5900002',
    'HTTP_POST_nnmrptconfig_nameParams_Overflow':'5900002',
    'HTTP_Netscape_SpaceView':'2000610',
    'IOS_Shell_Enable':'2103036',
    'winxp-windows-shell-bo':'15107',
    'spyware-msmediaservice':'12651',
    'watchguard-soho-web-dos':'14206',
    'mozilla-product-detected':'7123',
    'sapgui-activex-code-execution':'5900002',
    'nfs-root':'7814',
    'malcode-SPTRJ_Inet_DTime':'6715',
    'BOEP_ypager':'979',
    'JBIG2_Symbol_Overflow':'2114156',
    'electronicarts-snoopyctrl-bo':'2066',
    'MSRPC_CA_GCBHandleFromGroupName_Overflow':'5900002',
    'rhel-rhsa-freeradius-eapttls-dos':'10695',
    'Rlogin_-froot_backdoor':'10809',
    'malcode-DataLeaker':'6191',
    'bftelnet-username-dos':'813',
    'tftp-filename-bo':'13645',
    'HTTP_POST_SQL_Select_Count':'2110110',
    'rhel-rhsa-2007-1114-update':'10460',
    'malcode-Susp_Com_AutoStart':'6760',
    'IDENT version':'4648',
    'wireshark-gsm-bssmap-dos-win':'15116',
    'HTTP_POST_PeopleSoft_Traversal':'2113015',
    'Use_of_user_rights':'13944',
    'RPC_YPPasswd_Overflow':'2001736',
    'linux-ixj-root-privileges':'5937',
    'PDE_Unauthenticated_Host':'8773',
    'file-default-sulog':'2489',
    'rhel-rhsa-2011-0013-update':'5900002',
    'win-ms12kb2693777-update':'5900002',
    'rhel-rhsa-2009-1222-update':'5900002',
    'Qpopper_Auth_failed':'9188',
    'IMAP_Auth_Failed':'2001603',
    'asterisk-iax2-videoframe-bo':'585',
    'rhel-rhsa-2011-1104-update':'5900002',
    'BackOrifice_Ping':'2001506',
    'Security_attributes_on_object_changed':'11446',
    'SNMP_HP_ProCurve':'2106153',
    'SubSeven email':'13174',
    'Image_EMF_GDI_Header_Overflow':'5070',
    'ISA_IPSec_config_changed_restart_pending':'5503',
    'nt-domain-admin-nopwd':'8051',
    'vim-elevate-privileges':'14090',
    'LDAP_Active_Directory_Possible_Invalid_Free':'5831',
    'NNTP_Outlook_Reply_Overflow':'2122022',
    'suspicious-activex-installer-detected':'13275',
    'reg-sec-registry-access':'9439',
    'Email_Turn':'2001041',
    'rhel-rhsa-2004-234-update':'9706',
    'rhel-rhsa-2007-0562-update':'10342',
    'google-chrome-letter-code-execution':'5900002',
    'SIP_Long_Request_URI':'2120064',
    'HTTP_Shells_Sh':'2002528',
    'oracle-database-netauth-unspecified':'8544',
    'RTSP_Content_Type_Overflow':'11214',
    'CGI_perl.exe':'1200',
    'sunjava-error-path-disclosure':'13235',
    'quicktime-rtsp-responses-bo':'9247',
    'win-ms06kb924163-update':'14539',
    'rhel-rhsa-2005-763-update':'10021',
    'rhel-rhsa-2005-825-update':'10050',
    'aim-present':'167',
    'http-cgi-php-mylog':'3592',
    'spyware-everad':'12547',
    'rhel-rhsa-2008-0156-update':'10507',
    'BackOrifice2K_UDP_Auth_Request':'2100016',
    'win2k-telnet-handle-leak-dos':'14974',
    'officeviewer-open-command-execution':'8425',
    'ftp-unix-passwords':'2875',
    'adobe-flash-domainpolicy-security-bypass':'123',
    'Microsoft_Windows_Shell_Banner':'2110024',
    'rsagent-useradded-admingroup':'11176',
    'HTTP_WebpageCgi_ViewInfo':'2002663',
    'ms-stepbystep-bookmark-bo':'7219',
    'SMTP_FROM__field_overflow':'11907',
    'imail-login-bo':'5131',
    'SNMP_Community_Underflow':'2106077',
    'fetchmail-imap-msgnum-bo':'2451',
    'ravflic-filename-bo':'9323',
    'nt-logged-on':'8160',
    'mysql-default-root-access':'7518',
    'office-msodatasourcecontrol-bo':'8409',
    'Pict_Detected':'8933',
    'Oracle_batch_file_URL':'8591',
    'nestea-linux-dos':'7671',
    'trend-webdeployment-activex-code-exec':'13752',
    'exchange-malformed-rpc-dos':'2287',
    'win-adfs-code-execution':'14289',
    'HTTP_Malformed_Server_Response':'5900002',
    'rhel-rhsa-2011-1797-update':'5900002',
    'http-cgi-test':'3597',
    'SQL_Auth_Failed':'2001607',
    'evt_logcorrupt':'2244',
    'rhel-rhsa-2010-0737-update':'5900002',
    'ms-agent-activex-code-execution':'7154',
    'HTTP_OpenView_NNM_OvWebHelp_Overflow':'5900002',
    'smb-signing-not-required':'11730',
    'ourgame-gliedown2-activex-bo':'8663',
    'sopcast-activex-bo':'5900002',
    'revenger-backdoor':'9499',
    'oracle-dbmscdcimpdp-sql-injection':'8547',
    'Java_Getsoundbank_Overflow':'5900002',
    'rhel-rhsa-mozilla-viewimage-xss':'10729',
    'mailmax-bo':'6126',
    'DNS_Tunnel_Detected':'5900002',
    'hp-dced-bo':'3300',
    'nt-pw-history':'8252',
    'jre-setbytepixels-bo':'5900002',
    'rhel-rhsa-2008-0177-update':'10516',
    'ms-directshow-avi-bo':'7167',
    'Dameware_Detected':'1623',
    'suspicious-compoundfile-detected':'5900002',
    'Security_disabled_local_group_changed':'11453',
    'sunos-sendmail-ifs-gain-privilege':'13242',
    'snmp-toomanyvariables':'12118',
    'sybase-detect-tcp':'13294',
    'Suspect_Finger':'13257',
    'Phoenix_TCP_Response':'2113151',
    'RPC Amd Pid':'10845',
    'SOCKS connect':'12326',
    'Finger_List':'2001105',
    'SECURITY_SAM reg hack':'11473',
    'RTSP_WMP_NSS_Code_Execution':'5900002',
    'AOLIM_Login':'396',
    'socks5-connection-audit':'12342',
    'sun-jre-jpeg-bo':'5900002',
    'HTTP_Squid_ACL_Bypass':'2110059',
    'ie-ms05kb867282-update':'4803',
    'interscan-viruswall-ftpsave-bo':'5249',
    'TCP_SYN_with_URG_flag':'13466',
    'rhel-rhsa-2007-0795-update':'10376',
    'System_Successful_Login':'13346',
    'exchange-calendar-code-execution':'2280',
    'google-earth-dll-code-exec':'5900002',
    'Add_SID_failure':'89',
    'ms-aspnet-ms05kb887219-update':'7159',
    'oracle-application-server-bo':'8516',
    'tls-diginotar-untrusted-certificate':'5900002',
    'zip-file-password-protected':'15371',
    '6in4_Tunnel':'28',
    'rhel-rhsa-2005-141-update':'9865',
    'nt-logondos':'8170',
    'ACF_Mem_Corruption':'2114024',
    'Unisys_BIS_Tcp_Overflow':'5900002',
    'user-shutdown-anysystem-onceonly':'14013',
    'ISA_FW_Stop':'5499',
    'Twinge_Attack':'2000111',
    'CGI phf':'1156',
    'DNS zone transfer':'1861',
    'mysql-alter-restriction-bypass':'7508',
    'siteserver-site-csc':'11678',
    'SNMP_InvalidTag_Packet':'12225',
    'win-ms06kb905646-update':'14471',
    'exploit-WinApi(100048)':'2393',
    'jre-gif-bo':'5677',
    'One_TCP_Response':'2113219',
    'barcode-barcode-file-overwrite':'796',
    'dns-unauthorized-transfer-request':'1891',
    'LDAP_eDirectory_NullSearchRequest_Overflow':'5900002',
    'SAMI_WMP_Overflow':'11295',
    'rpc-admind':'10868',
    'novell-enumprinters-bo':'7919',
    'Email_To_Dot_Dot':'2001046',
    'gzip-lzh-array-code-execution':'3232',
    'rhel-rhsa-2008-0517-update':'10569',
    'rsagent-suspect-finger':'11143',
    'backdoor-snipernet':'728',
    'HTTP_AnyFormPost':'3748',
    'novell-iprint-activex-bo':'7921',
    'sntp-time-broadcast-audit':'12315',
    'quicktime-heap-bo':'9226',
    'license-gcr-network-bo':'5902',
    'Informix_Setenv_UseLastCommitted_Overflow':'5900002',
    'rhel-rhsa-2004-240-update':'9708',
    'telnet-terminaltype-long':'13544',
    'rhel-rhsa-2007-0106-update':'10252',
    'rhel-rhsa-2004-160-update':'9692',
    'lotus-notes-lzhsr-bo':'5900002',
    'NewTear attack':'7789',
    'HTTP_WinMX':'4530',
    'HTTP_Netware_DirList':'2002654',
    'halflife-server-running':'3262',
    'CGI_rguest.exe':'1204',
    'finger-rtm':'2589',
    'RAT_Content_Advisor_Overflow':'2113205',
    'cyrus-sasl-gain-access':'1611',
    'google-chrome-clipboard-security-bypass':'5900002',
    'mssql-malformed-tds-crash':'7410',
    'win-ms08kb948590-update':'14639',
    'mediaplayer-activex-obtain-information':'6976',
    'Email_Mime_Filename_Chars':'2102019',
    'SDP_Invalid_UTF8':'2106301',
    'xinetd-zero-length-bo':'15232',
    'quagga-bgpattributes-dos':'9195',
    'rhel-rhsa-2003-315-update':'9640',
    'rhel-rhsa-2005-201-update':'9873',
    'tdfc-export-limitedwritable':'13486',
    'SSDT_Modification_Detected-arktest':'12968',
    'crystalreports-activex-dos':'5900002',
    'win-ms07kb918118-update':'14552',
    'firefox-mchannel-code-exec':'5900002',
    'adobe-acrobat-unspec-code-execution':'111',
    'FrontPage Publishing DoS':'2747',
    'Secu_Descptr_propgtr_abnoraml_termination':'11430',
    'VmGuestRebootEvent':'14125',
    'IRC_buffer_overflow':'5385',
    'HTTP_JRun_Double_Slash':'2105053',
    'SMB_DLL_Filename':'5900002',
    'HTTP_URL_has_many_slashes':'4452',
    'service-wait-hint-change':'11550',
    'oracle-autovue-activex-file-overwrite':'5900002',
    'HTTP_Htimage_Files':'2105008',
    'TSM_FastBack_Mount_Code_Exec':'5900002',
    'sip-invite-unregistered-endpoint':'11622',
    'SSL_ASN1_Overflow':'2120012',
    'RNX_CrossDomain_Exec':'5900002',
    'events-to-note':'2235',
    'License_Notice':'5905',
    'ms-ras-ppp-dos':'7201',
    'display-properties-appearance':'1833',
    'soulseek-login-detected':'12407',
    'vmware-host-code-execution':'14145',
    'FTP_Pipe':'2001311',
    'LDAP_LSASS_Heap_Overflow':'5900002',
    'spyware-411-ferret':'12421',
    'win-ms08kb955218-update':'14676',
    'boep-abnormal-termination':'944',
    'pcanywhere-login-successful':'8759',
    'HTML_iTunes_Multi_Protocol_Overflow':'3424',
    'sscan_Scan':'2001517',
    'nt-sam-pipesamr-detected':'8291',
    'CompoundFile_Word_Malformed_Table_String':'2106240',
    'mozilla-javascript-navigator-code-excecution':'7089',
    'SMTP_many_quotes_in_recipient':'11922',
    'jfs-journal-insecure':'5670',
    'malcode-Win32_Zade':'6884',
    'decod-ip-protocol-violation':'1706',
    'tcp-post-syn-connection':'13393',
    'buttman-backdoor':'1052',
    'malcode-ExeSeq10':'6257',
    'malcode-ExeSeq11':'6258',
    'malcode-ExeSeq12':'6259',
    'malcode-ExeSeq13':'6260',
    'malcode-ExeSeq14':'6261',
    'HTTP_POST_win.ini_file':'4335',
    'malcode-ExeSeq16':'6262',
    'malcode-ExeSeq17':'6263',
    'malcode-ExeSeq19':'6264',
    'Oracle_Listener_Bo':'2120029',
    'HTTP_IIS_ASP_Transfer_Overflow':'4044',
    'HTTP_Answerbook_Format_String':'2115001',
    'java-awt-information-disclosure':'5577',
    'SNMP bad trap timestamp tag':'11981',
    'MSSQL_Successful_Trusted_Connection':'7449',
    'javascript-unescape-fromcharcode':'5900002',
    'Kerberos_Klogin_krb5_Overflow':'5900002',
    'MSRPC_CA_Arcserv_ASCORE_DoS':'7308',
    'http-cgi-glimpse-vuln':'3577',
    'kidterror-backdoor':'5778',
    'trillian-directim-bo':'13758',
    'passwd-nis':'8736',
    'AOL Instant Messenger Overflow':'379',
    'rhel-rhsa-2005-772-update':'10028',
    'rhel-rhsa-2012-0006-update':'5900002',
    'Windows_Kernel_Font_Code_Execution':'15033',
    'samba-sid-name-privilege-escalation':'11277',
    'linux-modprobe-execute-code':'5948',
    'tftp-download-winini-detected':'13642',
    'QuickTime_Reference_Movie_Overflow':'2114140',
    'rhel-rhsa-2008-0003-update':'10471',
    'win-ms09kb967340-update':'14723',
    'aix-iy85415-fix':'272',
    'multiple-antivirus-mzheader-code-execution':'7478',
    'xorg-xserver-dbe-swap-overflow':'15277',
    'mssql-data-buffer-dos':'7401',
    'nt-pwd-never-expire':'8254',
    'Email_UUCP_Recipient':'2149',
    'ftp-rnfr':'2866',
    'Complete_Baseline_Finished':'1420',
    'dns_unauth_xfer':'1963',
    'MySQL_FormatString_DoS':'7539',
    'http-iis-malformed-header':'3640',
    'WindowsMite_TCP_Response':'2113163',
    'rpc.statd dotdot file create':'10920',
    'rhel-rhsa-2010-0430-update':'5900002',
    'win2k-localgroup-member-removed':'14939',
    'microsoft-foxserver-command-execution':'7007',
    'ras-rrq-inconsistent-address':'9311',
    'nis-update-daemon':'7848',
    'msn-messenger-gif-execute-code':'7277',
    'CMF_iOffsetMusic_Overflow':'5900002',
    'comraider-activex-write-file-overwrite':'1471',
    'quicktime710-update':'9257',
    'decod-win-null':'1758',
    'SQL_Empty_Admin_Password_Failed':'12894',
    'rhel-rhsa-2004-440-update':'9740',
    'slmail-username-bo':'11694',
    'Proxy port probe':'9147',
    'SNMP_cable-docsis_community':'12176',
    'SMB_Auth_Failed':'2001606',
    'rhel-rhsa-2007-0534-update':'10335',
    'rhel-rhsa-2008-0906-update':'10603',
    'GirlFriend':'3098',
    'user-name-invalid':'13993',
    'Trinoo_Master_Request':'2100004',
    'ISA_detected_possible_land_attack':'5490',
    'db2-installed':'1648',
    'flashplayer-unspecified-info-disclosure':'2684',
    'malcode-DeleteSystemDirectory':'6199',
    'TCP_Urg_OutOfRange':'2000318',
    'URL contains Unicode _ 255':'13932',
    'win-ms12kb2665364-update':'5900002',
    'squid-storebuffer-dos':'12947',
    'win-ms05kb894549-update':'14441',
    'DNS BIND version request':'1841',
    'rhel-rhsa-2011-1306-update':'5900002',
    'rpc-32771':'10867',
    'rhel-rhsa-2004-004-update':'9653',
    'jbig2-malformed':'5658',
    'POP3 Attack':'8987',
    'nt-lock-memory':'8156',
    'rhel-rhsa-2007-0873-update':'10386',
    'eudora-long-attachment-filename':'2220',
    'iisv2-webdir-browse':'5024',
    'rhel-rhsa-flashplayer-unspec-info-disclosure':'10694',
    'win-htmlhelp-activex-code-execution':'14343',
    'kaspersky-online-activex-format-string':'5690',
    'http-post-shell-request':'3672',
    'malcode-SPNE_Jmp_IniMod':'6595',
    'cups-neg-memcpy-bo':'1563',
    'HTTP_FingerCgi':'2002569',
    'Email_Auth_CramMd5_Overflow':'2114069',
    'maxdb-websql-bo':'6945',
    'rhel-rhsa-2003-360-update':'9643',
    'rhel-rhsa-2005-004-update':'9794',
    'Codec_Range_Error':'2114157',
    'task-manager-enabled':'13359',
    'MSDNS_port_probe':'7251',
    'Nessus_Scan':'7668',
    'HTTP_Java_Web_Server_Webdav_Overflow':'5900002',
    'HTTP_URL_JspPath':'2000634',
    'TCP_Data_Changed':'2000320',
    'rhel-rhsa-2006-0758-update':'10209',
    'sendmail-headers-dos':'11496',
    'rhel-rhsa-2007-0889-update':'10391',
    'iis-device-asp-dos':'4923',
    'RTMP_ObjectType_CodeExec':'5900002',
    'Email_Autonomy_Kvdocve_Bo':'2124021',
    'ms-sharepoint-inplview-xss':'5900002',
    'MSRPC_RFPoison_Attack':'2002807',
    'firefox-geckoactivexobject-info-disclosure':'2623',
    'HTTP_Tilde':'2106036',
    'FTP_Windows_PWL_File':'2003604',
    'NetSphere trojan horse activity':'7748',
    'interbase-create-bo':'5245',
    'HTTP_URL_Repeated_Dot':'2000631',
    'tcp-ip-timestamp-dos':'13387',
    'malcode-AmbiDropper':'6135',
    'zincite-a-backdoor':'15368',
    'Outbound_replication_disabled':'8671',
    'HTML_Object_Styles_Overflow':'2121055',
    'rhel-rhsa-2005-830-update':'10053',
    'SMTP email name overflow':'11811',
    'htdig-htsearch-retrieve-files':'3362',
    'rhel-rhsa-2008-0262-update':'10544',
    'Image_PNG_Java_JRE_Overflow':'2125014',
    'aix-iy85930-fix':'275',
    'cisco-tunnel-interface-exists':'1329',
    'BOOTP File Overflow':'986',
    'home-anonftp':'3285',
    'ftp-bpftp-installed':'2831',
    'Hacker_Defender':'2110037',
    'SSH_FreeSSHd_NEWKEYS_DoS':'5900002',
    'rsagent-ldap-blacklist-permanent':'11065',
    'http-script-bypass':'3685',
    'HTTP_Apache_JK2_Host_Overflow':'2125004',
    'rc-command-groupwritable':'9324',
    'nt-ms-dns-cachepollution':'8188',
    'image-color-management-image-file-bo':'5054',
    'Email_Virus_investigator':'2002206',
    'AolAdmin':'391',
    'sec_auditlost':'11425',
    'webex-wrffile-bo':'5900002',
    'nt-351':'7955',
    'Stumbler_ChangeAddress':'13160',
    'rhel-rhsa-2003-236-update':'9617',
    'dhcp-client-overflow':'1791',
    'rsagent-suspect-portscan':'11150',
    'win-ms11kb2639417-update':'5900002',
    'Snork_Attack':'2000203',
    'ie-object-access-code-execution':'4812',
    'ghostscript-env-variable':'3085',
    'SMTP port probe':'11834',
    'email-active-script-html':'2068',
    'iis-invalid-mime-header-dos':'4954',
    'ftp-root-login-success':'2867',
    'win2k-directory-service-restore-password':'14912',
    'HTML_Messenger_Information_Disclosure':'2124012',
    'Cold_Fusion_Sample_URL':'1388',
    'spyware-transponder':'12777',
    'Installation Failure':'5233',
    'rsagent-mssql-connect-failed':'11074',
    'hp-openviewnnm-snmp-bo':'5900002',
    'backdoor-cow':'674',
    'win-ms06kb911280-update':'14481',
    'frontpage-pwd-service':'2762',
    'roamabout-wep-encryption-disabled':'10835',
    'oracle-listener-debug-dos':'8565',
    'rhel-rhsa-2005-213-update':'9875',
    'HTTP_Yahoo_Email_Attachment':'4537',
    'rhel-rhsa-2004-069-update':'9674',
    'HTTP_Lotus_Domino_Dir_Traversal':'2002599',
    'Code_Red_I':'1382',
    'apache-multiprocessingcode-dos':'466',
    'SMB_login_failed':'11757',
    'ver-tcpip-sys':'14071',
    'BrightStor_Discovery_UDP_Overflow':'2113236',
    'CGI wguest.exe':'1169',
    'Flash_NavigateToURL_XSS':'2114083',
    'HTTP_Nimda_Riched20dll':'4195',
    'nt-logon-audit':'8163',
    'expertpdfviewerx-activex-file-overwrite':'2341',
    'firefox-thinkpadsensor-dll-code-execution':'5900002',
    'nt-guestblankpw':'8130',
    'DNS_Windows_SMTP_MX_DoS':'5900002',
    'firefox-liboggz-code-execution':'2629',
    'win-ms12kb2651026-update':'5900002',
    'SNMP_String_Underflow':'12267',
    'HTTP URL has many slashes':'3536',
    'HTTP_Tunnel_Detected':'4432',
    'jsws-webdav-bo':'5686',
    'drat-backdoor':'2007',
    'Change_password_attack_likely_successful':'1223',
    'nt-malformed-image-header':'8177',
    'ICMP_Router_Advertisement_Dos':'4617',
    'openclose':'8449',
    'bournal-update-symlink':'1000',
    'denied-cronat':'1768',
    'smtp-mime-filename-audit':'11867',
    'SNMP_nonzero_len_null_type':'12245',
    'SQLServer_login_failed_too_many_users':'12926',
    'brightstor-messageengine-rpc-bo':'5900002',
    'rhel-rhsa-2005-589-update':'9991',
    'expeditor-rcplauncher-code-execution':'2339',
    'symantec-cba-command-execution':'5900002',
    'spyware-bargainbuddy':'12458',
    'spyware-consulinfo-bvdialer':'12501',
    'adobe-multiple-activex-bo':'130',
    'MS_Encoded_Script_Overflow':'7236',
    'spyware-adultlinks-quickbar':'12441',
    'FTP win.ini file':'2826',
    'msvm-java-file-read':'7463',
    'http-field-binary':'3617',
    'backdoor-satans-backdoor':'723',
    'sun-java-jnlp-bo':'13208',
    'novell-iprint-ienipp-activex-dos':'5900002',
    'snmp-smi-counter64-found':'12111',
    'ccproxy-connect-bo':'5900002',
    'TCP_trojan_horse_probe':'13470',
    'SNMP_Packet_Underflow':'2106073',
    'HTTP_IE_Object_Access_Code_Execution':'4023',
    'hp-ovnnm-ovwebhelp-bo':'5900002',
    'OTF_Java_IDEF_opcode_Overflow':'5900002',
    'rhel-rhsa-2007-0436-update':'10318',
    'Cisco_ILMI_SNMP_Community':'2106007',
    'weblogic-ssiservlet-source-disclosure':'14242',
    'csvform-cgi-execute-commands':'1557',
    'ibm-db2-sqlrlaka-bo':'4569',
    'ntmail-fileread':'8386',
    'HTTP_RHDS_AcceptLanguage_Overflow':'4354',
    'rhel-rhsa-2006-0164-update':'10083',
    'Amd_Pid':'348',
    'crontab-owner-unsecure':'1543',
    'portmap-pdump':'9050',
    'TCP_Short_Header':'2000307',
    'decod-smb-password-empty':'1736',
    'linux-superblockdoinit-dos':'5974',
    'ActiveX_Blocked':'85',
    'HTR_localstart_overflow':'3480',
    'HTTP_GET_contains_create%table':'3934',
    'SMTP To':'11839',
    'nt-pwd-nohistory-onceonly':'8256',
    'http-proxy':'3677',
    'rhel-rhsa-2003-146-update':'9597',
    'itunes-installed':'5568',
    'HTTP_Oracle_WebCache_Overflow':'2110062',
    'HTTP_IIS_Bdir_Htr':'2113038',
    'rhel-rhsa-2007-0044-update':'10226',
    'voip-account-without-password':'14168',
    'rstat-out':'11203',
    'jsws-digest-header-bo':'5900002',
    'HTTP_POST_Script':'2000635',
    'SMB_Samba_Mailslot_Logon_BO':'11782',
    'adpassword.txt URL':'143',
    'ICMP_Komahayown_Detected':'2113227',
    'PortalOfDoom':'9047',
    'fluxay-trojan':'2693',
    'malcode-HTMLRegWizardExploit':'6333',
    'SMTP_port_probe':'11931',
    'sendmail-alias-dos':'11480',
    'aix-iy72706-fix':'230',
    'irc-dcc-transfer':'5377',
    'ethereal-lmp-dissector-dos':'2208',
    'HTTP_IIS_Idq_Overflow':'4058',
    'spyware-dbd-ath-cx':'12513',
    'freebsd-nfsd-kernel-dos':'2727',
    'spyware-hotlink-bho':'12592',
    'pcanywhere-login-not-required':'8758',
    'SNMP_bad_version_tag':'12173',
    'PPTP malformed':'9092',
    'SNMP_VarBindList_Underflow':'2106092',
    'adobe-firefox-plugin-code-execution':'5900002',
    'rhel-rhsa-2010-0449-update':'5900002',
    'ca-license-string-bo':'1082',
    'win-sami-code-execution':'14826',
    'win95-nbsmbpwl':'15004',
    'HTTP_Arcadia_Tradecli':'2002623',
    'win-ms08kb951071-update':'14655',
    'telnet-client-slcaddreply-bo':'13534',
    'POP_Too_Many_Connects':'2110001',
    'httpserver-connectmethod-bypass-filtering':'4548',
    'novell-client-activex-dos':'5900002',
    'netbackup-connect-options-bo':'5900002',
    'file-default-passlength':'2479',
    'malcode-SPTRJ_NoICon_CpySelf_Misc':'6722',
    'RuxTick':'11234',
    'aix-iy23846-fix':'169',
    'IIS_data_service_query':'5014',
    'rhel-rhsa-2005-840-update':'10058',
    'Login Backdoor':'6020',
    'malcode-ExeSeq39':'6283',
    'Fragment_Differential_Overlap':'2000025',
    'libpng-pnginflate-bo':'5900002',
    'oracle-jre-scripting-unspecified':'5900002',
    'malcode-ScriptDropperIRC':'6505',
    'backdoor-asylum':'662',
    'sendmail-dns-txt-bo':'11490',
    'msn-messenger-video-request':'7278',
    'Nessus Scan':'7664',
    'win-ms09kb976325-update':'14772',
    'CGI_snork.bat':'1207',
    'HTTP_WebSphere_Host':'2105056',
    'jet-vba-shell':'5668',
    'rhel-rhsa-2005-673-update':'10005',
    'nds-user-account-locked-out':'7625',
    'win-ipp-service-code-execution':'14353',
    'rhel-rhsa-2008-1001-update':'5900002',
    'novell-iprint-time-bo':'7933',
    'radius-message-digest-bo':'9289',
    'reg-key-changed':'9400',
    'TeamViewer_Detected':'5900002',
    'gdgraphicslibrary-gdft-bo':'3070',
    'rhel-rhsa-mysql-case-privilege-escalation':'10736',
    'OSPF_Link_State_Update_Multicast':'8657',
    'Email_ExchangeStore_DoS':'2103016',
    'rhel-rhsa-2005-212-update':'9874',
    'oracle-database-aq-sql-injection':'5900002',
    'cart32-clientlist':'1105',
    'malcode-SPCOM_MBR_RdWrt':'6550',
    'ms-aspnet-forms-auth-bypass':'5900002',
    'win-ms07kb936782-update':'14594',
    'win-ms09kb960859-update':'14713',
    'win-ms12kb2698365-update':'5900002',
    'win-ms10kb2160329-update':'5900002',
    'RPC_Ypupdate_Exec':'2001712',
    'phorum':'8845',
    'rhel-rhsa-2007-0131-update':'10261',
    'nis-udp-running':'7844',
    'Ident_Error':'4657',
    'ie-ms05kb890047-update':'4804',
    'rhel-rhsa-2005-081-update':'9840',
    'linuxconf-sendmail-mail-relay':'5991',
    'ip-portscan':'5280',
    'lotus-timedate-bo':'6059',
    'RPC_UDP_port_probe':'10997',
    'rhel-rhsa-2003-270-update':'9627',
    'ActiveX_RealPlayer':'5900002',
    'dpapi-key-recovery-attempted':'1995',
    'ie-scriptlet-rendering-read-files':'4833',
    'aol-im':'382',
    'echo':'2038',
    'linux-sctp-netfilter-dos':'5968',
    'php-openbasedir-restriction-bypass':'8890',
    'nt-group-memrights':'8098',
    'spyware-clickspring':'12494',
    'rsagent-useraccount-created':'11174',
    'malcode-WormIndicator':'6909',
    'php-mbsendmail-header-injection':'8878',
    'http-pipelining-detected':'3663',
    'squid-clientprocessrequest-dos':'12930',
    'T0rn port probe':'13351',
    'JavaScript_HHCtrl_Overflow':'2113258',
    'videoedit-activex-bo':'5900002',
    'exploit-MSWord(100005)':'2377',
    'oracle-appserver-apache-services':'8517',
    'FTP_Filename':'2918',
    'nt-schedule-perm':'8294',
    'DNS_spoof_successful':'1957',
    'win2k-deny-logon-service':'14910',
    'rhel-rhsa-2008-0892-update':'10598',
    'sendmail-long-header-dos':'11498',
    'HTML_IE_Url_Overflow':'2109005',
    'Rockliffe_CGI_exploit':'10837',
    'http-dll-transfer':'5900002',
    'rhel-rhsa-2007-0403-update':'10314',
    'ypops-installed':'15349',
    'rhel-rhsa-2002-256-update':'9545',
    'screen-not-active':'11371',
    'Compaq_Insight_DMI_overflow':'1417',
    'BOEP_locator':'972',
    'Registry_NT_security_options_changed':'9465',
    'aix-iy70034-fix':'227',
    'malcode-BrowserHijack':'6171',
    'aix-iy72704-fix':'229',
    'jet-text-isam':'5667',
    'Image_WMF_HeaderFileSize_Overflow':'2116029',
    'spyware-timesink':'12768',
    'rhel-rhsa-2007-0532-update':'10333',
    'Failed_login-password_expired':'2430',
    'FTP_Passive_Response_Very_Long':'5900002',
    'weblogic-java-injection':'14238',
    'openldap-slapd-delete-attributes':'8455',
    'HTTP_Carbo_Server':'2106040',
    'mcafee-saas-activex-code-execution':'5900002',
    'rhel-rhsa-kernel-audit-dos':'10701',
    'ASP_IIS_HTMLEncode':'582',
    'Email_Virus_Double_Extension_Block':'2154',
    'spyware-newdotnet':'12675',
    'ssl-message-dos':'13081',
    'FTP_Unix_RemoteHost_File':'2003606',
    'chetcpasswd-shadow-file-disclosure':'1235',
    'nt-increase-quota-onceonly':'8141',
    'FTP_Append_Very_Long':'2122019',
    'HTTP_Viewsrc_fileread':'2002629',
    'bind-tsig-bo':'864',
    'SNMP community long':'11988',
    'apache-ftp-proxy-dos':'433',
    'Conficker_P2P_Detected':'2110189',
    'rsagent-ssh-ipoptions':'11123',
    'ethereal-smb-dissector-dos':'2212',
    'Content_CMS_OpenSSL_Exec':'5900002',
    'DesktopController_Error':'1776',
    'CompoundFile_Packager':'5900002',
    'rhel-rhsa-2009-0449-update':'5900002',
    'Saihyousen_Attack':'2000208',
    'ftp-stat':'2870',
    'SSH_RSA_auth._from_restricted_host':'13057',
    'rsagent-ssh-agentauthfailure':'11114',
    'Copy_of_Pict_Region_Overflow':'5900002',
    'http-get-compute-sum':'3620',
    'Script_NCTAudioFile_ActiveX_Bo':'2124055',
    'win-ms09kb971486-update':'14744',
    'nds-user-template-grace-logins':'7647',
    'msdtc-network-message-dos':'7254',
    'rhel-rhsa-2006-0658-update':'10173',
    'reg-afd-not-set':'9387',
    'macromedia-swf-file-code-execution':'6102',
    'user-rootequiv':'14009',
    'rhel-rhsa-2007-0010-update':'10217',
    'http-exe-transfer':'3616',
    'iis-asp-data-transfer-bo':'4901',
    'rhel-rhsa-2010-0489-update':'5900002',
    'rhel-rhsa-2004-192-update':'9702',
    'ie-ms02023-patch':'4797',
    'User_removed_from_local_admin_group':'14041',
    'webserver-version-detected':'14250',
    'lsh-heap-overflow':'6089',
    'cmnc200-camera-activex-bo':'5900002',
    'RTF_Word_Memory_Corruption_Exec':'5900002',
    'aix-iy64929-fix':'203',
    'spyware-global-netcom-inc':'12572',
    'STUN_Message_Attribute':'13166',
    'nt-posix':'8235',
    'ms-protected-store':'7199',
    'rhel-rhsa-2004-060-update':'9670',
    'Cart32 ChangeAdminPassword URL':'1101',
    'SISX_Installer_Blacklisted':'5900002',
    'oracle-appserver-location-bo':'8521',
    'rhel-rhsa-2011-1458-update':'5900002',
    'oracle-database-olap-olapimplt-dos':'5900002',
    'microsoft-richtextbox-file-overwrite':'7011',
    'rhel-rhsa-2008-0289-update':'10551',
    'MS_security_ID_lookup':'7240',
    'rhel-rhsa-2003-244-update':'9620',
    'HTTP_Netscape_Revlog':'2000650',
    'tcp-dataless-session-rst':'5900002',
    'malcode-WABWorm0':'6875',
    'Order_Form_v1.2_data_URL':'8620',
    'HTTP_ASP_WebConfig_Accessed':'5900002',
    'rhel-rhsa-2007-1130-update':'10464',
    'Linuxconf port probe':'5989',
    'frozen-file-group-changed':'2771',
    'zope-fmt-access-methods':'15396',
    'Local_Client_Virus_Flood':'6008',
    'pdf-extraneous-characters':'5900002',
    'QuickTime_Deep_Nesting':'5900002',
    'isa-syn-attack-detected':'5473',
    'RemoteRevise_TCP_Request':'2113061',
    'HTML_XUpload_ActiveX_Overflow':'3474',
    'netbsd-ftpd-glob-bo':'7697',
    'file-buffer-overflow':'2466',
    'file-uucpperm-uux':'2561',
    'FTP_Checksum_Cmd_BO':'2114019',
    'HTTP_JBoss_Console_Authentication_Bypass':'5900002',
    'HTTP_eDirectory_Multiple_Connection':'5900002',
    'malcode-rexx_09':'6467',
    'iis-htr-obtain-code':'4942',
    'Security_disabled_local_group_member_added':'11456',
    'namoinstaller-namoinstaller-code-execution':'7548',
    'novell-zenworks-activex-bo':'7941',
    'rhel-rhsa-2007-0735-update':'10367',
    'malcode-rexx_06':'6466',
    'malcode-rexx_05':'6465',
    'malcode-rexx_04':'6464',
    'php-running':'8899',
    'NetSphere_trojan_horse_activity':'7753',
    'sslv2-client-hello-overflow':'13103',
    'iis-htr-overflow':'4943',
    'HTTP_HTML_Tag_Injection':'2110176',
    'Email_Command_Overflow':'2102061',
    'Oracle_Init_Stored_Procedure_Overflow':'5900002',
    'rhel-rhsa-2007-0746-update':'10370',
    'PDF_CFF_Encoding_Error':'5900002',
    'SensorStatistics':'11526',
    'TFN_Daemon':'2001587',
    'XML_JNLP_Command_Injection':'5900002',
    'CVS_Auth_User_Failure':'1578',
    'python-repr-bo':'9167',
    'dabber-worm-detected':'1614',
    'CGI_websendmail':'1215',
    'modbus-tcpslave-bo':'7034',
    'rsagent-group-useradded':'11047',
    'HTTP_ColdFusion_Cfcache':'2002567',
    'adobe-fp-unspecified-bo':'5900002',
    'nt-afd-synflood':'7975',
    'rhel-rhsa-2011-0412-update':'5900002',
    'freefloatftpserver-allo-bo':'5900002',
    'rhel-rhsa-2011-0197-update':'5900002',
    'HTTP_Executable_Transfer':'3902',
    'exchange-detected':'2282',
    'HTML_Host_Command_Shell':'5900002',
    'HTTP_FrontPage_PWD':'2105060',
    'linux-plus':'5954',
    'rhel-rhsa-2007-0898-update':'10394',
    'ie-object-read-tif':'4816',
    'Tivoli_LCF_Default_Password':'2102029',
    'rhel-rhsa-2005-293-update':'9888',
    'operations-manager-sourceview-bo':'5900002',
    'rhel-rhsa-2005-397-update':'9934',
    'VmResumingEvent':'14135',
    'nt-dcom-default-launch':'8034',
    'XML_Subversion_Date_CmdExec':'2113244',
    'oracle-siebel-activex-code-execution':'5900002',
    'rhel-rhsa-2009-0333-update':'10633',
    'hp-instantsupport-extractcab-bo':'3308',
    'win-ms04011-patch':'14404',
    'IPv6_Router_Overflow':'2104038',
    'scada-dnp-broadcast-request':'11316',
    'HTTP_Perl_Example_Code':'2110058',
    'rsagent-ipop3d-userlogout':'11063',
    'rhel-rhsa-2003-038-update':'9569',
    'ghostscript-dsafer-read-files':'3084',
    'teamviewer-detected':'5900002',
    'linux-uncanonical-addr-dos':'5982',
    'Email_Executable_Content':'2110095',
    'Sophos_CPIO_BO':'2122007',
    'SIP_Large_Content_Length':'2120066',
    'OEM Not Installed':'8404',
    'rhel-rhsa-2008-0042-update':'10482',
    'rhel-rhsa-2008-0165-update':'10512',
    'win-ms11kb2508429-update':'5900002',
    'SNMP_Bad_RequestId':'2106108',
    'rhel-rhsa-2006-0266-update':'10105',
    'TearDrop2 attack':'13498',
    'quicktime-pascal-string-bo':'5900002',
    'zope-zclass-modification':'15399',
    'ForcedEntry_Response':'2001554',
    'rhel-rhsa-2008-0157-update':'10508',
    'nap-createaccount':'7550',
    'winnt-mutex-dos':'15064',
    'backdoor-biggluck':'665',
    'Cisco_CallMgrDB_Bo':'2120059',
    'SNMP community format':'11987',
    'iis-ftp-port-attack-enabled':'4933',
    'SISX_Installer_Detected':'5900002',
    'win-ms10kb982666-update':'5900002',
    'Agentx_HelixServer_Exec':'5900002',
    'malcode-HookAPI0':'6325',
    'mailenable-ntlm-message-bo':'6117',
    'SSL_TLS_Over_HTTP':'2110188',
    'HTTP_Apache_SlashSlash':'2105083',
    'Telnet NTLM tickle':'13518',
    'tcp-ip-source-quench-dos':'13386',
    'decod-smtp-invalid-mail-command':'1740',
    'malcode-SPPE_Reloc_CpuID':'6686',
    'isa-demand-dial-connection-detected':'5436',
    'rar-invalid-magic-bytes':'9304',
    'DataProtector_GET_FILE_Exec':'5900002',
    'ftp-pasvcore':'2859',
    'CGI win-c-sample.exe':'1171',
    'win-windowsshell-execute-code':'14877',
    'aix-iy67812-fix':'219',
    'HTTP_Tunnel_Not_TLS_or_SSL':'4433',
    'SSH2_Common_auth_failed_host':'13004',
    'nt-debug-onceonly':'8040',
    'brightstor-universalagent-bo':'1013',
    'HTTP_Cisco_IOS_Admin':'3828',
    'rhel-rhsa-2005-005-update':'9795',
    'CompoundFile_Publisher_Mem_Reference':'1451',
    'TFTP_sam.__file':'13679',
    'sametime-client-mouseover-xss':'11290',
    'smb-user-credentials-verified':'11731',
    '.htaccess URL':'1',
    'google-chrome-websockets-code-exec':'5900002',
    'decod-rip-metricchng':'1729',
    'RPC_Informix_Auth_Overflow':'5900002',
    'CGI_bash':'1177',
    'gtrust-added':'3216',
    'IMAP_Overflow':'5182',
    'cups-ippread-bo':'1560',
    'rhel-rhsa-2005-807-update':'10043',
    'rhel-rhsa-2008-0955-update':'5900002',
    'Telnet_Linker_Bug':'2000906',
    'Wav_Info_Overflow':'5900002',
    'abyss-unicode-directory-traversal':'34',
    'win2k-sp3':'14970',
    'php-file-upload-overflow':'8857',
    'rar-filename-not-rar-detected':'9303',
    'opachki-trojan-detected':'5900002',
    'spyware-ad-popper':'12430',
    'win2k-sp4':'14971',
    'win-wmf-execute-code':'14884',
    'roamabout-secure-access-disabled':'10834',
    'rpc.pcnfs_backdoor':'10913',
    'ca-etrust-caller-code-execution':'1078',
    'serverprotect-agrpccln-bo':'11533',
    'DNS_VirusScanTrojan':'2113005',
    'HTTP_IIS_ASP_WebConfig_Fetch_Error':'5900002',
    'JavaScript_Byte_Splitting':'5606',
    'rtsp-detected':'11212',
    'SIP_Long_Header_Name':'2120063',
    'cisco-vco-snmp-passwords':'1330',
    'rhel-rhsa-2005-070-update':'9834',
    'Script_Java_Web_Start_Jailbreak':'5900002',
    'Dameware_Obtain_Info':'2113049',
    'malcode-ExeSeq36':'6282',
    'rhel-rhsa-mozilla-parser-security-bypass':'10724',
    'malcode-ExeSeq35':'6281',
    'malcode-ExeSeq32':'6279',
    'TCP_Invalid_SACK':'2121022',
    'malcode-ExeSeq30':'6277',
    'cisco-ident':'1277',
    'ospf-null-authentication':'8646',
    'TCP_Probe_Rlogin':'13448',
    'rhel-rhsa-2003-207-update':'9613',
    'zone-signed-download':'15389',
    'microsoft-windows-ani-dos':'5900002',
    'icmp-flood-dos':'4597',
    'realwin-hmi-bo':'5900002',
    'AgentManagerNonresponsive':'161',
    'nt-group-system-env':'8109',
    'HTTP_MSMessenger_Message':'4172',
    'HTTP_IIS_Showcode':'2002678',
    'nt-unknown-pwdfilter':'8343',
    'Borland_Interbase_Multiple_Overflow':'997',
    'kerberos-krb5anametolocalname-bo':'5900002',
    'HTTP_FaxSurvey':'2002509',
    'anonftp-passwd':'362',
    'SMB_Negotiate_ProcessID_Exec':'11767',
    'rsagent-unixroot-login':'11166',
    'excel-xlsx-code-execution':'2271',
    'imesh-activex-bo':'5900002',
    'StreamingMedia_Detected':'13158',
    'smtp-expn':'11861',
    'rhel-rhsa-2004-165-update':'9693',
    'win-indexserver-view-files':'14351',
    'malcode-ExeSeq04_IVT':'6253',
    'Dragon-Fire_CGI':'2006',
    'integraxor-igcom-bo':'5900002',
    'xorg-xserver-dbe-overflow':'15276',
    'rhel-rhsa-2004-447-update':'9743',
    'aix-iy61956-fix':'185',
    'HTML_WindowsMedia_Overflow':'2114027',
    'spyware-searchseekfind':'12728',
    'interscan-viruswall-smtpscan-bo':'5251',
    'SubSeven_password-protected_activity':'13186',
    'tftp-homedir-set':'13650',
    'win2k-iomega-jaz-drive':'14930',
    'tomcat-mapuritoworker-bo':'13726',
    'FTP_SITE_ZIPCHK_buffer_overflow':'3005',
    'friendly-runapp-command-execution':'2744',
    'rhel-rhsa-mozilla-xmlprototype-code-execution':'10730',
    'Email_Ehlo':'2089',
    'SNMP trap timestamp underflow':'12031',
    'bugzilla-show-votes':'1047',
    'spyware-trti-dialer':'12779',
    'rhel-rhsa-kerberos-telnet-security-bypass':'10700',
    'spyware-optimal-soft':'12684',
    'rhel-rhsa-2008-0911-update':'5900002',
    'aix-iy73498-fix':'240',
    'rip-malformed':'5900002',
    'Radius_Password_Buffer_Overflow':'2002912',
    'ca-etrust-activex-bo':'1077',
    'chilkatimap-loadxmlemail-unauth-access':'1240',
    'BadUsernameSessionEvent':'785',
    'nt-dcom':'8038',
    'JavaScript_IE_mergeAttributes_Exec':'5620',
    'tivoli-tsm-adsmdll-bo':'13712',
    'apache-httponly-info-disc':'5900002',
    'cups-ippreadio-bo':'1561',
    'last2000-backdoor':'5807',
    'PhaseZero':'8836',
    'nt-ras':'8264',
    'http-testcgi-tcl-access':'3696',
    'realplayer-rjs-filename-directory-traversal':'9363',
    'win-ms08kb957173-update':'14688',
    'kaspersky-cab-heap-overflow':'5689',
    'Script_IE_toStaticHTML_Info_Disclosure':'5900002',
    'nds-user-password-length':'7642',
    'PE_Overlapping_Header':'2103035',
    'iams-smtp-vrfy-dos':'4558',
    'dansie-shopping-cart':'1630',
    'Zend_JavaBridge_Exec':'5900002',
    'ms-capicom-code-execution':'7163',
    'HTTP_IIS_Many_Hosts':'2000613',
    'nt-registry-permissions':'8274',
    'JavaScript_Suspicious_Xor':'5646',
    'nt-netbios-share':'8204',
    'freenet-connection-detected':'2728',
    'ramen-linux-worm-propagation':'9301',
    'CyberCop_Scanner':'1593',
    'firefox-flashplayer-code-execution':'2622',
    'nfs-root-ro':'7813',
    'RAR_Invalid_Header_Size':'2109015',
    'Oracle_InstantiateOffline_Bo':'2120046',
    'scada-dnp-coldrestart':'11317',
    'HTML_EDRAW_File_Overwrite':'2110148',
    'xfree86-xkbmap-parameter-bo':'15221',
    'UDP ECHO port probe':'13826',
    'Email_WIZ':'2001006',
    'JavaScript_Gateway_DoWebLaunch':'5616',
    'tftp-account-exist':'13641',
    'exploit-MSExcel(100010)':'2348',
    'rhel-rhsa-2008-0155-update':'10506',
    'ftp-wrapper-allow':'2881',
    'spyware-rcprograms':'12709',
    'spyware-marketdart':'12633',
    'brightstor-tapeengine-code-execution':'1012',
    'yahoomsg-login':'15332',
    'QuickTime_H264_Nal_Unit_Overflow':'9267',
    'realplayer-rm-bo':'9364',
    'xorg-xrender-bo':'15275',
    'Multimedia_File_Overflow':'2114049',
    'gnutella-present':'3146',
    'ca-dsmguicmctrls-code-execution':'1076',
    'jre-pak200-bo':'5900002',
    'mosucker-backdoor':'7040',
    'malcode-SystemFudge':'6791',
    'malcode-GenMalcodeDropper0':'6320',
    'cvs-empty-line-underflow':'1569',
    'windows-htmlapphost-command-execution':'15023',
    'iis-present':'4974',
    'samba-netbios-file-creation':'11269',
    'oracle-layer-validategeom-bo':'8564',
    'oracle-appserver-plsql-web-interface':'8530',
    'smb-filename-audit':'11721',
    'lotus-notes-helo-crash':'6058',
    'brightstor-igateway-http-get-bo':'1007',
    'rhel-rhsa-2006-0486-update':'10125',
    'win-ms06kb917344-update':'14507',
    'ms-mixed-object':'7187',
    'win-smb-process-gain-access':'14847',
    'SSH_Kerberos_auth._failed':'13044',
    'SNMP passwd':'12019',
    'trust-remote-user':'13803',
    'wireshark-scsi-dos-win':'15134',
    'php-nuke-prefix-admin-access':'8888',
    'SNMP_Trap_Enterprise_Underflow':'2106081',
    'rhel-rhsa-2005-432-update':'9949',
    'TCP_Zero_Window_DoS':'13477',
    'SSH_RSA_auth._refused':'13058',
    'TCP SYN flood':'13378',
    'rsagent-oracle-connect-internal':'11088',
    'malcode-VBAInfectSus':'6857',
    'win-ms08kb949032-update':'14645',
    'nt-winlogon-perm':'8368',
    'CHM_File_Detected':'1245',
    'Root_core_access':'10840',
    'rpc-server':'10882',
    'sunrpc-rwall-message-overflow-detected':'13244',
    'RPC_Amd_Version':'2001739',
    'oracle-tns-listener-empty-password':'8576',
    'rsagent-mssql-connect-trusted-successful':'11075',
    'rhel-rhsa-2007-0913-update':'10398',
    'rhel-rhsa-2005-429-update':'9947',
    'nt-user-rights':'8357',
    'snmp-errorindex-invalidtag':'12066',
    'malcode-InfectorX2':'6345',
    'SNMP_Cisco_Trap_Handling_Exec':'5900002',
    'malcode-InfectorX4':'6347',
    'malcode-InfectorX5':'6348',
    'spyware-aveo-attune':'12456',
    'win-ms11kb2514666-update':'5900002',
    'openssl-sslv2-client-dos':'8501',
    'VCF_attachment_overflow':'14070',
    'irix-fam':'5416',
    'win2k3-user-impersonate-client-privilege':'15000',
    'rhel-rhsa-2008-0522-update':'10570',
    'helix-get-dos':'3267',
    'hpsoftware-hpediag-bo':'3342',
    'ssh-agent-forwarding-denied':'12970',
    'nt-create-pagefile-onceonly':'8024',
    'SQL_PwdEncrypt_Overflow':'2113014',
    'bearshare-present':'808',
    'ods-wbuilder-unspecified':'5900002',
    'sco-sendmail-spam':'11369',
    'HTTP_Trend_Micro_Interscan_Traversal':'5900002',
    'yahoo-messenger-activex-dos':'15314',
    'SymASMIAO_MSGSYS_BO':'13319',
    'ipv6-bo':'5359',
    'Snort_Stream4_HeapBo':'2103023',
    'EPS_Long_Comment':'2191',
    'ie-pdwizard-code-execution':'4820',
    'visio-version-code-execution':'14105',
    'aim-game-overflow':'165',
    'U3D_Adobe_ArrayIndex_Exec':'5900002',
    'win-ms11kb2525835-update':'5900002',
    'openssl-ssl3getrecord-dos':'5900002',
    'iis-invalid-url-dos':'4955',
    'Spyware_PH_MessengerPlus':'2113191',
    'W2K domain controller attack':'14190',
    'Duplicate IP address':'2016',
    'jboss-deploymentfilerep-dir-traversal':'5664',
    'ms-ie-mshtml-dos':'7181',
    'spyware-nitline-media':'12679',
    'adobe-readeracrobat-code-execution':'5900002',
    'ospf-database-desc':'8640',
    'active-directory-database-init-failure':'60',
    'HTTP_IIS_RSA_WebAgent_BO':'2121035',
    'kernel-ext2-filesystem-dos':'5731',
    'pop-server-identify':'8983',
    'decod-ftp-passwd':'1689',
    'win-ms09kb969898-update':'14734',
    'malcode-REO1':'6455',
    'HTML_Suspicious_Hex_Text':'5900002',
    'iis-check-msoffice':'4915',
    'SNMP_lanmanger_enumeration':'12236',
    'win-ms07kb935839-update':'14588',
    'FTP_XM_Username_DoS':'2124003',
    'oracle9ias-application-cache-file-corruption':'8587',
    'HTTP_ViaVideo_Overflow':'2105058',
    'rhel-rhsa-firefox-popup-security-bypass':'10693',
    'blackice-blackdexe-bo':'911',
    'nt-scm-logon-failed':'8296',
    'malcode-PartialDropper0':'6423',
    'rhel-rhsa-2008-0002-update':'10470',
    'IPUnknownProtocol':'5358',
    'nt-winsupd-fix':'8374',
    'rhel-rhsa-2007-0703-update':'10354',
    'ssl-cbc-information-leak':'13073',
    'rhel-rhsa-2009-0362-update':'10647',
    'win-rpc-ntlmssp-dos':'14821',
    'bind-named-dns-dos':'849',
    'rpc-udp-port-probe':'10890',
    'ISAPI extension overflow':'5541',
    'RPC_Suspicious_Host_Credentials':'2001720',
    'netscape-zero-gif-bo':'7743',
    'RPC_Statd_Format_Attack':'2001737',
    'fraggle':'2718',
    'dhcp-dhcrelay-dos':'1792',
    'oracle-database-workspace-sql-injection':'5900002',
    'mapguideviewer-activex-dos':'5900002',
    'frontpage-ext-shtml-path':'2757',
    'display-dialog-enabled':'1832',
    'NewTear_attack':'7791',
    'RUN reg hack':'11228',
    'win-netbios-source-null':'14799',
    'linux-apache-username-exists':'5917',
    'psexec-detected':'9155',
    'ms-ole-automation-code-execution':'7194',
    'ms-winplayer-activex-code-execution':'7231',
    'spyware-wurldmedia':'12838',
    'RPC_Admind_Auth':'2001704',
    'sharepoint-soap-code-execution':'5900002',
    'TLS_Comodo_Fraudulent_Certificate':'5900002',
    'mpeg4viewer-csviewer-bo':'7146',
    'rhel-rhsa-2005-165-update':'9868',
    'CompoundFile_Suspicious_Pattern':'5900002',
    'PDF_Info_Reference':'8799',
    'altiris-consoleutilities-activex-bo':'333',
    'SNMP_Community_Overflow':'5900002',
    'rhel-rhsa-2004-536-update':'9761',
    'WoW23_TCP_Response':'2113158',
    'rhel-rhsa-2005-102-update':'9846',
    'SNMP_3COM_Communities':'2002013',
    'proxy-chain-detected':'9148',
    'nt-domain-admin':'8053',
    'win-ms12kb2651019-update':'5900002',
    'ibm-access-activex-bo':'4561',
    'win-ms09kb961759-update':'14718',
    'SQL_login_failed':'12904',
    'rhel-rhsa-2005-848-update':'10060',
    'Compaq_Insight_Cpqlogin_Overflow':'1416',
    'DNS_Cache_Poison':'2110145',
    'exchange-tnef-code-execution':'2303',
    'nt-logon-locally':'8167',
    'Detector_Error':'1779',
    'sygate-remote-admin':'13302',
    'HTTP_GET_SQL_Convert_Int':'2110102',
    'SMB_PowerPoint7_DLL_Hijacking':'5900002',
    'MIF_Notes_Value_Overflow':'5900002',
    'Trace_Route':'2000101',
    'ssrp-malformed-response-detected':'13122',
    'RPC_Portmap_Unset_Spoof':'2001742',
    'iis-read-files':'4975',
    'HTTP_HP_Operations_Manager_Default_User':'5900002',
    'malcode-SPMZ_DevWrt_Snk':'6559',
    'iis-ms01026-patch':'4961',
    'zone-form-submission':'15384',
    'spyware-dynamic-desktop-media':'12534',
    'nt-helpfile-bo':'8133',
    'HTTP_Lync_DLL_Hijacking':'5900002',
    'ekiga-unspecified-format-string':'2065',
    'danton-backdoor':'1633',
    'sharepoint-settings-bypass-authentication':'11584',
    'tdfc-filsys-not-empty':'13488',
    'ie-mime-execute-code':'4795',
    'rhel-rhsa-2004-609-update':'9777',
    'safari-webkit-pluginspage-info-disclosure':'11256',
    'SMB_Winreg_File':'2002703',
    'PDF_IO_Logic':'5900002',
    'Telnet password overflow':'13519',
    'youtube-activex-control-bo':'5900002',
    'SNMP_CommunityFormatString':'12186',
    'hp-storagedata-rsd-bo':'5900002',
    'compaq-insightmanager-format-string':'1413',
    'iis-check-dev-tools':'4912',
    'MSRPC_Race_Heap_Overflow':'2110047',
    'keyserv':'5773',
    'update-share-baseline':'13919',
    'Alvgus_Response':'2113070',
    'file-hard-links':'2507',
    'HTTP_AnswerBook2_Execute':'2002755',
    'aix-iy63365-fix':'189',
    'cisco-ios-telnet-dos':'1306',
    'ca-abld-rxrpc-bo':'1059',
    'rhel-rhsa-2006-0571-update':'10142',
    'Flv_String_Overflow':'2114066',
    'smtp-sendmail-relay':'11874',
    'roamabout-default-ssid':'10833',
    'nt-replace-token-onceonly':'8280',
    'HTTP_POST_Filename_WinIni':'2003905',
    'DesktopController_Info':'1777',
    'pptp-port-probe':'9094',
    'TSM_Login_Language_Overflow':'2114060',
    'BladeRunner_TCP_Request':'2113086',
    'cyrus-imap-username-bo':'1608',
    'HTTP_NphTestCgi':'2002520',
    'HTTP_3com_AirConnect_SNMPSetup':'2106014',
    'win-ms09kb959420-update':'14706',
    'aix-iy70027-fix':'224',
    'rhel-rhsa-2008-0982-update':'10618',
    'tcc-backdoor':'13361',
    'rhel-rhsa-2008-0186-update':'5900002',
    'nt-lsasp3':'8175',
    'BOEP_exchange':'967',
    'malcode-ComDropper0':'6180',
    'rhel-rhsa-2004-600-update':'9775',
    'oracle-appserver-plsql-authclient-bo':'8528',
    'iis-malformed-url-dos':'4960',
    'RPC_ARCserve_TapeEngine_Logging':'2114107',
    'HTTP_Unix_Passwords':'2003801',
    'ICMPv6_Malformed_Option_Segment':'2110085',
    'ie-file-origin-spoofing':'4743',
    'rhel-rhsa-2005-053-update':'9825',
    'CompoundFile_Word_Malformed_String':'2114017',
    'rhel-rhsa-openoffice-shell-command-execution':'10742',
    'aix-iy78223-fix':'252',
    'rhel-rhsa-2008-0181-update':'10519',
    'win-ms11kb2500212-update':'5900002',
    'Pict_Region_Overflow':'5900002',
    'win-ms06kb918439-update':'14514',
    'ourgame-glworld-glchatctrl-bo':'8669',
    'SNMP_Bad_Trap_Timestamp':'12167',
    'RPC_Statd_Overflow':'2001702',
    'PGM_Fragmentation_DoS':'5900002',
    'Image_GIF_Netscape_SubBlock_Corrupt':'2116027',
    'HTTP_Post_LanDesk_DirTraversal':'5900002',
    'ARJ_Long_FileName_Detected':'2119002',
    'decode-sql-password-empty':'1761',
    'brightstor-rpc-tapeengine-code-execution':'5900002',
    'update-registry-baseline':'13917',
    'mssql-malformed-rpc-dos':'7409',
    'nt-sp2':'8315',
    'openssh-pam-gain-access':'8473',
    'SOLIDDB_Auth_Bypass':'5900002',
    'Email_Exchange_Calendar_Malformed':'2121051',
    'snmp-oid-overflow':'12095',
    'fingerd-enumeration':'2613',
    'flexnetconnect-isusweb-code-execution':'2688',
    'virus-explorezip':'14095',
    'Spyware_PH_ABetterInternet':'2113173',
    'snmp-format-string':'12070',
    'rhel-rhsa-2011-0346-update':'5900002',
    'win-ms07kb935966-update':'14590',
    'msrpc-admin-access':'7287',
    'mssql-sqlxml-isapi-bo':'7433',
    'win-rpc-dcom-dos':'14820',
    'spyware-thesten':'12766',
    'mozilla-pluginspage-code-execution':'7120',
    'kingview-activex-validateuser-bo':'5900002',
    'IPM_Quarantine_Rule_Removed':'5328',
    'ms-ie-sameid-code-exec':'5900002',
    'HTTP_IIS_FPSE_Debug_Bo':'2110041',
    'php-sscnf-safemode-bypass':'8907',
    'timbuktu-detect':'13700',
    'rhel-rhsa-2008-0924-update':'5900002',
    'rhel-rhsa-2004-586-update':'9771',
    'arcadia-tradecli-dos':'541',
    'decod-netbios-req':'1715',
    'SMB_WriteAndX_Frag_Bo':'2118089',
    'IMAP_Literal_Overflow':'2121058',
    'rhel-rhsa-2011-1089-update':'5900002',
    'Local_group_user_removed':'6013',
    'rhel-rhsa-2008-0089-update':'10488',
    'BladeRunner_TCP_Response':'2113088',
    'Excel_File_Import_Code_Exec':'2272',
    'apache-modcache-dos':'5900002',
    'ftp-glob-implementation':'2846',
    'chm-file-detected':'1243',
    'MS name lookup':'7149',
    'SIP_Auth_Failed':'11641',
    'samba-smbd-connection-dos':'11280',
    'director-cim-consumer-dos':'1824',
    'backdoor-detected':'679',
    'rhel-rhsa-2007-0779-update':'10375',
    'Y3K_email':'15298',
    'HTTP_Oracle_Batchfile':'2002573',
    'spyware-sysweb-telecom-dialer':'12761',
    'SNMP_ifTable':'2104025',
    'ie-mhtml-information-disclosure':'4793',
    'win-ms11kb2520426-update':'5900002',
    'CGI perl.exe':'1153',
    'chilkatmail-chilkatcert-file-overwrite':'1241',
    'FTP compress exec exploit':'2788',
    'user-logoff-initiated':'13986',
    'chrome-blank-frames-security-bypass':'5900002',
    'POP3_date_overflow':'9007',
    'rhel-rhsa-2006-0634-update':'10170',
    'Cdomain_whois_raw.cgi':'1116',
    'Application_Added':'521',
    'itunes-music-file-bo':'5570',
    'HTTP_Lotus_Domino_NavAccess':'4138',
    'win-ms12kb2680352-update':'5900002',
    'passport-ccd-permission':'8721',
    'ghostscript-dsafer-command-execution':'3083',
    'win-ms04012-patch':'14405',
    'rhel-rhsa-2006-0612-update':'10164',
    'ypbind':'15347',
    'win-avi-validation-overflow':'14298',
    'TCP_Probe_Ftp':'13432',
    'ARCserve_Backup_LGServer_Malicious_Upload':'2101011',
    'php-addslashes-view-files':'8850',
    'SNTP_malformed':'12317',
    'win-ms08kb956803-update':'14684',
    'MIDI_Extremely_Large_Track':'5900002',
    'rhel-rhsa-2009-0053-update':'5900002'
}
